/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/platform","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],b=0,I=G.length;b<I;b++)e[b]=me[G[b]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=b}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function I(r){const C=[];for(let g in r)b.call(r,g)&&C.push(r[g]);return C}e.values=I;function T(r,C){for(let g in r)if(b.call(r,g)&&C({key:g,value:r[g]},function(){delete r[g]})===!1)return}e.forEach=T;function A(r,C){const g=Object.create(null);for(const m of r){const a=C(m);let h=g[a];h||(h=g[a]=[]),h.push(m)}return g}e.groupBy=A;function D(r){const C=Object.create(null);return r&&r.forEach((g,m)=>{C[m]=g}),C}e.fromMap=D;function P(r,C){const g=[],m=[];for(let a of r)C.has(a)||g.push(a);for(let a of C)r.has(a)||m.push(a);return{removed:g,added:m}}e.diffSets=P;function y(r,C){const g=[],m=[];for(let[a,h]of r)C.has(a)||g.push(h);for(let[a,h]of C)r.has(a)||m.push(h);return{removed:g,added:m}}e.diffMaps=y;class k{constructor(){this.map=new Map}add(C,g){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(g)}delete(C,g){const m=this.map.get(C);!m||(m.delete(g),m.size===0&&this.map.delete(C))}forEach(C,g){const m=this.map.get(C);!m||m.forEach(g)}}e.SetMap=k}),define(me[70],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function b(y){return(k,r,C)=>{let g=null,m=null;if(typeof C.value=="function"?(g="value",m=C.value):typeof C.get=="function"&&(g="get",m=C.get),!m)throw new Error("not supported");C[g]=y(m,r)}}e.createDecorator=b;let I=0;function T(){const y=`$memoize${I++}`;let k;const r=function(g,m,a){let h=null,S=null;if(typeof a.value=="function"?(h="value",S=a.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(h="get",S=a.get),!S)throw new Error("not supported");const w=`${y}:${m}`;a[h]=function(..._){return k=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,_)}),this[w]}};return r.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(C=>{C.indexOf(y)===0&&delete k[C]})},r}e.createMemoizer=T;function A(y,k,r){return T()(y,k,r)}e.memoize=A;function D(y,k,r){return b((C,g)=>{const m=`$debounce$${g}`,a=`$debounce$result$${g}`;return function(...h){this[a]||(this[a]=r?r():void 0),clearTimeout(this[m]),k&&(this[a]=k(this[a],...h),h=[this[a]]),this[m]=setTimeout(()=>{C.apply(this,h),this[a]=r?r():void 0},y)}})}e.debounce=D;function P(y,k,r){return b((C,g)=>{const m=`$throttle$timer$${g}`,a=`$throttle$result$${g}`,h=`$throttle$lastRun$${g}`,S=`$throttle$pending$${g}`;return function(...w){if(this[a]||(this[a]=r?r():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[a]=k(this[a],...w)),!this[S]){const _=this[h]+y;_<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[a]]),this[a]=r?r():void 0):(this[S]=!0,this[m]=setTimeout(()=>{this[S]=!1,this[h]=Date.now(),C.apply(this,[this[a]]),this[a]=r?r():void 0},_-Date.now()))}}})}e.throttle=P}),define(me[18],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function I(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=I;function T(f){y(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=T;function A(f){y(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=A;function D(f){if(f instanceof Error){let{name:t,message:n}=f;const s=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:s}}return f}e.transformErrorForSerialization=D;const P="Canceled";function y(f){return f instanceof Error&&f.name===P&&f.message===P}e.isPromiseCanceledError=y;class k extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=k;function r(){const f=new Error(P);return f.name=f.message,f}e.canceled=r;function C(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=C;function g(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=g;function m(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function a(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function h(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=h;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function p(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function c(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(me[15],ge([0,1,18]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(N,M=0){return N[N.length-(1+M)]}e.tail=I;function T(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=T;function A(N,M,F=(U,O)=>U===O){if(N===M)return!0;if(!N||!M||N.length!==M.length)return!1;for(let U=0,O=N.length;U<O;U++)if(!F(N[U],M[U]))return!1;return!0}e.equals=A;function D(N,M,F){let U=0,O=N.length-1;for(;U<=O;){const W=(U+O)/2|0,q=F(N[W],M);if(q<0)U=W+1;else if(q>0)O=W-1;else return W}return-(U+1)}e.binarySearch=D;function P(N,M){let F=0,U=N.length;if(U===0)return 0;for(;F<U;){const O=Math.floor((F+U)/2);M(N[O])?U=O:F=O+1}return F}e.findFirstInSorted=P;function y(N,M,F){if(N=N|0,N>=M.length)throw new TypeError("invalid index");let U=M[Math.floor(M.length*Math.random())],O=[],W=[],q=[];for(let Q of M){const he=F(Q,U);he<0?O.push(Q):he>0?W.push(Q):q.push(Q)}return N<O.length?y(N,O,F):N<O.length+q.length?q[0]:y(N-(O.length+q.length),W,F)}e.quickSelect=y;function k(N,M){const F=[];let U;for(const O of N.slice(0).sort(M))!U||M(U[0],O)!==0?(U=[O],F.push(U)):U.push(O);return F}e.groupBy=k;function r(N,M,F){const U=[];function O(Q,he,ve){if(!(he===0&&ve.length===0)){const Pe=U[U.length-1];Pe&&Pe.start+Pe.deleteCount===Q?(Pe.deleteCount+=he,Pe.toInsert.push(...ve)):U.push({start:Q,deleteCount:he,toInsert:ve})}}let W=0,q=0;for(;;){if(W===N.length){O(W,0,M.slice(q));break}if(q===M.length){O(W,N.length-W,[]);break}const Q=N[W],he=M[q],ve=F(Q,he);ve===0?(W+=1,q+=1):ve<0?(O(W,1,[]),W+=1):ve>0&&(O(W,0,[he]),q+=1)}return U}e.sortedDiff=r;function C(N,M,F){const U=r(N,M,F),O=[],W=[];for(const q of U)O.push(...N.slice(q.start,q.start+q.deleteCount)),W.push(...q.toInsert);return{removed:O,added:W}}e.delta=C;function g(N,M,F){if(F===0)return[];const U=N.slice(0,F).sort(M);return a(N,M,U,F,N.length),U}e.top=g;function m(N,M,F,U,O){return F===0?Promise.resolve([]):new Promise((W,q)=>{(async()=>{const Q=N.length,he=N.slice(0,F).sort(M);for(let ve=F,Pe=Math.min(F+U,Q);ve<Q;ve=Pe,Pe=Math.min(Pe+U,Q)){if(ve>F&&await new Promise(ke=>setTimeout(ke)),O&&O.isCancellationRequested)throw(0,b.canceled)();a(N,M,he,ve,Pe)}return he})().then(W,q)})}e.topAsync=m;function a(N,M,F,U,O){for(const W=F.length;U<O;U++){const q=N[U];if(M(q,F[W-1])<0){F.pop();const Q=P(F,he=>M(q,he)<0);F.splice(Q,0,q)}}}function h(N){return N.filter(M=>!!M)}e.coalesce=h;function S(N){let M=0;for(let F=0;F<N.length;F++)N[F]&&(N[M]=N[F],M+=1);N.length=M}e.coalesceInPlace=S;function w(N,M,F){N.splice(F,0,N.splice(M,1)[0])}e.move=w;function _(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=_;function p(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=p;function c(N,M){if(!M)return N.filter((U,O)=>N.indexOf(U)===O);const F=Object.create(null);return N.filter(U=>{const O=M(U);return F[O]?!1:(F[O]=!0,!0)})}e.distinct=c;function f(N){const M=new Set;return N.filter(F=>M.has(F)?!1:(M.add(F),!0))}e.distinctES6=f;function t(N){const M=Object.create(null);return F=>{const U=N(F);return M[U]?!1:(M[U]=!0,!0)}}e.uniqueFilter=t;function n(N,M){for(let F=N.length-1;F>=0;F--){const U=N[F];if(M(U))return F}return-1}e.lastIndex=n;function s(N,M){return N.length>0?N[0]:M}e.firstOrDefault=s;function i(N,M,F=(U,O)=>U===O){let U=0;for(let O=0,W=Math.min(N.length,M.length);O<W&&F(N[O],M[O]);O++)U++;return U}e.commonPrefixLength=i;function l(N){return[].concat(...N)}e.flatten=l;function o(N,M){let F=typeof M=="number"?N:0;typeof M=="number"?F=N:(F=0,M=N);const U=[];if(F<=M)for(let O=F;O<M;O++)U.push(O);else for(let O=F;O>M;O--)U.push(O);return U}e.range=o;function u(N,M,F){return N.reduce((U,O)=>(U[M(O)]=F?F(O):O,U),Object.create(null))}e.index=u;function E(N,M){return N.push(M),()=>d(N,M)}e.insert=E;function d(N,M){const F=N.indexOf(M);if(F>-1)return N.splice(F,1),M}e.remove=d;function v(N,M,F){const U=N.slice(0,M),O=N.slice(M);return U.concat(F,O)}e.arrayInsert=v;function R(N,M){let F;if(typeof M=="number"){let U=M;F=()=>{const O=Math.sin(U++)*179426549;return O-Math.floor(O)}}else F=Math.random;for(let U=N.length-1;U>0;U-=1){const O=Math.floor(F()*(U+1)),W=N[U];N[U]=N[O],N[O]=W}}e.shuffle=R;function L(N,M){const F=N.indexOf(M);F>-1&&(N.splice(F,1),N.unshift(M))}e.pushToStart=L;function H(N,M){const F=N.indexOf(M);F>-1&&(N.splice(F,1),N.push(M))}e.pushToEnd=H;function ie(N,M){return Array.isArray(N)?N.map(M):M(N)}e.mapArrayOrNot=ie;function j(N){return Array.isArray(N)?N:[N]}e.asArray=j;function B(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=B;function $(N,M){for(const F of N){const U=M(F);if(U!==void 0)return U}}e.mapFind=$}),define(me[71],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(I){const T=this;let A=!1,D;return function(){return A||(A=!0,D=I.apply(T,arguments)),D}}e.once=b}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(I){function T(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}I.is=T;const A=Object.freeze([]);function D(){return A}I.empty=D;function*P(f){yield f}I.single=P;function y(f){return f||A}I.from=y;function k(f){return!f||f[Symbol.iterator]().next().done===!0}I.isEmpty=k;function r(f){return f[Symbol.iterator]().next().value}I.first=r;function C(f,t){for(const n of f)if(t(n))return!0;return!1}I.some=C;function g(f,t){for(const n of f)if(t(n))return n}I.find=g;function*m(f,t){for(const n of f)t(n)&&(yield n)}I.filter=m;function*a(f,t){for(const n of f)yield t(n)}I.map=a;function*h(...f){for(const t of f)for(const n of t)yield n}I.concat=h;function*S(f){for(const t of f)for(const n of t)yield n}I.concatNested=S;function w(f,t,n){let s=n;for(const i of f)s=t(s,i);return s}I.reduce=w;function*_(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}I.slice=_;function p(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const s=f[Symbol.iterator]();for(let i=0;i<t;i++){const l=s.next();if(l.done)return[n,I.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return s}}]}I.consume=p;function c(f,t,n=(s,i)=>s===i){const s=f[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const l=s.next(),o=i.next();if(l.done!==o.done)return!1;if(l.done)return!0;if(!n(l.value,o.value))return!1}}I.equals=c})(b=e.Iterable||(e.Iterable={}))}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(t,n=!1){let s=0,i=t.length,l="",o=0,u=16,E=0;function d(B){let $=0,N=0;for(;$<B;){const M=t.charCodeAt(s);if(M>=48&&M<=57)N=N*16+M-48;else if(M>=65&&M<=70)N=N*16+M-65+10;else if(M>=97&&M<=102)N=N*16+M-97+10;else break;s++,$++}return $<B&&(N=-1),N}function v(B){s=B,l="",o=0,u=16,E=0}function R(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return E=3,t.substring(B,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;$=s}else E=3;return t.substring(B,$)}function L(){let B="",$=s;for(;;){if(s>=i){B+=t.substring($,s),E=2;break}const N=t.charCodeAt(s);if(N===34){B+=t.substring($,s),s++;break}if(N===92){if(B+=t.substring($,s),s++,s>=i){E=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const F=d(4);F>=0?B+=String.fromCharCode(F):E=4;break;default:E=5}$=s;continue}if(N>=0&&N<=31)if(y(N)){B+=t.substring($,s),E=2;break}else E=6;s++}return B}function H(){if(l="",E=0,o=s,s>=i)return o=i,u=17;let B=t.charCodeAt(s);if(P(B)){do s++,l+=String.fromCharCode(B),B=t.charCodeAt(s);while(P(B));return u=15}if(y(B))return s++,l+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),u=14;switch(B){case 123:return s++,u=1;case 125:return s++,u=2;case 91:return s++,u=3;case 93:return s++,u=4;case 58:return s++,u=6;case 44:return s++,u=5;case 34:return s++,l=L(),u=10;case 47:const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!y(t.charCodeAt(s));)s++;return l=t.substring($,s),u=12}if(t.charCodeAt(s+1)===42){s+=2;const N=i-1;let M=!1;for(;s<N;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,E=1),l=t.substring($,s),u=13}return l+=String.fromCharCode(B),s++,u=16;case 45:if(l+=String.fromCharCode(B),s++,s===i||!k(t.charCodeAt(s)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=R(),u=11;default:for(;s<i&&ie(B);)s++,B=t.charCodeAt(s);if(o!==s){switch(l=t.substring(o,s),l){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return l+=String.fromCharCode(B),s++,u=16}}function ie(B){if(P(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let B;do B=H();while(B>=12&&B<=15);return B}return{setPosition:v,getPosition:()=>s,scan:n?j:H,getToken:()=>u,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>E}}e.createScanner=D;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function C(t,n){const s=[],i=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function E(d,v,R,L){o.value=d,o.offset=v,o.length=R,o.type=L,o.colonOffset=void 0,l=o}try{p(t,{onObjectBegin:(d,v)=>{if(n<=d)throw i;l=void 0,u=n>d,s.push("")},onObjectProperty:(d,v,R)=>{if(n<v||(E(d,v,R,"property"),s[s.length-1]=d,n<=v+R))throw i},onObjectEnd:(d,v)=>{if(n<=d)throw i;l=void 0,s.pop()},onArrayBegin:(d,v)=>{if(n<=d)throw i;l=void 0,s.push(0)},onArrayEnd:(d,v)=>{if(n<=d)throw i;l=void 0,s.pop()},onLiteralValue:(d,v,R)=>{if(n<v||(E(d,v,R,f(d)),n<=v+R))throw i},onSeparator:(d,v,R)=>{if(n<=v)throw i;if(d===":"&&l&&l.type==="property")l.colonOffset=v,u=!1,l=void 0;else if(d===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(u=!0,s[s.length-1]=""),l=void 0}}})}catch(d){if(d!==i)throw d}return{path:s,previousNode:l,isAtPropertyKey:u,matches:d=>{let v=0;for(let R=0;v<d.length&&R<s.length;R++)if(d[v]===s[R]||d[v]==="*")v++;else if(d[v]!=="**")return!1;return v===d.length}}}e.getLocation=C;function g(t,n=[],s=A.DEFAULT){let i=null,l=[];const o=[];function u(d){Array.isArray(l)?l.push(d):i!==null&&(l[i]=d)}return p(t,{onObjectBegin:()=>{const d={};u(d),o.push(l),l=d,i=null},onObjectProperty:d=>{i=d},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const d=[];u(d),o.push(l),l=d,i=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:u,onError:(d,v,R)=>{n.push({error:d,offset:v,length:R})}},s),l[0]}e.parse=g;function m(t,n=[],s=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(d){i.type==="property"&&(i.length=d-i.offset,i=i.parent)}function o(d){return i.children.push(d),d}p(t,{onObjectBegin:d=>{i=o({type:"object",offset:d,length:-1,parent:i,children:[]})},onObjectProperty:(d,v,R)=>{i=o({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:d,offset:v,length:R,parent:i})},onObjectEnd:(d,v)=>{i.length=d+v-i.offset,i=i.parent,l(d+v)},onArrayBegin:(d,v)=>{i=o({type:"array",offset:d,length:-1,parent:i,children:[]})},onArrayEnd:(d,v)=>{i.length=d+v-i.offset,i=i.parent,l(d+v)},onLiteralValue:(d,v,R)=>{o({type:f(d),offset:v,length:R,parent:i,value:d}),l(v+R)},onSeparator:(d,v,R)=>{i.type==="property"&&(d===":"?i.colonOffset=v:d===","&&l(v))},onError:(d,v,R)=>{n.push({error:d,offset:v,length:R})}},s);const E=i.children[0];return E&&delete E.parent,E}e.parseTree=m;function a(t,n){if(!!t){let s=t;for(let i of n)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],l=!0;break}if(!l)return}else{const l=i;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}}e.findNodeAtLocation=a;function h(t){if(!t.parent||!t.parent.children)return[];const n=h(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=h;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const n=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(n[s.children[0].value]=S(i))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function _(t,n,s=!1){if(w(t,n,s)){const i=t.children;if(Array.isArray(i))for(let l=0;l<i.length&&i[l].offset<=n;l++){const o=_(i[l],n,s);if(o)return o}return t}}e.findNodeAtOffset=_;function p(t,n,s=A.DEFAULT){const i=D(t,!1);function l(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(he){return he?ve=>he(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=l(n.onObjectBegin),E=o(n.onObjectProperty),d=l(n.onObjectEnd),v=l(n.onArrayBegin),R=l(n.onArrayEnd),L=o(n.onLiteralValue),H=o(n.onSeparator),ie=l(n.onComment),j=o(n.onError),B=s&&s.disallowComments,$=s&&s.allowTrailingComma;function N(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(he){case 12:case 13:B?M(10):ie();break;case 16:M(1);break;case 15:case 14:break;default:return he}}}function M(he,ve=[],Pe=[]){if(j(he),ve.length+Pe.length>0){let ke=i.getToken();for(;ke!==17;){if(ve.indexOf(ke)!==-1){N();break}else if(Pe.indexOf(ke)!==-1)break;ke=N()}}}function F(he){const ve=i.getTokenValue();return he?L(ve):E(ve),N(),!0}function U(){switch(i.getToken()){case 11:let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(M(2),he=0)}catch(ve){M(2)}L(he);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return N(),!0}function O(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(F(!1),i.getToken()===6?(H(":"),N(),Q()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function W(){u(),N();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),H(","),N(),i.getToken()===2&&$)break}else he&&M(6,[],[]);O()||M(4,[],[2,5]),he=!0}return d(),i.getToken()!==2?M(7,[2],[]):N(),!0}function q(){v(),N();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),H(","),N(),i.getToken()===4&&$)break}else he&&M(6,[],[]);Q()||M(4,[],[4,5]),he=!0}return R(),i.getToken()!==4?M(8,[4],[]):N(),!0}function Q(){switch(i.getToken()){case 3:return q();case 1:return W();case 10:return F(!0);default:return U()}}return N(),i.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):Q()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=p;function c(t,n){let s=D(t),i=[],l,o=0,u;do switch(u=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:o!==u&&i.push(t.substring(o,u)),n!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,n)),o=s.getPosition();break}while(l!==17);return i.join("")}e.stripComments=c;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(me[132],ge([0,1,55]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(y,k,r){let C,g,m,a,h;if(k){for(a=k.offset,h=a+k.length,m=a;m>0&&!P(y,m-1);)m--;let o=h;for(;o<y.length&&!P(y,o);)o++;g=y.substring(m,o),C=A(g,r)}else g=y,C=0,m=0,a=0,h=y.length;const S=D(r,y);let w=!1,_=0,p;r.insertSpaces?p=T(" ",r.tabSize||4):p="	";const c=(0,b.createScanner)(g,!1);let f=!1;function t(){return S+T(p,C+_)}function n(){let o=c.scan();for(w=!1;o===15||o===14;)w=w||o===14,o=c.scan();return f=o===16||c.getTokenError()!==0,o}const s=[];function i(o,u,E){!f&&u<h&&E>a&&y.substring(u,E)!==o&&s.push({offset:u,length:E-u,content:o})}let l=n();if(l!==17){const o=c.getTokenOffset()+m,u=T(p,C);i(u,m,o)}for(;l!==17;){let o=c.getTokenOffset()+c.getTokenLength()+m,u=n(),E="";for(;!w&&(u===12||u===13);){const v=c.getTokenOffset()+m;i(" ",o,v),o=c.getTokenOffset()+c.getTokenLength()+m,E=u===12?t():"",u=n()}if(u===2)l!==1&&(_--,E=t());else if(u===4)l!==3&&(_--,E=t());else{switch(l){case 3:case 1:_++,E=t();break;case 5:case 12:E=t();break;case 13:w?E=t():E=" ";break;case 6:E=" ";break;case 10:if(u===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?E=" ":u!==5&&u!==17&&(f=!0);break;case 16:f=!0;break}w&&(u===12||u===13)&&(E=t())}const d=c.getTokenOffset()+m;i(E,o,d),l=u}return s}e.format=I;function T(y,k){let r="";for(let C=0;C<k;C++)r+=y;return r}function A(y,k){let r=0,C=0;const g=k.tabSize||4;for(;r<y.length;){const m=y.charAt(r);if(m===" ")C++;else if(m==="	")C+=g;else break;r++}return Math.floor(C/g)}function D(y,k){for(let r=0;r<k.length;r++){const C=k.charAt(r);if(C==="\r")return r+1<k.length&&k.charAt(r+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function P(y,k){return`\r
`.indexOf(y.charAt(k))!==-1}e.isEOL=P}),define(me[133],ge([0,1,55,132]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(k,r,C){return A(k,r,void 0,C)}e.removeProperty=T;function A(k,r,C,g,m){const a=r.slice(),h=[],S=(0,b.parseTree)(k,h);let w,_;for(;a.length>0&&(_=a.pop(),w=(0,b.findNodeAtLocation)(S,a),w===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(w)if(w.type==="object"&&typeof _=="string"&&Array.isArray(w.children)){const p=(0,b.findNodeAtLocation)(w,[_]);if(p!==void 0)if(C===void 0){if(!p.parent)throw new Error("Malformed AST");const c=w.children.indexOf(p.parent);let f,t=p.parent.offset+p.parent.length;if(c>0){const n=w.children[c-1];f=n.offset+n.length}else f=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return D(k,{offset:f,length:t-f,content:""},g)}else return D(k,{offset:p.offset,length:p.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const c=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,f=m?m(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(f>0){const n=w.children[f-1];t={offset:n.offset+n.length,length:0,content:","+c}}else w.children.length===0?t={offset:w.offset+1,length:0,content:c}:t={offset:w.offset+1,length:0,content:c+","};return D(k,t,g)}}else if(w.type==="array"&&typeof _=="number"&&Array.isArray(w.children))if(C!==void 0){const p=`${JSON.stringify(C)}`;let c;if(w.children.length===0||_===0)c={offset:w.offset+1,length:0,content:w.children.length===0?p:p+","};else{const f=_===-1||_>w.children.length?w.children.length:_,t=w.children[f-1];c={offset:t.offset+t.length,length:0,content:","+p}}return D(k,c,g)}else{const p=_,c=w.children[p];let f;if(w.children.length===1)f={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===p){const t=w.children[p-1],n=t.offset+t.length,s=w.offset+w.length;f={offset:n,length:s-2-n,content:""}}else f={offset:c.offset,length:w.children[p+1].offset-c.offset,content:""};return D(k,f,g)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(k,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(C)},g)}}e.setProperty=A;function D(k,r,C){let g=P(k,r),m=r.offset,a=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;m>0&&!(0,I.isEOL)(g,m-1);)m--;for(;a<g.length&&!(0,I.isEOL)(g,a);)a++}const h=(0,I.format)(g,{offset:m,length:a-m},C);for(let w=h.length-1;w>=0;w--){const _=h[w];g=P(g,_),m=Math.min(m,_.offset),a=Math.max(a,_.offset+_.length),a+=_.content.length-_.length}const S=k.length-(g.length-a)-m;return[{offset:m,length:S,content:g.substring(m,a)}]}e.withFormatting=D;function P(k,r){return k.substring(0,r.offset)+r.content+k.substring(r.offset+r.length)}e.applyEdit=P;function y(k,r){let C=r.slice(0).sort((m,a)=>{const h=m.offset-a.offset;return h===0?m.length-a.length:h}),g=k.length;for(let m=C.length-1;m>=0;m--){let a=C[m];if(a.offset+a.length<=g)k=P(k,a);else throw new Error("Overlapping edit");g=a.offset}return k}e.applyEdits=y}),define(me[134],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new b(()=>T(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,71,54]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let A=null;function D(p){A=p}if(e.setDisposableTracker=D,T){const p="__is_disposable_tracked__";A=new class{trackDisposable(c){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[p]||console.log(f)},3e3)}markTracked(c){if(c&&c!==h.None)try{c[p]=!0}catch(f){}}}}function P(p){!A||A.markTracked(p)}function y(p){return A&&A.trackDisposable(p),p}e.trackDisposable=y;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function r(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=r;function C(p){if(I.Iterable.is(p)){let c=[];for(const f of p)if(f){P(f);try{f.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(p)?[]:p}else if(p)return P(p),p.dispose(),p}e.dispose=C;function g(...p){return p.forEach(P),m(()=>C(p))}e.combinedDisposable=g;function m(p){const c=y({dispose:()=>{P(c),p()}});return c}e.toDisposable=m;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return P(c),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new a,y(this)}dispose(){P(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var f;this._isDisposed||c===this._value||((f=this._value)===null||f===void 0||f.dispose(),c&&P(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,P(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(c,...f){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...f)},this.references.set(c,t));const{object:n}=t,s=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=w;class _{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=_}),define(me[56],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class I{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,D){const P=new b(A);if(this._first===b.Undefined)this._first=P,this._last=P;else if(D){const k=this._last;this._last=P,P.prev=k,k.next=P}else{const k=this._first;this._first=P,P.next=k,k.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==b.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==b.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===b.Undefined&&A.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):A.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):A.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(K,oe){for(var fe=0;fe<oe.length;fe++){var Z=oe[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(K,Z.key,Z)}}function e(K,oe,fe){return oe&&G(K.prototype,oe),fe&&G(K,fe),K}function b(K,oe){if(!!K){if(typeof K=="string")return I(K,oe);var fe=Object.prototype.toString.call(K).slice(8,-1);if(fe==="Object"&&K.constructor&&(fe=K.constructor.name),fe==="Map"||fe==="Set")return Array.from(K);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return I(K,oe)}}function I(K,oe){(oe==null||oe>K.length)&&(oe=K.length);for(var fe=0,Z=new Array(oe);fe<oe;fe++)Z[fe]=K[fe];return Z}function T(K,oe){var fe;if(typeof Symbol=="undefined"||K[Symbol.iterator]==null){if(Array.isArray(K)||(fe=b(K))||oe&&K&&typeof K.length=="number"){fe&&(K=fe);var Z=0;return function(){return Z>=K.length?{done:!0}:{done:!1,value:K[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return fe=K[Symbol.iterator](),fe.next.bind(fe)}function A(K){var oe={exports:{}};return K(oe,oe.exports),oe.exports}var D=A(function(K){function oe(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function fe(Z){K.exports.defaults=Z}K.exports={defaults:oe(),getDefaults:oe,changeDefaults:fe}}),P=/[&<>"']/,y=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(oe){return C[oe]};function m(K,oe){if(oe){if(P.test(K))return K.replace(y,g)}else if(k.test(K))return K.replace(r,g);return K}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(K){return K.replace(a,function(oe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(K,oe){K=K.source||K,oe=oe||"";var fe={replace:function(ne,ce){return ce=ce.source||ce,ce=ce.replace(S,"$1"),K=K.replace(ne,ce),fe},getRegex:function(){return new RegExp(K,oe)}};return fe}var _=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(K,oe,fe){if(K){var Z;try{Z=decodeURIComponent(h(fe)).replace(_,"").toLowerCase()}catch(ne){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!p.test(fe)&&(fe=i(oe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch(ne){return null}return fe}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(K,oe){f[" "+K]||(t.test(K)?f[" "+K]=K+"/":f[" "+K]=E(K,"/",!0)),K=f[" "+K];var fe=K.indexOf(":")===-1;return oe.substring(0,2)==="//"?fe?oe:K.replace(n,"$1")+oe:oe.charAt(0)==="/"?fe?oe:K.replace(s,"$1")+oe:K+oe}var l={exec:function(){}};function o(K){for(var oe=1,fe,Z;oe<arguments.length;oe++){fe=arguments[oe];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(K[Z]=fe[Z])}return K}function u(K,oe){var fe=K.replace(/\|/g,function(ce,pe,Se){for(var qe=!1,Me=pe;--Me>=0&&Se[Me]==="\\";)qe=!qe;return qe?"|":" |"}),Z=fe.split(/ \|/),ne=0;if(Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ne<Z.length;ne++)Z[ne]=Z[ne].trim().replace(/\\\|/g,"|");return Z}function E(K,oe,fe){var Z=K.length;if(Z===0)return"";for(var ne=0;ne<Z;){var ce=K.charAt(Z-ne-1);if(ce===oe&&!fe)ne++;else if(ce!==oe&&fe)ne++;else break}return K.substr(0,Z-ne)}function d(K,oe){if(K.indexOf(oe[1])===-1)return-1;for(var fe=K.length,Z=0,ne=0;ne<fe;ne++)if(K[ne]==="\\")ne++;else if(K[ne]===oe[0])Z++;else if(K[ne]===oe[1]&&(Z--,Z<0))return ne;return-1}function v(K){K&&K.sanitize&&!K.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(K,oe){if(oe<1)return"";for(var fe="";oe>1;)oe&1&&(fe+=K),oe>>=1,K+=K;return fe+K}var L={escape:m,unescape:h,edit:w,cleanUrl:c,resolveUrl:i,noopTest:l,merge:o,splitCells:u,rtrim:E,findClosingBracket:d,checkSanitizeDeprecation:v,repeatString:R},H=D.defaults,ie=L.rtrim,j=L.splitCells,B=L.escape,$=L.findClosingBracket;function N(K,oe,fe){var Z=oe.href,ne=oe.title?B(oe.title):null,ce=K[1].replace(/\\([\[\]])/g,"$1");return K[0].charAt(0)!=="!"?{type:"link",raw:fe,href:Z,title:ne,text:ce}:{type:"image",raw:fe,href:Z,title:ne,text:B(ce)}}function M(K,oe){var fe=K.match(/^(\s+)(?:```)/);if(fe===null)return oe;var Z=fe[1];return oe.split(`
`).map(function(ne){var ce=ne.match(/^\s+/);if(ce===null)return ne;var pe=ce[0];return pe.length>=Z.length?ne.slice(Z.length):ne}).join(`
`)}var F=function(){function K(fe){this.options=fe||H}var oe=K.prototype;return oe.space=function(Z){var ne=this.rules.block.newline.exec(Z);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},oe.code=function(Z){var ne=this.rules.block.code.exec(Z);if(ne){var ce=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:ie(ce,`
`)}}},oe.fences=function(Z){var ne=this.rules.block.fences.exec(Z);if(ne){var ce=ne[0],pe=M(ce,ne[3]||"");return{type:"code",raw:ce,lang:ne[2]?ne[2].trim():ne[2],text:pe}}},oe.heading=function(Z){var ne=this.rules.block.heading.exec(Z);if(ne){var ce=ne[2].trim();if(/#$/.test(ce)){var pe=ie(ce,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(ce=pe.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:ce}}},oe.nptable=function(Z){var ne=this.rules.block.nptable.exec(Z);if(ne){var ce={type:"table",header:j(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(ce.header.length===ce.align.length){var pe=ce.align.length,Se;for(Se=0;Se<pe;Se++)/^ *-+: *$/.test(ce.align[Se])?ce.align[Se]="right":/^ *:-+: *$/.test(ce.align[Se])?ce.align[Se]="center":/^ *:-+ *$/.test(ce.align[Se])?ce.align[Se]="left":ce.align[Se]=null;for(pe=ce.cells.length,Se=0;Se<pe;Se++)ce.cells[Se]=j(ce.cells[Se],ce.header.length);return ce}}},oe.hr=function(Z){var ne=this.rules.block.hr.exec(Z);if(ne)return{type:"hr",raw:ne[0]}},oe.blockquote=function(Z){var ne=this.rules.block.blockquote.exec(Z);if(ne){var ce=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:ce}}},oe.list=function(Z){var ne=this.rules.block.list.exec(Z);if(ne){var ce=ne[0],pe=ne[2],Se=pe.length>1,qe={type:"list",raw:ce,ordered:Se,start:Se?+pe.slice(0,-1):"",loose:!1,items:[]},Me=ne[0].match(this.rules.block.item),He=!1,Qe,it,at,Ze,nt,dt,_t,ue,De=Me.length;at=this.rules.block.listItemStart.exec(Me[0]);for(var le=0;le<De;le++){if(Qe=Me[le],ce=Qe,le!==De-1){if(Ze=this.rules.block.listItemStart.exec(Me[le+1]),this.options.pedantic?Ze[1].length>at[1].length:Ze[1].length>at[0].length||Ze[1].length>3){Me.splice(le,2,Me[le]+`
`+Me[le+1]),le--,De--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==pe[pe.length-1]:Se===(Ze[2].length===1))&&(nt=Me.slice(le+1).join(`
`),qe.raw=qe.raw.substring(0,qe.raw.length-nt.length),le=De-1);at=Ze}it=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(it-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+it+"}","gm"),"")),dt=He||/\n\n(?!\s*$)/.test(Qe),le!==De-1&&(He=Qe.charAt(Qe.length-1)===`
`,dt||(dt=He)),dt&&(qe.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Qe),ue=void 0,_t&&(ue=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:ce,task:_t,checked:ue,loose:dt,text:Qe})}return qe}},oe.html=function(Z){var ne=this.rules.block.html.exec(Z);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):B(ne[0]):ne[0]}},oe.def=function(Z){var ne=this.rules.block.def.exec(Z);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ce=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ne[0],href:ne[2],title:ne[3]}}},oe.table=function(Z){var ne=this.rules.block.table.exec(Z);if(ne){var ce={type:"table",header:j(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ne[0];var pe=ce.align.length,Se;for(Se=0;Se<pe;Se++)/^ *-+: *$/.test(ce.align[Se])?ce.align[Se]="right":/^ *:-+: *$/.test(ce.align[Se])?ce.align[Se]="center":/^ *:-+ *$/.test(ce.align[Se])?ce.align[Se]="left":ce.align[Se]=null;for(pe=ce.cells.length,Se=0;Se<pe;Se++)ce.cells[Se]=j(ce.cells[Se].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},oe.lheading=function(Z){var ne=this.rules.block.lheading.exec(Z);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},oe.paragraph=function(Z){var ne=this.rules.block.paragraph.exec(Z);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},oe.text=function(Z){var ne=this.rules.block.text.exec(Z);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},oe.escape=function(Z){var ne=this.rules.inline.escape.exec(Z);if(ne)return{type:"escape",raw:ne[0],text:B(ne[1])}},oe.tag=function(Z,ne,ce){var pe=this.rules.inline.tag.exec(Z);if(pe)return!ne&&/^<a /i.test(pe[0])?ne=!0:ne&&/^<\/a>/i.test(pe[0])&&(ne=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ne,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):B(pe[0]):pe[0]}},oe.link=function(Z){var ne=this.rules.inline.link.exec(Z);if(ne){var ce=ne[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var pe=ie(ce.slice(0,-1),"\\");if((ce.length-pe.length)%2==0)return}else{var Se=$(ne[2],"()");if(Se>-1){var qe=ne[0].indexOf("!")===0?5:4,Me=qe+ne[1].length+Se;ne[2]=ne[2].substring(0,Se),ne[0]=ne[0].substring(0,Me).trim(),ne[3]=""}}var He=ne[2],Qe="";if(this.options.pedantic){var it=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(He);it&&(He=it[1],Qe=it[3])}else Qe=ne[3]?ne[3].slice(1,-1):"";return He=He.trim(),/^</.test(He)&&(this.options.pedantic&&!/>$/.test(ce)?He=He.slice(1):He=He.slice(1,-1)),N(ne,{href:He&&He.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},ne[0])}},oe.reflink=function(Z,ne){var ce;if((ce=this.rules.inline.reflink.exec(Z))||(ce=this.rules.inline.nolink.exec(Z))){var pe=(ce[2]||ce[1]).replace(/\s+/g," ");if(pe=ne[pe.toLowerCase()],!pe||!pe.href){var Se=ce[0].charAt(0);return{type:"text",raw:Se,text:Se}}return N(ce,pe,ce[0])}},oe.emStrong=function(Z,ne,ce){ce===void 0&&(ce="");var pe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!pe&&!(pe[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Se=pe[1]||pe[2]||"";if(!Se||Se&&(ce===""||this.rules.inline.punctuation.exec(ce))){var qe=pe[0].length-1,Me,He,Qe=qe,it=0,at=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(at.lastIndex=0,ne=ne.slice(-1*Z.length+qe);(pe=at.exec(ne))!=null;)if(Me=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Me){if(He=Me.length,pe[3]||pe[4]){Qe+=He;continue}else if((pe[5]||pe[6])&&qe%3&&!((qe+He)%3)){it+=He;continue}if(Qe-=He,!(Qe>0)){if(Qe+it-He<=0&&!ne.slice(at.lastIndex).match(at)&&(He=Math.min(He,He+Qe+it)),Math.min(qe,He)%2)return{type:"em",raw:Z.slice(0,qe+pe.index+He+1),text:Z.slice(1,qe+pe.index+He)};if(Math.min(qe,He)%2==0)return{type:"strong",raw:Z.slice(0,qe+pe.index+He+1),text:Z.slice(2,qe+pe.index+He-1)}}}}}},oe.codespan=function(Z){var ne=this.rules.inline.code.exec(Z);if(ne){var ce=ne[2].replace(/\n/g," "),pe=/[^ ]/.test(ce),Se=/^ /.test(ce)&&/ $/.test(ce);return pe&&Se&&(ce=ce.substring(1,ce.length-1)),ce=B(ce,!0),{type:"codespan",raw:ne[0],text:ce}}},oe.br=function(Z){var ne=this.rules.inline.br.exec(Z);if(ne)return{type:"br",raw:ne[0]}},oe.del=function(Z){var ne=this.rules.inline.del.exec(Z);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},oe.autolink=function(Z,ne){var ce=this.rules.inline.autolink.exec(Z);if(ce){var pe,Se;return ce[2]==="@"?(pe=B(this.options.mangle?ne(ce[1]):ce[1]),Se="mailto:"+pe):(pe=B(ce[1]),Se=pe),{type:"link",raw:ce[0],text:pe,href:Se,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.url=function(Z,ne){var ce;if(ce=this.rules.inline.url.exec(Z)){var pe,Se;if(ce[2]==="@")pe=B(this.options.mangle?ne(ce[0]):ce[0]),Se="mailto:"+pe;else{var qe;do qe=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(qe!==ce[0]);pe=B(ce[0]),ce[1]==="www."?Se="http://"+pe:Se=pe}return{type:"link",raw:ce[0],text:pe,href:Se,tokens:[{type:"text",raw:pe,text:pe}]}}},oe.inlineText=function(Z,ne,ce){var pe=this.rules.inline.text.exec(Z);if(pe){var Se;return ne?Se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):B(pe[0]):pe[0]:Se=B(this.options.smartypants?ce(pe[0]):pe[0]),{type:"text",raw:pe[0],text:Se}}},K}(),U=L.noopTest,O=L.edit,W=L.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:U,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=O(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=O(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=O(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=O(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=O(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=O(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=O(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=W({},q),q.gfm=W({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=O(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=O(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=W({},q.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:O(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=O(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=O(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=O(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=O(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=O(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=O(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=O(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=O(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=O(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=O(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=W({},Q),Q.pedantic=W({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=W({},Q.normal,{escape:O(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=O(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=W({},Q.gfm,{br:O(Q.br).replace("{2,}","*").getRegex(),text:O(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:q,inline:Q},ve=D.defaults,Pe=he.block,ke=he.inline,Le=L.repeatString;function V(K){return K.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(K){var oe="",fe,Z,ne=K.length;for(fe=0;fe<ne;fe++)Z=K.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var ee=function(){function K(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ve,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var Z={block:Pe.normal,inline:ke.normal};this.options.pedantic?(Z.block=Pe.pedantic,Z.inline=ke.pedantic):this.options.gfm&&(Z.block=Pe.gfm,this.options.breaks?Z.inline=ke.breaks:Z.inline=ke.gfm),this.tokenizer.rules=Z}K.lex=function(Z,ne){var ce=new K(ne);return ce.lex(Z)},K.lexInline=function(Z,ne){var ce=new K(ne);return ce.inlineTokens(Z)};var oe=K.prototype;return oe.lex=function(Z){return Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens,!0),this.inline(this.tokens),this.tokens},oe.blockTokens=function(Z,ne,ce){ne===void 0&&(ne=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var pe,Se,qe,Me;Z;){if(pe=this.tokenizer.space(Z)){Z=Z.substring(pe.raw.length),pe.type&&ne.push(pe);continue}if(pe=this.tokenizer.code(Z)){Z=Z.substring(pe.raw.length),Me=ne[ne.length-1],Me&&Me.type==="paragraph"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text):ne.push(pe);continue}if(pe=this.tokenizer.fences(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.heading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.nptable(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.hr(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.blockquote(Z)){Z=Z.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],ce),ne.push(pe);continue}if(pe=this.tokenizer.list(Z)){for(Z=Z.substring(pe.raw.length),qe=pe.items.length,Se=0;Se<qe;Se++)pe.items[Se].tokens=this.blockTokens(pe.items[Se].text,[],!1);ne.push(pe);continue}if(pe=this.tokenizer.html(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(ce&&(pe=this.tokenizer.def(Z))){Z=Z.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.lheading(Z)){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(ce&&(pe=this.tokenizer.paragraph(Z))){Z=Z.substring(pe.raw.length),ne.push(pe);continue}if(pe=this.tokenizer.text(Z)){Z=Z.substring(pe.raw.length),Me=ne[ne.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text):ne.push(pe);continue}if(Z){var He="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return ne},oe.inline=function(Z){var ne,ce,pe,Se,qe,Me,He=Z.length;for(ne=0;ne<He;ne++)switch(Me=Z[ne],Me.type){case"paragraph":case"text":case"heading":{Me.tokens=[],this.inlineTokens(Me.text,Me.tokens);break}case"table":{for(Me.tokens={header:[],cells:[]},Se=Me.header.length,ce=0;ce<Se;ce++)Me.tokens.header[ce]=[],this.inlineTokens(Me.header[ce],Me.tokens.header[ce]);for(Se=Me.cells.length,ce=0;ce<Se;ce++)for(qe=Me.cells[ce],Me.tokens.cells[ce]=[],pe=0;pe<qe.length;pe++)Me.tokens.cells[ce][pe]=[],this.inlineTokens(qe[pe],Me.tokens.cells[ce][pe]);break}case"blockquote":{this.inline(Me.tokens);break}case"list":{for(Se=Me.items.length,ce=0;ce<Se;ce++)this.inline(Me.items[ce].tokens);break}}return Z},oe.inlineTokens=function(Z,ne,ce,pe){ne===void 0&&(ne=[]),ce===void 0&&(ce=!1),pe===void 0&&(pe=!1);var Se,qe,Me=Z,He,Qe,it;if(this.tokens.links){var at=Object.keys(this.tokens.links);if(at.length>0)for(;(He=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)at.includes(He[0].slice(He[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,He.index)+"["+Le("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(He=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,He.index)+"["+Le("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(He=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,He.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;){if(Qe||(it=""),Qe=!1,Se=this.tokenizer.escape(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.tag(Z,ce,pe)){Z=Z.substring(Se.raw.length),ce=Se.inLink,pe=Se.inRawBlock;var Ze=ne[ne.length-1];Ze&&Se.type==="text"&&Ze.type==="text"?(Ze.raw+=Se.raw,Ze.text+=Se.text):ne.push(Se);continue}if(Se=this.tokenizer.link(Z)){Z=Z.substring(Se.raw.length),Se.type==="link"&&(Se.tokens=this.inlineTokens(Se.text,[],!0,pe)),ne.push(Se);continue}if(Se=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(Se.raw.length);var nt=ne[ne.length-1];Se.type==="link"?(Se.tokens=this.inlineTokens(Se.text,[],!0,pe),ne.push(Se)):nt&&Se.type==="text"&&nt.type==="text"?(nt.raw+=Se.raw,nt.text+=Se.text):ne.push(Se);continue}if(Se=this.tokenizer.emStrong(Z,Me,it)){Z=Z.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],ce,pe),ne.push(Se);continue}if(Se=this.tokenizer.codespan(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.br(Z)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.del(Z)){Z=Z.substring(Se.raw.length),Se.tokens=this.inlineTokens(Se.text,[],ce,pe),ne.push(Se);continue}if(Se=this.tokenizer.autolink(Z,J)){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(!ce&&(Se=this.tokenizer.url(Z,J))){Z=Z.substring(Se.raw.length),ne.push(Se);continue}if(Se=this.tokenizer.inlineText(Z,pe,V)){Z=Z.substring(Se.raw.length),Se.raw.slice(-1)!=="_"&&(it=Se.raw.slice(-1)),Qe=!0,qe=ne[ne.length-1],qe&&qe.type==="text"?(qe.raw+=Se.raw,qe.text+=Se.text):ne.push(Se);continue}if(Z){var dt="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(dt);break}else throw new Error(dt)}}return ne},e(K,null,[{key:"rules",get:function(){return{block:Pe,inline:ke}}}]),K}(),ae=D.defaults,we=L.cleanUrl,Ce=L.escape,Oe=function(){function K(fe){this.options=fe||ae}var oe=K.prototype;return oe.code=function(Z,ne,ce){var pe=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Se=this.options.highlight(Z,pe);Se!=null&&Se!==Z&&(ce=!0,Z=Se)}return Z=Z.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+Ce(pe,!0)+'">'+(ce?Z:Ce(Z,!0))+`</code></pre>
`:"<pre><code>"+(ce?Z:Ce(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ne,ce,pe){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+pe.slug(ce)+'">'+Z+"</h"+ne+`>
`:"<h"+ne+">"+Z+"</h"+ne+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ne,ce){var pe=ne?"ol":"ul",Se=ne&&ce!==1?' start="'+ce+'"':"";return"<"+pe+Se+`>
`+Z+"</"+pe+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ne+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ne){var ce=ne.header?"th":"td",pe=ne.align?"<"+ce+' align="'+ne.align+'">':"<"+ce+">";return pe+Z+"</"+ce+`>
`},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ne,ce){if(Z=we(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ce;var pe='<a href="'+Ce(Z)+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=">"+ce+"</a>",pe},oe.image=function(Z,ne,ce){if(Z=we(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ce;var pe='<img src="'+Z+'" alt="'+ce+'"';return ne&&(pe+=' title="'+ne+'"'),pe+=this.options.xhtml?"/>":">",pe},oe.text=function(Z){return Z},K}(),be=function(){function K(){}var oe=K.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ne,ce){return""+ce},oe.image=function(Z,ne,ce){return""+ce},oe.br=function(){return""},K}(),Ie=function(){function K(){this.seen={}}var oe=K.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ne){var ce=Z,pe=0;if(this.seen.hasOwnProperty(ce)){pe=this.seen[Z];do pe++,ce=Z+"-"+pe;while(this.seen.hasOwnProperty(ce))}return ne||(this.seen[Z]=pe,this.seen[ce]=0),ce},oe.slug=function(Z,ne){ne===void 0&&(ne={});var ce=this.serialize(Z);return this.getNextSafeSlug(ce,ne.dryrun)},K}(),Re=D.defaults,We=L.unescape,Ee=function(){function K(fe){this.options=fe||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new Ie}K.parse=function(Z,ne){var ce=new K(ne);return ce.parse(Z)},K.parseInline=function(Z,ne){var ce=new K(ne);return ce.parseInline(Z)};var oe=K.prototype;return oe.parse=function(Z,ne){ne===void 0&&(ne=!0);var ce="",pe,Se,qe,Me,He,Qe,it,at,Ze,nt,dt,_t,ue,De,le,Y,Ne,Te,Je=Z.length;for(pe=0;pe<Je;pe++)switch(nt=Z[pe],nt.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,We(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(at="",it="",Me=nt.header.length,Se=0;Se<Me;Se++)it+=this.renderer.tablecell(this.parseInline(nt.tokens.header[Se]),{header:!0,align:nt.align[Se]});for(at+=this.renderer.tablerow(it),Ze="",Me=nt.cells.length,Se=0;Se<Me;Se++){for(Qe=nt.tokens.cells[Se],it="",He=Qe.length,qe=0;qe<He;qe++)it+=this.renderer.tablecell(this.parseInline(Qe[qe]),{header:!1,align:nt.align[qe]});Ze+=this.renderer.tablerow(it)}ce+=this.renderer.table(at,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),ce+=this.renderer.blockquote(Ze);continue}case"list":{for(dt=nt.ordered,_t=nt.start,ue=nt.loose,Me=nt.items.length,Ze="",Se=0;Se<Me;Se++)le=nt.items[Se],Y=le.checked,Ne=le.task,De="",le.task&&(Te=this.renderer.checkbox(Y),ue?le.tokens.length>0&&le.tokens[0].type==="text"?(le.tokens[0].text=Te+" "+le.tokens[0].text,le.tokens[0].tokens&&le.tokens[0].tokens.length>0&&le.tokens[0].tokens[0].type==="text"&&(le.tokens[0].tokens[0].text=Te+" "+le.tokens[0].tokens[0].text)):le.tokens.unshift({type:"text",text:Te}):De+=Te),De+=this.parse(le.tokens,ue),Ze+=this.renderer.listitem(De,Ne,Y);ce+=this.renderer.list(Ze,dt,_t);continue}case"html":{ce+=this.renderer.html(nt.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;pe+1<Je&&Z[pe+1].type==="text";)nt=Z[++pe],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);ce+=ne?this.renderer.paragraph(Ze):Ze;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return ce},oe.parseInline=function(Z,ne){ne=ne||this.renderer;var ce="",pe,Se,qe=Z.length;for(pe=0;pe<qe;pe++)switch(Se=Z[pe],Se.type){case"escape":{ce+=ne.text(Se.text);break}case"html":{ce+=ne.html(Se.text);break}case"link":{ce+=ne.link(Se.href,Se.title,this.parseInline(Se.tokens,ne));break}case"image":{ce+=ne.image(Se.href,Se.title,Se.text);break}case"strong":{ce+=ne.strong(this.parseInline(Se.tokens,ne));break}case"em":{ce+=ne.em(this.parseInline(Se.tokens,ne));break}case"codespan":{ce+=ne.codespan(Se.text);break}case"br":{ce+=ne.br();break}case"del":{ce+=ne.del(this.parseInline(Se.tokens,ne));break}case"text":{ce+=ne.text(Se.text);break}default:{var Me='Token with "'+Se.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}return ce},K}(),Ke=L.merge,X=L.checkSanitizeDeprecation,re=L.escape,_e=D.getDefaults,xe=D.changeDefaults,ze=D.defaults;function $e(K,oe,fe){if(typeof K=="undefined"||K===null)throw new Error("marked(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");if(typeof oe=="function"&&(fe=oe,oe=null),oe=Ke({},$e.defaults,oe||{}),X(oe),fe){var Z=oe.highlight,ne;try{ne=ee.lex(K,oe)}catch(qe){return fe(qe)}var ce=function(Me){var He;if(!Me)try{He=Ee.parse(ne,oe)}catch(Qe){Me=Qe}return oe.highlight=Z,Me?fe(Me):fe(null,He)};if(!Z||Z.length<3||(delete oe.highlight,!ne.length))return ce();var pe=0;$e.walkTokens(ne,function(qe){qe.type==="code"&&(pe++,setTimeout(function(){Z(qe.text,qe.lang,function(Me,He){if(Me)return ce(Me);He!=null&&He!==qe.text&&(qe.text=He,qe.escaped=!0),pe--,pe===0&&ce()})},0))}),pe===0&&ce();return}try{var Se=ee.lex(K,oe);return oe.walkTokens&&$e.walkTokens(Se,oe.walkTokens),Ee.parse(Se,oe)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(qe.message+"",!0)+"</pre>";throw qe}}$e.options=$e.setOptions=function(K){return Ke($e.defaults,K),xe($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(K){var oe=Ke({},K);if(K.renderer&&function(){var Z=$e.defaults.renderer||new Oe,ne=function(Se){var qe=Z[Se];Z[Se]=function(){for(var Me=arguments.length,He=new Array(Me),Qe=0;Qe<Me;Qe++)He[Qe]=arguments[Qe];var it=K.renderer[Se].apply(Z,He);return it===!1&&(it=qe.apply(Z,He)),it}};for(var ce in K.renderer)ne(ce);oe.renderer=Z}(),K.tokenizer&&function(){var Z=$e.defaults.tokenizer||new F,ne=function(Se){var qe=Z[Se];Z[Se]=function(){for(var Me=arguments.length,He=new Array(Me),Qe=0;Qe<Me;Qe++)He[Qe]=arguments[Qe];var it=K.tokenizer[Se].apply(Z,He);return it===!1&&(it=qe.apply(Z,He)),it}};for(var ce in K.tokenizer)ne(ce);oe.tokenizer=Z}(),K.walkTokens){var fe=$e.defaults.walkTokens;oe.walkTokens=function(Z){K.walkTokens(Z),fe&&fe(Z)}}$e.setOptions(oe)},$e.walkTokens=function(K,oe){for(var fe=T(K),Z;!(Z=fe()).done;){var ne=Z.value;switch(oe(ne),ne.type){case"table":{for(var ce=T(ne.tokens.header),pe;!(pe=ce()).done;){var Se=pe.value;$e.walkTokens(Se,oe)}for(var qe=T(ne.tokens.cells),Me;!(Me=qe()).done;)for(var He=Me.value,Qe=T(He),it;!(it=Qe()).done;){var at=it.value;$e.walkTokens(at,oe)}break}case"list":{$e.walkTokens(ne.items,oe);break}default:ne.tokens&&$e.walkTokens(ne.tokens,oe)}}},$e.parseInline=function(K,oe){if(typeof K=="undefined"||K===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof K!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(K)+", string expected");oe=Ke({},$e.defaults,oe||{}),X(oe);try{var fe=ee.lexInline(K,oe);return oe.walkTokens&&$e.walkTokens(fe,oe.walkTokens),Ee.parseInline(fe,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+re(Z.message+"",!0)+"</pre>";throw Z}},$e.Parser=Ee,$e.parser=Ee.parse,$e.Renderer=Oe,$e.TextRenderer=be,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=F,$e.Slugger=Ie,$e.parse=$e;var Ye=$e;return Ye}),define(me[73],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(D,P,y){return Math.min(Math.max(D,P),y)}e.clamp=b;function I(D,P){return(P+D%P)%P}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class A{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function G(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function D(y){A.push(y,Date.now())}function P(){const y=[];for(let k=0;k<A.length;k+=2)y.push({name:A[k],startTime:A[k+1]});return y}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(T+D.startTime)});return A}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function b(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=b(I))})(),define(me[9],ge([0,1]),function(G,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,A=!1,D=!1,P=!1,y=!1,k=!1,r=!1,C,g=I,m,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof((b=h==null?void 0:h.versions)===null||b===void 0?void 0:b.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)a=navigator.userAgent,T=a.indexOf("Windows")>=0,A=a.indexOf("Macintosh")>=0,r=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=a.indexOf("Linux")>=0,k=!0,C=navigator.language,g=C;else if(typeof h=="object"){T=h.platform==="win32",A=h.platform==="darwin",D=h.platform==="linux",P=D&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,C=I,g=I;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const l=JSON.parse(i),o=l.availableLanguages["*"];C=l.locale,g=o||I,m=l._translationsConfigFile}catch(l){}y=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function _(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let p=0;A?p=1:T?p=3:D&&(p=2),e.isWindows=T,e.isMacintosh=A,e.isLinux=D,e.isLinuxSnap=P,e.isNative=y,e.isWeb=k,e.isIOS=r,e.platform=p,e.userAgent=a,e.language=g;var c;(function(i){function l(){return e.language}i.value=l;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=o;function u(){return e.language==="en"}i.isDefault=u})(c=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let d=0,v=o.length;d<v;d++){const R=o[d];if(R.id===E.data.vscodeSetImmediateId){o.splice(d,1),R.callback();return}}});let u=0;return E=>{const d=++u;o.push({id:d,callback:E}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const l=Promise.resolve();return o=>l.then(o)}();var f;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||r?2:T?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof b.globals.vscode!="undefined"){const T=b.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(A){return(0,b.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(T){return(0,b.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(me[8],ge([0,1,36]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,A=90,D=122,P=46,y=47,k=92,r=58,C=63;class g extends Error{constructor(c,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const s=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${s} ${n} of type ${f}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(p,c){if(typeof p!="string")throw new g(c,"string",p)}function a(p){return p===y||p===k}function h(p){return p===y}function S(p){return p>=I&&p<=A||p>=T&&p<=D}function w(p,c,f,t){let n="",s=0,i=-1,l=0,o=0;for(let u=0;u<=p.length;++u){if(u<p.length)o=p.charCodeAt(u);else{if(t(o))break;o=y}if(t(o)){if(!(i===u-1||l===1))if(l===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const E=n.lastIndexOf(f);E===-1?(n="",s=0):(n=n.slice(0,E),s=n.length-1-n.lastIndexOf(f)),i=u,l=0;continue}else if(n.length!==0){n="",s=0,i=u,l=0;continue}}c&&(n+=n.length>0?`${f}..`:"..",s=2)}else n.length>0?n+=`${f}${p.slice(i+1,u)}`:n=p.slice(i+1,u),s=u-i-1;i=u,l=0}else o===P&&l!==-1?++l:l=-1}return n}function _(p,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const f=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return f?f===c.root?`${f}${t}`:`${f}${p}${t}`:t}e.win32={resolve(...p){let c="",f="",t=!1;for(let n=p.length-1;n>=-1;n--){let s;if(n>=0){if(s=p[n],m(s,"path"),s.length===0)continue}else c.length===0?s=b.cwd():(s=b.env[`=${c}`]||b.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${c}\\`));const i=s.length;let l=0,o="",u=!1;const E=s.charCodeAt(0);if(i===1)a(E)&&(l=1,u=!0);else if(a(E))if(u=!0,a(s.charCodeAt(1))){let d=2,v=d;for(;d<i&&!a(s.charCodeAt(d));)d++;if(d<i&&d!==v){const R=s.slice(v,d);for(v=d;d<i&&a(s.charCodeAt(d));)d++;if(d<i&&d!==v){for(v=d;d<i&&!a(s.charCodeAt(d));)d++;(d===i||d!==v)&&(o=`\\\\${R}\\${s.slice(v,d)}`,l=d)}}}else l=1;else S(E)&&s.charCodeAt(1)===r&&(o=s.slice(0,2),l=2,i>2&&a(s.charCodeAt(2))&&(u=!0,l=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(t){if(c.length>0)break}else if(f=`${s.slice(l)}\\${f}`,t=u,u&&c.length>0)break}return f=w(f,!t,"\\",a),t?`${c}\\${f}`:`${c}${f}`||"."},normalize(p){m(p,"path");const c=p.length;if(c===0)return".";let f=0,t,n=!1;const s=p.charCodeAt(0);if(c===1)return h(s)?"\\":p;if(a(s))if(n=!0,a(p.charCodeAt(1))){let l=2,o=l;for(;l<c&&!a(p.charCodeAt(l));)l++;if(l<c&&l!==o){const u=p.slice(o,l);for(o=l;l<c&&a(p.charCodeAt(l));)l++;if(l<c&&l!==o){for(o=l;l<c&&!a(p.charCodeAt(l));)l++;if(l===c)return`\\\\${u}\\${p.slice(o)}\\`;l!==o&&(t=`\\\\${u}\\${p.slice(o,l)}`,f=l)}}}else f=1;else S(s)&&p.charCodeAt(1)===r&&(t=p.slice(0,2),f=2,c>2&&a(p.charCodeAt(2))&&(n=!0,f=3));let i=f<c?w(p.slice(f),!n,"\\",a):"";return i.length===0&&!n&&(i="."),i.length>0&&a(p.charCodeAt(c-1))&&(i+="\\"),t===void 0?n?`\\${i}`:i:n?`${t}\\${i}`:`${t}${i}`},isAbsolute(p){m(p,"path");const c=p.length;if(c===0)return!1;const f=p.charCodeAt(0);return a(f)||c>2&&S(f)&&p.charCodeAt(1)===r&&a(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let c,f;for(let s=0;s<p.length;++s){const i=p[s];m(i,"path"),i.length>0&&(c===void 0?c=f=i:c+=`\\${i}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&a(f.charCodeAt(0))){++n;const s=f.length;s>1&&a(f.charCodeAt(1))&&(++n,s>2&&(a(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&a(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(p,c){if(m(p,"from"),m(c,"to"),p===c)return"";const f=e.win32.resolve(p),t=e.win32.resolve(c);if(f===t||(p=f.toLowerCase(),c=t.toLowerCase(),p===c))return"";let n=0;for(;n<p.length&&p.charCodeAt(n)===k;)n++;let s=p.length;for(;s-1>n&&p.charCodeAt(s-1)===k;)s--;const i=s-n;let l=0;for(;l<c.length&&c.charCodeAt(l)===k;)l++;let o=c.length;for(;o-1>l&&c.charCodeAt(o-1)===k;)o--;const u=o-l,E=i<u?i:u;let d=-1,v=0;for(;v<E;v++){const L=p.charCodeAt(n+v);if(L!==c.charCodeAt(l+v))break;L===k&&(d=v)}if(v!==E){if(d===-1)return t}else{if(u>E){if(c.charCodeAt(l+v)===k)return t.slice(l+v+1);if(v===2)return t.slice(l+v)}i>E&&(p.charCodeAt(n+v)===k?d=v:v===2&&(d=3)),d===-1&&(d=0)}let R="";for(v=n+d+1;v<=s;++v)(v===s||p.charCodeAt(v)===k)&&(R+=R.length===0?"..":"\\..");return l+=d,R.length>0?`${R}${t.slice(l,o)}`:(t.charCodeAt(l)===k&&++l,t.slice(l,o))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const c=e.win32.resolve(p);if(c.length<=2)return p;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const f=c.charCodeAt(2);if(f!==C&&f!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(S(c.charCodeAt(0))&&c.charCodeAt(1)===r&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return p},dirname(p){m(p,"path");const c=p.length;if(c===0)return".";let f=-1,t=0;const n=p.charCodeAt(0);if(c===1)return a(n)?p:".";if(a(n)){if(f=t=1,a(p.charCodeAt(1))){let l=2,o=l;for(;l<c&&!a(p.charCodeAt(l));)l++;if(l<c&&l!==o){for(o=l;l<c&&a(p.charCodeAt(l));)l++;if(l<c&&l!==o){for(o=l;l<c&&!a(p.charCodeAt(l));)l++;if(l===c)return p;l!==o&&(f=t=l+1)}}}}else S(n)&&p.charCodeAt(1)===r&&(f=c>2&&a(p.charCodeAt(2))?3:2,t=f);let s=-1,i=!0;for(let l=c-1;l>=t;--l)if(a(p.charCodeAt(l))){if(!i){s=l;break}}else i=!1;if(s===-1){if(f===-1)return".";s=f}return p.slice(0,s)},basename(p,c){c!==void 0&&m(c,"ext"),m(p,"path");let f=0,t=-1,n=!0,s;if(p.length>=2&&S(p.charCodeAt(0))&&p.charCodeAt(1)===r&&(f=2),c!==void 0&&c.length>0&&c.length<=p.length){if(c===p)return"";let i=c.length-1,l=-1;for(s=p.length-1;s>=f;--s){const o=p.charCodeAt(s);if(a(o)){if(!n){f=s+1;break}}else l===-1&&(n=!1,l=s+1),i>=0&&(o===c.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=l))}return f===t?t=l:t===-1&&(t=p.length),p.slice(f,t)}for(s=p.length-1;s>=f;--s)if(a(p.charCodeAt(s))){if(!n){f=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":p.slice(f,t)},extname(p){m(p,"path");let c=0,f=-1,t=0,n=-1,s=!0,i=0;p.length>=2&&p.charCodeAt(1)===r&&S(p.charCodeAt(0))&&(c=t=2);for(let l=p.length-1;l>=c;--l){const o=p.charCodeAt(l);if(a(o)){if(!s){t=l+1;break}continue}n===-1&&(s=!1,n=l+1),o===P?f===-1?f=l:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||n===-1||i===0||i===1&&f===n-1&&f===t+1?"":p.slice(f,n)},format:_.bind(null,"\\"),parse(p){m(p,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return c;const f=p.length;let t=0,n=p.charCodeAt(0);if(f===1)return a(n)?(c.root=c.dir=p,c):(c.base=c.name=p,c);if(a(n)){if(t=1,a(p.charCodeAt(1))){let d=2,v=d;for(;d<f&&!a(p.charCodeAt(d));)d++;if(d<f&&d!==v){for(v=d;d<f&&a(p.charCodeAt(d));)d++;if(d<f&&d!==v){for(v=d;d<f&&!a(p.charCodeAt(d));)d++;d===f?t=d:d!==v&&(t=d+1)}}}}else if(S(n)&&p.charCodeAt(1)===r){if(f<=2)return c.root=c.dir=p,c;if(t=2,a(p.charCodeAt(2))){if(f===3)return c.root=c.dir=p,c;t=3}}t>0&&(c.root=p.slice(0,t));let s=-1,i=t,l=-1,o=!0,u=p.length-1,E=0;for(;u>=t;--u){if(n=p.charCodeAt(u),a(n)){if(!o){i=u+1;break}continue}l===-1&&(o=!1,l=u+1),n===P?s===-1?s=u:E!==1&&(E=1):s!==-1&&(E=-1)}return l!==-1&&(s===-1||E===0||E===1&&s===l-1&&s===i+1?c.base=c.name=p.slice(i,l):(c.name=p.slice(i,s),c.base=p.slice(i,l),c.ext=p.slice(s,l))),i>0&&i!==t?c.dir=p.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let c="",f=!1;for(let t=p.length-1;t>=-1&&!f;t--){const n=t>=0?p[t]:b.cwd();m(n,"path"),n.length!==0&&(c=`${n}/${c}`,f=n.charCodeAt(0)===y)}return c=w(c,!f,"/",h),f?`/${c}`:c.length>0?c:"."},normalize(p){if(m(p,"path"),p.length===0)return".";const c=p.charCodeAt(0)===y,f=p.charCodeAt(p.length-1)===y;return p=w(p,!c,"/",h),p.length===0?c?"/":f?"./":".":(f&&(p+="/"),c?`/${p}`:p)},isAbsolute(p){return m(p,"path"),p.length>0&&p.charCodeAt(0)===y},join(...p){if(p.length===0)return".";let c;for(let f=0;f<p.length;++f){const t=p[f];m(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(p,c){if(m(p,"from"),m(c,"to"),p===c||(p=e.posix.resolve(p),c=e.posix.resolve(c),p===c))return"";const f=1,t=p.length,n=t-f,s=1,i=c.length-s,l=n<i?n:i;let o=-1,u=0;for(;u<l;u++){const d=p.charCodeAt(f+u);if(d!==c.charCodeAt(s+u))break;d===y&&(o=u)}if(u===l)if(i>l){if(c.charCodeAt(s+u)===y)return c.slice(s+u+1);if(u===0)return c.slice(s+u)}else n>l&&(p.charCodeAt(f+u)===y?o=u:u===0&&(o=0));let E="";for(u=f+o+1;u<=t;++u)(u===t||p.charCodeAt(u)===y)&&(E+=E.length===0?"..":"/..");return`${E}${c.slice(s+o)}`},toNamespacedPath(p){return p},dirname(p){if(m(p,"path"),p.length===0)return".";const c=p.charCodeAt(0)===y;let f=-1,t=!0;for(let n=p.length-1;n>=1;--n)if(p.charCodeAt(n)===y){if(!t){f=n;break}}else t=!1;return f===-1?c?"/":".":c&&f===1?"//":p.slice(0,f)},basename(p,c){c!==void 0&&m(c,"ext"),m(p,"path");let f=0,t=-1,n=!0,s;if(c!==void 0&&c.length>0&&c.length<=p.length){if(c===p)return"";let i=c.length-1,l=-1;for(s=p.length-1;s>=0;--s){const o=p.charCodeAt(s);if(o===y){if(!n){f=s+1;break}}else l===-1&&(n=!1,l=s+1),i>=0&&(o===c.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=l))}return f===t?t=l:t===-1&&(t=p.length),p.slice(f,t)}for(s=p.length-1;s>=0;--s)if(p.charCodeAt(s)===y){if(!n){f=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":p.slice(f,t)},extname(p){m(p,"path");let c=-1,f=0,t=-1,n=!0,s=0;for(let i=p.length-1;i>=0;--i){const l=p.charCodeAt(i);if(l===y){if(!n){f=i+1;break}continue}t===-1&&(n=!1,t=i+1),l===P?c===-1?c=i:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||t===-1||s===0||s===1&&c===t-1&&c===f+1?"":p.slice(c,t)},format:_.bind(null,"/"),parse(p){m(p,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return c;const f=p.charCodeAt(0)===y;let t;f?(c.root="/",t=1):t=0;let n=-1,s=0,i=-1,l=!0,o=p.length-1,u=0;for(;o>=t;--o){const E=p.charCodeAt(o);if(E===y){if(!l){s=o+1;break}continue}i===-1&&(l=!1,i=o+1),E===P?n===-1?n=o:u!==1&&(u=1):n!==-1&&(u=-1)}if(i!==-1){const E=s===0&&f?1:s;n===-1||u===0||u===1&&n===i-1&&n===s+1?c.base=c.name=p.slice(E,i):(c.name=p.slice(E,n),c.base=p.slice(E,i),c.ext=p.slice(n,i))}return s>0?c.dir=p.slice(0,s-1):f&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[135],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var I;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(A,...D){const P=D.reduce((r,C)=>(r[C]=!0,r),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(r=>!P[r]).forEach(r=>{for(let C=0;C<y.length;C++)if(r.search(y[C])!==-1){delete A[r];break}})}e.sanitizeProcessEnvironment=T}),define(me[47],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=b.globals.performance&&typeof b.globals.performance.now=="function";class T{constructor(D){this._highResolution=I&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new T(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=T}),define(me[3],ge([0,1,18,71,6,56,47]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(w){w.None=()=>T.Disposable.None;function _(j){return(B,$=null,N)=>{let M=!1,F;return F=j(U=>{if(!M)return F?F.dispose():M=!0,B.call($,U)},null,N),M&&F.dispose(),F}}w.once=_;function p(j,B){return i(($,N=null,M)=>j(F=>$.call(N,B(F)),null,M))}w.map=p;function c(j,B){return i(($,N=null,M)=>j(F=>{B(F),$.call(N,F)},null,M))}w.forEach=c;function f(j,B){return i(($,N=null,M)=>j(F=>B(F)&&$.call(N,F),null,M))}w.filter=f;function t(j){return j}w.signal=t;function n(...j){return(B,$=null,N)=>(0,T.combinedDisposable)(...j.map(M=>M(F=>B.call($,F),null,N)))}w.any=n;function s(j,B,$){let N=$;return p(j,M=>(N=B(N,M),N))}w.reduce=s;function i(j){let B;const $=new g({onFirstListenerAdd(){B=j($.fire,$)},onLastListenerRemove(){B.dispose()}});return $.event}w.snapshot=i;function l(j,B,$=100,N=!1,M){let F,U,O,W=0;const q=new g({leakWarningThreshold:M,onFirstListenerAdd(){F=j(Q=>{W++,U=B(U,Q),N&&!O&&(q.fire(U),U=void 0),clearTimeout(O),O=setTimeout(()=>{const he=U;U=void 0,O=void 0,(!N||W>1)&&q.fire(he),W=0},$)})},onLastListenerRemove(){F.dispose()}});return q.event}w.debounce=l;function o(j){const B=new Date().getTime();return p(_(j),$=>new Date().getTime()-B)}w.stopwatch=o;function u(j){let B=!0,$;return f(j,N=>{const M=B||N!==$;return B=!1,$=N,M})}w.latch=u;function E(j,B=!1,$=[]){let N=$.slice(),M=j(O=>{N?N.push(O):U.fire(O)});const F=()=>{N&&N.forEach(O=>U.fire(O)),N=null},U=new g({onFirstListenerAdd(){M||(M=j(O=>U.fire(O)))},onFirstListenerDidAdd(){N&&(B?setTimeout(F):F())},onLastListenerRemove(){M&&M.dispose(),M=null}});return U.event}w.buffer=E;class d{constructor(B){this.event=B}map(B){return new d(p(this.event,B))}forEach(B){return new d(c(this.event,B))}filter(B){return new d(f(this.event,B))}reduce(B,$){return new d(s(this.event,B,$))}latch(){return new d(u(this.event))}debounce(B,$=100,N=!1,M){return new d(l(this.event,B,$,N,M))}on(B,$,N){return this.event(B,$,N)}once(B,$,N){return _(this.event)(B,$,N)}}function v(j){return new d(j)}w.chain=v;function R(j,B,$=N=>N){const N=(...O)=>U.fire($(...O)),M=()=>j.on(B,N),F=()=>j.removeListener(B,N),U=new g({onFirstListenerAdd:M,onLastListenerRemove:F});return U.event}w.fromNodeEventEmitter=R;function L(j,B,$=N=>N){const N=(...O)=>U.fire($(...O)),M=()=>j.addEventListener(B,N),F=()=>j.removeEventListener(B,N),U=new g({onFirstListenerAdd:M,onLastListenerRemove:F});return U.event}w.fromDOMEventEmitter=L;function H(j){const B=new g;let $=!1;return j.then(void 0,()=>null).then(()=>{$?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),$=!0,B.event}w.fromPromise=H;function ie(j){return new Promise(B=>_(j)(B))}w.toPromise=ie})(P=e.Event||(e.Event={}));class y{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${y._idPool++}`}start(_){this._stopWatch=new D.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let k=-1;function r(w){const _=k;return k=w,{dispose(){k=_}}}e.setGlobalLeakWarningThreshold=r;class C{constructor(_,p=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let p=k;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),!(p<=0||_<p)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(c)||0;if(this._stacks.set(c,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let t,n=0;for(const[s,i]of this._stacks)(!t||n<i)&&(t=s,n=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class g{constructor(_){var p;this._disposed=!1,this._options=_,this._leakageMon=k>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((p=this._options)===null||p===void 0?void 0:p._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(_,p,c)=>{var f;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(p?[_,p]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,p);const s=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let i;return i={dispose:()=>{s&&s(),i.dispose=g._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof T.DisposableStore?c.add(i):Array.isArray(c)&&c.push(i),i}),this._event}fire(_){var p,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,_]);for((p=this._perfMon)===null||p===void 0||p.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var _,p,c;(_=this._listeners)===null||_===void 0||_.clear(),(p=this._deliveryQueue)===null||p===void 0||p.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=g,g._noop=function(){};class m extends g{constructor(_){super(_);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=m;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const p={event:_,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const c=()=>{this.hasListeners&&this.unhook(p);const f=this.events.indexOf(p);this.events.splice(f,1)};return(0,T.toDisposable)((0,I.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(p=>this.emitter.fire(p))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class h{constructor(){this.buffers=[]}wrapEvent(_){return(p,c,f)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(c,t)):p.call(c,t)},void 0,f)}bufferEvents(_){const p=[];this.buffers.push(p);const c=_();return this.buffers.pop(),p.forEach(f=>f()),c}}e.EventBufferer=h;class S{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=T.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(me[21],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(P,y){const k=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(k)}}});var T;(function(P){function y(k){return k===P.None||k===P.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=D}),define(me[43],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(C){const g=this._icons.get(C.id);g?C.description?g.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function A(r,C){return new P(r,C)}e.registerCodicon=A;function D(r){return r?r.replace(/\$\((.*?)\)/g,(C,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=D;class P{constructor(C,g,m){this.id=C,this.definition=g,this.description=m,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function y(r,C){const g=["codicon","codicon-"+r];return C&&g.push("codicon-modifier-"+C),g}e.getClassNamesArray=y;var k;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function g(h){if(h instanceof P)return["codicon","codicon-"+h.id];const S=C.exec(h.id);if(!S)return g(P.error);let[,w,_]=S;const p=["codicon","codicon-"+w];return _&&p.push("codicon-modifier-"+_.substr(1)),p}r.asClassNameArray=g;function m(h){return g(h).join(" ")}r.asClassName=m;function a(h){return"."+g(h).join(".")}r.asCSSSelector=a})(k=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personAdd=new r("person-add",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(me[94],ge([0,1,18,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(p){const c=p;return c?[c.on,c.pause,c.resume,c.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=T;function A(p){const c=p;return c?T(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function D(p,c){return new P(p,c)}e.newWriteableStream=D;class P{constructor(c,f){this.reducer=c,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(f=>f(c))}emitError(c){this.listeners.error.length===0?(0,b.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(f=>f(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,f){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(c,f){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(p,c){const f=[];let t;for(;(t=p.read())!==null;)f.push(t);return c(f)}e.consumeReadable=y;function k(p,c,f){const t=[];let n;for(;(n=p.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return p.read()}}}e.peekReadable=k;function r(p,c){return new Promise((f,t)=>{const n=[];C(p,{onData:s=>{c&&n.push(s)},onError:s=>{c?t(s):f(void 0)},onEnd:()=>{f(c?c(n):void 0)}})})}e.consumeStream=r;function C(p,c){p.on("error",f=>c.onError(f)),p.on("end",()=>c.onEnd()),p.on("data",f=>c.onData(f))}e.listenStream=C;function g(p,c){return new Promise((f,t)=>{const n=new I.DisposableStore,s=[],i=u=>{if(s.push(u),s.length>c)return n.dispose(),p.pause(),f({stream:p,buffer:s,ended:!1})},l=u=>t(u),o=()=>f({stream:p,buffer:s,ended:!0});n.add((0,I.toDisposable)(()=>p.removeListener("error",l))),p.on("error",l),n.add((0,I.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),n.add((0,I.toDisposable)(()=>p.removeListener("data",i))),p.on("data",i)})}e.peekStream=g;function m(p,c){const f=D(c);return f.end(p),f}e.toStream=m;function a(){const p=D(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=a;function h(p){let c=!1;return{read:()=>c?null:(c=!0,p)}}e.toReadable=h;function S(p,c,f){const t=D(f);return C(p,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=S;function w(p,c,f){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?f([p,n]):p)}}}e.prefixedReadable=w;function _(p,c,f){let t=!1;const n=D(f);return C(c,{onData:s=>t?n.write(s):(t=!0,n.write(f([p,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(p)),n.end()}}),n}e.prefixedStream=_}),define(me[10],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=b;const I=/{(\d+)}/g;function T(K,...oe){return oe.length===0?K:K.replace(I,function(fe,Z){const ne=parseInt(Z,10);return isNaN(ne)||ne<0||ne>=oe.length?fe:oe[ne]})}e.format=T;function A(K){return K.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=A;function D(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function P(K,oe){let fe=0;const Z=oe.charCodeAt(0);for(let ne=K.length-1;ne>=0;ne--)K.charCodeAt(ne)===Z&&fe++;return fe}e.count=P;function y(K,oe,fe="\u2026"){return K.length<=oe?K:`${K.substr(0,oe)}${fe}`}e.truncate=y;function k(K,oe=" "){const fe=r(K,oe);return C(fe,oe)}e.trim=k;function r(K,oe){if(!K||!oe)return K;const fe=oe.length;if(fe===0||K.length===0)return K;let Z=0;for(;K.indexOf(oe,Z)===Z;)Z=Z+fe;return K.substring(Z)}e.ltrim=r;function C(K,oe){if(!K||!oe)return K;const fe=oe.length,Z=K.length;if(fe===0||Z===0)return K;let ne=Z,ce=-1;for(;ce=K.lastIndexOf(oe,ne-1),!(ce===-1||ce+fe!==ne);){if(ce===0)return"";ne=ce}return K.substring(0,ne)}e.rtrim=C;function g(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(K){return K.replace(/\*/g,"")}e.stripWildcards=m;function a(K,oe,fe={}){if(!K)throw new Error("Cannot create regex from empty string");oe||(K=D(K)),fe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Z="";return fe.global&&(Z+="g"),fe.matchCase||(Z+="i"),fe.multiline&&(Z+="m"),fe.unicode&&(Z+="u"),new RegExp(K,Z)}e.createRegExp=a;function h(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=w;function _(K){return K.split(/\r\n|\r|\n/)}e.splitLines=_;function p(K){for(let oe=0,fe=K.length;oe<fe;oe++){const Z=K.charCodeAt(oe);if(Z!==32&&Z!==9)return oe}return-1}e.firstNonWhitespaceIndex=p;function c(K,oe=0,fe=K.length){for(let Z=oe;Z<fe;Z++){const ne=K.charCodeAt(Z);if(ne!==32&&ne!==9)return K.substring(oe,Z)}return K.substring(oe,fe)}e.getLeadingWhitespace=c;function f(K,oe=K.length-1){for(let fe=oe;fe>=0;fe--){const Z=K.charCodeAt(fe);if(Z!==32&&Z!==9)return fe}return-1}e.lastNonWhitespaceIndex=f;function t(K,oe){return K<oe?-1:K>oe?1:0}e.compare=t;function n(K,oe,fe=0,Z=K.length,ne=0,ce=oe.length){for(;fe<Z&&ne<ce;fe++,ne++){let qe=K.charCodeAt(fe),Me=oe.charCodeAt(ne);if(qe<Me)return-1;if(qe>Me)return 1}const pe=Z-fe,Se=ce-ne;return pe<Se?-1:pe>Se?1:0}e.compareSubstring=n;function s(K,oe){return i(K,oe,0,K.length,0,oe.length)}e.compareIgnoreCase=s;function i(K,oe,fe=0,Z=K.length,ne=0,ce=oe.length){for(;fe<Z&&ne<ce;fe++,ne++){let qe=K.charCodeAt(fe),Me=oe.charCodeAt(ne);if(qe!==Me){const He=qe-Me;if(!(He===32&&o(Me))&&!(He===-32&&o(qe)))return l(qe)&&l(Me)?He:n(K.toLowerCase(),oe.toLowerCase(),fe,Z,ne,ce)}}const pe=Z-fe,Se=ce-ne;return pe<Se?-1:pe>Se?1:0}e.compareSubstringIgnoreCase=i;function l(K){return K>=97&&K<=122}e.isLowerAsciiLetter=l;function o(K){return K>=65&&K<=90}e.isUpperAsciiLetter=o;function u(K){return l(K)||o(K)}function E(K,oe){return K.length===oe.length&&d(K,oe)}e.equalsIgnoreCase=E;function d(K,oe,fe=K.length){for(let Z=0;Z<fe;Z++){const ne=K.charCodeAt(Z),ce=oe.charCodeAt(Z);if(ne!==ce){if(u(ne)&&u(ce)){const pe=Math.abs(ne-ce);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function v(K,oe){const fe=oe.length;return oe.length>K.length?!1:d(K,oe,fe)}e.startsWithIgnoreCase=v;function R(K,oe){let fe,Z=Math.min(K.length,oe.length);for(fe=0;fe<Z;fe++)if(K.charCodeAt(fe)!==oe.charCodeAt(fe))return fe;return Z}e.commonPrefixLength=R;function L(K,oe){let fe,Z=Math.min(K.length,oe.length);const ne=K.length-1,ce=oe.length-1;for(fe=0;fe<Z;fe++)if(K.charCodeAt(ne-fe)!==oe.charCodeAt(ce-fe))return fe;return Z}e.commonSuffixLength=L;function H(K){return 55296<=K&&K<=56319}e.isHighSurrogate=H;function ie(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ie;function j(K,oe){return(K-55296<<10)+(oe-56320)+65536}e.computeCodePoint=j;function B(K,oe,fe){const Z=K.charCodeAt(fe);if(H(Z)&&fe+1<oe){const ne=K.charCodeAt(fe+1);if(ie(ne))return j(Z,ne)}return Z}e.getNextCodePoint=B;function $(K,oe){const fe=K.charCodeAt(oe-1);if(ie(fe)&&oe>1){const Z=K.charCodeAt(oe-2);if(H(Z))return j(Z,fe)}return fe}function N(K,oe){const fe=$e.getInstance(),Z=oe,ne=K.length,ce=B(K,ne,oe);oe+=ce>=65536?2:1;let pe=fe.getGraphemeBreakType(ce);for(;oe<ne;){const Se=B(K,ne,oe),qe=fe.getGraphemeBreakType(Se);if(xe(pe,qe))break;oe+=Se>=65536?2:1,pe=qe}return oe-Z}e.nextCharLength=N;function M(K,oe){const fe=$e.getInstance(),Z=oe,ne=$(K,oe);oe-=ne>=65536?2:1;let ce=fe.getGraphemeBreakType(ne);for(;oe>0;){const pe=$(K,oe),Se=fe.getGraphemeBreakType(pe);if(xe(Se,ce))break;oe-=pe>=65536?2:1,ce=Se}return Z-oe}e.prevCharLength=M;function F(K,oe){const fe=$e.getInstance(),Z=K.length,ne=oe,ce=B(K,Z,oe),pe=fe.getGraphemeBreakType(ce);oe+=ce>=65536?2:1;let Se=pe;for(;oe<Z;){const Me=B(K,Z,oe),He=fe.getGraphemeBreakType(Me);if(xe(Se,He))break;oe+=Me>=65536?2:1,Se=He}const qe=oe;for(oe=ne,Se=pe;oe>0;){const Me=$(K,oe),He=fe.getGraphemeBreakType(Me);if(xe(He,Se))break;oe-=Me>=65536?2:1,Se=He}return[oe,qe]}function U(K,oe){return oe>0&&ie(K.charCodeAt(oe))?F(K,oe-1):F(K,oe)}e.getCharContainingOffset=U;function O(K){const oe=K.length;let fe=0,Z=0;for(;Z<oe;){const pe=B(K,oe,Z);Z+=pe>=65536?2:1,pe<128?fe+=1:pe<2048?fe+=2:pe<65536?fe+=3:fe+=4}const ne=new Uint8Array(fe);Z=0;let ce=0;for(;Z<oe;){const pe=B(K,oe,Z);Z+=pe>=65536?2:1,pe<128?ne[ce++]=pe:pe<2048?(ne[ce++]=192|(pe&1984)>>>6,ne[ce++]=128|(pe&63)>>>0):pe<65536?(ne[ce++]=224|(pe&61440)>>>12,ne[ce++]=128|(pe&4032)>>>6,ne[ce++]=128|(pe&63)>>>0):(ne[ce++]=240|(pe&1835008)>>>18,ne[ce++]=128|(pe&258048)>>>12,ne[ce++]=128|(pe&4032)>>>6,ne[ce++]=128|(pe&63)>>>0)}return ne}e.encodeUTF8=O;function W(K){const oe=K.byteLength,fe=[];let Z=0;for(;Z<oe;){const ne=K[Z];let ce;if(ne>=240&&Z+3<oe?ce=(K[Z++]&7)<<18>>>0|(K[Z++]&63)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=224&&Z+2<oe?ce=(K[Z++]&15)<<12>>>0|(K[Z++]&63)<<6>>>0|(K[Z++]&63)<<0>>>0:ne>=192&&Z+1<oe?ce=(K[Z++]&31)<<6>>>0|(K[Z++]&63)<<0>>>0:ce=K[Z++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)fe.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const pe=ce-65536,Se=55296+((pe&1047552)>>>10),qe=56320+((pe&1023)>>>0);fe.push(String.fromCharCode(Se)),fe.push(String.fromCharCode(qe))}else fe.push(String.fromCharCode(65533))}return fe.join("")}e.decodeUTF8=W;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(K){return q.test(K)}e.containsRTL=Q;const he=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(K){return he.test(K)}e.containsEmoji=ve;const Pe=/^[\t\n\r\x20-\x7E]*$/;function ke(K){return Pe.test(K)}e.isBasicASCII=ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Le;function V(K){for(let oe=0,fe=K.length;oe<fe;oe++)if(J(K.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=V;function J(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=J;function ee(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=ee;function ae(K,oe){if(K.length<oe)return K;const fe=/\b/g;let Z=0;for(;fe.test(K)&&!(K.length-fe.lastIndex<oe);)Z=fe.lastIndex,fe.lastIndex+=1;return K.substring(Z).replace(/^\s/,"")}e.lcut=ae;const we=/\x1B\x5B[12]?K/g,Ce=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(K){return K&&(K=K.replace(we,""),K=K.replace(Ce,""),K=K.replace(Oe,"")),K}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Re(K){return Ie(K)?K.substr(1):K}e.stripUTF8BOM=Re;function We(K,oe){if(!K||!oe||K.length<oe.length)return!1;const fe=oe.length,Z=K.toLowerCase();let ne=0,ce=-1;for(;ne<fe;){const pe=Z.indexOf(oe[ne],ce+1);if(pe<0)return!1;ce=pe,ne++}return!0}e.fuzzyContains=We;function Ee(K,oe=!1){return K?(oe&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ee;function Ke(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ke;function X(K,oe=1){if(oe===0)return"";let fe=-1;do fe=K.indexOf(`
`,fe+1),oe--;while(oe>0&&fe>=0);return fe===-1?K:(K[fe-1]==="\r"&&fe--,K.substr(0,fe))}e.getNLines=X;function re(K){const oe=90-65+1;return K=K%(2*oe),K<oe?String.fromCharCode(97+K):String.fromCharCode(65+K-oe)}e.singleLetterHash=re;function _e(K){return $e.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=_e;function xe(K,oe){return K===0?oe!==5&&oe!==7:K===2&&oe===3?!1:K===4||K===2||K===3||oe===4||oe===2||oe===3?!0:!(K===8&&(oe===8||oe===9||oe===11||oe===12)||(K===11||K===9)&&(oe===9||oe===10)||(K===12||K===10)&&oe===10||oe===5||oe===13||oe===7||K===1||K===13&&oe===14||K===6&&oe===6)}e.breakBetweenGraphemeBreakType=xe;var ze;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const fe=this._data,Z=fe.length/3;let ne=1;for(;ne<=Z;)if(oe<fe[3*ne])ne=2*ne;else if(oe>fe[3*ne+1])ne=2*ne+1;else return fe[3*ne+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(me[22],ge([0,1,10,94]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let P,y;class k{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return T?new k(Buffer.allocUnsafe(u)):new k(new Uint8Array(u))}static wrap(u){return T&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new k(u)}static fromString(u,E){return!((E==null?void 0:E.dontUseNodeBuffer)||!1)&&T?new k(Buffer.from(u)):A?(P||(P=new TextEncoder),new k(P.encode(u))):new k(b.encodeUTF8(u))}static concat(u,E){if(typeof E=="undefined"){E=0;for(let R=0,L=u.length;R<L;R++)E+=u[R].byteLength}const d=k.alloc(E);let v=0;for(let R=0,L=u.length;R<L;R++){const H=u[R];d.set(H,v),v+=H.byteLength}return d}toString(){return T?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(u,E){return new k(this.buffer.subarray(u,E))}set(u,E){u instanceof k?this.buffer.set(u.buffer,E):this.buffer.set(u,E)}readUInt32BE(u){return g(this.buffer,u)}writeUInt32BE(u,E){m(this.buffer,u,E)}readUInt32LE(u){return a(this.buffer,u)}writeUInt32LE(u,E){h(this.buffer,u,E)}readUInt8(u){return S(this.buffer,u)}writeUInt8(u,E){w(this.buffer,u,E)}}e.VSBuffer=k;function r(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=r;function C(o,u,E){o[E+0]=u&255,u=u>>>8,o[E+1]=u&255}e.writeUInt16LE=C;function g(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=g;function m(o,u,E){o[E+3]=u,u=u>>>8,o[E+2]=u,u=u>>>8,o[E+1]=u,u=u>>>8,o[E]=u}e.writeUInt32BE=m;function a(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=a;function h(o,u,E){o[E+0]=u&255,u=u>>>8,o[E+1]=u&255,u=u>>>8,o[E+2]=u&255,u=u>>>8,o[E+3]=u&255}e.writeUInt32LE=h;function S(o,u){return o[u]}e.readUInt8=S;function w(o,u,E){o[E]=u}e.writeUInt8=w;function _(o){return I.consumeReadable(o,u=>k.concat(u))}e.readableToBuffer=_;function p(o){return I.toReadable(o)}e.bufferToReadable=p;function c(o){return I.consumeStream(o,u=>k.concat(u))}e.streamToBuffer=c;async function f(o){return o.ended?k.concat(o.buffer):k.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=f;function t(o){return I.toStream(o,u=>k.concat(u))}e.bufferToStream=t;function n(o){return I.transform(o,{data:u=>typeof u=="string"?k.fromString(u):k.wrap(u)},u=>k.concat(u))}e.streamToBufferReadableStream=n;function s(o){return I.newWriteableStream(u=>k.concat(u),o)}e.newWriteableBufferStream=s;function i(o,u){return I.prefixedReadable(o,u,E=>k.concat(E))}e.prefixedBufferReadable=i;function l(o,u){return I.prefixedStream(o,u,E=>k.concat(E))}e.prefixedBufferStream=l}),define(me[74],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(w){return T(w,0)}e.hash=I;function T(w,_){switch(typeof w){case"object":return w===null?A(349,_):Array.isArray(w)?y(w,_):k(w,_);case"string":return P(w,_);case"boolean":return D(w,_);case"number":return A(w,_);case"undefined":return A(937,_);default:return A(617,_)}}e.doHash=T;function A(w,_){return(_<<5)-_+w|0}function D(w,_){return A(w?433:863,_)}function P(w,_){_=A(149417,_);for(let p=0,c=w.length;p<c;p++)_=A(w.charCodeAt(p),_);return _}e.stringHash=P;function y(w,_){return _=A(104579,_),w.reduce((p,c)=>T(c,p),_)}function k(w,_){return _=A(181387,_),Object.keys(w).sort().reduce((p,c)=>(p=P(c,p),T(w[c],p)),_)}class r{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=T(_,this._value),this._value}}e.Hasher=r;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function g(w,_,p=32){const c=p-_,f=~((1<<c)-1);return(w<<_|(f&w)>>>c)>>>0}function m(w,_=0,p=w.byteLength,c=0){for(let f=0;f<p;f++)w[_+f]=c}function a(w,_,p="0"){for(;w.length<_;)w=p+w;return w}function h(w,_=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(p=>p.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),_/4)}e.toHexString=h;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const p=_.length;if(p!==0){const c=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=_.charCodeAt(0),s=0);;){let i=n;if(b.isHighSurrogate(n))if(s+1<p){const l=_.charCodeAt(s+1);b.isLowSurrogate(l)?(s++,i=b.computeCodePoint(n,l)):i=65533}else{t=n;break}else b.isLowSurrogate(n)&&(i=65533);if(f=this._push(c,f,i),s++,s<p)n=_.charCodeAt(s);else break}this._buffLen=f,this._leftoverHighSurrogate=t}}_push(_,p,c){return c<128?_[p++]=c:c<2048?(_[p++]=192|(c&1984)>>>6,_[p++]=128|(c&63)>>>0):c<65536?(_[p++]=224|(c&61440)>>>12,_[p++]=128|(c&4032)>>>6,_[p++]=128|(c&63)>>>0):(_[p++]=240|(c&1835008)>>>18,_[p++]=128|(c&258048)>>>12,_[p++]=128|(c&4032)>>>6,_[p++]=128|(c&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=S._bigBlock32,p=this._buffDV;for(let u=0;u<64;u+=4)_.setUint32(u,p.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)_.setUint32(u,g(_.getUint32(u-12,!1)^_.getUint32(u-32,!1)^_.getUint32(u-56,!1)^_.getUint32(u-64,!1),1),!1);let c=this._h0,f=this._h1,t=this._h2,n=this._h3,s=this._h4,i,l,o;for(let u=0;u<80;u++)u<20?(i=f&t|~f&n,l=1518500249):u<40?(i=f^t^n,l=1859775393):u<60?(i=f&t|f&n|t&n,l=2400959708):(i=f^t^n,l=3395469782),o=g(c,5)+i+s+l+_.getUint32(u*4,!1)&4294967295,s=n,n=t,t=g(f,30),f=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[57],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const A="error",D="warning",P="warn",y="info";function k(r){return r?b.equalsIgnoreCase(A,r)?T.Error:b.equalsIgnoreCase(D,r)||b.equalsIgnoreCase(P,r)?T.Warning:b.equalsIgnoreCase(y,r)?T.Info:T.Ignore:T.Ignore}T.fromValue=k}(I||(I={})),e.default=I}),define(me[12],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(u){return Array.isArray(u)}e.isArray=b;function I(u){return typeof u=="string"}e.isString=I;function T(u){return Array.isArray(u)&&u.every(E=>I(E))}e.isStringArray=T;function A(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=A;function D(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=D;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=P;function y(u){return u===!0||u===!1}e.isBoolean=y;function k(u){return typeof u=="undefined"}e.isUndefined=k;function r(u){return!C(u)}e.isDefined=r;function C(u){return k(u)||u===null}e.isUndefinedOrNull=C;function g(u,E){if(!u)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=g;function m(u){if(C(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=m;function a(...u){const E=[];for(let d=0;d<u.length;d++){const v=u[d];if(C(v))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);E.push(v)}return E}e.assertAllDefined=a;const h=Object.prototype.hasOwnProperty;function S(u){if(!A(u))return!1;for(let E in u)if(h.call(u,E))return!1;return!0}e.isEmptyObject=S;function w(u){return typeof u=="function"}e.isFunction=w;function _(...u){return u.length>0&&u.every(w)}e.areFunctions=_;function p(u,E){const d=Math.min(u.length,E.length);for(let v=0;v<d;v++)c(u[v],E[v])}e.validateConstraints=p;function c(u,E){if(I(E)){if(typeof u!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(w(E)){try{if(u instanceof E)return}catch(d){}if(!C(u)&&u.constructor===E||E.length===1&&E.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function f(u){let E=[],d=Object.getPrototypeOf(u);for(;Object.prototype!==d;)E=E.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return E}e.getAllPropertyNames=f;function t(u){const E=[];for(const d of f(u))typeof u[d]=="function"&&E.push(d);return E}e.getAllMethodNames=t;function n(u,E){const d=R=>function(){const L=Array.prototype.slice.call(arguments,0);return E(R,L)};let v={};for(const R of u)v[R]=d(R);return v}e.createProxyObject=n;function s(u){return u===null?void 0:u}e.withNullAsUndefined=s;function i(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=i;function l(u){return class{constructor(){return new Proxy({},{get(E,d){if(E[d])return E[d];throw new Error(`Not Implemented: ${u}->${String(d)}`)}})}}}e.NotImplementedProxy=l;function o(u){throw new Error("Unreachable")}e.assertNever=o}),define(me[30],ge([0,1,9,10,8,12]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(n){return n===47||n===92}e.isPathSeparator=D;function P(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=P;function y(n,s=T.posix.sep){if(!n)return"";const i=n.length,l=n.charCodeAt(0);if(D(l)){if(D(n.charCodeAt(1))&&!D(n.charCodeAt(2))){let u=3;const E=u;for(;u<i&&!D(n.charCodeAt(u));u++);if(E!==u&&!D(n.charCodeAt(u+1))){for(u+=1;u<i;u++)if(D(n.charCodeAt(u)))return n.slice(0,u+1).replace(/[\\/]/g,s)}}return s}else if(S(l)&&n.charCodeAt(1)===58)return D(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let o=n.indexOf("://");if(o!==-1){for(o+=3;o<i;o++)if(D(n.charCodeAt(o)))return n.slice(0,o+1)}return""}e.getRoot=y;function k(n){if(!b.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let i=2;const l=i;for(;i<n.length&&(s=n.charCodeAt(i),s!==92);i++);return!(l===i||(s=n.charCodeAt(i+1),isNaN(s)||s===92))}e.isUNC=k;const r=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(n,s=b.isWindows){const i=s?r:C;return!(!n||n.length===0||/^\s+$/.test(n)||(i.lastIndex=0,i.test(n))||s&&g.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=m;function a(n,s,i){const l=n===s;return!i||l?l:!n||!s?!1:(0,I.equalsIgnoreCase)(n,s)}e.isEqual=a;function h(n,s,i,l=T.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(i){if(!(0,I.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let u=s.length;return s.charAt(s.length-1)===l&&u--,n.charAt(u)===l}return s.charAt(s.length-1)!==l&&(s+=l),n.indexOf(s)===0}e.isEqualOrParent=h;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function w(n,s){return b.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(s,n)),n=(0,T.normalize)(n),b.isWindows?(n=(0,I.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,I.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=w;function _(n){const s=(0,T.normalize)(n);return b.isWindows?n.length>3?!1:p(s)&&(n.length===2||s.charCodeAt(2)===92):s===T.posix.sep}e.isRootOrDriveLetter=_;function p(n){return b.isWindows?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function c(n){return p(n)?n[0]:void 0}e.getDriveLetter=c;function f(n,s,i){return s.length>n.length?-1:n===s?0:(i&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=f;function t(n){const s=n.split(":");let i,l,o;if(s.forEach(u=>{const E=Number(u);(0,A.isNumber)(E)?l===void 0?l=E:o===void 0&&(o=E):i=i?[i,u].join(":"):u}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:l!==void 0?l:void 0,column:o!==void 0?o:l!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[23],ge([0,1,12]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const h=Array.isArray(a)?[]:{};return Object.keys(a).forEach(S=>{a[S]&&typeof a[S]=="object"?h[S]=I(a[S]):h[S]=a[S]}),h}e.deepClone=I;function T(a){if(!a||typeof a!="object")return a;const h=[a];for(;h.length>0;){const S=h.shift();Object.freeze(S);for(const w in S)if(A.call(S,w)){const _=S[w];typeof _=="object"&&!Object.isFrozen(_)&&h.push(_)}}return a}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function D(a,h){return P(a,h,new Set)}e.cloneAndChange=D;function P(a,h,S){if((0,b.isUndefinedOrNull)(a))return a;const w=h(a);if(typeof w!="undefined")return w;if((0,b.isArray)(a)){const _=[];for(const p of a)_.push(P(p,h,S));return _}if((0,b.isObject)(a)){if(S.has(a))throw new Error("Cannot clone recursive data-structure");S.add(a);const _={};for(let p in a)A.call(a,p)&&(_[p]=P(a[p],h,S));return S.delete(a),_}return a}function y(a,h,S=!0){return(0,b.isObject)(a)?((0,b.isObject)(h)&&Object.keys(h).forEach(w=>{w in a?S&&((0,b.isObject)(a[w])&&(0,b.isObject)(h[w])?y(a[w],h[w],S):a[w]=h[w]):a[w]=h[w]}),a):h}e.mixin=y;function k(a,h){if(a===h)return!0;if(a==null||h===null||h===void 0||typeof a!=typeof h||typeof a!="object"||Array.isArray(a)!==Array.isArray(h))return!1;let S,w;if(Array.isArray(a)){if(a.length!==h.length)return!1;for(S=0;S<a.length;S++)if(!k(a[S],h[S]))return!1}else{const _=[];for(w in a)_.push(w);_.sort();const p=[];for(w in h)p.push(w);if(p.sort(),!k(_,p))return!1;for(S=0;S<_.length;S++)if(!k(a[_[S]],h[_[S]]))return!1}return!0}e.equals=k;function r(a){const h=new Set;return JSON.stringify(a,(S,w)=>{if((0,b.isObject)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}e.safeStringify=r;function C(a,h,S){const w=h(a);return typeof w=="undefined"?S:w}e.getOrDefault=C;function g(a,h){const S=Object.create(null);return!a||!h||Object.keys(h).forEach(_=>{const p=a[_],c=h[_];k(p,c)||(S[_]=c)}),S}e.distinct=g;function m(a,h){const S=h.toLowerCase(),w=Object.keys(a).find(_=>_.toLowerCase()===S);return w?a[w]:a[h]}e.getCaseInsensitive=m}),define(me[95],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function T(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=T}),define(me[2],ge([0,1,9,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function P(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!T.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,i){return!s&&!i?"file":s}function k(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const r="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,l,o,u,E,d=!1){typeof i=="object"?(this.scheme=i.scheme||r,this.authority=i.authority||r,this.path=i.path||r,this.query=i.query||r,this.fragment=i.fragment||r):(this.scheme=y(i,d),this.authority=l||r,this.path=k(this.scheme,o||r),this.query=u||r,this.fragment=E||r,P(this,d))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:l,authority:o,path:u,query:E,fragment:d}=i;return l===void 0?l=this.scheme:l===null&&(l=r),o===void 0?o=this.authority:o===null&&(o=r),u===void 0?u=this.path:u===null&&(u=r),E===void 0?E=this.query:E===null&&(E=r),d===void 0?d=this.fragment:d===null&&(d=r),l===this.scheme&&o===this.authority&&u===this.path&&E===this.query&&d===this.fragment?this:new h(l,o,u,E,d)}static parse(i,l=!1){const o=g.exec(i);return o?new h(o[2]||r,n(o[4]||r),n(o[5]||r),n(o[7]||r),n(o[9]||r),l):new h(r,r,r,r,r)}static file(i){let l=r;if(b.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const o=i.indexOf(C,2);o===-1?(l=i.substring(2),i=C):(l=i.substring(2,o),i=i.substring(o)||C)}return new h("file",l,i,r,r)}static from(i){return new h(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...l){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return b.isWindows&&i.scheme==="file"?o=m.file(I.win32.join(p(i,!0),...l)).path:o=I.posix.join(i.path,...l),i.with({path:o})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const l=new h(i);return l._formatted=i.external,l._fsPath=i._sep===a?i.fsPath:null,l}}else return i}}e.URI=m;const a=b.isWindows?1:void 0;class h extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=a),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let l,o=-1;for(let u=0;u<s.length;u++){const E=s.charCodeAt(u);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||i&&E===47)o!==-1&&(l+=encodeURIComponent(s.substring(o,u)),o=-1),l!==void 0&&(l+=s.charAt(u));else{l===void 0&&(l=s.substr(0,u));const d=S[E];d!==void 0?(o!==-1&&(l+=encodeURIComponent(s.substring(o,u)),o=-1),l+=d):o===-1&&(o=u)}}return o!==-1&&(l+=encodeURIComponent(s.substring(o))),l!==void 0?l:s}function _(s){let i;for(let l=0;l<s.length;l++){const o=s.charCodeAt(l);o===35||o===63?(i===void 0&&(i=s.substr(0,l)),i+=S[o]):i!==void 0&&(i+=s[l])}return i!==void 0?i:s}function p(s,i){let l;return s.authority&&s.path.length>1&&s.scheme==="file"?l=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?l=s.path.substr(1):l=s.path[1].toLowerCase()+s.path.substr(2):l=s.path,b.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=p;function c(s,i){const l=i?_:w;let o="",{scheme:u,authority:E,path:d,query:v,fragment:R}=s;if(u&&(o+=u,o+=":"),(E||u==="file")&&(o+=C,o+=C),E){let L=E.indexOf("@");if(L!==-1){const H=E.substr(0,L);E=E.substr(L+1),L=H.indexOf(":"),L===-1?o+=l(H,!1):(o+=l(H.substr(0,L),!1),o+=":",o+=l(H.substr(L+1),!1)),o+="@"}E=E.toLowerCase(),L=E.indexOf(":"),L===-1?o+=l(E,!1):(o+=l(E.substr(0,L),!1),o+=E.substr(L))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const L=d.charCodeAt(1);L>=65&&L<=90&&(d=`/${String.fromCharCode(L+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const L=d.charCodeAt(0);L>=65&&L<=90&&(d=`${String.fromCharCode(L+32)}:${d.substr(2)}`)}o+=l(d,!0)}return v&&(o+="?",o+=l(v,!1)),R&&(o+="#",o+=i?R:w(R,!1)),o}function f(s){try{return decodeURIComponent(s)}catch(i){return s.length>3?s.substr(0,3)+f(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,i=>f(i)):s}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[24],ge([0,1,2,10]),function(G,e,b,I){"use strict";var T,A,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,s){let i=t.get(n);return i===void 0&&(i=s,t.set(n,i)),i}e.getOrSet=P;function y(t){const n=[];return t.forEach((s,i)=>{n.push(`${i} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=y;function k(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class r{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=r;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class g{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new a(n))}static forPaths(){return new S(new g)}static forStrings(){return new S(new r)}static forConfigKeys(){return new S(new C)}clear(){this._root=void 0}set(n,s){const i=this._iter.reset(n);let l;for(this._root||(this._root=new h,this._root.segment=i.value()),l=this._root;;){const u=i.cmp(l.segment);if(u>0)l.left||(l.left=new h,l.left.segment=i.value()),l=l.left;else if(u<0)l.right||(l.right=new h,l.right.segment=i.value()),l=l.right;else if(i.hasNext())i.next(),l.mid||(l.mid=new h,l.mid.segment=i.value()),l=l.mid;else break}const o=l.value;return l.value=s,l.key=n,o}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let i=this._root;for(;i;){const l=s.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const i=this._iter.reset(n),l=[];let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)l.push([1,o]),o=o.left;else if(u<0)l.push([-1,o]),o=o.right;else if(i.hasNext())i.next(),l.push([0,o]),o=o.mid;else{for(s?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;l.length>0&&o.isEmpty();){let[E,d]=l.pop();switch(E){case 1:d.left=void 0;break;case 0:d.mid=void 0;break;case-1:d.right=void 0;break}o=d}break}}}findSubstr(n){const s=this._iter.reset(n);let i=this._root,l;for(;i;){const o=s.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(s.hasNext())s.next(),l=i.value||l,i=i.mid;else break}return i&&i.value||l}findSuperstr(n){const s=this._iter.reset(n);let i=this._root;for(;i;){const l=s.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[s,i]of this)n(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=S;class w{constructor(n,s){this[T]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s!=null?s:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[i,l]of this.map)n(l,b.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class p{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const i=this._map.get(n);if(!!i)return s!==0&&this.touch(i,s),i.value}set(n,s,i=0){let l=this._map.get(n);if(l)l.value=s,i!==0&&this.touch(l,i);else{switch(l={key:n,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const i=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const o={value:i.key,done:!1};return i=i.next,o}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const o={value:i.value,done:!1};return i=i.next,o}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const o={value:[i.key,i.value],done:!1};return i=i.next,o}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>n;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,i=n.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const i=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(i.previous=l,l.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const i=n.next,l=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=l,l.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,i)=>{n.push([i,s])}),n}fromJSON(n){this.clear();for(const[s,i]of n)this.set(s,i)}}e.LinkedMap=p;class c extends p{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class f{constructor(n){D.set(this,void 0),tt(this,D,n,"f")}get size(){return Ue(this,D,"f").size}forEach(n,s){Ue(this,D,"f").forEach(n,s)}get(n){return Ue(this,D,"f").get(n)}has(n){return Ue(this,D,"f").has(n)}entries(){return Ue(this,D,"f").entries()}keys(){return Ue(this,D,"f").keys()}values(){return Ue(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ue(this,D,"f").entries()}}e.ReadonlyMapView=f}),define(me[96],ge([0,1,24,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(Ie,Re){for(let We=0,Ee=be.length;We<Ee;We++){const Ke=be[We](Ie,Re);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(be,Ie,Re){if(!Re||Re.length<Ie.length)return null;let We;return be?We=I.startsWithIgnoreCase(Re,Ie):We=Re.indexOf(Ie)===0,We?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function D(be,Ie){const Re=Ie.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}e.matchesContiguousSubString=D;function P(be,Ie){return y(be.toLowerCase(),Ie.toLowerCase(),0,0)}e.matchesSubString=P;function y(be,Ie,Re,We){if(Re===be.length)return[];if(We===Ie.length)return null;if(be[Re]===Ie[We]){let Ee=null;return(Ee=y(be,Ie,Re+1,We+1))?w({start:We,end:We+1},Ee):null}return y(be,Ie,Re,We+1)}function k(be){return 97<=be&&be<=122}function r(be){return 65<=be&&be<=90}e.isUpper=r;function C(be){return 48<=be&&be<=57}function g(be){return be===32||be===9||be===10||be===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>m.add(be.charCodeAt(0)));function a(be){return g(be)||m.has(be)}function h(be,Ie){return be===Ie||a(be)&&a(Ie)}function S(be){return k(be)||r(be)||C(be)}function w(be,Ie){return Ie.length===0?Ie=[be]:be.end===Ie[0].start?Ie[0].start=be.start:Ie.unshift(be),Ie}function _(be,Ie){for(let Re=Ie;Re<be.length;Re++){const We=be.charCodeAt(Re);if(r(We)||C(We)||Re>0&&!S(be.charCodeAt(Re-1)))return Re}return be.length}function p(be,Ie,Re,We){if(Re===be.length)return[];if(We===Ie.length)return null;if(be[Re]!==Ie[We].toLowerCase())return null;{let Ee=null,Ke=We+1;for(Ee=p(be,Ie,Re+1,We+1);!Ee&&(Ke=_(Ie,Ke))<Ie.length;)Ee=p(be,Ie,Re+1,Ke),Ke++;return Ee===null?null:w({start:We,end:We+1},Ee)}}function c(be){let Ie=0,Re=0,We=0,Ee=0,Ke=0;for(let ze=0;ze<be.length;ze++)Ke=be.charCodeAt(ze),r(Ke)&&Ie++,k(Ke)&&Re++,S(Ke)&&We++,C(Ke)&&Ee++;const X=Ie/be.length,re=Re/be.length,_e=We/be.length,xe=Ee/be.length;return{upperPercent:X,lowerPercent:re,alphaPercent:_e,numericPercent:xe}}function f(be){const{upperPercent:Ie,lowerPercent:Re}=be;return Re===0&&Ie>.6}function t(be){const{upperPercent:Ie,lowerPercent:Re,alphaPercent:We,numericPercent:Ee}=be;return Re>.2&&Ie<.8&&We>.6&&Ee<.2}function n(be){let Ie=0,Re=0,We=0,Ee=0;for(let Ke=0;Ke<be.length;Ke++)We=be.charCodeAt(Ke),r(We)&&Ie++,k(We)&&Re++,g(We)&&Ee++;return(Ie===0||Re===0)&&Ee===0?be.length<=30:Ie<=5}function s(be,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!n(be)||Ie.length>60)return null;const Re=c(Ie);if(!t(Re)){if(!f(Re))return null;Ie=Ie.toLowerCase()}let We=null,Ee=0;for(be=be.toLowerCase();Ee<Ie.length&&(We=p(be,Ie,0,Ee))===null;)Ee=_(Ie,Ee+1);return We}e.matchesCamelCase=s;function i(be,Ie,Re=!1){if(!Ie||Ie.length===0)return null;let We=null,Ee=0;for(be=be.toLowerCase(),Ie=Ie.toLowerCase();Ee<Ie.length&&(We=l(be,Ie,0,Ee,Re))===null;)Ee=o(Ie,Ee+1);return We}e.matchesWords=i;function l(be,Ie,Re,We,Ee){if(Re===be.length)return[];if(We===Ie.length)return null;if(h(be.charCodeAt(Re),Ie.charCodeAt(We))){let Ke=null,X=We+1;if(Ke=l(be,Ie,Re+1,We+1,Ee),!Ee)for(;!Ke&&(X=o(Ie,X))<Ie.length;)Ke=l(be,Ie,Re+1,X,Ee),X++;return Ke===null?null:w({start:We,end:We+1},Ke)}else return null}function o(be,Ie){for(let Re=Ie;Re<be.length;Re++)if(a(be.charCodeAt(Re))||Re>0&&a(be.charCodeAt(Re-1)))return Re;return be.length}const u=T(e.matchesPrefix,s,D),E=T(e.matchesPrefix,s,P),d=new b.LRUCache(1e4);function v(be,Ie,Re=!1){if(typeof be!="string"||typeof Ie!="string")return null;let We=d.get(be);We||(We=new RegExp(I.convertSimple2RegExpPattern(be),"i"),d.set(be,We));const Ee=We.exec(Ie);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Re?E(be,Ie):u(be,Ie)}e.matchesFuzzy=v;function R(be,Ie){const Re=V(be,be.toLowerCase(),0,Ie,Ie.toLowerCase(),0,!0);return Re?H(Re):null}e.matchesFuzzy2=R;function L(be,Ie,Re,We,Ee,Ke){const X=Math.min(13,be.length);for(;Re<X;Re++){const re=V(be,Ie,Re,We,Ee,Ke,!1);if(re)return re}return[0,Ke]}e.anyScore=L;function H(be){if(typeof be=="undefined")return[];const Ie=[],Re=be[1];for(let We=be.length-1;We>1;We--){const Ee=be[We]+Re,Ke=Ie[Ie.length-1];Ke&&Ke.end===Ee?Ke.end=Ee+1:Ie.push({start:Ee,end:Ee+1})}return Ie}e.createMatches=H;const ie=128;function j(){const be=[],Ie=[];for(let Re=0;Re<=ie;Re++)Ie[Re]=0;for(let Re=0;Re<=ie;Re++)be.push(Ie.slice(0));return be}function B(be){const Ie=[];for(let Re=0;Re<=be;Re++)Ie[Re]=0;return Ie}const $=B(2*ie),N=B(2*ie),M=j(),F=j(),U=j(),O=!1;function W(be,Ie,Re,We,Ee){function Ke(re,_e,xe=" "){for(;re.length<_e;)re=xe+re;return re}let X=` |   |${We.split("").map(re=>Ke(re,3)).join("|")}
`;for(let re=0;re<=Re;re++)re===0?X+=" |":X+=`${Ie[re-1]}|`,X+=be[re].slice(0,Ee+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return X}function q(be,Ie,Re,We){be=be.substr(Ie),Re=Re.substr(We),console.log(W(F,be,be.length,Re,Re.length)),console.log(W(U,be,be.length,Re,Re.length)),console.log(W(M,be,be.length,Re,Re.length))}function Q(be,Ie){if(Ie<0||Ie>=be.length)return!1;const Re=be.codePointAt(Ie);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Re)}}function he(be,Ie){if(Ie<0||Ie>=be.length)return!1;switch(be.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function ve(be,Ie,Re){return Ie[be]!==Re[be]}function Pe(be,Ie,Re,We,Ee,Ke,X=!1){for(;Ie<Re&&Ee<Ke;)be[Ie]===We[Ee]&&(X&&($[Ie]=Ee),Ie+=1),Ee+=1;return Ie===Re}e.isPatternInWord=Pe;var ke;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Le;(function(be){be.Default=[-100,0];function Ie(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=Ie})(Le=e.FuzzyScore||(e.FuzzyScore={}));function V(be,Ie,Re,We,Ee,Ke,X){const re=be.length>ie?ie:be.length,_e=We.length>ie?ie:We.length;if(!(Re>=re||Ke>=_e||re-Re>_e-Ke)&&!!Pe(Ie,Re,re,Ee,Ke,_e,!0)){J(re,_e,Re,Ke,Ie,Ee);let xe=1,ze=1,$e=Re,Ye=Ke;const K=[!1];for(xe=1,$e=Re;$e<re;xe++,$e++){const ce=$[$e],pe=N[$e],Se=$e+1<re?N[$e+1]:_e;for(ze=ce-Ke+1,Ye=ce;Ye<Se;ze++,Ye++){let qe=Number.MIN_SAFE_INTEGER,Me=!1;Ye<=pe&&(qe=ee(be,Ie,$e,Re,We,Ee,Ye,_e,Ke,M[xe-1][ze-1]===0,K));let He=0;qe!==Number.MAX_SAFE_INTEGER&&(Me=!0,He=qe+F[xe-1][ze-1]);const Qe=Ye>ce,it=Qe?F[xe][ze-1]+(M[xe][ze-1]>0?-5:0):0,at=Ye>ce+1&&M[xe][ze-1]>0,Ze=at?F[xe][ze-2]+(M[xe][ze-2]>0?-5:0):0;if(at&&(!Qe||Ze>=it)&&(!Me||Ze>=He))F[xe][ze]=Ze,U[xe][ze]=3,M[xe][ze]=0;else if(Qe&&(!Me||it>=He))F[xe][ze]=it,U[xe][ze]=2,M[xe][ze]=0;else if(Me)F[xe][ze]=He,U[xe][ze]=1,M[xe][ze]=M[xe-1][ze-1]+1;else throw new Error("not possible")}}if(O&&q(be,Re,We,Ke),!(!K[0]&&!X)){xe--,ze--;const oe=[F[xe][ze],Ke];let fe=0,Z=0;for(;xe>=1;){let ce=ze;do{const pe=U[xe][ce];if(pe===3)ce=ce-2;else if(pe===2)ce=ce-1;else break}while(ce>=1);fe>1&&Ie[Re+xe-1]===Ee[Ke+ze-1]&&!ve(ce+Ke-1,We,Ee)&&fe+1>M[xe][ce]&&(ce=ze),ce===ze?fe++:fe=1,Z||(Z=ce),xe--,ze=ce-1,oe.push(ze)}_e===re&&(oe[0]+=2);const ne=Z-re;return oe[0]-=ne,oe}}}e.fuzzyScore=V;function J(be,Ie,Re,We,Ee,Ke){let X=be-1,re=Ie-1;for(;X>=Re&&re>=We;)Ee[X]===Ke[re]&&(N[X]=re,X--),re--}function ee(be,Ie,Re,We,Ee,Ke,X,re,_e,xe,ze){if(Ie[Re]!==Ke[X])return Number.MIN_SAFE_INTEGER;let $e=1,Ye=!1;return X===Re-We?$e=be[Re]===Ee[X]?7:5:ve(X,Ee,Ke)&&(X===0||!ve(X-1,Ee,Ke))?($e=be[Re]===Ee[X]?7:5,Ye=!0):Q(Ke,X)&&(X===0||!Q(Ke,X-1))?$e=5:(Q(Ke,X-1)||he(Ke,X-1))&&($e=5,Ye=!0),$e>1&&Re===We&&(ze[0]=!0),Ye||(Ye=ve(X,Ee,Ke)||Q(Ke,X-1)||he(Ke,X-1)),Re===We?X>_e&&($e-=Ye?3:5):xe?$e+=Ye?2:0:$e+=Ye?0:1,X+1===re&&($e-=Ye?3:5),$e}function ae(be,Ie,Re,We,Ee,Ke,X){return Ce(be,Ie,Re,We,Ee,Ke,!0,X)}e.fuzzyScoreGracefulAggressive=ae;function we(be,Ie,Re,We,Ee,Ke,X){return Ce(be,Ie,Re,We,Ee,Ke,!1,X)}e.fuzzyScoreGraceful=we;function Ce(be,Ie,Re,We,Ee,Ke,X,re){let _e=V(be,Ie,Re,We,Ee,Ke,re);if(_e&&!X)return _e;if(be.length>=3){const xe=Math.min(7,be.length-1);for(let ze=Re+1;ze<xe;ze++){const $e=Oe(be,ze);if($e){const Ye=V($e,$e.toLowerCase(),Re,We,Ee,Ke,re);Ye&&(Ye[0]-=3,(!_e||Ye[0]>_e[0])&&(_e=Ye))}}}return _e}function Oe(be,Ie){if(!(Ie+1>=be.length)){const Re=be[Ie],We=be[Ie+1];if(Re!==We)return be.slice(0,Ie)+We+Re+be.slice(Ie+2)}}}),define(me[136],ge([0,1,43,96,10]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${A.source}`,"g");function P(h){return h.replace(D,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=P;const y=new RegExp(`\\\\${A.source}`,"g");function k(h){return h.replace(y,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=k;const r=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(r,(S,w,_,p)=>_?S:w||p||"")}e.stripIcons=C;function g(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:m(h,S)}e.parseLabelWithIcons=g;function m(h,S){const w=[];let _="";function p(o){if(o){_+=o;for(const u of o)w.push(t)}}let c=-1,f="",t=0,n,s,i=S;const l=h.length;for(p(h.substr(0,S));i<l;)n=h[i],s=h[i+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(c=i,p(f),f=e.iconStartMarker,i++):n===")"&&c!==-1?(t+=i-c+1,c=-1,f=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(p(f),c=-1,f=""):p(n),i++;return p(f),{text:_,iconOffsets:w}}function a(h,S,w=!1){const{text:_,iconOffsets:p}=S;if(!p||p.length===0)return(0,I.matchesFuzzy)(h,_,w);const c=(0,T.ltrim)(_," "),f=_.length-c.length,t=(0,I.matchesFuzzy)(h,c,w);if(t)for(const n of t){const s=p[n.start+f]+f;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(me[97],ge([0,1,15,136,18]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(h="",S=!1){var w,_;if(this.value=h,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(w=S.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(_=S.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(h,S=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(h):h).replace(/([ \t]+)/g,(w,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,S){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=D;function P(a){return y(a)?!a.value:Array.isArray(a)?a.every(P):!0}e.isEmptyMarkdownString=P;function y(a){return a instanceof D?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function k(a,h){return!a&&!h?!0:!a||!h?!1:Array.isArray(a)&&Array.isArray(h)?(0,b.equals)(a,h,r):y(a)&&y(h)?r(a,h):!1}e.markedStringsEquals=k;function r(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function g(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function m(a){const h=[],S=a.split("|").map(_=>_.trim());a=S[0];const w=S[1];if(w){const _=/height=(\d+)/.exec(w),p=/width=(\d+)/.exec(w),c=_?_[1]:"",f=p?p[1]:"",t=isFinite(parseInt(f)),n=isFinite(parseInt(c));t&&h.push(`width="${f}"`),n&&h.push(`height="${c}"`)}return{href:a,dimensions:h}}e.parseHrefAndDimensions=m}),define(me[58],ge([0,1,22,10,2]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,P)}e.stringify=A;function D(k){let r=JSON.parse(k);return r=y(r),r}e.parse=D;function P(k,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:(0,I.regExpFlags)(r)}:r}function y(k,r=0){if(!k||r>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return T.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof b.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=y(k[C],r+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=y(k[C],r+1))}return k}e.revive=y}),define(me[11],ge([0,1,2,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,k,r){this._hosts[y]=k,this._ports[y]=r}setConnectionToken(y,k){this._connectionTokens[y]=k}rewrite(y){if(this._delegate)return this._delegate(y);const k=y.authority;let r=this._hosts[k];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const C=this._ports[k],g=this._connectionTokens[k];let m=`path=${encodeURIComponent(y.path)}`;return typeof g=="string"&&(m+=`&tkn=${encodeURIComponent(g)}`),b.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${r}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,k,r){const C=this.toUri(y,k);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(r||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(y,k){const r=this.toUri(y,k);return r.scheme===T.vscodeFileResource?r.with({scheme:T.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(y,k){return b.URI.isUri(y)?y:b.URI.parse(k.toUrl(y))}}e.FileAccess=new D}),define(me[75],ge([0,1,24]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new b.LRUCache(1e4);function T(k){return y(k,"NFC",I)}e.normalizeNFC=T;const A=new b.LRUCache(1e4);function D(k){return y(k,"NFD",A)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function y(k,r,C){if(!e.canNormalize||!k)return k;const g=C.get(k);if(g)return g;let m;return P.test(k)?m=k.normalize(r):m=k,C.set(k,m),m}e.removeAccents=function(){if(e.canNormalize){const k=/[\u0300-\u036f]/g;return function(r){return D(r).replace(k,"")}}else return function(k){return k}}()}),define(me[25],ge([0,1,30,8,2,10,11,9]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=y;class k{constructor(a){this._ignorePathCasing=a}compare(a,h,S=!1){return a===h?0:(0,A.compare)(this.getComparisonKey(a,S),this.getComparisonKey(h,S))}isEqual(a,h,S=!1){return a===h?!0:!a||!h?!1:this.getComparisonKey(a,S)===this.getComparisonKey(h,S)}getComparisonKey(a,h=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,h,S=!1){if(a.scheme===h.scheme){if(a.scheme===D.Schemas.file)return b.isEqualOrParent(y(a),y(h),this._ignorePathCasing(a))&&a.query===h.query&&(S||a.fragment===h.fragment);if((0,e.isEqualAuthority)(a.authority,h.authority))return b.isEqualOrParent(a.path,h.path,this._ignorePathCasing(a),"/")&&a.query===h.query&&(S||a.fragment===h.fragment)}return!1}joinPath(a,...h){return T.URI.joinPath(a,...h)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return I.posix.basename(a.path)}extname(a){return I.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let h;return a.scheme===D.Schemas.file?h=T.URI.file(I.dirname(y(a))).path:(h=I.posix.dirname(a.path),a.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),h="/")),a.with({path:h})}normalizePath(a){if(!a.path.length)return a;let h;return a.scheme===D.Schemas.file?h=T.URI.file(I.normalize(y(a))).path:h=I.posix.normalize(a.path),a.with({path:h})}relativePath(a,h){if(!(a.scheme!==h.scheme||!(0,e.isEqualAuthority)(a.authority,h.authority))){if(a.scheme===D.Schemas.file){const _=I.relative(y(a),y(h));return P.isWindows?b.toSlashes(_):_}let S=a.path||"/",w=h.path||"/";if(this._ignorePathCasing(a)){let _=0;for(const p=Math.min(S.length,w.length);_<p&&!(S.charCodeAt(_)!==w.charCodeAt(_)&&S.charAt(_).toLowerCase()!==w.charAt(_).toLowerCase());_++);S=w.substr(0,_)+S.substr(_)}return I.posix.relative(S,w)}}resolvePath(a,h){if(a.scheme===D.Schemas.file){const S=T.URI.file(I.resolve(y(a),h));return a.with({authority:S.authority,path:S.path})}return h.indexOf("/")===-1&&(h=b.toSlashes(h),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h)),a.with({path:I.posix.resolve(a.path,h)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,h){return a===h||(0,A.equalsIgnoreCase)(a,h)}hasTrailingPathSeparator(a,h=I.sep){if(a.scheme===D.Schemas.file){const S=y(a);return S.length>b.getRoot(S).length&&S[S.length-1]===h}else{const S=a.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,h=I.sep){return(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,h=I.sep){let S=!1;if(a.scheme===D.Schemas.file){const w=y(a);S=w!==void 0&&w.length===b.getRoot(w).length&&w[w.length-1]===h}else{h="/";const w=a.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(m=>m.scheme===D.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(m,a){const h=[];for(let S=0;S<m.length;S++){const w=a(m[S]);m.some((_,p)=>p===S?!1:(0,e.isEqualOrParent)(w,a(_)))||h.push(m[S])}return h}e.distinctParents=r;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(h){const S=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(p=>{const[c,f]=p.split(":");c&&f&&S.set(c,f)});const _=h.path.substring(0,h.path.indexOf(";"));return _&&S.set(m.META_DATA_MIME,_),S}m.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function g(m,a,h){if(a){let S=m.path;return S&&S[0]!==I.posix.sep&&(S=I.posix.sep+S),m.with({scheme:h,authority:a,path:S})}return m.with({scheme:h})}e.toLocalResource=g}),define(me[19],ge([0,1,21,18,3,6,56,25]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(F){return!!F&&typeof F.then=="function"}e.isThenable=y;function k(F){const U=new b.CancellationTokenSource,O=F(U.token),W=new Promise((q,Q)=>{U.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(O).then(he=>{U.dispose(),q(he)},he=>{U.dispose(),Q(he)})});return new class{cancel(){U.cancel()}then(q,Q){return W.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=k;function r(F,U,O){return Promise.race([F,new Promise(W=>U.onCancellationRequested(()=>W(O)))])}e.raceCancellation=r;async function C(F){let U=-1;const O=F.map((q,Q)=>q.then(he=>(U=Q,he))),W=await Promise.race(O);return F.forEach((q,Q)=>{Q!==U&&q.cancel()}),W}e.raceCancellablePromises=C;function g(F,U,O){let W;const q=setTimeout(()=>{W==null||W(void 0),O==null||O()},U);return Promise.race([F.finally(()=>clearTimeout(q)),new Promise(Q=>W=Q)])}e.raceTimeout=g;function m(F){return new Promise((U,O)=>{const W=F();y(W)?W.then(U,O):U(W)})}e.asPromise=m;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(O,O).then(W)})}return new Promise((O,W)=>{this.queuedPromise.then(O,W)})}return this.activePromise=U(),new Promise((O,W)=>{this.activePromise.then(q=>{this.activePromise=null,O(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(U,O){var W;const Q=((W=this.promiseMap.get(U))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(U)===Q&&this.promiseMap.delete(U)});return this.promiseMap.set(U,Q),Q}}e.SequencerByKey=S;class w{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,O=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,q)=>{this.doResolve=W,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class _{constructor(U){this.delayer=new w(U),this.throttler=new a}trigger(U,O){return this.delayer.trigger(()=>this.throttler.queue(U),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class p{constructor(){this._isOpen=!1,this._promise=new Promise((U,O)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class c extends p{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function f(F,U){return U?new Promise((O,W)=>{const q=setTimeout(O,F);U.onCancellationRequested(()=>{clearTimeout(q),W((0,I.canceled)())})}):k(O=>f(F,O))}e.timeout=f;function t(F,U=0){const O=setTimeout(F,U);return(0,A.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(F){return F.then(void 0,U=>{})}e.ignoreErrors=n;function s(F){const U=[];let O=0;const W=F.length;function q(){return O<W?F[O++]():null}function Q(he){he!=null&&U.push(he);const ve=q();return ve?ve.then(Q):Promise.resolve(U)}return Promise.resolve(null).then(Q)}e.sequence=s;function i(F,U=W=>!!W,O=null){let W=0;const q=F.length,Q=()=>{if(W>=q)return Promise.resolve(O);const he=F[W++];return Promise.resolve(he()).then(Pe=>U(Pe)?Promise.resolve(Pe):Q())};return Q()}e.first=i;function l(F,U=W=>!!W,O=null){if(F.length===0)return Promise.resolve(O);let W=F.length;const q=()=>{var Q,he;W=-1;for(const ve of F)(he=(Q=ve).cancel)===null||he===void 0||he.call(Q)};return new Promise((Q,he)=>{for(const ve of F)ve.then(Pe=>{--W>=0&&U(Pe)?(q(),Q(Pe)):W===0&&Q(O)}).catch(Pe=>{--W>=0&&(q(),he(Pe))})})}e.firstParallel=l;class o{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((O,W)=>{this.outstandingPromises.push({factory:U,c:O,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const O=U.factory();O.then(U.c,U.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class u extends o{constructor(){super(1)}}e.Queue=u;class E{constructor(){this.queues=new Map}queueFor(U,O=P.extUri){const W=O.getComparisonKey(U);let q=this.queues.get(W);return q||(q=new u,T.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(W)}),this.queues.set(W,q)),q}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=E;class d{constructor(U,O){this._token=-1,typeof U=="function"&&typeof O=="number"&&this.setIfNotSet(U,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},O)}setIfNotSet(U,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},O))}}e.TimeoutTimer=d;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,O){this.cancel(),this._token=setInterval(()=>{U()},O)}}e.IntervalTimer=v;class R{constructor(U,O){this.timeoutToken=-1,this.runner=U,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class L extends R{constructor(U,O){super(U,O);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const O=setTimeout(()=>U(F));let W=!1;return{dispose(){W||(W=!0,clearTimeout(O))}}}}else e.runWhenIdle=(F,U)=>{const O=requestIdleCallback(F,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(O))}}}}();class H{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function ie(F,U,O){let W;for(let q=0;q<O;q++)try{return await F()}catch(Q){W=Q,await f(U)}throw W}e.retry=ie;class j{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var U;(U=this._pending)===null||U===void 0||U.cancel()}setPending(U,O,W){return this._pending={taskId:U,cancel:()=>W==null?void 0:W(),promise:O},O.then(()=>this.donePending(U),()=>this.donePending(U)),O}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let O,W;const q=new Promise((Q,he)=>{O=Q,W=he});this._next={run:U,promise:q,promiseResolve:O,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=j;class B{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,O)=>{this.completeCallback=U,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(O=>{this.completeCallback(U),this.resolved=!0,O()})}error(U){return new Promise(O=>{this.errorCallback(U),this.rejected=!0,O()})}cancel(){new Promise(U=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=$;class N extends T.Emitter{async fireAsync(U,O,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,U]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),he=[],ve=Object.assign(Object.assign({},Q),{waitUntil:Pe=>{if(Object.isFrozen(he))throw new Error("waitUntil can NOT be called asynchronous");W&&(Pe=W(Pe,typeof q=="function"?q:q[0])),he.push(Pe)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Pe){(0,I.onUnexpectedError)(Pe);continue}Object.freeze(he),await M.settled(he).catch(Pe=>(0,I.onUnexpectedError)(Pe))}}}}e.AsyncEmitter=N;var M;(function(F){async function U(Q){return typeof Promise.allSettled=="function"?O(Q):W(Q)}F.allSettled=U;async function O(Q){return Promise.allSettled(Q)}async function W(Q){return Promise.all(Q.map(he=>he.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(Q){let he;const ve=await Promise.all(Q.map(Pe=>Pe.then(ke=>ke,ke=>{he||(he=ke)})));if(typeof he!="undefined")throw he;return ve}F.settled=q})(M=e.Promises||(e.Promises={}))}),define(me[98],ge([0,1,8,19]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(c,f,t=!1){const n=c||"",s=f||"",i=T.value.collator.compare(n,s);return T.value.collatorIsNumeric&&i===0&&n!==s?n<s?-1:1:i}e.compareFileNames=P;function y(c,f){const t=A.value.collator;return c=c||"",f=f||"",h(t,c,f)}e.compareFileNamesDefault=y;function k(c,f,t=!1){t||(c=c&&c.toLowerCase(),f=f&&f.toLowerCase());const[n,s]=m(c),[i,l]=m(f);return n!==i?n<i?-1:1:s===l?0:s<l?-1:1}e.noIntlCompareFileNames=k;function r(c,f){const[t,n]=m(c),[s,i]=m(f);let l=T.value.collator.compare(n,i);if(l===0){if(T.value.collatorIsNumeric&&n!==i)return n<i?-1:1;if(l=T.value.collator.compare(t,s),T.value.collatorIsNumeric&&l===0&&t!==s)return t<s?-1:1}return l}e.compareFileExtensions=r;function C(c,f){c=c||"",f=f||"";const t=a(c),n=a(f),s=A.value.collator,i=D.value.collator;let l;return l=h(i,t,n),l!==0?l:h(s,c,f)}e.compareFileExtensionsDefault=C;const g=/^(.*?)(\.([^.]*))?$/;function m(c,f=!1){const t=c?g.exec(c):[];let n=[t&&t[1]||"",t&&t[3]||""];return f&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function a(c){const f=c?g.exec(c):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function h(c,f,t){let n=c.compare(f,t);return n!==0?n:f.length!==t.length?f.length<t.length?-1:1:0}function S(c,f,t=!1){return t||(c=c&&c.toLowerCase(),f=f&&f.toLowerCase()),c===f?0:c<f?-1:1}function w(c,f,t=!1){const n=c.split(b.sep),s=f.split(b.sep),i=n.length-1,l=s.length-1;let o,u;for(let E=0;;E++){if(o=i===E,u=l===E,o&&u)return P(n[E],s[E],t);if(o)return-1;if(u)return 1;const d=S(n[E],s[E],t);if(d!==0)return d}}e.comparePaths=w;function _(c,f,t){const n=c.toLowerCase(),s=f.toLowerCase(),i=p(c,f,t);if(i)return i;const l=n.endsWith(t),o=s.endsWith(t);if(l!==o)return l?-1:1;const u=P(n,s);return u!==0?u:n.localeCompare(s)}e.compareAnything=_;function p(c,f,t){const n=c.toLowerCase(),s=f.toLowerCase(),i=n.startsWith(t),l=s.startsWith(t);if(i!==l)return i?-1:1;if(i&&l){if(n.length<s.length)return-1;if(n.length>s.length)return 1}return 0}e.compareByPrefix=p}),define(me[99],ge([0,1,98,96,8,9,10]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,y=[P,[]];function k(B,$,N,M){if(!B||!$)return y;const F=B.length,U=$.length;if(F<U)return y;const O=B.toLowerCase();return!M&&!O.includes(N)?y:r($,N,U,B,O,F)}e.scoreFuzzy=k;function r(B,$,N,M,F,U){const O=[],W=[];for(let ve=0;ve<N;ve++){const Pe=ve*U,ke=Pe-U,Le=ve>0,V=B[ve],J=$[ve];for(let ee=0;ee<U;ee++){const ae=ee>0,we=Pe+ee,Ce=we-1,Oe=ke+ee-1,be=ae?O[Ce]:0,Ie=Le&&ae?O[Oe]:0,Re=Le&&ae?W[Oe]:0;let We;!Ie&&Le?We=0:We=C(V,J,M,F,ee,Re),We&&Ie+We>=be?(W[we]=Re+1,O[we]=Ie+We):(W[we]=P,O[we]=be)}}const q=[];let Q=N-1,he=U-1;for(;Q>=0&&he>=0;){const ve=Q*U+he;W[ve]===P||(q.push(he),Q--),he--}return[O[N*U-1],q.reverse()]}function C(B,$,N,M,F,U){let O=0;if(!g($,M[F]))return O;if(O+=1,U>0&&(O+=U*5),B===N[F]&&(O+=1),F===0)O+=8;else{const W=m(N.charCodeAt(F-1));W?O+=W:(0,I.isUpper)(N.charCodeAt(F))&&(O+=2)}return O}function g(B,$){return B===$?!0:B==="/"||B==="\\"?$==="/"||$==="\\":!1}function m(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function h(B,$,N=0,M=0){const F=$;return F.values&&F.values.length>1?S(B,F.values,N,M):w(B,$,N,M)}e.scoreFuzzy2=h;function S(B,$,N,M){let F=0;const U=[];for(const O of $){const[W,q]=w(B,O,N,M);if(typeof W!="number")return a;F+=W,U.push(...q)}return[F,o(U)]}function w(B,$,N,M){const F=(0,I.fuzzyScore)($.original,$.originalLowercase,N,B,B.toLowerCase(),M,!0);return F?[F[0],(0,I.createMatches)(F)]:a}const _=Object.freeze({score:0}),p=1<<18,c=1<<17,f=1<<16;function t(B,$,N,M,F){if(!B||!$.normalized)return _;const U=M.getItemLabel(B);if(!U)return _;const O=M.getItemDescription(B);let W;O?W=`${U}${O}${$.normalized}${Array.isArray($.values)?$.values.length:""}${N}`:W=`${U}${$.normalized}${Array.isArray($.values)?$.values.length:""}${N}`;const q=F[W];if(q)return q;const Q=n(U,O,M.getItemPath(B),$,N);return F[W]=Q,Q}e.scoreItemFuzzy=t;function n(B,$,N,M,F){const U=!N||!M.containsPathSeparator;return N&&(A.isLinux?M.pathNormalized===N:(0,D.equalsIgnoreCase)(M.pathNormalized,N))?{score:p,labelMatch:[{start:0,end:B.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:M.values&&M.values.length>1?s(B,$,N,M.values,U,F):i(B,$,N,M,U,F)}function s(B,$,N,M,F,U){let O=0;const W=[],q=[];for(const Q of M){const{score:he,labelMatch:ve,descriptionMatch:Pe}=i(B,$,N,Q,F,U);if(he===P)return _;O+=he,ve&&W.push(...ve),Pe&&q.push(...Pe)}return{score:O,labelMatch:o(W),descriptionMatch:o(q)}}function i(B,$,N,M,F,U){if(F||!$){const[O,W]=k(B,M.normalized,M.normalizedLowercase,U);if(O){const q=(0,I.matchesPrefix)(M.normalized,B);let Q;return q?(Q=c,Q+=Math.round(M.normalized.length/B.length*100)):Q=f,{score:Q+O,labelMatch:q||l(W)}}}if($){let O=$;N&&(O=`${$}${T.sep}`);const W=O.length,q=`${O}${B}`,[Q,he]=k(q,M.normalized,M.normalizedLowercase,U);if(Q){const ve=l(he),Pe=[],ke=[];return ve.forEach(Le=>{Le.start<W&&Le.end>W?(Pe.push({start:0,end:Le.end-W}),ke.push({start:Le.start,end:W})):Le.start>=W?Pe.push({start:Le.start-W,end:Le.end-W}):ke.push(Le)}),{score:Q,labelMatch:Pe,descriptionMatch:ke}}}return _}function l(B){const $=[];if(!B)return $;let N;for(const M of B)N&&N.end===M?N.end+=1:(N={start:M,end:M+1},$.push(N));return $}function o(B){const $=B.sort((F,U)=>F.start-U.start),N=[];let M;for(const F of $)!M||!u(M,F)?(M=F,N.push(F)):(M.start=Math.min(M.start,F.start),M.end=Math.max(M.end,F.end));return N}function u(B,$){return!(B.end<$.start||$.end<B.start)}function E(B,$,N,M,F,U){const O=t(B,N,M,F,U),W=t($,N,M,F,U),q=O.score,Q=W.score;if((q===p||Q===p)&&q!==Q)return q===p?-1:1;if(q>f||Q>f){if(q!==Q)return q>Q?-1:1;if(q<c&&Q<c){const J=v(O.labelMatch,W.labelMatch);if(J!==0)return J}const Le=F.getItemLabel(B)||"",V=F.getItemLabel($)||"";if(Le.length!==V.length)return Le.length-V.length}if(q!==Q)return q>Q?-1:1;const he=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,ve=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(he&&!ve)return-1;if(ve&&!he)return 1;const Pe=d(B,O,F),ke=d($,W,F);return Pe&&ke&&Pe!==ke?ke>Pe?-1:1:R(B,$,N,F)}e.compareItemsByFuzzyScore=E;function d(B,$,N){let M=-1,F=-1;if($.descriptionMatch&&$.descriptionMatch.length?M=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(M=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(F=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const U=N.getItemDescription(B);U&&(F+=U.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(F=$.descriptionMatch[$.descriptionMatch.length-1].end);return F-M}function v(B,$){if(!B&&!$||(!B||!B.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!B||!B.length)return 1;const N=B[0].start,F=B[B.length-1].end-N,U=$[0].start,W=$[$.length-1].end-U;return F===W?0:W<F?1:-1}function R(B,$,N,M){const F=M.getItemLabel(B)||"",U=M.getItemLabel($)||"",O=M.getItemDescription(B),W=M.getItemDescription($),q=F.length+(O?O.length:0),Q=U.length+(W?W.length:0);if(q!==Q)return q-Q;const he=M.getItemPath(B),ve=M.getItemPath($);return he&&ve&&he.length!==ve.length?he.length-ve.length:F!==U?(0,b.compareAnything)(F,U,N.normalized):O&&W&&O!==W?(0,b.compareAnything)(O,W,N.normalized):he&&ve&&he!==ve?(0,b.compareAnything)(he,ve,N.normalized):0}const L=" ";function H(B){typeof B!="string"&&(B="");const $=B.toLowerCase(),{pathNormalized:N,normalized:M,normalizedLowercase:F}=ie(B),U=N.indexOf(T.sep)>=0;let O;const W=B.split(L);if(W.length>1)for(const q of W){const{pathNormalized:Q,normalized:he,normalizedLowercase:ve}=ie(q);he&&(O||(O=[]),O.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:he,normalizedLowercase:ve}))}return{original:B,originalLowercase:$,pathNormalized:N,normalized:M,normalizedLowercase:F,values:O,containsPathSeparator:U}}e.prepareQuery=H;function ie(B){let $;A.isWindows?$=B.replace(/\//g,T.sep):$=B.replace(/\\/g,T.sep);const N=(0,D.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:N,normalizedLowercase:N.toLowerCase()}}function j(B){return Array.isArray(B)?H(B.map($=>$.original).join(L)):H(B.original)}e.pieceToQuery=j}),define(me[33],ge([0,1,10,30,8,24,19]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",k="/",r="[/\\\\]",C="[^/\\\\]",g=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${C}*?`;default:return`(?:${r}|${C}+${r}|${r}${C}+)*?`}}function a(O,W){if(!O)return[];const q=[];let Q=!1,he=!1,ve="";for(const Pe of O){switch(Pe){case W:if(!Q&&!he){q.push(ve),ve="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":he=!0;break;case"]":he=!1;break}ve+=Pe}return ve&&q.push(ve),q}e.splitGlobAware=a;function h(O){if(!O)return"";let W="";const q=a(O,k);if(q.every(Q=>Q===y))W=".*";else{let Q=!1;q.forEach((he,ve)=>{if(he===y){Q||(W+=m(2),Q=!0);return}let Pe=!1,ke="",Le=!1,V="";for(const J of he){if(J!=="}"&&Pe){ke+=J;continue}if(Le&&(J!=="]"||!V)){let ee;J==="-"?ee=J:(J==="^"||J==="!")&&!V?ee="^":J===k?ee="":ee=b.escapeRegExpCharacters(J),V+=ee;continue}switch(J){case"{":Pe=!0;continue;case"[":Le=!0;continue;case"}":W+=`(?:${a(ke,",").map(we=>h(we)).join("|")})`,Pe=!1,ke="";break;case"]":W+="["+V+"]",Le=!1,V="";break;case"?":W+=C;continue;case"*":W+=m(1);continue;default:W+=b.escapeRegExpCharacters(J)}}ve<q.length-1&&(q[ve+1]!==y||ve+2<q.length)&&(W+=r),Q=!1})}return W}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function i(O,W){if(!O)return s;let q;typeof O!="string"?q=O.pattern:q=O,q=q.trim();const Q=`${q}_${!!W.trimForExclusions}`;let he=t.get(Q);if(he)return l(he,O);let ve;if(S.test(q)){const Pe=q.substr(4);he=function(ke,Le){return typeof ke=="string"&&ke.endsWith(Pe)?q:null}}else(ve=w.exec(o(q,W)))?he=u(ve[1],q):(W.trimForExclusions?p:_).test(q)?he=E(q,W):(ve=c.exec(o(q,W)))?he=d(ve[1].substr(1),q,!0):(ve=f.exec(o(q,W)))?he=d(ve[1],q,!1):he=v(q);return t.set(Q,he),l(he,O)}function l(O,W){return typeof W=="string"?O:function(q,Q){return I.isEqualOrParent(q,W.base)?O(T.relative(W.base,q),Q):null}}function o(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function u(O,W){const q=`/${O}`,Q=`\\${O}`,he=function(Pe,ke){return typeof Pe!="string"?null:ke?ke===O?W:null:Pe===O||Pe.endsWith(q)||Pe.endsWith(Q)?W:null},ve=[O];return he.basenames=ve,he.patterns=[W],he.allBasenames=ve,he}function E(O,W){const q=U(O.slice(1,-1).split(",").map(ke=>i(ke,W)).filter(ke=>ke!==s),O),Q=q.length;if(!Q)return s;if(Q===1)return q[0];const he=function(ke,Le){for(let V=0,J=q.length;V<J;V++)if(q[V](ke,Le))return O;return null},ve=q.find(ke=>!!ke.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Pe=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return Pe.length&&(he.allPaths=Pe),he}function d(O,W,q){const Q=T.sep===T.posix.sep,he=Q?O:O.replace(g,T.sep),ve=T.sep+he,Pe=T.posix.sep+O,ke=q?function(Le,V){return typeof Le=="string"&&(Le===he||Le.endsWith(ve)||!Q&&(Le===O||Le.endsWith(Pe)))?W:null}:function(Le,V){return typeof Le=="string"&&(Le===he||!Q&&Le===O)?W:null};return ke.allPaths=[(q?"*/":"./")+O],ke}function v(O){try{const W=new RegExp(`^${h(O)}$`);return function(q){return W.lastIndex=0,typeof q=="string"&&W.test(q)?O:null}}catch(W){return s}}function R(O,W,q){return!O||typeof W!="string"?!1:L(O)(W,void 0,q)}e.match=R;function L(O,W={}){if(!O)return n;if(typeof O=="string"||B(O)){const q=i(O,W);if(q===s)return n;const Q=function(he,ve){return!!q(he,ve)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return M(O,W)}e.parse=L;function H(O){if(!!O){let W;return q=>(W||(W=(O()||Promise.resolve([])).then(Q=>Q?j(Q):{})),W.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=H;function ie(O){if(!!O){let W;return q=>{if(!W){const Q=O();W=Q?j(Q):{}}return!!W[q]}}}e.hasSiblingFn=ie;function j(O){const W={};for(const q of O)W[q]=!0;return W}function B(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=B;function $(O){return O.allBasenames||[]}e.getBasenameTerms=$;function N(O){return O.allPaths||[]}e.getPathTerms=N;function M(O,W){const q=U(Object.getOwnPropertyNames(O).map(ke=>F(ke,O[ke],W)).filter(ke=>ke!==s)),Q=q.length;if(!Q)return s;if(!q.some(ke=>!!ke.requiresSiblings)){if(Q===1)return q[0];const ke=function(J,ee){for(let ae=0,we=q.length;ae<we;ae++){const Ce=q[ae](J,ee);if(Ce)return Ce}return null},Le=q.find(J=>!!J.allBasenames);Le&&(ke.allBasenames=Le.allBasenames);const V=q.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return V.length&&(ke.allPaths=V),ke}const he=function(ke,Le,V){let J;for(let ee=0,ae=q.length;ee<ae;ee++){const we=q[ee];we.requiresSiblings&&V&&(Le||(Le=T.basename(ke)),J||(J=Le.substr(0,Le.length-T.extname(ke).length)));const Ce=we(ke,Le,J,V);if(Ce)return Ce}return null},ve=q.find(ke=>!!ke.allBasenames);ve&&(he.allBasenames=ve.allBasenames);const Pe=q.reduce((ke,Le)=>Le.allPaths?ke.concat(Le.allPaths):ke,[]);return Pe.length&&(he.allPaths=Pe),he}function F(O,W,q){if(W===!1)return s;const Q=i(O,q);if(Q===s)return s;if(typeof W=="boolean")return Q;if(W){const he=W.when;if(typeof he=="string"){const ve=(Pe,ke,Le,V)=>{if(!V||!Q(Pe,ke))return null;const J=he.replace("$(basename)",Le),ee=V(J);return(0,D.isThenable)(ee)?ee.then(ae=>ae?O:null):ee?O:null};return ve.requiresSiblings=!0,ve}}return Q}function U(O,W){const q=O.filter(ke=>!!ke.basenames);if(q.length<2)return O;const Q=q.reduce((ke,Le)=>{const V=Le.basenames;return V?ke.concat(V):ke},[]);let he;if(W){he=[];for(let ke=0,Le=Q.length;ke<Le;ke++)he.push(W)}else he=q.reduce((ke,Le)=>{const V=Le.patterns;return V?ke.concat(V):ke},[]);const ve=function(ke,Le){if(typeof ke!="string")return null;if(!Le){let J;for(J=ke.length;J>0;J--){const ee=ke.charCodeAt(J-1);if(ee===47||ee===92)break}Le=ke.substr(J)}const V=Q.indexOf(Le);return V!==-1?he[V]:null};ve.basenames=Q,ve.patterns=he,ve.allBasenames=Q;const Pe=O.filter(ke=>!ke.basenames);return Pe.push(ve),Pe}}),define(me[76],ge([0,1,2,8,10,11,9,25,30]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,l,o){if(typeof i=="string"&&(i=b.URI.file(i)),o){const E=o.getWorkspaceFolder(i);if(E){const d=o.getWorkspace().folders.length>1;let v;if((0,P.isEqual)(E.uri,i)?v="":v=(0,P.relativePath)(E.uri,i),d){const R=E.name?E.name:(0,P.basename)(E.uri);v=v?R+" \u2022 "+v:R}return v}}if(i.scheme!==A.Schemas.file&&i.scheme!==A.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let u=(0,I.normalize)(i.fsPath);return!D.isWindows&&(l==null?void 0:l.userHome)&&(u=m(u,l.userHome.fsPath)),u}e.getPathLabel=k;function r(i){if(!!i){typeof i=="string"&&(i=b.URI.file(i));const l=(0,P.basename)(i)||(i.scheme===A.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(l)?C(l):l}}e.getBaseLabel=r;function C(i){return(0,y.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let g=Object.create(null);function m(i,l){if(D.isWindows||!i||!l)return i;let o=g.original===l?g.normalized:void 0;return o||(o=`${(0,T.rtrim)(l,I.posix.sep)}${I.posix.sep}`,g={original:l,normalized:o}),(D.isLinux?i.startsWith(o):(0,T.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=m;function a(i,l){return i.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=a;const h="\u2026",S="\\\\",w="~";function _(i,l=I.sep){const o=new Array(i.length);let u=!1;for(let E=0;E<i.length;E++){let d=i[E];if(d===""){o[E]=`.${l}`;continue}if(!d){o[E]=d;continue}u=!0;let v="";d.indexOf(S)===0?(v=d.substr(0,d.indexOf(S)+S.length),d=d.substr(d.indexOf(S)+S.length)):d.indexOf(l)===0?(v=d.substr(0,d.indexOf(l)+l.length),d=d.substr(d.indexOf(l)+l.length)):d.indexOf(w)===0&&(v=d.substr(0,d.indexOf(w)+w.length),d=d.substr(d.indexOf(w)+w.length));const R=d.split(l);for(let L=1;u&&L<=R.length;L++)for(let H=R.length-L;u&&H>=0;H--){u=!1;let ie=R.slice(H,H+L).join(l);for(let j=0;!u&&j<i.length;j++)if(j!==E&&i[j]&&i[j].indexOf(ie)>-1){const B=H+L===R.length,$=H>0&&i[j].indexOf(l)>-1?l+ie:ie,N=i[j].endsWith($);u=!B||N}if(!u){let j="";(R[0].endsWith(":")||v!=="")&&(H===1&&(H=0,L++,ie=R[0]+l+ie),H>0&&(j=R[0]+l),j=v+j),H>0&&(j=j+h+l),j=j+ie,H+L<R.length&&(j=j+l+h),o[E]=j}}u&&(o[E]=d)}return o}e.shorten=_;var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function c(i,l=Object.create(null)){const o=[];let u=!1,E="";for(const d of i)if(d==="$"||u&&d==="{")E&&o.push({value:E,type:p.TEXT}),E="",u=!0;else if(d==="}"&&u){const v=l[E];if(typeof v=="string")v.length&&o.push({value:v,type:p.VARIABLE});else if(v){const R=o[o.length-1];(!R||R.type!==p.SEPARATOR)&&o.push({value:v.label,type:p.SEPARATOR})}E="",u=!1}else E+=d;return E&&!u&&o.push({value:E,type:p.TEXT}),o.filter((d,v)=>{if(d.type===p.SEPARATOR){const R=o[v-1],L=o[v+1];return[R,L].every(H=>H&&(H.type===p.VARIABLE||H.type===p.TEXT)&&H.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=c;function f(i,l){return D.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(i,l){return D.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(i){const l=i.indexOf("/")!==-1?I.posix:I.win32,o=l.basename(i),u=l.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=s}),define(me[100],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(r){return r.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:I(b.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:I(b.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:b.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function A(r,C,g){if(!r||g>200)return null;if(typeof r=="object"){if(r instanceof b.URI)return C.transformOutgoing(r);for(let m in r)if(Object.hasOwnProperty.call(r,m)){const a=A(r[m],C,g+1);a!==null&&(r[m]=a)}}return null}function D(r,C){const g=A(r,C,0);return g===null?r:g}e.transformOutgoingURIs=D;function P(r,C,g,m){if(!r||m>200)return null;if(typeof r=="object"){if(r.$mid===1)return g?b.URI.revive(C.transformIncoming(r)):C.transformIncoming(r);for(let a in r)if(Object.hasOwnProperty.call(r,a)){const h=P(r[a],C,g,m+1);h!==null&&(r[a]=h)}}return null}function y(r,C){const g=P(r,C,!1,0);return g===null?r:g}e.transformIncomingURIs=y;function k(r,C){const g=P(r,C,!0,0);return g===null?r:g}e.transformAndReviveIncomingURIs=k}),define(me[28],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(y){return b.test(y)}e.isUUID=I;const T=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let k=0;k<y.length;k++)y[k]=Math.floor(Math.random()*256);return y};function P(){D(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let y=0,k="";return k+=A[T[y++]],k+=A[T[y++]],k+=A[T[y++]],k+=A[T[y++]],k+="-",k+=A[T[y++]],k+=A[T[y++]],k+="-",k+=A[T[y++]],k+=A[T[y++]],k+="-",k+=A[T[y++]],k+=A[T[y++]],k+="-",k+=A[T[y++]],k+=A[T[y++]],k+=A[T[y++]],k+=A[T[y++]],k+=A[T[y++]],k+=A[T[y++]],k}e.generateUuid=P}),define(me[137],ge([0,1,101]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(A="utf8"){this.stringDecoder=new b.StringDecoder(A),this.remaining=null}write(A){const D=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return D;let y=0,k,r=y;for(;r<P.length;)if(k=P.charCodeAt(r),k===13||k===10){if(D.push(P.substring(y,r)),r++,r<P.length){const C=k;k=P.charCodeAt(r),(C===13&&k===10||C===10&&k===13)&&r++}y=r}else r++;return this.remaining=y<P.length?P.substr(y):null,D}end(){return this.remaining}}e.LineDecoder=I}),define(me[26],ge([0,1,37,48,8,19,9,30,28,75,25,2]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function m($,N=g.UNLINK){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return N===g.UNLINK?h($):a($)}e.rimraf=m;async function a($){try{const N=(0,T.join)((0,I.tmpdir)(),(0,y.generateUuid)());try{await b.promises.rename($,N)}catch(M){return h($)}h(N).catch(M=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function h($){return b.promises.rmdir($,{recursive:!0,maxRetries:3})}function S($){if((0,P.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync($,{recursive:!0})}e.rimrafSync=S;async function w($,N){return c(await(N?_($):b.promises.readdir($)))}e.readdir=w;async function _($){try{return await b.promises.readdir($,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const N=[],M=await w($);for(const F of M){let U=!1,O=!1,W=!1;try{const q=await b.promises.lstat((0,T.join)($,F));U=q.isFile(),O=q.isDirectory(),W=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}N.push({name:F,isFile:()=>U,isDirectory:()=>O,isSymbolicLink:()=>W})}return N}function p($){return c(b.readdirSync($))}e.readdirSync=p;function c($){return $.map(N=>typeof N=="string"?D.isMacintosh?(0,k.normalizeNFC)(N):N:(N.name=D.isMacintosh?(0,k.normalizeNFC)(N.name):N.name,N))}async function f($){const N=await w($),M=[];for(const F of N)await n.existsDirectory((0,T.join)($,F))&&M.push(F);return M}e.readDirsInDir=f;function t($,N=1e3){return new Promise(M=>{let F=!1;const U=setInterval(()=>{F||(F=!0,b.access($,O=>{F=!1,O&&(clearInterval(U),M(void 0))}))},N)})}e.whenDeleted=t;var n;(function($){async function N(U){let O;try{if(O=await b.promises.lstat(U),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await b.promises.stat(U),symbolicLink:(O==null?void 0:O.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&W.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw q}throw W}}$.stat=N;async function M(U){try{const{stat:O,symbolicLink:W}=await $.stat(U);return O.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(O){}return!1}$.existsFile=M;async function F(U){try{const{stat:O,symbolicLink:W}=await $.stat(U);return O.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(O){}return!1}$.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function i($,N,M){return s.queueFor(C.URI.file($),r.extUriBiasedIgnorePathCase).queue(()=>{const F=E(M);return new Promise((U,O)=>o($,N,F,W=>W?O(W):U()))})}e.writeFile=i;let l=!0;function o($,N,M,F){if(!l)return b.writeFile($,N,{mode:M.mode,flag:M.flag},F);b.open($,M.flag,M.mode,(U,O)=>{if(U)return F(U);b.writeFile(O,N,W=>{if(W)return b.close(O,()=>F(W));b.fdatasync(O,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l=!1),b.close(O,Q=>F(Q))))})})}function u($,N,M){const F=E(M);if(!l)return b.writeFileSync($,N,{mode:F.mode,flag:F.flag});const U=b.openSync($,F.flag,F.mode);try{b.writeFileSync(U,N);try{b.fdatasyncSync(U)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),l=!1}}finally{b.closeSync(U)}}e.writeFileSync=u;function E($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function d($,N){if($!==N){async function M(F){try{const U=await b.promises.lstat(F);if(U.isDirectory()||U.isSymbolicLink())return;const O=await b.promises.open(F,"a");try{await O.utimes(U.atime,new Date)}finally{await O.close()}}catch(U){}}try{await b.promises.rename($,N),await M(N)}catch(F){if($.toLowerCase()!==N.toLowerCase()&&F.code==="EXDEV"||$.endsWith("."))await v($,N,{preserveSymlinks:!1}),await m($,g.MOVE),await M(N);else throw F}}}e.move=d;async function v($,N,M){return L($,N,{root:{source:$,target:N},options:M,handledSourcePaths:new Set})}e.copy=v;const R=511;async function L($,N,M){if(!M.handledSourcePaths.has($)){M.handledSourcePaths.add($);const{stat:F,symbolicLink:U}=await n.stat($);if(U){if(M.options.preserveSymlinks)try{return await j($,N,M)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(U.dangling)return}return F.isDirectory()?H($,N,F.mode&R,M):ie($,N,F.mode&R)}}async function H($,N,M,F){await b.promises.mkdir(N,{recursive:!0,mode:M});const U=await w($);for(const O of U)await L((0,T.join)($,O),(0,T.join)(N,O),F)}async function ie($,N,M){await b.promises.copyFile($,N),await b.promises.chmod(N,M)}async function j($,N,M){let F=await b.promises.readlink($);(0,P.isEqualOrParent)(F,M.root.source,!D.isLinux)&&(F=(0,T.join)(M.root.target,F.substr(M.root.source.length+1))),await b.promises.symlink(F,N)}async function B($){try{return await b.promises.access($),!0}catch(N){return!1}}e.exists=B}),define(me[102],ge([0,1,37,285,10,8,26]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(C){const g=(0,A.dirname)(C);if(C===g)return C;const m=((0,A.basename)(C)||C).toLowerCase();try{const h=(0,D.readdirSync)(g).filter(S=>S.toLowerCase()===m);if(h.length===1){const S=P(g);if(S)return(0,A.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(m);if(S>=0){const w=P(g);if(w)return(0,A.join)(w,h[S])}}}catch(a){}return null}e.realcaseSync=P;async function y(C){try{return await(0,I.promisify)(b.realpath)(C)}catch(g){const m=r(C);return await b.promises.access(m,b.constants.R_OK),m}}e.realpath=y;function k(C){try{return b.realpathSync(C)}catch(g){const m=r(C);return b.accessSync(m,b.constants.R_OK),m}}e.realpathSync=k;function r(C){return(0,T.rtrim)((0,A.normalize)(C),A.sep)}});var wt=this&&this.__await||function(G){return this instanceof wt?(this.v=G,this):new wt(G)},Rn=this&&this.__asyncGenerator||function(G,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=b.apply(G,e||[]),T,A=[];return T={},D("next"),D("throw"),D("return"),T[Symbol.asyncIterator]=function(){return this},T;function D(g){I[g]&&(T[g]=function(m){return new Promise(function(a,h){A.push([g,m,a,h])>1||P(g,m)})})}function P(g,m){try{y(I[g](m))}catch(a){C(A[0][3],a)}}function y(g){g.value instanceof wt?Promise.resolve(g.value.v).then(k,r):C(A[0][2],g)}function k(g){P("next",g)}function r(g){P("throw",g)}function C(g,m){g(m),A.shift(),A.length&&P(A[0][0],A[0][1])}},hn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(D){return new Promise(function(P,y){D=G[A](D),T(P,y,D.done,D.value)})}}function T(A,D,P,y){Promise.resolve(y).then(function(k){A({value:k,done:P})},D)}};define(me[103],ge([0,1,26,48,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(y||(y={}));let k;switch(process.arch){case"ia32":case"x32":k=1;break;case"arm":case"arm64":k=2;break;default:k=0;break}let r;process.env.PROCESSOR_ARCHITEW6432?r=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?r=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?r=1:r=0;class C{constructor(f,t,n){this.exePath=f,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?k===0?process.env["ProgramFiles(x86)"]||null:r===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:c=!1,findPreview:f=!1}={}){const t=g({useAlternateBitness:c});if(!t)return null;const n=T.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let s=-1,i=null;for(const u of await b.readdir(n)){let E=-1;if(f){const v=u.indexOf("-");if(v<0)continue;const R=u.substring(0,v);if(!A.test(R)||u.substring(v+1)!=="preview")continue;E=parseInt(R,10)}else{if(!A.test(u))continue;E=parseInt(u,10)}if(!(E<=s)){const d=T.join(n,u,"pwsh.exe");!await b.SymlinkSupport.existsFile(d)||(i=d,s=E)}}if(!i)return null;const l=t.includes("x86")?" (x86)":"",o=f?" Preview":"";return new C(i,`PowerShell${o}${l}`,!0)}async function a({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const f=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const s of await b.readdir(f))if(t.test(s)){const i=T.join(f,s,"pwsh.exe");return new C(i,n)}return null}function h(){const c=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function S(){const c=T.join(process.env.windir,k===1&&r!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}function w(){return Rn(this,arguments,function*(){let f=yield wt(m());f&&(yield yield wt(f)),f=yield wt(m({useAlternateBitness:!0})),f&&(yield yield wt(f)),f=yield wt(a()),f&&(yield yield wt(f)),f=h(),f&&(yield yield wt(f)),f=yield wt(m({findPreview:!0})),f&&(yield yield wt(f)),f=yield wt(a({findPreview:!0})),f&&(yield yield wt(f)),f=yield wt(m({useAlternateBitness:!0,findPreview:!0})),f&&(yield yield wt(f)),f=S(),f&&(yield yield wt(f))})}function _(){return Rn(this,arguments,function*(){var f,t;try{for(var n=hn(w()),s;s=yield wt(n.next()),!s.done;){const i=s.value;(yield wt(i.exists()))&&(yield yield wt(i))}}catch(i){f={error:i}}finally{try{s&&!s.done&&(t=n.return)&&(yield wt(t.call(n)))}finally{if(f)throw f.error}}})}e.enumeratePowerShellInstallations=_;async function p(){var c,f;try{for(var t=hn(_()),n;n=await t.next(),!n.done;)return n.value}catch(s){c={error:s}}finally{try{n&&!n.done&&(f=t.return)&&await f.call(t)}finally{if(c)throw c.error}}return null}e.getFirstAvailablePowerShellInstallation=p}),define(me[104],ge([0,1,3,6,19,21,18,22,15,12,58,10]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function m(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function h(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(S||(S={}));class w{constructor(U){this.buffer=U,this.pos=0}read(U){const O=this.buffer.slice(this.pos,this.pos+U);return this.pos+=O.byteLength,O}}class _{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var p;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(p||(p={}));function c(F){const U=P.VSBuffer.alloc(4);return U.writeUInt32BE(F,0),U}function f(F){return F.read(4).readUInt32BE(0)}function t(F){const U=P.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const n={Undefined:t(p.Undefined),String:t(p.String),Buffer:t(p.Buffer),VSBuffer:t(p.VSBuffer),Array:t(p.Array),Object:t(p.Object)},s=typeof Buffer!="undefined";function i(F,U){if(typeof U=="undefined")F.write(n.Undefined);else if(typeof U=="string"){const O=P.VSBuffer.fromString(U);F.write(n.String),F.write(c(O.byteLength)),F.write(O)}else if(s&&Buffer.isBuffer(U)){const O=P.VSBuffer.wrap(U);F.write(n.Buffer),F.write(c(O.byteLength)),F.write(O)}else if(U instanceof P.VSBuffer)F.write(n.VSBuffer),F.write(c(U.byteLength)),F.write(U);else if(Array.isArray(U)){F.write(n.Array),F.write(c(U.length));for(const O of U)i(F,O)}else{const O=P.VSBuffer.fromString(JSON.stringify(U));F.write(n.Object),F.write(c(O.byteLength)),F.write(O)}}function l(F){switch(F.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return F.read(f(F)).toString();case p.Buffer:return F.read(f(F)).buffer;case p.VSBuffer:return F.read(f(F));case p.Array:{const O=f(F),W=[];for(let q=0;q<O;q++)W.push(l(F));return W}case p.Object:return JSON.parse(F.read(f(F)).toString())}}class o{constructor(U,O,W=null,q=1e3){this.protocol=U,this.ctx=O,this.logger=W,this.timeoutDelay=q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(U,O){this.channels.set(U,O),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const O=this.send([U.type]);this.logger&&this.logger.logOutgoing(O,0,1,h(U.type));return}case 201:case 202:case 204:case 203:{const O=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(O,U.id,1,h(U.type),U.data);return}}}send(U,O=void 0){const W=new _;return i(W,U),i(W,O),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(O){return 0}}onRawMessage(U){const O=new w(U),W=l(O),q=l(O),Q=W[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${m(Q)}: ${W[2]}.${W[3]}`,q),this.onPromise({type:Q,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${m(Q)}: ${W[2]}.${W[3]}`,q),this.onEventListen({type:Q,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:W[1]})}}onPromise(U){const O=this.channels.get(U.channelName);if(!O){this.collectPendingRequest(U);return}const W=new A.CancellationTokenSource;let q;try{q=O.call(this.ctx,U.name,U.arg,W.token)}catch(ve){q=Promise.reject(ve)}const Q=U.id;q.then(ve=>{this.sendResponse({id:Q,data:ve,type:201}),this.activeRequests.delete(U.id)},ve=>{ve instanceof Error?this.sendResponse({id:Q,data:{message:ve.message,name:ve.name,stack:ve.stack?ve.stack.split?ve.stack.split(`
`):ve.stack:void 0},type:202}):this.sendResponse({id:Q,data:ve,type:203}),this.activeRequests.delete(U.id)});const he=(0,I.toDisposable)(()=>W.cancel());this.activeRequests.set(U.id,he)}onEventListen(U){const O=this.channels.get(U.channelName);if(!O){this.collectPendingRequest(U);return}const W=U.id,Q=O.listen(this.ctx,U.name,U.arg)(he=>this.sendResponse({id:W,data:he,type:204}));this.activeRequests.set(U.id,Q)}disposeActiveRequest(U){const O=this.activeRequests.get(U.id);O&&(O.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let O=this.pendingRequests.get(U.channelName);O||(O=[],this.pendingRequests.set(U.channelName,O));const W=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:U,timeoutTimer:W})}flushPendingRequests(U){const O=this.pendingRequests.get(U);if(O){for(const W of O)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=o;var u;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(U,O=null){this.protocol=U,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=O}getChannel(U){const O=this;return{call(W,q,Q){return O.isDisposed?Promise.reject(D.canceled()):O.requestPromise(U,W,q,Q)},listen(W,q){return O.isDisposed?Promise.reject(D.canceled()):O.requestEvent(U,W,q)}}}requestPromise(U,O,W,q=A.CancellationToken.None){const Q=this.lastRequestId++,ve={id:Q,type:100,channelName:U,name:O,arg:W};if(q.isCancellationRequested)return Promise.reject(D.canceled());let Pe;return new Promise((Le,V)=>{if(q.isCancellationRequested)return V(D.canceled());const J=()=>{const Ce=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,V(be);break;case 203:this.handlers.delete(Q),V(Oe.data);break}};this.handlers.set(Q,Ce),this.sendRequest(ve)};let ee=null;this.state===S.Idle?J():(ee=(0,T.createCancelablePromise)(Ce=>this.whenInitialized()),ee.then(()=>{ee=null,J()}));const ae=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),V(D.canceled())},we=q.onCancellationRequested(ae);Pe=(0,I.combinedDisposable)((0,I.toDisposable)(ae),we),this.activeRequests.add(Pe)}).finally(()=>{this.activeRequests.delete(Pe)})}requestEvent(U,O,W){const q=this.lastRequestId++,he={id:q,type:102,channelName:U,name:O,arg:W};let ve=null;const Pe=new b.Emitter({onFirstListenerAdd:()=>{ve=(0,T.createCancelablePromise)(Le=>this.whenInitialized()),ve.then(()=>{ve=null,this.activeRequests.add(Pe),this.sendRequest(he)})},onLastListenerRemove:()=>{ve?(ve.cancel(),ve=null):(this.activeRequests.delete(Pe),this.sendRequest({id:q,type:103}))}}),ke=Le=>Pe.fire(Le.data);return this.handlers.set(q,ke),Pe.event}sendRequest(U){switch(U.type){case 100:case 102:{const O=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(O,U.id,0,`${m(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const O=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(O,U.id,0,m(U.type));return}}}send(U,O=void 0){const W=new _;return i(W,U),i(W,O),this.sendBuffer(W.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(O){return 0}}onBuffer(U){const O=new w(U),W=l(O),q=l(O),Q=W[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,h(Q)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,W[1],0,h(Q),q),this.onResponse({type:W[0],id:W[1],data:q})}}onResponse(U){if(U.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(U.id);O&&O(U)}whenInitialized(){return this.state===S.Idle?Promise.resolve():b.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelClient=E;class d{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:O,onDidClientDisconnect:W})=>{b.Event.once(O.onMessage)(Q=>{const he=new w(Q),ve=l(he),Pe=new o(O,ve),ke=new E(O);this.channels.forEach((V,J)=>Pe.registerChannel(J,V));const Le={channelServer:Pe,channelClient:ke,ctx:ve};this._connections.add(Le),this._onDidAddConnection.fire(Le),W(()=>{Pe.dispose(),ke.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const U=[];return this._connections.forEach(O=>U.push(O)),U}getChannel(U,O){const W=this;return{call(q,Q,he){let ve;if((0,k.isFunction)(O)){let ke=(0,y.getRandomElement)(W.connections.filter(O));ve=ke?Promise.resolve(ke):b.Event.toPromise(b.Event.filter(W.onDidAddConnection,O))}else ve=O.routeCall(W,q,Q);const Pe=ve.then(ke=>ke.channelClient.getChannel(U));return R(Pe).call(q,Q,he)},listen(q,Q){if((0,k.isFunction)(O))return W.getMulticastEvent(U,O,q,Q);const he=O.routeEvent(W,q,Q).then(ve=>ve.channelClient.getChannel(U));return R(he).listen(q,Q)}}}getMulticastEvent(U,O,W,q){const Q=this;let he=new I.DisposableStore;const ve=new b.Emitter({onFirstListenerAdd:()=>{he=new I.DisposableStore;const Pe=new b.EventMultiplexer,ke=new Map,Le=J=>{const ae=J.channelClient.getChannel(U).listen(W,q),we=Pe.add(ae);ke.set(J,we)},V=J=>{const ee=ke.get(J);!ee||(ee.dispose(),ke.delete(J))};Q.connections.filter(O).forEach(Le),b.Event.filter(Q.onDidAddConnection,O)(Le,void 0,he),Q.onDidRemoveConnection(V,void 0,he),Pe.event(ve.fire,ve,he),he.add(Pe)},onLastListenerRemove:()=>{he.dispose()}});return ve.event}registerChannel(U,O){this.channels.set(U,O),this._connections.forEach(W=>{W.channelServer.registerChannel(U,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class v{constructor(U,O,W=null){const q=new _;i(q,O),U.send(q.buffer),this.channelClient=new E(U,W),this.channelServer=new o(U,O,W)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,O){this.channelServer.registerChannel(U,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=v;function R(F){return{call(U,O,W){return F.then(q=>q.call(U,O,W))},listen(U,O){const W=new b.Relay;return F.then(q=>W.input=q.listen(U,O)),W.event}}}e.getDelayedChannel=R;function L(F){let U=!1;return{call(O,W,q){return U?F.call(O,W,q):(0,T.timeout)(0).then(()=>U=!0).then(()=>F.call(O,W,q))},listen(O,W){if(U)return F.listen(O,W);const q=new b.Relay;return(0,T.timeout)(0).then(()=>U=!0).then(()=>q.input=F.listen(O,W)),q.event}}}e.getNextTickChannel=L;class H{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const O of U.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await b.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=H;var ie;(function(F){function U(q,Q){const he=q,ve=Q&&Q.disableMarshalling,Pe=new Map;for(const ke in he)W(ke)&&Pe.set(ke,b.Event.buffer(he[ke],!0));return new class{listen(ke,Le){const V=Pe.get(Le);if(V)return V;throw new Error(`Event not found: ${Le}`)}call(ke,Le,V){const J=he[Le];if(typeof J=="function"){if(!ve&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,r.revive)(V[ee]);return J.apply(he,V)}throw new Error(`Method not found: ${Le}`)}}}F.fromService=U;function O(q,Q){const he=Q&&Q.disableMarshalling;return new Proxy({},{get(ve,Pe){var ke;if(typeof Pe=="string")return((ke=Q==null?void 0:Q.properties)===null||ke===void 0?void 0:ke.has(Pe))?Q.properties.get(Pe):W(Pe)?q.listen(Pe):async function(...Le){let V;Q&&!(0,k.isUndefinedOrNull)(Q.context)?V=[Q.context,...Le]:V=Le;const J=await q.call(Pe,V);return he?J:(0,r.revive)(J)};throw new Error(`Property not found: ${String(Pe)}`)}})}F.toService=O;function W(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let U=F.toString();if(U!=="[object Object]")return U}return F}function $(F){return Array.isArray(F)?F.map(B):B(F)}function N(F,U,O,W,q,Q,he){he=$(he);const ve=j[q],Pe=ve[W%ve.length];let ke=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Pe}`];/\($/.test(Q)?(ke=ke.concat(he),ke.push(")")):ke.push(he),console.log.apply(console,ke)}e.logWithColors=N;class M{constructor(U,O){this._outgoingPrefix=U,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,O,W,q,Q){this._totalOutgoing+=U,N(this._outgoingPrefix,this._totalOutgoing,U,O,W,q,Q)}logIncoming(U,O,W,q,Q){this._totalIncoming+=U,N(this._incomingPrefix,this._totalIncoming,U,O,W,q,Q)}}e.IPCLogger=M}),define(me[105],ge([0,1,3,104,6,22,9,36]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function k(){return y||(y=A.VSBuffer.alloc(0)),y}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,i){if(s===0)return k();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const E=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=s),E}if(this._chunks[0].byteLength>s){const E=this._chunks[0].slice(0,s);return i&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),E}let l=A.VSBuffer.alloc(s),o=0,u=0;for(;s>0;){const E=this._chunks[u];if(E.byteLength>s){const d=E.slice(0,s);l.set(d,o),o+=s,i&&(this._chunks[u]=E.slice(s),this._totalLength-=s),s-=s}else l.set(E,o),o+=E.byteLength,i?(this._chunks.shift(),this._totalLength-=E.byteLength):u++,s-=E.byteLength}return l}}e.ChunkStream=r;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(s,i,l,o){this.type=s,this.id=i,this.ack=l,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends T.Disposable{constructor(s){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const l=this._state.messageType,o=this._state.id,u=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(l,o,u,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=A.VSBuffer.alloc(13);i.writeUInt8(s.type,0),i.writeUInt32BE(s.id,1),i.writeUInt32BE(s.ack,5),i.writeUInt32BE(s.data.byteLength,9),this._writeSoon(i,s.data)}}_bufferAdd(s,i){const l=this._totalLength===0;return this._data.push(s,i),this._totalLength+=s.byteLength+i.byteLength,l}_bufferTake(){const s=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,i){this._bufferAdd(s,i)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends T.Disposable{constructor(s){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new m(1,0,0,s))}}e.Protocol=S;class w extends I.IPCClient{constructor(s,i,l=null){super(s,i,l);this.protocol=s}static fromSocket(s,i){return new w(new S(s),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class p{constructor(s){this.data=s,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],i=0,l=this._first;for(;l;)s[i++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const i=new p(s);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class f{constructor(){this.lastRuns=[];const s=Date.now();for(let i=0;i<f._HISTORY_LENGTH;i++)this.lastRuns[i]=s-1e3*i;setInterval(()=>{for(let i=f._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const s=Date.now(),i=(1+f._HISTORY_LENGTH)*1e3;let l=0;for(let o=0;o<f._HISTORY_LENGTH;o++)s-this.lastRuns[o]<=i&&l++;return 1-l/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class t{constructor(s,i=null){this._loadEstimator=f.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new m(5,0,0,k());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const i=new m(4,0,0,k());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,i){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let i=0,l=s.length;i<l;i++)this._socketWriter.write(s[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new m(6,0,0,k())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const i=this._outgoingUnackMsg.toArray();for(let l=0,o=i.length;l<o;l++)this._socketWriter.write(i[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new m(1,i,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const i=new m(2,0,0,s);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),i=Date.now()-s.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,k());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[106],ge([0,1,95]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(P){let y=(0,b.toUint8)(P);this._defaultValue=y,this._asciiMap=I._createAsciiMap(y),this._map=new Map}static _createAsciiMap(P){let y=new Uint8Array(256);for(let k=0;k<256;k++)y[k]=P;return y}set(P,y){let k=(0,b.toUint8)(y);P>=0&&P<256?this._asciiMap[P]=k:this._map.set(P,k)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(T||(T={}));class A{constructor(){this._actual=new I(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=A}),define(me[138],ge([0,1,106]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends b.CharacterClassifier{constructor(P){super(0);for(let y=0,k=P.length;y<k;y++)this.set(P.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function A(D){let P={};return y=>(P.hasOwnProperty(y)||(P[y]=D(y)),P[y])}e.getMapForWordSeparators=A(D=>new T(D))}),define(me[49],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(T,A){this.lineNumber=T,this.column=A}with(T=this.lineNumber,A=this.column){return T===this.lineNumber&&A===this.column?this:new b(T,A)}delta(T=0,A=0){return this.with(this.lineNumber+T,this.column+A)}equals(T){return b.equals(this,T)}static equals(T,A){return!T&&!A?!0:!!T&&!!A&&T.lineNumber===A.lineNumber&&T.column===A.column}isBefore(T){return b.isBefore(this,T)}static isBefore(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<A.column}isBeforeOrEqual(T){return b.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<=A.column}static compare(T,A){let D=T.lineNumber|0,P=A.lineNumber|0;if(D===P){let y=T.column|0,k=A.column|0;return y-k}return D-P}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new b(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=b}),define(me[44],ge([0,1,49]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,D,P,y){A>P||A===P&&D>y?(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=P,this.endColumn=y)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,D){let P,y,k,r;return D.startLineNumber<A.startLineNumber?(P=D.startLineNumber,y=D.startColumn):D.startLineNumber===A.startLineNumber?(P=D.startLineNumber,y=Math.min(D.startColumn,A.startColumn)):(P=A.startLineNumber,y=A.startColumn),D.endLineNumber>A.endLineNumber?(k=D.endLineNumber,r=D.endColumn):D.endLineNumber===A.endLineNumber?(k=D.endLineNumber,r=Math.max(D.endColumn,A.endColumn)):(k=A.endLineNumber,r=A.endColumn),new I(P,y,k,r)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,D){let P=A.startLineNumber,y=A.startColumn,k=A.endLineNumber,r=A.endColumn,C=D.startLineNumber,g=D.startColumn,m=D.endLineNumber,a=D.endColumn;return P<C?(P=C,y=g):P===C&&(y=Math.max(y,g)),k>m?(k=m,r=a):k===m&&(r=Math.min(r,a)),P>k||P===k&&y>r?null:new I(P,y,k,r)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,D){return!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new b.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new b.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new I(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new I(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new I(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const k=A.startLineNumber|0,r=D.startLineNumber|0;if(k===r){const C=A.startColumn|0,g=D.startColumn|0;if(C===g){const m=A.endLineNumber|0,a=D.endLineNumber|0;if(m===a){const h=A.endColumn|0,S=D.endColumn|0;return h-S}return m-a}return C-g}return k-r}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(me[139],ge([0,1,49,44]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(P,y,k,r){super(P,y,k,r);this.selectionStartLineNumber=P,this.selectionStartColumn=y,this.positionLineNumber=k,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return A.selectionsEqual(this,P)}static selectionsEqual(P,y){return P.selectionStartLineNumber===y.selectionStartLineNumber&&P.selectionStartColumn===y.selectionStartColumn&&P.positionLineNumber===y.positionLineNumber&&P.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,P,y):new A(P,y,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,y){return this.getDirection()===0?new A(P,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,P,y)}static fromPositions(P,y=P){return new A(P.lineNumber,P.column,y.lineNumber,y.column)}static liftSelection(P){return new A(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,y){if(P&&!y||!P&&y)return!1;if(!P&&!y)return!0;if(P.length!==y.length)return!1;for(let k=0,r=P.length;k<r;k++)if(!this.selectionsEqual(P[k],y[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,y,k,r,C){return C===0?new A(P,y,k,r):new A(k,r,P,y)}}e.Selection=A}),define(me[107],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class y{constructor(a,h){this.range=a,this.matches=h}}e.FindMatch=y;var k;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,h,S,w,_,p){this.identifier=a,this.range=h,this.text=S,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=_,this._isTracked=p}}e.ValidAnnotatedEditOperation=C;class g{constructor(a,h,S){this.reverseEdits=a,this.changes=h,this.trimAutoWhitespaceLineNumbers=S}}e.ApplyEditsResult=g}),define(me[140],ge([0,1,10,138,49,44,107]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class y{constructor(p,c,f,t){this.searchString=p,this.isRegex=c,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=k(this.searchString):p=this.searchString.indexOf(`
`)>=0;let c=null;try{c=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let f=!this.isRegex&&!p;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new r(c,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=y;function k(_){if(!_||_.length===0)return!1;for(let p=0,c=_.length;p<c;p++)if(_.charCodeAt(p)===92){if(p++,p>=c)break;const t=_.charCodeAt(p);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class r{constructor(p,c,f){this.regex=p,this.wordSeparators=c,this.simpleSearch=f}}e.SearchData=r;function C(_,p,c){if(!c)return new D.FindMatch(_,null);let f=[];for(let t=0,n=p.length;t<n;t++)f[t]=p[t];return new D.FindMatch(_,f)}e.createFindMatch=C;class g{constructor(p){let c=[],f=0;for(let t=0,n=p.length;t<n;t++)p.charCodeAt(t)===10&&(c[f++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(p){const c=this._lineFeedsOffsets;let f=0,t=c.length-1;if(t===-1||p<=c[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);c[n]>=p?t=n-1:c[n+1]>=p?(f=n,t=n):f=n+1}return f+1}}class m{static findMatches(p,c,f,t,n){const s=c.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(p,f,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(p,f,s,t,n):[]}static _getMultilineMatchRange(p,c,f,t,n,s){let i,l=0;t?(l=t.findLineFeedCountBeforeOffset(n),i=c+n+l):i=c+n;let o;if(t){let v=t.findLineFeedCountBeforeOffset(n+s.length)-l;o=i+s.length+v}else o=i+s.length;const u=p.getPositionAt(i),E=p.getPositionAt(o);return new A.Range(u.lineNumber,u.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(p,c,f,t,n){const s=p.getOffsetAt(c.getStartPosition()),i=p.getValueInRange(c,1),l=p.getEOL()===`\r
`?new g(i):null,o=[];let u=0,E;for(f.reset(0);E=f.next(i);)if(o[u++]=C(this._getMultilineMatchRange(p,s,i,l,E.index,E[0]),E,t),u>=n)return o;return o}static _doFindMatchesLineByLine(p,c,f,t,n){const s=[];let i=0;if(c.startLineNumber===c.endLineNumber){const o=p.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return i=this._findMatchesInLine(f,o,c.startLineNumber,c.startColumn-1,i,s,t,n),s}const l=p.getLineContent(c.startLineNumber).substring(c.startColumn-1);i=this._findMatchesInLine(f,l,c.startLineNumber,c.startColumn-1,i,s,t,n);for(let o=c.startLineNumber+1;o<c.endLineNumber&&i<n;o++)i=this._findMatchesInLine(f,p.getLineContent(o),o,0,i,s,t,n);if(i<n){const o=p.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);i=this._findMatchesInLine(f,o,c.endLineNumber,0,i,s,t,n)}return s}static _findMatchesInLine(p,c,f,t,n,s,i,l){const o=p.wordSeparators;if(!i&&p.simpleSearch){const d=p.simpleSearch,v=d.length,R=c.length;let L=-v;for(;(L=c.indexOf(d,L+v))!==-1;)if((!o||S(o,c,R,L,v))&&(s[n++]=new D.FindMatch(new A.Range(f,L+1+t,f,L+1+v+t),null),n>=l))return n;return n}const u=new w(p.wordSeparators,p.regex);let E;u.reset(0);do if(E=u.next(c),E&&(s[n++]=C(new A.Range(f,E.index+1+t,f,E.index+1+E[0].length+t),E,i),n>=l))return n;while(E);return n}static findNextMatch(p,c,f,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(p,f,s,t):this._doFindNextMatchLineByLine(p,f,s,t)}static _doFindNextMatchMultiline(p,c,f,t){const n=new T.Position(c.lineNumber,1),s=p.getOffsetAt(n),i=p.getLineCount(),l=p.getValueInRange(new A.Range(n.lineNumber,n.column,i,p.getLineMaxColumn(i)),1),o=p.getEOL()===`\r
`?new g(l):null;f.reset(c.column-1);let u=f.next(l);return u?C(this._getMultilineMatchRange(p,s,l,o,u.index,u[0]),u,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(p,new T.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(p,c,f,t){const n=p.getLineCount(),s=c.lineNumber,i=p.getLineContent(s),l=this._findFirstMatchInLine(f,i,s,c.column,t);if(l)return l;for(let o=1;o<=n;o++){const u=(s+o-1)%n,E=p.getLineContent(u+1),d=this._findFirstMatchInLine(f,E,u+1,1,t);if(d)return d}return null}static _findFirstMatchInLine(p,c,f,t,n){p.reset(t-1);const s=p.next(c);return s?C(new A.Range(f,s.index+1,f,s.index+1+s[0].length),s,n):null}static findPreviousMatch(p,c,f,t){const n=c.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(p,f,s,t):this._doFindPreviousMatchLineByLine(p,f,s,t)}static _doFindPreviousMatchMultiline(p,c,f,t){const n=this._doFindMatchesMultiline(p,new A.Range(1,1,c.lineNumber,c.column),f,t,10*P);if(n.length>0)return n[n.length-1];const s=p.getLineCount();return c.lineNumber!==s||c.column!==p.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(p,new T.Position(s,p.getLineMaxColumn(s)),f,t):null}static _doFindPreviousMatchLineByLine(p,c,f,t){const n=p.getLineCount(),s=c.lineNumber,i=p.getLineContent(s).substring(0,c.column-1),l=this._findLastMatchInLine(f,i,s,t);if(l)return l;for(let o=1;o<=n;o++){const u=(n+s-o-1)%n,E=p.getLineContent(u+1),d=this._findLastMatchInLine(f,E,u+1,t);if(d)return d}return null}static _findLastMatchInLine(p,c,f,t){let n=null,s;for(p.reset(0);s=p.next(c);)n=C(new A.Range(f,s.index+1,f,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=m;function a(_,p,c,f,t){if(f===0)return!0;const n=p.charCodeAt(f-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=p.charCodeAt(f);if(_.get(s)!==0)return!0}return!1}function h(_,p,c,f,t){if(f+t===c)return!0;const n=p.charCodeAt(f+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=p.charCodeAt(f+t-1);if(_.get(s)!==0)return!0}return!1}function S(_,p,c,f,t){return a(_,p,c,f,t)&&h(_,p,c,f,t)}e.isValidMatch=S;class w{constructor(p,c){this._wordSeparators=p,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const c=p.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(f=this._searchRegex.exec(p),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(p,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||S(this._wordSeparators,p,c,t,n))return f}while(f);return null}}e.Searcher=w}),define(me[108],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(P=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(y+="\\"+k);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=b();function I(P){let y=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)y=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),y=new RegExp(P.source,k)}return y.lastIndex=0,y}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function A(P,y,k,r,C=T){if(k.length>C.maxLen){let S=P-C.maxLen/2;return S<0?S=0:r+=S,k=k.substring(S,P+C.maxLen/2),A(P,y,k,r,C)}const g=Date.now(),m=P-1-r;let a=-1,h=null;for(let S=1;!(Date.now()-g>=C.timeBudget);S++){const w=m-C.windowSize*S;y.lastIndex=Math.max(0,w);const _=D(y,k,m,a);if(!_&&h||(h=_,w<=0))break;a=w}if(h){let S={word:h[0],startColumn:r+1+h.index,endColumn:r+1+h.index+h[0].length};return y.lastIndex=0,S}return null}e.getWordAtText=A;function D(P,y,k,r){let C;for(;C=P.exec(y);){const g=C.index||0;if(g<=k&&P.lastIndex>=k)return C;if(r>0&&g>r)return null}return null}}),define(me[141],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class I{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let y=0,k=P.notIn.length;y<k;y++)switch(P.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of P)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function A(D,P,y){D.has(P)?D.get(P).push(y):D.set(P,[y])}}),define(me[77],ge([0,1,33,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(A,D,P,y){if(Array.isArray(A)){let k=0;for(const r of A){const C=T(r,D,P,y);if(C===10)return C;C>k&&(k=C)}return k}else{if(typeof A=="string")return y?A==="*"?5:A===P?10:0:0;if(A){const{language:k,pattern:r,scheme:C,hasAccessToAllModels:g}=A;if(!y&&!g)return 0;let m=0;if(C)if(C===D.scheme)m=10;else if(C==="*")m=5;else return 0;if(k)if(k===P)m=10;else if(k==="*")m=Math.max(m,5);else return 0;if(r){let a;if(typeof r=="string"?a=r:a=Object.assign(Object.assign({},r),{base:(0,I.normalize)(r.base)}),a===D.fsPath||(0,b.match)(a,D.fsPath))m=10;else return 0}return m}else return 0}}e.score=T}),define(me[142],ge([0,1,106]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(a,h,S){const w=new Uint8Array(a*h);for(let _=0,p=a*h;_<p;_++)w[_]=S;this._data=w,this.rows=a,this.cols=h}get(a,h){return this._data[a*this.cols+h]}set(a,h,S){this._data[a*this.cols+h]=S}}e.Uint8Matrix=T;class A{constructor(a){let h=0,S=0;for(let _=0,p=a.length;_<p;_++){let[c,f,t]=a[_];f>h&&(h=f),c>S&&(S=c),t>S&&(S=t)}h++,S++;let w=new T(S,h,0);for(let _=0,p=a.length;_<p;_++){let[c,f,t]=a[_];w.set(c,f,t)}this._states=w,this._maxCharCode=h}nextState(a,h){return h<0||h>=this._maxCharCode?0:this._states.get(a,h)}}e.StateMachine=A;let D=null;function P(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let k=null;function r(){if(k===null){k=new b.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<m.length;h++)k.set(m.charCodeAt(h),1);const a=".,;";for(let h=0;h<a.length;h++)k.set(a.charCodeAt(h),2)}return k}class C{static _createLink(a,h,S,w,_){let p=_-1;do{const c=h.charCodeAt(p);if(a.get(c)!==2)break;p--}while(p>w);if(w>0){const c=h.charCodeAt(w-1),f=h.charCodeAt(p);(c===40&&f===41||c===91&&f===93||c===123&&f===125)&&p--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:p+2},url:h.substring(w,p+1)}}static computeLinks(a,h=P()){const S=r();let w=[];for(let _=1,p=a.getLineCount();_<=p;_++){const c=a.getLineContent(_),f=c.length;let t=0,n=0,s=0,i=1,l=!1,o=!1,u=!1,E=!1;for(;t<f;){let d=!1;const v=c.charCodeAt(t);if(i===13){let R;switch(v){case 40:l=!0,R=0;break;case 41:R=l?0:1;break;case 91:u=!0,o=!0,R=0;break;case 93:u=!1,R=o?0:1;break;case 123:E=!0,R=0;break;case 125:R=E?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=u?0:1;break;default:R=S.get(v)}R===1&&(w.push(C._createLink(S,c,_,n,t)),d=!0)}else if(i===12){let R;v===91?(o=!0,R=0):R=S.get(v),R===1?d=!0:i=13}else i=h.nextState(i,v),i===0&&(d=!0);d&&(i=1,l=!1,o=!1,E=!1,n=t+1,s=v),t++}i===13&&w.push(C._createLink(S,c,_,n,f))}return w}}e.LinkComputer=C;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=g}),define(me[143],ge([0,1,3,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,P){return this._map.set(D,P),this.fire([D]),(0,I.toDisposable)(()=>{this._map.get(D)===P&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,P){let y=null,k=!1;return this._promises.set(D,P.then(r=>{this._promises.delete(D),!(k||!r)&&(y=this.register(D,r))})),(0,I.toDisposable)(()=>{k=!0,y&&y.dispose()})}getPromise(D){const P=this.get(D);if(P)return Promise.resolve(P);const y=this._promises.get(D);return y?y.then(k=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(me[109],ge([0,1,22,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function A(C){for(let g=0,m=C.length;g<m;g+=4){const a=C[g+0],h=C[g+1],S=C[g+2],w=C[g+3];C[g+0]=w,C[g+1]=S,C[g+2]=h,C[g+3]=a}}function D(C){const g=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||A(g),b.VSBuffer.wrap(g)}function P(C){const g=C.buffer;if(I.isLittleEndian()||A(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const m=new Uint8Array(g.byteLength);return m.set(g),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(C){const g=new Uint32Array(k(C));let m=0;if(g[m++]=C.id,C.type==="full")g[m++]=1,g[m++]=C.data.length,g.set(C.data,m),m+=C.data.length;else{g[m++]=2,g[m++]=C.deltas.length;for(const a of C.deltas)g[m++]=a.start,g[m++]=a.deleteCount,a.data?(g[m++]=a.data.length,g.set(a.data,m),m+=a.data.length):g[m++]=0}return D(g)}e.encodeSemanticTokensDto=y;function k(C){let g=0;if(g+=1+1,C.type==="full")g+=1+C.data.length;else{g+=1,g+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(g+=m.data.length)}return g}function r(C){const g=P(C);let m=0;const a=g[m++];if(g[m++]===1){const _=g[m++],p=g.subarray(m,m+_);return m+=_,{id:a,type:"full",data:p}}const S=g[m++];let w=[];for(let _=0;_<S;_++){const p=g[m++],c=g[m++],f=g[m++];let t;f>0&&(t=g.subarray(m,m+f),m+=f),w[_]={start:p,deleteCount:c,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(me[110],ge([0,1,95]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(D,P){this.index=D,this.remainder=P}}e.PrefixSumIndexOfResult=I;class T{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,P){D=(0,b.toUint32)(D);const y=this.values,k=this.prefixSum,r=P.length;return r===0?!1:(this.values=new Uint32Array(y.length+r),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+r),this.values.set(P,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,P){return D=(0,b.toUint32)(D),P=(0,b.toUint32)(P),this.values[D]===P?!1:(this.values[D]=P,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,P){D=(0,b.toUint32)(D),P=(0,b.toUint32)(P);const y=this.values,k=this.prefixSum;if(D>=y.length)return!1;let r=y.length-D;return P>=r&&(P=r),P===0?!1:(this.values=new Uint32Array(y.length-P),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+P),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,b.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),D>=this.values.length&&(D=this.values.length-1);for(let y=P;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let P=0,y=this.values.length-1,k=0,r=0,C=0;for(;P<=y;)if(k=P+(y-P)/2|0,r=this.prefixSum[k],C=r-this.values[k],D<C)y=k-1;else if(D>=r)P=k+1;else break;return new I(k,D-C)}}e.PrefixSumComputer=T}),define(me[144],ge([0,1,10,49,110]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(P,y,k,r){this._uri=P,this._lines=y,this._eol=k,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const y=P.changes;for(const k of y)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,y=this._lines.length,k=new Uint32Array(y);for(let r=0;r<y;r++)k[r]=this._lines[r].length+P;this._lineStarts=new T.PrefixSumComputer(k)}}_setLineText(P,y){this._lines[P]=y,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,y){if(y.length!==0){let k=(0,b.splitLines)(y);if(k.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+k[0]);let r=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this._lines.splice(P.lineNumber+C-1,0,k[C]),r[C-1]=k[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,r)}}}e.MirrorTextModel=A}),define(me[145],ge([16,17]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,A=T*24,D=A*7,P=A*30,y=A*365;function k(C,g){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,b.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,b.localize)(1,null);let a;return m<I?(a=m,g?a===1?(0,b.localize)(2,null,a):(0,b.localize)(3,null,a):a===1?(0,b.localize)(4,null,a):(0,b.localize)(5,null,a)):m<T?(a=Math.floor(m/I),g?a===1?(0,b.localize)(6,null,a):(0,b.localize)(7,null,a):a===1?(0,b.localize)(8,null,a):(0,b.localize)(9,null,a)):m<A?(a=Math.floor(m/T),g?a===1?(0,b.localize)(10,null,a):(0,b.localize)(11,null,a):a===1?(0,b.localize)(12,null,a):(0,b.localize)(13,null,a)):m<D?(a=Math.floor(m/A),g?a===1?(0,b.localize)(14,null,a):(0,b.localize)(15,null,a):a===1?(0,b.localize)(16,null,a):(0,b.localize)(17,null,a)):m<P?(a=Math.floor(m/D),g?a===1?(0,b.localize)(18,null,a):(0,b.localize)(19,null,a):a===1?(0,b.localize)(20,null,a):(0,b.localize)(21,null,a)):m<y?(a=Math.floor(m/P),g?a===1?(0,b.localize)(22,null,a):(0,b.localize)(23,null,a):a===1?(0,b.localize)(24,null,a):(0,b.localize)(25,null,a)):(a=Math.floor(m/y),g?a===1?(0,b.localize)(26,null,a):(0,b.localize)(27,null,a):a===1?(0,b.localize)(28,null,a):(0,b.localize)(29,null,a))}e.fromNow=k;function r(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(me[147],ge([16,17]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[59],ge([0,1,147,12,15]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,r){return r&&(k.stack||k.stacktrace)?b.localize(0,null,P(k),D(k.stack)||D(k.stacktrace)):P(k)}function D(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function y(k=null,r=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const C=T.coalesce(k),g=y(C[0],r);return C.length>1?b.localize(4,null,g,C.length):g}if(I.isString(k))return k;if(k.detail){const C=k.detail;if(C.error)return A(C.error,r);if(C.exception)return A(C.exception,r)}return k.stack?A(k,r):k.message?k.message:b.localize(5,null)}e.toErrorMessage=y}),define(me[148],ge([16,17]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[78],ge([0,1,8,37,26,38,148,36,12,23,30,9,137,11]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(f,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=A.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],n);return new Promise(i=>{s.once("error",l=>{i({success:!1,error:l})}),s.once("exit",(l,o)=>{i(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(s=>{A.execFile(n,[f.pid.toString()],{encoding:"utf8",shell:!0},(i,l,o)=>{s(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function S(f=P.env){return f.comspec||"cmd.exe"}e.getWindowsShell=S;class w{constructor(t,n,s,i){if(n!==void 0&&s!==void 0&&i!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=i;else{const l=t;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(P.env).forEach(o=>{l[o]=P.env[o]}),Object.keys(this.options.env).forEach(o=>{l[o]=this.options.env[o]}),this.options.env=l}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(P.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(n=>{let s,i;const l=new Promise((o,u)=>{s=o,i=u});if(n){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=A.exec(o,this.options,(u,E,d)=>{this.childProcess=null;const v=u;v&&v.killed?i({killed:this.terminateRequested,stdout:E.toString(),stderr:d.toString()}):this.handleExec(s,t,u,E,d)})}else{let o=null;const u=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,s,t,i);const d={terminated:this.terminateRequested};y.isNumber(E)&&(d.cmdCode=E),s(d)};if(this.shell&&C.isWindows){const E=k.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let d=!1,v=!1;const R=[];let L=this.ensureQuotes(this.cmd);R.push(L.value),d=L.quoted,this.args&&this.args.forEach(ie=>{L=this.ensureQuotes(ie),R.push(L.value),v=v&&L.quoted});const H=["/s","/c"];d?v?H.push('"'+R.join(" ")+'"'):R.length>1?H.push('"'+R[0]+'" '+R.slice(1).join(" ")):H.push('"'+R[0]+'"'):H.push(R.join(" ")),o=A.spawn(S(),H,E)}else this.cmd&&(o=A.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(y.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",E=>{this.childProcess=null,i({terminated:this.terminateRequested,error:E})}),o.pid&&(this.childProcess.on("close",u),this.handleSpawn(o,s,t,i,!0)))}return l})}handleClose(t,n,s,i){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,h(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=A.spawn(S(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class _ extends w{constructor(t,n,s,i){super(t,n,s,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,i,l){[i,l].forEach((o,u)=>{const E=new g.LineDecoder;E.write(o).forEach(R=>{n({line:R,source:u===0?0:1})});const v=E.end();v&&n({line:v,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,i,l){const o=new g.LineDecoder,u=new g.LineDecoder;t.stdout.on("data",E=>{o.write(E).forEach(v=>s({line:v,source:0}))}),t.stderr.on("data",E=>{u.write(E).forEach(v=>s({line:v,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=u}handleClose(t,n,s,i){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&s({line:l,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&s({line:o,source:1})}}e.LineProcess=_;function p(f){let t=[],n=!1;const s=function(i){if(n){t.push(i);return}(!f.send(i,o=>{if(o&&console.error(o),n=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(E=>s(E))}})||C.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=p;var c;(function(f){async function t(n,s,i){if(b.isAbsolute(n))return n;if(s===void 0&&(s=P.cwd()),b.dirname(n)!=="."||(i===void 0&&y.isString(P.env.PATH)&&(i=P.env.PATH.split(b.delimiter)),i===void 0||i.length===0))return b.join(s,n);async function o(u){return await T.exists(u)?!(await I.promises.stat(u)).isDirectory():!1}for(let u of i){let E;if(b.isAbsolute(u)?E=b.join(u,n):E=b.join(s,u,n),await o(E))return E;let d=E+".com";if(await o(d)||(d=E+".exe",await o(d)))return d}return b.join(s,n)}f.findExecutable=t})(c=e.win32||(e.win32={}))}),define(me[149],ge([0,1,48,9,103,78]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(m,a){return m===1?I.isWindows?C():A.getWindowsShell(a):k(m,a)}e.getSystemShell=D;function P(m,a){return m===1?I.isWindows?g(a):A.getWindowsShell(a):k(m,a)}e.getSystemShellSync=P;let y=null;function k(m,a){if(I.isLinux&&m===2||I.isMacintosh&&m===3)return"/bin/bash";if(!y){let h;if(I.isWindows)h="/bin/bash";else{if(h=a.SHELL,!h)try{h=(0,b.userInfo)().shell}catch(S){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}y=h}return y}let r=null;async function C(){return r||(r=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),r}function g(m){if(r)return r;const a=I.isWindows&&parseFloat((0,b.release)())>=10,h=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${m.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:A.getWindowsShell(m)}}),define(me[150],ge([16,17]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,9,108]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=D;class P{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,_e){this._values[re]=_e}}e.ValidatedEditorOptions=P;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class k{constructor(re,_e,xe,ze){this.id=re,this.name=_e,this.defaultValue=xe,this.schema=ze}compute(re,_e,xe){return xe}}class r{constructor(re,_e=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(re){return this.defaultValue}}class C{constructor(re,_e,xe,ze){this.id=re,this.name=_e,this.defaultValue=xe,this.schema=ze}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,_e,xe){return xe}}function g(X,re){return typeof X=="undefined"?re:X==="false"?!1:Boolean(X)}e.boolean=g;class m extends C{constructor(re,_e,xe,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=xe),super(re,_e,xe,ze)}validate(re){return g(re,this.defaultValue)}}class a extends C{constructor(re,_e,xe,ze,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=xe,Ye.minimum=ze,Ye.maximum=$e),super(re,_e,xe,Ye),this.minimum=ze,this.maximum=$e}static clampedInt(re,_e,xe,ze){if(typeof re=="undefined")return _e;let $e=parseInt(re,10);return isNaN($e)?_e:($e=Math.max(xe,$e),$e=Math.min(ze,$e),$e|0)}validate(re){return a.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class h extends C{constructor(re,_e,xe,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=xe),super(re,_e,xe,$e),this.validationFn=ze}static clamp(re,_e,xe){return re<_e?_e:re>xe?xe:re}static float(re,_e){if(typeof re=="number")return re;if(typeof re=="undefined")return _e;const xe=parseFloat(re);return isNaN(xe)?_e:xe}validate(re){return this.validationFn(h.float(re,this.defaultValue))}}class S extends C{static string(re,_e){return typeof re!="string"?_e:re}constructor(re,_e,xe,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=xe),super(re,_e,xe,ze)}validate(re){return S.string(re,this.defaultValue)}}function w(X,re,_e){return typeof X!="string"||_e.indexOf(X)===-1?re:X}e.stringSet=w;class _ extends C{constructor(re,_e,xe,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=xe),super(re,_e,xe,$e),this._allowedValues=ze}validate(re){return w(re,this.defaultValue,this._allowedValues)}}class p extends k{constructor(re,_e,xe,ze,$e,Ye,K=void 0){typeof K!="undefined"&&(K.type="string",K.enum=$e,K.default=ze),super(re,_e,xe,K),this._allowedValues=$e,this._convert=Ye}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function c(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,_e,xe){return xe===0?re.accessibilitySupport:xe}}class t extends k{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:b.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{insertSpace:g(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function o(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class u extends r{constructor(){super(123,[62,31])}compute(re,_e,xe){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),re.extraEditorClassName&&ze.push(re.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class E extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(re,_e,xe){return xe&&re.emptySelectionClipboard}}class d extends k{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:b.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:b.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{cursorMoveOnType:g(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:g(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":w(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(_e.loop,this.defaultValue.loop)}}}class v extends k{constructor(){super(41,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?v.OFF:re==="true"?v.ON:re:Boolean(re)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class R extends r{constructor(){super(40)}compute(re,_e,xe){return re.fontInfo}}class L extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(re){let _e=h.float(re,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(_e,6,100)}compute(re,_e,xe){return re.fontInfo.fontSize}}class H extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(a.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class ie extends k{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]};super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,description:b.localize(35,null)}})}validate(re){var _e,xe,ze,$e,Ye;if(!re||typeof re!="object")return this.defaultValue;const K=re;return{multiple:w(K.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=K.multipleDefinitions)!==null&&_e!==void 0?_e:w(K.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=K.multipleTypeDefinitions)!==null&&xe!==void 0?xe:w(K.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=K.multipleDeclarations)!==null&&ze!==void 0?ze:w(K.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=K.multipleImplementations)!==null&&$e!==void 0?$e:w(K.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=K.multipleReferences)!==null&&Ye!==void 0?Ye:w(K.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(K.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(K.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(K.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(K.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(K.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends k{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:b.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:g(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:g(_e.sticky,this.defaultValue.sticky)}}}var B;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class $ extends r{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(re,_e,xe){return $.computeLayout(_e,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const _e=re.height/re.lineHeight,xe=re.scrollBeyondLastLine?_e-1:0,ze=(re.viewLineCount+xe)/(re.pixelRatio*re.height),$e=Math.floor(re.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:xe,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(re,_e){const xe=re.outerWidth,ze=re.outerHeight,$e=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=_e.stableMinimapLayoutInput,K=Ye&&re.outerHeight===Ye.outerHeight&&re.lineHeight===Ye.lineHeight&&re.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&re.pixelRatio===Ye.pixelRatio&&re.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&re.minimap.enabled===Ye.minimap.enabled&&re.minimap.side===Ye.minimap.side&&re.minimap.size===Ye.minimap.size&&re.minimap.showSlider===Ye.minimap.showSlider&&re.minimap.renderCharacters===Ye.minimap.renderCharacters&&re.minimap.maxColumn===Ye.minimap.maxColumn&&re.minimap.scale===Ye.minimap.scale&&re.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&re.isViewportWrapping===Ye.isViewportWrapping,oe=re.lineHeight,fe=re.typicalHalfwidthCharacterWidth,Z=re.scrollBeyondLastLine,ne=re.minimap.renderCharacters;let ce=$e>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const pe=re.minimap.maxColumn,Se=re.minimap.size,qe=re.minimap.side,Me=re.verticalScrollbarWidth,He=re.viewLineCount,Qe=re.remainingWidth,it=re.isViewportWrapping,at=ne?2:3;let Ze=Math.floor($e*ze);const nt=Ze/$e;let dt=!1,_t=!1,ue=at*ce,De=ce/$e,le=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:Ge,desiredRatio:ht,minimapLineCount:ot}=$.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:Z,height:ze,lineHeight:oe,pixelRatio:$e});if(He/ot>1)dt=!0,_t=!0,ce=1,ue=1,De=ce/$e;else{let pt=!1,Et=ce+1;if(Se==="fit"){const yt=Math.ceil((He+Ge)*ue);it&&K&&Qe<=_e.stableFitRemainingWidth?(pt=!0,Et=_e.stableFitMaxMinimapScale):(pt=yt>Ze,it&&pt?(_e.stableMinimapLayoutInput=re,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(Se==="fill"||pt){dt=!0;const yt=ce;ue=Math.min(oe*$e,Math.max(1,Math.floor(1/ht))),ce=Math.min(Et,Math.max(1,Math.floor(ue/at))),ce>yt&&(le=Math.min(2,ce/yt)),De=ce/$e/le,Ze=Math.ceil(Math.max(rt,He+Ge)*ue),it&&pt&&(_e.stableFitMaxMinimapScale=ce)}}}const Y=Math.floor(pe*De),Ne=Math.min(Y,Math.max(0,Math.floor((Qe-Me-2)*De/(fe+De)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Ne);const Je=Te/$e;Te=Math.floor(Te*le);const et=ne?1:2,ut=qe==="left"?0:xe-Ne-Me;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Ne,minimapHeightIsEditorHeight:dt,minimapIsSampling:_t,minimapScale:ce,minimapLineHeight:ue,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:nt}}static computeLayout(re,_e){const xe=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Ye=_e.lineNumbersDigitCount|0,K=_e.typicalHalfwidthCharacterWidth,oe=_e.maxDigitWidth,fe=_e.pixelRatio,Z=_e.viewLineCount,ne=re.get(118),ce=ne==="inherit"?re.get(117):ne,pe=ce==="inherit"?re.get(113):ce,Se=re.get(116),qe=re.get(2),Me=_e.isDominatedByLongLines,He=re.get(46),Qe=re.get(56).renderType!==0,it=re.get(57),at=re.get(91),Ze=re.get(61),nt=re.get(89),dt=nt.verticalScrollbarSize,_t=nt.verticalHasArrows,ue=nt.arrowSize,De=nt.horizontalScrollbarSize,le=re.get(54),Y=re.get(35);let Ne;if(typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)){const At=parseFloat(le.substr(0,le.length-2));Ne=a.clampedInt(At*K,0,0,1e3)}else Ne=a.clampedInt(le,0,0,1e3);Y&&(Ne+=16);let Te=0;if(Qe){const At=Math.max(Ye,it);Te=Math.round(At*oe)}let Je=0;He&&(Je=$e);let et=0,ut=et+Je,rt=ut+Te,Ge=rt+Ne;const ht=xe-Je-Te-Ne;let ot=!1,vt=!1,pt=-1;qe!==2&&(ce==="inherit"&&Me?(ot=!0,vt=!0):pe==="on"||pe==="bounded"?vt=!0:pe==="wordWrapColumn"&&(pt=Se));const Et=$._computeMinimapLayout({outerWidth:xe,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:K,pixelRatio:fe,scrollBeyondLastLine:at,minimap:Ze,verticalScrollbarWidth:dt,viewLineCount:Z,remainingWidth:ht,isViewportWrapping:vt},_e.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(et+=Et.minimapWidth,ut+=Et.minimapWidth,rt+=Et.minimapWidth,Ge+=Et.minimapWidth);const yt=ht-Et.minimapWidth,Pt=Math.max(1,Math.floor((yt-dt-2)/K)),bt=_t?ue:0;return vt&&(pt=Math.max(1,Pt),pe==="bounded"&&(pt=Math.min(pt,Se))),{width:xe,height:ze,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ut,lineNumbersWidth:Te,decorationsLeft:rt,decorationsWidth:Ne,contentLeft:Ge,contentWidth:yt,minimap:Et,viewportColumn:Pt,isWordWrapMinified:ot,isViewportWrapping:vt,wrappingColumn:pt,verticalScrollbarWidth:dt,horizontalScrollbarHeight:De,overviewRuler:{top:bt,width:dt,height:ze-2*bt,right:0}}}}e.EditorLayoutInfoComputer=$;class N extends k{constructor(){const re={enabled:!0};super(53,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:b.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:g(re.enabled,this.defaultValue.enabled)}}}class M extends k{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",re,{"editor.inlineHints.enabled":{type:"boolean",default:re.enabled,description:b.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:re.fontSize,description:b.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:re.fontFamily,description:b.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:g(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class F extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(re,_e,xe){return re.fontInfo.lineHeight}}class U extends k{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:re.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:b.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:g(_e.enabled,this.defaultValue.enabled),size:w(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(_e.side,this.defaultValue.side,["right","left"]),showSlider:w(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class q extends k{constructor(){const re={enabled:!0,cycle:!1};super(72,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:b.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{enabled:g(_e.enabled,this.defaultValue.enabled),cycle:g(_e.cycle,this.defaultValue.cycle)}}}class Q extends r{constructor(){super(124)}compute(re,_e,xe){return re.pixelRatio}}class he extends k{constructor(){const re={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:b.localize(58,null)},comments:{type:"boolean",default:re.comments,description:b.localize(59,null)},other:{type:"boolean",default:re.other,description:b.localize(60,null)}}}],default:re,description:b.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const _e=re,xe={other:g(_e.other,this.defaultValue.other),comments:g(_e.comments,this.defaultValue.comments),strings:g(_e.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Pe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(re){let _e=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(_e=4,xe=re):re==="interval"?_e=3:re==="relative"?_e=2:re==="on"?_e=1:_e=0),{renderType:_e,renderFn:xe}}}function ke(X){const re=X.get(84);return re==="editable"?X.get(77):re!=="on"}e.filterValidationDecorations=ke;class Le extends k{constructor(){const re=[],_e={type:"number",description:b.localize(67,null)};super(88,"rulers",re,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:re,description:b.localize(69,null)})}validate(re){if(Array.isArray(re)){let _e=[];for(let xe of re)if(typeof xe=="number")_e.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const ze=xe;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((xe,ze)=>xe.column-ze.column),_e}return this.defaultValue}}function V(X,re){if(typeof X!="string")return re;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re,xe=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(_e.vertical,this.defaultValue.vertical),horizontal:V(_e.horizontal,this.defaultValue.horizontal),useShadows:g(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:g(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:re.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{insertMode:w(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(_e.showIcons,this.defaultValue.showIcons),showStatusBar:g(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:g(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(_e.showMethods,this.defaultValue.showMethods),showFunctions:g(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:g(_e.showConstructors,this.defaultValue.showConstructors),showFields:g(_e.showFields,this.defaultValue.showFields),showVariables:g(_e.showVariables,this.defaultValue.showVariables),showClasses:g(_e.showClasses,this.defaultValue.showClasses),showStructs:g(_e.showStructs,this.defaultValue.showStructs),showInterfaces:g(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:g(_e.showModules,this.defaultValue.showModules),showProperties:g(_e.showProperties,this.defaultValue.showProperties),showEvents:g(_e.showEvents,this.defaultValue.showEvents),showOperators:g(_e.showOperators,this.defaultValue.showOperators),showUnits:g(_e.showUnits,this.defaultValue.showUnits),showValues:g(_e.showValues,this.defaultValue.showValues),showConstants:g(_e.showConstants,this.defaultValue.showConstants),showEnums:g(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:g(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(_e.showKeywords,this.defaultValue.showKeywords),showWords:g(_e.showWords,this.defaultValue.showWords),showColors:g(_e.showColors,this.defaultValue.showColors),showFiles:g(_e.showFiles,this.defaultValue.showFiles),showReferences:g(_e.showReferences,this.defaultValue.showReferences),showFolders:g(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:g(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(_e.showSnippets,this.defaultValue.showSnippets),showUsers:g(_e.showUsers,this.defaultValue.showUsers),showIssues:g(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends r{constructor(){super(125,[77])}compute(re,_e,xe){return _e.get(77)?!0:re.tabFocusMode}}var Ce;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ce=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends r{constructor(){super(127,[126])}compute(re,_e,xe){const ze=_e.get(126);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Ie="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Re:I.isLinux?We:Ie,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:Ee(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:Ee(new f),accessibilityPageSize:Ee(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:Ee(new S(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:Ee(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:Ee(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:Ee(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:Ee(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:Ee(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:Ee(new m(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:Ee(new S(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:Ee(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:Ee(new p(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:Ee(new p(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:b.localize(145,null)})),cursorSurroundingLines:Ee(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:Ee(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:Ee(new E),extraEditorClassName:Ee(new S(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new h(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:b.localize(152,null)})),find:Ee(new d),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:Ee(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:Ee(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:Ee(new R),fontLigatures2:Ee(new v),fontSize:Ee(new L),fontWeight:Ee(new H),formatOnPaste:Ee(new m(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:Ee(new m(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:Ee(new m(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:Ee(new ie),hideCursorInOverviewRuler:Ee(new m(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:Ee(new m(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:Ee(new j),inDiffEditor:Ee(new m(51,"inDiffEditor",!1)),letterSpacing:Ee(new h(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:b.localize(165,null)})),lightbulb:Ee(new N),lineDecorationsWidth:Ee(new C(54,"lineDecorationsWidth",10)),lineHeight:Ee(new F),lineNumbers:Ee(new Pe),lineNumbersMinChars:Ee(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:Ee(new m(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:Ee(new _(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:Ee(new U),mouseStyle:Ee(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new h(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:Ee(new m(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:Ee(new m(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:Ee(new p(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:Ee(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:Ee(new m(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:Ee(new m(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:Ee(new a(70,"overviewRulerLanes",3,0,3)),padding:Ee(new W),parameterHints:Ee(new q),peekWidgetDefaultFocus:Ee(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:Ee(new m(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:Ee(new he),quickSuggestionsDelay:Ee(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:Ee(new m(77,"readOnly",!1)),renameOnType:Ee(new m(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:Ee(new m(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:Ee(new m(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:Ee(new m(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:Ee(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:Ee(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:Ee(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:Ee(new Le),scrollbar:Ee(new J),scrollBeyondLastColumn:Ee(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:Ee(new m(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:Ee(new m(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:Ee(new m(93,"selectionClipboard",!0,{description:b.localize(201,null),included:I.isLinux})),selectionHighlight:Ee(new m(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:Ee(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:Ee(new m(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:Ee(new m(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlineHints:Ee(new M),snippetSuggestions:Ee(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:Ee(new ae),smoothScrolling:Ee(new m(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:Ee(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ee),suggestFontSize:Ee(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:Ee(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:Ee(new m(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:Ee(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:Ee(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:Ee(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:Ee(new m(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:Ee(new S(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:Ee(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new S(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new S(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:Ee(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new p(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:Ee(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:Ee(new u),pixelRatio:Ee(new Q),tabFocusMode:Ee(new we),layoutInfo:Ee(new $),wrappingInfo:Ee(new be)}}),define(me[152],ge([16,17]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([16,17]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([16,17]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([16,17]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[156],ge([16,17]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[157],ge([16,17]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[158],ge([16,17]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[159],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[160],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[161],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(me[162],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[163],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[164],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[165],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[166],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[167],ge([16,17]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[168],ge([16,17]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[169],ge([16,17]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[170],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[171],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[172],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(me[173],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[174],ge([16,17]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[175],ge([16,17]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[176],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var I;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[177],ge([0,1,154]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function A(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=C.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function D(C){if(!C)return null;let g=C.majorBase,m=C.majorMustEqual,a=C.minorBase,h=C.minorMustEqual,S=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(g===0||(h=!1),w=!1),{majorBase:g,majorMustEqual:m,minorBase:a,minorMustEqual:h,patchBase:S,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=D;function P(C,g){let m;typeof C=="string"?m=D(A(C)):m=C;let a;if(typeof g=="string"?a=D(A(g)):a=g,!m||!a)return!1;let h=m.majorBase,S=m.minorBase,w=m.patchBase,_=a.majorBase,p=a.minorBase,c=a.patchBase,f=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?h>_?!0:h<_?!1:S>p?!0:S<p?!1:w>=c:(h===1&&_===0&&(!f||!t||!n)&&(_=1,p=0,c=0,f=!0,t=!1,n=!1),h<_?!1:h>_?!f:S<p?!1:S>p?!t:w<c?!1:w>c?!n:!0)}e.isValidVersion=P;function y(C,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:r(C,g.engines.vscode,m)}e.isValidExtensionVersion=y;function k(C,g){return C==="*"||r(g,C)}e.isEngineValid=k;function r(C,g,m=[]){let a=D(A(g));if(!a)return m.push(b.localize(0,null,g)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return m.push(b.localize(1,null,g)),!1}else if(!a.majorMustEqual)return m.push(b.localize(2,null,g)),!1;return P(C,a)?!0:(m.push(b.localize(3,null,C,g)),!1)}e.isVersionValid=r}),define(me[111],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(A,D=[],P=!1){this.ctor=A,this.staticArguments=D,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=b;const I=(T,...A)=>new b(T,A);e.createSyncDescriptor=I}),define(me[79],ge([0,1,111]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(D,P,y){P instanceof b.SyncDescriptor||(P=new b.SyncDescriptor(P,[],y)),I.push([D,P])}e.registerSingleton=T;function A(){return I}e.getSingletonServiceDescriptors=A}),define(me[178],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=b;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let D of this._nodes.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const P=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(D);P.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(A),P)}removeNode(A){const D=this._hashFn(A);this._nodes.delete(D);for(let P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(A){const D=this._hashFn(A);let P=this._nodes.get(D);return P||(P=new b(A),this._nodes.set(D,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[D,P]of this._nodes)A.push(`${D}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,D]of this._nodes){const P=new Set([A]),y=this._findCycle(D,P);if(y)return y}}_findCycle(A,D){for(let[P,y]of A.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const k=this._findCycle(y,D);if(k)return k;D.delete(P)}}}e.Graph=I}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function y(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=y})(b=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(P,y,k,r){y[b.DI_TARGET]===y?y[b.DI_DEPENDENCIES].push({id:P,index:k,optional:r}):(y[b.DI_DEPENDENCIES]=[{id:P,index:k,optional:r}],y[b.DI_TARGET]=y)}function T(P){if(b.serviceIds.has(P))return b.serviceIds.get(P);const y=function(k,r,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(y,k,C,!1)};return y.toString=()=>P,b.serviceIds.set(P,y),y}e.createDecorator=T;function A(P){return P}e.refineServiceDecorator=A;function D(P){return function(y,k,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(P,y,r,!0)}}e.optional=D}),define(me[179],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(me[180],ge([0,1,3,74,6,24,73,77,179]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(k):!!g.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(m,a){let h={selector:m,provider:a,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(h){let S=this._entries.indexOf(h);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const a=[];for(let h of this._entries)h._score>0&&a.push(h.provider);return a}ordered(m){const a=[];return this._orderedForEach(m,h=>a.push(h.provider)),a}orderedGroups(m){const a=[];let h,S;return this._orderedForEach(m,w=>{h&&S===w._score?h.push(w.provider):(S=w._score,h=[w.provider],a.push(h))}),a}_orderedForEach(m,a){if(!!m){this._updateScores(m);for(const h of this._entries)h._score>0&&a(h)}}_updateScores(m){let a={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let h of this._entries)if(h._score=(0,P.score)(h.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),k(h.selector)&&h._score>0){for(let S of this._entries)S._score=0;h._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(m,a){return m._score<a._score?1:m._score>a._score?-1:m._time<a._time?1:m._time>a._time?-1:0}}e.LanguageFeatureRegistry=r;class C{constructor(m,a,h=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=a,this.max=h,this._cache=new A.LRUCache(50,.7)}_key(m){return m.id+(0,I.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const a=this._key(m),h=this._cache.get(a);return this._clamp(h==null?void 0:h.value)}update(m,a){const h=this._key(m);let S=this._cache.get(h);return S||(S=new D.MovingAverage,this._cache.set(h,S)),S.update(a),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(me[80],ge([0,1,2,44,180,143,43]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class y{constructor(v,R){this.language=v,this.id=R}}e.LanguageIdentifier=y;var k;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var r;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var C;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var g;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(g=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let R=this.getForeground(v),L="mtk"+R,H=this.getFontStyle(v);return H&1&&(L+=" mtki"),H&2&&(L+=" mtkb"),H&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(v,R){const L=this.getForeground(v),H=this.getFontStyle(v);let ie=`color: ${R[L]};`;return H&1&&(ie+="font-style: italic;"),H&2&&(ie+="font-weight: bold;"),H&4&&(ie+="text-decoration: underline;"),ie}}e.TokenMetadata=m;var a;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(v){const R=d[v];let L=R&&D.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+v),L=D.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(v,R){let L=d[v];return typeof L=="undefined"&&!R&&(L=9),L}}();var h;(function(d){d[d.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(d){return d&&b.URI.isUri(d.uri)&&I.Range.isIRange(d.range)&&(I.Range.isIRange(d.originSelectionRange)||I.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=f;var t;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(d){d[d.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(d){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L(j){return v.get(j)}d.fromString=L;function H(j){return R.get(j)}d.toString=H;function ie(j,B){const $=R.get(j);let N=$&&D.iconRegistry.get("symbol-"+$);return N||(console.info("No codicon found for SymbolKind "+j),N=D.Codicon.symbolProperty),`${B?"inline":"block"} ${N.classNames}`}d.toCssClassName=ie})(s=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(v){this.value=v}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var l;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var u;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(u=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var E;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[181],ge([0,1,6,12,4,3,56,54]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,k){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:y,handler:k})}if(y.description){const a=[];for(let S of y.description.args)a.push(S.constraint);const h=y.handler;y.handler=function(S,...w){return(0,I.validateConstraints)(w,a),h(S,...w)}}const{id:r}=y;let C=this._commands.get(r);C||(C=new D.LinkedList,this._commands.set(r,C));let g=C.unshift(y),m=(0,b.toDisposable)(()=>{g();const a=this._commands.get(r);(a==null?void 0:a.isEmpty())&&this._commands.delete(r)});return this._onDidRegisterCommand.fire(r),m}registerCommandAlias(y,k){return e.CommandsRegistry.registerCommand(y,(r,...C)=>r.get(e.ICommandService).executeCommand(k,...C))}getCommand(y){const k=this._commands.get(y);if(!(!k||k.isEmpty()))return P.Iterable.first(k)}getCommands(){const y=new Map;for(const k of this._commands.keys()){const r=this.getCommand(k);r&&y.set(k,r)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(me[81],ge([0,1,10,4,9]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=T.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",T.isMacintosh),D.set("isLinux",T.isLinux),D.set("isWindows",T.isWindows),D.set("isWeb",T.isWeb),D.set("isMacNative",T.isMacintosh&&!T.isWeb),D.set("isEdge",A.indexOf("Edg/")>=0),D.set("isFirefox",A.indexOf("Firefox")>=0),D.set("isChrome",A.indexOf("Chrome")>=0),D.set("isSafari",A.indexOf("Safari")>=0),D.set("isIPad",A.indexOf("iPad")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(d){d[d.False=0]="False",d[d.True=1]="True",d[d.Defined=2]="Defined",d[d.Not=3]="Not",d[d.Equals=4]="Equals",d[d.NotEquals=5]="NotEquals",d[d.And=6]="And",d[d.Regex=7]="Regex",d[d.NotRegex=8]="NotRegex",d[d.Or=9]="Or",d[d.In=10]="In",d[d.NotIn=11]="NotIn",d[d.Greater=12]="Greater",d[d.GreaterEquals=13]="GreaterEquals",d[d.Smaller=14]="Smaller",d[d.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(v){return m.create(v)}static equals(v,R){return a.create(v,R)}static notEquals(v,R){return w.create(v,R)}static regex(v,R){return n.create(v,R)}static in(v,R){return h.create(v,R)}static not(v){return _.create(v)}static and(...v){return i.create(v)}static or(...v){return l.create(v)}static greater(v,R){return p.create(v,R)}static less(v,R){return f.create(v,R)}static deserialize(v,R=!1){if(!!v)return this._deserializeOrExpression(v,R)}static _deserializeOrExpression(v,R){let L=v.split("||");return l.create(L.map(H=>this._deserializeAndExpression(H,R)))}static _deserializeAndExpression(v,R){let L=v.split("&&");return i.create(L.map(H=>this._deserializeOne(H,R)))}static _deserializeOne(v,R){if(v=v.trim(),v.indexOf("!=")>=0){let L=v.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],R))}if(v.indexOf("==")>=0){let L=v.split("==");return a.create(L[0].trim(),this._deserializeValue(L[1],R))}if(v.indexOf("=~")>=0){let L=v.split("=~");return n.create(L[0].trim(),this._deserializeRegexValue(L[1],R))}if(v.indexOf(" in ")>=0){let L=v.split(" in ");return h.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const L=v.split(">=");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const L=v.split(">");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const L=v.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const L=v.split("<");return f.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(v)?_.create(v.substr(1).trim()):m.create(v)}static _deserializeValue(v,R){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let L=/^'([^']*)'$/.exec(v);return L?L[1].trim():v}static _deserializeRegexValue(v,R){if((0,b.isFalsyOrWhitespace)(v)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=v.indexOf("/"),H=v.lastIndexOf("/");if(L===H||L<0){if(R)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let ie=v.slice(L+1,H),j=v[H+1]==="i"?"i":"";try{return new RegExp(ie,j)}catch(B){if(R)throw new Error(`bad regexp-value '${v}', parse error: ${B}`);return console.warn(`bad regexp-value '${v}', parse error: ${B}`),null}}}e.ContextKeyExpr=k;function r(d,v){return d.cmp(v)}class C{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{constructor(v){this.key=v,this.type=2}static create(v){const R=D.get(v);return typeof R=="boolean"?R?g.INSTANCE:C.INSTANCE:new m(v)}cmp(v){return v.type!==this.type?this.type-v.type:u(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=m;class a{constructor(v,R){this.key=v,this.value=R,this.type=4}static create(v,R){if(typeof R=="boolean")return R?m.create(v):_.create(v);const L=D.get(v);return typeof L=="boolean"?R===(L?"true":"false")?g.INSTANCE:C.INSTANCE:new a(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class h{constructor(v,R){this.key=v,this.valueKey=R,this.type=10}static create(v,R){return new h(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const R=v.getValue(this.valueKey),L=v.getValue(this.key);return Array.isArray(R)?R.indexOf(L)>=0:typeof L=="string"&&typeof R=="object"&&R!==null?P.call(R,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=h;class S{constructor(v){this._actual=v,this.type=11}static create(v){return new S(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new S(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(v,R){this.key=v,this.value=R,this.type=5}static create(v,R){if(typeof R=="boolean")return R?_.create(v):m.create(v);const L=D.get(v);return typeof L=="boolean"?R===(L?"true":"false")?C.INSTANCE:g.INSTANCE:new w(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class _{constructor(v){this.key=v,this.type=3}static create(v){const R=D.get(v);return typeof R=="boolean"?R?C.INSTANCE:g.INSTANCE:new _(v)}cmp(v){return v.type!==this.type?this.type-v.type:u(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=_;class p{constructor(v,R){this.key=v,this.value=R,this.type=12}static create(v,R){return new p(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class c{constructor(v,R){this.key=v,this.value=R,this.type=13}static create(v,R){return new c(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class f{constructor(v,R){this.key=v,this.value=R,this.type=14}static create(v,R){return new f(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(v,R){this.key=v,this.value=R,this.type=15}static create(v,R){return new t(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:E(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(v,R){this.key=v,this.regexp=R,this.type=7}static create(v,R){return new n(v,R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const R=this.regexp?this.regexp.source:"",L=v.regexp?v.regexp.source:"";return R<L?-1:R>L?1:0}equals(v){if(v.type===this.type){const R=this.regexp?this.regexp.source:"",L=v.regexp?v.regexp.source:"";return this.key===v.key&&R===L}return!1}evaluate(v){let R=v.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(v){this.expr=v,this.type=6}static create(v){return i._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const H=r(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].evaluate(v))return!1;return!0}static _normalizeArr(v){const R=[];let L=!1;for(const H of v)if(!!H){if(H.type===1){L=!0;continue}if(H.type===0)return C.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&L)return g.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(r);R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const ie=R.pop(),j=l.create(H.expr.map(B=>i.create([B,ie])));j&&(R.push(j),R.sort(r))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new i(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let R of this.expr)v.push(R.negate());return l.create(v)}}e.ContextKeyAndExpr=i;class l{constructor(v){this.expr=v,this.type=9}static create(v){const R=l._normalizeArr(v);if(R.length!==0)return R.length===1?R[0]:new l(R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const H=r(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,L=this.expr.length;R<L;R++)if(this.expr[R].evaluate(v))return!0;return!1}static _normalizeArr(v){let R=[],L=!1;if(v){for(let H=0,ie=v.length;H<ie;H++){const j=v[H];if(!!j){if(j.type===0){L=!0;continue}if(j.type===1)return[g.INSTANCE];if(j.type===9){R=R.concat(j.expr);continue}R.push(j)}}if(R.length===0&&L)return[C.INSTANCE];R.sort(r)}return R}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new l(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let L of this.expr)v.push(L.negate());const R=L=>L.type===9?L.expr:[L];for(;v.length>1;){const L=v.shift(),H=v.shift(),ie=[];for(const j of R(L))for(const B of R(H))ie.push(k.and(j,B));v.unshift(k.or(...ie))}return v[0]}}e.ContextKeyOrExpr=l;class o extends m{constructor(v,R,L){super(v);this._defaultValue=R,typeof L=="object"?o._info.push(Object.assign(Object.assign({},L),{key:v})):L!==!0&&o._info.push({key:v,description:L,type:R!=null?typeof R:void 0})}static all(){return o._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(v){return k.equals(this.key,v)}notEqualsTo(v){return k.notEquals(this.key,v)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(d,v){return d<v?-1:d>v?1:0}function E(d,v,R,L){return d<R?-1:d>R?1:v<L?-1:v>L?1:0}}),define(me[182],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[183],ge([0,1,153,4,11]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A;var D;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var P;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var y;(function(C){C.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var k;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(k=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(g,m){super(g);this.code=m}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(me[29],ge([0,1,10,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class D{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,C){if(typeof r=="undefined"||r===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof r=="string"||typeof C=="string"){let g=typeof r=="string"?r:r.value,m=typeof C=="string"?C:C.value;return b.equalsIgnoreCase(g,m)}return r._lower===C._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=D;function P(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function y(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[184],ge([0,1,10,29]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(m,a){return m.uuid&&a.uuid?m.uuid===a.uuid:m.id===a.id?!0:(0,b.compareIgnoreCase)(m.id,a.id)===0}e.areSameExtensions=T;class A{constructor(a,h){this.version=h,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?T(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function D(m,a){return`${m}.${a}`}e.getExtensionId=D;function P(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(m,a){return P(D(m,a))}e.getGalleryExtensionId=y;function k(m,a){const h=[],S=w=>{for(const _ of h)if(_.some(p=>T(a(p),a(w))))return _;return null};for(const w of m){const _=S(w);_?_.push(w):h.push([w])}return h}e.groupByExtension=k;function r(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function g(m){const a=new Set;for(const h of m)h.malicious&&a.add(h.id.id);return a}e.getMaliciousExtensionsSet=g}),define(me[45],ge([0,1,155,8,2,4,10,12,24]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(j){return j.create===!0}e.isFileOpenForWriteOptions=k;var r;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var C;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=g;function m(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=m;function a(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function h(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=h;var S;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(B,$){super(B);this.code=$}}e.FileSystemProviderError=w;function _(j,B){const $=new w(j.toString(),B);return c($,B),$}e.createFileSystemProviderError=_;function p(j){return j||_((0,b.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=p;function c(j,B){return j.name=B?`${B} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=c;function f(j){if(!j)return S.Unknown;if(j instanceof w)return j.code;const B=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!B)return S.Unknown;switch(B[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=f;function t(j){if(j instanceof u)return j.fileOperationResult;switch(f(j)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(B,$,N){this.resource=B,this.operation=$,this.target=N}isOperation(B){return this.operation===B}}e.FileOperationEvent=s;var i;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const N of B)switch(N.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains(B,...$){return this.doContains(B,{includeChildren:!1},...$)}affects(B,...$){return this.doContains(B,{includeChildren:!0},...$)}doContains(B,$,...N){var M,F,U,O,W,q;if(!B)return!1;const Q=N.length>0;return!!((!Q||N.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(B))||$.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(B)))||(!Q||N.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(B))||$.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(B)))||(!Q||N.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(B))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const $=[],N=B===1?this.added:B===0?this.updated:this.deleted;if(N)for(const[,M]of N)$.push(M);return $}filter(B){return new l(this.changes.filter($=>B($)),this.ignorePathCasing)}}e.FileChangesEvent=l;function o(j,B,$){return!j||!B||j===B||B.length>j.length?!1:(B.charAt(B.length-1)!==I.sep&&(B+=I.sep),$?(0,D.startsWithIgnoreCase)(j,B):j.indexOf(B)===0)}e.isParent=o;class u extends Error{constructor(B,$,N){super(B);this.fileOperationResult=$,this.options=N}static isFileOperationError(B){return B instanceof Error&&!(0,P.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=u;var E;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var d;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(d=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=v;async function R(j,B){if(!B.canHandleResource(T.URI.from({scheme:j.scheme})))return new Promise($=>{const N=B.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===j.scheme&&M.added&&(N.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(B){return(0,P.isNumber)(B)||(B=0),B<L.KB?(0,b.localize)(1,null,B.toFixed(0)):B<L.MB?(0,b.localize)(2,null,(B/L.KB).toFixed(2)):B<L.GB?(0,b.localize)(3,null,(B/L.MB).toFixed(2)):B<L.TB?(0,b.localize)(4,null,(B/L.GB).toFixed(2)):(0,b.localize)(5,null,(B/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var H;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function ie(j){return{maxFileSize:j===0?300*L.MB:16*L.GB,maxHeapSize:j===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=ie}),define(me[82],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...T){this._entries=new Map;for(let[A,D]of T)this.set(A,D)}set(T,A){const D=this._entries.get(T);return this._entries.set(T,A),D}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=b}),define(me[185],ge([0,1,18,178,111,4,82,19]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class k extends Error{constructor(a){var h;super("cyclic dependency between services");this.message=(h=a.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class r{constructor(a=new D.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=h,this._parent=S,this._services.set(A.IInstantiationService,this)}createChild(a){return new r(a,this._strict,this)}invokeFunction(a,...h){let S=g.traceInvocation(a),w=!1;try{return a({get:(p,c)=>{if(w)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(p,S);if(!f&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return f}},...h)}finally{w=!0,S.stop()}}createInstance(a,...h){let S,w;return a instanceof T.SyncDescriptor?(S=g.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(h),S)):(S=g.traceCreation(a),w=this._createInstance(a,h,S)),S.stop(),w}_createInstance(a,h=[],S){let w=A._util.getServiceDependencies(a).sort((c,f)=>c.index-f.index),_=[];for(const c of w){let f=this._getOrCreateServiceInstance(c.id,S);if(!f&&this._strict&&!c.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${c.id}.`);_.push(f)}let p=w.length>0?w[0].index:h.length;if(h.length!==p){console.warn(`[createInstance] First service dependency of ${a.name} at position ${p+1} conflicts with ${h.length} static arguments`);let c=p-h.length;c>0?h=h.concat(new Array(c)):h=h.slice(0,p)}return new a(...[...h,..._])}_setServiceInstance(a,h){if(this._services.get(a)instanceof T.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,h.branch(a,!0)):(h.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,h,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,S){const w=new I.Graph(c=>c.id.toString());let _=0;const p=[{id:a,desc:h,_trace:S}];for(;p.length;){const c=p.pop();if(w.lookupOrInsertNode(c),_++>1e3)throw new k(w);for(let f of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${a} depends on ${f.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:f.id,desc:t,_trace:c._trace.branch(f.id,!0)};w.insertEdge(c,n),p.push(n)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:f}of c){if(this._getServiceInstanceOrDescriptor(f.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}w.removeNode(f)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,S=[],w,_){if(this._services.get(a)instanceof T.SyncDescriptor)return this._createServiceInstance(h,S,w,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,S,w,_);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h=[],S,w){if(S){const _=new P.IdleValue(()=>this._createInstance(a,h,w));return new Proxy(Object.create(null),{get(p,c){if(c in p)return p[c];let f=_.value,t=f[c];return typeof t!="function"||(t=t.bind(f),p[c]=t),t},set(p,c,f){return _.value[c]=f,!0}})}else return this._createInstance(a,h,w)}}e.InstantiationService=r;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class g{constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return y?new g(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(a){return y?new g(0,a.name):g._None}branch(a,h){let S=new g(2,a.toString());return this._dep.push([a,h,S]),S}stop(){let a=Date.now()-this._start;g._totals+=a;let h=!1;function S(_,p){let c=[],f=new Array(_+1).join("	");for(const[t,n,s]of p._dep)if(n&&s){h=!0,c.push(`${f}CREATES -> ${t}`);let i=S(_+1,s);i&&c.push(i)}else c.push(`${f}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(a>2||h)&&console.log(w.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(me[13],ge([0,1,4,6,9,3,59]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class r extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(y.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(y.Error,this.format(s))}else this.log(y.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(l){}n+=(s>0?" ":"")+i}return n}}e.AbstractMessageLogger=r;class C extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class a extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class h extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=h;class S extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?y.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function _(f){if(f.verbose)return y.Trace;if(typeof f.logLevel=="string"){const t=p(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function p(f){switch(f){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=p;function c(f){switch(f){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c}),define(me[112],ge([0,1,13,45]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(y,k,r,C){try{const g=await new Promise((m,a)=>{G(["spdlog"],m,a)});return g.setAsyncMode(8192,500),g.createRotatingLoggerAsync(y,k,r,C)}catch(g){console.error(g)}return null}function A(y,k,r,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(y,k,r,C)}e.createRotatingLogger=A;function D(y,k,r){switch(k){case b.LogLevel.Trace:y.trace(r);break;case b.LogLevel.Debug:y.debug(r);break;case b.LogLevel.Info:y.info(r);break;case b.LogLevel.Warning:y.warn(r);break;case b.LogLevel.Error:y.error(r);break;case b.LogLevel.Critical:y.critical(r);break;default:throw new Error("Invalid log level")}}class P extends b.AbstractMessageLogger{constructor(k,r,C,g){super();this.name=k,this.filepath=r,this.rotating=C,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const k=this.rotating?6:1,r=30/k*I.ByteSize.MB;return T(this.name,this.filepath,r,k).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:g,message:m}of this.buffer)D(this._logger,g,m);this.buffer=[]}})}log(k,r){this._logger?D(this._logger,k,r):this.getLevel()<=k&&this.buffer.push({level:k,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(me[113],ge([0,1,4,156,57]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(a,h){return h-a}y.compare=k;const r=Object.create(null);r[y.Error]=(0,I.localize)(0,null),r[y.Warning]=(0,I.localize)(1,null),r[y.Info]=(0,I.localize)(2,null);function C(a){return r[a]||""}y.toString=C;function g(a){switch(a){case T.default.Error:return y.Error;case T.default.Warning:return y.Warning;case T.default.Info:return y.Info;case T.default.Ignore:return y.Hint}}y.fromSeverity=g;function m(a){switch(a){case y.Error:return T.default.Error;case y.Warning:return T.default.Warning;case y.Info:return T.default.Info;case y.Hint:return T.default.Ignore}}y.toSeverity=m}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(y){const k="";function r(g){return C(g,!0)}y.makeKey=r;function C(g,m){let a=[k];return g.source?a.push(g.source.replace("\xA6","\\\xA6")):a.push(k),g.code?typeof g.code=="string"?a.push(g.code.replace("\xA6","\\\xA6")):a.push(g.code.value.replace("\xA6","\\\xA6")):a.push(k),g.severity!==void 0&&g.severity!==null?a.push(D.toString(g.severity)):a.push(k),g.message&&m?a.push(g.message.replace("\xA6","\\\xA6")):a.push(k),g.startLineNumber!==void 0&&g.startLineNumber!==null?a.push(g.startLineNumber.toString()):a.push(k),g.startColumn!==void 0&&g.startColumn!==null?a.push(g.startColumn.toString()):a.push(k),g.endLineNumber!==void 0&&g.endLineNumber!==null?a.push(g.endLineNumber.toString()):a.push(k),g.endColumn!==void 0&&g.endColumn!==null?a.push(g.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}y.makeKeyOptionalMessage=C})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[186],ge([0,1,57,4,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new y,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=P;class y{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=y}),define(me[187],ge([0,1,11,9,36,25]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof I.globals.vscode!="undefined"){const P=I.globals.vscode.context.configuration();if(P)D=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const P=(0,A.dirname)(b.FileAccess.asFileUri("",G));D=G.__$__nodeRequire((0,A.joinPath)(P,"product.json").fsPath);const y=G.__$__nodeRequire((0,A.joinPath)(P,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:y.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=D});var je=this&&this.__decorate||function(G,e,b,I){var T=arguments.length,A=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,b):I,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(G,e,b,I);else for(var P=G.length-1;P>=0;P--)(D=G[P])&&(A=(T<3?D(A):T>3?D(e,b,A):D(e,b))||A);return T>3&&A&&Object.defineProperty(e,b,A),A},Be=this&&this.__param||function(G,e){return function(b,I){e(b,I,G)}};define(me[114],ge([0,1,4,21,6,19]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var D;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(C,g){super();this.deferred=new A.DeferredPromise,g.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};y=je([Be(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const g=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:m.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,12,52]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(D,P){I.ok(b.isString(D)),I.ok(b.isObject(P)),I.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new T}),define(me[115],ge([0,1,40,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[T(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new A;b.Registry.add(e.Extensions.JSONContribution,D)}),define(me[83],ge([0,1,152,3,40,12,115]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=T.Registry.as(D.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,_=!0){this.registerConfigurations([w],_)}registerConfigurations(w,_=!0){const p=[];w.forEach(c=>{p.push(...this.validateAndRegisterProperties(c,_,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(w){const _=[],p=c=>{if(c.properties)for(const f in c.properties)_.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,c.properties[f]);c.allOf&&c.allOf.forEach(f=>p(f))};for(const c of w){p(c);const f=this.configurationContributors.indexOf(c);f!==-1&&this.configurationContributors.splice(f,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(w){const _=[],p=[];for(const c of w)for(const f in c)if(_.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),c[f]);const t={type:"object",default:this.defaultValues[f],description:b.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};p.push(C(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=c[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(w){const _=[];for(const p of w)for(const c in p)if(_.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const f=this.configurationProperties[c];f&&(this.updatePropertyDefaultValue(c,f),this.updateSchema(c,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const _ of w)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,_=!0,p,c=3){var f;c=A.isUndefinedOrNull(w.scope)?c:w.scope;let t=[],n=w.properties;if(n)for(let i in n){if(_&&a(i)){delete n[i];continue}const l=n[i];if(this.updatePropertyDefaultValue(i,l),e.OVERRIDE_PROPERTY_PATTERN.test(i)?l.scope=void 0:(l.scope=A.isUndefinedOrNull(l.scope)?c:l.scope,l.requireTrust=A.isUndefinedOrNull(l.requireTrust)?!!((f=p==null?void 0:p.requireTrustForConfigurations)===null||f===void 0?void 0:f.includes(i)):l.requireTrust),n[i].hasOwnProperty("included")&&!n[i].included){this.excludedConfigurationProperties[i]=n[i],delete n[i];continue}else this.configurationProperties[i]=n[i];!n[i].deprecationMessage&&n[i].markdownDeprecationMessage&&(n[i].deprecationMessage=n[i].markdownDeprecationMessage),t.push(i)}let s=w.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,_,p,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const _=p=>{let c=p.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let f=p.allOf;f&&f.forEach(_)};_(w)}updateSchema(w,_){switch(e.allSettings.properties[w]=_,_.scope){case 1:e.applicationSettings.properties[w]=_;break;case 2:e.machineSettings.properties[w]=_;break;case 6:e.machineOverridableSettings.properties[w]=_;break;case 3:e.windowSettings.properties[w]=_;break;case 4:e.resourceSettings.properties[w]=_;break;case 5:e.resourceSettings.properties[w]=_,this.resourceLanguageSettingsSchema.properties[w]=_;break}}removeFromSchema(w,_){switch(delete e.allSettings.properties[w],_.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const _=`[${w}]`,p={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,p),e.allSettings.properties[_]=p,e.applicationSettings.properties[_]=p,e.machineSettings.properties[_]=p,e.machineOverridableSettings.properties[_]=p,e.windowSettings.properties[_]=p,e.resourceSettings.properties[_]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,_){let p=this.defaultValues[w];A.isUndefined(p)&&(p=_.default),A.isUndefined(p)&&(p=g(_.type)),_.default=p}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function C(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=C;function g(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new k;T.Registry.add(e.Extensions.Configuration,m);function a(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?b.localize(5,null,S):m.getConfigurationProperties()[S]!==void 0?b.localize(6,null,S):null:b.localize(4,null)}e.validateProperty=a;function h(){const S=[],w=m.getConfigurationProperties();for(const _ of Object.keys(w))S.push([_,w[_].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=h}),define(me[84],ge([0,1,23,12,2,40,4,83]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=y;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function C(n,s){const i=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],l=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],o=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const L=w(n.contents,R),H=w(s.contents,R);b.equals(L,H)||o.push(R)}}const u=[],E=R=>{const L={};for(const H of R)for(const ie of H.identifiers)L[f(ie)]=H;return L},d=s?E(s.overrides):{},v=n?E(n.overrides):{};if(Object.keys(d).length)for(const R of i){const L=d[R];L&&u.push([(0,P.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(v).length)for(const R of l){const L=v[R];L&&u.push([(0,P.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(d).length&&Object.keys(v).length)for(const R of o){const L=v[R],H=d[R];if(L&&H){const ie=C({contents:L.contents,keys:L.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});u.push([(0,P.overrideIdentifierFromKey)(R),[...ie.added,...ie.removed,...ie.updated]])}}return{added:i,removed:l,updated:o,overrides:u}}e.compare=C;function g(n,s){const i=[];for(const l of Object.keys(n))if(P.OVERRIDE_PROPERTY_PATTERN.test(l)){const o={};for(const u in n[l])o[u]=n[l][u];i.push({identifiers:[(0,P.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(o),contents:m(o,s)})}return i}e.toOverrides=g;function m(n,s){const i=Object.create(null);for(let l in n)a(i,l,n[l],s);return i}e.toValuesTree=m;function a(n,s,i,l){const o=s.split("."),u=o.pop();let E=n;for(let d=0;d<o.length;d++){let v=o[d],R=E[v];switch(typeof R){case"undefined":R=E[v]=Object.create(null);break;case"object":break;default:l(`Ignoring ${s} as ${o.slice(0,d+1).join(".")} is ${JSON.stringify(R)}`);return}E=R}if(typeof E=="object"&&E!==null)try{E[u]=i}catch(d){l(`Ignoring ${s} as ${o.join(".")} is ${JSON.stringify(E)}`)}else l(`Ignoring ${s} as ${o.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=a;function h(n,s){const i=s.split(".");S(n,i)}e.removeFromValueTree=h;function S(n,s){const i=s.shift();if(s.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const l=n[i];typeof l=="object"&&!Array.isArray(l)&&(S(l,s),Object.keys(l).length===0&&delete n[i])}}function w(n,s,i){function l(E,d){let v=E;for(const R of d){if(typeof v!="object"||v===null)return;v=v[R]}return v}const o=s.split("."),u=l(n,o);return typeof u=="undefined"?i:u}e.getConfigurationValue=w;function _(n,s,i){Object.keys(s).forEach(l=>{l!=="__proto__"&&(l in n?I.isObject(n[l])&&I.isObject(s[l])?_(n[l],s[l],i):i&&(n[l]=s[l]):n[l]=s[l])})}e.merge=_;function p(){const n=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=p;function c(){const n=Object.create(null),s=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let i in s){let l=s[i].default;a(n,i,l,o=>console.error(`Conflict in default settings: ${o}`))}return n}e.getDefaultValues=c;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,s,i){const l=n.inspect(s),o=n.inspect(i);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:l.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,55,24,15,12,23,2,83,84,40,6,3]),function(G,e,b,I,T,A,D,P,y,k,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const i of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[i],o=n[i];o&&(typeof l=="object"&&typeof o=="object"?(l=D.deepClone(l),this.mergeContents(l,o)):l=o),s[i]=l}return new m(s,this.keys,this.overrides)}merge(...t){const n=D.deepClone(this.contents),s=D.deepClone(this.overrides),i=[...this.keys];for(const l of t){this.mergeContents(n,l.contents);for(const o of l.overrides){const[u]=s.filter(E=>T.equals(E.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):s.push(D.deepClone(o))}for(const o of l.keys)i.indexOf(o)===-1&&i.push(o)}return new m(n,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&A.isObject(t[s])&&A.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=D.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class a extends m{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,y.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:i,overrides:l,untrusted:o}=this.doParseRaw(t,n);this._configurationModel=new m(s,i,l),this._untrustedConfigurations=o||[]}doParseContent(t){let n={},s=null,i=[],l=[],o=[];function u(d){Array.isArray(i)?i.push(d):s&&(i[s]=d)}let E={onObjectBegin:()=>{let d={};u(d),l.push(i),i=d,s=null},onObjectProperty:d=>{s=d},onObjectEnd:()=>{i=l.pop()},onArrayBegin:()=>{let d=[];u(d),l.push(i),i=d,s=null},onArrayEnd:()=>{i=l.pop()},onLiteralValue:u,onError:(d,v,R)=>{o.push({error:d,offset:v,length:R})}};if(t)try{b.visit(t,E),n=i[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return n}doParseRaw(t,n){const s=r.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,n);t=i.raw;const l=(0,k.toValuesTree)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),o=Object.keys(t),u=(0,k.toOverrides)(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:o,overrides:u,untrusted:i.untrusted}}filter(t,n,s,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.isUntrusted))return{raw:t,untrusted:[]};const l={},o=[];for(let u in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(u)&&s){const E=this.filter(t[u],n,!1,i);l[u]=E.raw,o.push(...E.untrusted)}else{const E=n[u],d=E?typeof E.scope!="undefined"?E.scope:3:void 0;(d===void 0||i.scopes===void 0||i.scopes.includes(d))&&(i.isUntrusted&&(E==null?void 0:E.requireTrust)?o.push(u):l[u]=t[u])}return{raw:l,untrusted:o}}}e.ConfigurationModelParser=h;class S extends C.Disposable{constructor(t,n,s,i){super();this.userSettingsResource=t,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=S;class w{constructor(t,n,s=new m,i=new m,l=new I.ResourceMap,o=new m,u=new I.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=l,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new m,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(t):i.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const i=this.getConsolidateConfigurationModel(n,s),l=this.getFolderConfigurationModelForResource(n.resource,s),o=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,u=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),d=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,H=n.overrideIdentifier?o.override(n.overrideIdentifier).getValue(t):o.getValue(t),ie=i.getValue(t),j=T.distinct(T.flatten(i.overrides.map(B=>B.identifiers))).filter(B=>i.getOverrideValue(t,B)!==void 0);return{defaultValue:u,userValue:E,userLocalValue:d,userRemoteValue:v,workspaceValue:R,workspaceFolderValue:L,memoryValue:H,value:ie,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:n.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:o.getValue(t),override:n.overrideIdentifier?o.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(i=>y.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const l=(0,y.overrideIdentifierFromKey)(i),o=this._defaultConfiguration.getKeysForOverrideIdentifier(l),u=t.getKeysForOverrideIdentifier(l),E=[...u.filter(d=>o.indexOf(d)===-1),...o.filter(d=>u.indexOf(d)===-1),...o.filter(d=>!D.equals(this._defaultConfiguration.override(l).getValue(d),t.override(l).getValue(d)))];return[l,E]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:i,overrides:l}=(0,k.compare)(this.localUserConfiguration,t),o=[...n,...s,...i];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:i,overrides:l}=(0,k.compare)(this.remoteUserConfiguration,t);let o=[...n,...s,...i];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:i,overrides:l}=(0,k.compare)(this.workspaceConfiguration,t);let o=[...n,...s,...i];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:i,updated:l,removed:o,overrides:u}=(0,k.compare)(s,n);let E=[...i,...l,...o];return(E.length||!s)&&this.updateFolderConfiguration(t,n),{keys:E,overrides:u}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:l,overrides:o}=(0,k.compare)(n,void 0);return{keys:[...s,...i,...l],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const i=n.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const l=this._memoryConfigurationByResource.get(t);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(n=s.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:i,keys:l}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:i,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((o,u)=>(o.set(P.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new I.ResourceMap);return new w(n,s,new m,i,l,new m,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function _(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const i of f)i.keys.forEach(l=>t.add(l)),i.overrides.forEach(([l,o])=>{const u=(0,I.getOrSet)(n,l,new Set);o.forEach(E=>u.add(E))});const s=[];return n.forEach((i,l)=>s.push([l,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=_;class p{constructor(t,n,s,i){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(u=>l.add(u)),t.overrides.forEach(([,u])=>u.forEach(E=>l.add(E))),this.affectedKeys=[...l.values()];const o=new m;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,l=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!D.equals(i,l)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=p;class c extends p{constructor(t,n,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=c}),define(me[85],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var I;(function(D){D[D.Unknown=0]="Unknown",D[D.DisableTrust=1]="DisableTrust",D[D.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var T;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(P,y=T.Unknown,k){super(P);this._message=P,this._code=y,this._detail=k,this.isHandled=y===T.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===T.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===T.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}}e.RemoteAuthorityResolverError=A}),define(me[116],ge([0,1,11]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(y){return y.scheme===b.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=I;function T(y){if(!!y){const k=y.indexOf("+");return k<0?y:y.substr(0,k)}}e.getRemoteName=T;function A(y){return y.scheme!==b.Schemas.file&&y.scheme!==b.Schemas.vscodeRemote}function D(y){if(y.folders.length)return y.folders.every(k=>A(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&A(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=D;function P(y){var k;return(k=D(y))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=P}),define(me[189],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((T,A)=>G(["vsda"],T,A))}async sign(T){try{const A=await this.vsda(),D=new A.signer;if(D)return D.sign(T)}catch(A){}return T}}e.SignService=b}),define(me[190],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,A,D=5){let P;return P=A(y=>{const k=typeof y=="string"?y:y.data;let r=this._terminalBufferMap.get(T);if(r){r.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(T),D);r={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),P.dispose()}},this._terminalBufferMap.set(T,r)}),P}stopBuffering(T){const A=this._terminalBufferMap.get(T);A&&A.dispose()}flushBuffer(T){const A=this._terminalBufferMap.get(T);A&&(this._terminalBufferMap.delete(T),this._callback(T,A.data.join("")))}}e.TerminalDataBufferer=b}),define(me[191],ge([0,1,48,8,36,26,12,23,9]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function k(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=k;async function r(C,g,m,a=T.env,h=A.exists){if(I.isAbsolute(C))return await h(C)?C:void 0;if(g===void 0&&(g=T.cwd()),I.dirname(C)!=="."){const p=I.join(g,C);return await h(p)?p:void 0}const w=(0,P.getCaseInsensitive)(a,"PATH");if(m===void 0&&(0,D.isString)(w)&&(m=w.split(I.delimiter)),m===void 0||m.length===0){const p=I.join(g,C);return await h(p)?p:void 0}for(let p of m){let c;if(I.isAbsolute(p)?c=I.join(p,C):c=I.join(g,p,C),await h(c))return c;if(y.isWindows){let f=c+".com";if(await h(f)||(f=c+".exe",await h(f)))return f}}const _=I.join(g,C);return await h(_)?_:void 0}e.findExecutable=r}),define(me[192],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[193],ge([0,1,4,6,40,3,192,43]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var y;(function(S){function w(_){return _&&typeof _=="object"&&typeof _.id=="string"}S.isThemeColor=w})(y=e.ThemeColor||(e.ThemeColor={}));function k(S){return{id:S}}e.themeColorFromId=k;var r;(function(S){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=w;const _=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function p(t){const n=_.exec(t);if(!!n){let[,s]=n;return{id:s}}}S.fromString=p;function c(t,n){let s=t.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}S.modify=c;function f(t,n){var s,i;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((i=n.color)===null||i===void 0?void 0:i.id)}S.isEqual=f,S.asClassNameArray=P.CSSIcon.asClassNameArray,S.asClassName=P.CSSIcon.asClassName,S.asCSSSelector=P.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function C(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(w);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new g;T.Registry.add(e.Extensions.ThemingContribution,m);function a(S){return m.onColorThemeChange(S)}e.registerThemingParticipant=a;class h extends I.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,_){let p=this.theme.getColor(w);return p&&_&&(p=_(p,this.theme)),p?p.toString():null}}e.Themable=h}),define(me[194],ge([0,1,40,193,3,157,115,19,43]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,_,p,c){const f=this.iconsById[w];if(f){if(p&&!f.description){f.description=p,this.iconSchema.properties[w].markdownDescription=`${p} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=p),this._onDidChange.fire()}return f}let t={id:w,description:p,defaults:_,deprecationMessage:c};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),p&&(n.markdownDescription=`${p}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const _=this.iconReferenceSchema.enum.indexOf(w);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,_){const p=this.iconFontsById[w];if(p)return p;let c={id:w,definition:_};return this.iconFontsById[w]=c,this._onDidChange.fire(),c}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(f,t)=>f.id.localeCompare(t.id),_=f=>{for(;I.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of c.filter(t=>!!t.description).sort(w))p.push(`|<i class="${_(f)}"></i>|${f.id}|${I.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const f of c.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(w))p.push(`|<i class="${_(f)}"></i>|${f.id}|`);return p.join(`
`)}}const r=new k;b.Registry.add(e.Extensions.IconContribution,r);function C(S,w,_,p){return r.registerIcon(S,w,_,p)}e.registerIcon=C;function g(){return r}e.getIconRegistry=g;function m(){for(const S of y.iconRegistry.all)r.registerIcon(S.id,S.definition,S.description);y.iconRegistry.onDidRegister(S=>r.registerIcon(S.id,S.definition,S.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let a=b.Registry.as(D.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,r.getIconSchema());const h=new P.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=C("widget-close",y.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",y.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",y.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(me[60],ge([0,1,2,25,4,24]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var D;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function P(g){const m=g;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=P;function y(g){const m=g;return!!(m&&typeof m=="object"&&b.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class k{constructor(m,a,h,S){this._id=m,this._configuration=h,this._ignorePathCasing=S,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class r{constructor(m,a){this.raw=a,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,I.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function C(g){return new r({uri:g,index:0,name:(0,I.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=C}),define(me[117],ge([0,1,4,158,60,2,9,8,25,133,55,11,76,30,116]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?(0,P.extname)($):(0,y.extname)($))===h}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function _($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=_;function p($){return $.hasOwnProperty("fileUri")}e.isRecentFile=p;function c($){const N=$;return typeof(N==null?void 0:N.id)=="string"&&A.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=c;function f($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=f;function t($){const N=$;return typeof(N==null?void 0:N.id)=="string"&&A.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=t;function n($){const N=$;if(N==null?void 0:N.uri)return{id:N.id,uri:A.URI.revive(N.uri)};const M=$;if(M==null?void 0:M.configPath)return{id:M.id,configPath:A.URI.revive(M.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function s($,N){return y.extUriBiasedIgnorePathCase.isEqualOrParent($,N.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function i($){return l($)||o($)}e.isStoredWorkspaceFolder=i;function l($){const N=$;return typeof(N==null?void 0:N.path)=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=l;function o($){const N=$;return typeof(N==null?void 0:N.uri)=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=o;function u($,N,M,F,U=!D.isWindows,O){if($.scheme!==F.scheme)return{name:M,uri:$.toString(!0)};let W=N?void 0:O.relativePath(F,$);if(W!==void 0)W.length===0?W=".":D.isWindows&&$.scheme===C.Schemas.file&&!U&&(W=W.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)W=$.fsPath,D.isWindows&&(W=(0,g.normalizeDriveLetter)(W),U&&(W=(0,m.toSlashes)(W)));else{if(!O.isEqualAuthority($.authority,F.authority))return{name:M,uri:$.toString(!0)};W=$.path}return{name:M,path:W}}e.getStoredWorkspaceFolder=u;function E($,N,M){let F=[],U=new Set;const O=M.dirname(N);for(let W of $){let q=null;if(l(W))W.path&&(q=M.resolvePath(O,W.path));else if(o(W))try{q=A.URI.parse(W.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=M.getComparisonKey(q);if(!U.has(Q)){U.add(Q);const he=W.name||M.basenameOrAuthority(q);F.push(new T.WorkspaceFolder({uri:q,name:he,index:F.length},W))}}}return F}e.toWorkspaceFolders=E;function d($,N,M,F,U){let O=v(N,$);const W=U.dirname(N),q=U.dirname(F),Q=[],he=R(O.folders);for(const Le of O.folders){const V=l(Le)?U.resolvePath(W,Le.path):A.URI.parse(Le.uri);let J;M?J=!1:J=!l(Le)||(0,P.isAbsolute)(Le.path),Q.push(u(V,J,Le.name,q,he,U))}const ve={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Pe=k.setProperty($,["folders"],Q,ve);let ke=k.applyEdits($,Pe);return O.remoteAuthority===(0,a.getRemoteAuthority)(F)&&(ke=k.applyEdits(ke,k.removeProperty(ke,["remoteAuthority"],ve))),ke}e.rewriteWorkspaceFileForNewLocation=d;function v($,N){let M=r.parse(N);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(F=>i(F));else throw new Error(`${$} looks like an invalid workspace file.`);return M}function R($){return D.isWindows?$.some(N=>l(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function L($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function H($){return typeof $.folderUri=="string"}function ie($){return typeof $.fileUri=="string"}function j($,N){const M={workspaces:[],files:[]};if($){const F=function(O,W){for(let q=0;q<O.length;q++)try{W(O[q],q)}catch(Q){N.warn(`Error restoring recent entry ${JSON.stringify(O[q])}: ${Q.toString()}. Skip entry.`)}},U=$;if(Array.isArray(U.entries))F(U.entries,O=>{const W=O.label,q=O.remoteAuthority;L(O)?M.workspaces.push({label:W,remoteAuthority:q,workspace:{id:O.workspace.id,configPath:A.URI.parse(O.workspace.configPath)}}):H(O)?M.workspaces.push({label:W,remoteAuthority:q,folderUri:A.URI.parse(O.folderUri)}):ie(O)&&M.files.push({label:W,remoteAuthority:q,fileUri:A.URI.parse(O.fileUri)})});else{const O=$;Array.isArray(O.workspaces3)&&F(O.workspaces3,(W,q)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[q]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?M.workspaces.push({label:Q,workspace:{id:W.id,configPath:A.URI.parse(W.configURIPath)}}):typeof W=="string"&&M.workspaces.push({label:Q,folderUri:A.URI.parse(W)})}),Array.isArray(O.files2)&&F(O.files2,(W,q)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[q]||void 0;typeof W=="string"&&M.files.push({label:Q,fileUri:A.URI.parse(W)})})}}return M}e.restoreRecentlyOpened=j;function B($){const N={entries:[]};for(const M of $.workspaces)_(M)?N.entries.push({folderUri:M.folderUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority}):N.entries.push({workspace:{id:M.workspace.id,configPath:M.workspace.configPath.toString()},label:M.label,remoteAuthority:M.remoteAuthority});for(const M of $.files)N.entries.push({fileUri:M.fileUri.toString(),label:M.label,remoteAuthority:M.remoteAuthority});return N}e.toStoreData=B}),define(me[86],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const A=this._idPool++;return this._data.set(A,T),this.logDebugInfo(),A}get(T,A){return this._data.has(T)?this._data.get(T)[A]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[195],ge([0,1,2,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(P=>({name:P.name,group:P.group,resource:b.URI.revive(P.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(me[61],ge([0,1,11,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,P){P===null?this._providerInfo.delete(D):this._providerInfo.set(D,P)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[196],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class b{constructor(A,D,P){this._id=A,this._shared=D,this._storage=P,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(A,D){let P=this._value[A];return typeof P=="undefined"&&(P=D),P}update(A,D){return this._value[A]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=b;class I extends b{constructor(A,D){super(A.identifier.value,!0,D);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=I}),define(me[14],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[197],ge([0,1,29,3]),function(G,e,b,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,y){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(P.identifier),tt(this,T,y,"f"),Ue(this,T,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return Ue(this,T,"f").get(this._id,P)}store(P,y){return Ue(this,T,"f").store(this._id,P,y)}delete(P){return Ue(this,T,"f").delete(this._id,P)}}e.ExtensionSecrets=A,T=new WeakMap}),define(me[118],ge([0,1,4,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(D){D[D.NewChild=0]="NewChild",D[D.Disposed=1]="Disposed",D[D.Invalidated=2]="Invalidated",D[D.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const T=new WeakMap,A=D=>{let P=T.get(D);return P||(P={children:new Map,bus:new b.Emitter},T.set(D,P)),P};e.getPrivateApiFor=A}),define(me[50],ge([0,1,4,3,14]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(P){function y(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}P.fromApiTunnel=y;function k(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}P.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,k){return{dispose:()=>{}}}async $providePortAttributes(y,k,r,C,g){return[]}async $forwardPort(y,k){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([Be(0,T.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Ht=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[7],ge([0,1,15,18,97,24,12,2,28,45,85,87]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";var g,m,a,h,S,w,_,p,c,f,t,n,s,i,l,o;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function u(z){function x(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(x,z),Object.setPrototypeOf(x.prototype,z.prototype),x}let E=a=class{constructor(x){g.set(this,void 0),tt(this,g,x,"f")}static from(...x){let se=x;return new a(function(){if(se){for(const ye of se)ye&&typeof ye.dispose=="function"&&ye.dispose();se=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,E=a=je([u],E),e.Disposable=E;let d=h=class{constructor(x,se){if(x<0)throw(0,I.illegalArgument)("line must be non-negative");if(se<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=x,this._character=se}static Min(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ye=1;ye<x.length;ye++){const Ve=x[ye];Ve.isBefore(se)&&(se=Ve)}return se}static Max(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ye=1;ye<x.length;ye++){const Ve=x[ye];Ve.isAfter(se)&&(se=Ve)}return se}static isPosition(x){if(!x)return!1;if(x instanceof h)return!0;let{line:se,character:ye}=x;return typeof se=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,se=0){if(x===null||se===null)throw(0,I.illegalArgument)();let ye;return typeof x=="undefined"?ye=0:typeof x=="number"?ye=x:(ye=typeof x.lineDelta=="number"?x.lineDelta:0,se=typeof x.characterDelta=="number"?x.characterDelta:0),ye===0&&se===0?this:new h(this.line+ye,this.character+se)}with(x,se=this.character){if(x===null||se===null)throw(0,I.illegalArgument)();let ye;return typeof x=="undefined"?ye=this.line:typeof x=="number"?ye=x:(ye=typeof x.line=="number"?x.line:this.line,se=typeof x.character=="number"?x.character:this.character),ye===this.line&&se===this.character?this:new h(ye,se)}toJSON(){return{line:this.line,character:this.character}}};d=h=je([u],d),e.Position=d;let v=S=class{constructor(x,se,ye,Ve){let Xe,ct;if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Xe=new d(x,se),ct=new d(ye,Ve)):x instanceof d&&se instanceof d&&(Xe=x,ct=se),!Xe||!ct)throw new Error("Invalid arguments");Xe.isBefore(ct)?(this._start=Xe,this._end=ct):(this._start=ct,this._end=Xe)}static isRange(x){return x instanceof S?!0:x?d.isPosition(x.start)&&d.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof S?this.contains(x._start)&&this.contains(x._end):x instanceof d?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const se=d.Max(x.start,this._start),ye=d.Min(x.end,this._end);if(!se.isAfter(ye))return new S(se,ye)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const se=d.Min(x.start,this._start),ye=d.Max(x.end,this.end);return new S(se,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,se=this.end){if(x===null||se===null)throw(0,I.illegalArgument)();let ye;return x?d.isPosition(x)?ye=x:(ye=x.start||this.start,se=x.end||this.end):ye=this.start,ye.isEqual(this._start)&&se.isEqual(this.end)?this:new S(ye,se)}toJSON(){return[this.start,this.end]}};v=S=je([u],v),e.Range=v;let R=w=class extends v{constructor(x,se,ye,Ve){let Xe,ct;if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ve=="number"?(Xe=new d(x,se),ct=new d(ye,Ve)):x instanceof d&&se instanceof d&&(Xe=x,ct=se),!Xe||!ct)throw new Error("Invalid arguments");super(Xe,ct);this._anchor=Xe,this._active=ct}static isSelection(x){return x instanceof w?!0:x?v.isRange(x)&&d.isPosition(x.anchor)&&d.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=w=je([u],R),e.Selection=R;class L{constructor(x,se,ye){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,I.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,I.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(se),this.connectionToken=ye}}e.ResolvedAuthority=L;class H extends Error{constructor(x,se=r.RemoteAuthorityResolverErrorCode.Unknown,ye){super(x);this._message=x,this._code=se,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(x,se){return new H(x,r.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(x){return new H(x,r.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var ie;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var j;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=_=class{constructor(x,se){this._range=x,this._newText=se}static isTextEdit(x){return x instanceof _?!0:x?v.isRange(x)&&typeof x.newText=="string":!1}static replace(x,se){return new _(x,se)}static insert(x,se){return _.replace(new v(x,x),se)}static delete(x){return _.replace(x,"")}static setEndOfLine(x){const se=new _(new v(new d(0,0),new d(0,0)),"");return se.newEol=x,se}get range(){return this._range}set range(x){if(x&&!v.isRange(x))throw(0,I.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,I.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,I.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=_=je([u],B),e.TextEdit=B;var $;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,se,ye,Ve){this._edits.push({_type:1,from:x,to:se,options:ye,metadata:Ve})}createFile(x,se,ye){this._edits.push({_type:1,from:void 0,to:x,options:se,metadata:ye})}deleteFile(x,se,ye){this._edits.push({_type:1,from:x,to:void 0,options:se,metadata:ye})}replaceNotebookMetadata(x,se,ye){this._edits.push({_type:3,metadata:ye,uri:x,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(x,se,ye,Ve,Xe){(se!==ye||Ve.length>0)&&this._edits.push({_type:5,uri:x,index:se,count:ye-se,cells:Ve,metadata:Xe})}replaceNotebookCellOutput(x,se,ye,Ve){this._editNotebookCellOutput(x,se,!1,ye,Ve)}appendNotebookCellOutput(x,se,ye,Ve){this._editNotebookCellOutput(x,se,!0,ye,Ve)}replaceNotebookCellOutputItems(x,se,ye,Ve,Xe){this._editNotebookCellOutputItems(x,se,ye,!1,Ve,Xe)}appendNotebookCellOutputItems(x,se,ye,Ve,Xe){this._editNotebookCellOutputItems(x,se,ye,!0,Ve,Xe)}_editNotebookCellOutputItems(x,se,ye,Ve,Xe,ct){this._edits.push({_type:6,metadata:ct,uri:x,index:se,outputId:ye,append:Ve,newOutputItems:Xe})}_editNotebookCellOutput(x,se,ye,Ve,Xe){this._edits.push({_type:4,metadata:Xe,uri:x,index:se,append:ye,newOutputs:Ve,newMetadata:void 0})}replaceNotebookCellMetadata(x,se,ye,Ve){this._edits.push({_type:3,metadata:Ve,uri:x,edit:{editType:11,index:se,metadata:ye}})}replace(x,se,ye,Ve){this._edits.push({_type:2,uri:x,edit:new B(se,ye),metadata:Ve})}insert(x,se,ye,Ve){this.replace(x,new v(se,se),ye,Ve)}delete(x,se,ye){this.replace(x,se,"",ye)}has(x){return this._edits.some(se=>se._type===2&&se.uri.toString()===x.toString())}set(x,se){if(se)for(const ye of se)ye&&this._edits.push({_type:2,uri:x,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const Ve=this._edits[ye];Ve._type===2&&Ve.uri.toString()===x.toString()&&(this._edits[ye]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(x){const se=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===x.toString()&&se.push(ye.edit);return se}entries(){const x=new A.ResourceMap;for(let se of this._edits)if(se._type===2){let ye=x.get(se.uri);ye||(ye=[se.uri,[]],x.set(se.uri,ye)),ye[1].push(se.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=je([u],N),e.WorkspaceEdit=N;let M=p=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof p?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=p._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,se=this._tabstop++){if(typeof x=="function"){const ye=new p;ye._tabstop=this._tabstop,x(ye),this._tabstop=ye._tabstop,x=ye.value}else x=p._escape(x);return this.value+="${",this.value+=se,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,se=this._tabstop++){const ye=x.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(x,se){if(typeof se=="function"){const ye=new p;ye._tabstop=this._tabstop,se(ye),this._tabstop=ye._tabstop,se=ye.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=p=je([u],M),e.SnippetString=M;var F;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(F=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let O=c=class{constructor(x,se){if(this.uri=x,se)if(se instanceof v)this.range=se;else if(se instanceof d)this.range=new v(se,se);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof c?!0:x?v.isRange(x.range)&&P.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};O=c=je([u],O),e.Location=O;let W=class{constructor(x,se){this.location=x,this.message=se}static is(x){return x?typeof x.message=="string"&&x.location&&v.isRange(x.location.range)&&P.URI.isUri(x.location.uri):!1}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.location.range.isEqual(se.location.range)&&x.location.uri.toString()===se.location.uri.toString()}};W=je([u],W),e.DiagnosticRelatedInformation=W;let q=class{constructor(x,se,ye=U.Error){if(!v.isRange(x))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=x,this.message=se,this.severity=ye}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.severity===se.severity&&x.code===se.code&&x.severity===se.severity&&x.source===se.source&&x.range.isEqual(se.range)&&(0,b.equals)(x.tags,se.tags)&&(0,b.equals)(x.relatedInformation,se.relatedInformation,W.isEqual)}};q=je([u],q),e.Diagnostic=q;let Q=class{constructor(x,se){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,T.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=se}};Q=je([u],Q),e.Hover=Q;var he;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(he=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ve=class{constructor(x,se=he.Text){this.range=x,this.kind=se}toJSON(){return{range:this.range,kind:he[this.kind]}}};ve=je([u],ve),e.DocumentHighlight=ve;var Pe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Pe=e.SymbolKind||(e.SymbolKind={}));var ke;(function(z){z[z.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Le=f=class{constructor(x,se,ye,Ve,Xe){this.name=x,this.kind=se,this.containerName=Xe,typeof ye=="string"&&(this.containerName=ye),Ve instanceof O?this.location=Ve:ye instanceof v&&(this.location=new O(Ve,ye)),f.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Pe[this.kind],location:this.location,containerName:this.containerName}}};Le=f=je([u],Le),e.SymbolInformation=Le;let V=t=class{constructor(x,se,ye,Ve,Xe){this.name=x,this.detail=se,this.kind=ye,this.range=Ve,this.selectionRange=Xe,this.children=[],t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(t.validate)}};V=t=je([u],V),e.DocumentSymbol=V;var J;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor(x,se){this.title=x,this.kind=se}};ee=je([u],ee),e.CodeAction=ee;let ae=n=class{constructor(x){this.value=x}append(x){return new n(this.value?this.value+n.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+n.sep)}};ae.sep=".",ae=n=je([u],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let we=class{constructor(x,se){if(this.range=x,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=je([u],we),e.SelectionRange=we;class Ce{constructor(x,se,ye,Ve,Xe,ct){this.kind=x,this.name=se,this.detail=ye,this.uri=Ve,this.range=Xe,this.selectionRange=ct}}e.CallHierarchyItem=Ce;class Oe{constructor(x,se){this.fromRanges=se,this.from=x}}e.CallHierarchyIncomingCall=Oe;class be{constructor(x,se){this.fromRanges=se,this.to=x}}e.CallHierarchyOutgoingCall=be;let Ie=class{constructor(x,se){this.range=x,this.command=se}get isResolved(){return!!this.command}};Ie=je([u],Ie),e.CodeLens=Ie;let Re=s=class{constructor(x,se=!1){m.set(this,void 0),tt(this,m,new T.MarkdownString(x,{supportThemeIcons:se}),"f")}static isMarkdownString(x){return x instanceof s?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Ue(this,m,"f").value}set value(x){Ue(this,m,"f").value=x}get isTrusted(){return Ue(this,m,"f").isTrusted}set isTrusted(x){Ue(this,m,"f").isTrusted=x}get supportThemeIcons(){return Ue(this,m,"f").supportThemeIcons}appendText(x){return Ue(this,m,"f").appendText(x),this}appendMarkdown(x){return Ue(this,m,"f").appendMarkdown(x),this}appendCodeblock(x,se){return Ue(this,m,"f").appendCodeblock(se!=null?se:"",x),this}};m=new WeakMap,Re=s=je([u],Re),e.MarkdownString=Re;let We=class{constructor(x,se){this.label=x,this.documentation=se}};We=je([u],We),e.ParameterInformation=We;let Ee=class{constructor(x,se){this.label=x,this.documentation=se,this.parameters=[]}};Ee=je([u],Ee),e.SignatureInformation=Ee;let Ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ke=je([u],Ke),e.SignatureHelp=Ke;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var re;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(re=e.InlineHintKind||(e.InlineHintKind={}));let _e=class{constructor(x,se,ye){this.text=x,this.range=se,this.kind=ye}};_e=je([u],_e),e.InlineHint=_e;var xe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var $e;(function(z){z[z.Deprecated=1]="Deprecated"})($e=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(x,se){this.label=x,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=je([u],Ye),e.CompletionItem=Ye;let K=class{constructor(x=[],se=!1){this.items=x,this.isIncomplete=se}};K=je([u],K),e.CompletionList=K;var oe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(oe=e.ViewColumn||(e.ViewColumn={}));var fe;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(fe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Z;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(ne=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pe;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Se;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Se=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function x(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=x}(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let qe=class{constructor(x,se){if(se&&!P.URI.isUri(se))throw(0,I.illegalArgument)("target");if(!v.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.target=se}};qe=je([u],qe),e.DocumentLink=qe;let Me=class{constructor(x,se,ye,Ve){this.red=x,this.green=se,this.blue=ye,this.alpha=Ve}};Me=je([u],Me),e.Color=Me;let He=class{constructor(x,se){if(se&&!(se instanceof Me))throw(0,I.illegalArgument)("color");if(!v.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.color=se}};He=je([u],He),e.ColorInformation=He;let Qe=class{constructor(x){if(!x||typeof x!="string")throw(0,I.illegalArgument)("label");this.label=x}};Qe=je([u],Qe),e.ColorPresentation=Qe;var it;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(it=e.ColorFormat||(e.ColorFormat={}));var at;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ze;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var nt;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(nt=e.TaskPanelKind||(e.TaskPanelKind={}));let dt=i=class{constructor(x,se){if(typeof x!="string"||typeof se!="string")throw(0,I.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return i.Clean;case"build":return i.Build;case"rebuild":return i.Rebuild;case"test":return i.Test;default:return}}get id(){return this._id}};dt.Clean=new i("clean","Clean"),dt.Build=new i("build","Build"),dt.Rebuild=new i("rebuild","Rebuild"),dt.Test=new i("test","Test"),dt=i=je([u],dt),e.TaskGroup=dt;function _t(z){let x="";for(let se=0;se<z.length;se++)x+=z[se].replace(/,/g,",,")+",";return x}let ue=class{constructor(x,se,ye){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=x,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ye):this._options=se)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let se of this._args)x.push(se);return _t(x)}};ue=je([u],ue),e.ProcessExecution=ue;let De=class{constructor(x,se,ye){if(this._args=[],Array.isArray(se)){if(!x)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x,this._args=se,this._options=ye}else{if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x,this._options=se}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)x.push(typeof se=="string"?se:se.value);return _t(x)}};De=je([u],De),e.ShellExecution=De;var le;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(le=e.ShellQuoting||(e.ShellQuoting={}));var Y;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Y=e.TaskScope||(e.TaskScope={}));class Ne{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Ne;let Te=l=class{constructor(x,se,ye,Ve,Xe,ct){this.__deprecated=!1,this._definition=this.definition=x;let gt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ye,this.execution=Ve,gt=Xe,this.__deprecated=!0):se===Y.Global||se===Y.Workspace?(this.target=se,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Xe,gt=ct):(this.target=se,this._name=this.name=ye,this._source=this.source=Ve,this.execution=Xe,gt=ct),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof De?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof Ne?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const se=this._definition.type;(l.EmptyType===se||l.ProcessType===se||l.ShellType===se||l.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Te.ExtensionCallbackType="customExecution",Te.ProcessType="process",Te.ShellType="shell",Te.EmptyType="$empty",Te=l=je([u],Te),e.Task=Te;var Je;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Je=e.ProgressLocation||(e.ProgressLocation={}));let et=class{constructor(x,se=ut.None){this.collapsibleState=se,P.URI.isUri(x)?this.resourceUri=x:this.label=x}};et=je([u],et),e.TreeItem=et;var ut;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(x,se){this.id=x,this.color=se}};rt=je([u],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let Ge=class{constructor(x){this.id=x}};Ge=je([u],Ge),e.ThemeColor=Ge;var ht;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ot=class{constructor(x,se){if(typeof x!="string"&&(!x||!P.URI.isUri(x)&&!P.URI.isUri(x.uri)))throw(0,I.illegalArgument)("base");if(typeof se!="string")throw(0,I.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=P.URI.file(x),this.base=x):P.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=se}};ot=je([u],ot),e.RelativePattern=ot;let vt=class{constructor(x,se,ye,Ve){this.enabled=typeof x=="boolean"?x:!0,typeof se=="string"&&(this.condition=se),typeof ye=="string"&&(this.hitCondition=ye),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([u],vt),e.Breakpoint=vt;let pt=class extends vt{constructor(x,se,ye,Ve,Xe){super(se,ye,Ve,Xe);if(x===null)throw(0,I.illegalArgument)("location");this.location=x}};pt=je([u],pt),e.SourceBreakpoint=pt;let Et=class extends vt{constructor(x,se,ye,Ve,Xe){super(se,ye,Ve,Xe);this.functionName=x}};Et=je([u],Et),e.FunctionBreakpoint=Et;let yt=class extends vt{constructor(x,se,ye,Ve,Xe,ct,gt){super(Ve,Xe,ct,gt);if(!se)throw(0,I.illegalArgument)("dataId");this.label=x,this.dataId=se,this.canPersist=ye}};yt=je([u],yt),e.DataBreakpoint=yt;let Pt=class{constructor(x,se,ye){this.command=x,this.args=se||[],this.options=ye}};Pt=je([u],Pt),e.DebugAdapterExecutable=Pt;let bt=class{constructor(x,se){this.port=x,this.host=se}};bt=je([u],bt),e.DebugAdapterServer=bt;let At=class{constructor(x){this.path=x}};At=je([u],At),e.DebugAdapterNamedPipeServer=At;let Qt=class{constructor(x){this.implementation=x}};Qt=je([u],Qt),e.DebugAdapterInlineImplementation=Qt;let ft=class{constructor(x,se){this.range=x,this.expression=se}};ft=je([u],ft),e.EvaluatableExpression=ft;let Xt=class{constructor(x,se){this.range=x,this.text=se}};Xt=je([u],Xt),e.InlineValueText=Xt;let St=class{constructor(x,se,ye=!0){this.range=x,this.variableName=se,this.caseSensitiveLookup=ye}};St=je([u],St),e.InlineValueVariableLookup=St;let zt=class{constructor(x,se){this.range=x,this.expression=se}};zt=je([u],zt),e.InlineValueEvaluatableExpression=zt;let Yt=class{constructor(x,se){this.frameId=x,this.stoppedLocation=se}};Yt=je([u],Yt),e.InlineValueContext=Yt;var Vt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let lt=o=class extends Error{constructor(x,se=k.FileSystemProviderErrorCode.Unknown,ye){var Ve;super(P.URI.isUri(x)?x.toString(!0):x);this.code=(Ve=ye==null?void 0:ye.name)!==null&&Ve!==void 0?Ve:"Unknown",(0,k.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,o.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(x){return new o(x,k.FileSystemProviderErrorCode.FileExists,o.FileExists)}static FileNotFound(x){return new o(x,k.FileSystemProviderErrorCode.FileNotFound,o.FileNotFound)}static FileNotADirectory(x){return new o(x,k.FileSystemProviderErrorCode.FileNotADirectory,o.FileNotADirectory)}static FileIsADirectory(x){return new o(x,k.FileSystemProviderErrorCode.FileIsADirectory,o.FileIsADirectory)}static NoPermissions(x){return new o(x,k.FileSystemProviderErrorCode.NoPermissions,o.NoPermissions)}static Unavailable(x){return new o(x,k.FileSystemProviderErrorCode.Unavailable,o.Unavailable)}};lt=o=je([u],lt),e.FileSystemError=lt;let Jt=class{constructor(x,se,ye){this.start=x,this.end=se,this.kind=ye}};Jt=je([u],Jt),e.FoldingRange=Jt;var Tt;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Nt;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Nt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var fn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(fn=e.CommentMode||(e.CommentMode={}));class _n{constructor(x,se=[]){this.tokenTypes=x,this.tokenModifiers=se}}e.SemanticTokensLegend=_n;function mn(z){return typeof z=="undefined"||(0,D.isStringArray)(z)}class Zt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let se=0,ye=x.tokenTypes.length;se<ye;se++)this._tokenTypeStrToInt.set(x.tokenTypes[se],se);for(let se=0,ye=x.tokenModifiers.length;se<ye;se++)this._tokenModifierStrToInt.set(x.tokenModifiers[se],se)}}push(x,se,ye,Ve,Xe){if(typeof x=="number"&&typeof se=="number"&&typeof ye=="number"&&typeof Ve=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(x,se,ye,Ve,Xe);if(v.isRange(x)&&typeof se=="string"&&mn(ye))return this._push(x,se,ye);throw(0,I.illegalArgument)()}_push(x,se,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ve=x.start.line,Xe=x.start.character,ct=x.end.character-x.start.character,gt=this._tokenTypeStrToInt.get(se);let Dt=0;if(ye)for(const Ct of ye){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Ct);Dt|=1<<kt>>>0}this._pushEncoded(Ve,Xe,ct,gt,Dt)}_pushEncoded(x,se,ye,Ve,Xe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Ct=0,kt=0;for(let It=0;It<Dt;It++){let Lt=this._data[5*It],un=this._data[5*It+1];Lt===0?(Lt=Ct,un+=kt):Lt+=Ct,this._data[5*It]=Lt,this._data[5*It+1]=un,Ct=Lt,kt=un}}let ct=x,gt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Xe,this._prevLine=x,this._prevChar=se}static _sortAndDeltaEncode(x){let se=[];const ye=x.length/5|0;for(let gt=0;gt<ye;gt++)se[gt]=gt;se.sort((gt,Dt)=>{const Ct=x[5*gt],kt=x[5*Dt];if(Ct===kt){const It=x[5*gt+1],Lt=x[5*Dt+1];return It-Lt}return Ct-kt});const Ve=new Uint32Array(x.length);let Xe=0,ct=0;for(let gt=0;gt<ye;gt++){const Dt=5*se[gt],Ct=x[Dt+0],kt=x[Dt+1],It=x[Dt+2],Lt=x[Dt+3],un=x[Dt+4],Ln=Ct-Xe,Un=Ln===0?kt-ct:kt,dn=5*gt;Ve[dn+0]=Ln,Ve[dn+1]=Un,Ve[dn+2]=It,Ve[dn+3]=Lt,Ve[dn+4]=un,Xe=Ct,ct=kt}return Ve}build(x){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),x):new jt(Zt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Zt;class jt{constructor(x,se){this.resultId=se,this.data=x}}e.SemanticTokens=jt;class Mt{constructor(x,se,ye){this.start=x,this.deleteCount=se,this.data=ye}}e.SemanticTokensEdit=Mt;class En{constructor(x,se){this.resultId=se,this.edits=x}}e.SemanticTokensEdits=En;var en;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(en=e.DebugConsoleMode||(e.DebugConsoleMode={}));var tn;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(tn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let qt=class{constructor(){}};qt.Back={iconPath:new rt("arrow-left")},qt=je([u],qt),e.QuickInputButtons=qt;var Sn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Sn=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(x,se,ye){this.badge=x,this.tooltip=se,this.color=ye}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let nn=class{constructor(x){this.kind=x}};nn=je([u],nn),e.ColorTheme=nn;var yn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(yn=e.ColorThemeKind||(e.ColorThemeKind={}));class rn{constructor(x,se){if(x<0)throw(0,I.illegalArgument)("start must be positive");if(se<0)throw(0,I.illegalArgument)("end must be positive");x<=se?(this._start=x,this._end=se):(this._start=se,this._end=x)}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let se=this._start,ye=this._end;return x.start!==void 0&&(se=x.start),x.end!==void 0&&(ye=x.end),se===this._start&&ye===this._end?this:new rn(se,ye)}}e.NotebookRange=rn;class sn{constructor(x,se){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=se)}with(x){let{inputCollapsed:se,outputCollapsed:ye,custom:Ve}=x,Xe=Ht(x,["inputCollapsed","outputCollapsed","custom"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),Ve===void 0?Ve=this.custom:Ve===null&&(Ve=void 0),se===this.inputCollapsed&&ye===this.outputCollapsed&&Ve===this.custom&&Object.keys(Xe).length===0?this:new sn(Object.assign({inputCollapsed:se,outputCollapsed:ye,custom:Ve},Xe))}}e.NotebookCellMetadata=sn;class Ot{constructor(x=!0,se={}){var ye,Ve;typeof x=="object"?(Object.assign(this,x),this.trusted=(ye=x.trusted)!==null&&ye!==void 0?ye:!0,this.custom=(Ve=x.custom)!==null&&Ve!==void 0?Ve:{}):(this.trusted=x,this.custom=se)}with(x){let{custom:se,trusted:ye}=x,Ve=Ht(x,["custom","trusted"]);return se===void 0?se=this.custom:se===null&&(se=void 0),ye===void 0?ye=this.trusted:ye===null&&(ye=void 0),se===this.custom&&ye===this.trusted&&Object.keys(Ve).length===0?this:new Ot(Object.assign({trusted:ye,custom:se},Ve))}}e.NotebookDocumentMetadata=Ot;class gn{constructor(x,se,ye,Ve,Xe,ct){this.kind=x,this.source=se,this.language=ye,this.outputs=Ve!=null?Ve:[],this.metadata=Xe,this.latestExecutionSummary=ct}}e.NotebookCellData=gn;class pn{constructor(x,se){this.cells=x,this.metadata=se!=null?se:new Ot}}e.NotebookData=pn;class Ut{constructor(x,se,ye){this.mime=x,this.value=se,this.metadata=ye}static isNotebookCellOutputItem(x){return x instanceof Ut}}e.NotebookCellOutputItem=Ut;class Fe{constructor(x,se,ye){this.outputs=x,typeof se=="string"?(this.id=se,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=se!=null?se:ye)}}e.NotebookCellOutput=Fe;var on;(function(z){z[z.Markdown=1]="Markdown",z[z.Code=2]="Code"})(on=e.NotebookCellKind||(e.NotebookCellKind={}));var an;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(an=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(mt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(x,se,ye,Ve,Xe,ct){this.text=x,this.alignment=se,this.command=ye,this.tooltip=Ve,this.priority=Xe,this.accessibilityInformation=ct}}e.NotebookCellStatusBarItem=Cn;let Kt=class{constructor(x,se){this.label=x,this.timestamp=se}};Kt=je([u],Kt),e.TimelineItem=Kt;var vn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var In;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(In=e.StandardTokenType||(e.StandardTokenType={}));class Pn{constructor(x,se){this.ranges=x,this.wordPattern=se}}e.LinkedEditingRanges=Pn;var An;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var ln;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={}));var wn;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(wn=e.TestItemStatus||(e.TestItemStatus={}));const xt=(z,x,se,ye)=>{let Ve=se;return{enumerable:!0,configurable:!1,get(){return Ve},set(Xe){ye(Ve,Xe)||(Ve=Xe,z.bus.fire([3,x,Xe]))}}},Gt=(z,x)=>z===x,Tn=(z,x)=>z===x?!0:!z||!x?!1:z.isEqual(x);class cn{constructor(x,se,ye,Ve){this.label=se,this.data=Ve;const Xe=(0,C.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Xe.parent},children:{value:new A.ReadonlyMapView(Xe.children),enumerable:!0,writable:!1},range:xt(Xe,"range",void 0,Tn),description:xt(Xe,"description",void 0,Gt),runnable:xt(Xe,"runnable",!0,Gt),debuggable:xt(Xe,"debuggable",!0,Gt),status:xt(Xe,"status",wn.Resolved,Gt)})}invalidate(){(0,C.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,C.getPrivateApiFor)(this);x.parent&&(0,C.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof cn))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=(0,C.getPrivateApiFor)(this);if(se.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);se.children.set(x.id,x),se.bus.fire([0,x])}}e.TestItemImpl=cn;class te{constructor(x){this.message=x,this.severity=ln.Error}static diff(x,se,ye){const Ve=new te(x);return Ve.expectedOutput=se,Ve.actualOutput=ye,Ve}}e.TestMessage=te;var de;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(de=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ae;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Ae=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var st;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(st=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[119],ge([0,1,52,11,10,144,108,7,15]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function r(a,h){h?k.set(a,h):k.delete(a)}e.setWordDefinitionFor=r;function C(a){return k.get(a)}e.getWordDefinitionFor=C;class g extends A.MirrorTextModel{constructor(h,S,w,_,p,c,f,t){super(S,w,_,p);this._proxy=h,this._languageId=c,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,y.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===I.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(S){return S?h._getTextInRange(S):h.getText()},get eol(){return h._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(S){return h._lineAt(S)},offsetAt(S){return h._offsetAt(S)},positionAt(S){return h._positionAt(S)},validateRange(S){return h._validateRange(S)},validatePosition(S){return h._validatePosition(S)},getWordRangeAtPosition(S,w){return h._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,b.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,b.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const S=this._validateRange(h);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,_=S.start.line,p=S.end.line,c=[];c.push(this._lines[_].substring(S.start.character));for(let f=_+1;f<p;f++)c.push(this._lines[f]);return c.push(this._lines[p].substring(0,S.end.character)),c.join(w)}_lineAt(h){let S;if(h instanceof P.Position?S=h.line:typeof h=="number"&&(S=h),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new m(S,this._lines[S],S===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(h),w=this._lines[S.index].length;return new P.Position(S.index,Math.min(S.remainder,w))}_validateRange(h){if(!(h instanceof P.Range))throw new Error("Invalid argument");const S=this._validatePosition(h.start),w=this._validatePosition(h.end);return S===h.start&&w===h.end?h:new P.Range(S.line,S.character,w.line,w.character)}_validatePosition(h){if(!(h instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:S,character:w}=h,_=!1;if(S<0)S=0,w=0,_=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,_=!0;else{const p=this._lines[S].length;w<0?(w=0,_=!0):w>p&&(w=p,_=!0)}return _?new P.Position(S,w):h}_getWordRangeAtPosition(h,S){const w=this._validatePosition(h);if(!S)S=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const _=(0,D.getWordAtText)(w.character+1,(0,D.ensureValidWordDefinition)(S),this._lines[w.line],0);if(_)return new P.Range(w.line,_.startColumn-1,w.line,_.endColumn-1)}}e.ExtHostDocumentData=g;class m{constructor(h,S,w){this._line=h,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[198],ge([0,1,7,3,110,6,77,24,2,28]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(g,m,a,h){this._notebook=a,this._selector=h,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(w=>{const _=this._cellUris.get(w.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const g=[],m=[];for(const a of this._notebook.getCells())a.kind===b.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),g.push(a.document.getText().length+1),m.push(a.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(g){var m,a;if(!g){let p="";for(const c of this._cells)p+=c.document.getText()+`
`;return p=p.slice(0,-1),p}if(g.isEmpty)return"";const h=this.locationAt(g.start),S=this.locationAt(g.end),w=this._cells[(m=this._cellUris.get(h.uri))!==null&&m!==void 0?m:-1],_=this._cells[(a=this._cellUris.get(S.uri))!==null&&a!==void 0?a:-1];if(!w||!_)return"";if(w===_)return w.document.getText(new b.Range(h.range.start,S.range.end));{const p=w.document.getText(new b.Range(h.range.start,new b.Position(w.document.lineCount,0))),c=_.document.getText(new b.Range(new b.Position(0,0),S.range.end));return p+`
`+c}}offsetAt(g){const m=this._cellLines.getIndexOf(g.line),a=this._cellLengths.getAccumulatedValue(m.index-1),h=this._cells[m.index].document.offsetAt(g.with(m.remainder));return a+h}positionAt(g){if(typeof g=="number"){const a=this._cellLengths.getIndexOf(g),h=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(h)}const m=this._cellUris.get(g.uri);if(m!==void 0){const a=this._cellLines.getAccumulatedValue(m-1);return new b.Position(a+g.range.start.line,g.range.start.character)}return new b.Position(0,0)}locationAt(g){b.Range.isRange(g)||(g=new b.Range(g,g));const m=this._cellLines.getIndexOf(g.start.line);let a=m;g.isEmpty||(a=this._cellLines.getIndexOf(g.end.line));const h=new b.Position(m.remainder,g.start.character),S=new b.Position(a.remainder,g.end.character),w=new b.Range(h,S),_=this._cells[m.index];return new b.Location(_.document.uri,_.document.validateRange(w))}contains(g){return this._cellUris.has(g)}validateRange(g){const m=this.validatePosition(g.start),a=this.validatePosition(g.end);return g.with(m,a)}validatePosition(g){const m=this._cellLines.getIndexOf(g.line),a=new b.Position(m.remainder,g.character),h=this._cells[m.index].document.validatePosition(a),S=this._cellLines.getAccumulatedValue(m.index-1);return new b.Position(S+h.line,h.character)}}e.ExtHostNotebookConcatDocument=r}),define(me[199],ge([0,1,7,14,3]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let y=P==="light"?b.ColorThemeKind.Light:P==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Be(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(me[62],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=I}),define(me[200],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function T(P,y){if(y){const k=new I,r=(m,a)=>{if(a instanceof ArrayBuffer){const h=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(a)){const h=A(a);if(h){const S=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:h,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(P,r),g=k.buffers.map(m=>{const a=new Uint8Array(m);return b.VSBuffer.wrap(a)});return{message:C,buffers:g}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=T;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(P,y){const k=y.map(g=>{const m=new ArrayBuffer(g.byteLength);return new Uint8Array(m).set(g.buffer),m}),r=y.length?(g,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const a=m,{index:h}=a,S=k[h];if(a.view)switch(a.view.type){case 1:return new Int8Array(S,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return m}:void 0;return{message:JSON.parse(P,r),arrayBuffers:k}}e.deserializeWebviewMessage=D}),define(me[63],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,D,P){const y=A.webviewResourceRoot.replace("{{resource}}",P.scheme+T(P)).replace("{{uuid}}",D);return b.URI.parse(y)}e.asWebviewUri=I;function T(A){return A.toString().replace(/^\S+?:/,"")}}),define(me[201],ge([0,1,3,6,63,28]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,k,r){this._proxy=y,this._editors=k,this._initData=r,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const C=k.getVisibleTextEditors();for(const g of this._insets.values())C.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,k,r,C,g){let m;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){m=c;break}if(!m)throw new Error("not a visible editor");const a=this,h=this._handlePool++,S=new b.Emitter,w=new b.Emitter,_=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,T.asWebviewUri)(a._initData,this._uuid,c)}get cspSource(){return a._initData.webviewCspSource}set options(c){this._options=c,a._proxy.$setOptions(h,c)}get options(){return this._options}set html(c){this._html=c,a._proxy.$setHtml(h,c)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(c){return a._proxy.$postMessage(h,c)}},p=new class{constructor(){this.editor=y,this.line=k,this.height=r,this.webview=_,this.onDidDispose=w.event}dispose(){a._insets.has(h)&&(a._insets.delete(h),a._proxy.$disposeEditorInset(h),w.fire(),w.dispose(),S.dispose())}};return this._proxy.$createEditorInset(h,m.id,m.value.document.uri,k+1,r,C||{},g.identifier,g.extensionLocation),this._insets.set(h,{editor:y,inset:p,onDidReceiveMessage:S}),p}$onDidDispose(y){const k=this._insets.get(y);k&&k.inset.dispose()}$onDidReceiveMessage(y,k){const r=this._insets.get(y);r&&r.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=D}),define(me[202],ge([0,1,3,81,169,4,6,24,40,15,53,23,43,194]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",g.Codicon.window,(0,T.localize)(0,null));var a;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var h;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function w(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=w;class _ extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(o,u,E){var d;const v=this.get(o.id);if(v)return v;const R=o;return R.openCommandActionDescriptor=(E==null?void 0:E.donotRegisterOpenCommand)?void 0:(d=R.openCommandActionDescriptor)!==null&&d!==void 0?d:{id:R.id},(0,P.getOrSet)(this.viewContainers,u,[]).push(R),(E==null?void 0:E.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:u}),R}deregisterViewContainer(o){for(const u of this.viewContainers.keys()){const E=this.viewContainers.get(u),d=E==null?void 0:E.indexOf(o);if(d!==-1){E==null||E.splice(d,1),E.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:u});return}}}get(o){return this.all.filter(u=>u.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(E=>(E==null?void 0:E.id)===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===o)}}y.Registry.add(a.ViewContainersRegistry,new _);var p;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(p=e.ViewContentGroups||(e.ViewContentGroups={}));function c(l,o){var u,E,d,v;const R=(u=l.group)!==null&&u!==void 0?u:p.More,L=(E=o.group)!==null&&E!==void 0?E:p.More;return R!==L?R.localeCompare(L):((d=l.order)!==null&&d!==void 0?d:5)-((v=o.order)!==null&&v!==void 0?v:5)}class f extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new r.SetMap}registerViews(o,u){this.registerViews2([{views:o,viewContainer:u}])}registerViews2(o){o.forEach(({views:u,viewContainer:E})=>this.addViews(u,E)),this._onViewsRegistered.fire(o)}deregisterViews(o,u){const E=this.removeViews(o,u);E.length&&this._onViewsDeregistered.fire({views:E,viewContainer:u})}moveViews(o,u){for(const E of this._views.keys())if(E!==u){const d=this.removeViews(o,E);d.length&&(this.addViews(d,u),this._onDidChangeContainer.fire({views:d,from:E,to:u}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const u of this._viewContainers){const E=(this._views.get(u)||[]).filter(d=>d.id===o)[0];if(E)return E}return null}getViewContainer(o){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(d=>d.id===o)[0])return u;return null}registerViewWelcomeContent(o,u){return this._viewWelcomeContents.add(o,u),this._onDidChangeViewWelcomeContent.fire(o),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(o,u),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,u){const E=new Map;for(const[d,v]of u)this._viewWelcomeContents.add(o,v),E.set(d,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(o,v),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),E}getViewWelcomeContent(o){const u=[];return this._viewWelcomeContents.forEach(o,E=>u.push(E)),u.sort(c)}addViews(o,u){let E=this._views.get(u);E||(E=[],this._views.set(u,E),this._viewContainers.push(u));for(const d of o){if(this.getView(d.id)!==null)throw new Error((0,T.localize)(1,null,d.id));E.push(d)}}removeViews(o,u){const E=this._views.get(u);if(!E)return[];const d=[],v=[];for(const R of E)o.includes(R)?d.push(R):v.push(R);return d.length&&(v.length?this._views.set(u,v):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),d}}y.Registry.add(a.ViewsRegistry,new f),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(o,u){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,o),this._hasResolve=!!u,this.resolve=async E=>{var d,v;if(u&&!this.resolved){const R=await u(E);R&&(this.tooltip=(d=this.tooltip)!==null&&d!==void 0?d:R.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:R.command)}E.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(me[203],ge([0,1,2,181,117,13,182,202]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(h){return(S,...w)=>h(S.get(I.ICommandService),...w)}class k{static execute(S,w){const _={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return S.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:y(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(h,S){return h.get(T.IWorkspacesService).removeRecentlyOpened([S])});class r{static execute(S,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?b.URI.parse(w):b.URI.file(w):w=b.URI.revive(w),S.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=r,r.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(r.ID,y(r.execute));class C{static execute(S,w){const _=typeof w=="string"?{extensionId:w}:w;return S.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(h,S){const w=h.get(T.IWorkspacesService);let _;const p=S.uri,c=S.label,f=S.remoteAuthority;return S.type==="workspace"?_={workspace:await w.getWorkspaceIdentifier(p),label:c,remoteAuthority:f}:S.type==="folder"?_={folderUri:p,label:c,remoteAuthority:f}:_={fileUri:p,label:c,remoteAuthority:f},w.addRecentlyOpened([_])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(h){return h.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(h,S){const w=h.get(A.ILogService),_=h.get(D.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&w.setLevel(S)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(h){return h.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(h,S){const w=h.get(P.IViewDescriptorService),_=w.getViewContainerById(S.destinationId);if(!!_){for(const p of S.viewIds){const c=w.getViewDescriptorById(p);(c==null?void 0:c.canMoveView)&&w.moveViewsToContainer([c],_,P.ViewVisibilityState.Default)}await h.get(P.IViewsService).openViewContainer(_.id,!0)}});class g{static execute(S,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=g,g.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:g.ID,handler:y(g.execute),description:{description:"Move Views",args:[]}});class m{static execute(S,w){return S.executeCommand("_workbench.open",w)}}m.ID="vscode.open",I.CommandsRegistry.registerCommand(m.ID,y(m.execute));class a{static execute(S,w,_,p,c){return S.executeCommand("_workbench.diff",[w,_,p])}}a.ID="vscode.diff",I.CommandsRegistry.registerCommand(a.ID,y(a.execute))}),define(me[120],ge([0,1,3,19,170]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,y,k,r){const C={command:P};if(y&&Object.keys(y).length>0&&(C.arguments=y),this.internalSend("request",C),typeof r=="number"){const g=setTimeout(()=>{clearTimeout(g);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:P,message:(0,T.localize)(0,null,r,P)};m(a)}},r)}return k&&this.pendingRequests.set(C.seq,k),C.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,y){return P.type!=="event"||y.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,I.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const y=P,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}internalSend(P,y){y.type=P,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((y,k)=>P.set(k,y)),await(0,I.timeout)(500),P.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(me[204],ge([0,1,10,2,8,23,11]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function y(n,s,i){return n.replace(P,function(l,o){return s&&o.length>0&&o[0]!=="_"?l:i&&i.hasOwnProperty(o)?i[o]:l})}e.formatPII=y;function k(n){const s={};for(const i of Object.keys(n))i.startsWith("!")||(s[i]=n[i]);return s}e.filterExceptionsFromTelemetry=k;function r(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=r;function C(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(s,"extensionhost")||(0,b.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function g(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=g;function m(n,s,i){let l,o=0,u=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=u.exec(n);){let d=E.index+1,v=d+E[0].length;if(d<=s&&v>=i){l=E[0],o=d;break}}if(l){let d=/\w+/g,v=null;for(;(v=d.exec(l))&&!(v.index+1+o+v[0].length>=i););v&&(l=l.substring(0,d.lastIndex))}return l?{start:o,end:o+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(a))}e.isUri=h;function S(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return I.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=I.URI.revive(n.path);if(s)return s.scheme===D.Schemas.file?s.fsPath:s.toString()}return n.path}function _(n,s){const i=s?S:w,l=(0,A.deepClone)(n);return c(l,(o,u)=>{o&&u&&(u.path=i(u))}),l}e.convertToDAPaths=_;function p(n,s){const i=s?S:w,l=(0,A.deepClone)(n);return c(l,(o,u)=>{!o&&u&&(u.path=i(u))}),l}e.convertToVSCPaths=p;function c(n,s){switch(n.type){case"event":const i=n;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const l=n;switch(l.command){case"setBreakpoints":s(!0,l.arguments.source);break;case"breakpointLocations":s(!0,l.arguments.source);break;case"source":s(!0,l.arguments.source);break;case"gotoTargets":s(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(u=>s(!1,u));break;default:break}break;case"response":const o=n;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(u=>s(!1,u.source));break;case"loadedSources":o.body.sources.forEach(u=>s(!1,u));break;case"scopes":o.body.scopes.forEach(u=>s(!1,u.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(u=>s(!1,u.source));break;case"setBreakpoints":o.body.breakpoints.forEach(u=>s(!1,u.source));break;default:break}break}}function f(n){return n.filter(s=>{var i;return!((i=s.presentation)===null||i===void 0?void 0:i.hidden)}).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[205],ge([0,1,26,38,171,121,8,10,23,9,183,120]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class g extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",c=>this.handleData(c))}sendMessage(_){if(this.outputStream){const p=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${g.TWO_CRLF}${p}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+p))}continue}}else{const p=this.rawData.indexOf(g.TWO_CRLF);if(p!==-1){const f=this.rawData.toString("utf8",0,p).split(g.HEADER_LINESEPARATOR);for(const t of f){const n=t.split(g.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(p+g.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=g,g.TWO_CRLF=`\r
\r
`,g.HEADER_LINESEPARATOR=/\r?\n/,g.HEADER_FIELDSEPARATOR=/: */;class m extends g{startSession(){return new Promise((_,p)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",f=>{c?this._onError.fire(f):p(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class a extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=a;class h extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return A.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=h;class S extends g{constructor(_,p,c){super();this.adapterExecutable=_,this.debugType=p,this.outputService=c}async startSession(){const _=this.adapterExecutable.command,p=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(_)if(D.isAbsolute(_)){if(!await(0,b.exists)(_))throw new Error(T.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let f=process.env;if(c.env&&Object.keys(c.env).length>0&&(f=y.mixin(y.deepClone(process.env),c.env)),_==="node")if(Array.isArray(p)&&p.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:f,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(s.cwd=c.cwd);const i=I.fork(p[0],p.slice(1),s);if(!i.pid)throw new Error(T.localize(2,null,p[0]));this.serverProcess=i}else throw new Error(T.localize(3,null));else{const n={env:f};c.cwd&&(n.cwd=c.cwd),this.serverProcess=I.spawn(_,p,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=t.getChannel(r.ExtensionsChannelId);i&&i.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((_,p)=>{const c=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,t,n){if(f)return p(f)});c.on("exit",_),c.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,p){if(!!_){const c=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?c.runtime=D.join(p,_.runtime):c.runtime=_.runtime),_.runtimeArgs&&(c.runtimeArgs=_.runtimeArgs),_.program&&(D.isAbsolute(_.program)?c.program=_.program:c.program=D.join(p,_.program)),_.args&&(c.args=_.args);const f=_;return f.win&&(c.win=S.extract(f.win,p)),f.winx86&&(c.winx86=S.extract(f.winx86,p)),f.windows&&(c.windows=S.extract(f.windows,p)),f.osx&&(c.osx=S.extract(f.osx,p)),f.linux&&(c.linux=S.extract(f.linux,p)),c}}static platformAdapterExecutable(_,p){let c=Object.create(null);p=p.toLowerCase();for(const l of _)if(l.contributes){const o=l.contributes.debuggers;o&&o.length>0&&o.filter(u=>typeof u.type=="string"&&P.equalsIgnoreCase(u.type,p)).forEach(u=>{const E=S.extract(u,l.extensionLocation.fsPath);c=y.mixin(c,E,l.isBuiltin)})}let f;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=c.winx86||c.win||c.windows:k.isWindows?f=c.win||c.windows:k.isMacintosh?f=c.osx:k.isLinux&&(f=c.linux),f=f||c;let t=f.program||c.program;const n=f.args||c.args;let s=f.runtime||c.runtime;const i=f.runtimeArgs||c.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=S}),define(me[206],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(me[207],ge([0,1,38,8,78,172,26,9,84,4,206,11]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=A.localize(0,null);let m=class Bt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(b,c,T.getWindowsShell(),p)}}runInTerminal(p,c,f,t,n){const s=n.windowsExec||Bt.getDefaultTerminalWindows();return new Promise((i,l)=>{const o=`"${c} - ${g}"`,u=`""${f.join('" "')}" & pause"`,E=["/c","start",o,"/wait",s,"/c",u],d=Object.assign({},process.env,t);Object.keys(d).filter(L=>d[L]===null).forEach(L=>delete d[L]);const v={cwd:c,env:d,windowsVerbatimArguments:!0};b.spawn(Bt.CMD,E,v).on("error",L=>{l(S(L))}),i(void 0)})}spawnTerminal(p,c,f,t){const s=c.terminal.external.windowsExec||Bt.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const i=I.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return p.spawn(s,t?[t]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),(i==="wt"||i==="wt.exe")&&l.push("-d ."),new Promise((o,u)=>{const E=t?{cwd:t}:void 0,d=p.spawn(f,l,E);d.on("error",u),d.on("exit",()=>o())})}static getDefaultTerminalWindows(){if(!Bt._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Bt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return Bt._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=je([Be(0,(0,k.optional)(y.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let a=class Fn{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(b,c,p)}}runInTerminal(p,c,f,t,n){const s=n.osxExec||r.DEFAULT_TERMINAL_OSX;return new Promise((i,l)=>{if(s===r.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const o=s===r.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,G).fsPath,"-t",p||g,"-w",c];for(let R of f)E.push("-a"),E.push(R);if(t)for(let R in t){const L=t[R];L===null?(E.push("-u"),E.push(R)):(E.push("-e"),E.push(`${R}=${L}`))}let d="";const v=b.spawn(Fn.OSASCRIPT,E);v.on("error",R=>{l(S(R))}),v.stderr.on("data",R=>{d+=R.toString()}),v.on("exit",R=>{if(R===0)i(void 0);else if(d){const L=d.split(`
`,1);l(new Error(L[0]))}else l(new Error(A.localize(1,null,o,R)))})}else l(new Error(A.localize(2,null,s)))})}spawnTerminal(p,c,f){const n=c.terminal.external.osxExec||r.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const l=["-a",n];f&&l.push(f);const o=p.spawn("/usr/bin/open",l);o.on("error",i),o.on("exit",()=>s())})}};a.OSASCRIPT="/usr/bin/osascript",a=je([Be(0,(0,k.optional)(y.IConfigurationService))],a),e.MacExternalTerminalService=a;let h=class Wt{constructor(p){this._configurationService=p}openTerminal(p){if(this._configurationService){const c=this._configurationService.getValue();this.spawnTerminal(b,c,p)}}runInTerminal(p,c,f,t,n){const s=n.linuxExec?Promise.resolve(n.linuxExec):Wt.getDefaultTerminalLinuxReady();return new Promise((i,l)=>{let o=[];s.then(u=>{u.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const E=`${w(f)}; echo; read -p "${Wt.WAIT_MESSAGE}" -n1;`;o.push(`''${E}''`);const d=Object.assign({},process.env,t);Object.keys(d).filter(H=>d[H]===null).forEach(H=>delete d[H]);const v={cwd:c,env:d};let R="";const L=b.spawn(u,o,v);L.on("error",H=>{l(S(H))}),L.stderr.on("data",H=>{R+=H.toString()}),L.on("exit",H=>{if(H===0)i(void 0);else if(R){const ie=R.split(`
`,1);l(new Error(ie[0]))}else l(new Error(A.localize(4,null,u,H)))})})})}spawnTerminal(p,c,f){const t=c.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):Wt.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{n.then(l=>{const o=f?{cwd:f}:void 0,u=p.spawn(l,[],o);u.on("error",i),u.on("exit",()=>s())})})}static async getDefaultTerminalLinuxReady(){return Wt._DEFAULT_TERMINAL_LINUX_READY||(Wt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async p=>{P.isLinux?await D.exists("/etc/debian_version")?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm"):p("xterm")})),Wt._DEFAULT_TERMINAL_LINUX_READY}};h.WAIT_MESSAGE=A.localize(3,null),h=je([Be(0,(0,k.optional)(y.IConfigurationService))],h),e.LinuxExternalTerminalService=h;function S(_){return"errno"in _&&_.errno==="ENOENT"&&"path"in _&&typeof _.path=="string"?new Error(A.localize(5,null,_.path)):_}function w(_){let p="";for(let c of _)c.indexOf(" ")>=0?p+='"'+c+'"':p+=c,p+=" ";return p}}),define(me[208],ge([0,1,38,9,207,30]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let D;function P(g,m){if(!D)if(I.isWindows)D=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)D=new T.MacExternalTerminalService(void 0);else if(I.isLinux)D=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=m.getConfiguration("terminal");return D.runInTerminal(g.title,g.cwd,g.args,g.env||{},a.external||{})}e.runInExternalTerminal=P;function y(g,m){return new Promise((a,h)=>{let S="";const w=b.spawn(g,m);w.pid&&w.stdout.on("data",_=>{S+=_.toString()}),w.on("error",_=>{h(_)}),w.on("close",_=>{a(S)})})}function k(g){return g?I.isWindows?y("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(h=>parseInt(h)===g),m=>!0):y("/usr/bin/pgrep",["-lP",String(g)]).then(m=>{const a=m.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=k;var r;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(r||(r={}));function C(g,m,a,h){g=g.trim().toLowerCase();let S;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?S=1:g.indexOf("cmd.exe")>=0?S=0:g.indexOf("bash")>=0?S=2:I.isWindows?S=0:S=2;let w,_=" ";switch(S){case 1:if(w=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),a){const c=(0,A.getDriveLetter)(a);c&&(_+=`${c}:; `),_+=`cd ${w(a)}; `}if(h)for(let c in h){const f=h[c];f===null?_+=`Remove-Item env:${c}; `:_+=`\${env:${c}}='${f}'; `}if(m.length>0){const c=w(m.shift());_+=c[0]==="'"?`& ${c} `:`${c} `;for(let f of m)_+=`${w(f)} `}break;case 0:if(w=c=>(c=c.replace(/\"/g,'""'),c.indexOf(" ")>=0||c.indexOf('"')>=0||c.length===0?`"${c}"`:c),a){const c=(0,A.getDriveLetter)(a);c&&(_+=`${c}: && `),_+=`cd ${w(a)} && `}if(h){_+='cmd /C "';for(let c in h){let f=h[c];f===null?_+=`set "${c}=" && `:(f=f.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${c}=${f}" && `)}}for(let c of m)_+=`${w(c)} `;h&&(_+='"');break;case 2:w=c=>(c=c.replace(/(["'\\\$])/g,"\\$1"),c.indexOf(" ")>=0||c.indexOf(";")>=0||c.length===0?`"${c}"`:c);const p=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if(a&&(_+=`cd ${w(a)} ; `),h){_+="/usr/bin/env";for(let c in h){const f=h[c];f===null?_+=` -u ${p(c)}`:_+=` ${p(`${c}=${f}`)}`}_+=" "}for(let c of m)_+=`${w(c)} `;break}return _}e.prepareCommand=C}),define(me[88],ge([0,1,33,11,8,9,81]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var k;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var r;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function a(L){const H=h.parse(L);return H?H.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=a;var h;(function(L){L.scheme=I.Schemas.vscodeNotebookCell;const H=/^ch(\d{7,})/;function ie(N,M){return N.with({scheme:L.scheme,fragment:`ch${M.toString().padStart(7,"0")}${N.scheme!==I.Schemas.file?N.scheme:""}`})}L.generate=ie;function j(N){if(N.scheme===L.scheme){const M=H.exec(N.fragment);if(!!M)return{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substr(M[0].length)||I.Schemas.file,fragment:null})}}}L.parse=j;function B(N,M){return N.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${M.toString().padStart(7,"0")}${N.scheme!==I.Schemas.file?N.scheme:""}`})}L.generateCellMetadataUri=B;function $(N){if(N.scheme===I.Schemas.vscodeNotebookCellMetadata){const M=H.exec(N.fragment);if(!!M)return{handle:Number(M[1]),notebook:N.with({scheme:N.fragment.substr(M[0].length)||I.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=$})(h=e.CellUri||(e.CellUri={}));const S=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(L){var H,ie;return(ie=(H=S.get(L))===null||H===void 0?void 0:H.alwaysSecure)!==null&&ie!==void 0?ie:!1}e.mimeTypeIsAlwaysSecure=w;function _(L){var H,ie;return(ie=(H=S.get(L))===null||H===void 0?void 0:H.supportedByCore)!==null&&ie!==void 0?ie:!1}e.mimeTypeSupportedByCore=_;function p(L){var H,ie;return(ie=(H=S.get(L))===null||H===void 0?void 0:H.mergeable)!==null&&ie!==void 0?ie:!1}e.mimeTypeIsMergeable=p;function c(L,H){return A.isWindows&&(L=L.replace(/\//g,"\\"),H=H.replace(/\//g,"\\")),b.match(L,H)}function f(L,H,ie){let j=0;for(let B=0;B<H.length;B++){if(c(H[B],L))return j;j++}for(let B=0;B<ie.length;B++){if(c(ie[B],L))return j;j++}return j}function t(L,H,ie){return L.sort((j,B)=>f(j,H,ie)-f(B,H,ie))}e.sortMimeTypes=t;function n(L,H,ie,j=(B,$)=>B===$){const B=[];function $(F,U,O){if(!(U===0&&O.length===0)){const W=B[B.length-1];W&&W.start+W.deleteCount===F?(W.deleteCount+=U,W.toInsert.push(...O)):B.push({start:F,deleteCount:U,toInsert:O})}}let N=0,M=0;for(;;){if(N===L.length){$(N,0,H.slice(M));break}if(M===H.length){$(N,L.length-N,[]);break}const F=L[N],U=H[M];if(j(F,U)){N+=1,M+=1;continue}ie(U)?($(N,1,[]),N+=1):($(N,0,[U]),M+=1)}return B}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(L){L.default="default",L.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(L){const H=L;return!!((typeof H.include=="string"||b.isRelativePattern(H.include))&&(typeof H.exclude=="string"||b.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=i;function l(L,H,ie){if(Array.isArray(L.viewType)&&L.viewType.indexOf(H)>=0||L.viewType===H)return!0;if(L.filenamePattern){let j=i(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,B=i(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(b.match(j,(0,T.basename)(ie.fsPath).toLowerCase()))return!(B&&b.match(B,(0,T.basename)(ie.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class o{constructor(H){this.textModel=H}getElements(){const H=new Int32Array(this.textModel.cells.length);for(let ie=0;ie<this.textModel.cells.length;ie++)H[ie]=this.textModel.cells[ie].getHashValue();return H}}e.CellSequence=o,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var u;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function E(L){L.sort((ie,j)=>ie-j);const H=L.shift();return H===void 0?[]:L.reduce(function(ie,j){return j<=ie[0][1]?ie[0][1]=j+1:ie.unshift([j,j+1]),ie},[[H,H+1]]).reverse().map(ie=>({start:ie[0],end:ie[1]}))}e.cellIndexesToRanges=E;function d(L){return L.reduce((ie,j)=>{for(let B=j.start;B<j.end;B++)ie.push(B);return ie},[])}e.cellRangesToIndexes=d;function v(L){const H=L.sort((j,B)=>j.start-B.start),ie=H[0];return ie?H.reduce((j,B)=>{const $=j[j.length-1];return $.end>=B.start?$.end=Math.max($.end,B.end):j.push(B),j},[ie]):[]}e.reduceRanges=v;function R(L,H){return H.start>=L.start&&H.end<=L.end}e.cellRangeContains=R}),define(me[209],ge([0,1,174,4,81]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[210],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=b;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(me[211],ge([0,1,8,135,9]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(f,t){if(!!t)if(T.isWindows)for(const n in t){let s=n;for(const l in f)if(n.toLowerCase()===l.toLowerCase()){s=l;break}const i=t[n];i!==void 0&&D(f,s,i)}else Object.keys(t).forEach(n=>{const s=t[n];s!==void 0&&D(f,n,s)})}e.mergeEnvironments=A;function D(f,t,n){typeof n=="string"?f[t]=n:delete f[t]}function P(f,t,n,s){f.TERM_PROGRAM="vscode",t&&(f.TERM_PROGRAM_VERSION=t),r(f,s)&&(f.LANG=C(n)),f.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=P;function y(f,t){if(!!t)for(const n of Object.keys(t)){const s=t[n];s&&(f[n]=s)}}function k(f,t){return Object.keys(t).forEach(n=>{const s=t[n];if(typeof s=="string")try{t[n]=f(s)}catch(i){t[n]=s}}),t}function r(f,t){if(t==="on")return!0;if(t==="auto"){const n=f.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=r;function C(f){const t=f?f.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in s&&t.push(s[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function g(f,t,n,s,i,l){if(f.cwd){const u=typeof f.cwd=="object"?f.cwd.fsPath:f.cwd,E=m(u,n);return a(E||u)}let o;return!f.ignoreConfigurationCwd&&i&&(n&&(i=m(i,n,l)),i&&(b.isAbsolute(i)?o=i:s&&(o=b.join(s.fsPath,i)))),o||(o=s?s.fsPath:t||""),a(o)}e.getCwd=g;function m(f,t,n){if(t)try{return t(f)}catch(s){n==null||n.error("Could not resolve terminal cwd",s);return}return f}function a(f){return T.OS===1&&f&&f[1]===":"?f[0].toUpperCase()+f.substr(1):f}function h(f){let t=f;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=h;function S(f,t){if(!!t)return n=>t.resolve(f,n)}e.createVariableResolver=S;function w(f,t,n,s,i,l,o,u=T.platform){let E;o&&(E=p(f,"automationShell",u)),E||(E=p(f,"shell",u));let d=E||t;if(u===3&&!n&&s){const v=b.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&d.toLowerCase().indexOf(v)===0&&(d=b.join(s,"System32",d.substr(v.length+1)))}if(d&&u===3&&(d=d.replace(/\//g,"\\")),i)try{d=i(d)}catch(v){l.error("Could not resolve shell",v)}return d}e.getDefaultShell=w;function _(f,t,n,s,i=T.platform){if(t&&p(f,"automationShell",i))return[];const l=i===3?"windows":i===1?"osx":"linux";let o=f(`terminal.integrated.shellArgs.${l}`);if(!o)return[];if(typeof o=="string"&&i===3)return n?n(o):o;if(n){const u=[];for(const E of o)try{u.push(n(E))}catch(d){s.error(`Could not resolve terminal.integrated.shellArgs.${l}`,d),u.push(E)}o=u}return o}e.getDefaultShellArgs=_;function p(f,t,n=T.platform){return f(`terminal.integrated.${t}.${n===3?"windows":n===1?"osx":"linux"}`)}function c(f,t,n,s,i,l){let o={};if(f.strictEnv)y(o,f.env);else{y(o,l);const u=Object.assign({},t);n&&(u&&k(n,u),f.env&&k(n,f.env)),(0,I.sanitizeProcessEnvironment)(o,"VSCODE_IPC_HOOK_CLI"),A(o,u),A(o,f.env),P(o,s,T.locale,i)}return o}e.createTerminalEnvironment=c});var hn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(A){b[A]=G[A]&&function(D){return new Promise(function(P,y){D=G[A](D),T(P,y,D.done,D.value)})}}function T(A,D,P,y){Promise.resolve(y).then(function(k){A({value:k,done:P})},D)}};define(me[212],ge([0,1,37,8,103,191,38,26,43,9]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let r;function C(c,f,t,n,s,i,l){return f=f||{existsFile:P.SymlinkSupport.existsFile,readFile:b.promises.readFile},k.isWindows?g(c,f,t,n==null?void 0:n.useWslProfiles,n==null?void 0:n.profiles.windows,s,i):w(f,t,c,k.isMacintosh?n==null?void 0:n.profiles.osx:n==null?void 0:n.profiles.linux,l,s,i)}e.detectAvailableProfiles=C;async function g(c,f,t,n,s,i,l){const o=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),u=`${process.env.windir}\\${o?"Sysnative":"System32"}`;let E=!1;(0,A.getWindowsBuildNumber)()>=16299&&(E=!0),await a();const d=new Map;c||(d.set("PowerShell",{source:"PowerShell",icon:y.Codicon.terminalPowershell.id,isAutoDetected:!0}),d.set("Windows PowerShell",{path:`${u}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:y.Codicon.terminalPowershell.id,isAutoDetected:!0}),d.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),d.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),d.set("Command Prompt",{path:`${u}\\cmd.exe`,icon:y.Codicon.terminalCmd.id,isAutoDetected:!0})),_(s,d);const v=await m(d.entries(),f,t,i,l);if(!c||c&&n)try{const R=await S(`${u}\\${E?"wsl.exe":"bash.exe"}`,n);R&&v.push(...R)}catch(R){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return v}async function m(c,f,t,n,s){const i=[];for(const[l,o]of c)if(o!==null){let u,E,d;if("source"in o){const L=r==null?void 0:r.get(o.source);if(!L)continue;u=L.paths,E=o.args||L.args,d=o.icon||L.icon}else u=Array.isArray(o.path)?o.path:[o.path],E=k.isWindows||Array.isArray(o.args)?o.args:void 0,d=o.icon;const v=u.slice();for(let L=0;L<v.length;L++)v[L]=await(n==null?void 0:n.resolveAsync(s,v[L]))||v[L];const R=await p(l,v,f,E,o.env,o.overrideName,o.isAutoDetected,t);R?(R.isAutoDetected=o.isAutoDetected,R.icon=d,i.push(R)):t==null||t.trace("profile not validated",l,u)}return i}async function a(){r||(r=new Map,r.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),r.set("PowerShell",{profileName:"PowerShell",paths:await h(),icon:"terminal-powershell"}))}async function h(){var c,f;const t=[];try{for(var n=hn((0,T.enumeratePowerShellInstallations)()),s;s=await n.next(),!s.done;){const i=s.value;t.push(i.exePath)}}catch(i){c={error:i}}finally{try{s&&!s.done&&(f=n.return)&&await f.call(n)}finally{if(c)throw c.error}}return t}async function S(c,f){const t=[];if(f){const n=await new Promise((s,i)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(l,o)=>{if(l)return i("Problem occurred when getting wsl distros");s(o)})});if(n){const s=new RegExp(/[\r?\n]/),i=n.split(s).filter(l=>l.trim().length>0&&l!=="");for(let l of i)if(l!==""&&!l.startsWith("docker-desktop")){const o={profileName:`${l} (WSL)`,path:c,args:["-d",`${l}`]};l.includes("Debian")?o.icon="terminal-debian":o.icon="terminal-linux",t.push(o)}return t}}return[]}async function w(c,f,t,n,s,i,l){const o=new Map;if(!t){const u=await c.readFile("/etc/shells","utf8"),E=s||u.split(`
`).filter(v=>v.trim().indexOf("#")!==0&&v.trim().length>0),d=new Map;for(const v of E){let R=(0,I.basename)(v),L=d.get(R)||0;L++,L>1&&(R=`${R} (${L})`),d.set(R,L),o.set(R,{path:v,isAutoDetected:!0})}}return _(n,o),await m(o.entries(),c,f,i,l)}function _(c,f){if(!!c)for(const[t,n]of Object.entries(c))n===null||!("path"in n)&&!("source"in n)?f.delete(t):f.set(t,n)}async function p(c,f,t,n,s,i,l,o){if(f.length===0)return Promise.resolve(void 0);const u=f.shift();if(u==="")return p(c,f,t,n,s,i,l);const E={profileName:c,path:u,args:n,env:s,overrideName:i,isAutoDetected:l};if((0,I.basename)(u)===u){const v=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,A.findExecutable)(u,void 0,v,void 0,t.existsFile)?E:p(c,f,t,n)}return await t.existsFile((0,I.normalize)(u))?E:p(c,f,t,n,s,i,l)}}),define(me[122],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(y,k)=>{k.expand!==void 0&&(y.expand=k.expand),k.item!==void 0&&Object.assign(y.item,k.item)};e.applyTestItemUpdate=I;var T;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(y,k)=>`${y}:${k.toString()}`;e.getTestSubscriptionKey=A;class D{add(k){}update(k){}remove(k,r){}complete(){}}e.IncrementalChangeCollector=D;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const r=this.createChangeCollector();for(const C of k)switch(C[0]){case 0:{const g=C[1];if(g.parent){if(this.items.has(g.parent)){const m=this.items.get(g.parent);m.children.add(g.item.extId);const a=this.createItem(g,m);this.items.set(g.item.extId,a),r.add(a)}}else{this.roots.add(g.item.extId);const m=this.createItem(g);this.items.set(g.item.extId,m),r.add(m)}g.expand===2&&this.updateBusyControllers(1);break}case 1:{const g=C[1],m=this.items.get(g.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,g),r.update(m),g.expand!==void 0&&m.expand===2&&g.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const g=this.items.get(C[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g.item.extId);const m=[[C[1]]];for(;m.length;)for(const a of m.pop()){const h=this.items.get(a);h&&(m.push(h.children),this.items.delete(a),r.remove(h,h!==g),h.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}r.complete()}retireTest(k){}updateBusyControllers(k){this.busyControllerCount+=k}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=P}),define(me[213],ge([0,1,8,36,12,23,9,76,175]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(C,g,m,a){if(this._contributedVariables=new Map,this._context=C,this._labelService=g,m)if(D.isWindows){const h=Object.create(null);this._envVariables=h,Object.keys(m).forEach(S=>{h[S.toLowerCase()]=m[S]})}else this._envVariables=m}resolveWithEnvironment(C,g,m){return this.recursiveResolve(C,g?g.uri:void 0,m)}async resolveAsync(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolve(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolveAnyBase(C,g,m,a){const h=A.deepClone(g);return D.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):D.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):D.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,h,m,a)}resolveAny(C,g,m){return this.resolveAnyBase(C,g,m)}async resolveAnyAsync(C,g,m){return this.resolveAnyBase(C,g,m)}resolveAnyMap(C,g,m){const a=new Map;return{newConfig:this.resolveAnyBase(C,g,m,a),resolvedVariables:a}}resolveWithInteractionReplace(C,g,m,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,g,m,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,g){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,g)}recursiveResolve(C,g,m,a,h){if(T.isString(m))return this.resolveString(C,g,m,a,h);if(T.isArray(m))return m.map(S=>this.recursiveResolve(C,g,S,a,h));if(T.isObject(m)){let S=Object.create(null);return Object.keys(m).forEach(w=>{const _=this.resolveString(C,g,w,a,h);S[_]=this.recursiveResolve(C,g,m[w],a,h)}),S}return m}resolveString(C,g,m,a,h){return m.replace(k.VARIABLE_REGEXP,(w,_)=>{if(_.includes(k.VARIABLE_LHS))return w;let p=this.evaluateSingleVariable(C,w,_,g,a);return h&&h.set(_,p),p})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,g,m,a,h){let S;const w=m.split(":");w.length>1&&(m=w[0],S=w[1]);const _=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,y.localize)(0,null,g))},p=()=>{const f=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,g,b.basename(f)))},c=()=>{if(S){const f=this._context.getFolderUri(S);if(f)return f;throw new Error((0,y.localize)(2,null,g,S))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,g)):new Error((0,y.localize)(4,null,g))};switch(m){case"env":if(S){if(C){const f=C[D.isWindows?S.toLowerCase():S];if(T.isString(f))return f}return""}throw new Error((0,y.localize)(5,null,g));case"config":if(S){const f=this._context.getConfigurationValue(a,S);if(T.isUndefinedOrNull(f))throw new Error((0,y.localize)(6,null,g,S));if(T.isObject(f))throw new Error((0,y.localize)(7,null,g,S));return f}throw new Error((0,y.localize)(8,null,g));case"command":return this.resolveFromMap(g,S,h,"command");case"input":return this.resolveFromMap(g,S,h,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return a||S?(0,P.normalizeDriveLetter)(this.fsPath(c())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(c()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,y.localize)(9,null,g));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,g));case"file":return _();case"fileWorkspaceFolder":return p();case"relativeFile":return a||S?b.relative(this.fsPath(c()),_()):_();case"relativeFileDirname":const n=b.dirname(_());if(a||S){const o=b.relative(this.fsPath(c()),n);return o.length===0?".":o}return n;case"fileDirname":return b.dirname(_());case"fileExtname":return b.extname(_());case"fileBasename":return b.basename(_());case"fileBasenameNoExtension":const s=b.basename(_());return s.slice(0,s.length-b.extname(s).length);case"fileDirnameBasename":return b.basename(b.dirname(_()));case"execPath":const i=this._context.getExecPath();return i||g;case"execInstallFolder":const l=this._context.getAppRoot();return l||g;case"pathSeparator":return b.sep;default:try{const o=S?`${m}:${S}`:m;return this.resolveFromMap(g,o,h,void 0)}catch(o){return g}}}}resolveFromMap(C,g,m,a){if(g&&m){const h=a===void 0?m[g]:m[a+":"+g];if(typeof h=="string")return h;throw new Error((0,y.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[214],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var D;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_PIN=7]="EDITOR_PIN",g[g.EDITOR_STICKY=8]="EDITOR_STICKY",g[g.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function C(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(me[215],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,15,97,286,58,23,12,2,44,80,176,113,88,215,7]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(ue){function De(Y){const{selectionStartLineNumber:Ne,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=Y,ut=new h.Position(Ne-1,Te-1),rt=new h.Position(Je-1,et-1);return new h.Selection(ut,rt)}ue.to=De;function le(Y){const{anchor:Ne,active:Te}=Y;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=le})(S=e.Selection||(e.Selection={}));var w;(function(ue){function De(Y){if(!!Y){const{start:Ne,end:Te}=Y;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=De;function le(Y){if(!!Y){const{startLineNumber:Ne,startColumn:Te,endLineNumber:Je,endColumn:et}=Y;return new h.Range(Ne-1,Te-1,Je-1,et-1)}}ue.to=le})(w=e.Range||(e.Range={}));var _;(function(ue){function De(le){switch(le){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}ue.to=De})(_=e.TokenType||(e.TokenType={}));var p;(function(ue){function De(Y){return new h.Position(Y.lineNumber-1,Y.column-1)}ue.to=De;function le(Y){return{lineNumber:Y.line+1,column:Y.character+1}}ue.from=le})(p=e.Position||(e.Position={}));var c;(function(ue){function De(Y){switch(Y){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}ue.from=De;function le(Y){switch(Y){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}ue.to=le})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(ue){function De(Y){let Ne;return Y.code&&((0,P.isString)(Y.code)||(0,P.isNumber)(Y.code)?Ne=String(Y.code):Ne={value:String(Y.code.value),target:Y.code.target}),Object.assign(Object.assign({},w.from(Y.range)),{message:Y.message,source:Y.source,code:Ne,severity:n.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?(0,b.coalesce)(Y.tags.map(c.from)):void 0})}ue.from=De;function le(Y){var Ne;const Te=new h.Diagnostic(w.to(Y),Y.message,n.to(Y.severity));return Te.source=Y.source,Te.code=(0,P.isString)(Y.code)?Y.code:(Ne=Y.code)===null||Ne===void 0?void 0:Ne.value,Te.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Te.tags=Y.tags&&(0,b.coalesce)(Y.tags.map(c.to)),Te}ue.to=le})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function De(Y){return Object.assign(Object.assign({},w.from(Y.location.range)),{message:Y.message,resource:Y.location.uri})}ue.from=De;function le(Y){return new h.DiagnosticRelatedInformation(new h.Location(Y.resource,w.to(Y)),Y.message)}ue.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ue){function De(Y){switch(Y){case h.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ue.from=De;function le(Y){switch(Y){case g.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}ue.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ue){function De(Y){return typeof Y=="number"&&Y>=h.ViewColumn.One?Y-1:Y===h.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}ue.from=De;function le(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=le})(s=e.ViewColumn||(e.ViewColumn={}));function i(ue){return typeof ue.range!="undefined"}function l(ue){return ue.length===0?!0:!!i(ue[0])}e.isDecorationOptionsArr=l;var o;(function(ue){function De(et){return et.map(ue.from)}ue.fromMany=De;function le(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Y(et){let ut;if(le(et)){const{language:ot,value:vt}=et;ut={value:"```"+ot+`
`+vt+"\n```\n"}}else h.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const rt=Object.create(null);ut.uris=rt;const Ge=ot=>{try{let vt=y.URI.parse(ot,!0);vt=vt.with({query:Ne(vt.query,rt)}),rt[ot]=vt}catch(vt){}return""},ht=new T.Renderer;return ht.link=Ge,ht.image=ot=>Ge(I.parseHrefAndDimensions(ot).href),T(ut.value,{renderer:ht}),ut}ue.from=Y;function Ne(et,ut){if(!et)return et;let rt;try{rt=(0,A.parse)(et)}catch(ht){}if(!rt)return et;let Ge=!1;return rt=(0,D.cloneAndChange)(rt,ht=>{if(y.URI.isUri(ht)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ot]=ht,Ge=!0,ot}else return}),Ge?JSON.stringify(rt):et}function Te(et){const ut=new h.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}ue.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:ue.from(et)}ue.fromStrict=Je})(o=e.MarkdownString||(e.MarkdownString={}));function u(ue){return l(ue)?ue.map(De=>({range:w.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?o.fromMany(De.hoverMessage):De.hoverMessage?o.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ue.map(De=>({range:w.from(De)}))}e.fromRangeOrRangeWithMessage=u;function E(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=E;var d;(function(ue){function De(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?E(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ue.from=De})(d=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(ue){function De(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?E(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?d.from(le.before):void 0,after:le.after?d.from(le.after):void 0}}ue.from=De})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ue){function De(le){if(typeof le=="undefined")return le;switch(le){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=De})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function De(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?R.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?v.from(le.light):void 0,dark:le.dark?v.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?E(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?d.from(le.before):void 0,after:le.after?d.from(le.after):void 0}}ue.from=De})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(ue){function De(Y){return{text:Y.newText,eol:Y.newEol&&re.from(Y.newEol),range:w.from(Y.range)}}ue.from=De;function le(Y){const Ne=new h.TextEdit(w.to(Y.range),Y.text);return Ne.newEol=typeof Y.eol=="undefined"?void 0:re.to(Y.eol),Ne}ue.to=le})(H=e.TextEdit||(e.TextEdit={}));var ie;(function(ue){function De(Y,Ne,Te){var Je,et,ut;const rt={edits:[]};if(Y instanceof h.WorkspaceEdit)for(let Ge of Y._allEntries())if(Ge._type===1)rt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ht=Ne==null?void 0:Ne.getDocument(Ge.uri);rt.edits.push({_type:2,resource:Ge.uri,edit:H.from(Ge.edit),modelVersionId:ht==null?void 0:ht.version,metadata:Ge.metadata})}else Ge._type===3?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.lookupNotebookDocument(Ge.uri))===null||Je===void 0?void 0:Je.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(qe.from)}}),Ge.newMetadata&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:11,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(et=Te==null?void 0:Te.lookupNotebookDocument(Ge.uri))===null||et===void 0?void 0:et.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(pe.from)}}):Ge._type===6&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,outputId:Ge.outputId,items:((ut=Ge.newOutputItems)===null||ut===void 0?void 0:ut.map(Se.from))||[],append:Ge.append}});return rt}ue.from=De;function le(Y){const Ne=new h.WorkspaceEdit;for(const Te of Y.edits)Te.edit?Ne.replace(y.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Ne.renameFile(y.URI.revive(Te.oldUri),y.URI.revive(Te.newUri),Te.options);return Ne}ue.to=le})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ue){const De=Object.create(null);De[h.SymbolKind.File]=0,De[h.SymbolKind.Module]=1,De[h.SymbolKind.Namespace]=2,De[h.SymbolKind.Package]=3,De[h.SymbolKind.Class]=4,De[h.SymbolKind.Method]=5,De[h.SymbolKind.Property]=6,De[h.SymbolKind.Field]=7,De[h.SymbolKind.Constructor]=8,De[h.SymbolKind.Enum]=9,De[h.SymbolKind.Interface]=10,De[h.SymbolKind.Function]=11,De[h.SymbolKind.Variable]=12,De[h.SymbolKind.Constant]=13,De[h.SymbolKind.String]=14,De[h.SymbolKind.Number]=15,De[h.SymbolKind.Boolean]=16,De[h.SymbolKind.Array]=17,De[h.SymbolKind.Object]=18,De[h.SymbolKind.Key]=19,De[h.SymbolKind.Null]=20,De[h.SymbolKind.EnumMember]=21,De[h.SymbolKind.Struct]=22,De[h.SymbolKind.Event]=23,De[h.SymbolKind.Operator]=24,De[h.SymbolKind.TypeParameter]=25;function le(Ne){return typeof De[Ne]=="number"?De[Ne]:6}ue.from=le;function Y(Ne){for(const Te in De)if(De[Te]===Ne)return Number(Te);return h.SymbolKind.Property}ue.to=Y})(j=e.SymbolKind||(e.SymbolKind={}));var B;(function(ue){function De(Y){switch(Y){case h.SymbolTag.Deprecated:return 1}}ue.from=De;function le(Y){switch(Y){case 1:return h.SymbolTag.Deprecated}}ue.to=le})(B=e.SymbolTag||(e.SymbolTag={}));var $;(function(ue){function De(Y){return{name:Y.name,kind:j.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:O.from(Y.location)}}ue.from=De;function le(Y){const Ne=new h.SymbolInformation(Y.name,j.to(Y.kind),Y.containerName,O.to(Y.location));return Ne.tags=Y.tags&&Y.tags.map(B.to),Ne}ue.to=le})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var N;(function(ue){function De(Y){var Ne,Te;const Je={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:w.from(Y.range),selectionRange:w.from(Y.selectionRange),kind:j.from(Y.kind),tags:(Te=(Ne=Y.tags)===null||Ne===void 0?void 0:Ne.map(B.from))!==null&&Te!==void 0?Te:[]};return Y.children&&(Je.children=Y.children.map(De)),Je}ue.from=De;function le(Y){const Ne=new h.DocumentSymbol(Y.name,Y.detail,j.to(Y.kind),w.to(Y.range),w.to(Y.selectionRange));return(0,b.isNonEmptyArray)(Y.tags)&&(Ne.tags=Y.tags.map(B.to)),Y.children&&(Ne.children=Y.children.map(le)),Ne}ue.to=le})(N=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(ue){function De(le){const Y=new h.CallHierarchyItem(j.to(le.kind),le.name,le.detail||"",y.URI.revive(le.uri),w.to(le.range),w.to(le.selectionRange));return Y._sessionId=le._sessionId,Y._itemId=le._itemId,Y}ue.to=De})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(ue){function De(le){return new h.CallHierarchyIncomingCall(M.to(le.from),le.fromRanges.map(Y=>w.to(Y)))}ue.to=De})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var U;(function(ue){function De(le){return new h.CallHierarchyOutgoingCall(M.to(le.to),le.fromRanges.map(Y=>w.to(Y)))}ue.to=De})(U=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(ue){function De(Y){return{range:Y.range&&w.from(Y.range),uri:Y.uri}}ue.from=De;function le(Y){return new h.Location(y.URI.revive(Y.uri),w.to(Y.range))}ue.to=le})(O=e.location||(e.location={}));var W;(function(ue){function De(Y){const Ne=Y,Te=Y;return{originSelectionRange:Ne.originSelectionRange?w.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Te.uri,range:w.from(Ne.targetRange?Ne.targetRange:Te.range),targetSelectionRange:Ne.targetSelectionRange?w.from(Ne.targetSelectionRange):void 0}}ue.from=De;function le(Y){return{targetUri:y.URI.revive(Y.uri),targetRange:w.to(Y.range),targetSelectionRange:Y.targetSelectionRange?w.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?w.to(Y.originSelectionRange):void 0}}ue.to=le})(W=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(ue){function De(Y){return{range:w.from(Y.range),contents:o.fromMany(Y.contents)}}ue.from=De;function le(Y){return new h.Hover(Y.contents.map(o.to),w.to(Y.range))}ue.to=le})(q=e.Hover||(e.Hover={}));var Q;(function(ue){function De(Y){return{range:w.from(Y.range),expression:Y.expression}}ue.from=De;function le(Y){return new h.EvaluatableExpression(w.to(Y.range),Y.expression)}ue.to=le})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(ue){function De(Y){if(Y instanceof h.InlineValueText)return{type:"text",range:w.from(Y.range),text:Y.text};if(Y instanceof h.InlineValueVariableLookup)return{type:"variable",range:w.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=De;function le(Y){switch(Y.type){case"text":return{range:w.to(Y.range),text:Y.text};case"variable":return{range:w.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:w.to(Y.range),expression:Y.expression}}}ue.to=le})(he=e.InlineValue||(e.InlineValue={}));var ve;(function(ue){function De(Y){return{frameId:Y.frameId,stoppedLocation:w.from(Y.stoppedLocation)}}ue.from=De;function le(Y){return new h.InlineValueContext(Y.frameId,w.to(Y.stoppedLocation))}ue.to=le})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Pe;(function(ue){function De(Y){return{range:w.from(Y.range),kind:Y.kind}}ue.from=De;function le(Y){return new h.DocumentHighlight(w.to(Y.range),Y.kind)}ue.to=le})(Pe=e.DocumentHighlight||(e.DocumentHighlight={}));var ke;(function(ue){function De(le){switch(le){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}ue.to=De})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(ue){function De(le){return{triggerKind:ke.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ue.to=De})(Le=e.CompletionContext||(e.CompletionContext={}));var V;(function(ue){function De(Y){switch(Y){case h.CompletionItemTag.Deprecated:return 1}}ue.from=De;function le(Y){switch(Y){case 1:return h.CompletionItemTag.Deprecated}}ue.to=le})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ue){const De=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function le(Te){var Je;return(Je=De.get(Te))!==null&&Je!==void 0?Je:9}ue.from=le;const Y=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ne(Te){var Je;return(Je=Y.get(Te))!==null&&Je!==void 0?Je:h.CompletionItemKind.Property}ue.to=Ne})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ue){function De(le,Y){var Ne;const Te=new h.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Te.label2=le.label),Te.insertText=le.insertText,Te.kind=J.to(le.kind),Te.tags=(Ne=le.tags)===null||Ne===void 0?void 0:Ne.map(V.to),Te.detail=le.detail,Te.documentation=I.isMarkdownString(le.documentation)?o.to(le.documentation):le.documentation,Te.sortText=le.sortText,Te.filterText=le.filterText,Te.preselect=le.preselect,Te.commitCharacters=le.commitCharacters,k.Range.isIRange(le.range)?Te.range=w.to(le.range):typeof le.range=="object"&&(Te.range={inserting:w.to(le.range.insert),replacing:w.to(le.range.replace)}),Te.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Te.insertText=new h.SnippetString(le.insertText):(Te.insertText=le.insertText,Te.textEdit=Te.range instanceof h.Range?new h.TextEdit(Te.range,Te.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Te.additionalTextEdits=le.additionalTextEdits.map(Je=>H.to(Je))),Te.command=Y&&le.command?Y.fromInternal(le.command):void 0,Te}ue.to=De})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ue){function De(Y){return{label:Y.label,documentation:Y.documentation?o.fromStrict(Y.documentation):void 0}}ue.from=De;function le(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?o.to(Y.documentation):Y.documentation}}ue.to=le})(ae=e.ParameterInformation||(e.ParameterInformation={}));var we;(function(ue){function De(Y){return{label:Y.label,documentation:Y.documentation?o.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ae.from):[],activeParameter:Y.activeParameter}}ue.from=De;function le(Y){return{label:Y.label,documentation:I.isMarkdownString(Y.documentation)?o.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(ae.to):[],activeParameter:Y.activeParameter}}ue.to=le})(we=e.SignatureInformation||(e.SignatureInformation={}));var Ce;(function(ue){function De(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(we.from):[]}}ue.from=De;function le(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(we.to):[]}}ue.to=le})(Ce=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(ue){function De(Y){var Ne;return{text:Y.text,range:w.from(Y.range),kind:be.from((Ne=Y.kind)!==null&&Ne!==void 0?Ne:h.InlineHintKind.Other),description:Y.description&&o.fromStrict(Y.description),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}ue.from=De;function le(Y){const Ne=new h.InlineHint(Y.text,w.to(Y.range),be.to(Y.kind));return Ne.whitespaceAfter=Y.whitespaceAfter,Ne.whitespaceBefore=Y.whitespaceBefore,Ne.description=I.isMarkdownString(Y.description)?o.to(Y.description):Y.description,Ne}ue.to=le})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(ue){function De(Y){return Y}ue.from=De;function le(Y){return Y}ue.to=le})(be=e.InlineHintKind||(e.InlineHintKind={}));var Ie;(function(ue){function De(Y){return{range:w.from(Y.range),url:Y.target,tooltip:Y.tooltip}}ue.from=De;function le(Y){let Ne;if(Y.url)try{Ne=typeof Y.url=="string"?y.URI.parse(Y.url,!0):y.URI.revive(Y.url)}catch(Te){}return new h.DocumentLink(w.to(Y.range),Ne)}ue.to=le})(Ie=e.DocumentLink||(e.DocumentLink={}));var Re;(function(ue){function De(Y){const Ne=new h.ColorPresentation(Y.label);return Y.textEdit&&(Ne.textEdit=H.to(Y.textEdit)),Y.additionalTextEdits&&(Ne.additionalTextEdits=Y.additionalTextEdits.map(Te=>H.to(Te))),Ne}ue.to=De;function le(Y){return{label:Y.label,textEdit:Y.textEdit?H.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ne=>H.from(Ne)):void 0}}ue.from=le})(Re=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(ue){function De(Y){return new h.Color(Y[0],Y[1],Y[2],Y[3])}ue.to=De;function le(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}ue.from=le})(We=e.Color||(e.Color={}));var Ee;(function(ue){function De(Y){return{range:w.from(Y.range)}}ue.from=De;function le(Y){return new h.SelectionRange(w.to(Y.range))}ue.to=le})(Ee=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(ue){function De(le){switch(le){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}ue.to=De})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ue){function De(Y){switch(Y){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=De;function le(Y){switch(Y){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}ue.to=le})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var re;(function(ue){function De(Y){if(Y===h.EndOfLine.CRLF)return 1;if(Y===h.EndOfLine.LF)return 0}ue.from=De;function le(Y){if(Y===1)return h.EndOfLine.CRLF;if(Y===0)return h.EndOfLine.LF}ue.to=le})(re=e.EndOfLine||(e.EndOfLine={}));var _e;(function(ue){function De(le){if(typeof le=="object")return le.viewId;switch(le){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=De})(_e=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(ue){function De(le){const Y={start:le.start+1,end:le.end+1};return le.kind&&(Y.kind=ze.from(le.kind)),Y}ue.from=De})(xe=e.FoldingRange||(e.FoldingRange={}));var ze;(function(ue){function De(le){if(le)switch(le){case h.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}ue.from=De})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(ue){function De(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?w.from(le.selection):void 0,override:typeof le.override=="boolean"?C.EditorOverride.DISABLED:void 0}}ue.from=De})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ue){function De(Y){return Y instanceof h.RelativePattern||typeof Y=="string"?Y:le(Y)?new h.RelativePattern(Y.base,Y.pattern):Y}ue.from=De;function le(Y){const Ne=Y;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var K;(function(ue){function De(le){if(le){if(Array.isArray(le))return le.map(De);if(typeof le=="string")return le;{const Y=le;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Ye.from(Y.pattern),exclusive:Y.exclusive}}}else return}ue.from=De})(K=e.LanguageSelector||(e.LanguageSelector={}));var oe;(function(ue){function De(Y){return{start:Y.start,end:Y.end}}ue.from=De;function le(Y){return new h.NotebookRange(Y.start,Y.end)}ue.to=le})(oe=e.NotebookRange||(e.NotebookRange={}));var fe;(function(ue){function De(le){return new h.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ue.to=De})(fe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var Z;(function(ue){function De(Y){return Y}ue.from=De;function le(Y){return new h.NotebookDocumentMetadata().with(Y)}ue.to=le})(Z=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(ue){function De(Y){return{startTime:Y.runStartTime,endTime:Y.runEndTime,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}ue.to=De;function le(Y){return{lastRunSuccess:Y.success,runStartTime:Y.startTime,runEndTime:Y.endTime,executionOrder:Y.executionOrder}}ue.from=le})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(ue){function De(Y){switch(Y){case h.NotebookCellKind.Markdown:return m.CellKind.Markdown;case h.NotebookCellKind.Code:default:return m.CellKind.Code}}ue.from=De;function le(Y){switch(Y){case m.CellKind.Markdown:return h.NotebookCellKind.Markdown;case m.CellKind.Code:default:return h.NotebookCellKind.Code}}ue.to=le})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(ue){function De(Y){var Ne;return{cellKind:ce.from(Y.kind),language:Y.language,source:Y.source,metadata:Object.assign(Object.assign({},Y.metadata),ne.from((Ne=Y.latestExecutionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:Y.outputs?Y.outputs.map(qe.from):[]}}ue.from=De;function le(Y){return new h.NotebookCellData(ce.to(Y.cellKind),Y.source,Y.language,Y.outputs?Y.outputs.map(qe.to):void 0,Y.metadata?fe.to(Y.metadata):void 0)}ue.to=le})(pe=e.NotebookCellData||(e.NotebookCellData={}));var Se;(function(ue){function De(Y){return{mime:Y.mime,value:Y.value,metadata:Y.metadata}}ue.from=De;function le(Y){return new h.NotebookCellOutputItem(Y.mime,Y.value,Y.metadata)}ue.to=le})(Se=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(ue){function De(Y){return{outputId:Y.id,outputs:Y.outputs.map(Se.from),metadata:Y.metadata}}ue.from=De;function le(Y){const Ne=Y.outputs.map(Se.to);return new h.NotebookCellOutput(Ne,Y.outputId,Y.metadata)}ue.to=le})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Me;(function(ue){function De(Te){if(Te!=null){if(Te instanceof h.RelativePattern||typeof Te=="string")return Te;if(Ne(Te))return new h.RelativePattern(Te.base,Te.pattern);if(Y(Te))return{include:Ye.from(Te.include)||void 0,exclude:Ye.from(Te.exclude)||void 0}}}ue.from=De;function le(Te){return typeof Te=="string"?Te:Ne(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=le;function Y(Te){const Je=Te,et=Ye.from(Je.include);if(!(et&&et instanceof h.RelativePattern||typeof et=="string"))return!1;const ut=Ye.from(Je.exclude);return!!(ut&&ut instanceof h.RelativePattern||typeof ut=="string")}function Ne(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Me=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var He;(function(ue){function De(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?d.from(le.top):void 0}}ue.from=De})(He=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(ue){function De(le,Y,Ne){const Te=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Te,Ne),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ue.from=De})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(ue){function De(le){var Y,Ne,Te;return{transientOutputs:(Y=le==null?void 0:le.transientOutputs)!==null&&Y!==void 0?Y:!1,transientCellMetadata:Object.assign(Object.assign({},(Ne=le==null?void 0:le.transientCellMetadata)!==null&&Ne!==void 0?Ne:le==null?void 0:le.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Te=le==null?void 0:le.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}ue.from=De})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var at;(function(ue){function De(Y){var Ne;return{uri:Y.uri,provides:typeof Y.provides=="string"?[Y.provides]:(Ne=Y.provides)!==null&&Ne!==void 0?Ne:[]}}ue.from=De;function le(Y){return{uri:y.URI.revive(Y.uri),provides:Y.provides}}ue.to=le})(at=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ze;(function(ue){function De(Y){return{message:o.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?O.from(Y.location):void 0}}ue.from=De;function le(Y){const Ne=new h.TestMessage(typeof Y.message=="string"?Y.message:o.to(Y.message));return Ne.severity=Y.severity,Ne.actualOutput=Y.actualOutput,Ne.expectedOutput=Y.expectedOutput,Ne}ue.to=le})(Ze=e.TestMessage||(e.TestMessage={}));var nt;(function(ue){function De(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0}}ue.from=De;function le(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:!1,description:Te.description,runnable:!0}}ue.fromResultSnapshot=le;function Y(Te){return{id:Te.extId,label:Te.label,uri:y.URI.revive(Te.uri),range:w.to(Te.range),addChild:()=>{},dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=Y;function Ne(Te){const Je=new h.TestItemImpl(Te.extId,Te.label,y.URI.revive(Te.uri),void 0);return Je.range=w.to(Te.range),Je.debuggable=Te.debuggable,Je.description=Te.description,Je.runnable=Te.runnable,Je}ue.to=Ne})(nt=e.TestItem||(e.TestItem={}));var dt;(function(ue){const De=(Y,Ne)=>Object.assign(Object.assign({},nt.toPlain(Y.item)),{taskStates:Y.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(Ze.to)})),children:Y.children.map(Te=>Ne.get(Te)).filter(P.isDefined).map(Te=>De(Te,Ne))});function le(Y){const Ne=[],Te=new Map;for(const Je of Y.items)Te.set(Je.item.extId,Je),Je.direct&&Ne.push(Je);return{completedAt:Y.completedAt,results:Ne.map(Je=>De(Je,Te))}}ue.to=le})(dt=e.TestResults||(e.TestResults={}));var _t;(function(ue){function De(le){switch(le){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}ue.to=De})(_t=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[216],ge([0,1,2,18,7,20,56]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,r,C,g={timeout:1500,errors:3}){this._logService=k,this._documents=r,this._mainThreadBulkEdits=C,this._thresholds=g,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(r,C,g)=>{const a={dispose:this._callbacks.push([r,C,k])};return Array.isArray(g)&&g.push(a),a}}async $participateInSave(k,r){const C=b.URI.revive(k);let g=!1;const m=setTimeout(()=>g=!0,this._thresholds.timeout),a=[];try{for(let h of[...this._callbacks]){if(g)break;const S=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(h,{document:S,reason:A.TextDocumentSaveReason.to(r)});a.push(w)}}finally{clearTimeout(m)}return a}_deliverEventAsyncAndBlameBadListeners([k,r,C],g){const m=this._badListeners.get(k);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,k,r,g).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const h=this._badListeners.get(k);this._badListeners.set(k,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,r,C,g){const m=[],a=Date.now(),{document:h,reason:S}=g,{version:w}=h,_=Object.freeze({document:h,reason:S,waitUntil(p){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(p))}});try{r.apply(C,[_])}catch(p){return Promise.reject(p)}return Object.freeze(m),new Promise((p,c)=>{const f=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(f),p(t)}).catch(t=>{clearTimeout(f),c(t)})}).then(p=>{const c={edits:[]};for(const f of p)if(Array.isArray(f)&&f.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:s}of f)c.edits.push({_type:2,resource:h.uri,edit:{range:s&&A.Range.from(s),text:t,eol:n&&A.EndOfLine.from(n)}});if(c.edits.length!==0)return w===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(me[217],ge([0,1,3,19,33,2,20,7]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(C,g,m,a,h){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,m&&(this._config+=1),a&&(this._config+=2),h&&(this._config+=4);const S=(0,T.parse)(g),w=C(_=>{if(!m)for(let p of _.created){const c=A.URI.revive(p);S(c.fsPath)&&this._onDidCreate.fire(c)}if(!a)for(let p of _.changed){const c=A.URI.revive(p);S(c.fsPath)&&this._onDidChange.fire(c)}if(!h)for(let p of _.deleted){const c=A.URI.revive(p);S(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(C,g,m){this._logService=g,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,g,m,a){return new y(this._onFileSystemEvent.event,C,g,m,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,g){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(m=>A.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,g){return(m,a,h)=>{const S=function(_){m.call(a,_)};return S.extension=C,g.event(S,void 0,h)}}async $onWillRunFileOperation(C,g,m,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(h=>({oldUri:A.URI.revive(h.source),newUri:A.URI.revive(h.target)}))},m,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(h=>A.URI.revive(h.target))},m,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(h=>A.URI.revive(h.target))},m,a)}}async _fireWillEvent(C,g,m,a){const h=new Set,S=[];if(await C.fireAsync(g,a,async(_,p)=>{var c;const f=Date.now(),t=await Promise.resolve(_);t instanceof P.WorkspaceEdit&&(S.push(t),h.add((c=p.extension.displayName)!==null&&c!==void 0?c:p.extension.identifier.value)),Date.now()-f>m&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),!a.isCancellationRequested&&S.length!==0){const w={edits:[]};for(let _ of S){let{edits:p}=D.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(p)}return{edit:w,extensionNames:Array.from(h)}}}}e.ExtHostFileSystemEventService=k}),define(me[218],ge([0,1,11,23,2,20,7,88]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(g,m,a,h){this.start=g,this.deletedCount=m,this.deletedItems=a,this.items=h}static asApiEvents(g){return g.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(a=>a.cell)}))}}class k{constructor(g,m,a){var h;this._notebook=g,this._extHostDocument=m,this._cellData=a,this.handle=a.handle,this.uri=T.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(h=a.metadata)!==null&&h!==void 0?h:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(g,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:g}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const g=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return g._notebook.getCellIndex(g)},notebook:g._notebook.notebookDocument,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return g._outputs.slice(0)},get metadata(){return g._metadata},get latestExecutionSummary(){return g._previousResult}})}return this._cell}setOutputs(g){this._outputs=g.map(A.NotebookCellOutput.to)}setOutputItems(g,m,a){const h=a.map(A.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===g);S&&(m||(S.outputs.length=0),S.outputs.push(...h))}setMetadata(g){this._internalMetadata=g,this._metadata=A.NotebookCellMetadata.to(g),this._previousResult=A.NotebookCellPreviousExecutionResult.to(g)}}e.ExtHostCell=k;class r{constructor(g,m,a,h,S,w,_){this._proxy=g,this._textDocumentsAndEditors=m,this._textDocuments=a,this._emitter=h,this._viewType=S,this._metadata=w,this.uri=_,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const g=this;this._notebook={get uri(){return g.uri},get version(){return g._versionId},get viewType(){return g._viewType},get isDirty(){return g._isDirty},get isUntitled(){return g.uri.scheme===b.Schemas.untitled},get isClosed(){return g._disposed},get metadata(){return g._metadata},get cellCount(){return g._cells.length},cellAt(m){return m=g._validateIndex(m),g._cells[m].cell},getCells(m){return(m?g._getCells(m):g._cells).map(h=>h.cell)},save(){return g._save()}}}return this._notebook}updateBackup(g){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=g}disposeBackup(){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(g){g.metadata&&(this._metadata=this._metadata.with(g.metadata))}acceptModelChanged(g,m){this._versionId=g.versionId,this._isDirty=m;for(const a of g.rawEvents)a.kind===P.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===P.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===P.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(g){return g<0?0:g>=this._cells.length?this._cells.length-1:g}_validateRange(g){return g.start<0&&(g=g.with({start:0})),g.end>this._cells.length&&(g=g.with({end:this._cells.length})),g}_getCells(g){g=this._validateRange(g);const m=[];for(let a=g.start;a<g.end;a++)m.push(this._cells[a]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(g,m){if(!this._disposed){const a=[],h=[],S=[];g.reverse().forEach(w=>{const p=w[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return m||h.push(k.asModelAddData(this.notebookDocument,t)),n}),c=new y(w[0],w[1],[],p),f=this._cells.splice(w[0],w[1],...p);for(let t of f)S.push(t.uri),c.deletedItems.push(t.cell);a.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:S}),m||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(a)}))}}_moveCell(g,m){const a=this._cells.splice(g,1);this._cells.splice(m,0,...a);const h=[new y(g,1,a.map(S=>S.cell),[]),new y(m,0,[],a)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(h)}))}_setCellOutputs(g,m){const a=this._cells[g];a.setOutputs(m),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[a.cell]}))}_setCellOutputItems(g,m,a,h){const S=this._cells[g];S.setOutputItems(m,a,h),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.notebookDocument,cells:[S.cell]}))}_changeCellLanguage(g,m){const a=this._cells[g];a.cell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(a.uri,m)}_changeCellMetadata(g,m){var a;const h=this._cells[g],S=h.internalMetadata,w=h.cell.metadata;h.setMetadata(m);const _=h.cell.metadata;if((0,I.equals)(w,_)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.notebookDocument,cell:h.cell})),S.runState!==m.runState){const p=(a=m.runState)!==null&&a!==void 0?a:D.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.notebookDocument,cell:h.cell,executionState:p}))}}getCellFromIndex(g){return this._cells[g]}getCell(g){return this._cells.find(m=>m.handle===g)}getCellIndex(g){return this._cells.indexOf(g)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(me[219],ge([0,1,7,20]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(P){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=P}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(P){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:P})}replaceCellMetadata(P,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:P,metadata:y})}replaceCellOutput(P,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:P,outputs:y.map(k=>I.NotebookCellOutput.from(k))})}replaceCells(P,y,k){this._throwIfFinalized(),!(P===y&&k.length===0)&&this._collectedEdits.push({editType:1,index:P,count:y-P,cells:k.map(I.NotebookCellData.from)})}}class A{constructor(P,y,k,r,C,g){this.id=P,this._proxy=y,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=r,this._viewColumn=g}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.notebookDocument},get selections(){return P._selections},get visibleRanges(){return P._visibleRanges},revealRange(y,k){P._proxy.$tryRevealRange(P.id,I.NotebookRange.from(y),k!=null?k:b.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn},edit(y){const k=new T(this.document.version);return y(k),P._applyEdit(k.finalize())},get kernel(){return P._kernel},setDecorations(y,k){return P.setDecorations(y,k)}}}return this._editor}_acceptKernel(P){this._kernel=P}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_acceptViewColumn(P){this._viewColumn=P}_applyEdit(P){if(P.cellEdits.length===0)return Promise.resolve(!0);const y=[];let k=-1;for(let r=0;r<P.cellEdits.length;r++){if(k<0){y.push(P.cellEdits[r]),k++;continue}const g=y[k],m=P.cellEdits[r];if(g.editType===1&&m.editType===1&&g.index===m.index){g.cells.push(...P.cellEdits[r].cells),g.count+=P.cellEdits[r].count;continue}y.push(P.cellEdits[r]),k++}return this._proxy.$tryApplyEdits(this.id,P.documentVersionId,y)}setDecorations(P,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(P.key)))return y.isEmpty?this._hasDecorationsForKey.delete(P.key):this._hasDecorationsForKey.add(P.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(y),P.key)}}e.ExtHostNotebookEditor=A}),define(me[220],ge([0,1,20,114,163,21,70]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,g,m){const a=this._handles++,{title:h,location:S,cancellable:w}=g,_={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:b.ProgressLocation.from(S),title:h,source:_,cancellable:w},C),this._withProgress(a,m,!!w)}_withProgress(C,g,m){let a;m&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const h=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let S;try{S=g(new k(this._proxy,C),m&&a?a.token:A.CancellationToken.None)}catch(w){throw h(C),w}return S.then(w=>h(C),w=>h(C)),S}$acceptProgressCanceled(C){const g=this._mapHandleToCancellationSource.get(C);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=P;function y(r,C){return r.message=C.message,typeof C.increment=="number"&&(typeof r.increment=="number"?r.increment+=C.increment:r.increment=C.increment),r}class k extends I.Progress{constructor(C,g){super(m=>this.throttledReport(m));this._proxy=C,this._handle=g}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}je([(0,D.throttle)(100,(r,C)=>y(r,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(me[123],ge([0,1,52,18,72,20,7]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(g,m){const a=P._Keys.nextId();g.$registerTextEditorDecorationType(a,A.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){g.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new T.IdGenerator("TextEditorDecorationType");class y{constructor(g,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,m){this._throwIfFinalized();let a=null;if(g instanceof D.Position)a=new D.Range(g,g);else if(g instanceof D.Range)a=g;else throw new Error("Unrecognized location");this._pushEdit(a,m,!1)}insert(g,m){this._throwIfFinalized(),this._pushEdit(new D.Range(g,g),m,!0)}delete(g){this._throwIfFinalized();let m=null;if(g instanceof D.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(g,m,a){const h=this._document.validateRange(g);this._collectedEdits.push({range:h,text:m,forceMoveMarkers:a})}setEndOfLine(g){if(this._throwIfFinalized(),g!==D.EndOfLine.LF&&g!==D.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=y;class k{constructor(g,m,a,h){this._proxy=g,this._id=m,this._accept(a),this._logService=h;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const m=Math.floor(g);return m>0?m:null}if(typeof g=="string"){const m=parseInt(g,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(g){const m=this._validateTabSize(g);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const m=this._validateInsertSpaces(g);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(g)})))}assign(g){const m={};let a=!1;if(typeof g.tabSize!="undefined"){const h=this._validateTabSize(g.tabSize);h==="auto"?(a=!0,m.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,a=!0,m.tabSize=h)}if(typeof g.insertSpaces!="undefined"){const h=this._validateInsertSpaces(g.insertSpaces);h==="auto"?(a=!0,m.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,a=!0,m.insertSpaces=h)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,a=!0,m.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,a=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(g.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(g){g.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=k;class r{constructor(g,m,a,h,S,w,_,p){this.id=g,this._proxy=m,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new k(this._proxy,this.id,w,a),this._visibleRanges=_,this._viewColumn=p;const c=this;this.value=Object.freeze({get document(){return h.getValue()},set document(f){throw(0,I.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(f){if(!(f instanceof D.Selection))throw(0,I.illegalArgument)("selection");c._selections=[f],c._trySetSelection()},get selections(){return c._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof D.Selection)))throw(0,I.illegalArgument)("selections");c._selections=f,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(f){throw(0,I.readonly)("visibleRanges")},get options(){return c._options.value},set options(f){c._disposed||c._options.assign(f)},get viewColumn(){return c._viewColumn},set viewColumn(f){throw(0,I.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new y(h.getValue(),t);return f(n),c._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c._selections.map(i=>A.Range.from(i));else if(t instanceof D.Position){const{lineNumber:i,column:l}=A.Position.from(t);s=[{startLineNumber:i,startColumn:l,endLineNumber:i,endColumn:l}]}else if(t instanceof D.Range)s=[A.Range.from(t)];else{s=[];for(const i of t)if(i instanceof D.Range)s.push(A.Range.from(i));else{const{lineNumber:l,column:o}=A.Position.from(i);s.push({startLineNumber:l,startColumn:o,endLineNumber:l,endColumn:o})}}return m.$tryInsertSnippet(g,f.value,s,n)},setDecorations(f,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(f.key)||(n?c._hasDecorationsForKey.delete(f.key):c._hasDecorationsForKey.add(f.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return m.$trySetDecorations(g,f.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,l=t.length;i<l;i++){const o=t[i];s[4*i]=o.start.line+1,s[4*i+1]=o.start.character+1,s[4*i+2]=o.end.line+1,s[4*i+3]=o.end.character+1}return m.$trySetDecorationsFast(g,f.key,s)}}))},revealRange(f,t){c._runOnProxy(()=>m.$tryRevealRange(g,A.Range.from(f),t||D.TextEditorRevealType.Default))},show(f){m.$tryShowEditor(g,A.ViewColumn.from(f))},hide(){m.$tryHideEditor(g)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,b.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,b.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,b.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,b.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const m=g.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const a=m.edits.map(S=>S.range);a.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=a.length-1;S<w;S++){const _=a[S].end;if(a[S+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=m.edits.map(S=>({range:A.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,h,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=r}),define(me[221],ge([0,1,166,25,2,3,6,19,7,12,15,20,21]),function(G,e,b,I,T,A,D,P,y,k,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(S,w){if((0,k.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class a{constructor(w,_,p){this._proxy=w,this.commands=_,this.logService=p,this.treeViews=new Map;function c(f){return f&&f.$treeViewId&&f.$treeItemHandle}_.registerArgumentProcessor({processArgument:f=>c(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>c(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(w,_,p){const c=this.createTreeView(w,{treeDataProvider:_},p);return{dispose:()=>c.dispose()}}createTreeView(w,_,p){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany}),f=this.createExtHostTreeView(w,_,p);return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get message(){return f.message},set message(t){f.message=t},get title(){return f.title},set title(t){f.title=t},get description(){return f.description},set description(t){f.description=t},reveal:(t,n)=>f.reveal(t,n),dispose:async()=>{await c,this.treeViews.delete(w),f.dispose()}}}$getChildren(w,_){const p=this.treeViews.get(w);return p?p.getChildren(_):Promise.reject(new Error((0,b.localize)(0,null,w)))}async $hasResolve(w){const _=this.treeViews.get(w);if(!_)throw new Error((0,b.localize)(1,null,w));return _.hasResolve}$resolve(w,_,p){const c=this.treeViews.get(w);if(!c)throw new Error((0,b.localize)(2,null,w));return c.resolveTreeItem(_,p)}$setExpanded(w,_,p){const c=this.treeViews.get(w);if(!c)throw new Error((0,b.localize)(3,null,w));c.setExpanded(_,p)}$setSelection(w,_){const p=this.treeViews.get(w);if(!p)throw new Error((0,b.localize)(4,null,w));p.setSelection(_)}$setVisible(w,_){const p=this.treeViews.get(w);if(!p)throw new Error((0,b.localize)(5,null,w));p.setVisible(_)}createExtHostTreeView(w,_,p){const c=new h(w,_,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(w,c),c}convertArgument(w){const _=this.treeViews.get(w.$treeViewId);return _?_.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class h extends D.Disposable{constructor(w,_,p,c,f,t){super();if(this.viewId=w,this.proxy=p,this.commands=c,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const l of t.contributes.views[i])l.id===w&&(this._title=l.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,s;this._register(A.Event.debounce(this._onDidChangeData.event,(i,l)=>(i||(i={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(o=>s=o),this.refreshPromise=this.refreshPromise.then(()=>n)),i.elements.push(l.element)),l.message&&(i.message=!0),i),200,!0)(({message:i,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=s;return n=null,this.refresh(l).then(()=>o())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,k.isUndefinedOrNull)(w))}getChildren(w){const _=w?this.getExtensionElement(w):void 0;if(w&&!_)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(w);return(p?Promise.resolve(p):this.fetchChildrenNodes(_)).then(c=>c.map(f=>f.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,_){_=_||{select:!0,focus:!1};const p=(0,k.isUndefinedOrNull)(_.select)?!0:_.select,c=(0,k.isUndefinedOrNull)(_.focus)?!1:_.focus,f=(0,k.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:p,focus:c,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:c,expand:f})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,_){const p=this.getExtensionElement(w);p&&(_?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(w){(0,r.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,_){var p;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(w);if(c){const f=this.nodes.get(c);if(f){const t=(p=await this.dataProvider.resolveTreeItem(f.extensionItem,c,_))!==null&&p!==void 0?p:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(_=>_?this.resolveUnknownParentChain(_).then(p=>this.resolveTreeNode(_,p[p.length-1]).then(c=>(p.push(c),p))):Promise.resolve([]))}resolveParent(w){const _=this.nodes.get(w);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,_){const p=this.nodes.get(w);return p?Promise.resolve(p):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>this.createHandle(w,c,_,!0)).then(c=>this.getChildren(_?_.item.handle:void 0).then(()=>{const f=this.getExtensionElement(c);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(w){if(w){let _;if(typeof w=="string"){const p=this.getExtensionElement(w);_=p?this.nodes.get(p):void 0}else _=w;return _&&_.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const _=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=w?this.nodes.get(w):void 0,c=await this.dataProvider.getChildren(w);if(_.token.isCancellationRequested)return[];const f=await Promise.all((0,r.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,p):null}));return _.token.isCancellationRequested?[]:(0,r.coalesce)(f)}finally{_.dispose()}}refresh(w){if(w.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(w);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const _=new Set,p=w.map(f=>this.nodes.get(f));for(const f of p)if(f&&!_.has(f.item.handle)){let t=f;for(;t&&t.parent&&p.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(f.item.handle)}const c=[];return _.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&c.push(f)}}),c}refreshHandles(w){const _={};return Promise.all(w.map(p=>this.refreshNode(p).then(c=>{c&&(_[p]=c.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(w){const _=this.getExtensionElement(w);if(_){const p=this.nodes.get(_);if(p)return this.clearChildren(_),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(c=>{if(c){const f=this.createTreeNode(_,c,p.parent);return this.updateNodeCache(_,f,p,p.parent),p.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,_,p){const c=this.createTreeNode(w,_,p);if(_.id&&this.elements.has(c.item.handle))throw new Error((0,b.localize)(6,null,_.id));return this.addNodeToCache(w,c),this.addNodeToParentCache(c,p),c}getTooltip(w){return y.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,_){return _?this.commands.toInternal(_,w):void 0}createTreeNode(w,_,p){const c=new D.DisposableStore,f=this.createHandle(w,_,p),t=this.getLightIconPath(_);return{item:{handle:f,parentHandle:p?p.item.handle:void 0,label:m(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(c,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,k.isUndefinedOrNull)(_.collapsibleState)?y.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:p,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(w){return w.iconPath instanceof y.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:_,label:p,resourceUri:c},f,t){if(_)return`${h.ID_HANDLE_PREFIX}/${_}`;const n=m(p,this.extension),s=f?f.item.handle:h.LABEL_HANDLE_PREFIX;let i=n?n.label:c?(0,I.basename)(c):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const l=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,o=this.getChildrenNodes(f)||[];let u,E=0;do{if(u=`${s}/${E}:${i}`,t||!this.elements.has(u)||l===u)break;E++}while(E<=o.length);return u}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof y.ThemeIcon))return typeof w.iconPath=="string"||T.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof y.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return T.URI.isUri(w)?w:T.URI.file(w)}addNodeToCache(w,_){this.elements.set(_.item.handle,w),this.nodes.set(w,_)}updateNodeCache(w,_,p,c){this.elements.delete(_.item.handle),this.nodes.delete(w),_.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(w,_);const f=this.getChildrenNodes(c)||[],t=f.filter(n=>n.item.handle===p.item.handle)[0];t&&f.splice(f.indexOf(t),1,_)}addNodeToParentCache(w,_){_?(_.children||(_.children=[]),_.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const _=this.nodes.get(w);if(_){if(_.children)for(const p of _.children){const c=this.elements.get(p.item.handle);c&&this.clear(c)}_.children=void 0}}else this.clearAll()}clear(w){const _=this.nodes.get(w);if(_){if(_.children)for(const p of _.children){const c=this.elements.get(p.item.handle);c&&this.clear(c)}this.nodes.delete(w),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(me[222],ge([0,1,15,19,21,12,87,20,7,122]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class r{constructor(){this.testIdsToInternal=new Map}getTestById(S,w){if(w!==void 0){const _=this.testIdsToInternal.get(w),p=_==null?void 0:_.get(S);if(p)return[_,p]}return(0,b.mapFind)(this.testIdsToInternal.values(),_=>{const p=_.get(S);return p&&[_,p]})}createForHierarchy(S=()=>{}){return new a(this.createIdMap(g++),S)}createIdMap(S){const w=new m(S);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=r;var C;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let g=0;class m{constructor(S){this.id=S,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(S){if(this.map.has(S.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${S.item.extId}`);this.map.set(S.item.extId,S),S.parent||this._roots.add(S)}has(S){return this.map.has(S)}delete(S){const w=this.map.get(S);return w?(this.map.delete(S),this._roots.delete(w),!0):!1}get(S){return this.map.get(S)}comparePositions(S,w){const _=typeof S=="string"?this.map.get(S):S,p=typeof w=="string"?this.map.get(w):w;if(!_||!p)return 0;if(_===p)return 3;for(let c=this.map.get(p.parent);c;c=this.map.get(c.parent))if(c===_)return 1;for(let c=this.map.get(_.parent);c;c=this.map.get(c.parent))if(c===p)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=m;class a{constructor(S,w){this.testIdToInternal=S,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(S,w){this.addItem(S,w,null)}getTestByReference(S){return this.testItemToInternal.get(S)}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){const w=this.diff[this.diff.length-1];if(w&&S[0]===1){if(w[0]===1&&w[1].extId===S[1].extId){(0,k.applyTestItemUpdate)(w[1],S[1]);return}if(w[0]===0&&w[1].item.extId===S[1].extId){(0,k.applyTestItemUpdate)(w[1],S[1]);return}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,w){var _;const p=this.testIdToInternal.object.get(S);if(!!p){if((p.expandLevels===void 0||w>p.expandLevels)&&(p.expandLevels=w),p.expand===1){const c=this.refreshChildren(p);return c.isSettled?this.expandChildren(p,w-1):c.p.then(()=>this.expandChildren(p,w-1))}else if(p.expand===3)return((_=p.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?p.initialExpand.p.then(()=>this.expandChildren(p,w-1)):this.expandChildren(p,w-1)}}dispose(){var S;for(const w of this.testItemToInternal.values())(S=w.discoverCts)===null||S===void 0||S.dispose(!0),(0,D.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(S,w){const _=S==null?void 0:S.actual.id;switch(w[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(S);break;case 0:this.addItem(w[1],S.src.controller,S);break;case 3:const[p,c,f]=w;switch(c){case"status":this.updateExpandability(S);break;case"range":this.pushDiff([1,{extId:_,item:{range:P.Range.from(f)}}]);break;default:this.pushDiff([1,{extId:_,item:{[c]:f}}]);break}break;default:(0,A.assertNever)(w[0])}}addItem(S,w,_){if(!(S instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${S.id} did not`);if(this.testItemToInternal.has(S))throw new Error(`Attempted to add a single TestItem ${S.id} multiple times to the tree`);if(this.testIdToInternal.object.has(S.id))throw new Error(`Attempted to insert a duplicate test item ID ${S.id}`);const p=_?_.item.extId:null,c=S.resolveHandler?1:0,f=_==null?void 0:_.expandLevels,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:S,parent:p,item:P.TestItem.from(S),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(S,n),this.pushDiff([0,{parent:p,src:t,expand:c,item:n.item}]);const s=(0,D.getPrivateApiFor)(S);s.parent=_==null?void 0:_.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const i of s.children.values())this.testItemToInternal.has(i)||this.addItem(i,w,n)}updateExpandability(S){var w;let _;S.actual.resolveHandler?S.actual.status===y.TestItemStatus.Pending?_=S.discoverCts?2:1:((w=S.initialExpand)===null||w===void 0||w.complete(),_=3):_=0,_!==S.expand&&(S.expand=_,this.pushDiff([1,{extId:S.actual.id,expand:_}]),_===1&&S.expandLevels!==void 0&&this.refreshChildren(S))}expandChildren(S,w){if(!(w<0)){const _=[...S.actual.children.values()].map(p=>this.expand(p.id,w)).filter(I.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(S){if(S.discoverCts&&S.discoverCts.dispose(!0),!S.actual.resolveHandler){const w=new I.DeferredPromise;return w.complete(),w}return S.expand=2,S.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(S),S.initialExpand=new I.DeferredPromise,S.actual.resolveHandler(S.discoverCts.token),S.initialExpand}pushExpandStateUpdate(S){this.pushDiff([1,{extId:S.actual.id,expand:S.expand}])}removeItem(S){var w;this.pushDiff([2,S.actual.id]);const _=[S];for(;_.length;){const p=_.pop();if(!!p){(w=p.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(p.item.extId),this.testItemToInternal.delete(p.actual);for(const c of p.actual.children.values())_.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const S=this.collectDiff();S.length&&this.publishDiff(S)}}e.SingleUseTestCollection=a}),define(me[223],ge([0,1,29,3,8]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=A;class D{constructor(r){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let C of r.activationEvents)C==="onUri"&&(C=`onUri:${b.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(r)}}keepOnly(r){const C=new Set;r.forEach(g=>C.add(b.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>C.has(b.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,C){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const g=D._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(g.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(a=>m.add(b.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!m.has(b.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(g)}static _findLoopingExtensions(r){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const _=C.getArcs(S);for(let p=0;p<_.length;p++)if(!w.has(_[p]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let S of r){const w=b.ExtensionIdentifier.toKey(S.identifier);if(g.set(w,S),S.extensionDependencies)for(let _ of S.extensionDependencies){const p=b.ExtensionIdentifier.toKey(_);C.addArc(w,p)}}let m=new Set;C.getNodes().filter(S=>C.getArcs(S).length===0).forEach(S=>m.add(S));let a=C.getNodes().filter(S=>!m.has(S)),h;do{h=!1;for(let S=0;S<a.length;S++){const w=a[S];C.hasOnlyGoodArcs(w,m)&&(a.splice(S,1),S--,m.add(w),h=!0)}}while(h);return a.map(S=>g.get(S))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const C=this._activationMap.get(r);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const C=this._extensionsMap.get(b.ExtensionIdentifier.toKey(r));return C||void 0}}e.ExtensionDescriptionRegistry=D;var P;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(P||(P={}));function y(k,r){const C=k.isBuiltin?0:k.isUnderDevelopment?2:1,g=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(C!==g)return C-g;const m=T.posix.basename(k.extensionLocation.path),a=T.posix.basename(r.extensionLocation.path);return m<a?-1:m>a?1:0}}),define(me[224],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function A(P){const y=b.VSBuffer.alloc(1);switch(P){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function D(P,y){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(me[41],ge([0,1,3,2,4,29,184]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class P{constructor(_){this.dependency=_}}e.MissingDependencyError=P;var y;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(_,p,c,f){this.codeLoadingTime=_,this.activateCallTime=p,this.activateResolvedTime=c,this.activationReason=f}}e.ActivationTimes=k;class r{constructor(_,p){this.description=_,this.value=p}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function g(w){w.enableProposedApi||m(w)}e.checkProposedApiEnabled=g;function m(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=m;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function h(w){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=h;class S{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(_,p){}_activateById(_,p){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,p,c,f,t){}_onExtensionRuntimeError(_,p){}_onExtensionHostExit(_){}}e.NullExtensionService=S}),define(me[225],ge([0,1,161,29,41,13]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class P{constructor(h,S,w,_){this.startup=h,this.codeLoadingTime=S,this.activateCallTime=w,this.activateResolvedTime=_}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class y{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,S){return h===-1||S===-1?-1:S-h}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class k{constructor(h,S,w,_,p,c){this.activationFailed=h,this.activationFailedError=S,this.activationTimes=w,this.module=_,this.exports=p,this.subscriptions=c}}e.ActivatedExtension=k;class r extends k{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=r;class C extends k{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class g extends k{constructor(h){super(!0,h,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let m=class{constructor(h,S,w,_,p){this._logService=p,this._registry=h,this._resolvedExtensionsSet=new Set,S.forEach(c=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,w.forEach(c=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(c),c)),this._host=_,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const S=I.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(S)}getActivatedExtension(h){const S=I.ExtensionIdentifier.toKey(h),w=this._activatedExtensions.get(S);if(!w)throw new Error("Extension `"+h.value+"` is not known or not activated");return w}activateByEvent(h,S){if(this._alreadyActivatedEvents[h])return D;const w=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(w.map(_=>({id:_.identifier,reason:{startup:S,extensionId:_.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,S){const w=this._registry.getExtensionDescription(h);if(!w)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:w.identifier,reason:S}])}_handleActivateRequest(h,S,w){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(h.id))){S[I.ExtensionIdentifier.toKey(h.id)]=h;return}const _=this._registry.getExtensionDescription(h.id);if(!_){this._host.onExtensionActivationError(h.id,new T.MissingDependencyError(h.id.value));const f=new Error(`Unknown dependency '${h.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(h.id),new g(f));return}const p=typeof _.extensionDependencies=="undefined"?[]:_.extensionDependencies;let c=!0;for(let f=0,t=p.length;f<t;f++){const n=p[f];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(n))){const s=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(n));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(_.identifier,b.localize(0,null,_.displayName||_.identifier.value,n));const o=new Error(`Dependency ${n} failed to activate`);o.detail=s.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(_.identifier),new g(o));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n))){c=!1,S[I.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(n)),reason:h.reason};continue}const i=this._registry.getExtensionDescription(n);if(i){c=!1,S[I.ExtensionIdentifier.toKey(n)]={id:i.identifier,reason:h.reason};continue}this._host.onExtensionActivationError(_.identifier,new T.MissingDependencyError(n));const l=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(_.identifier),new g(l));return}}}c?S[I.ExtensionIdentifier.toKey(_.identifier)]=h:w.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(p=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(p.id))),h.length===0))return Promise.resolve(void 0);const S=Object.create(null),w=[];for(let p=0,c=h.length;p<c;p++)this._handleActivateRequest(h[p],S,w);for(let p=0,c=w.length;p<c;p++){const f=I.ExtensionIdentifier.toKey(w[p].id);S[f]&&delete S[f]}const _=Object.keys(S).map(p=>S[p]);return w.length===0?Promise.all(_.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(_).then(p=>this._activateExtensions(w))}_activateExtension(h,S){const w=I.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const _=this._activatingExtensions.get(w);if(_)return _;const p=this._host.actualActivateExtension(h,S).then(void 0,c=>(this._host.onExtensionActivationError(h,b.localize(1,null,h.value,c.message)),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(c),new g(c))).then(c=>{this._activatedExtensions.set(w,c),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,p),p}};m=je([Be(4,A.ILogService)],m),e.ExtensionsActivator=m}),define(me[226],ge([0,1,13,41,27,11,112]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends b.LogService{constructor(k){if(k.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new D.SpdLogLogger(I.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};P=je([Be(0,T.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(me[227],ge([0,1,18]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,D)=>{this._actualOk=A,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,b.onUnexpectedError)(A))}then(A,D){return this._ensureActual().then(A,D)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(me[124],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(y,k){this.isMain=y,this.sid=k,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const I=[];function T(P){const y=new b(!0,P);return I[y.nid]=y,y}e.createMainContextProxyIdentifier=T;function A(P){const y=new b(!1,P);return I[y.nid]=y,y}e.createExtHostContextProxyIdentifier=A;function D(P){return I[P].sid}e.getStringIdentifierForProxy=D}),define(me[5],ge([0,1,2,124,58]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var D;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var r;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(r=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(c){c.name="$ident";function f(n,s){return Object.defineProperty(n,c.name,{value:s,enumerable:!0}),n}c.mixin=f;function t(n){return n[c.name]}c.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(f){return f._id=a._n++,f}}e.IdObject=a,a._n=0;var h;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var S;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(S=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(c){if(c&&c.edits)for(const f of c.edits)typeof f.resource=="object"?f.resource=b.URI.revive(f.resource):(f.newUri=b.URI.revive(f.newUri),f.oldUri=b.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,T.revive)(f.metadata));return c}e.reviveWorkspaceEditDto=_;var p;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[89],ge([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,y){return this._proxy.$getPassword(P,y)}store(P,y,k){return this._proxy.$setPassword(P,y,k)}delete(P,y){return this._proxy.$deletePassword(P,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,13,5,14]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,k,r){const C=this.getUsageKey(y,k);this._reportedUsages.has(C)||(this._reportedUsages.add(C),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};D=je([Be(0,A.IExtHostRpcService),Be(1,I.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(P,y,k){}})}),define(me[228],ge([0,1,3,5,7,29]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,k,r,C={}){const g=A.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(g)||[],a=r.sort().join(" ");let h=m.find(S=>S.scopes===a);if(h)return h.result;{const S=this._getSession(y,g,k,r,C);h={scopes:a,result:S},m.push(h),this._inFlightRequests.set(g,m);try{await S}finally{const w=m.findIndex(_=>_.scopes===a);w>-1&&(m.splice(w),this._inFlightRequests.set(g,m))}return S}}async _getSession(y,k,r,C,g={}){await this._proxy.$ensureProvider(r);const m=y.displayName||y.name;return this._proxy.$getSession(r,C,k,m,g)}async removeSession(y,k){const r=this._authenticationProviders.get(y);return r?r.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,r,C){var g;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:r,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===y)||this._providers.push({id:y,label:k});const m=r.onDidChangeSessions(a=>{var h,S,w;this._proxy.$sendDidChangeSessions(y,{added:(h=a.added)!==null&&h!==void 0?h:[],changed:(S=a.changed)!==null&&S!==void 0?S:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(y,k,(g=C==null?void 0:C.supportsMultipleAccounts)!==null&&g!==void 0?g:!1),new T.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const a=this._providers.findIndex(h=>h.id===y);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const r=this._authenticationProviders.get(y);if(r)return Promise.resolve(r.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const r=this._authenticationProviders.get(y);if(r)return Promise.resolve(r.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const r=this._authenticationProviders.get(y);if(r)return Promise.resolve(r.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,k){return y.forEach(r=>{this._providers.some(C=>C.id===r.id)||this._providers.push(r)}),k.forEach(r=>{const C=this._providers.findIndex(g=>g.id===r.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(me[229],ge([0,1,5,14,20]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,y){this._extHostDocumentsAndEditors=y,this._proxy=P.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const y=T.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=je([Be(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(me[230],ge([0,1,5]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const D=A.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(P){return D.$writeText(P)}})}}e.ExtHostClipboard=I}),define(me[51],ge([0,1,12,7,20,23,5,15,13,58,44,49,2,6,4,14]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return(i==null?void 0:i.result)===p.Void?i:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,A.cloneAndChange)(s,function(i){if(r.Range.isIRange(i))return T.Range.to(i);if(C.Position.isIPosition(i))return T.Position.to(i);if(r.Range.isIRange(i.range)&&g.URI.isUri(i.uri))return T.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((o,u)=>{if(!o.validate(s[u]))throw new Error(`Invalid argument '${o.name}' when running '${t.id}', received: ${s[u]}`);return o.convert(s[u])}),l=await this.executeCommand(t.internalId,...i);return t.result.convert(l,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,i,l){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:i,description:l}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const i=(0,A.cloneAndChange)(n,function(l){if(l instanceof I.Position)return T.Position.from(l);if(l instanceof I.Range)return T.Range.from(l);if(l instanceof I.Location)return T.location.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,i,s);return(0,k.revive)(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw l}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:l,description:o}=s;if(o)for(let u=0;u<o.args.length;u++)try{(0,b.validateConstraint)(n[u],o.args[u].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${o.args[u].name}' - ${o.args[u].description}`)}try{return await i.apply(l,n)}catch(u){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...n);E&&(t=E.command)}throw this._logService.error(u,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((i,l)=>l.processArgument(i),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:i}=s;i&&(t[n]=i)}return Promise.resolve(t)}};S=je([Be(0,h.IExtHostRpcService),Be(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((l,o)=>l.convert(t.arguments&&t.arguments[o]));else if((0,P.isNonEmptyArray)(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),n.add((0,m.toDisposable)(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),s.$ident=l,s.id=this.delegatingCommandId,s.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return s}}fromInternal(t){const n=D.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class _{constructor(t,n,s,i){this.name=t,this.description=n,this.validate=s,this.convert=i}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",f=>g.URI.isUri(f),f=>f),_.Position=new _("position","A position in a text document",f=>I.Position.isPosition(f),T.Position.from),_.Range=new _("range","A range in a text document",f=>I.Range.isRange(f),T.Range.from),_.Selection=new _("selection","A selection in a text document",f=>I.Selection.isSelection(f),T.Selection.from),_.Number=new _("number","",f=>typeof f=="number",f=>f),_.String=new _("string","",f=>typeof f=="string",f=>f),_.CallHierarchyItem=new _("item","A call hierarchy item",f=>f instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class p{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=p,p.Void=new p("no result",f=>f);class c{constructor(t,n,s,i,l){this.id=t,this.internalId=n,this.description=s,this.args=i,this.result=l}}e.ApiCommand=c}),define(me[231],ge([0,1,6,20,7,80,51,203,15,109]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const r=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(I.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,h)=>{if(!(0,y.isFalsyOrEmpty)(a)){class S extends T.SymbolInformation{static to(_){const p=new S(_.name,I.SymbolKind.to(_.kind),_.containerName||"",new T.Location(h[0],I.Range.to(_.range)));return p.detail=_.detail,p.range=p.location.range,p.selectionRange=I.Range.to(_.selectionRange),p.children=_.children?_.children.map(S.to):[],p}}return a.map(S.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new D.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(I.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(I.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(h=>T.Position.isPosition(h)),a=>a.map(I.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(h=>{let S;for(const w of h.reverse())S=new T.SelectionRange(I.Range.to(w),S);return S}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const h=[];if(Array.isArray(a))for(let S of a)h.push(...S[1].map(I.WorkspaceSymbol.to));return h})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const h=(0,k.decodeSemanticTokensDto)(a);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const h=(0,k.decodeSemanticTokensDto)(a);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,h,S)=>{if(!a)return new T.CompletionList([]);const w=a.suggestions.map(_=>I.CompletionItem.to(_,S));return new T.CompletionList(w,a.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,h,S)=>g(w=>new T.CodeLens(I.Range.to(w.range),w.command&&S.fromInternal(w.command)))(a))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>T.Range.isRange(a),a=>T.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,h,S)=>g(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(w.command)}else{const _=new T.CodeAction(w.title,w.kind?new T.CodeActionKind(w.kind):void 0);return w.edit&&(_.edit=I.WorkspaceEdit.to(w.edit)),w.command&&(_.command=S.fromInternal(w.command)),_.isPreferred=w.isPreferred,_}})(a))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(h=>new T.ColorInformation(I.Range.to(h.range),I.Color.to(h.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",a=>a instanceof T.Color,I.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(I.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientMetadata:a.options.transientCellMetadata,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(h=>I.NotebookExclusiveDocumentPattern.to(h))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],D.ApiCommandResult.Void)];class C{constructor(h){this._disposables=new b.DisposableStore,this._commands=h}static register(h){return r.forEach(h.registerApiCommand,h),new C(h).registerCommands()}registerCommands(){const h=S=>(...w)=>S(this._commands,...w);this._register(P.RemoveFromRecentlyOpenedAPICommand.ID,h(P.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(P.OpenIssueReporter.ID,h(P.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(h,S,w){const _=this._commands.registerCommand(!1,h,S,this,w);this._disposables.add(_)}}e.ExtHostApiCommands=C;function g(a){return h=>{if(Array.isArray(h))return h.map(a)}}function m(a){if(!!Array.isArray(a)){const h=[];for(const S of a)A.isLocationLink(S)?h.push(I.DefinitionLink.to(S)):h.push(I.location.to(S));return h}}}),define(me[232],ge([0,1,19,70,3,6,2,80,29,20,7,5]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class g{constructor(c,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(C.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let l=n.commentUniqueId,o=i.getCommentByUniqueId(l);return o||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let l=n.text,o=n.commentUniqueId,u=i.getCommentByUniqueId(o);return u?(u.body=l,u):n}return n}})}createCommentController(c,f,t){const n=g.handlePool++,s=new a(c,n,this._proxy,f,t);this._commentControllers.set(s.handle,s);const i=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return i.push(s),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),i),s}$createCommentThreadTemplate(c,f,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(c,f,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(c,f){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(c,f,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(D.URI.revive(f));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(i=>i?i.map(l=>k.Range.from(l)):void 0)}$toggleReaction(c,f,t,n,s){const i=this._commentControllers.get(c);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const l=i.getCommentThread(f);if(l){const o=l.getCommentByUniqueId(n.uniqueIdInThread);if(i!==void 0&&o&&i.reactionHandler)return i.reactionHandler(o,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=g,g.handlePool=0;class m{constructor(c,f,t,n,s,i,l){this._proxy=c,this._commentController=f,this._id=t,this._uri=n,this._range=s,this._comments=i,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};c("range")&&(f.range=k.Range.from(this._range)),c("label")&&(f.label=this.label),c("contextValue")&&(f.contextValue=this.contextValue),c("comments")&&(f.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(f.collapseState=_(this._collapseState)),c("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}}getCommentByUniqueId(c){for(let f of this._commentsMap){let t=f[0],n=f[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,I.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class a{constructor(c,f,t,n,s){this._extension=c,this._handle=f,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,f,t,n){if(typeof c=="string"){const s=new m(this._proxy,this,c,f,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new m(this._proxy,this,void 0,c,f,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(c,f){const t=new m(this._proxy,this,void 0,D.URI.revive(c),k.Range.to(f),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,f){let t=this._threads.get(c);t&&(t.range=k.Range.to(f))}$deleteCommentThread(c){let f=this._threads.get(c);f&&f.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(p,c,f,t){let n=t.get(f);n||(n=++p.commentHandle,t.set(f,n));const s=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(f.body),userName:f.author.name,userIconPath:s,label:f.label,commentReactions:f.reactions?f.reactions.map(i=>S(i)):void 0}}function S(p){return{label:p.label,iconPath:p.iconPath?k.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function w(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?D.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function _(p){if(p!==void 0)switch(p){case r.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(me[125],ge([0,1,2,5,7,4,14,13,15,10,8]),function(G,e,b,I,T,A,D,P,y,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class bn{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const h=bn._handlePool++;this._provider.set(h,{provider:m,extensionId:a}),this._proxy.$registerDecorationProvider(h,a.value);const S=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(h,null);return}let _=(0,y.asArray)(w);if(_.length<=bn._maxEventSize){this._proxy.$onDidChange(h,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,_.length);const p=_.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,y.groupBy)(p,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let f=[];e:for(let t of c){let n;for(let s of t){let i=(0,r.dirname)(s.uri.path);if(n!==i&&(n=i,f.push(s.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(h,f)});return new T.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(m,a,h){if(!this._provider.has(m))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:_}=this._provider.get(m);return await Promise.all(a.map(async p=>{try{const{uri:c,id:f}=p,t=await Promise.resolve(w.provideFileDecoration(b.URI.revive(c),h));if(!t)return;try{T.FileDecoration.validate(t),S[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(c){this._logService.error(c)}})),S}};C._handlePool=0,C._maxEventSize=250,C=je([Be(0,D.IExtHostRpcService),Be(1,P.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(me[233],ge([0,1,160,113,2,5,7,20,3,13,24]),function(G,e,b,I,T,A,D,P,y,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,h,S,w,_){this._name=a,this._owner=h,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,h){if(!a){this.clear();return}this._checkDisposed();let S=[];if(T.URI.isUri(a)){if(!h){this.delete(a);return}this._data.set(a,h.slice()),S=[a]}else if(Array.isArray(a)){S=[];let _;a=[...a].sort(C._compareIndexedTuplesByUri);for(const p of a){const[c,f]=p;if((!_||c.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=c,S.push(c),this._data.set(c,[])),f){const t=this._data.get(c);t&&t.push(...f)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const w=[];for(let _ of S){let p=[];const c=this._data.get(_);if(c)if(c.length>this._maxDiagnosticsPerFile){p=[];const f=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===f[t]&&p.push(P.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;p.push({severity:I.MarkerSeverity.Info,message:(0,b.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=c.map(f=>P.Diagnostic.from(f));w.push([_,p])}this._proxy.$changeMany(this._owner,w)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,h){this._checkDisposed();for(let S of this._data.keys())a.apply(h,[S,this.get(S),this])}get(a){this._checkDisposed();const h=this._data.get(a);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,h){return a[0].toString()<h[0].toString()?-1:a[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=C;let g=class $t{constructor(a,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,$t._debouncer,50),$t._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(a,h){return a?a.concat(h):h}static _mapper(a){const h=[],S=new Set;for(const w of a)typeof w=="string"?S.has(w)||(S.add(w),h.push(T.URI.parse(w))):S.has(w.toString())||(S.add(w.toString()),h.push(w));return Object.freeze(h),{uris:h}}createDiagnosticCollection(a,h){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:_,_logService:p}=this,c=new class{$changeMany(n,s){w.$changeMany(n,s),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),p.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let f;if(!h)h="_generated_diagnostic_collection_name_#"+$t._idPool++,f=h;else if(!S.has(h))f=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do f=h+$t._idPool++;while(S.has(f))}return new class extends C{constructor(){super(h,f,$t._maxDiagnosticsPerFile,c,_);S.set(f,this)}dispose(){super.dispose(),S.delete(f)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const h=new Map,S=[];for(const w of this._collections.values())w.forEach((_,p)=>{let c=h.get(_.toString());typeof c=="undefined"&&(c=S.length,h.set(_.toString(),c),S.push([_,[]])),S[c][1]=S[c][1].concat(...p)});return S}}_getDiagnostics(a){let h=[];for(let S of this._collections.values())S.has(a)&&(h=h.concat(S.get(a)));return h}$acceptMarkersChange(a){if(!this._mirrorCollection){const h="_generated_mirror",S=new C(h,h,$t._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,S),this._mirrorCollection=S}for(const[h,S]of a)this._mirrorCollection.set(T.URI.revive(h),S.map(P.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=je([Be(1,k.ILogService)],g),e.ExtHostDiagnostics=g}),define(me[234],ge([0,1,2,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(D){this._proxy=D.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(P=>P?P.map(y=>b.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(P=>P?b.URI.revive(P):void 0)}}e.ExtHostDialogs=T}),define(me[235],ge([0,1,18,2,7,5,11,21,10]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(C,g,m){this._documentsAndEditors=g,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,g){if(Object.keys(D.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=k._handlePool++;this._documentContentProviders.set(m,g),this._proxy.$registerTextContentProvider(m,C);let a;return typeof g.onDidChange=="function"&&(a=g.onDidChange(h=>{if(h.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(m,h).then(S=>{if(!(!S&&typeof S!="string")){const w=this._documentsAndEditors.getDocument(h);if(!!w){const _=(0,y.splitLines)(S);if(!w.equalLines(_))return this._proxy.$onVirtualDocumentChange(h,S)}}},b.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,g){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(g),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(me[236],ge([0,1,3,6,2,5,119,20,12,23]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(g,m){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const h of a)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const h of a)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!!g){const m=this._documentsAndEditors.getDocument(g);if(m)return m}}getDocument(g){const m=this.getDocumentData(g);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${g}'`);return m.document}ensureDocumentData(g){const m=this._documentsAndEditors.getDocument(g);if(m)return Promise.resolve(m);let a=this._documentLoader.get(g.toString());return a||(a=this._proxy.$tryOpenDocument(g).then(h=>{this._documentLoader.delete(g.toString());const S=T.URI.revive(h);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(S))},h=>(this._documentLoader.delete(g.toString()),Promise.reject(h))),this._documentLoader.set(g.toString(),a)),a}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(m=>T.URI.revive(m))}$acceptModelModeChanged(g,m){const a=T.URI.revive(g),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(m),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(g){const m=T.URI.revive(g),a=this._documentsAndEditors.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(g,m){const a=T.URI.revive(g),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(m),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(g,m,a){const h=T.URI.revive(g),S=this._documentsAndEditors.getDocument(h);if(!S)throw new Error("unknown document");S._acceptIsDirty(a),S.onEvents(m),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:S.document,contentChanges:m.changes.map(w=>({range:P.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(g,m){(0,D.setWordDefinitionFor)(g,m)}}e.ExtHostDocuments=r}),define(me[39],ge([0,1,52,3,6,2,4,5,119,14,123,20,13,24,11,54,134]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(c,f){this._extHostRpc=c,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const f=[],t=[],n=[];if(c.removedDocuments)for(const s of c.removedDocuments){const i=A.URI.revive(s),l=this._documents.get(i);(l==null?void 0:l.unref())&&(this._documents.delete(i),f.push(l.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const i=A.URI.revive(s.uri);let l=this._documents.get(i);if(l&&i.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);l||(l=new w(new y.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,l),t.push(l.value)),l.ref()}if(c.removedEditors)for(const s of c.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&n.push(i)}if(c.addedEditors)for(const s of c.addedEditors){const i=A.URI.revive(s.documentUri);b.ok(this._documents.has(i),`document '${i}' does not exist`),b.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const l=this._documents.get(i).value,o=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>l.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(u=>C.Range.to(u)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,o)}c.newActiveEditor!==void 0&&(b.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,T.dispose)(f),(0,T.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(f),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var f;return(f=this._documents.get(c))===null||f===void 0?void 0:f.value}allDocuments(){return h.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const f=this._editors.get(this._activeEditorId);return c?f:f==null?void 0:f.value}}allEditors(){return[...this._editors.values()]}};_=je([Be(0,k.IExtHostRpcService),Be(1,g.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[237],ge([0,1,2,5,6,7,20,142,10,22]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const a=this._schemes.indexOf(m);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),a=[];let h,S,w=14,_=14;for(const p of m){let c=h?(0,y.commonPrefixLength)(h,p):0;for(c===0?S=1:S=_;c<p.length;c++)c+1===p.length?(w=_,_=9):_+=1,a.push([S,p.toUpperCase().charCodeAt(c),_]),a.push([S,p.toLowerCase().charCodeAt(c),_]),S=_;h=p,_=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(m){this._initStateMachine();const a=[],h=P.LinkComputer.computeLinks({getLineContent(S){return m.lineAt(S-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const S of h){const w=D.DocumentLink.to(S);w.target&&a.push(w)}return a}}class C{constructor(m,a){this._extHostLanguageFeatures=a,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,a,h,S={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,h);let _=2;S.isCaseSensitive&&(_+=1024),S.isReadonly&&(_+=2048),typeof h.copy=="function"&&(_+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(w,a,_).catch(c=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${a}`),console.error(c)});const p=h.onDidChangeFile(c=>{const f=[];for(const t of c){let{uri:n,type:s}=t;if(n.scheme===a){let i;switch(s){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}f.push({resource:n,type:i})}}this._proxy.$onFileSystemChange(w,f)});return(0,T.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(m){const{type:a,ctime:h,mtime:S,size:w}=m;return{type:a,ctime:h,mtime:S,size:w}}$stat(m,a){return Promise.resolve(this._getFsProvider(m).stat(b.URI.revive(a))).then(C._asIStat)}$readdir(m,a){return Promise.resolve(this._getFsProvider(m).readDirectory(b.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this._getFsProvider(m).readFile(b.URI.revive(a))).then(h=>k.VSBuffer.wrap(h))}$writeFile(m,a,h,S){return Promise.resolve(this._getFsProvider(m).writeFile(b.URI.revive(a),h.buffer,S))}$delete(m,a,h){return Promise.resolve(this._getFsProvider(m).delete(b.URI.revive(a),h))}$rename(m,a,h,S){return Promise.resolve(this._getFsProvider(m).rename(b.URI.revive(a),b.URI.revive(h),S))}$copy(m,a,h,S){const w=this._getFsProvider(m);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(b.URI.revive(a),b.URI.revive(h),S))}$mkdir(m,a){return Promise.resolve(this._getFsProvider(m).createDirectory(b.URI.revive(a)))}$watch(m,a,h,S){const w=this._getFsProvider(m).watch(b.URI.revive(h),S);this._watches.set(a,w)}$unwatch(m,a){const h=this._watches.get(a);h&&(h.dispose(),this._watches.delete(a))}$open(m,a,h){const S=this._getFsProvider(m);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(b.URI.revive(a),h))}$close(m,a){const h=this._getFsProvider(m);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(a))}$read(m,a,h,S){const w=this._getFsProvider(m);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const _=k.VSBuffer.alloc(S);return Promise.resolve(w.read(a,h,_.buffer,0,S)).then(p=>_.slice(0,p))}$write(m,a,h,S){const w=this._getFsProvider(m);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,h,S.buffer,0,S.byteLength))}_getFsProvider(m){const a=this._fsProvider.get(m);if(!a){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return a}}e.ExtHostFileSystem=C}),define(me[90],ge([0,1,5,45,7,22,4,14,61]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ft{constructor(C,g){const m=C.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return m.$stat(a).catch(Ft._handleError)},readDirectory(a){return m.$readdir(a).catch(Ft._handleError)},createDirectory(a){return m.$mkdir(a).catch(Ft._handleError)},async readFile(a){return m.$readFile(a).then(h=>h.buffer).catch(Ft._handleError)},writeFile(a,h){return m.$writeFile(a,A.VSBuffer.wrap(h)).catch(Ft._handleError)},delete(a,h){return m.$delete(a,Object.assign({recursive:!1,useTrash:!1},h)).catch(Ft._handleError)},rename(a,h,S){return m.$rename(a,h,Object.assign({overwrite:!1},S)).catch(Ft._handleError)},copy(a,h,S){return m.$copy(a,h,Object.assign({overwrite:!1},S)).catch(Ft._handleError)},isWritableFileSystem(a){const h=g.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};k=je([Be(0,P.IExtHostRpcService),Be(1,y.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(me[238],ge([0,1,6,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(D){this._handlePool=0,this._proxy=D.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,D),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=T}),define(me[239],ge([0,1,2,23,20,7,19,5,10,44,15,12,139,6,109,72,86,47,18]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class p{constructor(V,J){this._documents=V,this._provider=J}provideDocumentSymbols(V,J){const ee=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(ee,J)).then(ae=>{if(!(0,r.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(T.DocumentSymbol.from):p._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(V){var J;V=V.slice(0).sort((we,Ce)=>{let Oe=we.location.range.start.compareTo(Ce.location.range.start);return Oe===0&&(Oe=Ce.location.range.end.compareTo(we.location.range.end)),Oe});const ee=[],ae=[];for(const we of V){const Ce={name:we.name||"!!MISSING: name!!",kind:T.SymbolKind.from(we.kind),tags:((J=we.tags)===null||J===void 0?void 0:J.map(T.SymbolTag.from))||[],detail:"",containerName:we.containerName,range:T.Range.from(we.location.range),selectionRange:T.Range.from(we.location.range),children:[]};for(;;){if(ae.length===0){ae.push(Ce),ee.push(Ce);break}const Oe=ae[ae.length-1];if(k.Range.containsRange(Oe.range,Ce.range)&&!k.Range.equalsRange(Oe.range,Ce.range)){Oe.children&&Oe.children.push(Ce),ae.push(Ce);break}ae.pop()}}return ee}}class c{constructor(V,J,ee){this._documents=V,this._commands=J,this._provider=ee,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,J){const ee=this._documents.getDocument(V),ae=await this._provider.provideCodeLenses(ee,J);if(!(!ae||J.isCancellationRequested)){const we=this._cache.add(ae),Ce=new m.DisposableStore;this._disposables.set(we,Ce);const Oe={cacheId:we,lenses:[]};for(let be=0;be<ae.length;be++)Oe.lenses.push({cacheId:[we,be],range:T.Range.from(ae[be].range),command:this._commands.toInternal(ae[be].command,Ce)});return Oe}}async resolveCodeLens(V,J){var ee;const ae=V.cacheId&&this._cache.get(...V.cacheId);if(!!ae){let we;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?we=ae:we=await this._provider.resolveCodeLens(ae,J),we||(we=ae),!J.isCancellationRequested){const Ce=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Ce)return V.command=this._commands.toInternal((ee=we.command)!==null&&ee!==void 0?ee:c._badCmd,Ce),V}}}releaseCodeLenses(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(Le){return Array.isArray(Le)?Le.map(T.DefinitionLink.from):Le?[T.DefinitionLink.from(Le)]:[]}class t{constructor(V,J){this._documents=V,this._provider=J}provideDefinition(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDefinition(ae,we,ee)).then(f)}}class n{constructor(V,J){this._documents=V,this._provider=J}provideDeclaration(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDeclaration(ae,we,ee)).then(f)}}class s{constructor(V,J){this._documents=V,this._provider=J}provideImplementation(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideImplementation(ae,we,ee)).then(f)}}class i{constructor(V,J){this._documents=V,this._provider=J}provideTypeDefinition(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(ae,we,ee)).then(f)}}class l{constructor(V,J){this._documents=V,this._provider=J}provideHover(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideHover(ae,we,ee)).then(Ce=>{if(!(!Ce||(0,r.isFalsyOrEmpty)(Ce.contents)))return Ce.range||(Ce.range=ae.getWordRangeAtPosition(we)),Ce.range||(Ce.range=new A.Range(we,we)),T.Hover.from(Ce)})}}class o{constructor(V,J){this._documents=V,this._provider=J}provideEvaluatableExpression(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,we,ee)).then(Ce=>{if(Ce)return T.EvaluatableExpression.from(Ce)})}}class u{constructor(V,J){this._documents=V,this._provider=J}provideInlineValues(V,J,ee,ae){const we=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideInlineValues(we,T.Range.to(J),T.InlineValueContext.to(ee),ae)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(Oe=>T.InlineValue.from(Oe))})}}class E{constructor(V,J){this._documents=V,this._provider=J}provideDocumentHighlights(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(ae,we,ee)).then(Ce=>{if(Array.isArray(Ce))return Ce.map(T.DocumentHighlight.from)})}}class d{constructor(V,J){this._documents=V,this._provider=J}provideLinkedEditingRanges(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,we,ee)).then(Ce=>{if(Ce&&Array.isArray(Ce.ranges))return{ranges:(0,r.coalesce)(Ce.ranges.map(T.Range.from)),wordPattern:Ce.wordPattern}})}}class v{constructor(V,J){this._documents=V,this._provider=J}provideReferences(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideReferences(we,Ce,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class R{constructor(V,J,ee,ae,we,Ce,Oe){this._documents=V,this._commands=J,this._diagnostics=ee,this._provider=ae,this._logService=we,this._extension=Ce,this._apiDeprecation=Oe,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=g.Selection.isISelection(J)?T.Selection.to(J):T.Range.to(J),Oe=[];for(const Ie of this._diagnostics.getDiagnostics(V))if(Ce.intersection(Ie.range)&&Oe.push(Ie)>R._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(we,Ce,be,ae)).then(Ie=>{var Re;if(!(!(0,r.isNonEmptyArray)(Ie)||ae.isCancellationRequested)){const We=this._cache.add(Ie),Ee=new m.DisposableStore;this._disposables.set(We,Ee);const Ke=[];for(let X=0;X<Ie.length;X++){const re=Ie[X];!re||(R._isCommand(re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:re.title,command:this._commands.toInternal(re,Ee)})):(be.only&&(re.kind?be.only.contains(re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[We,X],title:re.title,command:re.command&&this._commands.toInternal(re.command,Ee),diagnostics:re.diagnostics&&re.diagnostics.map(T.Diagnostic.from),edit:re.edit&&T.WorkspaceEdit.from(re.edit),kind:re.kind&&re.kind.value,isPreferred:re.isPreferred,disabled:(Re=re.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:We,actions:Ke}}})}async resolveCodeAction(V,J){var ee;const[ae,we]=V,Ce=this._cache.get(ae,we);if(!(!Ce||R._isCommand(Ce))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(Ce,J))!==null&&ee!==void 0?ee:Ce;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}R._maxCodeActionsPerFile=1e3;class L{constructor(V,J){this._documents=V,this._provider=J}provideDocumentFormattingEdits(V,J,ee){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,J,ee)).then(we=>{if(Array.isArray(we))return we.map(T.TextEdit.from)})}}class H{constructor(V,J){this._documents=V,this._provider=J}provideDocumentRangeFormattingEdits(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Range.to(J);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(we,Ce,ee,ae)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class ie{constructor(V,J){this._documents=V,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,J,ee,ae,we){const Ce=this._documents.getDocument(V),Oe=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ce,Oe,ee,ae,we)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class j{constructor(V,J){this._provider=V,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,J){const ee=P.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,J)).then(ae=>{if((0,r.isNonEmptyArray)(ae)){for(const we of ae)if(!!we){if(!we.name){this._logService.warn("INVALID SymbolInformation, lacks name",we);continue}const Ce=P.IdObject.mixin(T.WorkspaceSymbol.from(we));this._symbolCache.set(Ce._id,we),ee.symbols.push(Ce)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(V,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const ee=this._symbolCache.get(V._id);if(ee){const ae=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,J));return ae&&(0,I.mixin)(V,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(V){const J=this._resultCache.get(V);if(J){for(let[ee,ae]=J;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(V)}}}class B{constructor(V,J,ee){this._documents=V,this._provider=J,this._logService=ee}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(we,Ce,ee,ae)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const be=B._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(V,J,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(V),we=T.Position.to(J);return(0,D.asPromise)(()=>this._provider.prepareRename(ae,we,ee)).then(Ce=>{let Oe,be;if(A.Range.isRange(Ce)?(Oe=Ce,be=ae.getText(Ce)):(0,C.isObject)(Ce)&&(Oe=Ce.range,be=Ce.placeholder),!!Oe){if(Oe.start.line>we.line||Oe.end.line<we.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:be}}},Ce=>{const Oe=B._asMessage(Ce);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Ce)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ${constructor(V,J){this.resultId=V,this.tokens=J}}class N{constructor(V,J){this._documents=V,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,J,ee){const ae=this._documents.getDocument(V),we=J!==0?this._previousResults.get(J):null;return(0,D.asPromise)(()=>we&&typeof we.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,we.resultId,ee):this._provider.provideDocumentSemanticTokens(ae,ee)).then(Ce=>(we&&this._previousResults.delete(J),Ce?(Ce=N._fixProvidedSemanticTokens(Ce),this._send(N._convertToEdits(we,Ce),Ce)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return N._isSemanticTokens(V)?N._isCorrectSemanticTokens(V)?V:new A.SemanticTokens(new Uint32Array(V.data),V.resultId):N._isSemanticTokensEdits(V)?N._isCorrectSemanticTokensEdits(V)?V:new A.SemanticTokensEdits(V.edits.map(J=>new A.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const J of V.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,J){if(!N._isSemanticTokens(J)||!V||!V.tokens)return J;const ee=V.tokens,ae=ee.length,we=J.data,Ce=we.length;let Oe=0;const be=Math.min(ae,Ce);for(;Oe<be&&ee[Oe]===we[Oe];)Oe++;if(Oe===ae&&Oe===Ce)return new A.SemanticTokensEdits([],J.resultId);let Ie=0;const Re=be-Oe;for(;Ie<Re&&ee[ae-Ie-1]===we[Ce-Ie-1];)Ie++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:ae-Oe-Ie,data:we.subarray(Oe,Ce-Ie)}],J.resultId)}_send(V,J){if(N._isSemanticTokens(V)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(V.resultId,V.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:V.data})}if(N._isSemanticTokensEdits(V)){const ee=this._nextResultId++;return N._isSemanticTokens(J)?this._previousResults.set(ee,new $(J.resultId,J.data)):this._previousResults.set(ee,new $(V.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(V.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=N;class M{constructor(V,J){this._documents=V,this._provider=J}provideDocumentRangeSemanticTokens(V,J,ee){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(J),ee)).then(we=>we?this._send(we):null)}_send(V){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=M;class F{constructor(V,J,ee,ae,we){this._documents=V,this._commands=J,this._provider=ee,this._apiDeprecation=ae,this._extension=we,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J),Oe=we.getWordRangeAtPosition(Ce)||new A.Range(Ce,Ce),be=Oe.with({end:Ce}),Ie=new w.StopWatch(!0),Re=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(we,Ce,ae,T.CompletionContext.to(ee)));if(!!Re&&!ae.isCancellationRequested){const We=Array.isArray(Re)?new A.CompletionList(Re):Re,Ee=F.supportsResolving(this._provider)?this._cache.add(We.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(Ee,Ke);const X=[],re={x:Ee,b:X,a:{replace:T.Range.from(Oe),insert:T.Range.from(be)},c:We.isIncomplete||void 0,d:Ie.elapsed()};for(let _e=0;_e<We.items.length;_e++){const xe=We.items[_e],ze=this._convertCompletionItem(xe,[Ee,_e],be,Oe);X.push(ze)}return re}}async resolveCompletionItem(V,J){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...V);if(!!ee){const ae=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(ee,J));if(!!ae)return this._convertCompletionItem(ae,V)}}}releaseCompletionItems(V){var J;(J=this._disposables.get(V))===null||J===void 0||J.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,J,ee,ae){var we;const Ce=this._disposables.get(J[0]);if(!Ce)throw Error("DisposableStore is missing...");const Oe={x:J,a:(we=V.label)!==null&&we!==void 0?we:"",o:V.label2,b:V.kind!==void 0?T.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(T.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(V.command,Ce)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=V.textEdit.newText):typeof V.insertText=="string"?Oe.h=V.insertText:V.insertText instanceof A.SnippetString&&(Oe.h=V.insertText.value,Oe.i|=4);let be;return V.textEdit?be=V.textEdit.range:V.range&&(be=V.range),A.Range.isRange(be)?Oe.j=T.Range.from(be):be&&(!(ee==null?void 0:ee.isEqual(be.inserting))||!(ae==null?void 0:ae.isEqual(be.replacing)))&&(Oe.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Oe}}class U{constructor(V,J){this._documents=V,this._provider=J,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(V,J,ee,ae){const we=this._documents.getDocument(V),Ce=T.Position.to(J),Oe=this.reviveContext(ee);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(we,Ce,ae,Oe)).then(be=>{if(be){const Ie=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:Ie})}})}reviveContext(V){let J;if(V.activeSignatureHelp){const ee=T.SignatureHelp.to(V.activeSignatureHelp),ae=this._cache.get(V.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=ee.activeSignature,J.activeParameter=ee.activeParameter):J=ee}return Object.assign(Object.assign({},V),{activeSignatureHelp:J})}releaseSignatureHelp(V){this._cache.delete(V)}}class O{constructor(V,J){this._documents=V,this._provider=J}provideInlineHints(V,J,ee){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(J),ee)).then(we=>we?{hints:we.map(T.InlineHint.from)}:void 0)}}class W{constructor(V,J){this._documents=V,this._provider=J,this._cache=new S.Cache("DocumentLink")}provideLinks(V,J){const ee=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(ee,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const we=this._cache.add(ae),Ce={links:[],id:we};for(let Oe=0;Oe<ae.length;Oe++){const be=T.DocumentLink.from(ae[Oe]);be.cacheId=[we,Oe],Ce.links.push(be)}return Ce}}})}resolveLink(V,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...V);return ee?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(ee,J)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class q{constructor(V,J){this._documents=V,this._provider=J}provideColors(V,J){const ee=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(ee,J)).then(ae=>Array.isArray(ae)?ae.map(Ce=>({color:T.Color.from(Ce.color),range:T.Range.from(Ce.range)})):[])}provideColorPresentations(V,J,ee){const ae=this._documents.getDocument(V),we=T.Range.to(J.range),Ce=T.Color.to(J.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(Ce,{document:ae,range:we},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class Q{constructor(V,J){this._documents=V,this._provider=J}provideFoldingRanges(V,J,ee){const ae=this._documents.getDocument(V);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(ae,J,ee)).then(we=>{if(!!Array.isArray(we))return we.map(T.FoldingRange.from)})}}class he{constructor(V,J,ee){this._documents=V,this._provider=J,this._logService=ee}provideSelectionRanges(V,J,ee){const ae=this._documents.getDocument(V),we=J.map(T.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(ae,we,ee)).then(Ce=>{if(!(0,r.isNonEmptyArray)(Ce))return[];if(Ce.length!==we.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<we.length;be++){const Ie=[];Oe.push(Ie);let Re=we[be],We=Ce[be];for(;;){if(!We.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(T.SelectionRange.from(We)),!We.parent)break;Re=We.range,We=We.parent}}return Oe})}}class ve{constructor(V,J){this._documents=V,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(V,J,ee){const ae=this._documents.getDocument(V),we=T.Position.to(J),Ce=await this._provider.prepareCallHierarchy(ae,we,ee);if(!!Ce){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Ce)?Ce.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,Ce)]}}async provideCallsTo(V,J,ee){const ae=this._itemFromCache(V,J);if(!ae)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!we)return we.map(Ce=>({from:this._cacheAndConvertItem(V,Ce.from),fromRanges:Ce.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(V,J,ee){const ae=this._itemFromCache(V,J);if(!ae)throw new Error("missing call hierarchy item");const we=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!we)return we.map(Ce=>({to:this._cacheAndConvertItem(V,Ce.to),fromRanges:Ce.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,J){var ee;const ae=this._cache.get(V),we={_sessionId:V,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:T.SymbolKind.from(J.kind),uri:J.uri,range:T.Range.from(J.range),selectionRange:T.Range.from(J.selectionRange),tags:(ee=J.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return ae.set(we._itemId,J),we}_itemFromCache(V,J){const ee=this._cache.get(V);return ee==null?void 0:ee.get(J)}}class Pe{constructor(V,J){this.adapter=V,this.extension=J}}class ke{constructor(V,J,ee,ae,we,Ce,Oe){this._adapter=new Map,this._uriTransformer=J,this._proxy=V.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=we,this._logService=Ce,this._apiDeprecation=Oe}_transformDocumentSelector(V){return(0,r.coalesce)((0,r.asArray)(V).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:T.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new A.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return ke._handlePool++}_withAdapter(V,J,ee,ae,we=!1){const Ce=this._adapter.get(V);if(!Ce)return Promise.resolve(ae);if(Ce.adapter instanceof J){let Oe;Ce.extension&&(Oe=Date.now(),this._logService.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const be=ee(Ce.adapter,Ce.extension),Ie=Ce.extension;return Ie&&Promise.resolve(be).then(()=>this._logService.trace(`[${Ie.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{we&&Re instanceof _.CancellationError||(this._logService.error(`[${Ie.identifier.value}] provider FAILED`),this._logService.error(Re))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,J){const ee=this._nextHandle();return this._adapter.set(ee,new Pe(V,J)),ee}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,J,ee,ae){const we=this._addNewAdapter(new p(this._documents,ee),V),Ce=ae&&ae.label||ke._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(we,this._transformDocumentSelector(J),Ce),this._createDisposable(we)}$provideDocumentSymbols(V,J,ee){return this._withAdapter(V,p,ae=>ae.provideDocumentSymbols(b.URI.revive(J),ee),void 0)}registerCodeLensProvider(V,J,ee){const ae=this._nextHandle(),we=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Pe(new c(this._documents,this._commands.converter,ee),V)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),we);let Ce=this._createDisposable(ae);if(we!==void 0){const Oe=ee.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(we));Ce=A.Disposable.from(Ce,Oe)}return Ce}$provideCodeLenses(V,J,ee){return this._withAdapter(V,c,ae=>ae.provideCodeLenses(b.URI.revive(J),ee),void 0)}$resolveCodeLens(V,J,ee){return this._withAdapter(V,c,ae=>ae.resolveCodeLens(J,ee),void 0)}$releaseCodeLenses(V,J){this._withAdapter(V,c,ee=>Promise.resolve(ee.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(V,J,ee){const ae=this._addNewAdapter(new t(this._documents,ee),V);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(V,J,ee,ae){return this._withAdapter(V,t,we=>we.provideDefinition(b.URI.revive(J),ee,ae),[])}registerDeclarationProvider(V,J,ee){const ae=this._addNewAdapter(new n(this._documents,ee),V);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(V,J,ee,ae){return this._withAdapter(V,n,we=>we.provideDeclaration(b.URI.revive(J),ee,ae),[])}registerImplementationProvider(V,J,ee){const ae=this._addNewAdapter(new s(this._documents,ee),V);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(V,J,ee,ae){return this._withAdapter(V,s,we=>we.provideImplementation(b.URI.revive(J),ee,ae),[])}registerTypeDefinitionProvider(V,J,ee){const ae=this._addNewAdapter(new i(this._documents,ee),V);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(V,J,ee,ae){return this._withAdapter(V,i,we=>we.provideTypeDefinition(b.URI.revive(J),ee,ae),[])}registerHoverProvider(V,J,ee,ae){const we=this._addNewAdapter(new l(this._documents,ee),V);return this._proxy.$registerHoverProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideHover(V,J,ee,ae){return this._withAdapter(V,l,we=>we.provideHover(b.URI.revive(J),ee,ae),void 0)}registerEvaluatableExpressionProvider(V,J,ee,ae){const we=this._addNewAdapter(new o(this._documents,ee),V);return this._proxy.$registerEvaluatableExpressionProvider(we,this._transformDocumentSelector(J)),this._createDisposable(we)}$provideEvaluatableExpression(V,J,ee,ae){return this._withAdapter(V,o,we=>we.provideEvaluatableExpression(b.URI.revive(J),ee,ae),void 0)}registerInlineValuesProvider(V,J,ee,ae){const we=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ce=this._addNewAdapter(new u(this._documents,ee),V);this._proxy.$registerInlineValuesProvider(Ce,this._transformDocumentSelector(J),we);let Oe=this._createDisposable(Ce);if(we!==void 0){const be=ee.onDidChangeInlineValues(Ie=>this._proxy.$emitInlineValuesEvent(we));Oe=A.Disposable.from(Oe,be)}return Oe}$provideInlineValues(V,J,ee,ae,we){return this._withAdapter(V,u,Ce=>Ce.provideInlineValues(b.URI.revive(J),ee,ae,we),void 0)}registerDocumentHighlightProvider(V,J,ee){const ae=this._addNewAdapter(new E(this._documents,ee),V);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(V,J,ee,ae){return this._withAdapter(V,E,we=>we.provideDocumentHighlights(b.URI.revive(J),ee,ae),void 0)}registerLinkedEditingRangeProvider(V,J,ee){const ae=this._addNewAdapter(new d(this._documents,ee),V);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(V,J,ee,ae){return this._withAdapter(V,d,async we=>{const Ce=await we.provideLinkedEditingRanges(b.URI.revive(J),ee,ae);if(Ce)return{ranges:Ce.ranges,wordPattern:Ce.wordPattern?ke._serializeRegExp(Ce.wordPattern):void 0}},void 0)}registerReferenceProvider(V,J,ee){const ae=this._addNewAdapter(new v(this._documents,ee),V);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(V,J,ee,ae,we){return this._withAdapter(V,v,Ce=>Ce.provideReferences(b.URI.revive(J),ee,ae,we),void 0)}registerCodeActionProvider(V,J,ee,ae){var we,Ce;const Oe=new m.DisposableStore,be=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(J),{providedKinds:(we=ae==null?void 0:ae.providedCodeActionKinds)===null||we===void 0?void 0:we.map(Ie=>Ie.value),documentation:(Ce=ae==null?void 0:ae.documentation)===null||Ce===void 0?void 0:Ce.map(Ie=>({kind:Ie.kind.value,command:this._commands.converter.toInternal(Ie.command,Oe)}))},ke._extLabel(V),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(V,J,ee,ae,we){return this._withAdapter(V,R,Ce=>Ce.provideCodeActions(b.URI.revive(J),ee,ae,we),void 0)}$resolveCodeAction(V,J,ee){return this._withAdapter(V,R,ae=>ae.resolveCodeAction(J,ee),void 0)}$releaseCodeActions(V,J){this._withAdapter(V,R,ee=>Promise.resolve(ee.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(V,J,ee){const ae=this._addNewAdapter(new L(this._documents,ee),V);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(V,J,ee,ae){return this._withAdapter(V,L,we=>we.provideDocumentFormattingEdits(b.URI.revive(J),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(V,J,ee){const ae=this._addNewAdapter(new H(this._documents,ee),V);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),V.identifier,V.displayName||V.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(V,J,ee,ae,we){return this._withAdapter(V,H,Ce=>Ce.provideDocumentRangeFormattingEdits(b.URI.revive(J),ee,ae,we),void 0)}registerOnTypeFormattingEditProvider(V,J,ee,ae){const we=this._addNewAdapter(new ie(this._documents,ee),V);return this._proxy.$registerOnTypeFormattingSupport(we,this._transformDocumentSelector(J),ae,V.identifier),this._createDisposable(we)}$provideOnTypeFormattingEdits(V,J,ee,ae,we,Ce){return this._withAdapter(V,ie,Oe=>Oe.provideOnTypeFormattingEdits(b.URI.revive(J),ee,ae,we,Ce),void 0)}registerWorkspaceSymbolProvider(V,J){const ee=this._addNewAdapter(new j(J,this._logService),V);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(V,J,ee){return this._withAdapter(V,j,ae=>ae.provideWorkspaceSymbols(J,ee),{symbols:[]})}$resolveWorkspaceSymbol(V,J,ee){return this._withAdapter(V,j,ae=>ae.resolveWorkspaceSymbol(J,ee),void 0)}$releaseWorkspaceSymbols(V,J){this._withAdapter(V,j,ee=>ee.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(V,J,ee){const ae=this._addNewAdapter(new B(this._documents,ee,this._logService),V);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),B.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(V,J,ee,ae,we){return this._withAdapter(V,B,Ce=>Ce.provideRenameEdits(b.URI.revive(J),ee,ae,we),void 0)}$resolveRenameLocation(V,J,ee,ae){return this._withAdapter(V,B,we=>we.resolveRenameLocation(b.URI.revive(J),ee,ae),void 0)}registerDocumentSemanticTokensProvider(V,J,ee,ae){const we=this._nextHandle(),Ce=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(we,new Pe(new N(this._documents,ee),V)),this._proxy.$registerDocumentSemanticTokensProvider(we,this._transformDocumentSelector(J),ae,Ce);let Oe=this._createDisposable(we);if(Ce){const be=ee.onDidChangeSemanticTokens(Ie=>this._proxy.$emitDocumentSemanticTokensEvent(Ce));Oe=A.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(V,J,ee,ae){return this._withAdapter(V,N,we=>we.provideDocumentSemanticTokens(b.URI.revive(J),ee,ae),null,!0)}$releaseDocumentSemanticTokens(V,J){this._withAdapter(V,N,ee=>ee.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(V,J,ee,ae){const we=this._addNewAdapter(new M(this._documents,ee),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(we,this._transformDocumentSelector(J),ae),this._createDisposable(we)}$provideDocumentRangeSemanticTokens(V,J,ee,ae){return this._withAdapter(V,M,we=>we.provideDocumentRangeSemanticTokens(b.URI.revive(J),ee,ae),null,!0)}registerCompletionItemProvider(V,J,ee,ae){const we=this._addNewAdapter(new F(this._documents,this._commands.converter,ee,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(we,this._transformDocumentSelector(J),ae,F.supportsResolving(ee),`${V.identifier.value}(${ae.join("")})`),this._createDisposable(we)}$provideCompletionItems(V,J,ee,ae,we){return this._withAdapter(V,F,Ce=>Ce.provideCompletionItems(b.URI.revive(J),ee,ae,we),void 0)}$resolveCompletionItem(V,J,ee){return this._withAdapter(V,F,ae=>ae.resolveCompletionItem(J,ee),void 0)}$releaseCompletionItems(V,J){this._withAdapter(V,F,ee=>ee.releaseCompletionItems(J),void 0)}registerSignatureHelpProvider(V,J,ee,ae){const we=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,Ce=this._addNewAdapter(new U(this._documents,ee),V);return this._proxy.$registerSignatureHelpProvider(Ce,this._transformDocumentSelector(J),we),this._createDisposable(Ce)}$provideSignatureHelp(V,J,ee,ae,we){return this._withAdapter(V,U,Ce=>Ce.provideSignatureHelp(b.URI.revive(J),ee,ae,we),void 0)}$releaseSignatureHelp(V,J){this._withAdapter(V,U,ee=>ee.releaseSignatureHelp(J),void 0)}registerInlineHintsProvider(V,J,ee){const ae=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new O(this._documents,ee),V);this._proxy.$registerInlineHintsProvider(we,this._transformDocumentSelector(J),ae);let Ce=this._createDisposable(we);if(ae!==void 0){const Oe=ee.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(ae));Ce=A.Disposable.from(Ce,Oe)}return Ce}$provideInlineHints(V,J,ee,ae){return this._withAdapter(V,O,we=>we.provideInlineHints(b.URI.revive(J),ee,ae),void 0)}registerDocumentLinkProvider(V,J,ee){const ae=this._addNewAdapter(new W(this._documents,ee),V);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(V,J,ee){return this._withAdapter(V,W,ae=>ae.provideLinks(b.URI.revive(J),ee),void 0)}$resolveDocumentLink(V,J,ee){return this._withAdapter(V,W,ae=>ae.resolveLink(J,ee),void 0)}$releaseDocumentLinks(V,J){this._withAdapter(V,W,ee=>ee.releaseLinks(J),void 0)}registerColorProvider(V,J,ee){const ae=this._addNewAdapter(new q(this._documents,ee),V);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(V,J,ee){return this._withAdapter(V,q,ae=>ae.provideColors(b.URI.revive(J),ee),[])}$provideColorPresentations(V,J,ee,ae){return this._withAdapter(V,q,we=>we.provideColorPresentations(b.URI.revive(J),ee,ae),void 0)}registerFoldingRangeProvider(V,J,ee){const ae=this._nextHandle(),we=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Pe(new Q(this._documents,ee),V)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),we);let Ce=this._createDisposable(ae);if(we!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(we));Ce=A.Disposable.from(Ce,Oe)}return Ce}$provideFoldingRanges(V,J,ee,ae){return this._withAdapter(V,Q,we=>we.provideFoldingRanges(b.URI.revive(J),ee,ae),void 0)}registerSelectionRangeProvider(V,J,ee){const ae=this._addNewAdapter(new he(this._documents,ee,this._logService),V);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(V,J,ee,ae){return this._withAdapter(V,he,we=>we.provideSelectionRanges(b.URI.revive(J),ee,ae),[])}registerCallHierarchyProvider(V,J,ee){const ae=this._addNewAdapter(new ve(this._documents,ee),V);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(V,J,ee,ae){return this._withAdapter(V,ve,we=>Promise.resolve(we.prepareSession(b.URI.revive(J),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(V,J,ee,ae){return this._withAdapter(V,ve,we=>we.provideCallsTo(J,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(V,J,ee,ae){return this._withAdapter(V,ve,we=>we.provideCallsFrom(J,ee,ae),void 0)}$releaseCallHierarchy(V,J){this._withAdapter(V,ve,ee=>Promise.resolve(ee.releaseSession(J)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,y.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:ke._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:ke._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?ke._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?ke._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:ke._serializeRegExp(V.beforeText),afterText:V.afterText?ke._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?ke._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(ke._serializeOnEnterRule)}setLanguageConfiguration(V,J,ee){let{wordPattern:ae}=ee;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const we=this._nextHandle(),Ce={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ke._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ke._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ke._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(we,J,Ce),this._createDisposable(we)}$setWordDefinitions(V){for(const J of V)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ke,ke._handlePool=0}),define(me[240],ge([0,1,5,20,7]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(P,y){this._proxy=P.getProxy(b.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,y){await this._proxy.$changeLanguage(P,y);const k=this._documents.getDocumentData(P);if(!k)throw new Error(`document '${P.toString}' NOT found`);return k.document}async tokenAtPosition(P,y){var k;const r=P.version,C=I.Position.from(y),g=await this._proxy.$tokensAtPosition(P.uri,C),m={type:T.StandardTokenType.Other,range:(k=P.getWordRangeAtPosition(y))!==null&&k!==void 0?k:new T.Range(y.line,y.character,y.line,y.character)};if(!g)return m;const a={range:I.Range.to(g.range),type:I.TokenType.to(g.type)};return!a.range.contains(y)||r!==P.version?m:a}}e.ExtHostLanguages=A}),define(me[241],ge([0,1,5,13,41]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let D=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(b.MainContext.MainThreadMessageService)}showMessage(y,k,r,C,g){const m={extension:y};let a;typeof C=="string"||A(C)?a=[C,...g]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,a=g),m.useCustom&&(0,T.checkProposedApiEnabled)(y);const h=[];for(let S=0;S<a.length;S++){const w=a[S];if(typeof w=="string")h.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:_,isCloseAffordance:p}=w;h.push({title:_,isCloseAffordance:!!p,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,r,m,h).then(S=>{if(typeof S=="number")return a[S]})}};D=je([Be(1,I.ILogService)],D),e.ExtHostMessageService=D}),define(me[242],ge([0,1,21,3,6,2,28,5,20,7,63,88,24,218,219,72,12,22,74,86]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class c extends T.Disposable{constructor(o,u,E,d,v){super();this._editorId=o,this.uri=u,this._proxy=E,this._webviewInitData=d,this.document=v,this._onDidReceiveDocumentMessage=new I.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:R=>this._proxy.$postMessage(this._editorId,void 0,R),asWebviewUri:R=>this._asWebviewUri(R)}}onDidReceiveMessage(o,u){var E;this._onDidReceiveDocumentMessage.fire(u),o!==void 0&&((E=this._rendererIdToEmitters.get(o))===null||E===void 0||E.fire(u))}getRendererComm(o){const u=new I.Emitter;return this._rendererIdToEmitters.set(o,u),{editorId:this._editorId,onDidReceiveMessage:u.event,postMessage:E=>this._proxy.$postMessage(this._editorId,o,E),asWebviewUri:E=>this._asWebviewUri(E)}}_asWebviewUri(o){return(0,r.asWebviewUri)(this._webviewInitData,this._editorId,o)}}class f extends T.Disposable{constructor(o,u,E,d){super();this._proxy=o,this._handle=u,this._extension=E,this._provider=d,this._kernelToFriendlyId=new g.ResourceMap,this._friendlyIdToKernel=new g.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(v=>{const R=v==null?void 0:v.uri;this._proxy.$onNotebookKernelChange(this._handle,R)}))}async provideKernels(o,u){const E=await this._provider.provideKernels(o.notebookDocument,u)||[],d=new Map;let v=0;const R=new Set,L=this._kernelToFriendlyId.get(o.uri),H=E.map(j=>{var B;let $=L==null?void 0:L.get(j);return $===void 0&&(j.id&&R.has(j.id)?$=`${this._extension.identifier.value}_${j.id}_${v++}`:$=`${this._extension.identifier.value}_${j.id||D.generateUuid()}`),d.set(j,$),{id:j.id,friendlyId:$,label:j.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:j.description,detail:j.detail,isPreferred:j.isPreferred,preloads:(B=j.preloads)===null||B===void 0?void 0:B.map(N=>(A.URI.isUri(N)&&(N={uri:N,provides:[]}),{uri:N.uri,provides:typeof N.provides=="string"?[N.provides]:N.provides===void 0?[]:N.provides})),supportedLanguages:j.supportedLanguages,implementsInterrupt:!!j.interrupt}});this._kernelToFriendlyId.set(o.uri,d);const ie=new Map;return d.forEach((j,B)=>{ie.set(j,B)}),this._friendlyIdToKernel.set(o.uri,ie),H}getKernelByFriendlyId(o,u){var E;return(E=this._friendlyIdToKernel.get(o))===null||E===void 0?void 0:E.get(u)}async resolveNotebook(o,u,E,d){var v;const R=(v=this._friendlyIdToKernel.get(u.uri))===null||v===void 0?void 0:v.get(o);if(R&&this._provider.resolveKernel)return this._provider.resolveKernel(R,u.notebookDocument,E,d)}async executeNotebook(o,u,E){var d;const v=(d=this._friendlyIdToKernel.get(u.uri))===null||d===void 0?void 0:d.get(o);if(!!v){const R=E.map(L=>y.NotebookRange.to(L));return v.executeCellsRequest(u.notebookDocument,R)}}async interruptNotebookExecution(o,u){var E;const d=(E=this._friendlyIdToKernel.get(u.uri))===null||E===void 0?void 0:E.get(o);if(!(!d||!d.interrupt))return d.interrupt(u.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=f;class t{constructor(o,u){const E=t._Keys.nextId();o.$registerNotebookEditorDecorationType(E,y.NotebookDecorationRenderOptions.from(u)),this.value={key:E,dispose(){o.$removeNotebookEditorDecorationType(E)}}}}e.NotebookEditorDecorationType=t,t._Keys=new h.IdGenerator("NotebookEditorDecorationType");class n{constructor(o,u,E,d,v,R,L){this._textDocumentsAndEditors=E,this._textDocuments=d,this._webviewInitData=v,this.logService=R,this._extensionStoragePaths=L,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new g.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new I.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new g.ResourceMap,this._statusBarCache=new p.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:H=>{var ie;if(H&&H.$mid===12){const j=(ie=H.notebookEditor)===null||ie===void 0?void 0:ie.notebookUri,B=H.cell.handle,$=this._documents.get(j),N=$==null?void 0:$.getCell(B);if(N)return N.cell}return H}})}get activeNotebookEditor(){var o;return(o=this._activeNotebookEditor)===null||o===void 0?void 0:o.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){return this._editors.get(o)}getIdByEditor(o){for(const[u,E]of this._editors)if(E.apiEditor===o)return u}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(o){return this._documents.get(o)}_getNotebookDocument(o){const u=this._documents.get(o);if(!u)throw new Error(`NO notebook document for '${o}'`);return u}_getProviderData(o){const u=this._notebookContentProviders.get(o);if(!u)throw new Error(`NO provider for '${o}'`);return u}registerNotebookContentProvider(o,u,E,d){var v,R,L;if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:o,provider:E});let H;E.onDidChangeNotebookContentOptions&&(H=E.onDidChangeNotebookContentOptions(()=>{const B=y.NotebookDocumentContentOptions.from(E.options);this._notebookProxy.$updateNotebookProviderOptions(u,B)}));const ie=(v=d==null?void 0:d.viewOptions)===null||v===void 0?void 0:v.filenamePattern.map(B=>y.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);((R=d==null?void 0:d.viewOptions)===null||R===void 0?void 0:R.filenamePattern)&&!ie&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=d==null?void 0:d.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`);const j=y.NotebookDocumentContentOptions.from(d);return this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation,description:o.description},u,{transientOutputs:j.transientOutputs,transientCellMetadata:j.transientCellMetadata,transientDocumentMetadata:j.transientDocumentMetadata,viewOptions:(d==null?void 0:d.viewOptions)&&ie?{displayName:d.viewOptions.displayName,filenamePattern:ie,exclusive:d.viewOptions.exclusive||!1}:void 0}),new k.Disposable(()=>{H==null||H.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}registerNotebookKernelProvider(o,u,E){const d=n._notebookKernelProviderHandlePool++,v=new f(this._notebookProxy,d,o,E);return this._notebookKernelProviders.set(d,v),this._notebookProxy.$registerNotebookKernelProvider({id:o.identifier,location:o.extensionLocation,description:o.description},d,{viewType:u.viewType,filenamePattern:u.filenamePattern?y.NotebookExclusiveDocumentPattern.from(u.filenamePattern):void 0}),new k.Disposable(()=>{v.dispose(),this._notebookKernelProviders.delete(d),this._notebookProxy.$unregisterNotebookKernelProvider(d)})}registerNotebookCellStatusBarItemProvider(o,u,E){const d=n._notebookStatusBarItemProviderHandlePool++,v=typeof E.onDidChangeCellStatusBarItems=="function"?n._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,E),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,v,u);let R;return v!==void 0&&(R=E.onDidChangeCellStatusBarItems(L=>this._notebookProxy.$emitCellStatusBarEvent(v))),new k.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,v),R&&R.dispose()})}createNotebookEditorDecorationType(o){return new t(this._notebookEditorsProxy,o).value}async openNotebookDocument(o){const u=this._documents.get(o);if(u)return u.notebookDocument;const E=await this._notebookDocumentsProxy.$tryOpenDocument(o),d=this._documents.get(A.URI.revive(E));return(0,S.assertIsDefined)(d==null?void 0:d.notebookDocument)}_withAdapter(o,u,E){const d=this._documents.get(A.URI.revive(u));if(!d)return[];const v=this._notebookKernelProviders.get(o);return v?E(v,d):[]}async showNotebookDocument(o,u){var E;A.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let d;typeof u=="object"?d={position:y.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(y.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.viewType,d),R=v&&((E=this._editors.get(v))===null||E===void 0?void 0:E.apiEditor);if(R)return R;throw v?new Error(`Could NOT open editor for "${o.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.toString()}".`)}async $provideNotebookKernels(o,u,E){return this._withAdapter(o,u,(d,v)=>d.provideKernels(v,E))}async $resolveNotebookKernel(o,u,E,d,v){await this._withAdapter(o,E,async(R,L)=>{const H=this._webviewComm.get(u);H&&await R.resolveNotebook(d,L,H.contentProviderComm,v)})}async $provideNotebookCellStatusBarItems(o,u,E,d){var v;const R=this._notebookStatusBarItemProviders.get(o),L=A.URI.revive(u),H=this._documents.get(L);if(!(!H||!R)){const ie=H.getCellFromIndex(E);if(!!ie){const j=await R.provideCellStatusBarItems(ie.cell,d);if(!!j){const B=new T.DisposableStore,$=this._statusBarCache.add([B]),N=(v=j&&j.map(M=>y.NotebookStatusBarItem.from(M,this._commandsConverter,B)))!==null&&v!==void 0?v:void 0;return{cacheId:$,items:N}}}}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}async $resolveNotebookEditor(o,u,E){const d=this._notebookContentProviders.get(o),v=A.URI.revive(u),R=this._documents.get(v);if(!(!R||!d)){let L=this._webviewComm.get(E);L||(L=new c(E,v,this._notebookProxy,this._webviewInitData,R),this._webviewComm.set(E,L))}}async $executeNotebookKernelFromProvider(o,u,E,d){await this._withAdapter(o,u,async(v,R)=>v.executeNotebook(E,R,d))}registerNotebookSerializer(o,u,E,d){const v=this._handlePool++;this._notebookSerializer.set(v,E);const R=y.NotebookDocumentContentOptions.from(d);return this._notebookProxy.$registerNotebookSerializer(v,{id:o.identifier,location:o.extensionLocation,description:o.description},u,R),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(v)})}async $dataToNotebook(o,u,E){const d=this._notebookSerializer.get(o);if(!d)throw new Error("NO serializer found");const v=await d.deserializeNotebook(u.buffer,E);return{metadata:y.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(y.NotebookCellData.from)}}async $notebookToData(o,u,E){const d=this._notebookSerializer.get(o);if(!d)throw new Error("NO serializer found");const v=await d.serializeNotebook({metadata:y.NotebookDocumentMetadata.to(u.metadata),cells:u.cells.map(y.NotebookCellData.to)},E);return w.VSBuffer.wrap(v)}async $cancelNotebookCellExecution(o,u,E,d){await this._withAdapter(o,u,async(R,L)=>R.interruptNotebookExecution(E,L));const v=this._documents.get(A.URI.revive(u));if(!!v)for(let R of d)for(let L=R.start;L<R.end;L++){const H=v.getCellFromIndex(L);H&&this.cancelOneNotebookCellExecution(H)}}cancelOneNotebookCellExecution(o){const u=this._activeExecutions.get(o.uri);u==null||u.cancel()}async $openNotebook(o,u,E,d,v){const{provider:R}=this._getProviderData(o),L=await R.openNotebook(A.URI.revive(u),{backupId:E,untitledDocumentData:d==null?void 0:d.buffer},v);return{metadata:y.NotebookDocumentMetadata.from(L.metadata),cells:L.cells.map(y.NotebookCellData.from)}}async $saveNotebook(o,u,E){const d=this._getNotebookDocument(A.URI.revive(u)),{provider:v}=this._getProviderData(o);return await v.saveNotebook(d.notebookDocument,E),!0}async $saveNotebookAs(o,u,E,d){const v=this._getNotebookDocument(A.URI.revive(u)),{provider:R}=this._getProviderData(o);return await R.saveNotebookAs(A.URI.revive(E),v.notebookDocument,d),!0}async $backupNotebook(o,u,E){var d;const v=this._getNotebookDocument(A.URI.revive(u)),R=this._getProviderData(o),L=(d=this._extensionStoragePaths.workspaceValue(R.extension))!==null&&d!==void 0?d:this._extensionStoragePaths.globalValue(R.extension),H=String((0,_.hash)([v.uri.toString(),this._backupIdPool++])),ie=A.URI.joinPath(L,H),j=await R.provider.backupNotebook(v.notebookDocument,{destination:ie},E);return v.updateBackup(j),j.id}$acceptNotebookActiveKernelChange(o){o.providerHandle!==void 0&&this._withAdapter(o.providerHandle,o.uri,async(u,E)=>{const d=o.kernelFriendlyId?u.getKernelByFriendlyId(A.URI.revive(o.uri),o.kernelFriendlyId):void 0;this._editors.forEach(v=>{v.notebookData===E&&v._acceptKernel(d)}),this._onDidChangeActiveNotebookKernel.fire({document:E.notebookDocument,kernel:d})})}$onDidReceiveMessage(o,u,E){var d;(d=this._webviewComm.get(o))===null||d===void 0||d.onDidReceiveMessage(u,E)}$acceptModelChanged(o,u,E){this._getNotebookDocument(A.URI.revive(o)).acceptModelChanged(u,E)}$acceptDirtyStateChanged(o,u){const E=this._getNotebookDocument(A.URI.revive(o));E.acceptModelChanged({rawEvents:[],versionId:E.notebookDocument.version},u)}$acceptModelSaved(o){const u=this._getNotebookDocument(A.URI.revive(o));this._onDidSaveNotebookDocument.fire(u.notebookDocument)}$acceptEditorPropertiesChanged(o,u){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",o,u);const E=this._editors.get(o);if(!E)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);u.visibleRanges&&E._acceptVisibleRanges(u.visibleRanges.ranges.map(y.NotebookRange.to)),u.selections&&E._acceptSelections(u.selections.selections.map(y.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(o){for(const u in o){const E=this._editors.get(u);if(!E)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);E._acceptViewColumn(y.ViewColumn.to(o[u]))}}$acceptDocumentPropertiesChanged(o,u){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",o.path,u);const E=this._getNotebookDocument(A.URI.revive(o));E.acceptDocumentPropertiesChanged(u),u.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:E.notebookDocument})}_createExtHostEditor(o,u,E){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const d=o.uri;let v=this._webviewComm.get(u);v||(v=new c(u,d,this._notebookProxy,this._webviewInitData,o),this._webviewComm.set(u,v));const R=new a.ExtHostNotebookEditor(u,this._notebookEditorsProxy,o,E.visibleRanges.map(y.NotebookRange.to),E.selections.map(y.NotebookRange.to),typeof E.viewColumn=="number"?y.ViewColumn.to(E.viewColumn):void 0);this._editors.set(u,R)}$acceptDocumentAndEditorsDelta(o){var u,E,d;if(o.removedDocuments)for(const R of o.removedDocuments){const L=A.URI.revive(R),H=this._documents.get(L);H&&(H.dispose(),this._documents.delete(L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:H.notebookDocument.getCells().map(ie=>ie.document.uri)}),this._onDidCloseNotebookDocument.fire(H.notebookDocument));for(const ie of this._editors.values())ie.notebookData.uri.toString()===L.toString()&&this._editors.delete(ie.id)}if(o.addedDocuments){const R=[];for(const L of o.addedDocuments){const H=A.URI.revive(L.uri),ie=L.viewType;if(this._documents.has(H))throw new Error(`adding EXISTING notebook ${H} `);const j=this,B=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange($){j._onDidChangeNotebookCells.fire($)},emitCellOutputsChange($){j._onDidChangeCellOutputs.fire($)},emitCellMetadataChange($){j._onDidChangeCellMetadata.fire($)},emitCellExecutionStateChange($){j._onDidChangeCellExecutionState.fire($)}},ie,L.metadata?y.NotebookDocumentMetadata.to(L.metadata):new k.NotebookDocumentMetadata,H);B.acceptModelChanged({versionId:L.versionId,rawEvents:[{kind:C.NotebookCellsChangeType.Initialize,changes:[[0,0,L.cells]]}]},!1),R.push(...L.cells.map($=>m.ExtHostCell.asModelAddData(B.notebookDocument,$))),(u=this._documents.get(H))===null||u===void 0||u.dispose(),this._documents.set(H,B),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(B.notebookDocument)}}if(o.addedEditors)for(const R of o.addedEditors){if(this._editors.has(R.id))return;const L=A.URI.revive(R.documentUri),H=this._documents.get(L);H&&this._createExtHostEditor(H,R.id,R)}const v=[];if(o.removedEditors)for(const R of o.removedEditors){const L=this._editors.get(R);L&&(this._editors.delete(R),((E=this._activeNotebookEditor)===null||E===void 0?void 0:E.id)===L.id&&(this._activeNotebookEditor=void 0),v.push(L))}if(o.visibleEditors){this._visibleNotebookEditors=o.visibleEditors.map(L=>this._editors.get(L)).filter(L=>!!L);const R=new Set;this._visibleNotebookEditors.forEach(L=>R.add(L.id));for(const L of this._editors.values()){const H=R.has(L.id);L._acceptVisibility(H)}this._visibleNotebookEditors=[...this._editors.values()].map(L=>L).filter(L=>L.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.newActiveEditor===null?this._activeNotebookEditor=void 0:o.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.newActiveEditor)),o.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.apiEditor)}createNotebookCellExecution(o,u,E){const d=this.lookupNotebookDocument(o);if(!d)throw new Error(`Invalid cell uri / index: ${o}, ${u} `);const v=d.getCellFromIndex(u);if(!v)throw new Error(`Invalid cell uri / index: ${o}, ${u} `);if(!this._activeExecutions.has(v.uri)){const R=new i(o,d,v,this._notebookDocumentsProxy);this._activeExecutions.set(v.uri,R);const L=R.onDidChangeState(()=>{R.state===s.Resolved&&(R.dispose(),L.dispose(),this._activeExecutions.delete(v.uri))});return R.asApiObject()}}}e.ExtHostNotebookController=n,n._notebookKernelProviderHandlePool=0,n._notebookStatusBarItemProviderHandlePool=0;var s;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(s||(s={}));class i extends T.Disposable{constructor(o,u,E,d){super();this._uri=o,this._document=u,this._cell=E,this._proxy=d,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._executionOrder=E.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(o){return this._proxy.$applyEdits(this._uri,o,!1)}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(o){const u=[{editType:11,handle:this._cell.handle,metadata:o}];this.applyEdits(u)}cellIndexToHandle(o){const u=typeof o=="number"?this._document.getCellFromIndex(o):this._cell;if(!!u)return u.handle}asApiObject(){const o=this;return Object.freeze({get document(){return o._document.notebookDocument},get cell(){return o._cell.cell},get executionOrder(){return o._executionOrder},set executionOrder(u){o._executionOrder=u,o.mixinMetadata({executionOrder:u})},start(u){if(o._state===s.Resolved||o._state===s.Started)throw new Error("Cannot call start again");o._state=s.Started,o._onDidChangeState.fire(),o.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:u==null?void 0:u.startTime})},end(u){var E,d;if(o._state===s.Resolved)throw new Error("Cannot call resolve twice");o._state=s.Resolved,o._onDidChangeState.fire(),o.mixinMetadata({runState:k.NotebookCellExecutionState.Idle,lastRunSuccess:(E=u==null?void 0:u.success)!==null&&E!==void 0?E:null,runEndTime:(d=u==null?void 0:u.endTime)!==null&&d!==void 0?d:null})},clearOutput(u){return o.verifyStateForOutput(),this.replaceOutput([],u)},async appendOutput(u,E){o.verifyStateForOutput();const d=o.cellIndexToHandle(E);if(typeof d=="number")return u=Array.isArray(u)?u:[u],o.applyEdits([{editType:2,handle:d,append:!0,outputs:u.map(y.NotebookCellOutput.from)}])},async replaceOutput(u,E){o.verifyStateForOutput();const d=o.cellIndexToHandle(E);if(typeof d=="number")return u=Array.isArray(u)?u:[u],o.applyEdits([{editType:2,handle:d,outputs:u.map(y.NotebookCellOutput.from)}])},async appendOutputItems(u,E){return o.verifyStateForOutput(),u=Array.isArray(u)?u:[u],o.applyEdits([{editType:10,append:!0,items:u.map(y.NotebookCellOutputItem.from),outputId:E}])},async replaceOutputItems(u,E){return o.verifyStateForOutput(),u=Array.isArray(u)?u:[u],o.applyEdits([{editType:10,items:u.map(y.NotebookCellOutputItem.from),outputId:E}])},token:o._tokenSource.token})}}}),define(me[243],ge([0,1,3,6,5,2,20,15,63]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class k{constructor(C,g,m){this._initData=g,this._extHostNotebook=m,this._kernelData=new Map,this._handlePool=0,this._proxy=C.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(C,g,m,a,h,S){for(let v of this._kernelData.values())if(v.controller.id===g)throw new Error(`notebook controller with id '${g}' ALREADY exist`);const w=this._handlePool++,_=this,p=["plaintext"],c=()=>console.warn(`NO execute handler from notebook controller '${i.id}' of extension: '${C.identifier}'`);let f=!1;const t=new I.DisposableStore,n=new b.Emitter,s=new b.Emitter,i={id:g,selector:m,extensionId:C.identifier,extensionLocation:C.extensionLocation,label:a||C.identifier.value,supportedLanguages:p,preloads:S?S.map(D.NotebookKernelPreload.from):[]};let l=h!=null?h:c,o;this._proxy.$addKernel(w,i).catch(v=>{console.log(v),f=!0});let u=0;const E=()=>{if(!f){const v=++u;Promise.resolve().then(()=>{v===u&&this._proxy.$updateKernel(w,i)})}},d={get id(){return i.id},get selector(){return i.selector},onDidChangeNotebookAssociation:n.event,get label(){return i.label},set label(v){var R;i.label=(R=v!=null?v:C.displayName)!==null&&R!==void 0?R:C.name,E()},get detail(){var v;return(v=i.detail)!==null&&v!==void 0?v:""},set detail(v){i.detail=v,E()},get description(){var v;return(v=i.description)!==null&&v!==void 0?v:""},set description(v){i.description=v,E()},get isPreferred(){var v;return(v=i.isPreferred)!==null&&v!==void 0?v:!1},set isPreferred(v){i.isPreferred=v,E()},get supportedLanguages(){return i.supportedLanguages},set supportedLanguages(v){i.supportedLanguages=(0,P.isNonEmptyArray)(v)?v:p,E()},get hasExecutionOrder(){var v;return(v=i.hasExecutionOrder)!==null&&v!==void 0?v:!1},set hasExecutionOrder(v){i.hasExecutionOrder=v,E()},get preloads(){return i.preloads?i.preloads.map(D.NotebookKernelPreload.to):[]},get executeHandler(){return l},set executeHandler(v){l=v!=null?v:c},get interruptHandler(){return o},set interruptHandler(v){o=v,i.supportsInterrupt=Boolean(v),E()},createNotebookCellExecutionTask(v){if(f)throw new Error("notebook controller is DISPOSED");return _._extHostNotebook.createNotebookCellExecution(v.notebook.uri,v.index,i.id)},dispose:()=>{f||(f=!0,this._kernelData.delete(w),t.dispose(),n.dispose(),s.dispose(),this._proxy.$removeKernel(w))},onDidReceiveMessage:s.event,postMessage(v,R){return _._proxy.$postMessage(w,R&&_._extHostNotebook.getIdByEditor(R),v)},asWebviewUri(v){return(0,y.asWebviewUri)(_._initData.environment,i.id,v)}};return this._kernelData.set(w,{extensionId:C.identifier,controller:d,onDidChangeSelection:n,onDidReceiveMessage:s}),d}$acceptSelection(C,g,m){const a=this._kernelData.get(C);a&&a.onDidChangeSelection.fire({selected:m,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(g)).notebookDocument})}async $executeCells(C,g,m){const a=this._kernelData.get(C);if(!!a){const h=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(g));if(!h)throw new Error("MISSING notebook");const S=[];for(let w of m)S.push(...h.notebookDocument.getCells(D.NotebookRange.to(w)));try{a.controller.executeHandler.call(a.controller,S,a.controller)}catch(w){console.error(w)}}}async $cancelCells(C,g,m){const a=this._kernelData.get(C);if(!!a){const h=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(g));if(!h)throw new Error("MISSING notebook");a.controller.interruptHandler&&a.controller.interruptHandler.call(a.controller);for(const S of m)for(let w=S.start;w<S.end;w++){const _=h.getCellFromIndex(w);_&&this._extHostNotebook.cancelOneNotebookCellExecution(_)}}}$acceptRendererMessage(C,g,m){const a=this._kernelData.get(C);if(!!a){const h=this._extHostNotebook.getEditorById(g);if(!h)throw new Error(`send message for UNKNOWN editor: ${g}`);a.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:m}))}}}e.ExtHostNotebookKernels=k}),define(me[65],ge([0,1,5,3,6,22,4,14]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends T.Disposable{constructor(a,h,S,w){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,h,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(h=>this._proxy.$clear(h,a))}show(a,h){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof a=="boolean"?a:h)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class k extends y{constructor(a,h){super(a,!1,void 0,h)}append(a){super.append(a),this._id.then(h=>this._proxy.$append(h,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class r extends y{constructor(a,h,S){super(a,!0,h,S)}append(a){throw new Error("Not supported")}}class C{constructor(a,h){this.name=a,this._channel=h}append(a){this._channel.then(h=>h.append(a))}appendLine(a){this._channel.then(h=>h.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,h){this._channel.then(S=>S.show(a,h))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let g=class{constructor(a){this._proxy=a.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new k(a,this._proxy)}createOutputChannelFromLogFile(a,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new r(a,h,this._proxy)}};g=je([Be(0,P.IExtHostRpcService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(me[244],ge([0,1,19,21,3,6,5,2,7,18,15,57]),function(G,e,b,I,T,A,D,P,y,k,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(m,a,h){const S=m.getProxy(D.MainContext.MainThreadQuickOpen);class w{constructor(i,l){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=l}showQuickPick(i,l,o,u=I.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(i),d=++this._instances,v=S.$show(d,{title:o==null?void 0:o.title,placeHolder:o==null?void 0:o.placeHolder,matchOnDescription:o==null?void 0:o.matchOnDescription,matchOnDetail:o==null?void 0:o.matchOnDetail,ignoreFocusLost:o==null?void 0:o.ignoreFocusOut,canPickMany:o==null?void 0:o.canPickMany},u),R={},L=v.then(()=>R);return Promise.race([L,E]).then(H=>{if(H!==R)return E.then(ie=>{const j=[];for(let B=0;B<ie.length;B++){const $=ie[B];let N,M,F,U,O;typeof $=="string"?N=$:(N=$.label,M=$.description,F=$.detail,U=$.picked,O=$.alwaysShow),j.push({label:N,description:M,handle:B,detail:F,picked:U,alwaysShow:O})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{o.onDidSelectItem(ie[B])}),S.$setItems(d,j),v.then(B=>{if(typeof B=="number")return ie[B];if(Array.isArray(B))return B.map($=>ie[$])})})}).then(void 0,H=>{if(!(0,k.isPromiseCanceledError)(H))return S.$setError(d,H),Promise.reject(H)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,l=I.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,S.$input(i,typeof this._validateInput=="function",l).then(void 0,o=>{if(!(0,k.isPromiseCanceledError)(o))return Promise.reject(o)})}$validateInput(i){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,l=I.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!o){const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(E=>E.uri.toString()===o.uri.toString())}}createQuickPick(i,l){const o=new t(i,l,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(i){const l=new n(i,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(i,l){const o=this._sessions.get(i);o&&o._fireDidChangeValue(l)}$onDidAccept(i){const l=this._sessions.get(i);l&&l._fireDidAccept()}$onDidChangeActive(i,l){const o=this._sessions.get(i);o instanceof t&&o._fireDidChangeActive(l)}$onDidChangeSelection(i,l){const o=this._sessions.get(i);o instanceof t&&o._fireDidChangeSelection(l)}$onDidTriggerButton(i,l){const o=this._sessions.get(i);o&&o._fireDidTriggerButton(l)}$onDidHide(i){const l=this._sessions.get(i);l&&l._fireDidHide()}}class _{constructor(i,l){this._extensionId=i,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((l,o)=>{const u=l===y.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(u,l)}),this.update({buttons:i.map((l,o)=>({iconPath:p(l.iconPath),tooltip:l.tooltip,handle:l===y.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const l=this._handlesToButtons.get(i);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(i){if(!this._disposed){for(const l of Object.keys(i)){const o=i[l];this._pendingUpdate[l]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function p(s){if(s instanceof y.ThemeIcon)return{id:s.id};const i=f(s),l=c(s);return{dark:typeof i=="string"?P.URI.file(i):i,light:typeof l=="string"?P.URI.file(l):l}}function c(s){return typeof s=="object"&&"light"in s?s.light:s}function f(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends _{constructor(i,l,o){super(i,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((l,o)=>{this._handlesToItems.set(o,l),this._itemsToHandles.set(l,o)}),this.update({items:i.map((l,o)=>({label:l.label,description:l.description,handle:o,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(i){const l=(0,r.coalesce)(i.map(o=>this._handlesToItems.get(o)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(i){const l=(0,r.coalesce)(i.map(o=>this._handlesToItems.get(o)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class n extends _{constructor(i,l){super(i,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(a,h)}e.createExtHostQuickOpen=g}),define(me[245],ge([0,1,2,3,70,6,19,5,15,98,13,29,41]),function(G,e,b,I,T,A,D,P,y,k,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(i){if(i)return typeof i.iconPath=="string"?b.URI.file(i.iconPath):i.iconPath}function a(i,l){if(!i.iconPath&&!l.iconPath)return 0;if(i.iconPath){if(!l.iconPath)return 1}else return-1;const o=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,u=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return(0,k.comparePaths)(o,u)}function h(i,l){let o=0;if(i.strikeThrough!==l.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==l.faded)return i.faded?1:-1;if(i.tooltip!==l.tooltip)return(i.tooltip||"").localeCompare(l.tooltip||"");if(o=a(i,l),o!==0)return o;if(i.light&&l.light)o=a(i.light,l.light);else{if(i.light)return 1;if(l.light)return-1}if(o!==0)return o;if(i.dark&&l.dark)o=a(i.dark,l.dark);else{if(i.dark)return 1;if(l.dark)return-1}return o}function S(i,l){if(i.command!==l.command)return i.command<l.command?-1:1;if(i.title!==l.title)return i.title<l.title?-1:1;if(i.tooltip!==l.tooltip){if(i.tooltip!==void 0&&l.tooltip!==void 0)return i.tooltip<l.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(i.arguments===l.arguments)return 0;if(i.arguments)if(l.arguments){if(i.arguments.length!==l.arguments.length)return i.arguments.length-l.arguments.length}else return 1;else return-1;for(let o=0;o<i.arguments.length;o++){const u=i.arguments[o],E=l.arguments[o];if(u!==E)return u<E?-1:1}return 0}function w(i,l){let o=(0,k.comparePaths)(i.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(o!==0)return o;if(i.command&&l.command)o=S(i.command,l.command);else{if(i.command)return 1;if(l.command)return-1}if(o!==0)return o;if(i.decorations&&l.decorations)o=h(i.decorations,l.decorations);else{if(i.decorations)return 1;if(l.decorations)return-1}return o}function _(i,l){for(let o=0;o<i.length;o++)if(i[o]!==l[o])return!1;return!0}function p(i,l){return i.command===l.command&&i.title===l.title&&i.tooltip===l.tooltip&&(i.arguments&&l.arguments?_(i.arguments,l.arguments):i.arguments===l.arguments)}function c(i,l){return(0,y.equals)(i,l,p)}class f{constructor(l,o,u){this._extension=l,this._proxy=o,this._sourceControlHandle=u,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,g.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){(0,g.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,o){(0,g.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,o)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=f;class t{constructor(l,o,u,E,d){this._proxy=l,this._commands=o,this._sourceControlHandle=u,this._id=E,this._label=d,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,o){const u=this._resourceStatesCommandsMap.get(l);return u?(0,D.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],o)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const o=[...this._resourceStates].sort(w),E=(0,y.sortedDiff)(this._resourceSnapshot,o,w).map(R=>{const L=R.toInsert.map(H=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,H);const j=H.resourceUri,B=m(H.decorations),$=H.decorations&&m(H.decorations.light)||B,N=H.decorations&&m(H.decorations.dark)||B,M=[];let F;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const he=new A.DisposableStore;F=this._commands.converter.toInternal(H.command,he),this._resourceStatesDisposablesMap.set(ie,he)}else this._resourceStatesCommandsMap.set(ie,H.command);$&&M.push($),N&&N.toString()!==($==null?void 0:$.toString())&&M.push(N);const U=H.decorations&&H.decorations.tooltip||"",O=H.decorations&&!!H.decorations.strikeThrough,W=H.decorations&&!!H.decorations.faded,q=H.contextValue||"";return{rawResource:[ie,j,M,U,O,W,q,F],handle:ie}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),d=E.map(({start:R,deleteCount:L,toInsert:H})=>[R,L,H.map(ie=>ie.rawResource)]),v=E.reverse();for(const{start:R,deleteCount:L,toInsert:H}of v){const ie=H.map(B=>B.handle),j=this._handlesSnapshot.splice(R,L,...ie);for(const B of j)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(l=this._resourceStatesDisposablesMap.get(B))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=o,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(l,o,u,E,d,v){this._proxy=o,this._commands=u,this._id=E,this._label=d,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,d,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=l;const o=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:o})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(!(this._statusBarCommands&&l&&c(this._statusBarCommands,l))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=l;const o=(l||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:o})}}get selected(){return this._selected}createResourceGroup(l,o){const u=new t(this._proxy,this._commands,this.handle,l,o),E=I.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const l=[],o=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const d=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});I.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),d.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),l.push([u.handle,u.id,u.label,u.features]);const v=u._takeResourceStateSnapshot();v.length>0&&o.push([u.handle,v]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,l,o),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(o=>{const u=o._takeResourceStateSnapshot();u.length!==0&&l.push([o.handle,u])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Mn{constructor(l,o,u){this._commands=o,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=l.getProxy(P.MainContext.MainThreadSCM),this._telemetry=l.getProxy(P.MainContext.MainThreadTelemetry),o.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const d=this._sourceControls.get(E.sourceControlHandle);if(!d)return E;const v=d.getResourceGroup(E.groupHandle);return v?v.getResourceState(E.handle):E}else if(E&&E.$mid===4){const d=this._sourceControls.get(E.sourceControlHandle);return d?d.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const d=this._sourceControls.get(E.handle);return d||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,o,u,E){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,o,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const d=Mn._handlePool++,v=new n(l,this._proxy,this._commands,o,u,E);this._sourceControls.set(d,v);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier))||[];return R.push(v),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(l.identifier),R),v}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const o=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(l.identifier)),u=o&&o[o.length-1];return u&&u.inputBox}$provideOriginalResource(l,o,u){const E=b.URI.revive(o);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,E.toString());const d=this._sourceControls.get(l);return!d||!d.quickDiffProvider||!d.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>d.quickDiffProvider.provideOriginalResource(E,u)).then(v=>v||null)}$onInputBoxValueChange(l,o){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const u=this._sourceControls.get(l);return u&&u.inputBox.$onInputBoxValueChange(o),Promise.resolve(void 0)}$executeResourceCommand(l,o,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,o,u);const d=this._sourceControls.get(l);if(!d)return Promise.resolve(void 0);const v=d.getResourceGroup(o);return v?v.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(l,o,u){this.logService.trace("ExtHostSCM#$validateInput",l);const E=this._sourceControls.get(l);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>E.inputBox.validateInput(o,u)).then(d=>d?Promise.resolve([d.message,d.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var o,u;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((o=this._sourceControls.get(l))===null||o===void 0||o.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((u=this._sourceControls.get(this._selectedSourceControlHandle))===null||u===void 0||u.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};s._handlePool=0,s=je([Be(2,r.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[246],ge([0,1,7,5,164,6]),function(G,e,b,I,T,A){"use strict";var D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(g,m,a,h,S=b.StatusBarAlignment.Left,w,_){D.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,D,g,"f"),tt(this,P,m,"f"),this._id=y.ID_GEN++,this._statusId=a,this._statusName=h,this._alignment=S,this._priority=w,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!y.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Ue(this,P,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Ue(this,P,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,D,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var g;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,D,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(g=this._command)===null||g===void 0?void 0:g.internal,m,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,P=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(g){this._messages=[],this._item=g.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const m={message:g};return this._messages.unshift(m),this._update(),new b.Disposable(()=>{const a=this._messages.indexOf(m);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(g,m){this._proxy=g.getProxy(I.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new k(this)}createStatusBarEntry(g,m,a,h,S){return new y(this._proxy,this._commands,g,m,a,h,S)}setStatusBarMessage(g,m){const a=this._statusMessage.setMessage(g);let h;return typeof m=="number"?h=setTimeout(()=>a.dispose(),m):typeof m!="undefined"&&m.then(()=>a.dispose(),()=>a.dispose()),new b.Disposable(()=>{a.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=r}),define(me[91],ge([0,1,5,3,4]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,y){this._proxy.$registerExtensionStorageKeysToSync(P,y)}getValue(P,y,k){return this._proxy.$getValue(P,y).then(r=>r||k)}setValue(P,y,k){return this._proxy.$setValue(P,y,k)}$acceptValue(P,y,k){this._onDidChangeStorage.fire({shared:P,key:y,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(me[92],ge([0,1,4,27,13,90,2]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,r,C){var g;this._logService=r,this._extHostFileSystem=C,this._workspace=(g=k.workspace)!==null&&g!==void 0?g:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,C=D.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(g){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=D.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),C}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(k){if(this._value)return D.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return D.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};P=je([Be(0,I.IExtHostInitDataService),Be(1,T.ILogService),Be(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(me[34],ge([0,1,3,5,4,2,14,6,7,165,18,210,21,28,190]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class h{constructor(t,n,s,i){this._proxy=t,this._id=n,this._creationOptions=s,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(o=>this._pidPromiseComplete=o);const l=this;this.value={get name(){return l._name||""},get processId(){return l._pidPromise},get creationOptions(){return l._creationOptions},get exitStatus(){return l._exitStatus},sendText(o,u=!0){l._checkDisposed(),l._proxy.$sendText(l._id,o,u)},show(o){l._checkDisposed(),l._proxy.$show(l._id,o)},hide(){l._checkDisposed(),l._proxy.$hide(l._id)},dispose(){l._disposed||(l._disposed=!0,l._proxy.$dispose(l._id))},get dimensions(){if(!(l._cols===void 0||l._rows===void 0))return{columns:l._cols,rows:l._rows}}}}async create(t,n,s,i,l,o,u,E,d,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:i,icon:l,initialText:o,waitOnExit:u,strictEnv:E,hideFromUser:d,isFeatureTerminal:v,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let w=1,_=class extends P.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new h(this._proxy,(0,m.generateUuid)(),t,t.name),s=new S(t.pty);return n.createExtensionTerminal().then(i=>{const l=this._setupExtHostProcessListeners(i,s);this._terminalProcessDisposables[i]=l}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const i=new S(n),l=this._setupExtHostProcessListeners(t,i);this._terminalProcessDisposables[t]=l}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const i=this._getTerminalById(t);i&&i.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const i=this._terminals.splice(s,1)[0];i.setExitCode(n),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(t,n,s,i){if(n){const u=this._getTerminalObjectIndexById(this._terminals,n);if(u!==null){this._terminals[u]._id=t,this._onDidOpenTerminal.fire(this.terminals[u]),this._terminals[u].isOpen=!0;return}}const l={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:A.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},o=new h(this._proxy,t,l,s);this._terminals.push(o),this._onDidOpenTerminal.fire(o.value),o.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(l=>{const o=this.onDidOpenTerminal(async u=>{u===s.value&&(o.dispose(),l())})});const i=this._terminalProcesses.get(t);i?i.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new P.DisposableStore;s.add(n.onProcessReady(l=>this._proxy.$sendProcessReady(t,l.pid,l.cwd))),s.add(n.onProcessTitleChanged(l=>this._proxy.$sendProcessTitle(t,l))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(l=>this._onProcessExit(t,l))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(l=>this._proxy.$sendOverrideDimensions(t,l))),this._terminalProcesses.set(t,n);const i=this._extensionTerminalAwaitingStart[t];return i&&n instanceof S&&(n.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var i;try{(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,s)}catch(l){if(l.code!=="EPIPE"&&l.code!=="ERR_IPC_CHANNEL_CLOSED")throw l}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const i=this._terminalLinkCancellationSource.get(t);i&&i.dispose(!0);const l=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,l);const o=[],u={terminal:s.value,line:n},E=[];for(const R of this._linkProviders)E.push(new Promise(async L=>{l.token.onCancellationRequested(()=>L({provider:R,links:[]}));const H=await R.provideTerminalLinks(u,l.token)||[];l.token.isCancellationRequested||L({provider:R,links:H})}));const d=await Promise.all(E);if(l.token.isCancellationRequested)return[];const v=new Map;for(const R of d)R&&R.links.length>0&&o.push(...R.links.map(L=>{const H={id:w++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return v.set(H.id,{provider:R.provider,link:L}),H}));return this._terminalLinkCache.set(t,v),o}$activateLink(t,n){var s;const i=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((i,l)=>i._id===n?(s=l,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new p,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],i=new p(n[1]);this._setEnvironmentVariableCollection(s,i)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};_=je([Be(1,D.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class p{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,i)=>t.call(n,i,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let c=class extends _{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new r.NotSupportedError}createTerminalFromOptions(t){throw new r.NotSupportedError}getDefaultShell(t,n){throw new r.NotSupportedError}getDefaultShellArgs(t,n){throw new r.NotSupportedError}$getAvailableProfiles(t){throw new r.NotSupportedError}async $getDefaultShellAndArgs(t){throw new r.NotSupportedError}};c=je([Be(0,D.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(me[247],ge([0,1,3,15,5,123,20,7]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(r,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const C=this._extHostDocumentsAndEditors.allEditors();return r?C:C.map(g=>g.value)}async showTextDocument(r,C,g){let m;typeof C=="number"?m={position:D.ViewColumn.from(C),preserveFocus:g}:typeof C=="object"?m={position:D.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?D.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(r.uri,m),h=a&&this._extHostDocumentsAndEditors.getEditor(a);if(h)return h.value;throw a?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r){return new A.TextEditorDecorationType(this._proxy,r).value}$acceptEditorPropertiesChanged(r,C){const g=this._extHostDocumentsAndEditors.getEditor(r);if(!g)throw new Error("unknown text editor");if(C.options&&g._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(D.Selection.to);g._acceptSelections(m)}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(D.Range.to));g._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=P.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:a,kind:m})}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:m})}}$acceptEditorPositionData(r){for(const C in r){const g=this._extHostDocumentsAndEditors.getEditor(C);if(!g)throw new Error("Unknown text editor");const m=D.ViewColumn.to(r[C]);g.value.viewColumn!==m&&(g._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:m}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=y});var Ht=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[248],ge([0,1,2,4,5,6,7]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class P{constructor(r,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:g=>{var m,a;if(g&&g.$mid===11){const h=g.uri===void 0?void 0:b.URI.revive(g.uri);return(a=(m=this._itemsBySourceAndUriMap.get(g.source))===null||m===void 0?void 0:m.get(y(h)))===null||a===void 0?void 0:a.get(g.handle)}return g}})}async $getTimeline(r,C,g,m,a){const h=this._providers.get(r);return h==null?void 0:h.provideTimeline(b.URI.revive(C),g,m,a)}registerTimelineProvider(r,C,g,m){const a=new A.DisposableStore,h=this.convertTimelineItem(C.id,m,a).bind(this);let S;C.onDidChange&&(S=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:r,onDidChange:void 0,async provideTimeline(_,p,c,f){var t;(f==null?void 0:f.resetCache)&&(a.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(_,p,c);if(n!=null){const s=h(_,f);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(s)})}},dispose(){var _;for(const p of w.values())(_=p.get(C.id))===null||_===void 0||_.clear();S==null||S.dispose(),a.dispose()}}))}convertTimelineItem(r,C,g){return(m,a)=>{let h;if(a==null?void 0:a.cacheResults){let S=this._itemsBySourceAndUriMap.get(r);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(r,S));const w=y(m);h=S.get(w),h===void 0&&(h=new Map,S.set(w,h))}return S=>{var w,_;const{iconPath:p}=S,c=Ht(S,["iconPath"]),f=`${r}|${(w=S.id)!==null&&w!==void 0?w:S.timestamp}`;h==null||h.set(f,S);let t,n,s;return S.iconPath&&(p instanceof D.ThemeIcon?s={id:p.id}:b.URI.isUri(p)?(t=p,n=p):{light:t,dark:n}=p),Object.assign(Object.assign({},c),{id:(_=c.id)!==null&&_!==void 0?_:void 0,handle:f,source:r,command:S.command?C.toInternal(S.command,g):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),(0,A.toDisposable)(()=>{var g;for(const m of this._itemsBySourceAndUriMap.values())(g=m.get(r.id))===null||g===void 0||g.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=P;function y(k){return k==null?void 0:k.toString()}}),define(me[249],ge([0,1,6,11,2,5]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,r,C){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const g=C.schemes.find(m=>!D.supportedSchemes.has(m));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,r),this._proxy.$registerUriOpener(k,C.schemes,y,C.label),(0,b.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,r){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener with id: ${y}`);const g=T.URI.revive(k);return C.canOpenExternalUri(g,r)}async $openUri(y,k,r){const C=this._openers.get(y);if(!C)throw new Error(`Unknown opener id: '${y}'`);return C.openExternalUri(T.URI.revive(k.resolvedUri),{sourceUri:T.URI.revive(k.sourceUri)},r)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(me[250],ge([0,1,5,2,6,18,29]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(k,r){if(this.handles.has(D.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const C=P.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(k)),this.handlers.set(C,r),this._proxy.$registerUriHandler(C,k),(0,T.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(k)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(k,r){const C=this.handlers.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(r))}catch(g){(0,A.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[66],ge([0,1,22,3,2,177,200,63,5]),function(G,e,b,I,T,A,D,P,y){"use strict";var k,r,C,g,m,a,h,S,w,_,p,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(d,v,R,L,H,ie,j){k.set(this,void 0),r.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,""),S.set(this,void 0),w.set(this,!1),_.set(this,!1),p.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new I.Emitter),this._onDidDispose=Ue(this,c,"f").event,tt(this,k,d,"f"),tt(this,r,v,"f"),tt(this,S,R,"f"),tt(this,g,L,"f"),tt(this,m,H,"f"),tt(this,a,ie,"f"),tt(this,p,t(ie),"f"),tt(this,C,j,"f")}dispose(){tt(this,w,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return tt(this,_,!0,"f"),(0,P.asWebviewUri)(Ue(this,g,"f"),Ue(this,k,"f"),d)}get cspSource(){return Ue(this,g,"f").webviewCspSource.replace("{{uuid}}",Ue(this,k,"f"))}get html(){return this.assertNotDisposed(),Ue(this,h,"f")}set html(d){this.assertNotDisposed(),Ue(this,h,"f")!==d&&(tt(this,h,d,"f"),!Ue(this,_,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(tt(this,_,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,r,"f").$setHtml(Ue(this,k,"f"),d))}get options(){return this.assertNotDisposed(),Ue(this,S,"f")}set options(d){this.assertNotDisposed(),Ue(this,r,"f").$setOptions(Ue(this,k,"f"),l(Ue(this,a,"f"),Ue(this,m,"f"),d)),tt(this,S,d,"f")}async postMessage(d){if(Ue(this,w,"f"))return!1;const v=n(d,{serializeBuffersForPostMessage:Ue(this,p,"f")});return Ue(this,r,"f").$postMessage(Ue(this,k,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,k=new WeakMap,r=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap;function t(E){if(!E.enableProposedApi)return!1;try{const d=(0,A.normalizeVersion)((0,A.parseVersion)(E.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=56}catch(d){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(E,d){if(d.serializeBuffersForPostMessage){const v=[],R=(H,ie)=>{if(ie&&ie instanceof ArrayBuffer){let j=v.findIndex(B=>B.original===ie);if(j===-1){const B=new Uint8Array(ie),$=b.VSBuffer.wrap(B);j=v.length,v.push({original:ie,vsBuffer:$})}return{$$vscode_array_buffer_reference$$:!0,index:j}}return ie};return{message:JSON.stringify(E,R),buffers:v.map(H=>H.vsBuffer)}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeMessage=n;class s{constructor(d,v,R,L,H){this.initData=v,this.workspace=R,this._logService=L,this._deprecationService=H,this._webviews=new Map,this._webviewProxy=d.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(d,v,...R){const L=this.getWebview(d);if(L){const{message:H}=(0,D.deserializeWebviewMessage)(v,R);L._onMessageEmitter.fire(H)}}$onMissingCsp(d,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,v,R){const L=new f(d,this._webviewProxy,o(v),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(d,L),L._onDidDispose(()=>{this._webviews.delete(d)}),L}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=s;function i(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=i;function l(E,d,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||u(E,d)}}e.serializeWebviewOptions=l;function o(E){var d;return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:(d=E.localResourceRoots)===null||d===void 0?void 0:d.map(v=>T.URI.from(v))}}e.reviveOptions=o;function u(E,d){return[...((d==null?void 0:d.getWorkspaceFolders())||[]).map(v=>v.uri),E.extensionLocation]}}),define(me[251],ge([0,1,21,74,6,11,25,2,20,66,86,5,7]),function(G,e,b,I,T,A,D,P,y,k,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const i=this.key(t,n.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const l=new m(n,s);return this._documents.set(i,l),l}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var h;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(h||(h={}));class S{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,i){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:i}),new g.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,i,l){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=l,this._editorProviders=new S,this._documents=new a,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,i){const l=new T.DisposableStore;return _(s)?(l.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&l.add(s.onDidChangeCustomDocument(o=>{const u=this.getCustomDocumentEntry(n,o.document.uri);if(p(o)){const E=u.addEdit(o);this._proxy.$onDidEdit(o.document.uri,n,E,o.label)}else this._proxy.$onContentChange(o.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(l,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,i,l){var o;const u=this._editorProviders.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${n}'`);const E=P.URI.revive(t),d=await u.provider.openCustomDocument(E,{backupId:s,untitledDocumentData:i==null?void 0:i.buffer},l);let v;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(v=(o=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&o!==void 0?o:this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(n,d,v),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const i=P.URI.revive(t),{document:l}=this.getCustomDocumentEntry(n,i);this._documents.delete(n,l),l.dispose()}async $resolveWebviewEditor(t,n,s,i,l,o){const u=this._editorProviders.get(s);if(!u)throw new Error(`No provider found for '${s}'`);const E=y.ViewColumn.to(l),d=this._extHostWebview.createNewWebview(n,i.webviewOptions,u.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(n,s,i.title,E,i.panelOptions,d),R=P.URI.revive(t);switch(u.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,R);return u.provider.resolveCustomEditor(L,v,o)}case 0:{const L=this._extHostDocuments.getDocument(R);return u.provider.resolveCustomTextEditor(L,v,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const o=P.URI.revive(n),u=this._extHostDocuments.getDocument(o);await i.provider.moveCustomTextEditor(u,l,b.CancellationToken.None)}async $undo(t,n,s,i){return this.getCustomDocumentEntry(n,t).undo(s,i)}async $redo(t,n,s,i){return this.getCustomDocumentEntry(n,t).redo(s,i)}async $revert(t,n,s){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,n,s){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,n,s,i){const l=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(l.document,P.URI.revive(s),i)}async $backup(t,n,s){const i=this.getCustomDocumentEntry(n,t),o=await this.getCustomEditorProvider(n).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(o),o.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,P.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function _(f){return typeof f.resolveCustomTextEditor=="function"}function p(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function c(f){const t=f.scheme===A.Schemas.file||f.scheme===A.Schemas.untitled?f.fsPath:f.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[252],ge([0,1,3,6,2,28,20,66,5,7]),function(G,e,b,I,T,A,D,P,y,k){"use strict";var r,C,g,m,a,h,S,w,_,p,c,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(o,u,E,d,v,R,L){super();r.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,void 0),S.set(this,void 0),w.set(this,void 0),_.set(this,!0),p.set(this,!0),c.set(this,!1),f.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,f,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,r,o,"f"),tt(this,C,u,"f"),tt(this,g,E,"f"),tt(this,a,R,"f"),tt(this,w,v,"f"),tt(this,h,d,"f"),tt(this,m,L,"f")}dispose(){Ue(this,c,"f")||(tt(this,c,!0,"f"),Ue(this,f,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,r,"f")),Ue(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,g,"f")}get title(){return this.assertNotDisposed(),Ue(this,h,"f")}set title(o){this.assertNotDisposed(),Ue(this,h,"f")!==o&&(tt(this,h,o,"f"),Ue(this,C,"f").$setTitle(Ue(this,r,"f"),o))}get iconPath(){return this.assertNotDisposed(),Ue(this,S,"f")}set iconPath(o){this.assertNotDisposed(),Ue(this,S,"f")!==o&&(tt(this,S,o,"f"),Ue(this,C,"f").$setIconPath(Ue(this,r,"f"),T.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,p,"f")}get visible(){return this.assertNotDisposed(),Ue(this,_,"f")}_updateViewState(o){Ue(this,c,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(tt(this,p,o.active,"f"),tt(this,_,o.visible,"f"),tt(this,w,o.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(o,u){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,r,"f"),{viewColumn:o?D.ViewColumn.from(o):void 0,preserveFocus:!!u})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,_=new WeakMap,p=new WeakMap,c=new WeakMap,f=new WeakMap,t=new WeakMap;class s{constructor(o,u,E){this.webviews=u,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(o,u,E,d,v={}){const R=typeof d=="object"?d.viewColumn:d,L={viewColumn:D.ViewColumn.from(R),preserveFocus:typeof d=="object"&&!!d.preserveFocus},H=(0,P.shouldSerializeBuffersForPostMessage)(o),ie=s.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(o),ie,u,{title:E,panelOptions:i(v),webviewOptions:(0,P.serializeWebviewOptions)(o,this.workspace,v),serializeBuffersForPostMessage:H},L);const j=this.webviews.createNewWebview(ie,v,o);return this.createNewWebviewPanel(ie,u,E,R,v,j)}$onDidChangeWebviewPanelViewStates(o){const u=Object.keys(o);u.sort((E,d)=>{const v=o[E],R=o[d];return v.active?1:R.active?-1:+v.visible-+R.visible});for(const E of u){const d=this.getWebviewPanel(E);if(!!d){const v=o[E];d._updateViewState({active:v.active,visible:v.visible,viewColumn:D.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(o){const u=this.getWebviewPanel(o);u==null||u.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,u,E){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:E,extension:o}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(o)}),new k.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(o,u,E,d){const v=this._serializers.get(u);if(!v)throw new Error(`No serializer found for '${u}'`);const{serializer:R,extension:L}=v,H=this.webviews.createNewWebview(o,E.webviewOptions,L),ie=this.createNewWebviewPanel(o,u,E.title,d,E.panelOptions,H);await R.deserializeWebviewPanel(ie,E.state)}createNewWebviewPanel(o,u,E,d,v,R){const L=new n(o,this._proxy,u,E,d,v,R);return this._webviewPanels.set(o,L),L}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=s;function i(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[253],ge([0,1,3,6,66,5,7]),function(G,e,b,I,T,A,D){"use strict";var P,y,k,r,C,g,m,a,h,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(c,f,t,n,s,i){super();P.set(this,void 0),y.set(this,void 0),k.set(this,void 0),r.set(this,void 0),C.set(this,!1),g.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,S.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,S,"f").event,tt(this,k,t,"f"),tt(this,m,n,"f"),tt(this,P,c,"f"),tt(this,y,f,"f"),tt(this,r,s,"f"),tt(this,g,i,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,S,"f").fire(),Ue(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(c){this.assertNotDisposed(),Ue(this,m,"f")!==c&&(tt(this,m,c,"f"),Ue(this,y,"f").$setWebviewViewTitle(Ue(this,P,"f"),c))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(c){this.assertNotDisposed(),Ue(this,a,"f")!==c&&(tt(this,a,c,"f"),Ue(this,y,"f").$setWebviewViewDescription(Ue(this,P,"f"),c))}get visible(){return Ue(this,g,"f")}get webview(){return Ue(this,r,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(c){c===Ue(this,g,"f")||Ue(this,C,"f")||(tt(this,g,c,"f"),Ue(this,h,"f").fire())}show(c){this.assertNotDisposed(),Ue(this,y,"f").$show(Ue(this,P,"f"),!!c)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,y=new WeakMap,k=new WeakMap,r=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap;class _{constructor(c,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(c),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new D.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(c,f,t,n,s){const i=this._viewProviders.get(f);if(!i)throw new Error(`No view provider found for '${f}'`);const{provider:l,extension:o}=i,u=this._extHostWebview.createNewWebview(c,{},o),E=new w(c,this._proxy,f,t,u,!0);this._webviewViews.set(c,E),await l.resolveWebviewView(E,{state:n},s)}async $onDidChangeWebviewViewVisibility(c,f){this.getWebviewView(c)._setVisible(f)}async $disposeWebviewView(c){const f=this.getWebviewView(c);this._webviewViews.delete(c),f.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const f=this._webviewViews.get(c);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=_}),define(me[126],ge([0,1,3,5,2,11,10,4,14]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class On{constructor(C){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=On.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,g){let m;if(typeof C=="string"){m=C;try{C=T.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,D.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,g)}async asExternalUri(C,g){if((0,D.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,g);return T.URI.from(m)}};k.InitialState={focused:!0},k=je([Be(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(me[254],ge([0,1,8,48,28,51,6,5,2,14]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends D.Disposable{constructor(g,m){super();const a=g.getProxy(P.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async h=>{const S=y.URI.file((0,b.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await a.$download(h,S),S})}};r=je([Be(0,k.IExtHostRpcService),Be(1,A.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(me[255],ge([0,1,2,8,146,26,37,65,27,14,6,13,112,45]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(_,p){this.file=p,this.appender=(0,g.createRotatingLogger)(_,p,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class h extends P.AbstractExtHostOutputChannel{constructor(_,p,c){super(_,!1,b.URI.file(p.file),c);this._appender=p}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,p){this._appender.flush(),super.show(_,p)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=h;let S=class extends P.ExtHostOutputService{constructor(_,p,c){super(_);this.logService=p,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new r.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(_){if(_){const p=this._channels.get(_);p&&(this._visibleChannelDisposable.value=p.onDidAppend(()=>p.update()))}}createOutputChannel(_){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this._doCreateOutChannel(_);return p.then(c=>c._id.then(f=>this._channels.set(f,c))),new P.LazyOutputChannel(_,p)}async _doCreateOutChannel(_){try{const p=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(p)||await D.promises.mkdir(p,{recursive:!0});const f=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,I.join)(p,`${f}.log`)),n=new a(f,t.fsPath);return new h(_,n,this._proxy)}catch(p){return this.logService.error(p),new P.ExtHostPushOutputChannel(_,this._proxy)}}};S=je([Be(0,k.IExtHostRpcService),Be(1,C.ILogService),Be(2,y.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(me[256],ge([0,1,5,14,6,27,2,38,25,37,26,7,9,50,3,73,13]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(u,E,d){this.remoteAddress=u,this.localAddress=E,this._dispose=d,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(o){const u=o.trim().split(`
`),E=[];return u.forEach(v=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);R&&R.length>=3&&E.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),E.reduce((v,R)=>(v[R.socket]=R,v),{})}e.getSockets=_;function p(...o){const u=[].concat(...o.map(f));return[...new Map(u.filter(E=>E.st==="0A").map(E=>{const d=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:c(d[0]),port:parseInt(d[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=p;function c(o){let u="";if(o.length===8)for(let E=o.length-2;E>=0;E-=2)u+=parseInt(o.substr(E,2),16),E!==0&&(u+=".");else for(let E=o.length-4;E>=0;E-=4)u+=parseInt(o.substr(E,4),16).toString(16),E!==0&&(u+=":");return u}e.parseIpAddress=c;function f(o){const u=o.trim().split(`
`),E=u.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return u.map(v=>v.trim().split(/\s+/).reduce((R,L,H)=>(R[E[H]||H]=L,R),{}))}e.loadConnectionTable=f;function t(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function n(o){const u=o.trim().split(`
`),E=[];return u.forEach(d=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(d);v&&v.length>=4&&E.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),E}e.getRootProcesses=n;async function s(o,u,E){const d=E.reduce((R,L)=>(R[L.pid]=L,R),{}),v=[];return o.forEach(({socket:R,ip:L,port:H})=>{var ie;const j=u[R]?u[R].pid:void 0,B=j?(ie=d[j])===null||ie===void 0?void 0:ie.cmd:void 0;j&&B&&!t(B)&&v.push({host:L,port:H,detail:B,pid:j})}),v}e.findPorts=s;function i(o,u,E){const d=new Map,v=n(u);for(const R of o){const L=E.get(R.port);if(L){d.set(R.port,L);continue}const H=v.find(ie=>ie.cmd.includes(`${R.port}`));if(H){let ie=H,j;do j=v.find(B=>B.ppid===ie.pid),j&&(ie=j);while(j);d.set(R.port,{host:R.ip,port:R.port,pid:ie.pid,detail:ie.cmd,ppid:ie.ppid})}else d.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return d}e.tryFindRootPorts=i;let l=class extends T.Disposable{constructor(u,E,d){super();this.logService=d,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=u.getProxy(b.MainContext.MainThreadTunnelService),g.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(u,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${E.remoteAddress.port}.`);const d=await this._proxy.$openTunnel(E,u.displayName);if(d){const v=new w(d.remoteAddress,d.localAddress,()=>this._proxy.$closeTunnel(d.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(u){return Math.max(u*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(u,E){const d=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(d,{selector:u,provider:E}),this._proxy.$registerPortsAttributesProvider(u,d),new C.Disposable(()=>{this._portAttributesProviders.delete(d),this._proxy.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(u,E,d,v,R){const L=[];for(const ie of u){const j=this._portAttributesProviders.get(ie);if(!j)return[];L.push(...await Promise.all(E.map(async B=>j.provider.providePortAttributes(B,d,v,R))))}const H=L.filter(ie=>!!ie);return H.length>0?H.map(ie=>({autoForwardAction:ie.autoForwardAction,port:ie.port})):[]}async $registerCandidateFinder(u){if(!(u&&this._candidateFindingEnabled)){this._candidateFindingEnabled=u;let E=new h.MovingAverage,d;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(H=>H.port).join(", ")}`);const L=new Date().getTime()-v;E.update(L),(!d||JSON.stringify(d)!==JSON.stringify(R))&&(d=R,await this._proxy.$onFoundNewCandidates(d)),await new Promise(H=>setTimeout(()=>H(),this.calculateDelay(E.value)))}}}async setTunnelExtensionFunctions(u){var E;return u?(u.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this._showCandidatePort=u.showCandidatePort,await this._proxy.$setCandidateFilter()),u.tunnelFactory&&(this._forwardPortProvider=u.tunnelFactory,await this._proxy.$setTunnelProvider((E=u.tunnelFeatures)!==null&&E!==void 0?E:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(u,E){if(this._extensionTunnels.has(u.host)){const d=this._extensionTunnels.get(u.host);d.has(u.port)&&(E&&d.get(u.port).disposeListener.dispose(),await d.get(u.port).tunnel.dispose(),d.delete(u.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(u,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this._forwardPortProvider(u,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const v=await d;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(u.remoteAddress.host)||this._extensionTunnels.set(u.remoteAddress.host,new Map);const R=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:v,disposeListener:R}),m.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(d){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const E=await Promise.all(u.map(v=>{var R;return this._showCandidatePort(v.host,v.port,(R=v.detail)!==null&&R!==void 0?R:"")})),d=u.filter((v,R)=>E[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(v=>v.port).join(", ")} to ${d.map(v=>v.port).join(", ")}`),d}async findCandidatePorts(){let u="",E="";try{u=await k.promises.readFile("/proc/net/tcp","utf8"),E=await k.promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const d=p(u,E),v=await new Promise(N=>{(0,P.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(M,F,U)=>{N(F)})}),R=_(v),L=await r.readdir("/proc"),H=[];for(let N of L)try{const M=Number(N),F=y.joinPath(D.URI.file("/proc"),N);if((await k.promises.stat(F.fsPath)).isDirectory()&&!isNaN(M)){const O=await k.promises.readlink(y.joinPath(F,"cwd").fsPath),W=await k.promises.readFile(y.joinPath(F,"cmdline").fsPath,"utf8");H.push({pid:M,cwd:O,cmd:W})}}catch(M){}const ie=[],j=d.filter(N=>{const M=R[N.socket];return M||ie.push(N),M}),B=s(j,R,H);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ie.length}`),ie.length>0){const N=await new Promise(M=>{(0,P.exec)("ps -F -A -l | grep root",(F,U,O)=>{M(U)})});this._foundRootPorts=i(ie,N,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return B.then(N=>$?N.concat($):N)}};l=je([Be(0,I.IExtHostRpcService),Be(1,A.IExtHostInitDataService),Be(2,S.ILogService)],l),e.ExtHostTunnelService=l}),define(me[257],ge([0,1,19,21,18,3,6,100,227,124,22]),function(G,e,b,I,T,A,D,P,y,k,r){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function g(i,l){try{return JSON.stringify(i,l)}catch(o){return"null"}}function m(i,l){return JSON.stringify(i,l)}function a(i){return i?(l,o)=>o&&o.$mid===1?i.transformOutgoing(o):o:null}var h;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},_=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class c extends D.Disposable{constructor(l,o=null,u=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=o,this._uriTransformer=u,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,d=k.ProxyIdentifier.count;E<d;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?(0,P.transformIncomingURIs)(l,this._uriTransformer):l}getProxy(l){const{nid:o,sid:u}=l;return this._proxies[o]||(this._proxies[o]=this._createProxy(o,u)),this._proxies[o]}_createProxy(l,o){let u={get:(E,d)=>(typeof d=="string"&&!E[d]&&d.charCodeAt(0)===36&&(E[d]=(...v)=>this._remoteCall(l,d,v)),d===p?o:E[d])};return new Proxy(Object.create(null),u)}set(l,o){return this._locals[l.nid]=o,o}assertRegistered(l){for(let o=0,u=l.length;o<u;o++){const E=l[o];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(l){if(!this._isDisposed){const o=l.byteLength,u=f.read(l,0),E=u.readUInt8(),d=u.readUInt32();switch(E){case 1:case 2:{let{rpcId:v,method:R,args:L}=t.deserializeRequestJSONArgs(u);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(o,d,v,R,L,E===2);break}case 3:case 4:{let{rpcId:v,method:R,args:L}=t.deserializeRequestMixedArgs(u);this._uriTransformer&&(L=(0,P.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(o,d,v,R,L,E===4);break}case 5:{this._logger&&this._logger.logIncoming(o,d,0,"ack"),this._onDidReceiveAcknowledge(d);break}case 6:{this._receiveCancel(o,d);break}case 7:{this._receiveReply(o,d,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(u);this._uriTransformer&&(v=(0,P.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(o,d,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(u);this._receiveReply(o,d,v);break}case 10:{let v=t.deserializeReplyErrError(u);this._uriTransformer&&(v=(0,P.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(o,d,v);break}case 11:{this._receiveReplyErr(o,d,void 0);break}default:console.error("received unexpected message"),console.error(l)}}}_receiveRequest(l,o,u,E,d,v){this._logger&&this._logger.logIncoming(l,o,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(u)}.${E}(`,d);const R=String(o);let L,H;if(v){const j=new I.CancellationTokenSource;d.push(j.token),L=this._invokeHandler(u,E,d),H=()=>j.cancel()}else L=this._invokeHandler(u,E,d),H=w;this._cancelInvokedHandlers[R]=H;const ie=t.serializeAcknowledged(o);this._logger&&this._logger.logOutgoing(ie.byteLength,o,1,"ack"),this._protocol.send(ie),L.then(j=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyOK(o,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,o,1,"reply:",j),this._protocol.send(B)},j=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyErr(o,j);this._logger&&this._logger.logOutgoing(B.byteLength,o,1,"replyErr:",j),this._protocol.send(B)})}_receiveCancel(l,o){this._logger&&this._logger.logIncoming(l,o,1,"receiveCancel");const u=String(o);this._cancelInvokedHandlers[u]&&this._cancelInvokedHandlers[u]()}_receiveReply(l,o,u){this._logger&&this._logger.logIncoming(l,o,0,"receiveReply:",u);const E=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const d=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],d.resolveOk(u)}}_receiveReplyErr(l,o,u){this._logger&&this._logger.logIncoming(l,o,0,"receiveReplyErr:",u);const E=String(o);if(!!this._pendingRPCReplies.hasOwnProperty(E)){const d=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let v;u&&(u.$isError?(v=new Error,v.name=u.name,v.message=u.message,v.stack=u.stack):v=u),d.resolveErr(v)}}_invokeHandler(l,o,u){try{return Promise.resolve(this._doInvokeHandler(l,o,u))}catch(E){return Promise.reject(E)}}_doInvokeHandler(l,o,u){const E=this._locals[l];if(!E)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(l));let d=E[o];if(typeof d!="function")throw new Error("Unknown method "+o+" on actor "+(0,k.getStringIdentifierForProxy)(l));return d.apply(E,u)}_remoteCall(l,o,u){if(this._isDisposed)return Promise.reject(T.canceled());let E=null;if(u.length>0&&I.CancellationToken.isCancellationToken(u[u.length-1])&&(E=u.pop()),E&&E.isCancellationRequested)return Promise.reject(T.canceled());const d=t.serializeRequestArguments(u,this._uriReplacer),v=++this._lastMessageId,R=String(v),L=new y.LazyPromise;E&&E.onCancellationRequested(()=>{const ie=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(ie.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[R]=L,this._onWillSendRequest(v);const H=t.serializeRequest(v,l,o,d,!!E);return this._logger&&this._logger.logOutgoing(H.byteLength,v,0,`request: ${(0,k.getStringIdentifierForProxy)(l)}.${o}(`,u),this._protocol.send(H),L}}e.RPCProtocol=c,C=_,c.UNRESPONSIVE_TIME=3*1e3;class f{constructor(l,o){this._buff=l,this._offset=o}static alloc(l,o,u){let E=new f(r.VSBuffer.alloc(u+1+4),0);return E.writeUInt8(l),E.writeUInt32(o),E}static read(l,o){return new f(l,o)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const u=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,u}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,u}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const o=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,o}static sizeMixedArray(l,o){let u=0;u+=1;for(let E=0,d=l.length;E<d;E++){const v=l[E],R=o[E];switch(u+=1,R){case 1:u+=this.sizeLongString(v);break;case 2:u+=this.sizeVSBuffer(v);break;case 3:break}}return u}writeMixedArray(l,o){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let u=0,E=l.length;u<E;u++){const d=l[u];switch(o[u]){case 1:this.writeUInt8(1),this.writeLongString(d);break;case 2:this.writeUInt8(2),this.writeVSBuffer(d);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let o=new Array(l);for(let u=0;u<l;u++)switch(this.readUInt8()){case 1:o[u]=this.readLongString();break;case 2:o[u]=this.readVSBuffer();break;case 3:o[u]=void 0;break}return o}}class t{static _arrayContainsBufferOrUndefined(l){for(let o=0,u=l.length;o<u;o++)if(l[o]instanceof r.VSBuffer||typeof l[o]=="undefined")return!0;return!1}static serializeRequestArguments(l,o){if(this._arrayContainsBufferOrUndefined(l)){let u=[],E=[];for(let d=0,v=l.length;d<v;d++){const R=l[d];R instanceof r.VSBuffer?(u[d]=R,E[d]=2):typeof R=="undefined"?(u[d]=r.VSBuffer.alloc(0),E[d]=3):(u[d]=r.VSBuffer.fromString(m(R,o)),E[d]=1)}return{type:"mixed",args:u,argsType:E}}return{type:"simple",args:m(l,o)}}static serializeRequest(l,o,u,E,d){return E.type==="mixed"?this._requestMixedArgs(l,o,u,E.args,E.argsType,d):this._requestJSONArgs(l,o,u,E.args,d)}static _requestJSONArgs(l,o,u,E,d){const v=r.VSBuffer.fromString(u),R=r.VSBuffer.fromString(E);let L=0;L+=f.sizeUInt8(),L+=f.sizeShortString(v),L+=f.sizeLongString(R);let H=f.alloc(d?2:1,l,L);return H.writeUInt8(o),H.writeShortString(v),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(l){const o=l.readUInt8(),u=l.readShortString(),E=l.readLongString();return{rpcId:o,method:u,args:JSON.parse(E)}}static _requestMixedArgs(l,o,u,E,d,v){const R=r.VSBuffer.fromString(u);let L=0;L+=f.sizeUInt8(),L+=f.sizeShortString(R),L+=f.sizeMixedArray(E,d);let H=f.alloc(v?4:3,l,L);return H.writeUInt8(o),H.writeShortString(R),H.writeMixedArray(E,d),H.buffer}static deserializeRequestMixedArgs(l){const o=l.readUInt8(),u=l.readShortString(),E=l.readMixedArray(),d=new Array(E.length);for(let v=0,R=E.length;v<R;v++){const L=E[v];typeof L=="string"?d[v]=JSON.parse(L):d[v]=L}return{rpcId:o,method:u,args:d}}static serializeAcknowledged(l){return f.alloc(5,l,0).buffer}static serializeCancel(l){return f.alloc(6,l,0).buffer}static serializeReplyOK(l,o,u){return typeof o=="undefined"?this._serializeReplyOKEmpty(l):o instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(l,o):this._serializeReplyOKJSON(l,g(o,u))}static _serializeReplyOKEmpty(l){return f.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,o){let u=0;u+=f.sizeVSBuffer(o);let E=f.alloc(8,l,u);return E.writeVSBuffer(o),E.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,o){const u=r.VSBuffer.fromString(o);let E=0;E+=f.sizeLongString(u);let d=f.alloc(9,l,E);return d.writeLongString(u),d.buffer}static deserializeReplyOKJSON(l){const o=l.readLongString();return JSON.parse(o)}static serializeReplyErr(l,o){return o?this._serializeReplyErrEror(l,o):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,o){const u=r.VSBuffer.fromString(g(T.transformErrorForSerialization(o),null));let E=0;E+=f.sizeLongString(u);let d=f.alloc(10,l,E);return d.writeLongString(u),d.buffer}static deserializeReplyErrError(l){const o=l.readLongString();return JSON.parse(o)}static _serializeReplyErrEmpty(l){return f.alloc(11,l,0).buffer}}var n;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(me[258],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[259],ge([0,1,11,8,9,2,4,258]),function(G,e,b,I,T,A,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(r,C){this.localUserHome=r,this.remoteAgentService=C,this.resolveOS=(async()=>{const g=await this.remoteAgentService.getEnvironment();return(g==null?void 0:g.os)||T.OS})(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(g==null?void 0:g.userHome)||r})()}async userHome(r){return(r==null?void 0:r.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(r=>r===1?I.win32:I.posix)}async fileURI(r){let C="";if(await this.resolveOS===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const m=r.indexOf("/",2);m===-1?(C=r.substring(2),r="/"):(C=r.substring(2,m),r=r.substring(m)||"/")}return A.URI.from({scheme:b.Schemas.file,authority:C,path:r,query:"",fragment:""})}};y=je([Be(1,P.IRemoteAgentService)],y),e.AbstractPathService=y}),define(me[31],ge([0,1,15,33,23,30,10,4,8,18]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const r="\u27EA ",C=" characters skipped \u27EB",g=(r.length+C.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var m;(function(N){N[N.file=0]="file",N[N.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(N){N[N.File=1]="File",N[N.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function h(N){return!!N.preview}e.resultIsMatch=h;function S(N){return!!N.resource}e.isFileMatch=S;function w(N){return!!N.message}e.isProgressMessage=w;var _;(function(N){N[N.Normal=0]="Normal",N[N.NewSearchStarted=1]="NewSearchStarted"})(_=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(M){this.resource=M,this.results=[]}}e.FileMatch=p;class c{constructor(M,F,U){this.ranges=F;const O=Array.isArray(F)?F:[F];if(U&&U.matchLines===1&&f(O)){M=(0,D.getNLines)(M,U.matchLines);let W="",q=0,Q=0;const he=Math.floor(U.charsPerLine/5),ve=[];for(const Pe of O){const ke=Math.max(Pe.startColumn-he,0),Le=Pe.startColumn+U.charsPerLine;if(ke>Q+he+g){const V=r+(ke-Q)+C;W+=V+M.slice(ke,Le),q+=ke-(Q+V.length)}else W+=M.slice(Q,Le);ve.push(new n(0,Pe.startColumn-q,Pe.endColumn-q)),Q=Le}this.preview={text:W,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const W=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:M,matches:(0,b.mapArrayOrNot)(F,q=>new t(q.startLineNumber-W,q.startColumn,q.endLineNumber-W,q.endColumn))}}}}e.TextSearchMatch=c;function f(N){const M=N[0].startLineNumber;for(const F of N)if(F.startLineNumber!==M||F.endLineNumber!==M)return!1;return!0}class t{constructor(M,F,U,O){this.startLineNumber=M,this.startColumn=F,this.endLineNumber=U,this.endColumn=O}}e.SearchRange=t;class n extends t{constructor(M,F,U){super(M,F,M,U)}}e.OneLineRange=n;var s;(function(N){N.Default="default",N.FileNames="fileNames",N.Type="type",N.Modified="modified",N.CountDescending="countDescending",N.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function i(N,M=!0){const F=N&&N.files&&N.files.exclude,U=M&&N&&N.search&&N.search.exclude;if(!(!F&&!U)){if(!F||!U)return F||U;let O=Object.create(null);return O=T.mixin(O,T.deepClone(F)),O=T.mixin(O,T.deepClone(U),!0),O}}e.getExcludes=i;function l(N,M){return N.excludePattern&&I.match(N.excludePattern,M)?!1:N.includePattern||N.usingSearchPaths?N.includePattern&&I.match(N.includePattern,M)?!0:N.usingSearchPaths?!!N.folderQueries&&N.folderQueries.some(F=>{const U=F.folder.fsPath;if(A.isEqualOrParent(M,U)){const O=y.relative(U,M);return!F.includePattern||!!I.match(F.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var o;(function(N){N[N.unknownEncoding=1]="unknownEncoding",N[N.regexParseError=2]="regexParseError",N[N.globParseError=3]="globParseError",N[N.invalidLiteral=4]="invalidLiteral",N[N.rgProcessError=5]="rgProcessError",N[N.other=6]="other",N[N.canceled=7]="canceled"})(o=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(M,F){super(M);this.code=F}}e.SearchError=u;function E(N){const M=N.message;if((0,k.isPromiseCanceledError)(N))return new u(M,o.canceled);try{const F=JSON.parse(M);return new u(F.message,F.code)}catch(F){return new u(M,o.other)}}e.deserializeSearchError=E;function d(N){const M={message:N.message,code:N.code};return new Error(JSON.stringify(M))}e.serializeSearchError=d;function v(N){return N.type==="error"?!0:N.type==="success"}e.isSerializedSearchComplete=v;function R(N){return N.type==="success"}e.isSerializedSearchSuccess=R;function L(N){return!!N.path}e.isSerializedFileMatch=L;function H(N,M){const F=N.searchPath?N.searchPath:N.relativePath;return(0,D.fuzzyContains)(F,M)}e.isFilePatternMatch=H;class ie{constructor(M){this.path=M,this.results=[]}addMatch(M){this.results.push(M)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ie;function j(N,M){const F=Object.assign(Object.assign({},N||{}),M||{});return Object.keys(F).filter(U=>{const O=F[U];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=j;class B{constructor(M,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},M.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let U=M.includePattern;F.includePattern&&(U?U=Object.assign(Object.assign({},U),F.includePattern):U=F.includePattern),U&&(this._parsedIncludeExpression=I.parse(U))}includedInQuerySync(M,F,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(M,F,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(M,F,U))}includedInQuery(M,F,U){return Promise.resolve(this._parsedExcludeExpression(M,F,U)).then(W=>!!W).then(W=>W?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(M,F,U)).then(q=>!!q):Promise.resolve(!0)).then(W=>W)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=B;function $(N){for(const M in N)if(typeof N[M]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,15,19,21,3,24,11,73,25,10,12,2,167,4,13,186,60,61,27,14,7,31,5]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p,c,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,L,H){return new k.ExtUri(ie=>u(ie,H)).isEqual(R,L)}function i(R,L,H){return s(R.uri,L.uri,H)?0:(0,r.compare)(R.uri.toString(),L.uri.toString())}function l(R,L,H){return R.index!==L.index?R.index<L.index?-1:1:s(R.uri,L.uri,H)?(0,r.compare)(R.name,L.name):(0,r.compare)(R.uri.toString(),L.uri.toString())}function o(R,L,H,ie){const j=R.slice(0).sort(($,N)=>H($,N,ie)),B=L.slice(0).sort(($,N)=>H($,N,ie));return(0,b.delta)(j,B,($,N)=>H($,N,ie))}function u(R,L){const H=L.getCapabilities(R.scheme);return!(H&&H&1024)}class E extends w.Workspace{constructor(L,H,ie,j,B,$){super(L,ie.map(N=>new w.WorkspaceFolder(N)),j,$);this._name=H,this._isUntitled=B,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris($),ie.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(L,H,ie,j){if(!L)return{workspace:null,added:[],removed:[]};const{id:B,name:$,folders:N,configuration:M,isUntitled:F}=L,U=[],O=H;H?N.forEach((he,ve)=>{const Pe=g.URI.revive(he.uri),ke=E._findFolder(ie||H,Pe,j);ke?(ke.name=he.name,ke.index=he.index,U.push(ke)):U.push({uri:Pe,name:he.name,index:ve})}):U.push(...N.map(({uri:he,name:ve,index:Pe})=>({uri:g.URI.revive(he),name:ve,index:Pe}))),U.sort((he,ve)=>he.index<ve.index?-1:1);const W=new E(B,$,U,M?g.URI.revive(M):null,!!F,he=>u(he,j)),{added:q,removed:Q}=o(O?O.workspaceFolders:[],W.workspaceFolders,i,j);return{workspace:W,added:q,removed:Q}}static _findFolder(L,H,ie){for(let j=0;j<L.folders.length;j++){const B=L.workspaceFolders[j];if(s(B.uri,H,ie))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,H){return H&&this._structure.get(L)&&(L=(0,k.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let d=class{constructor(L,H,ie,j){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new A.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=ie,this._requestIdProvider=new y.Counter,this._barrier=new I.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const B=H.workspace;this._confirmedWorkspace=B?new E(B.id,B.name,[],B.configuration?g.URI.revive(B.configuration):null,!!B.isUntitled,$=>u($,ie)):void 0}$initializeWorkspace(L,H){this._trusted=H,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:P.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,H,ie,...j){const B=[];if(Array.isArray(j)&&j.forEach(U=>{g.URI.isUri(U.uri)&&!B.some(O=>s(O.uri,U.uri,this._extHostFileSystemInfo))&&B.push({uri:U.uri,name:U.name||(0,k.basenameOrAuthority)(U.uri)})}),this._unconfirmedWorkspace||[H,ie].some(U=>typeof U!="number"||U<0)||ie===0&&B.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+ie>$.length)return!1;const N=$.slice(0);N.splice(H,ie,...B.map(U=>({uri:U.uri,name:U.name||(0,k.basenameOrAuthority)(U.uri),index:void 0})));for(let U=0;U<N.length;U++){const O=N[U];if(N.some((W,q)=>q!==U&&s(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}N.forEach((U,O)=>U.index=O);const{added:M,removed:F}=o($,N,l,this._extHostFileSystemInfo);if(M.length===0&&F.length===0)return!1;if(this._proxy){const U=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(U,H,ie,B).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,m.localize)(0,null,U,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(N),!0}getWorkspaceFolder(L,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,H)}async getWorkspaceFolder2(L,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,H)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,H){let ie,j="";if(typeof L=="string"?(ie=g.URI.file(L),j=L):typeof L!="undefined"&&(ie=L,j=L.fsPath),!ie)return j;const B=this.getWorkspaceFolder(ie,!0);if(!B)return j;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let $=(0,k.relativePath)(B.uri,ie);return H&&B.name&&($=`${B.name}/${$}`),$}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:H,added:ie,removed:j}=E.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:j}))}findFiles(L,H,ie,j,B=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let $;if(H===null?$=!1:H&&(typeof H=="string"?$=H:$=H.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:N,folder:M}=v(L);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(N),(0,C.withUndefinedAsNull)(M),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(ie),B).then(F=>Array.isArray(F)?F.map(U=>g.URI.revive(U)):[])}async findTextInFiles(L,H,ie,j,B=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),N=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:M,folder:F}=v(H.include),U=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,O={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:N,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:M,excludePattern:U},W=!1;if(this._activeSearchCallbacks[$]=q=>{if(!W){const Q=g.URI.revive(q.resource);q.results.forEach(he=>{(0,t.resultIsMatch)(he)?ie({uri:Q,preview:{text:he.preview.text,matches:(0,b.mapArrayOrNot)(he.preview.matches,ve=>new f.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(he.ranges,ve=>new f.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ie({uri:Q,text:he.text,lineNumber:he.lineNumber})})}},B.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(L,(0,C.withUndefinedAsNull)(F),O,$,B);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(L,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){const H=this._proxy.$requestWorkspaceTrust(L);return(L==null?void 0:L.modal)?H:Promise.resolve(this._trusted)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};d=je([Be(0,c.IExtHostRpcService),Be(1,p.IExtHostInitDataService),Be(2,_.IExtHostFileSystemInfo),Be(3,h.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function v(R){let L,H;return R&&(typeof R=="string"?L=R:(L=R.pattern,H=R.baseFolder||g.URI.file(R.base))),{includePattern:L,folder:H}}}),define(me[35],ge([0,1,23,3,32,5,7,188,83,12,19,4,14,13,2]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(n,s){if(s){const i=s.split(".");let l=n;for(let o=0;l&&o<i.length;o++)l=l[i[o]];return l}}function S(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function p(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(S(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(p(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(s,i,l){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=l,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,i))}};f=je([Be(0,g.IExtHostRpcService),Be(1,T.IExtHostWorkspace),Be(2,m.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(s,i,l,o){this._onDidChangeConfiguration=new I.Emitter,this._proxy=s,this._logService=o,this._extHostWorkspace=i,this._configuration=P.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,l))}getConfiguration(s,i,l){const o=c(i)||{},u=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,o,l==null?void 0:l.identifier);function E(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(v){return typeof h(u,v)!="undefined"},get:(v,R)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,o,l==null?void 0:l.identifier);let L=h(u,v);if(typeof L=="undefined")L=R;else{let H;const ie=(j,B)=>{let $;const N=()=>{H=H||(0,b.deepClone)(u),$=$||h(H,B)};return(0,k.isObject)(j)?new Proxy(j,{get:(M,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return N(),()=>$;if(H)return $=$||h(H,B),$[F];const U=M[F];return typeof F=="string"?ie(U,`${B}.${F}`):U},set:(M,F,U)=>(N(),$&&($[F]=U),!0),deleteProperty:(M,F)=>(N(),$&&delete $[F],!0),defineProperty:(M,F,U)=>(N(),$&&Object.defineProperty($,F,U),!0)}):j};L=ie(L,v)}return L},update:(v,R,L,H)=>{v=s?`${s}.${v}`:v;const ie=E(L);return R!==void 0?this._proxy.$updateConfigurationOption(ie,v,R,o,H):this._proxy.$removeConfigurationOption(ie,v,o,H)},inspect:v=>{var R,L,H,ie,j,B,$,N;v=s?`${s}.${v}`:v;const M=(0,b.deepClone)(this._configuration.inspect(v,o,this._extHostWorkspace.workspace));if(M)return{key:v,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(L=M.user)===null||L===void 0?void 0:L.value,workspaceValue:(H=M.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(ie=M.workspaceFolder)===null||ie===void 0?void 0:ie.value,defaultLanguageValue:(j=M.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(B=M.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:($=M.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(N=M.workspaceFolder)===null||N===void 0?void 0:N.override,languageIds:M.overrideIdentifiers}}};return typeof u=="object"&&(0,b.mixin)(d,u,!1),Object.freeze(d)}_toReadonlyValue(s){const i=l=>(0,k.isObject)(l)?new Proxy(l,{get:(o,u)=>i(o[u]),set:(o,u,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(o,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(o,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return i(s)}_validateConfigurationAccess(s,i,l){const o=y.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),u=l?`[${l.value}] `:"";if(o===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){(i==null?void 0:i.resource)&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const l=new P.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,u)=>l.affectsConfiguration(o,c(u))})}_toMap(s){return s.reduce((i,l)=>(i.set(l[0],l[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[67],ge([0,1,2,19,3,5,7,32,39,35,21,34,14,27,4,11,9,13,64,209,18]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(j){function B(M){if(M){const F=M;return F&&!!F.process}else return!1}j.is=B;function $(M){if(M!=null){const F={process:M.process,args:M.args};return M.options&&(F.options=s.from(M.options)),F}}j.from=$;function N(M){if(M!=null)return new D.ProcessExecution(M.process,M.args,M.options)}j.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(j){function B(N){if(N!=null)return N}j.from=B;function $(N){if(N!=null)return N}j.to=$})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(j){function B(M){if(M){const F=M;return F&&(!!F.commandLine||!!F.command)}else return!1}j.is=B;function $(M){if(M!=null){const F={};return M.commandLine!==void 0?F.commandLine=M.commandLine:(F.command=M.command,F.args=M.args),M.options&&(F.options=l.from(M.options)),F}}j.from=$;function N(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new D.ShellExecution(M.commandLine,M.options):new D.ShellExecution(M.command,M.args?M.args:[],M.options)}j.to=N})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var u;(function(j){function B(M){if(M){let F=M;return F&&F.customExecution==="customExecution"}else return!1}j.is=B;function $(M){return{customExecution:"customExecution"}}j.from=$;function N(M,F){return F.get(M)}j.to=N})(u=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(j){function B($,N){let M;return $.scope!==void 0&&typeof $.scope!="number"?M=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===D.TaskScope.Workspace&&N&&N.workspaceFile?M=N.workspaceFile:M=p.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:M}}j.from=B})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(j){function B(M,F){if(M==null)return[];const U=[];for(let O of M){const W=$(O,F);W&&U.push(W)}return U}j.fromMany=B;function $(M,F){if(M!=null){let U;M.execution instanceof D.ProcessExecution?U=i.from(M.execution):M.execution instanceof D.ShellExecution?U=o.from(M.execution):M.execution&&M.execution instanceof D.CustomExecution&&(U=u.from(M.execution));const O=t.from(M.definition);let W;if(M.scope?typeof M.scope=="number"?W=M.scope:W=M.scope.uri:W=D.TaskScope.Workspace,!(!O||!W)){const q=M.group?M.group.id:void 0;return{_id:M._id,definition:O,name:M.name,source:{extensionId:F.identifier.value,label:M.source,scope:W},execution:U,isBackground:M.isBackground,group:q,presentationOptions:n.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}}}j.from=$;async function N(M,F,U){if(M!=null){let O;i.is(M.execution)?O=i.to(M.execution):o.is(M.execution)?O=o.to(M.execution):u.is(M.execution)&&(O=u.to(M._id,U));const W=t.to(M.definition);let q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?q=M.source.scope:q=await F.resolveWorkspaceFolder(b.URI.revive(M.source.scope)):q=D.TaskScope.Workspace),!(!W||!q)){const Q=new D.Task(W,q,M.name,M.source.label,O,M.problemMatchers);return M.isBackground!==void 0&&(Q.isBackground=M.isBackground),M.group!==void 0&&(Q.group=D.TaskGroup.from(M.group)),M.presentationOptions&&(Q.presentationOptions=n.to(M.presentationOptions)),M._id&&(Q._id=M._id),M.detail&&(Q.detail=M.detail),Q}}}j.to=N})(d=e.TaskDTO||(e.TaskDTO={}));var v;(function(j){function B(N){return N}j.from=B;function $(N){if(!!N)return Object.assign(Object.create(null),N)}j.to=$})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(B,$,N){this._id=$,this._task=N,f.set(this,void 0),tt(this,f,B,"f")}get task(){return this._task}terminate(){Ue(this,f,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}f=new WeakMap;var L;(function(j){function B($){return{id:$._id,task:void 0}}j.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(B,$,N,M,F,U,O,W){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=M,this._configurationService=F,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,$,N){if(!N)return new D.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:$,provider:N,extension:B}),this._proxy.$registerTaskProvider(M,$),new D.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(B,$){this._proxy.$registerTaskSystem(B,$)}fetchTasks(B){return this._proxy.$fetchTasks(v.from(B)).then(async $=>{const N=[];for(let M of $){const F=await d.to(M,this._workspaceProvider,this._providedCustomExecutions2);F&&N.push(F)}return N})}get taskExecutions(){const B=[];return this._taskExecutions.forEach($=>B.push($)),B}terminateTask(B){if(!(B instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,$,N){const M=this._providedCustomExecutions2.get(B.id);if(M){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,M),this._terminalService.attachPtyToTerminal($,await M.callback(N))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const $=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:$,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:B.exitCode})}$provideTasks(B,$){const N=this._handlers.get(B);if(!N)return Promise.reject(new Error("no handler found"));const M=[],F=(0,I.asPromise)(()=>N.provider.provideTasks(r.CancellationToken.None)).then(U=>this.provideTasksInternal($,M,N,U));return new Promise(U=>{F.then(O=>{Promise.all(M).then(()=>{U(O)})})})}async $resolveTask(B,$){const N=this._handlers.get(B);if(!N)return Promise.reject(new Error("no handler found"));if($.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${N.type}].`);const M=await d.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const F=await N.provider.resolveTask(M,r.CancellationToken.None);if(!!F){this.checkDeprecation(F,N);const U=d.from(F,N.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(U.execution)&&await this.addCustomExecution(U,F,!0),await this.resolveTaskInternal(U)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,$,N){const M=await this._proxy.$createTaskId(B);!N&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,$.execution)}async getTaskExecution(B,$){if(typeof B=="string"){const F=this._taskExecutionPromises.get(B);if(!F)throw new Error("Unexpected: The specified task is missing an execution");return F}let N=this._taskExecutionPromises.get(B.id);if(N)return N;const M=new Promise(async(F,U)=>{const O=$||await d.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);O?F(new R(this,B.id,O)):U("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,M),M.then(F=>(this._taskExecutions.set(B.id,F),F),F=>Promise.reject(F))}checkDeprecation(B,$){B._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let N=this._notProvidedCustomExecutions.values(),M=N.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=N.next()}};H=je([Be(0,g.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,P.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,w.ILogService),Be(7,_.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let ie=class extends H{constructor(B,$,N,M,F,U,O,W){super(B,$,N,M,F,U,O,W);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(B,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const N=d.from($,B);if(N===void 0)throw new Error("Task is not valid");if(u.is(N.execution))await this.addCustomExecution(N,$,!1);else throw new c.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),$);return this._proxy.$executeTask(N).catch(F=>{throw new Error(F)}),M}provideTasksInternal(B,$,N,M){const F=[];if(M)for(let U of M){this.checkDeprecation(U,N),(!U.definition||!B[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const O=d.from(U,N.extension);O&&u.is(O.execution)?(F.push(O),$.push(this.addCustomExecution(O,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:N.extension}}async resolveTaskInternal(B){if(u.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,$,N){}};ie=je([Be(0,g.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,P.IExtHostWorkspace),Be(3,y.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,C.IExtHostTerminalService),Be(6,w.ILogService),Be(7,_.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Ht=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(G);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(G,I[T])&&(b[I[T]]=G[I[T]]);return b};define(me[260],ge([0,1,15,19,22,21,3,71,54,6,23,12,2,28,5,39,14,87,20,7,32,222,122]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p,c,f,t){"use strict";var n,s,i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const o=(N,M)=>`${N}:${M.toString()}`;let u=class{constructor(M,F,U){this.documents=F,this.workspace=U,this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new E(this.proxy),this.workspaceObservers=new B(this.proxy),this.textDocumentObservers=new $(this.proxy,F)}registerTestController(M,F){const U=(0,m.generateUuid)();this.controllers.set(U,{instance:F,extensionId:M}),this.proxy.$registerTestController(U);const O=[...this.testControllers.keys()];return setTimeout(()=>{var W;for(const q of O)(W=this.testControllers.get(q))===null||W===void 0||W.subscribeFn(U,F)},0),new p.Disposable(()=>{this.controllers.delete(U),this.proxy.$unregisterTestController(U)})}createTextDocumentTestObserver(M){return this.textDocumentObservers.checkout(M.uri)}createWorkspaceTestObserver(M){return this.workspaceObservers.checkout(M.uri)}async runTests(M,F=A.CancellationToken.None){const U=O=>O.map(this.getInternalTestForReference,this).filter(C.isDefined).map(W=>({src:W.src,testId:W.item.extId}));await this.proxy.$runTests({exclude:M.exclude?U(M.exclude).map(O=>O.testId):void 0,tests:U(M.tests),debug:M.debug},F)}createTestRunTask(M,F,U,O=!0){return this.runQueue.createTestRunTask(M,F,U,O)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,r.deepFreeze)(_.TestResults.to(F))).concat(this.results).sort((F,U)=>U.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(M,F){const U=g.URI.revive(F),O=o(M,U);if(!this.testControllers.has(O)){const W=new A.CancellationTokenSource;let q;if(M===1){let Pe=this.documents.getDocument(U);if(!Pe){const ke=new k.DisposableStore;Pe=await new Promise(Le=>{ke.add((0,I.disposableTimeout)(()=>Le(void 0),5e3)),ke.add(this.documents.onDidAddDocuments(V=>{const J=V.find(ee=>ee.document.uri.toString()===U.toString());J&&Le(J)}))}).finally(()=>ke.dispose())}if(Pe){const ke=await this.workspace.getWorkspaceFolder2(U,!1);q=Le=>Le.createDocumentTestRoot?Le.createDocumentTestRoot(Pe.document,W.token):(0,e.createDefaultDocumentTestRoot)(Le,Pe.document,ke,W.token)}}else{const Pe=await this.workspace.getWorkspaceFolder2(U,!1);Pe&&(q=ke=>ke.createWorkspaceTestRoot(Pe,W.token))}if(!!q){const Q=async(Pe,ke)=>{try{const Le=await q(ke);Le&&ve.addRoot(Le,Pe)}catch(Le){console.error(Le)}},he=new k.DisposableStore,ve=he.add(this.ownedTests.createForHierarchy(Pe=>this.proxy.$publishDiff(M,F,Pe)));he.add((0,k.toDisposable)(()=>W.dispose(!0)));for(const[Pe,ke]of this.controllers)Q(Pe,ke.instance);ve.pushDiff([3,-1]),this.testControllers.set(O,{store:he,collection:ve,subscribeFn:Q})}}}async $expandTest(M,F){const U=(0,b.mapFind)(this.testControllers.values(),O=>O.collection.treeId===M.src.tree?O:void 0);await(U==null?void 0:U.collection.expand(M.testId,F<0?Infinity:F)),this.flushCollectionDiffs()}$unsubscribeFromTests(M,F){var U;const O=g.URI.revive(F),W=o(M,O);(U=this.testControllers.get(W))===null||U===void 0||U.store.dispose(),this.testControllers.delete(W)}$acceptDiff(M,F,U){M===1?this.textDocumentObservers.acceptDiff(g.URI.revive(F),U):this.workspaceObservers.acceptDiff(g.URI.revive(F),U)}async $runTestsForProvider(M,F){const U=this.controllers.get(M.tests[0].src.controller);if(!!U){const O=M.tests.map(({testId:Q,src:he})=>this.ownedTests.getTestById(Q,he==null?void 0:he.tree)).filter(C.isDefined).map(([Q,he])=>he),W=M.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,he])=>O.some(ve=>Q.comparePositions(ve,he)===1));if(!!O.length){const q={tests:O.map(Q=>L.unwrap(Q.actual)),exclude:W.map(([,Q])=>L.unwrap(Q.actual)),debug:M.debug};await this.runQueue.enqueueRun({dto:d.fromInternal(M),token:F,extensionId:U.extensionId,req:q,doRun:()=>U.instance.runTests(q,F)})}}}$lookupTest(M){const F=this.ownedTests.getTestById(M.testId);if(!F)return Promise.resolve(void 0);const U=F[1],{actual:O,discoverCts:W,expandLevels:q}=U,Q=Ht(U,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:M}of this.testControllers.values())M.flushDiff()}getInternalTestForReference(M){var F,U;return(U=(F=this.workspaceObservers.getMirroredTestDataByReference(M))!==null&&F!==void 0?F:(0,b.mapFind)(this.testControllers.values(),O=>O.collection.getTestByReference(M)))!==null&&U!==void 0?U:this.textDocumentObservers.getMirroredTestDataByReference(M)}};u=je([Be(0,S.IExtHostRpcService),Be(1,h.IExtHostDocumentsAndEditors),Be(2,c.IExtHostWorkspace)],u),e.ExtHostTesting=u;class E{constructor(M){this.proxy=M,this.state=new Map}enqueueRun(M){let F=this.state.get(M.extensionId);F||(F={queue:[],current:void 0},this.state.set(M.extensionId,F));const U=new I.DeferredPromise,O=()=>{const W=[],q=new Set;F.current={publicReq:M.req,factory:Q=>{const he=new v(Q,M.dto,q,this.proxy);return W.push(he),M.token.onCancellationRequested(()=>he.end()),he}},this.invokeRunner(M.extensionId,M.dto.id,M.doRun,W).finally(()=>U.complete())};return F.queue.push(O),F.queue.length===1&&O(),U.p}createTestRunTask(M,F,U,O){var W,q;const Q=this.state.get(M);if((Q==null?void 0:Q.current.publicReq)===F)return Q.current.factory(U);const he=d.fromPublic(F),ve=new v(U,he,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:F.debug,exclude:(q=(W=F.exclude)===null||W===void 0?void 0:W.map(Pe=>Pe.id))!==null&&q!==void 0?q:[],id:he.id,tests:F.tests.map(Pe=>Pe.id),persist:O}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(he.id)),ve}invokeRunner(M,F,U,O){try{const W=U();return(0,I.isThenable)(W)?W.then(()=>this.handleInvokeResult(M,F,O,void 0)).catch(q=>this.handleInvokeResult(M,F,O,q)):this.handleInvokeResult(M,F,O,void 0)}catch(W){return this.handleInvokeResult(M,F,O,W)}}async handleInvokeResult(M,F,U,O){const W=this.state.get(M);!W||(W.queue.shift(),W.queue.length>0?W.queue[0]():this.state.delete(M),await Promise.all(U.map(q=>q.onEnd.wait())))}}class d{constructor(M,F,U){this.id=M,this.include=F,this.exclude=U}static fromPublic(M){var F,U;return new d((0,m.generateUuid)(),new Set(M.tests.map(O=>O.id)),new Set((U=(F=M.exclude)===null||F===void 0?void 0:F.map(O=>O.id))!==null&&U!==void 0?U:y.Iterable.empty()))}static fromInternal(M){return new d(M.runId,new Set(M.tests.map(F=>F.testId)),new Set(M.excludeExtIds))}isIncluded(M){for(let F=M;F;F=F.parent){if(this.include.has(F.id))return!0;if(this.exclude.has(F.id))return!1}return!0}}class v{constructor(M,F,U,O){this.name=M,n.set(this,void 0),s.set(this,void 0),i.set(this,(0,m.generateUuid)()),l.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,O,"f"),tt(this,s,F,"f"),tt(this,l,U,"f"),O.$startedTestRunTask(F.id,{id:Ue(this,i,"f"),name:M,running:!0})}setState(M,F,U){Ue(this,s,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,n,"f").$updateTestStateInRun(Ue(this,s,"f").id,Ue(this,i,"f"),M.id,F,U))}appendMessage(M,F){Ue(this,s,"f").isIncluded(M)&&(this.ensureTestIsKnown(M),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,s,"f").id,Ue(this,i,"f"),M.id,_.TestMessage.from(F)))}appendOutput(M){Ue(this,n,"f").$appendOutputToRun(Ue(this,s,"f").id,Ue(this,i,"f"),T.VSBuffer.fromString(M))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,s,"f").id,Ue(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(M){const F=Ue(this,l,"f");if(!F.has(M.id)){const U=[];for(;U.unshift(_.TestItem.from(M)),!(F.has(M.id)||(F.add(M.id),!M.parent));)M=M.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,s,"f").id,U)}}}n=new WeakMap,s=new WeakMap,i=new WeakMap,l=new WeakMap;const R=async(N,M,F,U)=>{if(!!F){const O=await N.createWorkspaceTestRoot(F,U);if(!!O)return U.onCancellationRequested(()=>{L.removeFilter(M)}),L.getWrapperForTestItem(O,M)}};e.createDefaultDocumentTestRoot=R;class L extends p.TestItemImpl{constructor(M,F,U){super(M.id,M.label,M.uri,void 0);if(this.actual=M,this.filterDocument=F,this.actualParent=U,!(M instanceof p.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${M.id} did not`);this.debuggable=M.debuggable,this.runnable=M.runnable,this.description=M.description,this.error=M.error,this.status=M.status;const O=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(M).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=L.getWrapperForTestItem(q[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=M,Q.refreshMatch();break;default:O.bus.fire(q)}})}static removeFilter(M){this.wrapperMap.delete(M)}static getWrapperForTestItem(M,F,U){let O=this.wrapperMap.get(F);if(O==null?void 0:O.has(M))return O.get(M);O||(O=new WeakMap,this.wrapperMap.set(F,O));const W=new L(M,F,U);return O.set(M,W),W}static unwrap(M){return M instanceof L?M.actual:M}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var M;const F=this._cachedMatchesFilter;for(const O of this.actual.children.values()){const W=L.getWrapperForTestItem(O,this.filterDocument,this);W.hasNodeMatchingFilter?this.addChild(W):W.dispose()}const U=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=U,U!==F&&((M=this.actualParent)===null||M===void 0||M.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=L,L.wrapperMap=new WeakMap;class H extends t.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,_.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:F,removed:U}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...F].map(O=>O.revived)},get removed(){return[...U].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(M){let F=[];for(const U of M){const O=this.items.get(U);O&&F.push(O.revived)}return F}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,F){return Object.assign(Object.assign({},M),{revived:_.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new H(this.changeEmitter)}}e.MirroredTestCollection=ie;class j{constructor(){this.resources=new Map}checkout(M){var F,U;const O=M.toString(),W=(F=this.resources.get(O))!==null&&F!==void 0?F:this.createObserverData(M);return(U=W.pendingDeletion)===null||U===void 0||U.dispose(),W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,onDidDiscoverInitialTests:new D.Emitter().event,get tests(){return W.tests.rootTestItems},dispose:(0,P.once)(()=>{--W.observers||(W.pendingDeletion=this.eventuallyDispose(M))})}}getMirroredTestDataByReference(M){for(const{tests:F}of this.resources.values()){const U=F.getMirroredTestDataByReference(M);if(U)return U}}eventuallyDispose(M){return(0,I.disposableTimeout)(()=>this.unlisten(M),10*1e3)}createObserverData(M){const F=new ie,U=this.listen(M,W=>F.apply(W)),O={observers:0,tests:F,listener:U};return this.resources.set(M.toString(),O),O}unlisten(M){var F;const U=M.toString(),O=this.resources.get(U);O&&(O.observers=-1,(F=O.pendingDeletion)===null||F===void 0||F.dispose(),O.listener.dispose(),this.resources.delete(U))}}class B extends j{constructor(M){super();this.proxy=M,this.diffListeners=new Map}acceptDiff(M,F){var U;(U=this.diffListeners.get(M.toString()))===null||U===void 0||U(F)}listen(M,F){this.proxy.$subscribeToDiffs(0,M);const U=M.toString();return this.diffListeners.set(U,F),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,M),this.diffListeners.delete(U)})}}class $ extends j{constructor(M,F){super();this.proxy=M,this.documents=F,this.diffListeners=new Map}acceptDiff(M,F){var U;(U=this.diffListeners.get(M.toString()))===null||U===void 0||U(F)}listen(M,F){if(!this.documents.getDocument(M))return new p.Disposable(()=>{});const O=M.toString();return this.diffListeners.set(O,F),this.proxy.$subscribeToDiffs(1,M),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,M),this.diffListeners.delete(O)})}}}),define(me[261],ge([0,1,15,53,33,76,24,11,8,25,10,12,2,140,173,84,60,214,259,31]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(E,d,v,R){this.configurationService=E,this.workspaceContextService=d,this.editorGroupsService=v,this.pathService=R}text(E,d,v={}){E=this.getContentPattern(E,v);const R=this.configurationService.getValue(),L=d&&d.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep),H=this.commonQuery(d==null?void 0:d.map(S.toWorkspaceFolder),v);return Object.assign(Object.assign({},H),{type:2,contentPattern:E,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:R.search.usePCRE2||L||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(E,d){const v=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},E),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(E,d)&&(R.isCaseSensitive=!0),this.isMultiline(E)&&(R.isMultiline=!0),R}file(E,d={}){const v=this.commonQuery(E,d);return Object.assign(Object.assign({},v),{type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey})}handleIncludeExclude(E,d){return E?(E=Array.isArray(E)?E.map(i):i(E),d?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],d={}){const v=this.handleIncludeExclude(d.includePattern,d.expandPatterns),R=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),L=E.length>1,H=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,d,R)):E.map(B=>this.getFolderQueryForRoot(B,d,R,L))).filter(B=>!!B),ie={_reason:d._reason,folderQueries:H,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:R.pattern,includePattern:v.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const $=b.coalesce(b.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(F=>F.resource)))).filter(M=>(0,p.pathIncludedInQuery)(ie,M.fsPath)),N=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ie),N)}const j=d.extraFileResources&&d.extraFileResources.filter(B=>(0,p.pathIncludedInQuery)(ie,B.fsPath));return ie.extraFileResources=j&&j.length?j:void 0,ie}commonQueryFromFileList(E){const d=[],v=new D.ResourceMap,R={};let L=!1;return E.forEach(H=>{var ie,j;if(H.scheme!==P.Schemas.walkThrough)if((0,k.isAbsolutePath)(H)){const $=(j=(ie=this.workspaceContextService.getWorkspaceFolder(H))===null||ie===void 0?void 0:ie.uri)!==null&&j!==void 0?j:H.with({path:y.dirname(H.fsPath)});let N=v.get($);N||(L=!0,N={folder:$,includePattern:{}},d.push(N),v.set($,N));const M=y.relative($.fsPath,H.fsPath);(0,C.assertIsDefined)(N.includePattern)[M.replace(/\\/g,"/")]=!0}else H.fsPath&&(L=!0,R[H.fsPath]=!0)}),{folderQueries:d,includePattern:R,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(E,d){if(d.isSmartCase){if(E.isRegExp){if(r.containsUppercaseCharacter(E.pattern,!0))return!0}else if(r.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&(0,m.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const d=N=>y.isAbsolute(N)||/^\.\.?([\/\\]|$)/.test(N),R=(Array.isArray(E)?E:n(E)).map(N=>{const M=this.pathService.resolvedUserHome;return M?(0,A.untildify)(N,M.scheme===P.Schemas.file?M.fsPath:M.path):N}),L=I.groupBy(R,N=>d(N)?"searchPaths":"exprSegments"),H=(L.exprSegments||[]).map(N=>r.rtrim(N,"/")).map(N=>r.rtrim(N,"\\")).map(N=>(N[0]==="."&&(N="*"+N),s(N))),ie={},j=this.expandSearchPathPatterns(L.searchPaths||[]);j&&j.length&&(ie.searchPaths=j);const B=b.flatten(H),$=t(...B);return $&&(ie.pattern=$),ie}getExcludesForFolder(E,d){return d.disregardExcludeSettings?void 0:(0,p.getExcludes)(E,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const d=b.flatten(E.map(R=>{let{pathPortion:L,globPortion:H}=f(R);H&&(H=l(H));const ie=this.expandOneSearchPath(L);return b.flatten(ie.map(j=>this.resolveOneSearchPathPattern(j,H)))})),v=new Map;return d.forEach(R=>{const L=R.searchPath.toString(),H=v.get(L);H?R.pattern&&(H.pattern=H.pattern||{},H.pattern[R.pattern]=!0):v.set(L,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(E){if(y.isAbsolute(E)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==P.Schemas.file?[{searchPath:d[0].uri.with({path:E})}]:[{searchPath:g.URI.file(y.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=i(E),E.startsWith("../")||E===".."){const R=y.posix.resolve(d.path,E);return[{searchPath:d.with({path:R})}]}const v=l(E);return[{searchPath:d,pattern:v}]}else{if(E==="./"||E===".\\")return[];{const d=E.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(d){const v=d[1],R=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===v);if(R.length)return R.map(L=>{const H=d[2];return{searchPath:L.uri,pattern:H&&l(H)}});{const L=a.localize(0,null,v);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(E,d){const v=E.pattern&&d?`${E.pattern}/${d}`:E.pattern||d,R=[{searchPath:E.searchPath,pattern:v}];return v&&!v.endsWith("**")&&R.push({searchPath:E.searchPath,pattern:v+"/**"}),R}getFolderQueryForSearchPath(E,d,v){const R=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(E.searchPath),d,v,!1);return R?Object.assign(Object.assign({},R),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,d,v,R){let L;const H=g.URI.isUri(E)?E:E.uri;if(v.searchPaths){const N=v.searchPaths.filter(M=>(0,k.isEqual)(M.searchPath,H))[0];if(N&&!N.pattern)return null;N&&(L=N.pattern)}const ie=this.configurationService.getValue({resource:H}),j=this.getExcludesForFolder(ie,d),B=Object.assign(Object.assign({},j||{}),L||{}),$=g.URI.isUri(E)?(0,k.basename)(E):E.name;return{folder:H,folderName:R?$:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!ie.search.followSymlinks}}};c=je([Be(0,h.IConfigurationService),Be(1,S.IWorkspaceContextService),Be(2,w.IEditorGroupsService),Be(3,_.IPathService)],c),e.QueryBuilder=c;function f(u){const E=u.match(/[\*\{\}\(\)\[\]\?]/);if(E){const d=E.index,v=u.substr(0,d).match(/[/|\\][^/\\]*$/);if(v){let R=u.substr(0,v.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:u.substr((v.index||0)+1)}}}return{pathPortion:u}}function t(...u){return u.length?u.reduce((E,d)=>(E[d]=!0,E),Object.create(null)):void 0}function n(u){return T.splitGlobAware(u,",").map(E=>E.trim()).filter(E=>!!E.length)}function s(u){return[`**/${u}/**`,`**/${u}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function i(u){return u.replace(/\\/g,"/")}function l(u){return i(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(u,E){u=b.distinct(u,R=>R.toString());const d=[],v=E.getWorkspace();return u&&u.forEach(R=>{let L;if(E.getWorkbenchState()===2)L=(0,k.relativePath)(v.folders[0].uri,R),L&&L!=="."&&(L="./"+L);else{const H=E.getWorkspaceFolder(R);if(H){const ie=H.name;if(v.folders.filter(B=>B.name===ie).length===1){const B=(0,k.relativePath)(H.uri,R);B===""?L=`./${H.name}`:L=`./${H.name}/${B}`}else L=R.fsPath}}L&&d.push(L)}),d}e.resolveResourcesForSearchIncludes=o}),define(me[262],ge([0,1,25,2,21,18,4,261,31,60]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function C(h,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const _=[],p=[];for(const i of w)if(/^workspaceContains:/.test(i)){const l=i.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||h.forceUsingSearch?p.push(l):_.push(l)}if(_.length===0&&p.length===0)return Promise.resolve(void 0);let c;const f=new Promise((i,l)=>{c=i}),t=i=>c({activationEvent:i}),n=Promise.all(_.map(i=>g(h,i,t))).then(()=>{}),s=m(h,S.identifier,p,t);return Promise.all([n,s]).then(()=>{c(void 0)}),f}e.checkActivateWorkspaceContainsExtension=C;async function g(h,S,w){for(const _ of h.folders)if(await h.exists(b.joinPath(I.URI.revive(_),S))){w(`workspaceContains:${S}`);return}}async function m(h,S,w,_){if(w.length===0)return Promise.resolve(void 0);const p=new T.CancellationTokenSource,c=h.checkExists(h.folders,w,p.token),f=setTimeout(async()=>{p.cancel(),_(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await c}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}p.dispose(),clearTimeout(f),t&&_(`workspaceContains:${w.join(",")}`)}function a(h,S,w,_){const p=h.get(D.IInstantiationService),c=h.get(y.ISearchService),t=p.createInstance(P.QueryBuilder).file(S.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return c.fileSearch(t,_).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(G,e,b,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!T:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(G,b):T?T.value=b:e.set(G,b),b},Ue=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[42],ge([0,1,162,8,68,25,19,6,24,2,13,5,35,225,91,32,41,223,18,29,11,22,196,7,85,4,27,92,14,82,50,34,3,262,89,197]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p,c,f,t,n,s,i,l,o,u,E,d,v,R,L,H,ie){"use strict";var j,B,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let N=class Nn extends P.Disposable{constructor(O,W,q,Q,he,ve,Pe,ke,Le,V){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=q,this._initData=Pe,this._extHostWorkspace=Q,this._extHostConfiguration=he,this._logService=ve,this._extHostTunnelService=Le,this._extHostTerminalService=V,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new H.ExtHostSecretState(this._extHostContext),this._storagePath=ke,this._instaService=O.createChild(new E.ServiceCollection([a.IExtHostStorage,this._storage],[H.IExtHostSecretState,this._secretState]));const J=new Set;this._initData.hostExtensions.forEach(ee=>J.add(p.ExtensionIdentifier.toKey(ee))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,ae)},actualActivateExtension:async(ee,ae)=>{if(J.has(p.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ae),new m.HostExtension;const we=this._registry.getExtensionDescription(ee);return this._activateExtension(we,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){_.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this._deactivate(he))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const q=this._activator.getActivatedExtension(O);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=y.TernarySearchTree.forPaths(),W=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(Q=>O.set(k.URI.file(Q).fsPath,q))});this._extensionPathIndex=Promise.all(W).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const q=this._activator.getActivatedExtension(O);if(!q)return W;try{typeof q.module.deactivate=="function"&&(W=Promise.resolve(q.module.deactivate()).then(void 0,Q=>Promise.resolve(void 0)))}catch(Q){}try{(0,P.dispose)(q.subscriptions)}catch(Q){}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then(q=>{const Q=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",Q),q},q=>{throw this._logExtensionActivationTimes(O,W,"failure"),q})}_logExtensionActivationTimes(O,W,q,Q){const he=M(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},he),Q||{}),{outcome:q}))}_doActivateExtension(O,W){const q=M(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const Q=this._getEntryPoint(O);if(!Q)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(W)}`),this._logService.flush();const he=new m.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,A.joinPath)(O.extensionLocation,Q),he),this._loadExtensionContext(O)]).then(ve=>(T.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Nn._callActivate(this._logService,O.identifier,ve[0],ve[1],he))).then(ve=>(T.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),ve))}_loadExtensionContext(O){const W=new t.ExtensionGlobalMemento(O,this._storage),q=new t.ExtensionMemento(O.identifier.value,!1,this._storage),Q=new ie.ExtensionSecrets(O,this._secretState),he=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ve=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const Pe=this;let ke;return Object.freeze({globalState:W,workspaceState:q,secrets:Q,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Le){return I.join(O.extensionLocation.fsPath,Le)},get storagePath(){var Le;return(Le=Pe._storagePath.workspaceValue(O))===null||Le===void 0?void 0:Le.fsPath},get globalStoragePath(){return Pe._storagePath.globalValue(O).fsPath},get logPath(){return I.join(Pe._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(Pe._initData.logsLocation,O.identifier.value)},get storageUri(){return Pe._storagePath.workspaceValue(O)},get globalStorageUri(){return Pe._storagePath.globalValue(O)},get extensionMode(){return he},get extension(){return ke===void 0&&(ke=new F(Pe,O.identifier,O,ve)),ke},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),Pe.extensionRuntime},get environmentVariableCollection(){return Pe._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,q,Q,he){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,q,Q,he).then(ve=>new m.ActivatedExtension(!1,null,he.build(),q,ve,Q.subscriptions))}static _callActivateOptional(O,W,q,Q,he){if(typeof q.activate=="function")try{he.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const ve=typeof global=="object"?global:self,Pe=q.activate.apply(ve,[Q]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Pe).then(ke=>(he.activateResolveStop(),ke))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,he=>{this._logService.error(he)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(he=>this._handleWorkspaceContainsEagerExtensions(he.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(W),Q=Promise.all([O,q]).then(()=>{});return Promise.race([Q,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(!this.isActivated(W.identifier)){const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={folders:O.map(ve=>ve.uri),forceUsingSearch:q,exists:ve=>this._hostUtils.exists(ve.fsPath),checkExists:(ve,Pe,ke)=>this._mainThreadWorkspaceProxy.$checkExists(ve,Pe,ke)},he=await(0,L.checkActivateWorkspaceContainsExtension)(Q,W);if(!!he)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:he.activationEvent}).then(void 0,ve=>this._logService.error(ve))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W||W.scheme!==c.Schemas.file)throw new Error(b.localize(0,null));const q=(0,A.originalFSPath)(W),Q=await this._loadCommonJSModule(null,W,new m.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(b.localize(1,null,q));return new Promise((he,ve)=>{const Pe=(Le,V)=>{Le?ve(Le):he(typeof V=="number"&&V>0?1:0)},ke=Q.run(q,Pe);ke&&ke.then&&ke.then(()=>{he(0)}).catch(Le=>{ve(Le.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,P.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,W){const q=O.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const Q=O.substr(0,q);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1);const he=this._resolvers[Q];if(!he)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${Q}`);const ve=await he.resolve(O,{resolveAttempt:W});T.mark(`code/extHost/didResolveAuthorityOK/${Q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(he));const Pe={authority:O,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},ke={extensionHostEnv:ve.extensionHostEnv,trust:ve.trust};return{type:"ok",value:{authority:Pe,options:ke,tunnelInformation:{environmentTunnels:ve.environmentTunnels}}}}catch(ve){if(T.mark(`code/extHost/didResolveAuthorityError/${Q}`),ve instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(Q=>Q.extensionLocation=k.URI.revive(Q.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(W.map(async Q=>{const he=this._registry.getExtensionDescription(Q);if(!!he){const ve=await this._hostUtils.realpath(he.extensionLocation.fsPath);q.delete(k.URI.file(ve).fsPath)}})),await Promise.all(O.map(async Q=>{const he=await this._hostUtils.realpath(Q.extensionLocation.fsPath);q.set(k.URI.file(he).fsPath,Q)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=f.VSBuffer.alloc(O),q=Math.random()%256;for(let Q=0;Q<O;Q++)W.writeUInt8(q,Q);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};N=je([Be(0,i.IInstantiationService),Be(1,e.IHostUtils),Be(2,u.IExtHostRpcService),Be(3,h.IExtHostWorkspace),Be(4,g.IExtHostConfiguration),Be(5,r.ILogService),Be(6,l.IExtHostInitDataService),Be(7,o.IExtensionStoragePaths),Be(8,d.IExtHostTunnelService),Be(9,v.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function M(U,O){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class F{constructor(O,W,q,Q){j.set(this,void 0),B.set(this,void 0),$.set(this,void 0),tt(this,j,O,"f"),tt(this,B,W,"f"),tt(this,$,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=Q}get isActive(){return Ue(this,j,"f").isActivated(Ue(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,j,"f").getExtensionExports(Ue(this,$,"f"))}activate(){return Ue(this,j,"f").activateByIdWithErrors(Ue(this,$,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,j=new WeakMap,B=new WeakMap,$=new WeakMap}),define(me[46],ge([0,1,8,2,3,19,5,7,120,32,42,39,213,35,204,14,4,12,36]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let p=class{constructor(o,u,E,d,v){this._workspaceService=u,this._extensionService=E,this._editorsService=d,this._configurationService=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=o.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(L=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,u){const E=o;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let d=`debug:${encodeURIComponent(E.path||"")}`,v="?";return u&&(d+=`${v}session=${encodeURIComponent(u.id)}`,v="&"),d+=`${v}ref=${E.sourceReference}`,I.URI.parse(d)}else{if(E.path)return I.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const u=[];for(const E of o.getAllExtensionDescriptions())if(E.contributes){const d=E.contributes.debuggers;if(d&&d.length>0)for(const v of d)(0,a.isDebuggerMainContribution)(v)&&u.push(v.type)}this._debugServiceProxy.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(u=>o.push(u)),o}addBreakpoints(o){this.startBreakpoints();const u=o.filter(v=>{const R=v.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,v),!0)});this.fireBreakpointChanges(u,[],[]);const E=[],d=new Map;for(const v of u)if(v instanceof P.SourceBreakpoint){let R=d.get(v.location.uri.toString());R||(R={type:"sourceMulti",uri:v.location.uri,lines:[]},d.set(v.location.uri.toString(),R),E.push(R)),R.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof P.FunctionBreakpoint&&E.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(o){this.startBreakpoints();const u=o.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],u,[]);const E=u.filter(R=>R instanceof P.SourceBreakpoint).map(R=>R.id),d=u.filter(R=>R instanceof P.FunctionBreakpoint).map(R=>R.id),v=u.filter(R=>R instanceof P.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(E,d,v)}startDebugging(o,u,E){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,u,{parentSessionID:E.parentSession?E.parentSession.id:void 0,repl:E.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,u,E){if(!u)return new P.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:d,provider:u}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,E,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,d),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==u),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(o,u,E){if(!E)return new P.Disposable(()=>{});if(!this.definesDebugType(o,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.getAdapterDescriptorFactoryByType(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:u,handle:d,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(u,d),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(o,u){if(!u)return new P.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:E,factory:u}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==u)})}async $runInTerminal(o,u){return Promise.resolve(void 0)}async $substituteVariables(o,u){if(!this._variableResolver){const[v,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,R)}let E;const d=await this.getFolder(o);return d&&(E={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,u)}createDebugAdapter(o,u){if(o.type==="implementation")return new s(o.implementation)}createSignService(){}async $startDASession(o,u){const E=this,d=await this.getSession(u);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const R=this.convertToDto(v),L=this.createDebugAdapter(R,d);if(!L)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const H=L;return this._debugAdapters.set(o,H),this.getDebugAdapterTrackers(d).then(ie=>(ie&&this._debugAdaptersTrackers.set(o,ie),H.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const B=j,$={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(B.arguments.value);$.body={signature:N},H.sendResponse($)}else throw new Error("no signer")}catch(N){$.success=!1,$.message=N.message,H.sendResponse($)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(j),j=(0,a.convertToVSCPaths)(j,!0),E._debugServiceProxy.$acceptDAMessage(o,j)}),H.onError(j=>{ie&&ie.onError&&ie.onError(j),this._debugServiceProxy.$acceptDAError(o,j.name,j.message,j.stack)}),H.onExit(j=>{ie&&ie.onExit&&ie.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,w.withNullAsUndefined)(j),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),H.startSession()))})}$sendDAMessage(o,u){u=(0,a.convertToDAPaths)(u,!1);const E=this._debugAdaptersTrackers.get(o);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(u);const d=this._debugAdapters.get(o);d&&d.sendMessage(u)}$stopDASession(o){const u=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),u&&u.onWillStopSession&&u.onWillStopSession();const E=this._debugAdapters.get(o);return this._debugAdapters.delete(o),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const u=[],E=[],d=[];if(o.added)for(const v of o.added){const R=v.id;if(R&&!this._breakpoints.has(R)){let L;if(v.type==="function")L=new P.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")L=new P.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const H=I.URI.revive(v.uri);L=new P.SourceBreakpoint(new P.Location(H,new P.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}L._id=R,this._breakpoints.set(R,L),u.push(L)}}if(o.removed)for(const v of o.removed){const R=this._breakpoints.get(v);R&&(this._breakpoints.delete(v),E.push(R))}if(o.changed){for(const v of o.changed)if(v.id){const R=this._breakpoints.get(v.id);if(R){if(R instanceof P.FunctionBreakpoint&&v.type==="function"){const L=R;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.functionName=v.functionName}else if(R instanceof P.SourceBreakpoint&&v.type==="source"){const L=R;L.enabled=v.enabled,L.condition=v.condition,L.hitCondition=v.hitCondition,L.logMessage=v.logMessage,L.location=new P.Location(I.URI.revive(v.uri),new P.Position(v.line,v.character))}d.push(R)}}}this.fireBreakpointChanges(u,E,d)}$provideDebugConfigurations(o,u,E){return(0,A.asPromise)(async()=>{const d=this.getConfigProviderByHandle(o);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(u);return d.provideDebugConfigurations(v,E)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(o,u,E,d){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(o);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(u);return v.resolveDebugConfiguration(R,E,d)})}$resolveDebugConfigurationWithSubstitutedVariables(o,u,E,d){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(o);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(u);return v.resolveDebugConfigurationWithSubstitutedVariables(R,E,d)})}async $provideDebugAdapter(o,u){const E=this.getAdapterDescriptorFactoryByHandle(o);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(u);return this.getAdapterDescriptor(E,d).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(o){const u=await this.getSession(o);this._onDidStartDebugSession.fire(u)}async $acceptDebugSessionTerminated(o){const u=await this.getSession(o);u&&(this._onDidTerminateDebugSession.fire(u),this._debugSessions.delete(u.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,u){const E=await this.getSession(o);E&&E._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(o,u){const d={session:await this.getSession(o),event:u.event,body:u.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(o){if(o instanceof P.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof P.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const u=this._adapterFactories.filter(E=>E.type===o);if(u.length>0)return u[0].factory}getAdapterDescriptorFactoryByHandle(o){const u=this._adapterFactories.filter(E=>E.handle===o);if(u.length>0)return u[0].factory}getConfigProviderByHandle(o){const u=this._configProviders.filter(E=>E.handle===o);if(u.length>0)return u[0].provider}definesDebugType(o,u){if(o.contributes){const E=o.contributes.debuggers;if(E&&E.length>0){for(const d of E)if(d.label&&d.type&&d.type===u)return!0}}return!1}getDebugAdapterTrackers(o){const E=o.configuration.type,d=this._trackerFactories.filter(v=>v.type===E||v.type==="*").map(v=>(0,A.asPromise)(()=>v.factory.createDebugAdapterTracker(o)).then(R=>R,R=>null));return Promise.race([Promise.all(d).then(v=>{const R=v.filter(L=>!!L);if(R.length>0)return new n(R)}),new Promise((v,R)=>{const L=setTimeout(()=>{clearTimeout(L),R(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(o,u){const E=u.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new P.DebugAdapterServer(E));if(o){const v=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>o.createDebugAdapterDescriptor(u,this.daExecutableFromPackage(u,v))).then(R=>{if(R)return R})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(u,d))}daExecutableFromPackage(o,u){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,u,E){(o.length>0||u.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:u,changed:E}))}async getSession(o){if(o)if(typeof o=="string"){const u=this._debugSessions.get(o);if(u)return u}else{let u=this._debugSessions.get(o.id);if(!u){const E=await this.getFolder(o.folderUri);u=new c(this._debugServiceProxy,o.id,o.type,o.name,E,o.configuration),this._debugSessions.set(u.id,u),this._debugServiceProxy.$sessionCached(u.id)}return u}throw new Error("cannot find session")}getFolder(o){if(o){const u=I.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};p=je([Be(0,h.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,r.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration)],p),e.ExtHostDebugServiceBase=p;class c{constructor(o,u,E,d,v,R){this._debugServiceProxy=o,this._id=u,this._type=E,this._name=d,this._workspaceFolder=v,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,u){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,u)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=c;class f{constructor(o){this.value=Object.freeze({append(u){o.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=f;class t extends g.AbstractVariableResolverService{constructor(o,u,E,d){super({getFolderUri:v=>{const R=o.filter(L=>L.name===v);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(v,R)=>E.getConfiguration(void 0,v).get(R),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(u){const v=u.activeEditor();if(v)return b.normalize(v.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(u&&d){const v=u.activeEditor();if(v){const R=d.getWorkspaceFolder(v.document.uri);if(R)return b.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(u){const v=u.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(u){const v=u.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,_.env)}}e.ExtHostVariableResolverService=t;class n{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(u=>u.onError?u.onError(o):void 0)}onExit(o,u){this.trackers.forEach(E=>E.onExit?E.onExit(o,u):void 0)}}class s extends y.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends p{constructor(o,u,E,d,v){super(o,u,E,d,v)}createVariableResolver(o,u,E){return new t(o,u,E)}};i=je([Be(0,h.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,r.IExtHostExtensionService),Be(3,C.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration)],i),e.WorkerExtHostDebugService=i}),define(me[263],ge([0,1,68,2,5,35,41,29,14,27,4,42,36,13]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(p,c,f,t,n,s,i){this._apiFactory=p,this._extensionRegistry=c,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,c,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,c,this._initData.environment.appUriScheme))}register(p){if(Array.isArray(p.nodeModuleName))for(let c of p.nodeModuleName)this._factories.set(c,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(c=>p.alternativeModuleName(c))}};a=je([Be(2,r.IInstantiationService),Be(3,A.IExtHostConfiguration),Be(4,C.IExtHostExtensionService),Be(5,k.IExtHostInitDataService),Be(6,m.ILogService)],a),e.RequireInterceptor=a;class h{constructor(p,c,f,t,n){this._apiFactory=p,this._extensionPaths=c,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,c){const f=this._extensionPaths.findSubstr(c.fsPath);if(f){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(p,c){this.nodeModuleName="keytar";const{environment:f}=c,t=p.getProxy(T.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;g.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,i)=>t.$setPassword(n,s,i),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(p,c){return this._impl}alternativeModuleName(p){const c=p.length;if(!(c<=7||!this.alternativeNames)){const f=c-7;if((p.charAt(f)==="/"||p.charAt(f)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}}};S=je([Be(0,y.IExtHostRpcService),Be(1,k.IExtHostInitDataService)],S);let w=class{constructor(p,c,f){this._extensionPaths=p,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(T.MainContext.MainThreadTelemetry);const t=f.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,s)=>{const i=I.URI.parse(n);return s?this.callOriginal(n,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,n,{}):this.callOriginal(n,s)}}load(p,c,f){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(p),this._impl}callOriginal(p,c){return this.sendNoForwardTelemetry(),this._original(p,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=je([Be(2,y.IExtHostRpcService)],w)}),define(me[264],ge([0,1,168,9,7,205,32,42,39,35,34,14,46,189,208,19]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let S=class extends g.ExtHostDebugServiceBase{constructor(p,c,f,t,n,s){super(p,c,f,t,n);this._terminalService=s,this._integratedTerminalInstances=new w}createDebugAdapter(p,c){switch(p.type){case"server":return new A.SocketDebugAdapter(p);case"pipeServer":return new A.NamedPipeDebugAdapter(p);case"executable":return new A.ExecutableDebugAdapter(p,c.type)}return super.createDebugAdapter(p,c)}daExecutableFromPackage(p,c){const f=A.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),p.type);if(f)return new T.DebugAdapterExecutable(f.command,f.args,f.options)}createSignService(){return new m.SignService}async $runInTerminal(p,c){if(p.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(v=>{this._integratedTerminalInstances.onTerminalClosed(v)}));const f=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,f),n=this._terminalService.getDefaultShellArgs(!0,f),s=JSON.stringify({shell:t,shellArgs:n});let i=await this._integratedTerminalInstances.checkout(s),l,o=!1;if(i)l=p.cwd;else{const v={shellPath:t,shellArgs:n,cwd:p.cwd,name:p.title||b.localize(0,null)};o=!0,i=this._terminalService.createTerminalFromOptions(v,!0),this._integratedTerminalInstances.insert(i,s)}i.show(!0);const u=await i.processId;o?await new Promise(v=>setTimeout(v,1e3)):f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?i.sendText("cls"):t.indexOf("bash")>=0?i.sendText("clear"):I.isWindows?i.sendText("cls"):i.sendText("clear"));const E=(0,a.prepareCommand)(t,p.args,l,p.env);i.sendText(E);const d=this.onDidTerminateDebugSession(v=>{v.id===c&&(this._integratedTerminalInstances.free(i),d.dispose())});return u}else if(p.kind==="external")return(0,a.runInExternalTerminal)(p,await this._configurationService.getConfigProvider());return super.$runInTerminal(p,c)}createVariableResolver(p,c,f){return new g.ExtHostVariableResolverService(p,c,f,this._workspaceService)}};S=je([Be(0,C.IExtHostRpcService),Be(1,D.IExtHostWorkspace),Be(2,P.IExtHostExtensionService),Be(3,y.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,r.IExtHostTerminalService)],S),e.ExtHostDebugService=S;class w{constructor(){this._terminalInstances=new Map}async checkout(p){const f=[...this._terminalInstances.entries()].map(([t,n])=>(0,h.createCancelablePromise)(async s=>{if(n.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const i=Date.now();return n.lastUsedAt+w.minUseDelay>i||s.isCancellationRequested||n.config!==p?null:(n.lastUsedAt=i,t)}));return await(0,h.firstParallel)(f,t=>!!t)}insert(p,c){this._terminalInstances.set(p,{lastUsedAt:Date.now(),config:c})}free(p){const c=this._terminalInstances.get(p);c&&(c.lastUsedAt=-1)}onTerminalClosed(p){this._terminalInstances.delete(p)}}w.minUseDelay=1e3}),define(me[265],ge([0,1,8,2,78,32,46,39,35,34,14,27,67,11,13,64]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=class extends g.ExtHostTaskBase{constructor(_,p,c,f,t,n,s,i){super(_,p,c,f,t,n,s,i);this.workspaceService=c,p.remote.isRemote&&p.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:p.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,p){const c=p;if(!p.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const f=g.TaskHandleDTO.from(c,this.workspaceService),t=await this._proxy.$getTaskExecution(f);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,p);return this._proxy.$executeTask(f).catch(()=>{}),n}else{const f=g.TaskDTO.from(p,_);if(f===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(f.execution)&&await this.addCustomExecution(f,p,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(f),p);return this._proxy.$executeTask(f).catch(()=>{}),t}}provideTasksInternal(_,p,c,f){const t=[];if(f)for(let n of f){this.checkDeprecation(n,c),(!n.definition||!_[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const s=g.TaskDTO.from(n,c.extension);s&&(t.push(s),g.CustomExecutionDTO.is(s.execution)&&p.push(this.addCustomExecution(s,n,!0)))}return{tasks:t,extension:c.extension}}async resolveTaskInternal(_){return _}async getVariableResolver(_){if(this._variableResolver===void 0){const p=await this._configurationService.getConfigProvider();this._variableResolver=new D.ExtHostVariableResolverService(_,this._editorService,p,this.workspaceService)}return this._variableResolver}async $resolveVariables(_,p){const c=I.URI.revive(_),f={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(c),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const s=await this.getVariableResolver(n),i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let l of p.variables)f.variables[l]=await s.resolveAsync(i,l);if(p.process!==void 0){let l;if(p.process.path!==void 0){l=p.process.path.split(b.delimiter);for(let o=0;o<l.length;o++)l[o]=await s.resolveAsync(i,l[o])}f.process=await T.win32.findExecutable(await s.resolveAsync(i,p.process.name),p.process.cwd!==void 0?await s.resolveAsync(i,p.process.cwd):void 0,l)}return f}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(_,p,c){return T.win32.findExecutable(_,p,c)}};S=je([Be(0,r.IExtHostRpcService),Be(1,C.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,P.IExtHostDocumentsAndEditors),Be(4,y.IExtHostConfiguration),Be(5,k.IExtHostTerminalService),Be(6,a.ILogService),Be(7,h.IExtHostApiDeprecationService)],S),e.ExtHostTask=S}),define(me[266],ge([0,1,9,12,28,149,13,35,46,39,14,34,32,211,212]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let h=class extends C.BaseExtHostTerminalService{constructor(w,_,p,c,f){super(!0,w);this._extHostConfiguration=_,this._extHostWorkspace=p,this._extHostDocumentsAndEditors=c,this._logService=f,(0,A.getSystemShell)(b.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,_,p){const c=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:w,shellPath:_,shellArgs:p},w);return this._terminals.push(c),c.create(_,p),c.value}createTerminalFromOptions(w,_){const p=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),w,w.name);return this._terminals.push(p),p.create((0,I.withNullAsUndefined)(w.shellPath),(0,I.withNullAsUndefined)(w.shellArgs),(0,I.withNullAsUndefined)(w.cwd),(0,I.withNullAsUndefined)(w.env),(0,I.withNullAsUndefined)(w.icon),(0,I.withNullAsUndefined)(w.message),void 0,(0,I.withNullAsUndefined)(w.strictEnv),(0,I.withNullAsUndefined)(w.hideFromUser),(0,I.withNullAsUndefined)(_),!0),p.value}getDefaultShell(w,_){var p;const c=f=>_.getConfiguration(f.substr(0,f.lastIndexOf("."))).get(f.substr(f.lastIndexOf(".")+1));return m.getDefaultShell(c,(p=this._defaultShell)!==null&&p!==void 0?p:(0,A.getSystemShellSync)(b.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,_){const p=c=>_.getConfiguration(c.substr(0,c.lastIndexOf("."))).get(c.substr(c.lastIndexOf(".")+1));return m.getDefaultShellArgs(p,w,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),_=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new y.ExtHostVariableResolverService(_||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const _=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(w,void 0,this._logService,_,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(w){const _=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,_),args:this.getDefaultShellArgs(w,_)}}};h=je([Be(0,r.IExtHostRpcService),Be(1,P.IExtHostConfiguration),Be(2,g.IExtHostWorkspace),Be(3,k.IExtHostDocumentsAndEditors),Be(4,D.ILogService)],h),e.ExtHostTerminalService=h}),define(me[267],ge([0,1,19,18,68,6,2,5,257,13,79,82,27,185,14,62,42,34]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(c,f,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new y.RPCProtocol(c,null,n);f=_._transform(f,s);const i=new C.ServiceCollection(...(0,r.getSingletonServiceDescriptors)());i.set(g.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(s)),i.set(h.IURITransformerService,new h.URITransformerService(n)),i.set(S.IHostUtils,t);const l=new m.InstantiationService(i,!0),o=l.invokeFunction(v=>v.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=l.invokeFunction(v=>v.get(k.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=l.invokeFunction(v=>v.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const u=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(R,L)=>{let H="",ie,j;for(const B of L)H+=`
	at ${B.toString()}`,j=B.getFileName(),!ie&&j&&(ie=v.findSubstr(j));return u.set(R,ie),`${R.name||"Error"}: ${R.message||""}${H}`}});const E=s.getProxy(P.MainContext.MainThreadExtensionService),d=s.getProxy(P.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{const R=I.transformErrorForSerialization(v),L=u.get(v);L?E.$onExtensionRuntimeError(L.identifier,R):d.$onUnexpectedError(R)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,f){c.extensions.forEach(n=>n.extensionLocation=D.URI.revive(f.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=D.URI.revive(f.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>D.URI.revive(f.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=D.URI.revive(f.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=D.URI.revive(f.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=D.URI.revive(f.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=D.URI.revive(f.transformIncomingURIs(c.logsLocation)),c.logFile=D.URI.revive(f.transformIncomingURIs(c.logFile)),c.workspace=f.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=_}),define(me[268],ge([0,1,8,21,59,33,25,47,31]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(g,m,a){this.config=g,this.provider=m,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&A.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&A.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const m=this.config.folderQueries||[];return new Promise((a,h)=>{const S=w=>{this.resultCount++,g(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const _=w.toString(),p=b.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,p)||this.matchFile(S,{base:w,basename:p})}),Promise.all(m.map(w=>this.searchInFolder(w,S))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{h(new Error((0,T.toErrorMessage)(w)))})})}async searchInFolder(g,m){const a=new I.CancellationTokenSource,h=this.getSearchOptionsForFolder(g),S=this.initDirectoryTree(),w=new y.QueryGlobTester(this.config,g),_=!w.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(a),p=P.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,a.token),f=p.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const s=b.posix.relative(g.folder.path,n.path);if(_){const i=b.basename(n.path);this.matchFile(m,{base:g.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(S,g.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,m),{providerTime:f,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(g){const m=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),a=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:a,includes:m,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},m,a,h){if(a===this.filePattern){const w=b.basename(this.filePattern);this.matchFile(h,{base:m,relativePath:this.filePattern,basename:w})}function S(w){const _=b.basename(w),p=b.dirname(w);let c=g[p];c||(c=g[p]=[],S(p)),c.push({base:m,relativePath:w,basename:_})}S(a)}matchDirectoryTree({rootEntries:g,pathToEntries:m},a,h){const S=this,w=this.filePattern;function _(p){const c=A.hasSiblingFn(()=>p.map(f=>f.basename));for(let f=0,t=p.length;f<t;f++){const n=p[f],{relativePath:s,basename:i}=n;if(!!a.includedInQuerySync(s,i,w!==i?c:void 0)){const l=m[s];if(l)_(l);else{if(s===w)continue;S.matchFile(h,n)}if(S.isLimitHit)break}}}_(g)}matchFile(g,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(m))}}class r{constructor(){this.sessions=new Map}fileSearch(g,m,a,h){const S=this.getSessionTokenSource(g.cacheKey),w=new k(g,m,S&&S.token);let _=0;const p=c=>{_+=c.length,a(c.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(w,r.BATCH_SIZE,p,h).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:c.stats}}))}clearCache(g){const m=this.getSessionTokenSource(g);m&&m.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new I.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:D.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,m,a,h){h.onCancellationRequested(()=>{g.cancel()});const S=_=>{_&&(w.push(_),m>0&&w.length>=m&&(a(w),w=[]))};let w=[];return g.search(S).then(_=>(w.length&&a(w),_),_=>(w.length&&a(w),Promise.reject(_)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(me[127],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=e.Position=void 0;class b{constructor(A,D){this.line=A,this.character=D}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,D){return new b(0,0)}with(A){return new b(0,0)}}e.Position=b;class I{constructor(A,D,P,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(A,D),this.end=new b(P,y)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new I(0,0,0,0)}with(A){return new I(0,0,0,0)}}e.Range=I}),define(me[128],ge([0,1,8,15,21,59,25,33,2,31,11]),function(G,e,b,I,T,A,D,P,y,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class C{constructor(_,p,c){this.query=_,this.provider=p,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(_,p){const c=this.query.folderQueries||[],f=new T.CancellationTokenSource;return p.onCancellationRequested(()=>f.cancel()),new Promise((t,n)=>{this.collector=new m(_);let s=!1;const i=(l,o)=>{if(!s&&!this.isLimitHit){const u=this.resultSize(l);h(l)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,s=!0,f.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const E=this.resultSize(l);this.resultCount+=E,(E>0||!h(l))&&this.collector.add(l,o)}};Promise.all(c.map((l,o)=>this.searchInFolder(l,u=>i(u,o),f.token))).then(l=>{f.dispose(),this.collector.flush();const o=l.some(u=>!!u&&!!u.limitHit);t({limitHit:this.isLimitHit||o,stats:{type:"textSearchProvider"}})},l=>{f.dispose();const o=(0,A.toErrorMessage)(l);n(new Error(o))})})}resultSize(_){return h(_)?Array.isArray(_.ranges)?_.ranges.length:1:0}trimResultToSize(_,p){const c=Array.isArray(_.ranges)?_.ranges:[_.ranges],f=Array.isArray(_.preview.matches)?_.preview.matches:[_.preview.matches];return{ranges:c.slice(0,p),preview:{matches:f.slice(0,p),text:_.preview.text},uri:_.uri}}async searchInFolder(_,p,c){const f=new k.QueryGlobTester(this.query,_),t=[],n={report:l=>{if(!!this.validateProviderResult(l)){const o=_.folder.scheme===r.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(l.uri))):void 0,u=D.relativePath(_.folder,l.uri);u&&t.push(f.includedInQuery(u,b.basename(u),o).then(E=>{E&&p(l)}))}}},s=this.getSearchOptionsForFolder(_),i=await this.provider.provideTextSearchResults(g(this.query.contentPattern),s,n,c);return await Promise.all(t),i}validateProviderResult(_){if(h(_)){if(Array.isArray(_.ranges)){if(!Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(_.preview.matches.length!==_.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(_.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(_){const p=(0,k.resolvePatternsForProvider)(this.query.includePattern,_.includePattern),c=(0,k.resolvePatternsForProvider)(this.query.excludePattern,_.excludePattern),f={folder:y.URI.from(_.folder),excludes:c,includes:p,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,followSymlinks:!_.ignoreSymlinks,encoding:_.fileEncoding&&this.fileUtils.toCanonicalName(_.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return f.usePCRE2=this.query.usePCRE2,f}}e.TextSearchManager=C;function g(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class m{constructor(_){this._onResult=_,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,p=>this.sendItems(p))}add(_,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,_.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:_.uri,results:[]}),this._currentFileMatch.results.push(a(_))}pushToCollector(){const _=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,_)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(_){this._onResult(_)}}e.TextSearchResultsCollector=m;function a(w){return h(w)?{preview:{matches:(0,I.mapArrayOrNot)(w.preview.matches,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character})),text:w.preview.text},ranges:(0,I.mapArrayOrNot)(w.ranges,_=>({startLineNumber:_.start.line,startColumn:_.start.character,endLineNumber:_.end.line,endColumn:_.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function h(w){return!!w.preview}e.extensionResultIsMatch=h;class S{constructor(_,p){this.maxBatchSize=_,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(_,p){!_||this.addItemToBatch(_,p)}addItems(_,p){!_||this.addItemsToBatch(_,p)}addItemToBatch(_,p){this.batch.push(_),this.batchSize+=p,this.onUpdate()}addItemsToBatch(_,p){this.batch=this.batch.concat(_),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(me[69],ge([0,1,6,5,4,268,14,62,13,2,128]),function(G,e,b,I,T,A,D,P,y,k,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(h,S,w){this.extHostRpc=h,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,S){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(h,S){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(h,S,w,_){const p=g(w),c=this._fileSearchProvider.get(h);if(c)return this._fileSearchManager.fileSearch(p,c,f=>{this._proxy.$handleFileMatch(h,S,f.map(t=>t.resource))},_);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,S,w,_){const p=this._textSearchProvider.get(h);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const c=g(w);return this.createTextSearchManager(c,p).search(t=>this._proxy.$handleTextMatch(h,S,t),_)}createTextSearchManager(h,S){return new r.TextSearchManager(h,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=je([Be(0,D.IExtHostRpcService),Be(1,P.IURITransformerService),Be(2,y.ILogService)],C),e.ExtHostSearch=C;function g(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(m),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>k.URI.revive(h))})}e.reviveQuery=g;function m(a){return Object.assign(Object.assign({},a),{folder:k.URI.revive(a.folder)})}}),define(me[269],ge([0,1,159,21,18,3,57,2,151,107,141,77,45,5,231,230,51,232,35,233,234,235,216,236,39,42,237,217,239,240,241,65,220,244,245,246,91,34,247,221,20,7,250,66,126,32,41,53,201,238,116,125,67,46,69,13,62,14,27,242,199,50,64,228,248,198,92,90,253,251,252,229,61,260,249,89,195,118,243,85]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p,c,f,t,n,s,i,l,o,u,E,d,v,R,L,H,ie,j,B,$,N,M,F,U,O,W,q,Q,he,ve,Pe,ke,Le,V,J,ee,ae,we,Ce,Oe,be,Ie,Re,We,Ee,Ke,X,re,_e,xe,ze,$e,Ye,K,oe,fe,Z,ne,ce,pe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function qe(Me){const He=Me.get(Oe.IExtHostInitDataService),Qe=Me.get(K.IExtHostFileSystemInfo),it=Me.get(_e.IExtHostConsumerFileSystem),at=Me.get(i.IExtHostExtensionService),Ze=Me.get(q.IExtHostWorkspace),nt=Me.get(ce.IExtHostTelemetry),dt=Me.get(_.IExtHostConfiguration),_t=Me.get(we.IURITransformerService),ue=Me.get(Ce.IExtHostRpcService),De=Me.get(j.IExtHostStorage),le=Me.get(re.IExtensionStoragePaths),Y=Me.get(ae.ILogService),Ne=Me.get(Re.IExtHostTunnelService),Te=Me.get(We.IExtHostApiDeprecationService),Je=Me.get(W.IExtHostWindow),et=Me.get(Z.IExtHostSecretState);ue.set(m.ExtHostContext.ExtHostFileSystemInfo,Qe),ue.set(m.ExtHostContext.ExtHostLogService,Y),ue.set(m.ExtHostContext.ExtHostWorkspace,Ze),ue.set(m.ExtHostContext.ExtHostConfiguration,dt),ue.set(m.ExtHostContext.ExtHostExtensionService,at),ue.set(m.ExtHostContext.ExtHostStorage,De),ue.set(m.ExtHostContext.ExtHostTunnelService,Ne),ue.set(m.ExtHostContext.ExtHostWindow,Je),ue.set(m.ExtHostContext.ExtHostSecretState,et),ue.set(m.ExtHostContext.ExtHostTelemetry,nt);const ut=ue.set(m.ExtHostContext.ExtHostDecorations,Me.get(Le.IExtHostDecorations)),rt=ue.set(m.ExtHostContext.ExtHostDocumentsAndEditors,Me.get(s.IExtHostDocumentsAndEditors)),Ge=ue.set(m.ExtHostContext.ExtHostCommands,Me.get(S.IExtHostCommands)),ht=ue.set(m.ExtHostContext.ExtHostTerminalService,Me.get(B.IExtHostTerminalService)),ot=ue.set(m.ExtHostContext.ExtHostDebugService,Me.get(J.IExtHostDebugService)),vt=ue.set(m.ExtHostContext.ExtHostSearch,Me.get(ee.IExtHostSearch)),pt=ue.set(m.ExtHostContext.ExtHostTask,Me.get(V.IExtHostTask)),Et=ue.set(m.ExtHostContext.ExtHostOutputService,Me.get(v.IExtHostOutputService)),yt=ue.set(m.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),Pt=ue.set(m.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ue)),bt=ue.set(m.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,rt)),At=ue.set(m.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(ue,rt,Y)),Qt=ue.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Y,bt,ue.getProxy(m.MainContext.MainThreadBulkEdits))),ft=ue.set(m.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(ue,Ge,rt,bt,He.environment,Y,le)),Xt=ue.set(m.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(ue,He,ft)),St=ue.set(m.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(ue,rt)),zt=ue.set(m.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ue.getProxy(m.MainContext.MainThreadTreeViews),Ge,Y)),Yt=ue.set(m.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(ue.getProxy(m.MainContext.MainThreadEditorInsets),St,He.environment)),Vt=ue.set(m.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(ue,Y)),lt=ue.set(m.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(ue,_t,bt,Ge,Vt,Y,Te)),Jt=ue.set(m.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(ue,lt)),Tt=ue.set(m.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(ue,Y,rt)),Nt=ue.set(m.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Ge)),fn=ue.set(m.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(ue,Ge,Y)),_n=ue.set(m.ExtHostContext.ExtHostComments,new w.ExtHostComments(ue,Ge,bt)),mn=ue.set(m.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ue.getProxy(m.MainContext.MainThreadProgress))),Zt=ue.set(m.ExtHostContext.ExtHosLabelService,new Pe.ExtHostLabelService(ue)),jt=ue.set(m.ExtHostContext.ExtHostTheming,new Ie.ExtHostTheming(ue)),Mt=ue.set(m.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(ue)),En=ue.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,Ge)),en=ue.set(m.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(ue,He.environment,Ze,Y,Te)),tn=ue.set(m.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ue,en,Ze)),qt=ue.set(m.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(ue,bt,le,en,tn)),Sn=ue.set(m.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(ue,en)),Rt=ue.set(m.ExtHostContext.ExtHostTesting,new oe.ExtHostTesting(ue,rt,Ze)),nn=ue.set(m.ExtHostContext.ExtHostUriOpeners,new fe.ExtHostUriOpeners(ue)),yn=(0,he.values)(m.ExtHostContext);ue.assertRegistered(yn);const rn=new Ye.ExtHostBulkEdits(ue,rt),sn=new h.ExtHostClipboard(ue),Ot=new d.ExtHostMessageService(ue,Y),gn=new c.ExtHostDialogs(ue),pn=new ie.ExtHostStatusBar(ue,Ge.converter),Ut=new E.ExtHostLanguages(ue,bt);return a.ExtHostApiCommands.register(Ge),function(Fe,on,an){const mt=function(){let te=!Fe.isUnderDevelopment;function de(Ae){te||(Y.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")de(st);else{const z=st;typeof z.scheme=="undefined"&&de(st),!Fe.enableProposedApi&&typeof z.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Fe)}return st}}(),Dn={getSession(te,de,Ae){return Mt.getSession(Fe,te,de,Ae)},get onDidChangeSessions(){return Mt.onDidChangeSessions},registerAuthenticationProvider(te,de,Ae,st){return Mt.registerAuthenticationProvider(te,de,Ae,st)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Fe),Mt.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Fe),Mt.providers},logout(te,de){return(0,Q.checkProposedApiEnabled)(Fe),Mt.removeSession(te,de)}},Cn={registerCommand(te,de,Ae){return Ge.registerCommand(!0,te,de,Ae)},registerTextEditorCommand(te,de,Ae){return Ge.registerCommand(!0,te,(...st)=>{const z=St.getActiveTextEditor();if(!z){Y.warn("Cannot execute "+te+" because there is no active text editor.");return}return z.edit(x=>{de.apply(Ae,[z,x,...st])}).then(x=>{x||Y.warn("Edits from command "+te+" were not applied.")},x=>{Y.warn("An error occurred while running command "+te,x)})})},registerDiffInformationCommand:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),Ge.registerCommand(!0,te,async(...st)=>{const z=rt.activeEditor(!0);if(!z){Y.warn("Cannot execute "+te+" because there is no active text editor.");return}const x=await St.getDiffInformation(z.id);de.apply(Ae,[x,...st])})),executeCommand(te,...de){return Ge.executeCommand(te,...de)},getCommands(te=!1){return Ge.getCommands(te)}},Kt={get machineId(){return He.telemetryInfo.machineId},get sessionId(){return He.telemetryInfo.sessionId},get language(){return He.environment.appLanguage},get appName(){return He.environment.appName},get appRoot(){var te,de;return(de=(te=He.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return He.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return ht.getDefaultShell(!1,an)},get isTelemetryEnabled(){return nt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return nt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(He.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return Je.openUri(te,{allowTunneling:!!He.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(te){return te.scheme===He.environment.appUriScheme?Pt.createAppUri(te):Je.asExternalUri(te,{allowTunneling:!!He.remote.authority})},get remoteName(){return(0,ke.getRemoteName)(He.remote.authority)},get uiKind(){return He.uiKind}};He.environment.extensionTestsLocationURI||Object.freeze(Kt);const vn=He.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,kn={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.registerTestController(Fe.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Fe),Rt.runTests(te)},createTestItem(te,de){return new F.TestItemImpl(te.id,te.label,te.uri,de)},createTestRunTask(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),Rt.createTestRunTask(Fe.identifier.value,te,de,Ae)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Fe),Rt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Fe),Rt.results}},In={getExtension(te){const de=on.getExtensionDescription(te);if(de)return new i.Extension(at,Fe.identifier,de,vn)},get all(){return on.getAllExtensionDescriptions().map(te=>new i.Extension(at,Fe.identifier,te,vn))},get onDidChange(){return on.onDidChange}},Pn={createDiagnosticCollection(te){return Vt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return Vt.onDidChangeDiagnostics},getDiagnostics:te=>Vt.getDiagnostics(te),getLanguages(){return Ut.getLanguages()},setTextDocumentLanguage(te,de){return Ut.changeLanguage(te.uri,de)},match(te,de){return(0,C.score)(M.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,Ae){return lt.registerCodeActionProvider(Fe,mt(te),de,Ae)},registerCodeLensProvider(te,de){return lt.registerCodeLensProvider(Fe,mt(te),de)},registerDefinitionProvider(te,de){return lt.registerDefinitionProvider(Fe,mt(te),de)},registerDeclarationProvider(te,de){return lt.registerDeclarationProvider(Fe,mt(te),de)},registerImplementationProvider(te,de){return lt.registerImplementationProvider(Fe,mt(te),de)},registerTypeDefinitionProvider(te,de){return lt.registerTypeDefinitionProvider(Fe,mt(te),de)},registerHoverProvider(te,de){return lt.registerHoverProvider(Fe,mt(te),de,Fe.identifier)},registerEvaluatableExpressionProvider(te,de){return lt.registerEvaluatableExpressionProvider(Fe,mt(te),de,Fe.identifier)},registerInlineValuesProvider(te,de){return lt.registerInlineValuesProvider(Fe,mt(te),de,Fe.identifier)},registerDocumentHighlightProvider(te,de){return lt.registerDocumentHighlightProvider(Fe,mt(te),de)},registerLinkedEditingRangeProvider(te,de){return lt.registerLinkedEditingRangeProvider(Fe,mt(te),de)},registerReferenceProvider(te,de){return lt.registerReferenceProvider(Fe,mt(te),de)},registerRenameProvider(te,de){return lt.registerRenameProvider(Fe,mt(te),de)},registerDocumentSymbolProvider(te,de,Ae){return lt.registerDocumentSymbolProvider(Fe,mt(te),de,Ae)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,de){return lt.registerDocumentFormattingEditProvider(Fe,mt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return lt.registerDocumentRangeFormattingEditProvider(Fe,mt(te),de)},registerOnTypeFormattingEditProvider(te,de,Ae,...st){return lt.registerOnTypeFormattingEditProvider(Fe,mt(te),de,[Ae].concat(st))},registerDocumentSemanticTokensProvider(te,de,Ae){return lt.registerDocumentSemanticTokensProvider(Fe,mt(te),de,Ae)},registerDocumentRangeSemanticTokensProvider(te,de,Ae){return lt.registerDocumentRangeSemanticTokensProvider(Fe,mt(te),de,Ae)},registerSignatureHelpProvider(te,de,Ae,...st){return typeof Ae=="object"?lt.registerSignatureHelpProvider(Fe,mt(te),de,Ae):lt.registerSignatureHelpProvider(Fe,mt(te),de,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(te,de,...Ae){return lt.registerCompletionItemProvider(Fe,mt(te),de,Ae)},registerDocumentLinkProvider(te,de){return lt.registerDocumentLinkProvider(Fe,mt(te),de)},registerColorProvider(te,de){return lt.registerColorProvider(Fe,mt(te),de)},registerFoldingRangeProvider(te,de){return lt.registerFoldingRangeProvider(Fe,mt(te),de)},registerSelectionRangeProvider(te,de){return lt.registerSelectionRangeProvider(Fe,te,de)},registerCallHierarchyProvider(te,de){return lt.registerCallHierarchyProvider(Fe,te,de)},setLanguageConfiguration:(te,de)=>lt.setLanguageConfiguration(Fe,te,de),getTokenInformationAtPosition(te,de){return(0,Q.checkProposedApiEnabled)(Fe),Ut.tokenAtPosition(te,de)},registerInlineHintsProvider(te,de){return(0,Q.checkProposedApiEnabled)(Fe),lt.registerInlineHintsProvider(Fe,te,de)}},An={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(te,de,Ae){const st=await(P.URI.isUri(te)?Promise.resolve(ln.openTextDocument(te)):Promise.resolve(te));return St.showTextDocument(st,de,Ae)},createTextEditorDecorationType(te){return St.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,de,Ae){return St.onDidChangeActiveTextEditor(te,de,Ae)},onDidChangeVisibleTextEditors(te,de,Ae){return St.onDidChangeVisibleTextEditors(te,de,Ae)},onDidChangeTextEditorSelection(te,de,Ae){return St.onDidChangeTextEditorSelection(te,de,Ae)},onDidChangeTextEditorOptions(te,de,Ae){return St.onDidChangeTextEditorOptions(te,de,Ae)},onDidChangeTextEditorVisibleRanges(te,de,Ae){return St.onDidChangeTextEditorVisibleRanges(te,de,Ae)},onDidChangeTextEditorViewColumn(te,de,Ae){return St.onDidChangeTextEditorViewColumn(te,de,Ae)},onDidCloseTerminal(te,de,Ae){return ht.onDidCloseTerminal(te,de,Ae)},onDidOpenTerminal(te,de,Ae){return ht.onDidOpenTerminal(te,de,Ae)},onDidChangeActiveTerminal(te,de,Ae){return ht.onDidChangeActiveTerminal(te,de,Ae)},onDidChangeTerminalDimensions(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ht.onDidChangeTerminalDimensions(te,de,Ae)},onDidWriteTerminalData(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ht.onDidWriteTerminalData(te,de,Ae)},get state(){return Je.state},onDidChangeWindowState(te,de,Ae){return Je.onDidChangeWindowState(te,de,Ae)},showInformationMessage(te,...de){return Ot.showMessage(Fe,D.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Ot.showMessage(Fe,D.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Ot.showMessage(Fe,D.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Ae){return Nt.showQuickPick(te,!!Fe.enableProposedApi,de,Ae)},showWorkspaceFolderPick(te){return Nt.showWorkspaceFolderPick(te)},showInputBox(te,de){return Nt.showInput(te,de)},showOpenDialog(te){return gn.showOpenDialog(te)},showSaveDialog(te){return gn.showSaveDialog(te)},createStatusBarItem(te,de){let Ae,st,z,x;return te&&typeof te!="number"?(Ae=te.id,st=te.name,z=te.alignment,de=te.priority,x=te.accessibilityInformation):(Ae=Fe.identifier.value,st=b.localize(0,null,Fe.displayName||Fe.name),z=te),pn.createStatusBarEntry(Ae,st,z,de,x)},setStatusBarMessage(te,de){return pn.setStatusBarMessage(te,de)},withScmProgress(te){return Te.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),mn.withProgress(Fe,{location:F.ProgressLocation.SourceControl},(de,Ae)=>te({report(st){}}))},withProgress(te,de){return mn.withProgress(Fe,te,de)},createOutputChannel(te){return Et.createOutputChannel(te)},createWebviewPanel(te,de,Ae,st){return tn.createWebviewPanel(Fe,te,de,Ae,st)},createWebviewTextEditorInset(te,de,Ae,st){return(0,Q.checkProposedApiEnabled)(Fe),Yt.createWebviewEditorInset(te,de,Ae,st,Fe)},createTerminal(te,de,Ae){return typeof te=="object"?"pty"in te?ht.createExtensionTerminal(te):(te.message&&(0,Q.checkProposedApiEnabled)(Fe),te.icon&&(0,Q.checkProposedApiEnabled)(Fe),ht.createTerminalFromOptions(te)):ht.createTerminal(te,de,Ae)},registerTerminalLinkProvider(te){return ht.registerLinkProvider(te)},registerTreeDataProvider(te,de){return zt.registerTreeDataProvider(te,de,Fe)},createTreeView(te,de){return zt.createTreeView(te,de,Fe)},registerWebviewPanelSerializer:(te,de)=>tn.registerWebviewPanelSerializer(Fe,te,de),registerCustomEditorProvider:(te,de,Ae={})=>qt.registerCustomEditorProvider(Fe,te,de,Ae),registerFileDecorationProvider(te){return ut.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return Pt.registerUriHandler(Fe.identifier,te)},createQuickPick(){return Nt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Nt.createInputBox(Fe.identifier)},get activeColorTheme(){return jt.activeColorTheme},onDidChangeActiveColorTheme(te,de,Ae){return jt.onDidChangeActiveColorTheme(te,de,Ae)},registerWebviewViewProvider(te,de,Ae){return Sn.registerWebviewViewProvider(Fe,te,de,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookEditor(te,de,Ae)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorSelection(te,de,Ae)},onDidChangeNotebookEditorVisibleRanges(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookEditorVisibleRanges(te,de,Ae)},showNotebookDocument(te,de){return(0,Q.checkProposedApiEnabled)(Fe),ft.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),nn.registerExternalUriOpener(Fe.identifier,te,de,Ae)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Fe),yt.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Fe),yt.onDidChangeTabs}},ln={get rootPath(){return Te.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(te){throw T.readonly()},getWorkspaceFolder(te){return Ze.getWorkspaceFolder(te)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(te){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(te){throw T.readonly()},updateWorkspaceFolders:(te,de,...Ae)=>Ze.updateWorkspaceFolders(Fe,te,de||0,...Ae),onDidChangeWorkspaceFolders:function(te,de,Ae){return Ze.onDidChangeWorkspace(te,de,Ae)},asRelativePath:(te,de)=>Ze.getRelativePath(te,de),findFiles:(te,de,Ae,st)=>Ze.findFiles(M.GlobPattern.from(te),M.GlobPattern.from(de),Ae,Fe.identifier,st),findTextInFiles:(te,de,Ae,st)=>{let z,x;return typeof de=="object"?(z=de,x=Ae):(z={},x=de,st=Ae),Ze.findTextInFiles(te,z||{},x,Fe.identifier,st)},saveAll:te=>Ze.saveAll(te),applyEdit(te){return rn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,Ae,st)=>Tt.createFileSystemWatcher(M.GlobPattern.from(te),de,Ae,st),get textDocuments(){return bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.readonly()},openTextDocument(te){let de;const Ae=te;if(typeof te=="string")de=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))de=Promise.resolve(te);else if(!Ae||typeof Ae=="object")de=bt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>bt.ensureDocumentData(st).then(z=>z.document))},onDidOpenTextDocument:(te,de,Ae)=>bt.onDidAddDocument(te,de,Ae),onDidCloseTextDocument:(te,de,Ae)=>bt.onDidRemoveDocument(te,de,Ae),onDidChangeTextDocument:(te,de,Ae)=>bt.onDidChangeDocument(te,de,Ae),onDidSaveTextDocument:(te,de,Ae)=>bt.onDidSaveDocument(te,de,Ae),onWillSaveTextDocument:(te,de,Ae)=>Qt.getOnWillSaveTextDocumentEvent(Fe)(te,de,Ae),onDidChangeConfiguration:(te,de,Ae)=>an.onDidChangeConfiguration(te,de,Ae),getConfiguration(te,de){return de=arguments.length===1?void 0:de,an.getConfiguration(te,de,Fe)},registerTextDocumentContentProvider(te,de){return At.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Te.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Fe,te,de)),registerFileSystemProvider(te,de,Ae){return Jt.registerFileSystemProvider(Fe.identifier,te,de,Ae)},get fs(){return it.value},registerFileSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),vt.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),vt.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),at.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Fe),Zt.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,Ae)=>Tt.onDidCreateFile(te,de,Ae),onDidDeleteFiles:(te,de,Ae)=>Tt.onDidDeleteFile(te,de,Ae),onDidRenameFiles:(te,de,Ae)=>Tt.onDidRenameFile(te,de,Ae),onWillCreateFiles:(te,de,Ae)=>Tt.getOnWillCreateFileEvent(Fe)(te,de,Ae),onWillDeleteFiles:(te,de,Ae)=>Tt.getOnWillDeleteFileEvent(Fe)(te,de,Ae),onWillRenameFiles:(te,de,Ae)=>Tt.getOnWillRenameFileEvent(Fe)(te,de,Ae),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Fe),Ne.openTunnel(Fe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Fe),Ne.getTunnels()},onDidChangeTunnels:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),Ne.onDidChangeTunnels(te,de,Ae)),registerPortAttributesProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),Ne.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),En.registerTimelineProvider(te,de,Fe.identifier,Ge.converter)),get isTrusted(){return(0,Q.checkProposedApiEnabled)(Fe),Ze.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Fe),Ze.requestWorkspaceTrust(te)),onDidReceiveWorkspaceTrust:(te,de,Ae)=>Ze.onDidReceiveWorkspaceTrust(te,de,Ae)},wn={get inputBox(){return Te.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),fn.getLastInputBox(Fe)},createSourceControl(te,de,Ae){return fn.createSourceControl(Fe,te,de,Ae)}},xt={createCommentController(te,de){return _n.createCommentController(Fe,te,de)}},Gt={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(te,de,Ae){return ot.onDidStartDebugSession(te,de,Ae)},onDidTerminateDebugSession(te,de,Ae){return ot.onDidTerminateDebugSession(te,de,Ae)},onDidChangeActiveDebugSession(te,de,Ae){return ot.onDidChangeActiveDebugSession(te,de,Ae)},onDidReceiveDebugSessionCustomEvent(te,de,Ae){return ot.onDidReceiveDebugSessionCustomEvent(te,de,Ae)},onDidChangeBreakpoints(te,de,Ae){return ot.onDidChangeBreakpoints(te,de,Ae)},registerDebugConfigurationProvider(te,de,Ae){return ot.registerDebugConfigurationProvider(te,de,Ae||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return ot.registerDebugAdapterDescriptorFactory(Fe,te,de)},registerDebugAdapterTrackerFactory(te,de){return ot.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ot.startDebugging(te,de,{parentSession:Ae}):ot.startDebugging(te,de,Ae||{})},stopDebugging(te){return ot.stopDebugging(te)},addBreakpoints(te){return ot.addBreakpoints(te)},removeBreakpoints(te){return ot.removeBreakpoints(te)},asDebugSourceUri(te,de){return ot.asDebugSourceUri(te,de)}},Tn={registerTaskProvider:(te,de)=>pt.registerTaskProvider(Fe,te,de),fetchTasks:te=>pt.fetchTasks(te),executeTask:te=>pt.executeTask(Fe,te),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(te,de,Ae)=>pt.onDidStartTask(te,de,Ae),onDidEndTask:(te,de,Ae)=>pt.onDidEndTask(te,de,Ae),onDidStartTaskProcess:(te,de,Ae)=>pt.onDidStartTaskProcess(te,de,Ae),onDidEndTaskProcess:(te,de,Ae)=>pt.onDidEndTaskProcess(te,de,Ae)},cn={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Fe),ft.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Fe),ft.notebookDocuments.map(te=>te.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookSerializer(Fe,te,de,Ae)},registerNotebookContentProvider:(te,de,Ae)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookContentProvider(Fe,te,de,Ae)),registerNotebookKernelProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookKernelProvider(Fe,te,de)),registerNotebookCellStatusBarItemProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Fe),ft.registerNotebookCellStatusBarItemProvider(Fe,te,de)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookDocumentMetadata(te,de,Ae)},onDidChangeNotebookCells(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCells(te,de,Ae)},onDidChangeCellExecutionState(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeNotebookCellExecutionState(te,de,Ae)},onDidChangeCellOutputs(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeCellOutputs(te,de,Ae)},onDidChangeCellMetadata(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.onDidChangeCellMetadata(te,de,Ae)},createConcatTextDocument(te,de){return(0,Q.checkProposedApiEnabled)(Fe),new X.ExtHostNotebookConcatDocument(ft,bt,te,de)},createNotebookCellExecutionTask(te,de,Ae){return(0,Q.checkProposedApiEnabled)(Fe),ft.createNotebookCellExecution(te,de,Ae)},createNotebookController(te,de,Ae,st,z){return(0,Q.checkProposedApiEnabled)(Fe),Xt.createNotebookController(Fe,te,de,Ae,st,z)}};return{version:He.version,authentication:Dn,commands:Cn,comments:xt,debug:Gt,env:Kt,extensions:In,languages:Pn,notebook:cn,scm:wn,tasks:Tn,test:kn,window:An,workspace:ln,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:g.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:r.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:P.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlineHint:F.InlineHint,InlineHintKind:F.InlineHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,RemoteTrustOption:Se.RemoteTrustOption,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookDocumentMetadata:F.NotebookDocumentMetadata,NotebookCellMetadata:F.NotebookCellMetadata,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,LinkedEditingRanges:F.LinkedEditingRanges,TestItemStatus:F.TestItemStatus,TestResultState:F.TestResultState,TestMessage:F.TestMessage,TestMessageSeverity:F.TestMessageSeverity,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=qe}),define(me[270],ge([0,1,79,65,32,125,35,51,39,34,67,46,69,92,91,50,64,126,90,61,89,118]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_,p,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,b.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,b.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,b.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,b.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,b.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,b.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,b.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,b.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,b.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,b.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,b.registerSingleton)(r.IExtHostTask,r.WorkerExtHostTask),(0,b.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,b.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,b.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,b.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,b.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,b.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry)}),define(me[93],ge([0,1,15,13,31,127]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=D;function P(C,g,m,a){const h=(0,b.mapArrayOrNot)(m,y),S=new T.TextSearchMatch(g,h,a),w=S.preview.matches;return{ranges:(0,b.mapArrayOrNot)(h,k),uri:C,preview:{text:S.preview.text,matches:(0,b.mapArrayOrNot)(w,k)}}}e.createTextSearchResult=P;function y(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let r=class{constructor(g,m){this.prefix=g,this.logService=m}appendLine(g){this.logService.debug(`${this.prefix}#search`,g)}};r=je([Be(1,I.ILogService)],r),e.OutputChannel=r}),define(me[271],ge([0,1,94,22]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,P=512*8,y=512*128;class k{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((l,o)=>{G(["iconv-lite-umd"],l,o)})).getDecoder(m(n));else{const i=new TextDecoder;s={write(l){return i.decode(l,{stream:!0})},end(){return i.decode()}}}return new k(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function r(t,n){var s;const i=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?P:D;return new Promise((l,o)=>{const u=(0,b.newWriteableStream)(L=>L.join("")),E=[];let d=0,v;const R=async()=>{try{const L=await f({buffer:I.VSBuffer.concat(E),bytesRead:d},n.guessEncoding);L.encoding=await n.overwriteEncoding(L.encoding),v=await k.create(L.encoding);const H=v.write(I.VSBuffer.concat(E).buffer);u.write(H),E.length=0,d=0,l({stream:u,detected:L})}catch(L){o(L)}};(0,b.listenStream)(t,{onData:async L=>{v?u.write(v.write(L.buffer)):(E.push(L),d+=L.byteLength,d>=i&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:L=>u.error(L),onEnd:async()=>{v||await R(),u.end(v==null?void 0:v.end())}})})}e.toDecodeStream=r;async function C(t,n,s){const l=(await new Promise((E,d)=>{G(["iconv-lite-umd"],E,d)})).getEncoder(m(n),s);let o=!1,u=!1;return{read(){if(u)return null;const E=t.read();if(typeof E!="string"){if(u=!0,!o&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const d=l.end();return d&&d.length>0?(o=!0,I.VSBuffer.wrap(d)):null}return o=!0,I.VSBuffer.wrap(l.write(E))}}}e.toEncodeReadable=C;async function g(t){return(await new Promise((s,i)=>{G(["iconv-lite-umd"],s,i)})).encodingExists(m(t))}e.encodingExists=g;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),i=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return s===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const h=["ascii","utf-16","utf-32"];async function S(t){const n=await new Promise((u,E)=>{G(["jschardet"],u,E)}),s=t.slice(0,y),i=p(s.buffer),l=n.detect(i);if(!l||!l.encoding)return null;const o=l.encoding.toLowerCase();return 0<=h.indexOf(o)?null:_(l.encoding)}const w={ibm866:"cp866",big5:"cp950"};function _(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function p(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function c(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=c;function f({buffer:t,bytesRead:n},s){let i=a(t,n),l=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let o=!0,u=!0,E=!1;for(let d=0;d<n&&d<A;d++){const v=d%2==1,R=t.readUInt8(d)===0;if(R&&(E=!0),o&&(v&&!R||!v&&R)&&(o=!1),u&&(v&&R||!v&&!R)&&(u=!1),R&&!o&&!u)break}E&&(o?i=e.UTF16le:u?i=e.UTF16be:l=!0)}return s&&!l&&!i&&t?S(t.slice(0,n)).then(o=>({seemsBinary:!1,encoding:o})):{seemsBinary:l,encoding:i}}e.detectEncodingFromBuffer=f,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[129],ge([0,1,271,26,128]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends T.TextSearchManager{constructor(P,y,k=I){super(P,y,{readdir:r=>k.readdir(r.fsPath),toCanonicalName:r=>(0,b.toCanonicalName)(r)})}}e.NativeTextSearchManager=A}),define(me[272],ge([0,1,273,287,288,2,289]),function(G,e,b,I,T,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(C,g,m,a,h,S){const w=S.environment.useHostProxy,_=typeof w=="boolean"?w:!S.remote.isRemote,p=(0,D.createProxyResolver)({resolveProxy:f=>C.resolveProxy(f),getHttpProxySetting:()=>g.getConfiguration("http").get("proxy"),log:(f,t,...n)=>{switch(f){case D.LogLevel.Trace:a.trace(t,...n);break;case D.LogLevel.Debug:a.debug(t,...n);break;case D.LogLevel.Info:a.info(t,...n);break;case D.LogLevel.Warning:a.warn(t,...n);break;case D.LogLevel.Error:a.error(t,...n);break;case D.LogLevel.Critical:a.critical(t,...n);break;case D.LogLevel.Off:break;default:s(f,t,n);break}function s(i,l,...o){a.error("Unknown log level",i),a.error(l,...o)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:f=>{h.$publicLog2("resolveProxy",f)},useHostProxy:_,env:process.env}),c=y(g,p);return r(m,c)}e.connectProxyResolver=P;function y(C,g){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(h=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(h=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,D.createHttpPatch)(b,g,{config:"off"},a,!0)),on:Object.assign({},b,(0,D.createHttpPatch)(b,g,{config:"on"},a,!0)),override:Object.assign({},b,(0,D.createHttpPatch)(b,g,{config:"override"},a,!0)),onRequest:Object.assign({},b,(0,D.createHttpPatch)(b,g,m,a,!0)),default:Object.assign(b,(0,D.createHttpPatch)(b,g,m,a,!1))},https:{off:Object.assign({},I,(0,D.createHttpPatch)(I,g,{config:"off"},a,!0)),on:Object.assign({},I,(0,D.createHttpPatch)(I,g,{config:"on"},a,!0)),override:Object.assign({},I,(0,D.createHttpPatch)(I,g,{config:"override"},a,!0)),onRequest:Object.assign({},I,(0,D.createHttpPatch)(I,g,m,a,!0)),default:Object.assign(I,(0,D.createHttpPatch)(I,g,m,a,!1))},tls:Object.assign(T,(0,D.createTlsPatch)(T))}}const k=new Map;function r(C,g){return C.getExtensionPathIndex().then(m=>{const a=G.__$__nodeRequire("module"),h=a._load;a._load=function(w,_,p){if(w==="tls")return g.tls;if(w!=="http"&&w!=="https")return h.apply(this,arguments);const c=g[w],f=m.findSubstr(A.URI.file(_.filename).fsPath);let t=k.get(f);if(t||k.set(f,t={}),!t[w]){let n=c.default;f&&f.enableProposedApi&&(n=c[f.proxySupport]||c.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[274],ge([0,1,38,8,75,30,9,10,93,275]),function(G,e,b,I,T,A,D,P,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(p,c,f,t){const n=g(p,c,f,t),s=c.folder.fsPath;return{cmd:b.spawn(r,n.args,{cwd:s}),rgDiskPath:r,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=C;function g(p,c,f,t){const n=["--files","--hidden","--case-sensitive"];a([c],f,!1).forEach(i=>{const l=(0,y.anchorGlob)(i);if(n.push("-g",l),D.isMacintosh){const o=(0,T.normalizeNFD)(l);o!==l&&n.push("-g",o)}});const s=m([c],t,void 0,!1);return s.globArgs.forEach(i=>{const l=`!${(0,y.anchorGlob)(i)}`;if(n.push("-g",l),D.isMacintosh){const o=(0,T.normalizeNFD)(l);o!==l&&n.push("-g",o)}}),c.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),c.ignoreSymlinks||n.push("--follow"),p.exists&&n.push("--quiet"),n.push("--no-config"),c.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function m(p,c,f,t=!0){const n=[];let s={};return p.forEach(i=>{const l=Object.assign({},i.excludePattern||{},c||{}),o=h(l,t?i.folder.fsPath:void 0,f);n.push(...o.globArgs),o.siblingClauses&&(s=Object.assign(s,o.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=m;function a(p,c,f=!0){const t=[];return p.forEach(n=>{const s=Object.assign({},c||{},n.includePattern||{}),i=h(s,f?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=a;function h(p,c,f){const t=[],n={};return Object.keys(p).forEach(s=>{if(!(f&&f.has(s))&&!!s){const i=p[s];s=w(c?S(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(_(s))):i&&i.when&&(n[s]=i)}}),{globArgs:t,siblingClauses:n}}function S(p,c){return I.isAbsolute(c)?c:I.join(p,c)}e.getAbsoluteGlob=S;function w(p){return p=P.rtrim(p,"\\"),P.rtrim(p,"/")}function _(p){return A.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=_}),define(me[276],ge([0,1,38,37,8,101,15,59,33,75,30,9,47,10,12,26,31,274,99]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(s=>s())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&y.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&y.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(l=>{const o=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),u=l.folder.fsPath;i.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==u).forEach(E=>{(0,r.isEqualOrParent)(E,u)&&(o[T.relative(u,E)]=!0)}),this.folderExcludePatterns.set(u,new t(o,u))})}cancel(){this.isCanceled=!0}walk(i,l,o,u,E){if(this.fileWalkSW=g.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);l.forEach(d=>{const v=T.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,v)||this.matchFile(o,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=g.StopWatch.create(!1),this.parallel(i,(d,v)=>{this.call(this.cmdTraversal,this,d,o,u,R=>{if(R){const L=(0,P.toErrorMessage)(R);console.error(L),this.errors.push(L),v(R,void 0)}else v(null,void 0)})},(d,v)=>{this.fileWalkSW.stop();const R=d?D.coalesce(d)[0]:null;E(R,this.isLimitHit)})}parallel(i,l,o){const u=new Array(i.length),E=new Array(i.length);let d=!1,v=0;if(i.length===0)return o(null,[]);i.forEach((R,L)=>{l(R,(H,ie)=>{if(H?(d=!0,u[L]=null,E[L]=H):(u[L]=ie,E[L]=null),++v===i.length)return o(d?E:null,u)})})}call(i,l,...o){try{i.apply(l,o)}catch(u){o[o.length-1](u)}}cmdTraversal(i,l,o,u){const E=i.folder.fsPath,d=C.isMacintosh;let v;const R=()=>v&&v.kill();p.add(R);let L=M=>{p.delete(R),L=()=>{},u(M)},H="";const ie=this.initDirectoryTree();let j;const B=(0,w.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=B.cmd,j=!Object.keys(B.siblingClauses).length;const $=B.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let N=`${B.rgDiskPath} ${$}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),o({message:N}),this.cmdResultCount=0,this.collectStdout(v,"utf8",o,(M,F,U)=>{if(M){L(M);return}if(this.isLimitHit){L();return}const W=(H+(d?k.normalizeNFC(F||""):F)).split(`
`);if(U){const q=W.length;W[q-1]=W[q-1].trim(),W[q-1]||W.pop()}else H=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,j){for(const q of W)if(this.matchFile(l,{base:E,relativePath:q,searchPath:this.getSearchPath(i,q)}),this.isLimitHit){R();break}(U||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,ie,E,W,l),U&&(this.matchDirectoryTree(ie,E,l),L())})}spawnFindCmd(i){const l=this.folderExcludePatterns.get(i.folder.fsPath),o=l.getBasenameTerms(),u=l.getPathTerms(),E=["-L","."];if(o.length||u.length){E.push("-not","(","(");for(const d of o)E.push("-name",d),E.push("-o");for(const d of u)E.push("-path",d),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),b.spawn("find",E,{cwd:i.folder.fsPath})}readStdout(i,l,o){let u="";this.collectStdout(i,l,()=>{},(E,d,v)=>{if(E){o(E);return}u+=d,v&&o(null,u)})}collectStdout(i,l,o,u){let E=(R,L,H)=>{(R||H)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),u(R,L,H)},d=!1;i.stdout?(this.forwardData(i.stdout,l,E),i.stdout.once("data",()=>d=!0)):o({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):o({message:"stderr is null"}),i.on("error",R=>{E(R)}),i.on("close",R=>{let L;!d&&(L=this.decodeData(v,l))&&n(L)?E(new Error(`command failed with error code ${R}: ${this.decodeData(v,l)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(i,l,o){const u=new A.StringDecoder(l);return i.on("data",E=>{o(null,u.write(E))}),u}collectData(i){const l=[];return i.on("data",o=>{l.push(o)}),l}decodeData(i,l){const o=new A.StringDecoder(l);return i.map(u=>o.write(u)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:l},o,u,E){u.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:o,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const d=v=>{const R=T.basename(v),L=T.dirname(v);let H=l[L];H||(H=l[L]=[],d(L)),H.push({base:o,relativePath:v,basename:R,searchPath:this.getSearchPath(i,v)})};u.forEach(d)}matchDirectoryTree({rootEntries:i,pathToEntries:l},o,u){const E=this,d=this.folderExcludePatterns.get(o),v=this.filePattern;function R(L){E.directoriesWalked++;const H=y.hasSiblingFn(()=>L.map(ie=>ie.basename));for(let ie=0,j=L.length;ie<j;ie++){const B=L[ie],{relativePath:$,basename:N}=B;if(!d.test($,N,v!==N?H:void 0)){const M=l[$];if(M)R(M);else{if(E.filesWalked++,$===v)continue;E.matchFile(u,B)}if(E.isLimitHit)break}}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,l,o,u,E){const d=i.folder,v=y.hasSiblingFn(()=>o);this.parallel(o,(R,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const H=l?[l,R].join(T.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(H,R,this.config.filePattern!==R?v:void 0))return L(null);const ie=[d.fsPath,H].join(T.sep);I.lstat(ie,(j,B)=>{if(j||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(ie,B,($,N)=>$||this.isCanceled||this.isLimitHit?L(null):N.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ie,B,(M,F)=>M||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?L(null):(this.walkedPaths[F]=!0,(0,h.readdir)(ie).then(U=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,H,U,u,O=>L(O||null))},U=>{L(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&a.isNumber(N.size)&&N.size>this.maxFilesize||this.matchFile(u,{base:d.fsPath,relativePath:H,searchPath:this.getSearchPath(i,H)}),L(null,void 0)))})},R=>{const L=R&&D.coalesce(R);return E(L&&L.length>0?L[0]:void 0)})}matchFile(i,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,T.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(l))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,l,o){return l.isSymbolicLink()?I.stat(i,o):o(null,l)}realPathIfNeeded(i,l,o){return l.isSymbolicLink()?I.realpath(i,(u,E)=>u?o(u):o(null,E)):o(null,i)}getSearchPath(i,l){return i.folderName?T.join(i.folderName,l):l}}e.FileWalker=c;class f{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,l,o){this.walker.walk(this.folderQueries,this.extraFiles,i,l,(u,E)=>{o(u,{limitHit:E,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}}e.Engine=f;class t{constructor(i,l){this.expression=i,this.root=l,this.init(i)}init(i){let l,o;Object.keys(i).filter(u=>i[u]).forEach(u=>{T.isAbsolute(u)?(l=l||y.getEmptyExpression(),l[u]=i[u]):(o=o||y.getEmptyExpression(),o[u]=i[u])}),this.absoluteParsedExpr=l&&y.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=o&&y.parse(o,{trimForExclusions:!0})}test(i,l,o){return this.relativeParsedExpr&&this.relativeParsedExpr(i,l,o)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,i),l,o)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...y.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...y.getPathTerms(this.relativeParsedExpr)),i}}function n(s){const i=s.trim().split(`
`),l=i[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=n}),define(me[130],ge([0,1,38,290,101,15,53,33,8,10,2,31,127,291,275,93]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(d){this.outputChannel=d}provideTextSearchResults(d,v,R,L){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((H,ie)=>{L.onCancellationRequested(()=>O());const j=n(d,v),B=v.folder.fsPath,$=j.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${S} ${$}
 - cwd: ${B}`);let N=b.spawn(S,j,{cwd:B});N.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ie((0,C.serializeSearchError)(new C.SearchError(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let M=!1;const F=new c(v.maxResults,B,v.previewOptions);F.on("result",ve=>{M=!0,q="",R.report(ve)});let U=!1;const O=()=>{U=!0,N&&N.kill(),F&&F.cancel()};let W=!1;F.on("hitLimit",()=>{W=!0,O()});let q="";N.stdout.on("data",ve=>{F.handleData(ve),M||(q+=ve)});let Q=!1;N.stdout.once("data",()=>Q=!0);let he="";N.stderr.on("data",ve=>{const Pe=ve.toString();this.outputChannel.appendLine(Pe),he+=Pe}),N.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),U)H({limitHit:W});else{F.flush(),N=null;let ve;he&&!Q&&(ve=_(he))?ie((0,C.serializeSearchError)(new C.SearchError(ve.message,ve.code))):H({limitHit:W})}})})}}e.RipgrepTextSearchEngine=w;function _(E){const d=E.split(`
`),v=d[0].trim();if(d.some(L=>L.startsWith("regex parse error")))return new C.SearchError(p(d),C.SearchErrorCode.regexParseError);const R=v.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(v,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function p(E){const d=["Regex parse error"],v=E.filter(R=>R.startsWith("PCRE2:"));if(v.length>=1){const R=v[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const L=R.split(":")[1];d.push(":"+L)}}return d.join("")}e.buildRegexParseError=p;class c extends I.EventEmitter{constructor(d,v,R){super();this.maxResults=d,this.rootFolder=v,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,v){return super.on(d,v),this}handleData(d){if(!this.isDone){const v=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(v)}}handleDecodedData(d){let v=d.indexOf(`
`);const R=this.remainder+d;if(v>=0)v+=this.remainder.length;else{this.remainder=R;return}let L=0;for(;v>=0;)this.handleLine(R.substring(L,v).trim()),L=v+1,v=R.indexOf(`
`,L);this.remainder=R.substring(L)}handleLine(d){if(!(this.isDone||!d)){let v;try{v=JSON.parse(d)}catch(R){throw new Error(`malformed line from rg: ${d}`)}if(v.type==="match"){const R=f(v.data.path),L=r.URI.file(y.join(this.rootFolder,R)),H=this.createTextSearchMatch(v.data,L);this.onResult(H),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const R=f(v.data.path),L=r.URI.file(y.join(this.rootFolder,R));this.createTextSearchContext(v.data,L).forEach(ie=>this.onResult(ie))}}}createTextSearchMatch(d,v){const R=d.line_number-1;let L=!1,H=f(d.lines);R===0&&(0,k.startsWithUTF8BOM)(H)&&(L=!0,H=(0,k.stripUTF8BOM)(H));const ie=Buffer.from(H);let j=0,B=0,$=R;d.submatches.length===0&&d.submatches.push(H.length?{start:0,end:1,match:{text:H[0]}}:{start:0,end:0,match:{text:""}});const N=(0,A.coalesce)(d.submatches.map((M,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let U=f(M.match);R===0&&F===0&&L&&(U=(0,k.stripUTF8BOM)(U),M.start=M.start<=3?0:M.start-3,M.end=M.end<=3?0:M.end-3);const O=ie.slice(j,M.start).toString().length,W=B+O,q=t(U),Q=$,he=q.numLines+Q,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+W;return j=M.end,B=ve,$=he,new g.Range(Q,W,he,ve)}));return(0,h.createTextSearchResult)(v,H,N,this.previewOptions)}createTextSearchContext(d,v){const R=f(d.lines),L=d.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((H,ie)=>({text:H,uri:v,lineNumber:L+ie}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=c;function f(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const d=/\n/g;let v=0,R=-1,L;for(;L=d.exec(E);)v++,R=L.index;const H=R>=0?E.length-R-1:E.length;return{numLines:v,lastLineLength:H}}function n(E,d){const v=["--hidden"];v.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:L}=(0,D.groupBy)(d.includes,ie=>ie.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const ie=new Set;L.forEach(j=>{ie.add(j)}),v.push("-g","!*"),ie.forEach(j=>{s(j).map(h.anchorGlob).forEach(B=>{v.push("-g",B)})})}R&&R.length&&R.forEach(ie=>{v.push("-g",ie)}),d.excludes.map(h.anchorGlob).forEach(ie=>v.push("-g",`!${ie}`)),d.maxFileSize&&v.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),d.followSymlinks&&v.push("--follow"),d.encoding&&d.encoding!=="utf8"&&v.push("--encoding",d.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,k.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),d.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),E.isRegExp&&(E.pattern=i(E.pattern),v.push("--auto-hybrid-regex"));let H;if(E.isWordMatch){const j=(0,k.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",j)}else if(E.isRegExp){let ie=o(E.pattern);ie=u(ie),v.push("--regexp",ie)}else H=E.pattern,v.push("--fixed-strings");return v.push("--no-config"),d.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),E.isMultiline&&v.push("--multiline"),d.beforeContext&&v.push("--before-context",d.beforeContext+""),d.afterContext&&v.push("--after-context",d.afterContext+""),v.push("--"),H&&v.push(H),v.push("."),v}function s(E){const d=(0,P.splitGlobAware)(E,"/");return d.map((v,R)=>d.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function i(E){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(d);)E=E.replace(d,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(v);)E=E.replace(v,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=i;const l=E=>E.type==="Assertion"&&E.kind==="lookbehind";function o(E){let d;try{d=new m.RegExpParser().parsePattern(E)}catch(j){return E}let v="",R=0;const L=(j,B,$)=>{v+=E.slice(R,j)+$,R=B},H=[];return new m.RegExpVisitor({onCharacterEnter(j){if(j.raw==="\\n"){const B=H[0];if(!B)L(j.start,j.end,"\\r?\\n");else if(!H.some(l))if(B.type==="CharacterClass"){const $=E.slice(B.start+1,j.start)+E.slice(j.end,B.end-1);L(B.start,B.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else B.type==="Quantifier"&&L(j.start,j.end,"(?:\\r?\\n)")}},onQuantifierEnter(j){H.unshift(j)},onQuantifierLeave(){H.shift()},onCharacterClassRangeEnter(j){H.unshift(j)},onCharacterClassRangeLeave(){H.shift()},onCharacterClassEnter(j){H.unshift(j)},onCharacterClassLeave(){H.shift()},onAssertionEnter(j){l(j)&&H.push(j)},onAssertionLeave(j){H[0]===j&&H.shift()}}).visit(d),v+=E.slice(R),v}e.fixRegexNewline=o;function u(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=u}),define(me[277],ge([0,1,21,130,114,11]),function(G,e,b,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,r,C,g){const m=new I.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===A.Schemas.userData){const a=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:A.Schemas.file})}),h=new T.Progress(S=>C.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:r.folder.scheme})})));return this.withToken(g,S=>m.provideTextSearchResults(k,a,h,S))}else return this.withToken(g,a=>m.provideTextSearchResults(k,r,C,a))}async withToken(k,r){const C=P(k);this.inProgress.add(C);const g=await r(C.token);return this.inProgress.delete(C),g}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=D;function P(y){const k=new b.CancellationTokenSource;return y.onCancellationRequested(()=>k.cancel()),k}}),define(me[278],ge([0,1,26,130,129]),function(G,e,b,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(y){this.query=y}search(y,k,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){r({message:m})}},g=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),b);return new Promise((m,a)=>g.search(h=>{k(h.map(D))},y).then(h=>m({limitHit:h.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=A;function D(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((y,k)=>{if(k.ranges){const r=k;return y+(Array.isArray(r.ranges)?r.ranges.length:1)}else return y+1},0)}}}),define(me[279],ge([0,1,37,292,15,19,18,3,99,8,47,2,45,31,276,278]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(b);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=p(t),i=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(l=>this.doFileSearchWithEngine(a.Engine,s,o=>i.fire(o),l)),n.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}textSearch(t){let n;const s=p(t),i=new P.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(l=>this.ripgrepTextSearch(s,o=>i.fire(o),l)),n.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,g.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,i,l=S.BATCH_SIZE){let o=0;const u=d=>{Array.isArray(d)?(o+=d.length,s(d.map(v=>this.rawMatchToSearchItem(v)))):d.relativePath?(o++,s(this.rawMatchToSearchItem(d))):s(d)};if(n.sortByScore){let d=this.trySortedSearchFromCache(n,u,i);if(!d){const v=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(v);d=this.doSortedSearch(R,n,s,u,i)}return new Promise((v,R)=>{d.then(([L,H])=>{const ie=H.map(j=>this.rawMatchToSearchItem(j));this.sendProgress(ie,s,l),v(L)},R)})}const E=new t(n);return this.doSearch(E,u,l,i).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:"searchProcess",fromCache:!1,resultCount:o,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,i,l){const o=new P.Emitter;let u=(0,A.createCancelablePromise)(d=>{let v=[];const R=L=>{Array.isArray(L)?v=L:(i(L),o.fire(L))};return this.doSearch(t,R,-1,d).then(L=>[L,v])}),E;if(n.cacheKey){E=this.getOrCreateCache(n.cacheKey);const d={promise:u,event:o.event,resolved:!1};E.resultsToSearchCache[n.filePattern||""]=d,u.then(()=>{d.resolved=!0},v=>{delete E.resultsToSearchCache[n.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([d,v])=>{const R=E?E.scorerCache:Object.create(null),L=(typeof n.maxResults!="number"||n.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(n,v,R,l).then(H=>{const ie=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:ie,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:H.length},limitHit:d.limitHit||typeof n.maxResults=="number"&&v.length>n.maxResults},H]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,s){const i=t.cacheKey&&this.caches[t.cacheKey];if(!!i){const l=this.getResultsFromCache(i,t.filePattern||"",n,s);if(l)return l.then(([o,u,E])=>{const d=r.StopWatch.create(!1);return this.sortResults(t,u,i.scorerCache,s).then(v=>{const R=d.elapsed(),L={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:u.length,sortingTime:R};return[{type:"success",limitHit:o.limitHit||typeof t.maxResults=="number"&&u.length>t.maxResults,stats:L},v]})})}}sortResults(t,n,s,i){const l=(0,y.prepareQuery)(t.filePattern||""),o=(E,d)=>(0,y.compareItemsByFuzzyScore)(E,d,l,!0,_,s),u=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,o,u,1e4,i)}sendProgress(t,n,s){if(s&&s>0)for(let i=0;i<t.length;i+=s)n(t.slice(i,i+s));else n(t)}getResultsFromCache(t,n,s,i){const l=r.StopWatch.create(!1),o=n.indexOf(k.sep)>=0;let u;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(o&&R.indexOf(k.sep)<0&&R!=="")continue;const L=t.resultsToSearchCache[R];u={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!u)return null;const E=l.elapsed(),d=r.StopWatch.create(!1),v=u.event(s);return i&&i.onCancellationRequested(()=>{v.dispose()}),u.promise.then(([R,L])=>{if(i&&i.isCancellationRequested)throw(0,D.canceled)();const H=[],ie=(0,y.prepareQuery)(n).normalizedLowercase;for(const j of L)!(0,m.isFilePatternMatch)(j,ie)||H.push(j);return[R,H,{cacheWasResolved:u.resolved,cacheLookupTime:E,cacheFilterTime:d.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,n,s,i){return new Promise((l,o)=>{let u=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(s?(u.push(E),s>0&&u.length>=s&&(n(u),u=[])):n(E))},E=>{n(E)},(E,d)=>{u.length&&n(u),E?o(E):l(d)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(f){return(0,k.basename)(f.relativePath)}getItemDescription(f){return(0,k.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function p(f){return Object.assign(Object.assign({},f),{folderQueries:f.folderQueries&&f.folderQueries.map(c),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>C.URI.revive(t))})}function c(f){return Object.assign(Object.assign({},f),{folder:C.URI.revive(f.folder)})}}),define(me[280],ge([0,1,6,2,26,13,31,279,277,93,14,62,27,69,11,129]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends m.ExtHostSearch{constructor(_,p,c,f){super(_,c,f);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new k.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new y.RipgrepSearchProvider(t)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new k.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new y.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(a.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(_,p){const c=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(_)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(_,p,c,f){const t=(0,m.reviveQuery)(c);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,p,t,f):super.$provideFileSearchResults(_,p,c,f)}doInternalFileSearch(_,p,c,f){const t=n=>{if((0,D.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(_,p,n.map(s=>I.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,t,f)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,p){return new h.NativeTextSearchManager(_,p)}};S=je([Be(0,r.IExtHostRpcService),Be(1,g.IExtHostInitDataService),Be(2,C.IURITransformerService),Be(3,A.ILogService)],S),e.NativeExtHostSearch=S}),define(me[131],ge([0,1,293,121,294,3,104,8,48,28,6,22,105,18,9]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(u){this.socket=u,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const E=d=>u(C.VSBuffer.wrap(d));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(u){return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,m.onUnexpectedError)(E)}}end(){this.socket.end()}drain(){return new Promise((u,E)=>{if(this.socket.bufferSize===0){u();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),u()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=h;var S;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(w||(w={}));class _ extends r.Disposable{constructor(u,E,d,v){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=v,E?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),d&&(this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new g.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(C.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,E){let d=2;u.byteLength<126?d+=0:u.byteLength<2**16?d+=2:d+=8;const v=C.VSBuffer.alloc(d);if(E?v.writeUInt8(194,0):v.writeUInt8(130,0),u.byteLength<126)v.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){v.writeUInt8(126,1);let R=1;v.writeUInt8(u.byteLength>>>8&255,++R),v.writeUInt8(u.byteLength>>>0&255,++R)}else{v.writeUInt8(127,1);let R=1;v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(u.byteLength>>>24&255,++R),v.writeUInt8(u.byteLength>>>16&255,++R),v.writeUInt8(u.byteLength>>>8&255,++R),v.writeUInt8(u.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=v.byteLength+u.byteLength,this.socket.write(C.VSBuffer.concat([v,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),v=(E.readUInt8(0)&128)>>>7,R=E.readUInt8(1),L=(R&128)>>>7,H=R&127;this._state.state=2,this._state.readLen=2+(L?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),d=E.readUInt8(1),v=(d&128)>>>7;let R=d&127,L=1;R===126?R=E.readUInt8(++L)*2**8+E.readUInt8(++L):R===127&&(R=E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*0+E.readUInt8(++L)*2**24+E.readUInt8(++L)*2**16+E.readUInt8(++L)*2**8+E.readUInt8(++L));let H=0;v&&(H=E.readUInt8(++L)*2**24+E.readUInt8(++L)*2**16+E.readUInt8(++L)*2**8+E.readUInt8(++L)),this._state.state=3,this._state.readLen=R,this._state.mask=H}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);p(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const d=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=d.length,this._onData.fire(C.VSBuffer.wrap(d))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function p(o,u){if(u!==0){let E=o.byteLength>>>2;for(let ie=0;ie<E;ie++){const j=o.readUInt32BE(ie*4);o.writeUInt32BE(j^u,ie*4)}let d=E*4,v=o.byteLength-d;const R=u>>>24&255,L=u>>>16&255,H=u>>>8&255;v>=1&&o.writeUInt8(o.readUInt8(d)^R,d),v>=2&&o.writeUInt8(o.readUInt8(d+1)^L,d+1),v>=3&&o.writeUInt8(o.readUInt8(d+2)^H,d+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function f(){const o=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,P.join)((0,y.tmpdir)(),`vscode-ipc-${o}.sock`),n(u),u}e.createRandomIPCHandle=f;function t(o,u,E){const d=(0,b.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${E}-${u}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${E}-${u}.sock`):v=(0,P.join)(o,`${E}-${u}.sock`),n(v),v}e.createStaticIPCHandle=t;function n(o){const u=c[a.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class s extends D.IPCServer{constructor(u){super(s.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const E=A.Event.fromNodeEventEmitter(u,"connection");return A.Event.map(E,d=>({protocol:new g.Protocol(new h(d)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(o){return new Promise((u,E)=>{const d=(0,I.createServer)();d.on("error",E),d.listen(o,()=>{d.removeListener("error",E),u(new s(d))})})}e.serve=i;function l(o,u){return new Promise((E,d)=>{const v=(0,I.createConnection)(o,()=>{v.removeListener("error",d),E(g.Client.fromSocket(new h(v),u))});v.once("error",d)})}e.connect=l}),define(me[281],ge([0,1,131,273,37,51,2,117,13]),function(G,e,b,I,T,A,D,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(g,m,a){this._commands=g,this.logService=m,this._ipcHandlePath=a,this._server=I.createServer((h,S)=>this.onRequest(h,S)),this.setup().catch(h=>(m.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch(g){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,m){const a=[];g.setEncoding("utf8"),g.on("data",h=>a.push(h)),g.on("end",()=>{const h=JSON.parse(a.join(""));switch(h.type){case"open":this.open(h,m);break;case"openExternal":this.openExternal(h,m);break;case"status":this.getStatus(h,m);break;case"extensionManagement":this.manageExtensions(h,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${h.type}`,S=>{S&&this.logService.error(S)}),m.end();break}})}open(g,m){let{fileURIs:a,folderURIs:h,forceNewWindow:S,diffMode:w,addMode:_,forceReuseWindow:p,gotoLineMode:c,waitMarkerFilePath:f}=g;const t=[];if(Array.isArray(h))for(const n of h)try{t.push({folderUri:D.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,P.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:D.URI.parse(n)}):t.push({fileUri:D.URI.parse(n)})}catch(s){}if(t.length){const n=f?D.URI.file(f):void 0,i={forceNewWindow:S,diffMode:w,addMode:_,gotoLineMode:c,forceReuseWindow:p,preferNewWindow:!p&&!n&&!_,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(g,m){for(const a of g.uris){const h=D.URI.parse(a),S=h.scheme==="file"?h:a;await this._commands.executeCommand("_remoteCLI.openExternal",S)}m.writeHead(200),m.end()}async manageExtensions(g,m){try{const a=w=>w==null?void 0:w.map(_=>/\.vsix$/i.test(_)?D.URI.parse(_):_),h={list:g.list,install:a(g.install),uninstall:a(g.uninstall),force:g.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);m.writeHead(200),m.write(S)}catch(a){m.writeHead(500),m.write(String(a),h=>{h&&this.logService.error(h)})}m.end()}async getStatus(g,m){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(a),m.end()}catch(a){m.writeHead(500),m.write(String(a),h=>{h&&this.logService.error(h)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let r=class extends k{constructor(g,m){super(g,m,(0,b.createRandomIPCHandle)())}};r=je([Be(0,A.IExtHostCommands),Be(1,y.ILogService)],r),e.CLIServer=r}),define(me[282],ge([0,1,68,269,263,5,272,42,254,2,11,7,281,102]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends T.RequireInterceptor{_installInterceptor(){const w=this,_=G.__$__nodeRequire("module"),p=_._load;_._load=function(f,t,n){for(let s of w._alternatives){let i=s(f);if(i){f=i;break}}return w._factories.has(f)?w._factories.get(f).load(f,k.URI.file((0,m.realpathSync)(t.filename)),s=>p.apply(this,[s,t,n])):p.apply(this,arguments)}}}class h extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(y.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(g.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),b.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,D.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const c=process.send,f=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?c.apply(process,t):(f.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,_,p){if(_.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let c=null;p.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{w&&b.mark(`code/extHost/willLoadExtensionCode/${w.value}`),c=G.__$__nodeRequire(_.fsPath)}catch(f){return Promise.reject(f)}finally{w&&b.mark(`code/extHost/didLoadExtensionCode/${w.value}`),p.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const _ in w){const p=w[_];p===null?delete process.env[_]:process.env[_]=p}}}e.ExtHostExtensionService=h}),define(me[283],ge([0,1,79,255,266,265,264,280,282,226,256,46,42,65,69,67,34,50,13]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h,S,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(g.IExtHostExtensionService,y.ExtHostExtensionService),(0,b.registerSingleton)(_.ILogService,k.ExtHostLogService),(0,b.registerSingleton)(C.IExtHostDebugService,D.ExtHostDebugService),(0,b.registerSingleton)(m.IExtHostOutputService,I.ExtHostOutputService2),(0,b.registerSingleton)(a.IExtHostSearch,P.NativeExtHostSearch),(0,b.registerSingleton)(h.IExtHostTask,A.ExtHostTask),(0,b.registerSingleton)(S.IExtHostTerminalService,T.ExtHostTerminalService),(0,b.registerSingleton)(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(me[284],ge([0,1,121,295,68,18,105,131,187,224,267,22,100,26,102,19,270,283]),function(G,e,b,I,T,A,D,P,y,k,r,C,g,m,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const S=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=G.__$__nodeRequire("module"),i=s._load;s._load=function(l){if(l==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const w=process.exit.bind(process);function _(s){process.exit=function(i){if(s)w(i);else{const l=new Error("An extension called process.exit() and this was prevented.");console.warn(l.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let p=function(s){w()};function c(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,i)=>{let l=null,o=setTimeout(()=>{i(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const u=108e5,E=3e5,d=new h.RunOnceScheduler(()=>p("renderer disconnected for too long (1)"),u),v=new h.RunOnceScheduler(()=>p("renderer disconnected for too long (2)"),E);process.on("message",(L,H)=>{if(L&&L.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ie=C.VSBuffer.wrap(Buffer.from(L.initialDataChunk,"base64"));let j;if(L.skipWebSocketFrames)j=new P.NodeSocket(H);else{const B=C.VSBuffer.wrap(Buffer.from(L.inflateBytes,"base64"));j=new P.WebSocketNodeSocket(new P.NodeSocket(H),L.permessageDeflate,B,!1)}l?(d.cancel(),v.cancel(),l.beginAcceptReconnection(j,ie),l.endAcceptReconnection()):(clearTimeout(o),l=new D.PersistentProtocol(j,ie),l.onDidDispose(()=>p("renderer disconnected")),s(l),l.onSocketClose(()=>{d.schedule()}))}if(L&&L.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;d.isScheduled()&&v.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,l)=>{const o=b.createConnection(s,()=>{o.removeListener("error",l),i(new D.PersistentProtocol(new P.NodeSocket(o)))});o.once("error",l)})}}async function f(){const s=await c();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(i=>{(0,k.isMessageOfType)(i,2)?(this._terminating=!0,p("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||s.send(i)}drain(){return s.drain()}}}function t(s){return new Promise(i=>{const l=s.onMessage(o=>{l.dispose();const u=JSON.parse(o.toString()),E=u.commit,d=y.default.commit;E&&d&&E!==d&&w(55);const v=[];process.on("unhandledRejection",(H,ie)=>{v.push(ie),setTimeout(()=>{const j=v.indexOf(ie);j>=0&&ie.catch(B=>{v.splice(j,1),console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),(0,A.onUnexpectedError)(H)})},1e3)}),process.on("rejectionHandled",H=>{const ie=v.indexOf(H);ie>=0&&v.splice(ie,1)}),process.on("uncaughtException",function(H){(0,A.onUnexpectedError)(H)});let R=0;setInterval(function(){try{process.kill(u.parentPid,0),R=0}catch(H){H&&H.code==="EPERM"?(R++,R>=3&&p(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${H.message} (code: ${H.code}) (errno: ${H.errno})`)):p(`parent process ${u.parentPid} does not exist anymore: ${H.message} (code: ${H.code}) (errno: ${H.errno})`)}},1e3);let L;try{L=G.__$__nodeRequire("native-watchdog"),L.start(u.parentPid)}catch(H){(0,A.onUnexpectedError)(H)}s.send((0,k.createMessageOfType)(0)),i({protocol:s,initData:u})});s.send((0,k.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const s=await f();T.mark("code/extHost/didConnectToRenderer");const i=await t(s);T.mark("code/extHost/didWaitForInitData");const{initData:l}=i;_(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const o=new class{exit(v){w(v)}exists(v){return(0,m.exists)(v)}realpath(v){return(0,a.realpath)(v)}};let u=null;if(l.remote.authority&&S.uriTransformerPath)try{const v=G.__$__nodeRequire(S.uriTransformerPath)(l.remote.authority);u=new g.URITransformer(v)}catch(d){console.error(d)}const E=new r.ExtensionHostMain(i.protocol,l,o,u);p=d=>E.terminate(d)}e.startExtensionHostProcess=n}),define(me[296],ge([0,1,284]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4816cfd1f4161a3bb272354d181a9947760ee26/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
