/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/shared/webview","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(Y){for(var e=[],_=0,k=Y.length;_<k;_++)e[_]=be[Y[_]];return e};define(be[42],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=_}),define(be[52],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function k(i){const I=[];for(let d in i)_.call(i,d)&&I.push(i[d]);return I}e.values=k;function A(i,I){for(let d in i)if(_.call(i,d)&&I({key:d,value:i[d]},function(){delete i[d]})===!1)return}e.forEach=A;function T(i,I){const d=Object.create(null);for(const f of i){const r=I(f);let o=d[r];o||(o=d[r]=[]),o.push(f)}return d}e.groupBy=T;function S(i){const I=Object.create(null);return i&&i.forEach((d,f)=>{I[f]=d}),I}e.fromMap=S;function D(i,I){const d=[],f=[];for(let r of i)I.has(r)||d.push(r);for(let r of I)i.has(r)||f.push(r);return{removed:d,added:f}}e.diffSets=D;function y(i,I){const d=[],f=[];for(let[r,o]of i)I.has(r)||d.push(o);for(let[r,o]of I)i.has(r)||f.push(o);return{removed:d,added:f}}e.diffMaps=y;class C{constructor(){this.map=new Map}add(I,d){let f=this.map.get(I);f||(f=new Set,this.map.set(I,f)),f.add(d)}delete(I,d){const f=this.map.get(I);!f||(f.delete(d),f.size===0&&this.map.delete(I))}forEach(I,d){const f=this.map.get(I);!f||f.forEach(d)}}e.SetMap=C}),define(be[53],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(y){return(C,i,I)=>{let d=null,f=null;if(typeof I.value=="function"?(d="value",f=I.value):typeof I.get=="function"&&(d="get",f=I.get),!f)throw new Error("not supported");I[d]=y(f,i)}}e.createDecorator=_;let k=0;function A(){const y=`$memoize${k++}`;let C;const i=function(d,f,r){let o=null,v=null;if(typeof r.value=="function"?(o="value",v=r.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(o="get",v=r.get),!v)throw new Error("not supported");const m=`${y}:${f}`;r[o]=function(...E){return C=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:v.apply(this,E)}),this[m]}};return i.clear=()=>{typeof C!="undefined"&&Object.getOwnPropertyNames(C).forEach(I=>{I.indexOf(y)===0&&delete C[I]})},i}e.createMemoizer=A;function T(y,C,i){return A()(y,C,i)}e.memoize=T;function S(y,C,i){return _((I,d)=>{const f=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...o){this[r]||(this[r]=i?i():void 0),clearTimeout(this[f]),C&&(this[r]=C(this[r],...o),o=[this[r]]),this[f]=setTimeout(()=>{I.apply(this,o),this[r]=i?i():void 0},y)}})}e.debounce=S;function D(y,C,i){return _((I,d)=>{const f=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,o=`$throttle$lastRun$${d}`,v=`$throttle$pending$${d}`;return function(...m){if(this[r]||(this[r]=i?i():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),C&&(this[r]=C(this[r],...m)),!this[v]){const E=this[o]+y;E<=Date.now()?(this[o]=Date.now(),I.apply(this,[this[r]]),this[r]=i?i():void 0):(this[v]=!0,this[f]=setTimeout(()=>{this[v]=!1,this[o]=Date.now(),I.apply(this,[this[r]]),this[r]=i?i():void 0},E-Date.now()))}}})}e.throttle=D}),define(be[11],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function k(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=k;function A(b){y(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=A;function T(b){y(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=T;function S(b){if(b instanceof Error){let{name:t,message:n}=b;const a=b.stacktrace||b.stack;return{$isError:!0,name:t,message:n,stack:a}}return b}e.transformErrorForSerialization=S;const D="Canceled";function y(b){return b instanceof Error&&b.name===D&&b.message===D}e.isPromiseCanceledError=y;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function i(){const b=new Error(D);return b.name=b.message,b}e.canceled=i;function I(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=I;function d(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=d;function f(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function r(b){const t=new Error(`${b} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function o(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=o;class v extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=v;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function p(b){const t=b;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function u(b,t=Object.create(null)){const n=new Error(b);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(be[12],we([0,1,11]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(O,F=0){return O[O.length-(1+F)]}e.tail=k;function A(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}e.tail2=A;function T(O,F,N=(B,U)=>B===U){if(O===F)return!0;if(!O||!F||O.length!==F.length)return!1;for(let B=0,U=O.length;B<U;B++)if(!N(O[B],F[B]))return!1;return!0}e.equals=T;function S(O,F,N){let B=0,U=O.length-1;for(;B<=U;){const Q=(B+U)/2|0,Z=N(O[Q],F);if(Z<0)B=Q+1;else if(Z>0)U=Q-1;else return Q}return-(B+1)}e.binarySearch=S;function D(O,F){let N=0,B=O.length;if(B===0)return 0;for(;N<B;){const U=Math.floor((N+B)/2);F(O[U])?B=U:N=U+1}return N}e.findFirstInSorted=D;function y(O,F,N){if(O=O|0,O>=F.length)throw new TypeError("invalid index");let B=F[Math.floor(F.length*Math.random())],U=[],Q=[],Z=[];for(let ne of F){const pe=N(ne,B);pe<0?U.push(ne):pe>0?Q.push(ne):Z.push(ne)}return O<U.length?y(O,U,N):O<U.length+Z.length?Z[0]:y(O-(U.length+Z.length),Q,N)}e.quickSelect=y;function C(O,F){const N=[];let B;for(const U of O.slice(0).sort(F))!B||F(B[0],U)!==0?(B=[U],N.push(B)):B.push(U);return N}e.groupBy=C;function i(O,F,N){const B=[];function U(ne,pe,Pe){if(!(pe===0&&Pe.length===0)){const Oe=B[B.length-1];Oe&&Oe.start+Oe.deleteCount===ne?(Oe.deleteCount+=pe,Oe.toInsert.push(...Pe)):B.push({start:ne,deleteCount:pe,toInsert:Pe})}}let Q=0,Z=0;for(;;){if(Q===O.length){U(Q,0,F.slice(Z));break}if(Z===F.length){U(Q,O.length-Q,[]);break}const ne=O[Q],pe=F[Z],Pe=N(ne,pe);Pe===0?(Q+=1,Z+=1):Pe<0?(U(Q,1,[]),Q+=1):Pe>0&&(U(Q,0,[pe]),Z+=1)}return B}e.sortedDiff=i;function I(O,F,N){const B=i(O,F,N),U=[],Q=[];for(const Z of B)U.push(...O.slice(Z.start,Z.start+Z.deleteCount)),Q.push(...Z.toInsert);return{removed:U,added:Q}}e.delta=I;function d(O,F,N){if(N===0)return[];const B=O.slice(0,N).sort(F);return r(O,F,B,N,O.length),B}e.top=d;function f(O,F,N,B,U){return N===0?Promise.resolve([]):new Promise((Q,Z)=>{(async()=>{const ne=O.length,pe=O.slice(0,N).sort(F);for(let Pe=N,Oe=Math.min(N+B,ne);Pe<ne;Pe=Oe,Oe=Math.min(Oe+B,ne)){if(Pe>N&&await new Promise(Te=>setTimeout(Te)),U&&U.isCancellationRequested)throw(0,_.canceled)();r(O,F,pe,Pe,Oe)}return pe})().then(Q,Z)})}e.topAsync=f;function r(O,F,N,B,U){for(const Q=N.length;B<U;B++){const Z=O[B];if(F(Z,N[Q-1])<0){N.pop();const ne=D(N,pe=>F(Z,pe)<0);N.splice(ne,0,Z)}}}function o(O){return O.filter(F=>!!F)}e.coalesce=o;function v(O){let F=0;for(let N=0;N<O.length;N++)O[N]&&(O[F]=O[N],F+=1);O.length=F}e.coalesceInPlace=v;function m(O,F,N){O.splice(N,0,O.splice(F,1)[0])}e.move=m;function E(O){return!Array.isArray(O)||O.length===0}e.isFalsyOrEmpty=E;function p(O){return Array.isArray(O)&&O.length>0}e.isNonEmptyArray=p;function u(O,F){if(!F)return O.filter((B,U)=>O.indexOf(B)===U);const N=Object.create(null);return O.filter(B=>{const U=F(B);return N[U]?!1:(N[U]=!0,!0)})}e.distinct=u;function b(O){const F=new Set;return O.filter(N=>F.has(N)?!1:(F.add(N),!0))}e.distinctES6=b;function t(O){const F=Object.create(null);return N=>{const B=O(N);return F[B]?!1:(F[B]=!0,!0)}}e.uniqueFilter=t;function n(O,F){for(let N=O.length-1;N>=0;N--){const B=O[N];if(F(B))return N}return-1}e.lastIndex=n;function a(O,F){return O.length>0?O[0]:F}e.firstOrDefault=a;function s(O,F,N=(B,U)=>B===U){let B=0;for(let U=0,Q=Math.min(O.length,F.length);U<Q&&N(O[U],F[U]);U++)B++;return B}e.commonPrefixLength=s;function c(O){return[].concat(...O)}e.flatten=c;function l(O,F){let N=typeof F=="number"?O:0;typeof F=="number"?N=O:(N=0,F=O);const B=[];if(N<=F)for(let U=N;U<F;U++)B.push(U);else for(let U=N;U>F;U--)B.push(U);return B}e.range=l;function h(O,F,N){return O.reduce((B,U)=>(B[F(U)]=N?N(U):U,B),Object.create(null))}e.index=h;function P(O,F){return O.push(F),()=>g(O,F)}e.insert=P;function g(O,F){const N=O.indexOf(F);if(N>-1)return O.splice(N,1),F}e.remove=g;function w(O,F,N){const B=O.slice(0,F),U=O.slice(F);return B.concat(N,U)}e.arrayInsert=w;function R(O,F){let N;if(typeof F=="number"){let B=F;N=()=>{const U=Math.sin(B++)*179426549;return U-Math.floor(U)}}else N=Math.random;for(let B=O.length-1;B>0;B-=1){const U=Math.floor(N()*(B+1)),Q=O[B];O[B]=O[U],O[U]=Q}}e.shuffle=R;function L(O,F){const N=O.indexOf(F);N>-1&&(O.splice(N,1),O.unshift(F))}e.pushToStart=L;function V(O,F){const N=O.indexOf(F);N>-1&&(O.splice(N,1),O.push(F))}e.pushToEnd=V;function he(O,F){return Array.isArray(O)?O.map(F):F(O)}e.mapArrayOrNot=he;function z(O){return Array.isArray(O)?O:[O]}e.asArray=z;function W(O){return O[Math.floor(Math.random()*O.length)]}e.getRandomElement=W;function J(O,F){for(const N of O){const B=F(N);if(B!==void 0)return B}}e.mapFind=J}),define(be[54],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(k){const A=this;let T=!1,S;return function(){return T||(T=!0,S=k.apply(A,arguments)),S}}e.once=_}),define(be[55],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(be[43],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(k){function A(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}k.is=A;const T=Object.freeze([]);function S(){return T}k.empty=S;function*D(b){yield b}k.single=D;function y(b){return b||T}k.from=y;function C(b){return!b||b[Symbol.iterator]().next().done===!0}k.isEmpty=C;function i(b){return b[Symbol.iterator]().next().value}k.first=i;function I(b,t){for(const n of b)if(t(n))return!0;return!1}k.some=I;function d(b,t){for(const n of b)if(t(n))return n}k.find=d;function*f(b,t){for(const n of b)t(n)&&(yield n)}k.filter=f;function*r(b,t){for(const n of b)yield t(n)}k.map=r;function*o(...b){for(const t of b)for(const n of t)yield n}k.concat=o;function*v(b){for(const t of b)for(const n of t)yield n}k.concatNested=v;function m(b,t,n){let a=n;for(const s of b)a=t(a,s);return a}k.reduce=m;function*E(b,t,n=b.length){for(t<0&&(t+=b.length),n<0?n+=b.length:n>b.length&&(n=b.length);t<n;t++)yield b[t]}k.slice=E;function p(b,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,b];const a=b[Symbol.iterator]();for(let s=0;s<t;s++){const c=a.next();if(c.done)return[n,k.empty()];n.push(c.value)}return[n,{[Symbol.iterator](){return a}}]}k.consume=p;function u(b,t,n=(a,s)=>a===s){const a=b[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const c=a.next(),l=s.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!n(c.value,l.value))return!1}}k.equals=u})(_=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function S(t,n=!1){let a=0,s=t.length,c="",l=0,h=16,P=0;function g(W){let J=0,O=0;for(;J<W;){const F=t.charCodeAt(a);if(F>=48&&F<=57)O=O*16+F-48;else if(F>=65&&F<=70)O=O*16+F-65+10;else if(F>=97&&F<=102)O=O*16+F-97+10;else break;a++,J++}return J<W&&(O=-1),O}function w(W){a=W,c="",l=0,h=16,P=0}function R(){const W=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&C(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&C(t.charCodeAt(a)))for(a++;a<t.length&&C(t.charCodeAt(a));)a++;else return P=3,t.substring(W,a);let J=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&C(t.charCodeAt(a))){for(a++;a<t.length&&C(t.charCodeAt(a));)a++;J=a}else P=3;return t.substring(W,J)}function L(){let W="",J=a;for(;;){if(a>=s){W+=t.substring(J,a),P=2;break}const O=t.charCodeAt(a);if(O===34){W+=t.substring(J,a),a++;break}if(O===92){if(W+=t.substring(J,a),a++,a>=s){P=2;break}switch(t.charCodeAt(a++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const N=g(4);N>=0?W+=String.fromCharCode(N):P=4;break;default:P=5}J=a;continue}if(O>=0&&O<=31)if(y(O)){W+=t.substring(J,a),P=2;break}else P=6;a++}return W}function V(){if(c="",P=0,l=a,a>=s)return l=s,h=17;let W=t.charCodeAt(a);if(D(W)){do a++,c+=String.fromCharCode(W),W=t.charCodeAt(a);while(D(W));return h=15}if(y(W))return a++,c+=String.fromCharCode(W),W===13&&t.charCodeAt(a)===10&&(a++,c+=`
`),h=14;switch(W){case 123:return a++,h=1;case 125:return a++,h=2;case 91:return a++,h=3;case 93:return a++,h=4;case 58:return a++,h=6;case 44:return a++,h=5;case 34:return a++,c=L(),h=10;case 47:const J=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<s&&!y(t.charCodeAt(a));)a++;return c=t.substring(J,a),h=12}if(t.charCodeAt(a+1)===42){a+=2;const O=s-1;let F=!1;for(;a<O;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,F=!0;break}a++}return F||(a++,P=1),c=t.substring(J,a),h=13}return c+=String.fromCharCode(W),a++,h=16;case 45:if(c+=String.fromCharCode(W),a++,a===s||!C(t.charCodeAt(a)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=R(),h=11;default:for(;a<s&&he(W);)a++,W=t.charCodeAt(a);if(l!==a){switch(c=t.substring(l,a),c){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return c+=String.fromCharCode(W),a++,h=16}}function he(W){if(D(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let W;do W=V();while(W>=12&&W<=15);return W}return{setPosition:w,getPosition:()=>a,scan:n?z:V,getToken:()=>h,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>P}}e.createScanner=S;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const a=[],s=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function P(g,w,R,L){l.value=g,l.offset=w,l.length=R,l.type=L,l.colonOffset=void 0,c=l}try{p(t,{onObjectBegin:(g,w)=>{if(n<=g)throw s;c=void 0,h=n>g,a.push("")},onObjectProperty:(g,w,R)=>{if(n<w||(P(g,w,R,"property"),a[a.length-1]=g,n<=w+R))throw s},onObjectEnd:(g,w)=>{if(n<=g)throw s;c=void 0,a.pop()},onArrayBegin:(g,w)=>{if(n<=g)throw s;c=void 0,a.push(0)},onArrayEnd:(g,w)=>{if(n<=g)throw s;c=void 0,a.pop()},onLiteralValue:(g,w,R)=>{if(n<w||(P(g,w,R,b(g)),n<=w+R))throw s},onSeparator:(g,w,R)=>{if(n<=w)throw s;if(g===":"&&c&&c.type==="property")c.colonOffset=w,h=!1,c=void 0;else if(g===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(h=!0,a[a.length-1]=""),c=void 0}}})}catch(g){if(g!==s)throw g}return{path:a,previousNode:c,isAtPropertyKey:h,matches:g=>{let w=0;for(let R=0;w<g.length&&R<a.length;R++)if(g[w]===a[R]||g[w]==="*")w++;else if(g[w]!=="**")return!1;return w===g.length}}}e.getLocation=I;function d(t,n=[],a=T.DEFAULT){let s=null,c=[];const l=[];function h(g){Array.isArray(c)?c.push(g):s!==null&&(c[s]=g)}return p(t,{onObjectBegin:()=>{const g={};h(g),l.push(c),c=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const g=[];h(g),l.push(c),c=g,s=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:h,onError:(g,w,R)=>{n.push({error:g,offset:w,length:R})}},a),c[0]}e.parse=d;function f(t,n=[],a=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(g){s.type==="property"&&(s.length=g-s.offset,s=s.parent)}function l(g){return s.children.push(g),g}p(t,{onObjectBegin:g=>{s=l({type:"object",offset:g,length:-1,parent:s,children:[]})},onObjectProperty:(g,w,R)=>{s=l({type:"property",offset:w,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:g,offset:w,length:R,parent:s})},onObjectEnd:(g,w)=>{s.length=g+w-s.offset,s=s.parent,c(g+w)},onArrayBegin:(g,w)=>{s=l({type:"array",offset:g,length:-1,parent:s,children:[]})},onArrayEnd:(g,w)=>{s.length=g+w-s.offset,s=s.parent,c(g+w)},onLiteralValue:(g,w,R)=>{l({type:b(g),offset:w,length:R,parent:s,value:g}),c(w+R)},onSeparator:(g,w,R)=>{s.type==="property"&&(g===":"?s.colonOffset=w:g===","&&c(w))},onError:(g,w,R)=>{n.push({error:g,offset:w,length:R})}},a);const P=s.children[0];return P&&delete P.parent,P}e.parseTree=f;function r(t,n){if(!!t){let a=t;for(let s of n)if(typeof s=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===s){a=l.children[1],c=!0;break}if(!c)return}else{const c=s;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}}e.findNodeAtLocation=r;function o(t){if(!t.parent||!t.parent.children)return[];const n=o(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;n.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&n.push(a)}return n}e.getNodePath=o;function v(t){switch(t.type){case"array":return t.children.map(v);case"object":const n=Object.create(null);for(let a of t.children){const s=a.children[1];s&&(n[a.children[0].value]=v(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=v;function m(t,n,a=!1){return n>=t.offset&&n<t.offset+t.length||a&&n===t.offset+t.length}e.contains=m;function E(t,n,a=!1){if(m(t,n,a)){const s=t.children;if(Array.isArray(s))for(let c=0;c<s.length&&s[c].offset<=n;c++){const l=E(s[c],n,a);if(l)return l}return t}}e.findNodeAtOffset=E;function p(t,n,a=T.DEFAULT){const s=S(t,!1);function c(pe){return pe?()=>pe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(pe){return pe?Pe=>pe(Pe,s.getTokenOffset(),s.getTokenLength()):()=>!0}const h=c(n.onObjectBegin),P=l(n.onObjectProperty),g=c(n.onObjectEnd),w=c(n.onArrayBegin),R=c(n.onArrayEnd),L=l(n.onLiteralValue),V=l(n.onSeparator),he=c(n.onComment),z=l(n.onError),W=a&&a.disallowComments,J=a&&a.allowTrailingComma;function O(){for(;;){const pe=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:W||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(pe){case 12:case 13:W?F(10):he();break;case 16:F(1);break;case 15:case 14:break;default:return pe}}}function F(pe,Pe=[],Oe=[]){if(z(pe),Pe.length+Oe.length>0){let Te=s.getToken();for(;Te!==17;){if(Pe.indexOf(Te)!==-1){O();break}else if(Oe.indexOf(Te)!==-1)break;Te=O()}}}function N(pe){const Pe=s.getTokenValue();return pe?L(Pe):P(Pe),O(),!0}function B(){switch(s.getToken()){case 11:let pe=0;try{pe=JSON.parse(s.getTokenValue()),typeof pe!="number"&&(F(2),pe=0)}catch(Pe){F(2)}L(pe);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return O(),!0}function U(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(N(!1),s.getToken()===6?(V(":"),O(),ne()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function Q(){h(),O();let pe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(pe||F(4,[],[]),V(","),O(),s.getToken()===2&&J)break}else pe&&F(6,[],[]);U()||F(4,[],[2,5]),pe=!0}return g(),s.getToken()!==2?F(7,[2],[]):O(),!0}function Z(){w(),O();let pe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(pe||F(4,[],[]),V(","),O(),s.getToken()===4&&J)break}else pe&&F(6,[],[]);ne()||F(4,[],[4,5]),pe=!0}return R(),s.getToken()!==4?F(8,[4],[]):O(),!0}function ne(){switch(s.getToken()){case 3:return Z();case 1:return Q();case 10:return N(!0);default:return B()}}return O(),s.getToken()===17?a.allowEmptyContent?!0:(F(4,[],[]),!1):ne()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=p;function u(t,n){let a=S(t),s=[],c,l=0,h;do switch(h=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:l!==h&&s.push(t.substring(l,h)),n!==void 0&&s.push(a.getTokenValue().replace(/[^\r\n]/g,n)),l=a.getPosition();break}while(c!==17);return s.join("")}e.stripComments=u;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(be[105],we([0,1,44]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(y,C,i){let I,d,f,r,o;if(C){for(r=C.offset,o=r+C.length,f=r;f>0&&!D(y,f-1);)f--;let l=o;for(;l<y.length&&!D(y,l);)l++;d=y.substring(f,l),I=T(d,i)}else d=y,I=0,f=0,r=0,o=y.length;const v=S(i,y);let m=!1,E=0,p;i.insertSpaces?p=A(" ",i.tabSize||4):p="	";const u=(0,_.createScanner)(d,!1);let b=!1;function t(){return v+A(p,I+E)}function n(){let l=u.scan();for(m=!1;l===15||l===14;)m=m||l===14,l=u.scan();return b=l===16||u.getTokenError()!==0,l}const a=[];function s(l,h,P){!b&&h<o&&P>r&&y.substring(h,P)!==l&&a.push({offset:h,length:P-h,content:l})}let c=n();if(c!==17){const l=u.getTokenOffset()+f,h=A(p,I);s(h,f,l)}for(;c!==17;){let l=u.getTokenOffset()+u.getTokenLength()+f,h=n(),P="";for(;!m&&(h===12||h===13);){const w=u.getTokenOffset()+f;s(" ",l,w),l=u.getTokenOffset()+u.getTokenLength()+f,P=h===12?t():"",h=n()}if(h===2)c!==1&&(E--,P=t());else if(h===4)c!==3&&(E--,P=t());else{switch(c){case 3:case 1:E++,P=t();break;case 5:case 12:P=t();break;case 13:m?P=t():P=" ";break;case 6:P=" ";break;case 10:if(h===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?P=" ":h!==5&&h!==17&&(b=!0);break;case 16:b=!0;break}m&&(h===12||h===13)&&(P=t())}const g=u.getTokenOffset()+f;s(P,l,g),c=h}return a}e.format=k;function A(y,C){let i="";for(let I=0;I<C;I++)i+=y;return i}function T(y,C){let i=0,I=0;const d=C.tabSize||4;for(;i<y.length;){const f=y.charAt(i);if(f===" ")I++;else if(f==="	")I+=d;else break;i++}return Math.floor(I/d)}function S(y,C){for(let i=0;i<C.length;i++){const I=C.charAt(i);if(I==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function D(y,C){return`\r
`.indexOf(y.charAt(C))!==-1}e.isEOL=D}),define(be[106],we([0,1,44,105]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(C,i,I){return T(C,i,void 0,I)}e.removeProperty=A;function T(C,i,I,d,f){const r=i.slice(),o=[],v=(0,_.parseTree)(C,o);let m,E;for(;r.length>0&&(E=r.pop(),m=(0,_.findNodeAtLocation)(v,r),m===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(m)if(m.type==="object"&&typeof E=="string"&&Array.isArray(m.children)){const p=(0,_.findNodeAtLocation)(m,[E]);if(p!==void 0)if(I===void 0){if(!p.parent)throw new Error("Malformed AST");const u=m.children.indexOf(p.parent);let b,t=p.parent.offset+p.parent.length;if(u>0){const n=m.children[u-1];b=n.offset+n.length}else b=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return S(C,{offset:b,length:t-b,content:""},d)}else return S(C,{offset:p.offset,length:p.length,content:JSON.stringify(I)},d);else{if(I===void 0)return[];const u=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,b=f?f(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(b>0){const n=m.children[b-1];t={offset:n.offset+n.length,length:0,content:","+u}}else m.children.length===0?t={offset:m.offset+1,length:0,content:u}:t={offset:m.offset+1,length:0,content:u+","};return S(C,t,d)}}else if(m.type==="array"&&typeof E=="number"&&Array.isArray(m.children))if(I!==void 0){const p=`${JSON.stringify(I)}`;let u;if(m.children.length===0||E===0)u={offset:m.offset+1,length:0,content:m.children.length===0?p:p+","};else{const b=E===-1||E>m.children.length?m.children.length:E,t=m.children[b-1];u={offset:t.offset+t.length,length:0,content:","+p}}return S(C,u,d)}else{const p=E,u=m.children[p];let b;if(m.children.length===1)b={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===p){const t=m.children[p-1],n=t.offset+t.length,a=m.offset+m.length;b={offset:n,length:a-2-n,content:""}}else b={offset:u.offset,length:m.children[p+1].offset-u.offset,content:""};return S(C,b,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${m.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return S(C,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(I)},d)}}e.setProperty=T;function S(C,i,I){let d=D(C,i),f=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;f>0&&!(0,k.isEOL)(d,f-1);)f--;for(;r<d.length&&!(0,k.isEOL)(d,r);)r++}const o=(0,k.format)(d,{offset:f,length:r-f},I);for(let m=o.length-1;m>=0;m--){const E=o[m];d=D(d,E),f=Math.min(f,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const v=C.length-(d.length-r)-f;return[{offset:f,length:v,content:d.substring(f,r)}]}e.withFormatting=S;function D(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=D;function y(C,i){let I=i.slice(0).sort((f,r)=>{const o=f.offset-r.offset;return o===0?f.length-r.length:o}),d=C.length;for(let f=I.length-1;f>=0;f--){let r=I[f];if(r.offset+r.length<=d)C=D(C,r);else throw new Error("Overlapping edit");d=r.offset}return C}e.applyEdits=y}),define(be[107],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new _(()=>A(this.getValue()))}}e.Lazy=_}),define(be[6],we([0,1,54,43]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function S(p){T=p}if(e.setDisposableTracker=S,A){const p="__is_disposable_tracked__";T=new class{trackDisposable(u){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[p]||console.log(b)},3e3)}markTracked(u){if(u&&u!==o.None)try{u[p]=!0}catch(b){}}}}function D(p){!T||T.markTracked(p)}function y(p){return T&&T.trackDisposable(p),p}e.trackDisposable=y;class C extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=C;function i(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.isDisposable=i;function I(p){if(k.Iterable.is(p)){let u=[];for(const b of p)if(b){D(b);try{b.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new C(u);return Array.isArray(p)?[]:p}else if(p)return D(p),p.dispose(),p}e.dispose=I;function d(...p){return p.forEach(D),f(()=>I(p))}e.combinedDisposable=d;function f(p){const u=y({dispose:()=>{D(u),p()}});return u}e.toDisposable=f;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return D(u),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class o{constructor(){this._store=new r,y(this)}dispose(){D(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=o,o.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var b;this._isDisposed||u===this._value||((b=this._value)===null||b===void 0||b.dispose(),u&&D(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,D(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=v;class m{constructor(){this.references=new Map}acquire(u,...b){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...b)},this.references.set(u,t));const{object:n}=t,a=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:a}}}e.ReferenceCollection=m;class E{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=E}),define(be[45],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(T){this.element=T,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class k{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,S){const D=new _(T);if(this._first===_.Undefined)this._first=D,this._last=D;else if(S){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(D))}}shift(){if(this._first!==_.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==_.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==_.Undefined&&T.next!==_.Undefined){const S=T.prev;S.next=T.next,T.next.prev=S}else T.prev===_.Undefined&&T.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):T.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):T.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==_.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(H,se){for(var de=0;de<se.length;de++){var K=se[de];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(H,K.key,K)}}function e(H,se,de){return se&&Y(H.prototype,se),de&&Y(H,de),H}function _(H,se){if(!!H){if(typeof H=="string")return k(H,se);var de=Object.prototype.toString.call(H).slice(8,-1);if(de==="Object"&&H.constructor&&(de=H.constructor.name),de==="Map"||de==="Set")return Array.from(H);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return k(H,se)}}function k(H,se){(se==null||se>H.length)&&(se=H.length);for(var de=0,K=new Array(se);de<se;de++)K[de]=H[de];return K}function A(H,se){var de;if(typeof Symbol=="undefined"||H[Symbol.iterator]==null){if(Array.isArray(H)||(de=_(H))||se&&H&&typeof H.length=="number"){de&&(H=de);var K=0;return function(){return K>=H.length?{done:!0}:{done:!1,value:H[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return de=H[Symbol.iterator](),de.next.bind(de)}function T(H){var se={exports:{}};return H(se,se.exports),se.exports}var S=T(function(H){function se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function de(K){H.exports.defaults=K}H.exports={defaults:se(),getDefaults:se,changeDefaults:de}}),D=/[&<>"']/,y=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(se){return I[se]};function f(H,se){if(se){if(D.test(H))return H.replace(y,d)}else if(C.test(H))return H.replace(i,d);return H}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(H){return H.replace(r,function(se,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var v=/(^|[^\[])\^/g;function m(H,se){H=H.source||H,se=se||"";var de={replace:function(ee,le){return le=le.source||le,le=le.replace(v,"$1"),H=H.replace(ee,le),de},getRegex:function(){return new RegExp(H,se)}};return de}var E=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(H,se,de){if(H){var K;try{K=decodeURIComponent(o(de)).replace(E,"").toLowerCase()}catch(ee){return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}se&&!p.test(de)&&(de=s(se,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch(ee){return null}return de}var b={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(H,se){b[" "+H]||(t.test(H)?b[" "+H]=H+"/":b[" "+H]=P(H,"/",!0)),H=b[" "+H];var de=H.indexOf(":")===-1;return se.substring(0,2)==="//"?de?se:H.replace(n,"$1")+se:se.charAt(0)==="/"?de?se:H.replace(a,"$1")+se:H+se}var c={exec:function(){}};function l(H){for(var se=1,de,K;se<arguments.length;se++){de=arguments[se];for(K in de)Object.prototype.hasOwnProperty.call(de,K)&&(H[K]=de[K])}return H}function h(H,se){var de=H.replace(/\|/g,function(le,fe,Ee){for(var Ve=!1,Fe=fe;--Fe>=0&&Ee[Fe]==="\\";)Ve=!Ve;return Ve?"|":" |"}),K=de.split(/ \|/),ee=0;if(K.length>se)K.splice(se);else for(;K.length<se;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function P(H,se,de){var K=H.length;if(K===0)return"";for(var ee=0;ee<K;){var le=H.charAt(K-ee-1);if(le===se&&!de)ee++;else if(le!==se&&de)ee++;else break}return H.substr(0,K-ee)}function g(H,se){if(H.indexOf(se[1])===-1)return-1;for(var de=H.length,K=0,ee=0;ee<de;ee++)if(H[ee]==="\\")ee++;else if(H[ee]===se[0])K++;else if(H[ee]===se[1]&&(K--,K<0))return ee;return-1}function w(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(H,se){if(se<1)return"";for(var de="";se>1;)se&1&&(de+=H),se>>=1,H+=H;return de+H}var L={escape:f,unescape:o,edit:m,cleanUrl:u,resolveUrl:s,noopTest:c,merge:l,splitCells:h,rtrim:P,findClosingBracket:g,checkSanitizeDeprecation:w,repeatString:R},V=S.defaults,he=L.rtrim,z=L.splitCells,W=L.escape,J=L.findClosingBracket;function O(H,se,de){var K=se.href,ee=se.title?W(se.title):null,le=H[1].replace(/\\([\[\]])/g,"$1");return H[0].charAt(0)!=="!"?{type:"link",raw:de,href:K,title:ee,text:le}:{type:"image",raw:de,href:K,title:ee,text:W(le)}}function F(H,se){var de=H.match(/^(\s+)(?:```)/);if(de===null)return se;var K=de[1];return se.split(`
`).map(function(ee){var le=ee.match(/^\s+/);if(le===null)return ee;var fe=le[0];return fe.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var N=function(){function H(de){this.options=de||V}var se=H.prototype;return se.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee)return ee[0].length>1?{type:"space",raw:ee[0]}:{raw:`
`}},se.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var le=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?le:he(le,`
`)}}},se.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var le=ee[0],fe=F(le,ee[3]||"");return{type:"code",raw:le,lang:ee[2]?ee[2].trim():ee[2],text:fe}}},se.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var le=ee[2].trim();if(/#$/.test(le)){var fe=he(le,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(le=fe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:le}}},se.nptable=function(K){var ee=this.rules.block.nptable.exec(K);if(ee){var le={type:"table",header:z(ee[1].replace(/^ *| *\| *$/g,"")),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ee[3]?ee[3].replace(/\n$/,"").split(`
`):[],raw:ee[0]};if(le.header.length===le.align.length){var fe=le.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(fe=le.cells.length,Ee=0;Ee<fe;Ee++)le.cells[Ee]=z(le.cells[Ee],le.header.length);return le}}},se.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},se.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var le=ee[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ee[0],text:le}}},se.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var le=ee[0],fe=ee[2],Ee=fe.length>1,Ve={type:"list",raw:le,ordered:Ee,start:Ee?+fe.slice(0,-1):"",loose:!1,items:[]},Fe=ee[0].match(this.rules.block.item),We=!1,Qe,it,at,Ze,nt,dt,wt,ue,Se=Fe.length;at=this.rules.block.listItemStart.exec(Fe[0]);for(var ae=0;ae<Se;ae++){if(Qe=Fe[ae],le=Qe,ae!==Se-1){if(Ze=this.rules.block.listItemStart.exec(Fe[ae+1]),this.options.pedantic?Ze[1].length>at[1].length:Ze[1].length>at[0].length||Ze[1].length>3){Fe.splice(ae,2,Fe[ae]+`
`+Fe[ae+1]),ae--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?Ze[2][Ze[2].length-1]!==fe[fe.length-1]:Ee===(Ze[2].length===1))&&(nt=Fe.slice(ae+1).join(`
`),Ve.raw=Ve.raw.substring(0,Ve.raw.length-nt.length),ae=Se-1);at=Ze}it=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(it-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+it+"}","gm"),"")),dt=We||/\n\n(?!\s*$)/.test(Qe),ae!==Se-1&&(We=Qe.charAt(Qe.length-1)===`
`,dt||(dt=We)),dt&&(Ve.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Qe),ue=void 0,wt&&(ue=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:wt,checked:ue,loose:dt,text:Qe})}return Ve}},se.html=function(K){var ee=this.rules.block.html.exec(K);if(ee)return{type:this.options.sanitize?"paragraph":"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):W(ee[0]):ee[0]}},se.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var le=ee[1].toLowerCase().replace(/\s+/g," ");return{tag:le,raw:ee[0],href:ee[2],title:ee[3]}}},se.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var le={type:"table",header:z(ee[1].replace(/^ *| *\| *$/g,"")),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ee[3]?ee[3].replace(/\n$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ee[0];var fe=le.align.length,Ee;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(le.align[Ee])?le.align[Ee]="right":/^ *:-+: *$/.test(le.align[Ee])?le.align[Ee]="center":/^ *:-+ *$/.test(le.align[Ee])?le.align[Ee]="left":le.align[Ee]=null;for(fe=le.cells.length,Ee=0;Ee<fe;Ee++)le.cells[Ee]=z(le.cells[Ee].replace(/^ *\| *| *\| *$/g,""),le.header.length);return le}}},se.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1]}},se.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee)return{type:"paragraph",raw:ee[0],text:ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1]}},se.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0]}},se.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:W(ee[1])}},se.tag=function(K,ee,le){var fe=this.rules.inline.tag.exec(K);if(fe)return!ee&&/^<a /i.test(fe[0])?ee=!0:ee&&/^<\/a>/i.test(fe[0])&&(ee=!1),!le&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?le=!0:le&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(le=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:ee,inRawBlock:le,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]}},se.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var le=ee[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var fe=he(le.slice(0,-1),"\\");if((le.length-fe.length)%2==0)return}else{var Ee=J(ee[2],"()");if(Ee>-1){var Ve=ee[0].indexOf("!")===0?5:4,Fe=Ve+ee[1].length+Ee;ee[2]=ee[2].substring(0,Ee),ee[0]=ee[0].substring(0,Fe).trim(),ee[3]=""}}var We=ee[2],Qe="";if(this.options.pedantic){var it=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);it&&(We=it[1],Qe=it[3])}else Qe=ee[3]?ee[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(le)?We=We.slice(1):We=We.slice(1,-1)),O(ee,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},ee[0])}},se.reflink=function(K,ee){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var fe=(le[2]||le[1]).replace(/\s+/g," ");if(fe=ee[fe.toLowerCase()],!fe||!fe.href){var Ee=le[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return O(le,fe,le[0])}},se.emStrong=function(K,ee,le){le===void 0&&(le="");var fe=this.rules.inline.emStrong.lDelim.exec(K);if(!!fe&&!(fe[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=fe[1]||fe[2]||"";if(!Ee||Ee&&(le===""||this.rules.inline.punctuation.exec(le))){var Ve=fe[0].length-1,Fe,We,Qe=Ve,it=0,at=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(at.lastIndex=0,ee=ee.slice(-1*K.length+Ve);(fe=at.exec(ee))!=null;)if(Fe=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Fe){if(We=Fe.length,fe[3]||fe[4]){Qe+=We;continue}else if((fe[5]||fe[6])&&Ve%3&&!((Ve+We)%3)){it+=We;continue}if(Qe-=We,!(Qe>0)){if(Qe+it-We<=0&&!ee.slice(at.lastIndex).match(at)&&(We=Math.min(We,We+Qe+it)),Math.min(Ve,We)%2)return{type:"em",raw:K.slice(0,Ve+fe.index+We+1),text:K.slice(1,Ve+fe.index+We)};if(Math.min(Ve,We)%2==0)return{type:"strong",raw:K.slice(0,Ve+fe.index+We+1),text:K.slice(2,Ve+fe.index+We-1)}}}}}},se.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var le=ee[2].replace(/\n/g," "),fe=/[^ ]/.test(le),Ee=/^ /.test(le)&&/ $/.test(le);return fe&&Ee&&(le=le.substring(1,le.length-1)),le=W(le,!0),{type:"codespan",raw:ee[0],text:le}}},se.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},se.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2]}},se.autolink=function(K,ee){var le=this.rules.inline.autolink.exec(K);if(le){var fe,Ee;return le[2]==="@"?(fe=W(this.options.mangle?ee(le[1]):le[1]),Ee="mailto:"+fe):(fe=W(le[1]),Ee=fe),{type:"link",raw:le[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},se.url=function(K,ee){var le;if(le=this.rules.inline.url.exec(K)){var fe,Ee;if(le[2]==="@")fe=W(this.options.mangle?ee(le[0]):le[0]),Ee="mailto:"+fe;else{var Ve;do Ve=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(Ve!==le[0]);fe=W(le[0]),le[1]==="www."?Ee="http://"+fe:Ee=fe}return{type:"link",raw:le[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},se.inlineText=function(K,ee,le){var fe=this.rules.inline.text.exec(K);if(fe){var Ee;return ee?Ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]:Ee=W(this.options.smartypants?le(fe[0]):fe[0]),{type:"text",raw:fe[0],text:Ee}}},H}(),B=L.noopTest,U=L.edit,Q=L.merge,Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:B,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=U(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,Z.item=U(Z.item,"gm").replace(/bull/g,Z.bullet).getRegex(),Z.listItemStart=U(/^( *)(bull)/).replace("bull",Z.bullet).getRegex(),Z.list=U(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=U(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=U(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=U(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=Q({},Z),Z.gfm=Q({},Z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.nptable=U(Z.gfm.nptable).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Z._tag).getRegex(),Z.gfm.table=U(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=Q({},Z.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:U(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=U(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=U(Z._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=U(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=U(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=U(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=U(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=U(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=U(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=U(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=U(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=Q({},ne),ne.pedantic=Q({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=Q({},ne.normal,{escape:U(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=U(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=Q({},ne.gfm,{br:U(ne.br).replace("{2,}","*").getRegex(),text:U(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:Z,inline:ne},Pe=S.defaults,Oe=pe.block,Te=pe.inline,xe=L.repeatString;function $(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(H){var se="",de,K,ee=H.length;for(de=0;de<ee;de++)K=H.charCodeAt(de),Math.random()>.5&&(K="x"+K.toString(16)),se+="&#"+K+";";return se}var ie=function(){function H(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||Pe,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var K={block:Oe.normal,inline:Te.normal};this.options.pedantic?(K.block=Oe.pedantic,K.inline=Te.pedantic):this.options.gfm&&(K.block=Oe.gfm,this.options.breaks?K.inline=Te.breaks:K.inline=Te.gfm),this.tokenizer.rules=K}H.lex=function(K,ee){var le=new H(ee);return le.lex(K)},H.lexInline=function(K,ee){var le=new H(ee);return le.inlineTokens(K)};var se=H.prototype;return se.lex=function(K){return K=K.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(K,this.tokens,!0),this.inline(this.tokens),this.tokens},se.blockTokens=function(K,ee,le){ee===void 0&&(ee=[]),le===void 0&&(le=!0),this.options.pedantic&&(K=K.replace(/^ +$/gm,""));for(var fe,Ee,Ve,Fe;K;){if(fe=this.tokenizer.space(K)){K=K.substring(fe.raw.length),fe.type&&ee.push(fe);continue}if(fe=this.tokenizer.code(K)){K=K.substring(fe.raw.length),Fe=ee[ee.length-1],Fe&&Fe.type==="paragraph"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text):ee.push(fe);continue}if(fe=this.tokenizer.fences(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.heading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.nptable(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.hr(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.blockquote(K)){K=K.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],le),ee.push(fe);continue}if(fe=this.tokenizer.list(K)){for(K=K.substring(fe.raw.length),Ve=fe.items.length,Ee=0;Ee<Ve;Ee++)fe.items[Ee].tokens=this.blockTokens(fe.items[Ee].text,[],!1);ee.push(fe);continue}if(fe=this.tokenizer.html(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(le&&(fe=this.tokenizer.def(K))){K=K.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.lheading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(le&&(fe=this.tokenizer.paragraph(K))){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.text(K)){K=K.substring(fe.raw.length),Fe=ee[ee.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text):ee.push(fe);continue}if(K){var We="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return ee},se.inline=function(K){var ee,le,fe,Ee,Ve,Fe,We=K.length;for(ee=0;ee<We;ee++)switch(Fe=K[ee],Fe.type){case"paragraph":case"text":case"heading":{Fe.tokens=[],this.inlineTokens(Fe.text,Fe.tokens);break}case"table":{for(Fe.tokens={header:[],cells:[]},Ee=Fe.header.length,le=0;le<Ee;le++)Fe.tokens.header[le]=[],this.inlineTokens(Fe.header[le],Fe.tokens.header[le]);for(Ee=Fe.cells.length,le=0;le<Ee;le++)for(Ve=Fe.cells[le],Fe.tokens.cells[le]=[],fe=0;fe<Ve.length;fe++)Fe.tokens.cells[le][fe]=[],this.inlineTokens(Ve[fe],Fe.tokens.cells[le][fe]);break}case"blockquote":{this.inline(Fe.tokens);break}case"list":{for(Ee=Fe.items.length,le=0;le<Ee;le++)this.inline(Fe.items[le].tokens);break}}return K},se.inlineTokens=function(K,ee,le,fe){ee===void 0&&(ee=[]),le===void 0&&(le=!1),fe===void 0&&(fe=!1);var Ee,Ve,Fe=K,We,Qe,it;if(this.tokens.links){var at=Object.keys(this.tokens.links);if(at.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)at.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,We.index)+"["+xe("a",We[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,We.index)+"["+xe("a",We[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(Fe))!=null;)Fe=Fe.slice(0,We.index)+"++"+Fe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;){if(Qe||(it=""),Qe=!1,Ee=this.tokenizer.escape(K)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.tag(K,le,fe)){K=K.substring(Ee.raw.length),le=Ee.inLink,fe=Ee.inRawBlock;var Ze=ee[ee.length-1];Ze&&Ee.type==="text"&&Ze.type==="text"?(Ze.raw+=Ee.raw,Ze.text+=Ee.text):ee.push(Ee);continue}if(Ee=this.tokenizer.link(K)){K=K.substring(Ee.raw.length),Ee.type==="link"&&(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe)),ee.push(Ee);continue}if(Ee=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(Ee.raw.length);var nt=ee[ee.length-1];Ee.type==="link"?(Ee.tokens=this.inlineTokens(Ee.text,[],!0,fe),ee.push(Ee)):nt&&Ee.type==="text"&&nt.type==="text"?(nt.raw+=Ee.raw,nt.text+=Ee.text):ee.push(Ee);continue}if(Ee=this.tokenizer.emStrong(K,Fe,it)){K=K.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,fe),ee.push(Ee);continue}if(Ee=this.tokenizer.codespan(K)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.br(K)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.del(K)){K=K.substring(Ee.raw.length),Ee.tokens=this.inlineTokens(Ee.text,[],le,fe),ee.push(Ee);continue}if(Ee=this.tokenizer.autolink(K,G)){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(!le&&(Ee=this.tokenizer.url(K,G))){K=K.substring(Ee.raw.length),ee.push(Ee);continue}if(Ee=this.tokenizer.inlineText(K,fe,$)){K=K.substring(Ee.raw.length),Ee.raw.slice(-1)!=="_"&&(it=Ee.raw.slice(-1)),Qe=!0,Ve=ee[ee.length-1],Ve&&Ve.type==="text"?(Ve.raw+=Ee.raw,Ve.text+=Ee.text):ee.push(Ee);continue}if(K){var dt="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(dt);break}else throw new Error(dt)}}return ee},e(H,null,[{key:"rules",get:function(){return{block:Oe,inline:Te}}}]),H}(),oe=S.defaults,me=L.cleanUrl,De=L.escape,Ne=function(){function H(de){this.options=de||oe}var se=H.prototype;return se.code=function(K,ee,le){var fe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(K,fe);Ee!=null&&Ee!==K&&(le=!0,K=Ee)}return K=K.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+De(fe,!0)+'">'+(le?K:De(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:De(K,!0))+`</code></pre>
`},se.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},se.html=function(K){return K},se.heading=function(K,ee,le,fe){return this.options.headerIds?"<h"+ee+' id="'+this.options.headerPrefix+fe.slug(le)+'">'+K+"</h"+ee+`>
`:"<h"+ee+">"+K+"</h"+ee+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(K,ee,le){var fe=ee?"ol":"ul",Ee=ee&&le!==1?' start="'+le+'"':"";return"<"+fe+Ee+`>
`+K+"</"+fe+`>
`},se.listitem=function(K){return"<li>"+K+`</li>
`},se.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(K){return"<p>"+K+`</p>
`},se.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},se.tablerow=function(K){return`<tr>
`+K+`</tr>
`},se.tablecell=function(K,ee){var le=ee.header?"th":"td",fe=ee.align?"<"+le+' align="'+ee.align+'">':"<"+le+">";return fe+K+"</"+le+`>
`},se.strong=function(K){return"<strong>"+K+"</strong>"},se.em=function(K){return"<em>"+K+"</em>"},se.codespan=function(K){return"<code>"+K+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(K){return"<del>"+K+"</del>"},se.link=function(K,ee,le){if(K=me(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<a href="'+De(K)+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=">"+le+"</a>",fe},se.image=function(K,ee,le){if(K=me(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var fe='<img src="'+K+'" alt="'+le+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=this.options.xhtml?"/>":">",fe},se.text=function(K){return K},H}(),ge=function(){function H(){}var se=H.prototype;return se.strong=function(K){return K},se.em=function(K){return K},se.codespan=function(K){return K},se.del=function(K){return K},se.html=function(K){return K},se.text=function(K){return K},se.link=function(K,ee,le){return""+le},se.image=function(K,ee,le){return""+le},se.br=function(){return""},H}(),Ce=function(){function H(){this.seen={}}var se=H.prototype;return se.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(K,ee){var le=K,fe=0;if(this.seen.hasOwnProperty(le)){fe=this.seen[K];do fe++,le=K+"-"+fe;while(this.seen.hasOwnProperty(le))}return ee||(this.seen[K]=fe,this.seen[le]=0),le},se.slug=function(K,ee){ee===void 0&&(ee={});var le=this.serialize(K);return this.getNextSafeSlug(le,ee.dryrun)},H}(),Ae=S.defaults,Be=L.unescape,_e=function(){function H(de){this.options=de||Ae,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}H.parse=function(K,ee){var le=new H(ee);return le.parse(K)},H.parseInline=function(K,ee){var le=new H(ee);return le.parseInline(K)};var se=H.prototype;return se.parse=function(K,ee){ee===void 0&&(ee=!0);var le="",fe,Ee,Ve,Fe,We,Qe,it,at,Ze,nt,dt,wt,ue,Se,ae,q,Le,Ie,Xe=K.length;for(fe=0;fe<Xe;fe++)switch(nt=K[fe],nt.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,Be(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(at="",it="",Fe=nt.header.length,Ee=0;Ee<Fe;Ee++)it+=this.renderer.tablecell(this.parseInline(nt.tokens.header[Ee]),{header:!0,align:nt.align[Ee]});for(at+=this.renderer.tablerow(it),Ze="",Fe=nt.cells.length,Ee=0;Ee<Fe;Ee++){for(Qe=nt.tokens.cells[Ee],it="",We=Qe.length,Ve=0;Ve<We;Ve++)it+=this.renderer.tablecell(this.parseInline(Qe[Ve]),{header:!1,align:nt.align[Ve]});Ze+=this.renderer.tablerow(it)}le+=this.renderer.table(at,Ze);continue}case"blockquote":{Ze=this.parse(nt.tokens),le+=this.renderer.blockquote(Ze);continue}case"list":{for(dt=nt.ordered,wt=nt.start,ue=nt.loose,Fe=nt.items.length,Ze="",Ee=0;Ee<Fe;Ee++)ae=nt.items[Ee],q=ae.checked,Le=ae.task,Se="",ae.task&&(Ie=this.renderer.checkbox(q),ue?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Ie+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Ie+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Ie}):Se+=Ie),Se+=this.parse(ae.tokens,ue),Ze+=this.renderer.listitem(Se,Le,q);le+=this.renderer.list(Ze,dt,wt);continue}case"html":{le+=this.renderer.html(nt.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(Ze=nt.tokens?this.parseInline(nt.tokens):nt.text;fe+1<Xe&&K[fe+1].type==="text";)nt=K[++fe],Ze+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);le+=ee?this.renderer.paragraph(Ze):Ze;continue}default:{var et='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return le},se.parseInline=function(K,ee){ee=ee||this.renderer;var le="",fe,Ee,Ve=K.length;for(fe=0;fe<Ve;fe++)switch(Ee=K[fe],Ee.type){case"escape":{le+=ee.text(Ee.text);break}case"html":{le+=ee.html(Ee.text);break}case"link":{le+=ee.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,ee));break}case"image":{le+=ee.image(Ee.href,Ee.title,Ee.text);break}case"strong":{le+=ee.strong(this.parseInline(Ee.tokens,ee));break}case"em":{le+=ee.em(this.parseInline(Ee.tokens,ee));break}case"codespan":{le+=ee.codespan(Ee.text);break}case"br":{le+=ee.br();break}case"del":{le+=ee.del(this.parseInline(Ee.tokens,ee));break}case"text":{le+=ee.text(Ee.text);break}default:{var Fe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return le},H}(),qe=L.merge,j=L.checkSanitizeDeprecation,te=L.escape,ve=S.getDefaults,Ue=S.changeDefaults,He=S.defaults;function $e(H,se,de){if(typeof H=="undefined"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof se=="function"&&(de=se,se=null),se=qe({},$e.defaults,se||{}),j(se),de){var K=se.highlight,ee;try{ee=ie.lex(H,se)}catch(Ve){return de(Ve)}var le=function(Fe){var We;if(!Fe)try{We=_e.parse(ee,se)}catch(Qe){Fe=Qe}return se.highlight=K,Fe?de(Fe):de(null,We)};if(!K||K.length<3||(delete se.highlight,!ee.length))return le();var fe=0;$e.walkTokens(ee,function(Ve){Ve.type==="code"&&(fe++,setTimeout(function(){K(Ve.text,Ve.lang,function(Fe,We){if(Fe)return le(Fe);We!=null&&We!==Ve.text&&(Ve.text=We,Ve.escaped=!0),fe--,fe===0&&le()})},0))}),fe===0&&le();return}try{var Ee=ie.lex(H,se);return se.walkTokens&&$e.walkTokens(Ee,se.walkTokens),_e.parse(Ee,se)}catch(Ve){if(Ve.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+te(Ve.message+"",!0)+"</pre>";throw Ve}}$e.options=$e.setOptions=function(H){return qe($e.defaults,H),Ue($e.defaults),$e},$e.getDefaults=ve,$e.defaults=He,$e.use=function(H){var se=qe({},H);if(H.renderer&&function(){var K=$e.defaults.renderer||new Ne,ee=function(Ee){var Ve=K[Ee];K[Ee]=function(){for(var Fe=arguments.length,We=new Array(Fe),Qe=0;Qe<Fe;Qe++)We[Qe]=arguments[Qe];var it=H.renderer[Ee].apply(K,We);return it===!1&&(it=Ve.apply(K,We)),it}};for(var le in H.renderer)ee(le);se.renderer=K}(),H.tokenizer&&function(){var K=$e.defaults.tokenizer||new N,ee=function(Ee){var Ve=K[Ee];K[Ee]=function(){for(var Fe=arguments.length,We=new Array(Fe),Qe=0;Qe<Fe;Qe++)We[Qe]=arguments[Qe];var it=H.tokenizer[Ee].apply(K,We);return it===!1&&(it=Ve.apply(K,We)),it}};for(var le in H.tokenizer)ee(le);se.tokenizer=K}(),H.walkTokens){var de=$e.defaults.walkTokens;se.walkTokens=function(K){H.walkTokens(K),de&&de(K)}}$e.setOptions(se)},$e.walkTokens=function(H,se){for(var de=A(H),K;!(K=de()).done;){var ee=K.value;switch(se(ee),ee.type){case"table":{for(var le=A(ee.tokens.header),fe;!(fe=le()).done;){var Ee=fe.value;$e.walkTokens(Ee,se)}for(var Ve=A(ee.tokens.cells),Fe;!(Fe=Ve()).done;)for(var We=Fe.value,Qe=A(We),it;!(it=Qe()).done;){var at=it.value;$e.walkTokens(at,se)}break}case"list":{$e.walkTokens(ee.items,se);break}default:ee.tokens&&$e.walkTokens(ee.tokens,se)}}},$e.parseInline=function(H,se){if(typeof H=="undefined"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");se=qe({},$e.defaults,se||{}),j(se);try{var de=ie.lexInline(H,se);return se.walkTokens&&$e.walkTokens(de,se.walkTokens),_e.parseInline(de,se)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+te(K.message+"",!0)+"</pre>";throw K}},$e.Parser=_e,$e.parser=_e.parse,$e.Renderer=Ne,$e.TextRenderer=ge,$e.Lexer=ie,$e.lexer=ie.lex,$e.Tokenizer=N,$e.Slugger=Ce,$e.parse=$e;var Ye=$e;return Ye}),define(be[81],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(S,D,y){return Math.min(Math.max(S,D),y)}e.clamp=_;function k(S,D){return(D+S%D)%D}e.rot=k;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function Y(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function S(y){T.push(y,Date.now())}function D(){const y=[];for(let C=0;C<T.length;C+=2)y.push({name:T[C],startTime:T[C+1]});return y}return{mark:S,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const S of performance.getEntriesByType("mark"))T.push({name:S.name,startTime:Math.round(A+S.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function _(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=_(k))})(),define(be[21],we([0,1]),function(Y,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,T=!1,S=!1,D=!1,y=!1,C=!1,i=!1,I,d=k,f,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const v=typeof((_=o==null?void 0:o.versions)===null||_===void 0?void 0:_.electron)=="string"&&o.type==="renderer";if(e.isElectronSandboxed=v&&(o==null?void 0:o.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=o==null?void 0:o.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)r=navigator.userAgent,A=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,C=!0,I=navigator.language,d=I;else if(typeof o=="object"){A=o.platform==="win32",T=o.platform==="darwin",S=o.platform==="linux",D=S&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,I=k,d=k;const s=o.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),l=c.availableLanguages["*"];I=c.locale,d=l||k,f=c._translationsConfigFile}catch(c){}y=!0}else console.error("Unable to resolve platform.");var m;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function E(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let p=0;T?p=1:A?p=3:S&&(p=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=S,e.isLinuxSnap=D,e.isNative=y,e.isWeb=C,e.isIOS=i,e.platform=p,e.userAgent=r,e.language=d;var u;(function(s){function c(){return e.language}s.value=c;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function h(){return e.language==="en"}s.isDefault=h})(u=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let g=0,w=l.length;g<w;g++){const R=l[g];if(R.id===P.data.vscodeSetImmediateId){l.splice(g,1),R.callback();return}}});let h=0;return P=>{const g=++h;l.push({id:g,callback:P}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof(o==null?void 0:o.nextTick)=="function")return o.nextTick.bind(o);const c=Promise.resolve();return l=>c.then(l)}();var b;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(b=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:A?1:3;let t=!0,n=!1;function a(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a}),define(be[46],we([0,1,21]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof _.globals.vscode!="undefined"){const A=_.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,_.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(A){return(0,_.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(be[13],we([0,1,46]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,T=90,S=122,D=46,y=47,C=92,i=58,I=63;class d extends Error{constructor(u,b,t){let n;typeof b=="string"&&b.indexOf("not ")===0?(n="must not be",b=b.replace(/^not /,"")):n="must be";const a=u.indexOf(".")!==-1?"property":"argument";let s=`The "${u}" ${a} ${n} of type ${b}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function f(p,u){if(typeof p!="string")throw new d(u,"string",p)}function r(p){return p===y||p===C}function o(p){return p===y}function v(p){return p>=k&&p<=T||p>=A&&p<=S}function m(p,u,b,t){let n="",a=0,s=-1,c=0,l=0;for(let h=0;h<=p.length;++h){if(h<p.length)l=p.charCodeAt(h);else{if(t(l))break;l=y}if(t(l)){if(!(s===h-1||c===1))if(c===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const P=n.lastIndexOf(b);P===-1?(n="",a=0):(n=n.slice(0,P),a=n.length-1-n.lastIndexOf(b)),s=h,c=0;continue}else if(n.length!==0){n="",a=0,s=h,c=0;continue}}u&&(n+=n.length>0?`${b}..`:"..",a=2)}else n.length>0?n+=`${b}${p.slice(s+1,h)}`:n=p.slice(s+1,h),a=h-s-1;s=h,c=0}else l===D&&c!==-1?++c:c=-1}return n}function E(p,u){if(u===null||typeof u!="object")throw new d("pathObject","Object",u);const b=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return b?b===u.root?`${b}${t}`:`${b}${p}${t}`:t}e.win32={resolve(...p){let u="",b="",t=!1;for(let n=p.length-1;n>=-1;n--){let a;if(n>=0){if(a=p[n],f(a,"path"),a.length===0)continue}else u.length===0?a=_.cwd():(a=_.env[`=${u}`]||_.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==u.toLowerCase()&&a.charCodeAt(2)===C)&&(a=`${u}\\`));const s=a.length;let c=0,l="",h=!1;const P=a.charCodeAt(0);if(s===1)r(P)&&(c=1,h=!0);else if(r(P))if(h=!0,r(a.charCodeAt(1))){let g=2,w=g;for(;g<s&&!r(a.charCodeAt(g));)g++;if(g<s&&g!==w){const R=a.slice(w,g);for(w=g;g<s&&r(a.charCodeAt(g));)g++;if(g<s&&g!==w){for(w=g;g<s&&!r(a.charCodeAt(g));)g++;(g===s||g!==w)&&(l=`\\\\${R}\\${a.slice(w,g)}`,c=g)}}}else c=1;else v(P)&&a.charCodeAt(1)===i&&(l=a.slice(0,2),c=2,s>2&&r(a.charCodeAt(2))&&(h=!0,c=3));if(l.length>0)if(u.length>0){if(l.toLowerCase()!==u.toLowerCase())continue}else u=l;if(t){if(u.length>0)break}else if(b=`${a.slice(c)}\\${b}`,t=h,h&&u.length>0)break}return b=m(b,!t,"\\",r),t?`${u}\\${b}`:`${u}${b}`||"."},normalize(p){f(p,"path");const u=p.length;if(u===0)return".";let b=0,t,n=!1;const a=p.charCodeAt(0);if(u===1)return o(a)?"\\":p;if(r(a))if(n=!0,r(p.charCodeAt(1))){let c=2,l=c;for(;c<u&&!r(p.charCodeAt(c));)c++;if(c<u&&c!==l){const h=p.slice(l,c);for(l=c;c<u&&r(p.charCodeAt(c));)c++;if(c<u&&c!==l){for(l=c;c<u&&!r(p.charCodeAt(c));)c++;if(c===u)return`\\\\${h}\\${p.slice(l)}\\`;c!==l&&(t=`\\\\${h}\\${p.slice(l,c)}`,b=c)}}}else b=1;else v(a)&&p.charCodeAt(1)===i&&(t=p.slice(0,2),b=2,u>2&&r(p.charCodeAt(2))&&(n=!0,b=3));let s=b<u?m(p.slice(b),!n,"\\",r):"";return s.length===0&&!n&&(s="."),s.length>0&&r(p.charCodeAt(u-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(p){f(p,"path");const u=p.length;if(u===0)return!1;const b=p.charCodeAt(0);return r(b)||u>2&&v(b)&&p.charCodeAt(1)===i&&r(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let u,b;for(let a=0;a<p.length;++a){const s=p[a];f(s,"path"),s.length>0&&(u===void 0?u=b=s:u+=`\\${s}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof b=="string"&&r(b.charCodeAt(0))){++n;const a=b.length;a>1&&r(b.charCodeAt(1))&&(++n,a>2&&(r(b.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&r(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(p,u){if(f(p,"from"),f(u,"to"),p===u)return"";const b=e.win32.resolve(p),t=e.win32.resolve(u);if(b===t||(p=b.toLowerCase(),u=t.toLowerCase(),p===u))return"";let n=0;for(;n<p.length&&p.charCodeAt(n)===C;)n++;let a=p.length;for(;a-1>n&&p.charCodeAt(a-1)===C;)a--;const s=a-n;let c=0;for(;c<u.length&&u.charCodeAt(c)===C;)c++;let l=u.length;for(;l-1>c&&u.charCodeAt(l-1)===C;)l--;const h=l-c,P=s<h?s:h;let g=-1,w=0;for(;w<P;w++){const L=p.charCodeAt(n+w);if(L!==u.charCodeAt(c+w))break;L===C&&(g=w)}if(w!==P){if(g===-1)return t}else{if(h>P){if(u.charCodeAt(c+w)===C)return t.slice(c+w+1);if(w===2)return t.slice(c+w)}s>P&&(p.charCodeAt(n+w)===C?g=w:w===2&&(g=3)),g===-1&&(g=0)}let R="";for(w=n+g+1;w<=a;++w)(w===a||p.charCodeAt(w)===C)&&(R+=R.length===0?"..":"\\..");return c+=g,R.length>0?`${R}${t.slice(c,l)}`:(t.charCodeAt(c)===C&&++c,t.slice(c,l))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const u=e.win32.resolve(p);if(u.length<=2)return p;if(u.charCodeAt(0)===C){if(u.charCodeAt(1)===C){const b=u.charCodeAt(2);if(b!==I&&b!==D)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(v(u.charCodeAt(0))&&u.charCodeAt(1)===i&&u.charCodeAt(2)===C)return`\\\\?\\${u}`;return p},dirname(p){f(p,"path");const u=p.length;if(u===0)return".";let b=-1,t=0;const n=p.charCodeAt(0);if(u===1)return r(n)?p:".";if(r(n)){if(b=t=1,r(p.charCodeAt(1))){let c=2,l=c;for(;c<u&&!r(p.charCodeAt(c));)c++;if(c<u&&c!==l){for(l=c;c<u&&r(p.charCodeAt(c));)c++;if(c<u&&c!==l){for(l=c;c<u&&!r(p.charCodeAt(c));)c++;if(c===u)return p;c!==l&&(b=t=c+1)}}}}else v(n)&&p.charCodeAt(1)===i&&(b=u>2&&r(p.charCodeAt(2))?3:2,t=b);let a=-1,s=!0;for(let c=u-1;c>=t;--c)if(r(p.charCodeAt(c))){if(!s){a=c;break}}else s=!1;if(a===-1){if(b===-1)return".";a=b}return p.slice(0,a)},basename(p,u){u!==void 0&&f(u,"ext"),f(p,"path");let b=0,t=-1,n=!0,a;if(p.length>=2&&v(p.charCodeAt(0))&&p.charCodeAt(1)===i&&(b=2),u!==void 0&&u.length>0&&u.length<=p.length){if(u===p)return"";let s=u.length-1,c=-1;for(a=p.length-1;a>=b;--a){const l=p.charCodeAt(a);if(r(l)){if(!n){b=a+1;break}}else c===-1&&(n=!1,c=a+1),s>=0&&(l===u.charCodeAt(s)?--s==-1&&(t=a):(s=-1,t=c))}return b===t?t=c:t===-1&&(t=p.length),p.slice(b,t)}for(a=p.length-1;a>=b;--a)if(r(p.charCodeAt(a))){if(!n){b=a+1;break}}else t===-1&&(n=!1,t=a+1);return t===-1?"":p.slice(b,t)},extname(p){f(p,"path");let u=0,b=-1,t=0,n=-1,a=!0,s=0;p.length>=2&&p.charCodeAt(1)===i&&v(p.charCodeAt(0))&&(u=t=2);for(let c=p.length-1;c>=u;--c){const l=p.charCodeAt(c);if(r(l)){if(!a){t=c+1;break}continue}n===-1&&(a=!1,n=c+1),l===D?b===-1?b=c:s!==1&&(s=1):b!==-1&&(s=-1)}return b===-1||n===-1||s===0||s===1&&b===n-1&&b===t+1?"":p.slice(b,n)},format:E.bind(null,"\\"),parse(p){f(p,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return u;const b=p.length;let t=0,n=p.charCodeAt(0);if(b===1)return r(n)?(u.root=u.dir=p,u):(u.base=u.name=p,u);if(r(n)){if(t=1,r(p.charCodeAt(1))){let g=2,w=g;for(;g<b&&!r(p.charCodeAt(g));)g++;if(g<b&&g!==w){for(w=g;g<b&&r(p.charCodeAt(g));)g++;if(g<b&&g!==w){for(w=g;g<b&&!r(p.charCodeAt(g));)g++;g===b?t=g:g!==w&&(t=g+1)}}}}else if(v(n)&&p.charCodeAt(1)===i){if(b<=2)return u.root=u.dir=p,u;if(t=2,r(p.charCodeAt(2))){if(b===3)return u.root=u.dir=p,u;t=3}}t>0&&(u.root=p.slice(0,t));let a=-1,s=t,c=-1,l=!0,h=p.length-1,P=0;for(;h>=t;--h){if(n=p.charCodeAt(h),r(n)){if(!l){s=h+1;break}continue}c===-1&&(l=!1,c=h+1),n===D?a===-1?a=h:P!==1&&(P=1):a!==-1&&(P=-1)}return c!==-1&&(a===-1||P===0||P===1&&a===c-1&&a===s+1?u.base=u.name=p.slice(s,c):(u.name=p.slice(s,a),u.base=p.slice(s,c),u.ext=p.slice(a,c))),s>0&&s!==t?u.dir=p.slice(0,s-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let u="",b=!1;for(let t=p.length-1;t>=-1&&!b;t--){const n=t>=0?p[t]:_.cwd();f(n,"path"),n.length!==0&&(u=`${n}/${u}`,b=n.charCodeAt(0)===y)}return u=m(u,!b,"/",o),b?`/${u}`:u.length>0?u:"."},normalize(p){if(f(p,"path"),p.length===0)return".";const u=p.charCodeAt(0)===y,b=p.charCodeAt(p.length-1)===y;return p=m(p,!u,"/",o),p.length===0?u?"/":b?"./":".":(b&&(p+="/"),u?`/${p}`:p)},isAbsolute(p){return f(p,"path"),p.length>0&&p.charCodeAt(0)===y},join(...p){if(p.length===0)return".";let u;for(let b=0;b<p.length;++b){const t=p[b];f(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(p,u){if(f(p,"from"),f(u,"to"),p===u||(p=e.posix.resolve(p),u=e.posix.resolve(u),p===u))return"";const b=1,t=p.length,n=t-b,a=1,s=u.length-a,c=n<s?n:s;let l=-1,h=0;for(;h<c;h++){const g=p.charCodeAt(b+h);if(g!==u.charCodeAt(a+h))break;g===y&&(l=h)}if(h===c)if(s>c){if(u.charCodeAt(a+h)===y)return u.slice(a+h+1);if(h===0)return u.slice(a+h)}else n>c&&(p.charCodeAt(b+h)===y?l=h:h===0&&(l=0));let P="";for(h=b+l+1;h<=t;++h)(h===t||p.charCodeAt(h)===y)&&(P+=P.length===0?"..":"/..");return`${P}${u.slice(a+l)}`},toNamespacedPath(p){return p},dirname(p){if(f(p,"path"),p.length===0)return".";const u=p.charCodeAt(0)===y;let b=-1,t=!0;for(let n=p.length-1;n>=1;--n)if(p.charCodeAt(n)===y){if(!t){b=n;break}}else t=!1;return b===-1?u?"/":".":u&&b===1?"//":p.slice(0,b)},basename(p,u){u!==void 0&&f(u,"ext"),f(p,"path");let b=0,t=-1,n=!0,a;if(u!==void 0&&u.length>0&&u.length<=p.length){if(u===p)return"";let s=u.length-1,c=-1;for(a=p.length-1;a>=0;--a){const l=p.charCodeAt(a);if(l===y){if(!n){b=a+1;break}}else c===-1&&(n=!1,c=a+1),s>=0&&(l===u.charCodeAt(s)?--s==-1&&(t=a):(s=-1,t=c))}return b===t?t=c:t===-1&&(t=p.length),p.slice(b,t)}for(a=p.length-1;a>=0;--a)if(p.charCodeAt(a)===y){if(!n){b=a+1;break}}else t===-1&&(n=!1,t=a+1);return t===-1?"":p.slice(b,t)},extname(p){f(p,"path");let u=-1,b=0,t=-1,n=!0,a=0;for(let s=p.length-1;s>=0;--s){const c=p.charCodeAt(s);if(c===y){if(!n){b=s+1;break}continue}t===-1&&(n=!1,t=s+1),c===D?u===-1?u=s:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||t===-1||a===0||a===1&&u===t-1&&u===b+1?"":p.slice(u,t)},format:E.bind(null,"/"),parse(p){f(p,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return u;const b=p.charCodeAt(0)===y;let t;b?(u.root="/",t=1):t=0;let n=-1,a=0,s=-1,c=!0,l=p.length-1,h=0;for(;l>=t;--l){const P=p.charCodeAt(l);if(P===y){if(!c){a=l+1;break}continue}s===-1&&(c=!1,s=l+1),P===D?n===-1?n=l:h!==1&&(h=1):n!==-1&&(h=-1)}if(s!==-1){const P=a===0&&b?1:a;n===-1||h===0||h===1&&n===s-1&&n===a+1?u.base=u.name=p.slice(P,s):(u.name=p.slice(P,n),u.base=p.slice(P,s),u.ext=p.slice(n,s))}return a>0?u.dir=p.slice(0,a-1):b&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],we([0,1,21]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=_.globals.performance&&typeof _.globals.performance.now=="function";class A{constructor(S){this._highResolution=k&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new A(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=A}),define(be[3],we([0,1,11,54,6,45,56]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(m){m.None=()=>A.Disposable.None;function E(z){return(W,J=null,O)=>{let F=!1,N;return N=z(B=>{if(!F)return N?N.dispose():F=!0,W.call(J,B)},null,O),F&&N.dispose(),N}}m.once=E;function p(z,W){return s((J,O=null,F)=>z(N=>J.call(O,W(N)),null,F))}m.map=p;function u(z,W){return s((J,O=null,F)=>z(N=>{W(N),J.call(O,N)},null,F))}m.forEach=u;function b(z,W){return s((J,O=null,F)=>z(N=>W(N)&&J.call(O,N),null,F))}m.filter=b;function t(z){return z}m.signal=t;function n(...z){return(W,J=null,O)=>(0,A.combinedDisposable)(...z.map(F=>F(N=>W.call(J,N),null,O)))}m.any=n;function a(z,W,J){let O=J;return p(z,F=>(O=W(O,F),O))}m.reduce=a;function s(z){let W;const J=new d({onFirstListenerAdd(){W=z(J.fire,J)},onLastListenerRemove(){W.dispose()}});return J.event}m.snapshot=s;function c(z,W,J=100,O=!1,F){let N,B,U,Q=0;const Z=new d({leakWarningThreshold:F,onFirstListenerAdd(){N=z(ne=>{Q++,B=W(B,ne),O&&!U&&(Z.fire(B),B=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=B;B=void 0,U=void 0,(!O||Q>1)&&Z.fire(pe),Q=0},J)})},onLastListenerRemove(){N.dispose()}});return Z.event}m.debounce=c;function l(z){const W=new Date().getTime();return p(E(z),J=>new Date().getTime()-W)}m.stopwatch=l;function h(z){let W=!0,J;return b(z,O=>{const F=W||O!==J;return W=!1,J=O,F})}m.latch=h;function P(z,W=!1,J=[]){let O=J.slice(),F=z(U=>{O?O.push(U):B.fire(U)});const N=()=>{O&&O.forEach(U=>B.fire(U)),O=null},B=new d({onFirstListenerAdd(){F||(F=z(U=>B.fire(U)))},onFirstListenerDidAdd(){O&&(W?setTimeout(N):N())},onLastListenerRemove(){F&&F.dispose(),F=null}});return B.event}m.buffer=P;class g{constructor(W){this.event=W}map(W){return new g(p(this.event,W))}forEach(W){return new g(u(this.event,W))}filter(W){return new g(b(this.event,W))}reduce(W,J){return new g(a(this.event,W,J))}latch(){return new g(h(this.event))}debounce(W,J=100,O=!1,F){return new g(c(this.event,W,J,O,F))}on(W,J,O){return this.event(W,J,O)}once(W,J,O){return E(this.event)(W,J,O)}}function w(z){return new g(z)}m.chain=w;function R(z,W,J=O=>O){const O=(...U)=>B.fire(J(...U)),F=()=>z.on(W,O),N=()=>z.removeListener(W,O),B=new d({onFirstListenerAdd:F,onLastListenerRemove:N});return B.event}m.fromNodeEventEmitter=R;function L(z,W,J=O=>O){const O=(...U)=>B.fire(J(...U)),F=()=>z.addEventListener(W,O),N=()=>z.removeEventListener(W,O),B=new d({onFirstListenerAdd:F,onLastListenerRemove:N});return B.event}m.fromDOMEventEmitter=L;function V(z){const W=new d;let J=!1;return z.then(void 0,()=>null).then(()=>{J?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),J=!0,W.event}m.fromPromise=V;function he(z){return new Promise(W=>E(z)(W))}m.toPromise=he})(D=e.Event||(e.Event={}));class y{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${y._idPool++}`}start(E){this._stopWatch=new S.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let C=-1;function i(m){const E=C;return C=m,{dispose(){C=E}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(E,p=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let p=C;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),!(p<=0||E<p)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),b=this._stacks.get(u)||0;if(this._stacks.set(u,b+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let t,n=0;for(const[a,s]of this._stacks)(!t||n<s)&&(t=a,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class d{constructor(E){var p;this._disposed=!1,this._options=E,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((p=this._options)===null||p===void 0?void 0:p._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(E,p,u)=>{var b;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(p?[E,p]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,p);const a=(b=this._leakageMon)===null||b===void 0?void 0:b.check(this._listeners.size);let s;return s={dispose:()=>{a&&a(),s.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof A.DisposableStore?u.add(s):Array.isArray(u)&&u.push(s),s}),this._event}fire(E){var p,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let b of this._listeners)this._deliveryQueue.push([b,E]);for((p=this._perfMon)===null||p===void 0||p.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[b,t]=this._deliveryQueue.shift();try{typeof b=="function"?b.call(void 0,t):b[0].call(b[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var E,p,u;(E=this._listeners)===null||E===void 0||E.clear(),(p=this._deliveryQueue)===null||p===void 0||p.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class f extends d{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=f;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const p={event:E,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const u=()=>{this.hasListeners&&this.unhook(p);const b=this.events.indexOf(p);this.events.splice(b,1)};return(0,A.toDisposable)((0,k.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(p=>this.emitter.fire(p))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(E){return(p,u,b)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(u,t)):p.call(u,t)},void 0,b)}bufferEvents(E){const p=[];this.buffers.push(p);const u=E();return this.buffers.pop(),p.forEach(b=>b()),u}}e.EventBufferer=o;class v{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=A.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(be[20],we([0,1,3]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(D,y){const C=setTimeout(D.bind(y),0);return{dispose(){clearTimeout(C)}}});var A;(function(D){function y(C){return C===D.None||C===D.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=y,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=S}),define(be[36],we([0,1,3]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(I){const d=this._icons.get(I.id);d?I.description?d.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new k;e.iconRegistry=A;function T(i,I){return new D(i,I)}e.registerCodicon=T;function S(i){return i?i.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=S;class D{constructor(I,d,f){this.id=I,this.definition=d,this.description=f,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function y(i,I){const d=["codicon","codicon-"+i];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=y;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(o){if(o instanceof D)return["codicon","codicon-"+o.id];const v=I.exec(o.id);if(!v)return d(D.error);let[,m,E]=v;const p=["codicon","codicon-"+m];return E&&p.push("codicon-modifier-"+E.substr(1)),p}i.asClassNameArray=d;function f(o){return d(o).join(" ")}i.asClassName=f;function r(o){return"."+d(o).join(".")}i.asCSSSelector=r})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(be[108],we([0,1,11,6]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(p){const u=p;return u?[u.on,u.pause,u.resume,u.destroy].every(b=>typeof b=="function"):!1}e.isReadableStream=A;function T(p){const u=p;return u?A(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function S(p,u){return new D(p,u)}e.newWriteableStream=S;class D{constructor(u,b){this.reducer=u,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){var b;if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof((b=this.options)===null||b===void 0?void 0:b.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(b=>b(u))}emitError(u){this.listeners.error.length===0?(0,_.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(b=>b(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,b){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(u,b){if(!this.state.destroyed){let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(b);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(p,u){const b=[];let t;for(;(t=p.read())!==null;)b.push(t);return u(b)}e.consumeReadable=y;function C(p,u,b){const t=[];let n;for(;(n=p.read())!==null&&t.length<b;)t.push(n);return n===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const a=n;return n=void 0,a}return p.read()}}}e.peekReadable=C;function i(p,u){return new Promise((b,t)=>{const n=[];I(p,{onData:a=>{u&&n.push(a)},onError:a=>{u?t(a):b(void 0)},onEnd:()=>{b(u?u(n):void 0)}})})}e.consumeStream=i;function I(p,u){p.on("error",b=>u.onError(b)),p.on("end",()=>u.onEnd()),p.on("data",b=>u.onData(b))}e.listenStream=I;function d(p,u){return new Promise((b,t)=>{const n=new k.DisposableStore,a=[],s=h=>{if(a.push(h),a.length>u)return n.dispose(),p.pause(),b({stream:p,buffer:a,ended:!1})},c=h=>t(h),l=()=>b({stream:p,buffer:a,ended:!0});n.add((0,k.toDisposable)(()=>p.removeListener("error",c))),p.on("error",c),n.add((0,k.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),n.add((0,k.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=d;function f(p,u){const b=S(u);return b.end(p),b}e.toStream=f;function r(){const p=S(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=r;function o(p){let u=!1;return{read:()=>u?null:(u=!0,p)}}e.toReadable=o;function v(p,u,b){const t=S(b);return I(p,{onData:n=>t.write(u.data(n)),onError:n=>t.error(u.error?u.error(n):n),onEnd:()=>t.end()}),t}e.transform=v;function m(p,u,b){let t=!1;return{read:()=>{const n=u.read();return t?n:(t=!0,n!==null?b([p,n]):p)}}}e.prefixedReadable=m;function E(p,u,b){let t=!1;const n=S(b);return I(u,{onData:a=>t?n.write(a):(t=!0,n.write(b([p,a]))),onError:a=>n.error(a),onEnd:()=>{t||(t=!0,n.write(p)),n.end()}}),n}e.prefixedStream=E}),define(be[8],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function A(H,...se){return se.length===0?H:H.replace(k,function(de,K){const ee=parseInt(K,10);return isNaN(ee)||ee<0||ee>=se.length?de:se[ee]})}e.format=A;function T(H){return H.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=T;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function D(H,se){let de=0;const K=se.charCodeAt(0);for(let ee=H.length-1;ee>=0;ee--)H.charCodeAt(ee)===K&&de++;return de}e.count=D;function y(H,se,de="\u2026"){return H.length<=se?H:`${H.substr(0,se)}${de}`}e.truncate=y;function C(H,se=" "){const de=i(H,se);return I(de,se)}e.trim=C;function i(H,se){if(!H||!se)return H;const de=se.length;if(de===0||H.length===0)return H;let K=0;for(;H.indexOf(se,K)===K;)K=K+de;return H.substring(K)}e.ltrim=i;function I(H,se){if(!H||!se)return H;const de=se.length,K=H.length;if(de===0||K===0)return H;let ee=K,le=-1;for(;le=H.lastIndexOf(se,ee-1),!(le===-1||le+de!==ee);){if(le===0)return"";ee=le}return H.substring(0,ee)}e.rtrim=I;function d(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(H){return H.replace(/\*/g,"")}e.stripWildcards=f;function r(H,se,de={}){if(!H)throw new Error("Cannot create regex from empty string");se||(H=S(H)),de.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let K="";return de.global&&(K+="g"),de.matchCase||(K+="i"),de.multiline&&(K+="m"),de.unicode&&(K+="u"),new RegExp(H,K)}e.createRegExp=r;function o(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function v(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function m(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=m;function E(H){return H.split(/\r\n|\r|\n/)}e.splitLines=E;function p(H){for(let se=0,de=H.length;se<de;se++){const K=H.charCodeAt(se);if(K!==32&&K!==9)return se}return-1}e.firstNonWhitespaceIndex=p;function u(H,se=0,de=H.length){for(let K=se;K<de;K++){const ee=H.charCodeAt(K);if(ee!==32&&ee!==9)return H.substring(se,K)}return H.substring(se,de)}e.getLeadingWhitespace=u;function b(H,se=H.length-1){for(let de=se;de>=0;de--){const K=H.charCodeAt(de);if(K!==32&&K!==9)return de}return-1}e.lastNonWhitespaceIndex=b;function t(H,se){return H<se?-1:H>se?1:0}e.compare=t;function n(H,se,de=0,K=H.length,ee=0,le=se.length){for(;de<K&&ee<le;de++,ee++){let Ve=H.charCodeAt(de),Fe=se.charCodeAt(ee);if(Ve<Fe)return-1;if(Ve>Fe)return 1}const fe=K-de,Ee=le-ee;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstring=n;function a(H,se){return s(H,se,0,H.length,0,se.length)}e.compareIgnoreCase=a;function s(H,se,de=0,K=H.length,ee=0,le=se.length){for(;de<K&&ee<le;de++,ee++){let Ve=H.charCodeAt(de),Fe=se.charCodeAt(ee);if(Ve!==Fe){const We=Ve-Fe;if(!(We===32&&l(Fe))&&!(We===-32&&l(Ve)))return c(Ve)&&c(Fe)?We:n(H.toLowerCase(),se.toLowerCase(),de,K,ee,le)}}const fe=K-de,Ee=le-ee;return fe<Ee?-1:fe>Ee?1:0}e.compareSubstringIgnoreCase=s;function c(H){return H>=97&&H<=122}e.isLowerAsciiLetter=c;function l(H){return H>=65&&H<=90}e.isUpperAsciiLetter=l;function h(H){return c(H)||l(H)}function P(H,se){return H.length===se.length&&g(H,se)}e.equalsIgnoreCase=P;function g(H,se,de=H.length){for(let K=0;K<de;K++){const ee=H.charCodeAt(K),le=se.charCodeAt(K);if(ee!==le){if(h(ee)&&h(le)){const fe=Math.abs(ee-le);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(ee).toLowerCase()!==String.fromCharCode(le).toLowerCase())return!1}}return!0}function w(H,se){const de=se.length;return se.length>H.length?!1:g(H,se,de)}e.startsWithIgnoreCase=w;function R(H,se){let de,K=Math.min(H.length,se.length);for(de=0;de<K;de++)if(H.charCodeAt(de)!==se.charCodeAt(de))return de;return K}e.commonPrefixLength=R;function L(H,se){let de,K=Math.min(H.length,se.length);const ee=H.length-1,le=se.length-1;for(de=0;de<K;de++)if(H.charCodeAt(ee-de)!==se.charCodeAt(le-de))return de;return K}e.commonSuffixLength=L;function V(H){return 55296<=H&&H<=56319}e.isHighSurrogate=V;function he(H){return 56320<=H&&H<=57343}e.isLowSurrogate=he;function z(H,se){return(H-55296<<10)+(se-56320)+65536}e.computeCodePoint=z;function W(H,se,de){const K=H.charCodeAt(de);if(V(K)&&de+1<se){const ee=H.charCodeAt(de+1);if(he(ee))return z(K,ee)}return K}e.getNextCodePoint=W;function J(H,se){const de=H.charCodeAt(se-1);if(he(de)&&se>1){const K=H.charCodeAt(se-2);if(V(K))return z(K,de)}return de}function O(H,se){const de=$e.getInstance(),K=se,ee=H.length,le=W(H,ee,se);se+=le>=65536?2:1;let fe=de.getGraphemeBreakType(le);for(;se<ee;){const Ee=W(H,ee,se),Ve=de.getGraphemeBreakType(Ee);if(Ue(fe,Ve))break;se+=Ee>=65536?2:1,fe=Ve}return se-K}e.nextCharLength=O;function F(H,se){const de=$e.getInstance(),K=se,ee=J(H,se);se-=ee>=65536?2:1;let le=de.getGraphemeBreakType(ee);for(;se>0;){const fe=J(H,se),Ee=de.getGraphemeBreakType(fe);if(Ue(Ee,le))break;se-=fe>=65536?2:1,le=Ee}return K-se}e.prevCharLength=F;function N(H,se){const de=$e.getInstance(),K=H.length,ee=se,le=W(H,K,se),fe=de.getGraphemeBreakType(le);se+=le>=65536?2:1;let Ee=fe;for(;se<K;){const Fe=W(H,K,se),We=de.getGraphemeBreakType(Fe);if(Ue(Ee,We))break;se+=Fe>=65536?2:1,Ee=We}const Ve=se;for(se=ee,Ee=fe;se>0;){const Fe=J(H,se),We=de.getGraphemeBreakType(Fe);if(Ue(We,Ee))break;se-=Fe>=65536?2:1,Ee=We}return[se,Ve]}function B(H,se){return se>0&&he(H.charCodeAt(se))?N(H,se-1):N(H,se)}e.getCharContainingOffset=B;function U(H){const se=H.length;let de=0,K=0;for(;K<se;){const fe=W(H,se,K);K+=fe>=65536?2:1,fe<128?de+=1:fe<2048?de+=2:fe<65536?de+=3:de+=4}const ee=new Uint8Array(de);K=0;let le=0;for(;K<se;){const fe=W(H,se,K);K+=fe>=65536?2:1,fe<128?ee[le++]=fe:fe<2048?(ee[le++]=192|(fe&1984)>>>6,ee[le++]=128|(fe&63)>>>0):fe<65536?(ee[le++]=224|(fe&61440)>>>12,ee[le++]=128|(fe&4032)>>>6,ee[le++]=128|(fe&63)>>>0):(ee[le++]=240|(fe&1835008)>>>18,ee[le++]=128|(fe&258048)>>>12,ee[le++]=128|(fe&4032)>>>6,ee[le++]=128|(fe&63)>>>0)}return ee}e.encodeUTF8=U;function Q(H){const se=H.byteLength,de=[];let K=0;for(;K<se;){const ee=H[K];let le;if(ee>=240&&K+3<se?le=(H[K++]&7)<<18>>>0|(H[K++]&63)<<12>>>0|(H[K++]&63)<<6>>>0|(H[K++]&63)<<0>>>0:ee>=224&&K+2<se?le=(H[K++]&15)<<12>>>0|(H[K++]&63)<<6>>>0|(H[K++]&63)<<0>>>0:ee>=192&&K+1<se?le=(H[K++]&31)<<6>>>0|(H[K++]&63)<<0>>>0:le=H[K++],le>=0&&le<=55295||le>=57344&&le<=65535)de.push(String.fromCharCode(le));else if(le>=65536&&le<=1114111){const fe=le-65536,Ee=55296+((fe&1047552)>>>10),Ve=56320+((fe&1023)>>>0);de.push(String.fromCharCode(Ee)),de.push(String.fromCharCode(Ve))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ne(H){return Z.test(H)}e.containsRTL=ne;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Pe(H){return pe.test(H)}e.containsEmoji=Pe;const Oe=/^[\t\n\r\x20-\x7E]*$/;function Te(H){return Oe.test(H)}e.isBasicASCII=Te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function xe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=xe;function $(H){for(let se=0,de=H.length;se<de;se++)if(G(H.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=$;function G(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=G;function ie(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ie;function oe(H,se){if(H.length<se)return H;const de=/\b/g;let K=0;for(;de.test(H)&&!(H.length-de.lastIndex<se);)K=de.lastIndex,de.lastIndex+=1;return H.substring(K).replace(/^\s/,"")}e.lcut=oe;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ne=/\x1b\[0?m/g;function ge(H){return H&&(H=H.replace(me,""),H=H.replace(De,""),H=H.replace(Ne,"")),H}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Ae;function Be(H,se){if(!H||!se||H.length<se.length)return!1;const de=se.length,K=H.toLowerCase();let ee=0,le=-1;for(;ee<de;){const fe=K.indexOf(se[ee],le+1);if(fe<0)return!1;le=fe,ee++}return!0}e.fuzzyContains=Be;function _e(H,se=!1){return H?(se&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function qe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=qe;function j(H,se=1){if(se===0)return"";let de=-1;do de=H.indexOf(`
`,de+1),se--;while(se>0&&de>=0);return de===-1?H:(H[de-1]==="\r"&&de--,H.substr(0,de))}e.getNLines=j;function te(H){const se=90-65+1;return H=H%(2*se),H<se?String.fromCharCode(97+H):String.fromCharCode(65+H-se)}e.singleLetterHash=te;function ve(H){return $e.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=ve;function Ue(H,se){return H===0?se!==5&&se!==7:H===2&&se===3?!1:H===4||H===2||H===3||se===4||se===2||se===3?!0:!(H===8&&(se===8||se===9||se===11||se===12)||(H===11||H===9)&&(se===9||se===10)||(H===12||H===10)&&se===10||se===5||se===13||se===7||H===1||H===13&&se===14||H===6&&se===6)}e.breakBetweenGraphemeBreakType=Ue;var He;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ye()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const de=this._data,K=de.length/3;let ee=1;for(;ee<=K;)if(se<de[3*ee])ee=2*ee;else if(se>de[3*ee+1])ee=2*ee+1;else return de[3*ee+2];return 0}}$e._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[23],we([0,1,8,108]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let D,y;class C{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return A?new C(Buffer.allocUnsafe(h)):new C(new Uint8Array(h))}static wrap(h){return A&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new C(h)}static fromString(h,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&A?new C(Buffer.from(h)):T?(D||(D=new TextEncoder),new C(D.encode(h))):new C(_.encodeUTF8(h))}static concat(h,P){if(typeof P=="undefined"){P=0;for(let R=0,L=h.length;R<L;R++)P+=h[R].byteLength}const g=C.alloc(P);let w=0;for(let R=0,L=h.length;R<L;R++){const V=h[R];g.set(V,w),w+=V.byteLength}return g}toString(){return A?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(h,P){return new C(this.buffer.subarray(h,P))}set(h,P){h instanceof C?this.buffer.set(h.buffer,P):this.buffer.set(h,P)}readUInt32BE(h){return d(this.buffer,h)}writeUInt32BE(h,P){f(this.buffer,h,P)}readUInt32LE(h){return r(this.buffer,h)}writeUInt32LE(h,P){o(this.buffer,h,P)}readUInt8(h){return v(this.buffer,h)}writeUInt8(h,P){m(this.buffer,h,P)}}e.VSBuffer=C;function i(l,h){return l[h+0]<<0>>>0|l[h+1]<<8>>>0}e.readUInt16LE=i;function I(l,h,P){l[P+0]=h&255,h=h>>>8,l[P+1]=h&255}e.writeUInt16LE=I;function d(l,h){return l[h]*2**24+l[h+1]*2**16+l[h+2]*2**8+l[h+3]}e.readUInt32BE=d;function f(l,h,P){l[P+3]=h,h=h>>>8,l[P+2]=h,h=h>>>8,l[P+1]=h,h=h>>>8,l[P]=h}e.writeUInt32BE=f;function r(l,h){return l[h+0]<<0>>>0|l[h+1]<<8>>>0|l[h+2]<<16>>>0|l[h+3]<<24>>>0}e.readUInt32LE=r;function o(l,h,P){l[P+0]=h&255,h=h>>>8,l[P+1]=h&255,h=h>>>8,l[P+2]=h&255,h=h>>>8,l[P+3]=h&255}e.writeUInt32LE=o;function v(l,h){return l[h]}e.readUInt8=v;function m(l,h,P){l[P]=h}e.writeUInt8=m;function E(l){return k.consumeReadable(l,h=>C.concat(h))}e.readableToBuffer=E;function p(l){return k.toReadable(l)}e.bufferToReadable=p;function u(l){return k.consumeStream(l,h=>C.concat(h))}e.streamToBuffer=u;async function b(l){return l.ended?C.concat(l.buffer):C.concat([...l.buffer,await u(l.stream)])}e.bufferedStreamToBuffer=b;function t(l){return k.toStream(l,h=>C.concat(h))}e.bufferToStream=t;function n(l){return k.transform(l,{data:h=>typeof h=="string"?C.fromString(h):C.wrap(h)},h=>C.concat(h))}e.streamToBufferReadableStream=n;function a(l){return k.newWriteableStream(h=>C.concat(h),l)}e.newWriteableBufferStream=a;function s(l,h){return k.prefixedReadable(l,h,P=>C.concat(P))}e.prefixedBufferReadable=s;function c(l,h){return k.prefixedStream(l,h,P=>C.concat(P))}e.prefixedBufferStream=c}),define(be[57],we([0,1,8]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(m){return A(m,0)}e.hash=k;function A(m,E){switch(typeof m){case"object":return m===null?T(349,E):Array.isArray(m)?y(m,E):C(m,E);case"string":return D(m,E);case"boolean":return S(m,E);case"number":return T(m,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=A;function T(m,E){return(E<<5)-E+m|0}function S(m,E){return T(m?433:863,E)}function D(m,E){E=T(149417,E);for(let p=0,u=m.length;p<u;p++)E=T(m.charCodeAt(p),E);return E}e.stringHash=D;function y(m,E){return E=T(104579,E),m.reduce((p,u)=>A(u,p),E)}function C(m,E){return E=T(181387,E),Object.keys(m).sort().reduce((p,u)=>(p=D(u,p),A(m[u],p)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=A(E,this._value),this._value}}e.Hasher=i;var I;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(m,E,p=32){const u=p-E,b=~((1<<u)-1);return(m<<E|(b&m)>>>u)>>>0}function f(m,E=0,p=m.byteLength,u=0){for(let b=0;b<p;b++)m[E+b]=u}function r(m,E,p="0"){for(;m.length<E;)m=p+m;return m}function o(m,E=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(p=>p.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),E/4)}e.toHexString=o;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const p=E.length;if(p!==0){const u=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,n,a;for(t!==0?(n=t,a=-1,t=0):(n=E.charCodeAt(0),a=0);;){let s=n;if(_.isHighSurrogate(n))if(a+1<p){const c=E.charCodeAt(a+1);_.isLowSurrogate(c)?(a++,s=_.computeCodePoint(n,c)):s=65533}else{t=n;break}else _.isLowSurrogate(n)&&(s=65533);if(b=this._push(u,b,s),a++,a<p)n=E.charCodeAt(a);else break}this._buffLen=b,this._leftoverHighSurrogate=t}}_push(E,p,u){return u<128?E[p++]=u:u<2048?(E[p++]=192|(u&1984)>>>6,E[p++]=128|(u&63)>>>0):u<65536?(E[p++]=224|(u&61440)>>>12,E[p++]=128|(u&4032)>>>6,E[p++]=128|(u&63)>>>0):(E[p++]=240|(u&1835008)>>>18,E[p++]=128|(u&258048)>>>12,E[p++]=128|(u&4032)>>>6,E[p++]=128|(u&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=v._bigBlock32,p=this._buffDV;for(let h=0;h<64;h+=4)E.setUint32(h,p.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)E.setUint32(h,d(E.getUint32(h-12,!1)^E.getUint32(h-32,!1)^E.getUint32(h-56,!1)^E.getUint32(h-64,!1),1),!1);let u=this._h0,b=this._h1,t=this._h2,n=this._h3,a=this._h4,s,c,l;for(let h=0;h<80;h++)h<20?(s=b&t|~b&n,c=1518500249):h<40?(s=b^t^n,c=1859775393):h<60?(s=b&t|b&n|t&n,c=2400959708):(s=b^t^n,c=3395469782),l=d(u,5)+s+a+c+E.getUint32(h*4,!1)&4294967295,a=n,n=t,t=d(b,30),b=u,u=l;this._h0=this._h0+u&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],we([0,1,8]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(k||(k={})),function(A){const T="error",S="warning",D="warn",y="info";function C(i){return i?_.equalsIgnoreCase(T,i)?A.Error:_.equalsIgnoreCase(S,i)||_.equalsIgnoreCase(D,i)?A.Warning:_.equalsIgnoreCase(y,i)?A.Info:A.Ignore:A.Ignore}A.fromValue=C}(k||(k={})),e.default=k}),define(be[10],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(h){return Array.isArray(h)}e.isArray=_;function k(h){return typeof h=="string"}e.isString=k;function A(h){return Array.isArray(h)&&h.every(P=>k(P))}e.isStringArray=A;function T(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=T;function S(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=S;function D(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=D;function y(h){return h===!0||h===!1}e.isBoolean=y;function C(h){return typeof h=="undefined"}e.isUndefined=C;function i(h){return!I(h)}e.isDefined=i;function I(h){return C(h)||h===null}e.isUndefinedOrNull=I;function d(h,P){if(!h)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=d;function f(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=f;function r(...h){const P=[];for(let g=0;g<h.length;g++){const w=h[g];if(I(w))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);P.push(w)}return P}e.assertAllDefined=r;const o=Object.prototype.hasOwnProperty;function v(h){if(!T(h))return!1;for(let P in h)if(o.call(h,P))return!1;return!0}e.isEmptyObject=v;function m(h){return typeof h=="function"}e.isFunction=m;function E(...h){return h.length>0&&h.every(m)}e.areFunctions=E;function p(h,P){const g=Math.min(h.length,P.length);for(let w=0;w<g;w++)u(h[w],P[w])}e.validateConstraints=p;function u(h,P){if(k(P)){if(typeof h!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(m(P)){try{if(h instanceof P)return}catch(g){}if(!I(h)&&h.constructor===P||P.length===1&&P.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function b(h){let P=[],g=Object.getPrototypeOf(h);for(;Object.prototype!==g;)P=P.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return P}e.getAllPropertyNames=b;function t(h){const P=[];for(const g of b(h))typeof h[g]=="function"&&P.push(g);return P}e.getAllMethodNames=t;function n(h,P){const g=R=>function(){const L=Array.prototype.slice.call(arguments,0);return P(R,L)};let w={};for(const R of h)w[R]=g(R);return w}e.createProxyObject=n;function a(h){return h===null?void 0:h}e.withNullAsUndefined=a;function s(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=s;function c(h){return class{constructor(){return new Proxy({},{get(P,g){if(P[g])return P[g];throw new Error(`Not Implemented: ${h}->${String(g)}`)}})}}}e.NotImplementedProxy=c;function l(h){throw new Error("Unreachable")}e.assertNever=l}),define(be[37],we([0,1,21,8,13,10]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(n){return n===47||n===92}e.isPathSeparator=S;function D(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=D;function y(n,a=A.posix.sep){if(!n)return"";const s=n.length,c=n.charCodeAt(0);if(S(c)){if(S(n.charCodeAt(1))&&!S(n.charCodeAt(2))){let h=3;const P=h;for(;h<s&&!S(n.charCodeAt(h));h++);if(P!==h&&!S(n.charCodeAt(h+1))){for(h+=1;h<s;h++)if(S(n.charCodeAt(h)))return n.slice(0,h+1).replace(/[\\/]/g,a)}}return a}else if(v(c)&&n.charCodeAt(1)===58)return S(n.charCodeAt(2))?n.slice(0,2)+a:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<s;l++)if(S(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=y;function C(n){if(!_.isWindows||!n||n.length<5)return!1;let a=n.charCodeAt(0);if(a!==92||(a=n.charCodeAt(1),a!==92))return!1;let s=2;const c=s;for(;s<n.length&&(a=n.charCodeAt(s),a!==92);s++);return!(c===s||(a=n.charCodeAt(s+1),isNaN(a)||a===92))}e.isUNC=C;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,a=_.isWindows){const s=a?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||a&&d.test(n)||n==="."||n===".."||a&&n[n.length-1]==="."||a&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function r(n,a,s){const c=n===a;return!s||c?c:!n||!a?!1:(0,k.equalsIgnoreCase)(n,a)}e.isEqual=r;function o(n,a,s,c=A.sep){if(n===a)return!0;if(!n||!a||a.length>n.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(n,a))return!1;if(a.length===n.length)return!0;let h=a.length;return a.charAt(a.length-1)===c&&h--,n.charAt(h)===c}return a.charAt(a.length-1)!==c&&(a+=c),n.indexOf(a)===0}e.isEqualOrParent=o;function v(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=v;function m(n,a){return _.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(a,n)),n=(0,A.normalize)(n),_.isWindows?(n=(0,k.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,k.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=m;function E(n){const a=(0,A.normalize)(n);return _.isWindows?n.length>3?!1:p(a)&&(n.length===2||a.charCodeAt(2)===92):a===A.posix.sep}e.isRootOrDriveLetter=E;function p(n){return _.isWindows?v(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function u(n){return p(n)?n[0]:void 0}e.getDriveLetter=u;function b(n,a,s){return a.length>n.length?-1:n===a?0:(s&&(n=n.toLowerCase(),a=a.toLowerCase()),n.indexOf(a))}e.indexOfPath=b;function t(n){const a=n.split(":");let s,c,l;if(a.forEach(h=>{const P=Number(h);(0,T.isNumber)(P)?c===void 0?c=P:l===void 0&&(l=P):s=s?[s,h].join(":"):h}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[24],we([0,1,10]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const o=Array.isArray(r)?[]:{};return Object.keys(r).forEach(v=>{r[v]&&typeof r[v]=="object"?o[v]=k(r[v]):o[v]=r[v]}),o}e.deepClone=k;function A(r){if(!r||typeof r!="object")return r;const o=[r];for(;o.length>0;){const v=o.shift();Object.freeze(v);for(const m in v)if(T.call(v,m)){const E=v[m];typeof E=="object"&&!Object.isFrozen(E)&&o.push(E)}}return r}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function S(r,o){return D(r,o,new Set)}e.cloneAndChange=S;function D(r,o,v){if((0,_.isUndefinedOrNull)(r))return r;const m=o(r);if(typeof m!="undefined")return m;if((0,_.isArray)(r)){const E=[];for(const p of r)E.push(D(p,o,v));return E}if((0,_.isObject)(r)){if(v.has(r))throw new Error("Cannot clone recursive data-structure");v.add(r);const E={};for(let p in r)T.call(r,p)&&(E[p]=D(r[p],o,v));return v.delete(r),E}return r}function y(r,o,v=!0){return(0,_.isObject)(r)?((0,_.isObject)(o)&&Object.keys(o).forEach(m=>{m in r?v&&((0,_.isObject)(r[m])&&(0,_.isObject)(o[m])?y(r[m],o[m],v):r[m]=o[m]):r[m]=o[m]}),r):o}e.mixin=y;function C(r,o){if(r===o)return!0;if(r==null||o===null||o===void 0||typeof r!=typeof o||typeof r!="object"||Array.isArray(r)!==Array.isArray(o))return!1;let v,m;if(Array.isArray(r)){if(r.length!==o.length)return!1;for(v=0;v<r.length;v++)if(!C(r[v],o[v]))return!1}else{const E=[];for(m in r)E.push(m);E.sort();const p=[];for(m in o)p.push(m);if(p.sort(),!C(E,p))return!1;for(v=0;v<E.length;v++)if(!C(r[E[v]],o[E[v]]))return!1}return!0}e.equals=C;function i(r){const o=new Set;return JSON.stringify(r,(v,m)=>{if((0,_.isObject)(m)||Array.isArray(m)){if(o.has(m))return"[Circular]";o.add(m)}return m})}e.safeStringify=i;function I(r,o,v){const m=o(r);return typeof m=="undefined"?v:m}e.getOrDefault=I;function d(r,o){const v=Object.create(null);return!r||!o||Object.keys(o).forEach(E=>{const p=r[E],u=o[E];C(p,u)||(v[E]=u)}),v}e.distinct=d;function f(r,o){const v=o.toLowerCase(),m=Object.keys(r).find(E=>E.toLowerCase()===v);return m?r[m]:r[o]}e.getCaseInsensitive=f}),define(be[82],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function k(T){return T<0?0:T>255?255:T|0}e.toUint8=k;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(be[2],we([0,1,21,13]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,S=/^\/\//;function D(a,s){if(!a.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!A.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!T.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,s){return!a&&!s?"file":a}function C(a,s){switch(a){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const i="",I="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(s,c,l,h,P,g=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=y(s,g),this.authority=c||i,this.path=C(this.scheme,l||i),this.query=h||i,this.fragment=P||i,D(this,g))}static isUri(s){return s instanceof f?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:c,authority:l,path:h,query:P,fragment:g}=s;return c===void 0?c=this.scheme:c===null&&(c=i),l===void 0?l=this.authority:l===null&&(l=i),h===void 0?h=this.path:h===null&&(h=i),P===void 0?P=this.query:P===null&&(P=i),g===void 0?g=this.fragment:g===null&&(g=i),c===this.scheme&&l===this.authority&&h===this.path&&P===this.query&&g===this.fragment?this:new o(c,l,h,P,g)}static parse(s,c=!1){const l=d.exec(s);return l?new o(l[2]||i,n(l[4]||i),n(l[5]||i),n(l[7]||i),n(l[9]||i),c):new o(i,i,i,i,i)}static file(s){let c=i;if(_.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const l=s.indexOf(I,2);l===-1?(c=s.substring(2),s=I):(c=s.substring(2,l),s=s.substring(l)||I)}return new o("file",c,s,i,i)}static from(s){return new o(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...c){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return _.isWindows&&s.scheme==="file"?l=f.file(k.win32.join(p(s,!0),...c)).path:l=k.posix.join(s.path,...c),s.with({path:l})}toString(s=!1){return u(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof f)return s;{const c=new o(s);return c._formatted=s.external,c._fsPath=s._sep===r?s.fsPath:null,c}}else return s}}e.URI=f;const r=_.isWindows?1:void 0;class o extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=r),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(a,s){let c,l=-1;for(let h=0;h<a.length;h++){const P=a.charCodeAt(h);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||s&&P===47)l!==-1&&(c+=encodeURIComponent(a.substring(l,h)),l=-1),c!==void 0&&(c+=a.charAt(h));else{c===void 0&&(c=a.substr(0,h));const g=v[P];g!==void 0?(l!==-1&&(c+=encodeURIComponent(a.substring(l,h)),l=-1),c+=g):l===-1&&(l=h)}}return l!==-1&&(c+=encodeURIComponent(a.substring(l))),c!==void 0?c:a}function E(a){let s;for(let c=0;c<a.length;c++){const l=a.charCodeAt(c);l===35||l===63?(s===void 0&&(s=a.substr(0,c)),s+=v[l]):s!==void 0&&(s+=a[c])}return s!==void 0?s:a}function p(a,s){let c;return a.authority&&a.path.length>1&&a.scheme==="file"?c=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?s?c=a.path.substr(1):c=a.path[1].toLowerCase()+a.path.substr(2):c=a.path,_.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=p;function u(a,s){const c=s?E:m;let l="",{scheme:h,authority:P,path:g,query:w,fragment:R}=a;if(h&&(l+=h,l+=":"),(P||h==="file")&&(l+=I,l+=I),P){let L=P.indexOf("@");if(L!==-1){const V=P.substr(0,L);P=P.substr(L+1),L=V.indexOf(":"),L===-1?l+=c(V,!1):(l+=c(V.substr(0,L),!1),l+=":",l+=c(V.substr(L+1),!1)),l+="@"}P=P.toLowerCase(),L=P.indexOf(":"),L===-1?l+=c(P,!1):(l+=c(P.substr(0,L),!1),l+=P.substr(L))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const L=g.charCodeAt(1);L>=65&&L<=90&&(g=`/${String.fromCharCode(L+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const L=g.charCodeAt(0);L>=65&&L<=90&&(g=`${String.fromCharCode(L+32)}:${g.substr(2)}`)}l+=c(g,!0)}return w&&(l+="?",l+=c(w,!1)),R&&(l+="#",l+=s?R:m(R,!1)),l}function b(a){try{return decodeURIComponent(a)}catch(s){return a.length>3?a.substr(0,3)+b(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(a){return a.match(t)?a.replace(t,s=>b(s)):a}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[22],we([0,1,2,8]),function(Y,e,_,k){"use strict";var A,T,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,a){let s=t.get(n);return s===void 0&&(s=a,t.set(n,s)),s}e.getOrSet=D;function y(t){const n=[];return t.forEach((a,s)=>{n.push(`${s} => ${a}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=y;function C(t){const n=[];return t.forEach(a=>{n.push(a)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const a=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return a-s}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class d{constructor(n=!0,a=!0){this._splitOnBackslash=n,this._caseSensitive=a}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(n){this._iter=n}static forUris(n=()=>!1){return new v(new r(n))}static forPaths(){return new v(new d)}static forStrings(){return new v(new i)}static forConfigKeys(){return new v(new I)}clear(){this._root=void 0}set(n,a){const s=this._iter.reset(n);let c;for(this._root||(this._root=new o,this._root.segment=s.value()),c=this._root;;){const h=s.cmp(c.segment);if(h>0)c.left||(c.left=new o,c.left.segment=s.value()),c=c.left;else if(h<0)c.right||(c.right=new o,c.right.segment=s.value()),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new o,c.mid.segment=s.value()),c=c.mid;else break}const l=c.value;return c.value=a,c.key=n,l}get(n){var a;return(a=this._getNode(n))===null||a===void 0?void 0:a.value}_getNode(n){const a=this._iter.reset(n);let s=this._root;for(;s;){const c=a.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else break}return s}has(n){const a=this._getNode(n);return!((a==null?void 0:a.value)===void 0&&(a==null?void 0:a.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,a){const s=this._iter.reset(n),c=[];let l=this._root;for(;l;){const h=s.cmp(l.segment);if(h>0)c.push([1,l]),l=l.left;else if(h<0)c.push([-1,l]),l=l.right;else if(s.hasNext())s.next(),c.push([0,l]),l=l.mid;else{for(a?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;c.length>0&&l.isEmpty();){let[P,g]=c.pop();switch(P){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}l=g}break}}}findSubstr(n){const a=this._iter.reset(n);let s=this._root,c;for(;s;){const l=a.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(a.hasNext())a.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(n){const a=this._iter.reset(n);let s=this._root;for(;s;){const c=a.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[a,s]of this)n(s,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=v;class m{constructor(n,a){this[A]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=a!=null?a:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,a){return this.map.set(this.toKey(n),a),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,a){typeof a!="undefined"&&(n=n.bind(a));for(let[s,c]of this.map)n(c,_.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield _.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[_.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[_.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class p{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,a=0){const s=this._map.get(n);if(!!s)return a!==0&&this.touch(s,a),s.value}set(n,a,s=0){let c=this._map.get(n);if(c)c.value=a,s!==0&&this.touch(c,s);else{switch(c={key:n,value:a,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this._map.get(n);if(!!a)return this._map.delete(n),this.removeItem(a),this._size--,a.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,a){const s=this._state;let c=this._head;for(;c;){if(a?n.bind(a)(c.value,c.key,this):n(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,a=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.key,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return c}values(){const n=this,a=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.value,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return c}entries(){const n=this,a=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:[s.key,s.value],done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return c}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let a=this._head,s=this.size;for(;a&&s>n;)this._map.delete(a.key),a=a.next,s--;this._head=a,this._size=s,a&&(a.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const a=n.next,s=n.previous;if(!a||!s)throw new Error("Invalid list");a.previous=s,s.next=a}n.next=void 0,n.previous=void 0,this._state++}touch(n,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this._head)return;const s=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(a===2){if(n===this._tail)return;const s=n.next,c=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((a,s)=>{n.push([s,a])}),n}fromJSON(n){this.clear();for(const[a,s]of n)this.set(a,s)}}e.LinkedMap=p;class u extends p{constructor(n,a=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class b{constructor(n){S.set(this,void 0),tt(this,S,n,"f")}get size(){return Me(this,S,"f").size}forEach(n,a){Me(this,S,"f").forEach(n,a)}get(n){return Me(this,S,"f").get(n)}has(n){return Me(this,S,"f").has(n)}entries(){return Me(this,S,"f").entries()}keys(){return Me(this,S,"f").keys()}values(){return Me(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Me(this,S,"f").entries()}}e.ReadonlyMapView=b}),define(be[109],we([0,1,22,8]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Ae){for(let Be=0,_e=ge.length;Be<_e;Be++){const qe=ge[Be](Ce,Ae);if(qe)return qe}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Be;return ge?Be=k.startsWithIgnoreCase(Ae,Ce):Be=Ae.indexOf(Ce)===0,Be?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Ae=Ce.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}e.matchesContiguousSubString=S;function D(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function y(ge,Ce,Ae,Be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(ge[Ae]===Ce[Be]){let _e=null;return(_e=y(ge,Ce,Ae+1,Be+1))?m({start:Be,end:Be+1},_e):null}return y(ge,Ce,Ae,Be+1)}function C(ge){return 97<=ge&&ge<=122}function i(ge){return 65<=ge&&ge<=90}e.isUpper=i;function I(ge){return 48<=ge&&ge<=57}function d(ge){return ge===32||ge===9||ge===10||ge===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>f.add(ge.charCodeAt(0)));function r(ge){return d(ge)||f.has(ge)}function o(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function v(ge){return C(ge)||i(ge)||I(ge)}function m(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function E(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++){const Be=ge.charCodeAt(Ae);if(i(Be)||I(Be)||Ae>0&&!v(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function p(ge,Ce,Ae,Be){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(ge[Ae]!==Ce[Be].toLowerCase())return null;{let _e=null,qe=Be+1;for(_e=p(ge,Ce,Ae+1,Be+1);!_e&&(qe=E(Ce,qe))<Ce.length;)_e=p(ge,Ce,Ae+1,qe),qe++;return _e===null?null:m({start:Be,end:Be+1},_e)}}function u(ge){let Ce=0,Ae=0,Be=0,_e=0,qe=0;for(let He=0;He<ge.length;He++)qe=ge.charCodeAt(He),i(qe)&&Ce++,C(qe)&&Ae++,v(qe)&&Be++,I(qe)&&_e++;const j=Ce/ge.length,te=Ae/ge.length,ve=Be/ge.length,Ue=_e/ge.length;return{upperPercent:j,lowerPercent:te,alphaPercent:ve,numericPercent:Ue}}function b(ge){const{upperPercent:Ce,lowerPercent:Ae}=ge;return Ae===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Be,numericPercent:_e}=ge;return Ae>.2&&Ce<.8&&Be>.6&&_e<.2}function n(ge){let Ce=0,Ae=0,Be=0,_e=0;for(let qe=0;qe<ge.length;qe++)Be=ge.charCodeAt(qe),i(Be)&&Ce++,C(Be)&&Ae++,d(Be)&&_e++;return(Ce===0||Ae===0)&&_e===0?ge.length<=30:Ce<=5}function a(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(ge)||Ce.length>60)return null;const Ae=u(Ce);if(!t(Ae)){if(!b(Ae))return null;Ce=Ce.toLowerCase()}let Be=null,_e=0;for(ge=ge.toLowerCase();_e<Ce.length&&(Be=p(ge,Ce,0,_e))===null;)_e=E(Ce,_e+1);return Be}e.matchesCamelCase=a;function s(ge,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Be=null,_e=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(Be=c(ge,Ce,0,_e,Ae))===null;)_e=l(Ce,_e+1);return Be}e.matchesWords=s;function c(ge,Ce,Ae,Be,_e){if(Ae===ge.length)return[];if(Be===Ce.length)return null;if(o(ge.charCodeAt(Ae),Ce.charCodeAt(Be))){let qe=null,j=Be+1;if(qe=c(ge,Ce,Ae+1,Be+1,_e),!_e)for(;!qe&&(j=l(Ce,j))<Ce.length;)qe=c(ge,Ce,Ae+1,j,_e),j++;return qe===null?null:m({start:Be,end:Be+1},qe)}else return null}function l(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++)if(r(ge.charCodeAt(Ae))||Ae>0&&r(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const h=A(e.matchesPrefix,a,S),P=A(e.matchesPrefix,a,D),g=new _.LRUCache(1e4);function w(ge,Ce,Ae=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let Be=g.get(ge);Be||(Be=new RegExp(k.convertSimple2RegExpPattern(ge),"i"),g.set(ge,Be));const _e=Be.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Ae?P(ge,Ce):h(ge,Ce)}e.matchesFuzzy=w;function R(ge,Ce){const Ae=$(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?V(Ae):null}e.matchesFuzzy2=R;function L(ge,Ce,Ae,Be,_e,qe){const j=Math.min(13,ge.length);for(;Ae<j;Ae++){const te=$(ge,Ce,Ae,Be,_e,qe,!1);if(te)return te}return[0,qe]}e.anyScore=L;function V(ge){if(typeof ge=="undefined")return[];const Ce=[],Ae=ge[1];for(let Be=ge.length-1;Be>1;Be--){const _e=ge[Be]+Ae,qe=Ce[Ce.length-1];qe&&qe.end===_e?qe.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=V;const he=128;function z(){const ge=[],Ce=[];for(let Ae=0;Ae<=he;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=he;Ae++)ge.push(Ce.slice(0));return ge}function W(ge){const Ce=[];for(let Ae=0;Ae<=ge;Ae++)Ce[Ae]=0;return Ce}const J=W(2*he),O=W(2*he),F=z(),N=z(),B=z(),U=!1;function Q(ge,Ce,Ae,Be,_e){function qe(te,ve,Ue=" "){for(;te.length<ve;)te=Ue+te;return te}let j=` |   |${Be.split("").map(te=>qe(te,3)).join("|")}
`;for(let te=0;te<=Ae;te++)te===0?j+=" |":j+=`${Ce[te-1]}|`,j+=ge[te].slice(0,_e+1).map(ve=>qe(ve.toString(),3)).join("|")+`
`;return j}function Z(ge,Ce,Ae,Be){ge=ge.substr(Ce),Ae=Ae.substr(Be),console.log(Q(N,ge,ge.length,Ae,Ae.length)),console.log(Q(B,ge,ge.length,Ae,Ae.length)),console.log(Q(F,ge,ge.length,Ae,Ae.length))}function ne(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Ae=ge.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Ae)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Pe(ge,Ce,Ae){return Ce[ge]!==Ae[ge]}function Oe(ge,Ce,Ae,Be,_e,qe,j=!1){for(;Ce<Ae&&_e<qe;)ge[Ce]===Be[_e]&&(j&&(J[Ce]=_e),Ce+=1),_e+=1;return Ce===Ae}e.isPatternInWord=Oe;var Te;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var xe;(function(ge){ge.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ce})(xe=e.FuzzyScore||(e.FuzzyScore={}));function $(ge,Ce,Ae,Be,_e,qe,j){const te=ge.length>he?he:ge.length,ve=Be.length>he?he:Be.length;if(!(Ae>=te||qe>=ve||te-Ae>ve-qe)&&!!Oe(Ce,Ae,te,_e,qe,ve,!0)){G(te,ve,Ae,qe,Ce,_e);let Ue=1,He=1,$e=Ae,Ye=qe;const H=[!1];for(Ue=1,$e=Ae;$e<te;Ue++,$e++){const le=J[$e],fe=O[$e],Ee=$e+1<te?O[$e+1]:ve;for(He=le-qe+1,Ye=le;Ye<Ee;He++,Ye++){let Ve=Number.MIN_SAFE_INTEGER,Fe=!1;Ye<=fe&&(Ve=ie(ge,Ce,$e,Ae,Be,_e,Ye,ve,qe,F[Ue-1][He-1]===0,H));let We=0;Ve!==Number.MAX_SAFE_INTEGER&&(Fe=!0,We=Ve+N[Ue-1][He-1]);const Qe=Ye>le,it=Qe?N[Ue][He-1]+(F[Ue][He-1]>0?-5:0):0,at=Ye>le+1&&F[Ue][He-1]>0,Ze=at?N[Ue][He-2]+(F[Ue][He-2]>0?-5:0):0;if(at&&(!Qe||Ze>=it)&&(!Fe||Ze>=We))N[Ue][He]=Ze,B[Ue][He]=3,F[Ue][He]=0;else if(Qe&&(!Fe||it>=We))N[Ue][He]=it,B[Ue][He]=2,F[Ue][He]=0;else if(Fe)N[Ue][He]=We,B[Ue][He]=1,F[Ue][He]=F[Ue-1][He-1]+1;else throw new Error("not possible")}}if(U&&Z(ge,Ae,Be,qe),!(!H[0]&&!j)){Ue--,He--;const se=[N[Ue][He],qe];let de=0,K=0;for(;Ue>=1;){let le=He;do{const fe=B[Ue][le];if(fe===3)le=le-2;else if(fe===2)le=le-1;else break}while(le>=1);de>1&&Ce[Ae+Ue-1]===_e[qe+He-1]&&!Pe(le+qe-1,Be,_e)&&de+1>F[Ue][le]&&(le=He),le===He?de++:de=1,K||(K=le),Ue--,He=le-1,se.push(He)}ve===te&&(se[0]+=2);const ee=K-te;return se[0]-=ee,se}}}e.fuzzyScore=$;function G(ge,Ce,Ae,Be,_e,qe){let j=ge-1,te=Ce-1;for(;j>=Ae&&te>=Be;)_e[j]===qe[te]&&(O[j]=te,j--),te--}function ie(ge,Ce,Ae,Be,_e,qe,j,te,ve,Ue,He){if(Ce[Ae]!==qe[j])return Number.MIN_SAFE_INTEGER;let $e=1,Ye=!1;return j===Ae-Be?$e=ge[Ae]===_e[j]?7:5:Pe(j,_e,qe)&&(j===0||!Pe(j-1,_e,qe))?($e=ge[Ae]===_e[j]?7:5,Ye=!0):ne(qe,j)&&(j===0||!ne(qe,j-1))?$e=5:(ne(qe,j-1)||pe(qe,j-1))&&($e=5,Ye=!0),$e>1&&Ae===Be&&(He[0]=!0),Ye||(Ye=Pe(j,_e,qe)||ne(qe,j-1)||pe(qe,j-1)),Ae===Be?j>ve&&($e-=Ye?3:5):Ue?$e+=Ye?2:0:$e+=Ye?0:1,j+1===te&&($e-=Ye?3:5),$e}function oe(ge,Ce,Ae,Be,_e,qe,j){return De(ge,Ce,Ae,Be,_e,qe,!0,j)}e.fuzzyScoreGracefulAggressive=oe;function me(ge,Ce,Ae,Be,_e,qe,j){return De(ge,Ce,Ae,Be,_e,qe,!1,j)}e.fuzzyScoreGraceful=me;function De(ge,Ce,Ae,Be,_e,qe,j,te){let ve=$(ge,Ce,Ae,Be,_e,qe,te);if(ve&&!j)return ve;if(ge.length>=3){const Ue=Math.min(7,ge.length-1);for(let He=Ae+1;He<Ue;He++){const $e=Ne(ge,He);if($e){const Ye=$($e,$e.toLowerCase(),Ae,Be,_e,qe,te);Ye&&(Ye[0]-=3,(!ve||Ye[0]>ve[0])&&(ve=Ye))}}}return ve}function Ne(ge,Ce){if(!(Ce+1>=ge.length)){const Ae=ge[Ce],Be=ge[Ce+1];if(Ae!==Be)return ge.slice(0,Ce)+Be+Ae+ge.slice(Ce+2)}}}),define(be[110],we([0,1,36,109,8]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${T.source}`,"g");function D(o){return o.replace(S,(v,m)=>m?v:`\\${v}`)}e.escapeIcons=D;const y=new RegExp(`\\\\${T.source}`,"g");function C(o){return o.replace(y,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function I(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(i,(v,m,E,p)=>E?v:m||p||"")}e.stripIcons=I;function d(o){const v=o.indexOf(e.iconStartMarker);return v===-1?{text:o}:f(o,v)}e.parseLabelWithIcons=d;function f(o,v){const m=[];let E="";function p(l){if(l){E+=l;for(const h of l)m.push(t)}}let u=-1,b="",t=0,n,a,s=v;const c=o.length;for(p(o.substr(0,v));s<c;)n=o[s],a=o[s+1],n===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(u=s,p(b),b=e.iconStartMarker,s++):n===")"&&u!==-1?(t+=s-u+1,u=-1,b=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?b+=n:(p(b),u=-1,b=""):p(n),s++;return p(b),{text:E,iconOffsets:m}}function r(o,v,m=!1){const{text:E,iconOffsets:p}=v;if(!p||p.length===0)return(0,k.matchesFuzzy)(o,E,m);const u=(0,A.ltrim)(E," "),b=E.length-u.length,t=(0,k.matchesFuzzy)(o,u,m);if(t)for(const n of t){const a=p[n.start+b]+b;n.start+=a,n.end+=a}return t}e.matchesFuzzyIconAware=r}),define(be[83],we([0,1,12,110,11]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(o="",v=!1){var m,E;if(this.value=o,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1):(this.isTrusted=(m=v.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(E=v.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(o,v=0){return this.value+=I(this.supportThemeIcons?(0,k.escapeIcons)(o):o).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,v){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=S;function D(r){return y(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function y(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function C(r,o){return!r&&!o?!0:!r||!o?!1:Array.isArray(r)&&Array.isArray(o)?(0,_.equals)(r,o,i):y(r)&&y(o)?i(r,o):!1}e.markedStringsEquals=C;function i(r,o){return r===o?!0:!r||!o?!1:r.value===o.value&&r.isTrusted===o.isTrusted&&r.supportThemeIcons===o.supportThemeIcons}function I(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function f(r){const o=[],v=r.split("|").map(E=>E.trim());r=v[0];const m=v[1];if(m){const E=/height=(\d+)/.exec(m),p=/width=(\d+)/.exec(m),u=E?E[1]:"",b=p?p[1]:"",t=isFinite(parseInt(b)),n=isFinite(parseInt(u));t&&o.push(`width="${b}"`),n&&o.push(`height="${u}"`)}return{href:r,dimensions:o}}e.parseHrefAndDimensions=f}),define(be[58],we([0,1,23,8,2]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,D)}e.stringify=T;function S(C){let i=JSON.parse(C);return i=y(i),i}e.parse=S;function D(C,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,k.regExpFlags)(i)}:i}function y(C,i=0){if(!C||i>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return A.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof _.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=y(C[I],i+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=y(C[I],i+1))}return C}e.revive=y}),define(be[18],we([0,1,2,21]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,C,i){this._hosts[y]=C,this._ports[y]=i}setConnectionToken(y,C){this._connectionTokens[y]=C}rewrite(y){if(this._delegate)return this._delegate(y);const C=y.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],d=this._connectionTokens[C];let f=`path=${encodeURIComponent(y.path)}`;return typeof d=="string"&&(f+=`&tkn=${encodeURIComponent(d)}`),_.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new T;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,C,i){const I=this.toUri(y,C);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):k.isNative&&(i||k.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(y,C){const i=this.toUri(y,C);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(y,C){return _.URI.isUri(y)?y:_.URI.parse(C.toUrl(y))}}e.FileAccess=new S}),define(be[25],we([0,1,37,13,2,8,18,21]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,A.uriToFsPath)(f,!0)}e.originalFSPath=y;class C{constructor(r){this._ignorePathCasing=r}compare(r,o,v=!1){return r===o?0:(0,T.compare)(this.getComparisonKey(r,v),this.getComparisonKey(o,v))}isEqual(r,o,v=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,v)===this.getComparisonKey(o,v)}getComparisonKey(r,o=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,o,v=!1){if(r.scheme===o.scheme){if(r.scheme===S.Schemas.file)return _.isEqualOrParent(y(r),y(o),this._ignorePathCasing(r))&&r.query===o.query&&(v||r.fragment===o.fragment);if((0,e.isEqualAuthority)(r.authority,o.authority))return _.isEqualOrParent(r.path,o.path,this._ignorePathCasing(r),"/")&&r.query===o.query&&(v||r.fragment===o.fragment)}return!1}joinPath(r,...o){return A.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return k.posix.basename(r.path)}extname(r){return k.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===S.Schemas.file?o=A.URI.file(k.dirname(y(r))).path:(o=k.posix.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===S.Schemas.file?o=A.URI.file(k.normalize(y(r))).path:o=k.posix.normalize(r.path),r.with({path:o})}relativePath(r,o){if(!(r.scheme!==o.scheme||!(0,e.isEqualAuthority)(r.authority,o.authority))){if(r.scheme===S.Schemas.file){const E=k.relative(y(r),y(o));return D.isWindows?_.toSlashes(E):E}let v=r.path||"/",m=o.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const p=Math.min(v.length,m.length);E<p&&!(v.charCodeAt(E)!==m.charCodeAt(E)&&v.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);v=m.substr(0,E)+v.substr(E)}return k.posix.relative(v,m)}}resolvePath(r,o){if(r.scheme===S.Schemas.file){const v=A.URI.file(k.resolve(y(r),o));return r.with({authority:v.authority,path:v.path})}return o.indexOf("/")===-1&&(o=_.toSlashes(o),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o)),r.with({path:k.posix.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||(0,T.equalsIgnoreCase)(r,o)}hasTrailingPathSeparator(r,o=k.sep){if(r.scheme===S.Schemas.file){const v=y(r);return v.length>_.getRoot(v).length&&v[v.length-1]===o}else{const v=r.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=k.sep){return(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=k.sep){let v=!1;if(r.scheme===S.Schemas.file){const m=y(r);v=m!==void 0&&m.length===_.getRoot(m).length&&m[m.length-1]===o}else{o="/";const m=r.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path+"/"}):r}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(f=>f.scheme===S.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(f,r){const o=[];for(let v=0;v<f.length;v++){const m=r(f[v]);f.some((E,p)=>p===v?!1:(0,e.isEqualOrParent)(m,r(E)))||o.push(f[v])}return o}e.distinctParents=i;var I;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(o){const v=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(p=>{const[u,b]=p.split(":");u&&b&&v.set(u,b)});const E=o.path.substring(0,o.path.indexOf(";"));return E&&v.set(f.META_DATA_MIME,E),v}f.parseMetaData=r})(I=e.DataUri||(e.DataUri={}));function d(f,r,o){if(r){let v=f.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),f.with({scheme:o,authority:r,path:v})}return f.with({scheme:o})}e.toLocalResource=d}),define(be[14],we([0,1,20,11,3,6,45,25]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(N){return!!N&&typeof N.then=="function"}e.isThenable=y;function C(N){const B=new _.CancellationTokenSource,U=N(B.token),Q=new Promise((Z,ne)=>{B.token.onCancellationRequested(()=>{ne((0,k.canceled)())}),Promise.resolve(U).then(pe=>{B.dispose(),Z(pe)},pe=>{B.dispose(),ne(pe)})});return new class{cancel(){B.cancel()}then(Z,ne){return Q.then(Z,ne)}catch(Z){return this.then(void 0,Z)}finally(Z){return Q.finally(Z)}}}e.createCancelablePromise=C;function i(N,B,U){return Promise.race([N,new Promise(Q=>B.onCancellationRequested(()=>Q(U)))])}e.raceCancellation=i;async function I(N){let B=-1;const U=N.map((Z,ne)=>Z.then(pe=>(B=ne,pe))),Q=await Promise.race(U);return N.forEach((Z,ne)=>{ne!==B&&Z.cancel()}),Q}e.raceCancellablePromises=I;function d(N,B,U){let Q;const Z=setTimeout(()=>{Q==null||Q(void 0),U==null||U()},B);return Promise.race([N.finally(()=>clearTimeout(Z)),new Promise(ne=>Q=ne)])}e.raceTimeout=d;function f(N){return new Promise((B,U)=>{const Q=N();y(Q)?Q.then(B,U):B(Q)})}e.asPromise=f;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(U,U).then(Q)})}return new Promise((U,Q)=>{this.queuedPromise.then(U,Q)})}return this.activePromise=B(),new Promise((U,Q)=>{this.activePromise.then(Z=>{this.activePromise=null,U(Z)},Z=>{this.activePromise=null,Q(Z)})})}}e.Throttler=r;class o{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=o;class v{constructor(){this.promiseMap=new Map}queue(B,U){var Q;const ne=((Q=this.promiseMap.get(B))!==null&&Q!==void 0?Q:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(B)===ne&&this.promiseMap.delete(B)});return this.promiseMap.set(B,ne),ne}}e.SequencerByKey=v;class m{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,U=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,Z)=>{this.doResolve=Q,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class E{constructor(B){this.delayer=new m(B),this.throttler=new r}trigger(B,U){return this.delayer.trigger(()=>this.throttler.queue(B),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class p{constructor(){this._isOpen=!1,this._promise=new Promise((B,U)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class u extends p{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function b(N,B){return B?new Promise((U,Q)=>{const Z=setTimeout(U,N);B.onCancellationRequested(()=>{clearTimeout(Z),Q((0,k.canceled)())})}):C(U=>b(N,U))}e.timeout=b;function t(N,B=0){const U=setTimeout(N,B);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(N){return N.then(void 0,B=>{})}e.ignoreErrors=n;function a(N){const B=[];let U=0;const Q=N.length;function Z(){return U<Q?N[U++]():null}function ne(pe){pe!=null&&B.push(pe);const Pe=Z();return Pe?Pe.then(ne):Promise.resolve(B)}return Promise.resolve(null).then(ne)}e.sequence=a;function s(N,B=Q=>!!Q,U=null){let Q=0;const Z=N.length,ne=()=>{if(Q>=Z)return Promise.resolve(U);const pe=N[Q++];return Promise.resolve(pe()).then(Oe=>B(Oe)?Promise.resolve(Oe):ne())};return ne()}e.first=s;function c(N,B=Q=>!!Q,U=null){if(N.length===0)return Promise.resolve(U);let Q=N.length;const Z=()=>{var ne,pe;Q=-1;for(const Pe of N)(pe=(ne=Pe).cancel)===null||pe===void 0||pe.call(ne)};return new Promise((ne,pe)=>{for(const Pe of N)Pe.then(Oe=>{--Q>=0&&B(Oe)?(Z(),ne(Oe)):Q===0&&ne(U)}).catch(Oe=>{--Q>=0&&(Z(),pe(Oe))})})}e.firstParallel=c;class l{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((U,Q)=>{this.outstandingPromises.push({factory:B,c:U,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const U=B.factory();U.then(B.c,B.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class P{constructor(){this.queues=new Map}queueFor(B,U=D.extUri){const Q=U.getComparisonKey(B);let Z=this.queues.get(Q);return Z||(Z=new h,A.Event.once(Z.onFinished)(()=>{Z==null||Z.dispose(),this.queues.delete(Q)}),this.queues.set(Q,Z)),Z}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=P;class g{constructor(B,U){this._token=-1,typeof B=="function"&&typeof U=="number"&&this.setIfNotSet(B,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},U)}setIfNotSet(B,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},U))}}e.TimeoutTimer=g;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setInterval(()=>{B()},U)}}e.IntervalTimer=w;class R{constructor(B,U){this.timeoutToken=-1,this.runner=B,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class L extends R{constructor(B,U){super(B,U);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const U=setTimeout(()=>B(N));let Q=!1;return{dispose(){Q||(Q=!0,clearTimeout(U))}}}}else e.runWhenIdle=(N,B)=>{const U=requestIdleCallback(N,typeof B=="number"?{timeout:B}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(U))}}}}();class V{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=V;async function he(N,B,U){let Q;for(let Z=0;Z<U;Z++)try{return await N()}catch(ne){Q=ne,await b(B)}throw Q}e.retry=he;class z{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var B;(B=this._pending)===null||B===void 0||B.cancel()}setPending(B,U,Q){return this._pending={taskId:B,cancel:()=>Q==null?void 0:Q(),promise:U},U.then(()=>this.donePending(B),()=>this.donePending(B)),U}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let U,Q;const Z=new Promise((ne,pe)=>{U=ne,Q=pe});this._next={run:B,promise:Z,promiseResolve:U,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=z;class W{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class J{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,U)=>{this.completeCallback=B,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(U=>{this.completeCallback(B),this.resolved=!0,U()})}error(B){return new Promise(U=>{this.errorCallback(B),this.rejected=!0,U()})}cancel(){new Promise(B=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=J;class O extends A.Emitter{async fireAsync(B,U,Q){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const Z of this._listeners)this._asyncDeliveryQueue.push([Z,B]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[Z,ne]=this._asyncDeliveryQueue.shift(),pe=[],Pe=Object.assign(Object.assign({},ne),{waitUntil:Oe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");Q&&(Oe=Q(Oe,typeof Z=="function"?Z:Z[0])),pe.push(Oe)}});try{typeof Z=="function"?Z.call(void 0,Pe):Z[0].call(Z[1],Pe)}catch(Oe){(0,k.onUnexpectedError)(Oe);continue}Object.freeze(pe),await F.settled(pe).catch(Oe=>(0,k.onUnexpectedError)(Oe))}}}}e.AsyncEmitter=O;var F;(function(N){async function B(ne){return typeof Promise.allSettled=="function"?U(ne):Q(ne)}N.allSettled=B;async function U(ne){return Promise.allSettled(ne)}async function Q(ne){return Promise.all(ne.map(pe=>pe.then(Pe=>({status:"fulfilled",value:Pe}),Pe=>({status:"rejected",reason:Pe}))))}async function Z(ne){let pe;const Pe=await Promise.all(ne.map(Oe=>Oe.then(Te=>Te,Te=>{pe||(pe=Te)})));if(typeof pe!="undefined")throw pe;return Pe}N.settled=Z})(F=e.Promises||(e.Promises={}))}),define(be[111],we([0,1,13,14]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new k.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),T=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(u,b,t=!1){const n=u||"",a=b||"",s=A.value.collator.compare(n,a);return A.value.collatorIsNumeric&&s===0&&n!==a?n<a?-1:1:s}e.compareFileNames=D;function y(u,b){const t=T.value.collator;return u=u||"",b=b||"",o(t,u,b)}e.compareFileNamesDefault=y;function C(u,b,t=!1){t||(u=u&&u.toLowerCase(),b=b&&b.toLowerCase());const[n,a]=f(u),[s,c]=f(b);return n!==s?n<s?-1:1:a===c?0:a<c?-1:1}e.noIntlCompareFileNames=C;function i(u,b){const[t,n]=f(u),[a,s]=f(b);let c=A.value.collator.compare(n,s);if(c===0){if(A.value.collatorIsNumeric&&n!==s)return n<s?-1:1;if(c=A.value.collator.compare(t,a),A.value.collatorIsNumeric&&c===0&&t!==a)return t<a?-1:1}return c}e.compareFileExtensions=i;function I(u,b){u=u||"",b=b||"";const t=r(u),n=r(b),a=T.value.collator,s=S.value.collator;let c;return c=o(s,t,n),c!==0?c:o(a,u,b)}e.compareFileExtensionsDefault=I;const d=/^(.*?)(\.([^.]*))?$/;function f(u,b=!1){const t=u?d.exec(u):[];let n=[t&&t[1]||"",t&&t[3]||""];return b&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function r(u){const b=u?d.exec(u):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function o(u,b,t){let n=u.compare(b,t);return n!==0?n:b.length!==t.length?b.length<t.length?-1:1:0}function v(u,b,t=!1){return t||(u=u&&u.toLowerCase(),b=b&&b.toLowerCase()),u===b?0:u<b?-1:1}function m(u,b,t=!1){const n=u.split(_.sep),a=b.split(_.sep),s=n.length-1,c=a.length-1;let l,h;for(let P=0;;P++){if(l=s===P,h=c===P,l&&h)return D(n[P],a[P],t);if(l)return-1;if(h)return 1;const g=v(n[P],a[P],t);if(g!==0)return g}}e.comparePaths=m;function E(u,b,t){const n=u.toLowerCase(),a=b.toLowerCase(),s=p(u,b,t);if(s)return s;const c=n.endsWith(t),l=a.endsWith(t);if(c!==l)return c?-1:1;const h=D(n,a);return h!==0?h:n.localeCompare(a)}e.compareAnything=E;function p(u,b,t){const n=u.toLowerCase(),a=b.toLowerCase(),s=n.startsWith(t),c=a.startsWith(t);if(s!==c)return s?-1:1;if(s&&c){if(n.length<a.length)return-1;if(n.length>a.length)return 1}return 0}e.compareByPrefix=p}),define(be[28],we([0,1,8,37,13,22,14]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const y="**",C="/",i="[/\\\\]",I="[^/\\\\]",d=/\//g;function f(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function r(U,Q){if(!U)return[];const Z=[];let ne=!1,pe=!1,Pe="";for(const Oe of U){switch(Oe){case Q:if(!ne&&!pe){Z.push(Pe),Pe="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Pe+=Oe}return Pe&&Z.push(Pe),Z}e.splitGlobAware=r;function o(U){if(!U)return"";let Q="";const Z=r(U,C);if(Z.every(ne=>ne===y))Q=".*";else{let ne=!1;Z.forEach((pe,Pe)=>{if(pe===y){ne||(Q+=f(2),ne=!0);return}let Oe=!1,Te="",xe=!1,$="";for(const G of pe){if(G!=="}"&&Oe){Te+=G;continue}if(xe&&(G!=="]"||!$)){let ie;G==="-"?ie=G:(G==="^"||G==="!")&&!$?ie="^":G===C?ie="":ie=_.escapeRegExpCharacters(G),$+=ie;continue}switch(G){case"{":Oe=!0;continue;case"[":xe=!0;continue;case"}":Q+=`(?:${r(Te,",").map(me=>o(me)).join("|")})`,Oe=!1,Te="";break;case"]":Q+="["+$+"]",xe=!1,$="";break;case"?":Q+=I;continue;case"*":Q+=f(1);continue;default:Q+=_.escapeRegExpCharacters(G)}}Pe<Z.length-1&&(Z[Pe+1]!==y||Pe+2<Z.length)&&(Q+=i),ne=!1})}return Q}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},a=function(){return null};function s(U,Q){if(!U)return a;let Z;typeof U!="string"?Z=U.pattern:Z=U,Z=Z.trim();const ne=`${Z}_${!!Q.trimForExclusions}`;let pe=t.get(ne);if(pe)return c(pe,U);let Pe;if(v.test(Z)){const Oe=Z.substr(4);pe=function(Te,xe){return typeof Te=="string"&&Te.endsWith(Oe)?Z:null}}else(Pe=m.exec(l(Z,Q)))?pe=h(Pe[1],Z):(Q.trimForExclusions?p:E).test(Z)?pe=P(Z,Q):(Pe=u.exec(l(Z,Q)))?pe=g(Pe[1].substr(1),Z,!0):(Pe=b.exec(l(Z,Q)))?pe=g(Pe[1],Z,!1):pe=w(Z);return t.set(ne,pe),c(pe,U)}function c(U,Q){return typeof Q=="string"?U:function(Z,ne){return k.isEqualOrParent(Z,Q.base)?U(A.relative(Q.base,Z),ne):null}}function l(U,Q){return Q.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function h(U,Q){const Z=`/${U}`,ne=`\\${U}`,pe=function(Oe,Te){return typeof Oe!="string"?null:Te?Te===U?Q:null:Oe===U||Oe.endsWith(Z)||Oe.endsWith(ne)?Q:null},Pe=[U];return pe.basenames=Pe,pe.patterns=[Q],pe.allBasenames=Pe,pe}function P(U,Q){const Z=B(U.slice(1,-1).split(",").map(Te=>s(Te,Q)).filter(Te=>Te!==a),U),ne=Z.length;if(!ne)return a;if(ne===1)return Z[0];const pe=function(Te,xe){for(let $=0,G=Z.length;$<G;$++)if(Z[$](Te,xe))return U;return null},Pe=Z.find(Te=>!!Te.allBasenames);Pe&&(pe.allBasenames=Pe.allBasenames);const Oe=Z.reduce((Te,xe)=>xe.allPaths?Te.concat(xe.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function g(U,Q,Z){const ne=A.sep===A.posix.sep,pe=ne?U:U.replace(d,A.sep),Pe=A.sep+pe,Oe=A.posix.sep+U,Te=Z?function(xe,$){return typeof xe=="string"&&(xe===pe||xe.endsWith(Pe)||!ne&&(xe===U||xe.endsWith(Oe)))?Q:null}:function(xe,$){return typeof xe=="string"&&(xe===pe||!ne&&xe===U)?Q:null};return Te.allPaths=[(Z?"*/":"./")+U],Te}function w(U){try{const Q=new RegExp(`^${o(U)}$`);return function(Z){return Q.lastIndex=0,typeof Z=="string"&&Q.test(Z)?U:null}}catch(Q){return a}}function R(U,Q,Z){return!U||typeof Q!="string"?!1:L(U)(Q,void 0,Z)}e.match=R;function L(U,Q={}){if(!U)return n;if(typeof U=="string"||W(U)){const Z=s(U,Q);if(Z===a)return n;const ne=function(pe,Pe){return!!Z(pe,Pe)};return Z.allBasenames&&(ne.allBasenames=Z.allBasenames),Z.allPaths&&(ne.allPaths=Z.allPaths),ne}return F(U,Q)}e.parse=L;function V(U){if(!!U){let Q;return Z=>(Q||(Q=(U()||Promise.resolve([])).then(ne=>ne?z(ne):{})),Q.then(ne=>!!ne[Z]))}}e.hasSiblingPromiseFn=V;function he(U){if(!!U){let Q;return Z=>{if(!Q){const ne=U();Q=ne?z(ne):{}}return!!Q[Z]}}}e.hasSiblingFn=he;function z(U){const Q={};for(const Z of U)Q[Z]=!0;return Q}function W(U){const Q=U;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=W;function J(U){return U.allBasenames||[]}e.getBasenameTerms=J;function O(U){return U.allPaths||[]}e.getPathTerms=O;function F(U,Q){const Z=B(Object.getOwnPropertyNames(U).map(Te=>N(Te,U[Te],Q)).filter(Te=>Te!==a)),ne=Z.length;if(!ne)return a;if(!Z.some(Te=>!!Te.requiresSiblings)){if(ne===1)return Z[0];const Te=function(G,ie){for(let oe=0,me=Z.length;oe<me;oe++){const De=Z[oe](G,ie);if(De)return De}return null},xe=Z.find(G=>!!G.allBasenames);xe&&(Te.allBasenames=xe.allBasenames);const $=Z.reduce((G,ie)=>ie.allPaths?G.concat(ie.allPaths):G,[]);return $.length&&(Te.allPaths=$),Te}const pe=function(Te,xe,$){let G;for(let ie=0,oe=Z.length;ie<oe;ie++){const me=Z[ie];me.requiresSiblings&&$&&(xe||(xe=A.basename(Te)),G||(G=xe.substr(0,xe.length-A.extname(Te).length)));const De=me(Te,xe,G,$);if(De)return De}return null},Pe=Z.find(Te=>!!Te.allBasenames);Pe&&(pe.allBasenames=Pe.allBasenames);const Oe=Z.reduce((Te,xe)=>xe.allPaths?Te.concat(xe.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function N(U,Q,Z){if(Q===!1)return a;const ne=s(U,Z);if(ne===a)return a;if(typeof Q=="boolean")return ne;if(Q){const pe=Q.when;if(typeof pe=="string"){const Pe=(Oe,Te,xe,$)=>{if(!$||!ne(Oe,Te))return null;const G=pe.replace("$(basename)",xe),ie=$(G);return(0,S.isThenable)(ie)?ie.then(oe=>oe?U:null):ie?U:null};return Pe.requiresSiblings=!0,Pe}}return ne}function B(U,Q){const Z=U.filter(Te=>!!Te.basenames);if(Z.length<2)return U;const ne=Z.reduce((Te,xe)=>{const $=xe.basenames;return $?Te.concat($):Te},[]);let pe;if(Q){pe=[];for(let Te=0,xe=ne.length;Te<xe;Te++)pe.push(Q)}else pe=Z.reduce((Te,xe)=>{const $=xe.patterns;return $?Te.concat($):Te},[]);const Pe=function(Te,xe){if(typeof Te!="string")return null;if(!xe){let G;for(G=Te.length;G>0;G--){const ie=Te.charCodeAt(G-1);if(ie===47||ie===92)break}xe=Te.substr(G)}const $=ne.indexOf(xe);return $!==-1?pe[$]:null};Pe.basenames=ne,Pe.patterns=pe,Pe.allBasenames=ne;const Oe=U.filter(Te=>!Te.basenames);return Oe.push(Pe),Oe}}),define(be[59],we([0,1,2,13,8,18,21,25,37]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(s,c,l){if(typeof s=="string"&&(s=_.URI.file(s)),l){const P=l.getWorkspaceFolder(s);if(P){const g=l.getWorkspace().folders.length>1;let w;if((0,D.isEqual)(P.uri,s)?w="":w=(0,D.relativePath)(P.uri,s),g){const R=P.name?P.name:(0,D.basename)(P.uri);w=w?R+" \u2022 "+w:R}return w}}if(s.scheme!==T.Schemas.file&&s.scheme!==T.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(s.fsPath))return(0,k.normalize)(I(s.fsPath));let h=(0,k.normalize)(s.fsPath);return!S.isWindows&&(c==null?void 0:c.userHome)&&(h=f(h,c.userHome.fsPath)),h}e.getPathLabel=C;function i(s){if(!!s){typeof s=="string"&&(s=_.URI.file(s));const c=(0,D.basename)(s)||(s.scheme===T.Schemas.file?s.fsPath:s.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(c)?I(c):c}}e.getBaseLabel=i;function I(s){return(0,y.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let d=Object.create(null);function f(s,c){if(S.isWindows||!s||!c)return s;let l=d.original===c?d.normalized:void 0;return l||(l=`${(0,A.rtrim)(c,k.posix.sep)}${k.posix.sep}`,d={original:c,normalized:l}),(S.isLinux?s.startsWith(l):(0,A.startsWithIgnoreCase)(s,l))&&(s=`~/${s.substr(l.length)}`),s}e.tildify=f;function r(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=r;const o="\u2026",v="\\\\",m="~";function E(s,c=k.sep){const l=new Array(s.length);let h=!1;for(let P=0;P<s.length;P++){let g=s[P];if(g===""){l[P]=`.${c}`;continue}if(!g){l[P]=g;continue}h=!0;let w="";g.indexOf(v)===0?(w=g.substr(0,g.indexOf(v)+v.length),g=g.substr(g.indexOf(v)+v.length)):g.indexOf(c)===0?(w=g.substr(0,g.indexOf(c)+c.length),g=g.substr(g.indexOf(c)+c.length)):g.indexOf(m)===0&&(w=g.substr(0,g.indexOf(m)+m.length),g=g.substr(g.indexOf(m)+m.length));const R=g.split(c);for(let L=1;h&&L<=R.length;L++)for(let V=R.length-L;h&&V>=0;V--){h=!1;let he=R.slice(V,V+L).join(c);for(let z=0;!h&&z<s.length;z++)if(z!==P&&s[z]&&s[z].indexOf(he)>-1){const W=V+L===R.length,J=V>0&&s[z].indexOf(c)>-1?c+he:he,O=s[z].endsWith(J);h=!W||O}if(!h){let z="";(R[0].endsWith(":")||w!=="")&&(V===1&&(V=0,L++,he=R[0]+c+he),V>0&&(z=R[0]+c),z=w+z),V>0&&(z=z+o+c),z=z+he,V+L<R.length&&(z=z+c+o),l[P]=z}}h&&(l[P]=g)}return l}e.shorten=E;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function u(s,c=Object.create(null)){const l=[];let h=!1,P="";for(const g of s)if(g==="$"||h&&g==="{")P&&l.push({value:P,type:p.TEXT}),P="",h=!0;else if(g==="}"&&h){const w=c[P];if(typeof w=="string")w.length&&l.push({value:w,type:p.VARIABLE});else if(w){const R=l[l.length-1];(!R||R.type!==p.SEPARATOR)&&l.push({value:w.label,type:p.SEPARATOR})}P="",h=!1}else P+=g;return P&&!h&&l.push({value:P,type:p.TEXT}),l.filter((g,w)=>{if(g.type===p.SEPARATOR){const R=l[w-1],L=l[w+1];return[R,L].every(V=>V&&(V.type===p.VARIABLE||V.type===p.TEXT)&&V.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=u;function b(s,c){return S.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function t(s,c){return S.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):S.isWindows?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function a(s){const c=s.indexOf("/")!==-1?k.posix:k.win32,l=c.basename(s),h=c.dirname(s);return l.length?{name:l,parentPath:h}:{name:h,parentPath:""}}e.splitName=a}),define(be[112],we([0,1,2]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(i){return i.toJSON()}class A{constructor(I){this._uriTransformer=I}transformIncoming(I){const d=this._uriTransformer.transformIncoming(I);return d===I?I:k(_.URI.from(d))}transformOutgoing(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:k(_.URI.from(d))}transformOutgoingURI(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:_.URI.from(d)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,I,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof _.URI)return I.transformOutgoing(i);for(let f in i)if(Object.hasOwnProperty.call(i,f)){const r=T(i[f],I,d+1);r!==null&&(i[f]=r)}}return null}function S(i,I){const d=T(i,I,0);return d===null?i:d}e.transformOutgoingURIs=S;function D(i,I,d,f){if(!i||f>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?_.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const o=D(i[r],I,d,f+1);o!==null&&(i[r]=o)}}return null}function y(i,I){const d=D(i,I,!1,0);return d===null?i:d}e.transformIncomingURIs=y;function C(i,I){const d=D(i,I,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=C}),define(be[29],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(y){return _.test(y)}e.isUUID=k;const A=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let C=0;C<y.length;C++)y[C]=Math.floor(Math.random()*256);return y};function D(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let y=0,C="";return C+=T[A[y++]],C+=T[A[y++]],C+=T[A[y++]],C+=T[A[y++]],C+="-",C+=T[A[y++]],C+=T[A[y++]],C+="-",C+=T[A[y++]],C+=T[A[y++]],C+="-",C+=T[A[y++]],C+=T[A[y++]],C+="-",C+=T[A[y++]],C+=T[A[y++]],C+=T[A[y++]],C+=T[A[y++]],C+=T[A[y++]],C+=T[A[y++]],C}e.generateUuid=D}),define(be[84],we([0,1,82]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(D){let y=(0,_.toUint8)(D);this._defaultValue=y,this._asciiMap=k._createAsciiMap(y),this._map=new Map}static _createAsciiMap(D){let y=new Uint8Array(256);for(let C=0;C<256;C++)y[C]=D;return y}set(D,y){let C=(0,_.toUint8)(y);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=k;var A;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new k(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(be[113],we([0,1,84]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends _.CharacterClassifier{constructor(D){super(0);for(let y=0,C=D.length;y<C;y++)this.set(D.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(S){let D={};return y=>(D.hasOwnProperty(y)||(D[y]=S(y)),D[y])}e.getMapForWordSeparators=T(S=>new A(S))}),define(be[38],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new _(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return _.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return _.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return _.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let S=A.lineNumber|0,D=T.lineNumber|0;if(S===D){let y=A.column|0,C=T.column|0;return y-C}return S-D}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new _(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=_}),define(be[32],we([0,1,38]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(T,S,D,y){T>D||T===D&&S>y?(this.startLineNumber=D,this.startColumn=y,this.endLineNumber=T,this.endColumn=S):(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=D,this.endColumn=y)}isEmpty(){return k.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return k.containsPosition(this,T)}static containsPosition(T,S){return!(S.lineNumber<T.startLineNumber||S.lineNumber>T.endLineNumber||S.lineNumber===T.startLineNumber&&S.column<T.startColumn||S.lineNumber===T.endLineNumber&&S.column>T.endColumn)}containsRange(T){return k.containsRange(this,T)}static containsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>T.endColumn)}strictContainsRange(T){return k.strictContainsRange(this,T)}static strictContainsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<=T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>=T.endColumn)}plusRange(T){return k.plusRange(this,T)}static plusRange(T,S){let D,y,C,i;return S.startLineNumber<T.startLineNumber?(D=S.startLineNumber,y=S.startColumn):S.startLineNumber===T.startLineNumber?(D=S.startLineNumber,y=Math.min(S.startColumn,T.startColumn)):(D=T.startLineNumber,y=T.startColumn),S.endLineNumber>T.endLineNumber?(C=S.endLineNumber,i=S.endColumn):S.endLineNumber===T.endLineNumber?(C=S.endLineNumber,i=Math.max(S.endColumn,T.endColumn)):(C=T.endLineNumber,i=T.endColumn),new k(D,y,C,i)}intersectRanges(T){return k.intersectRanges(this,T)}static intersectRanges(T,S){let D=T.startLineNumber,y=T.startColumn,C=T.endLineNumber,i=T.endColumn,I=S.startLineNumber,d=S.startColumn,f=S.endLineNumber,r=S.endColumn;return D<I?(D=I,y=d):D===I&&(y=Math.max(y,d)),C>f?(C=f,i=r):C===f&&(i=Math.min(i,r)),D>C||D===C&&y>i?null:new k(D,y,C,i)}equalsRange(T){return k.equalsRange(this,T)}static equalsRange(T,S){return!!T&&!!S&&T.startLineNumber===S.startLineNumber&&T.startColumn===S.startColumn&&T.endLineNumber===S.endLineNumber&&T.endColumn===S.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(T){return new _.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(T){return new _.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,S){return new k(this.startLineNumber,this.startColumn,T,S)}setStartPosition(T,S){return new k(T,S,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(T){return new k(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,S=T){return new k(T.lineNumber,T.column,S.lineNumber,S.column)}static lift(T){return T?new k(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn)}static areIntersecting(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,S){if(T&&S){const C=T.startLineNumber|0,i=S.startLineNumber|0;if(C===i){const I=T.startColumn|0,d=S.startColumn|0;if(I===d){const f=T.endLineNumber|0,r=S.endLineNumber|0;if(f===r){const o=T.endColumn|0,v=S.endColumn|0;return o-v}return f-r}return I-d}return C-i}return(T?1:0)-(S?1:0)}static compareRangesUsingEnds(T,S){return T.endLineNumber===S.endLineNumber?T.endColumn===S.endColumn?T.startLineNumber===S.startLineNumber?T.startColumn-S.startColumn:T.startLineNumber-S.startLineNumber:T.endColumn-S.endColumn:T.endLineNumber-S.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=k}),define(be[114],we([0,1,38,32]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends k.Range{constructor(D,y,C,i){super(D,y,C,i);this.selectionStartLineNumber=D,this.selectionStartColumn=y,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,y){return D.selectionStartLineNumber===y.selectionStartLineNumber&&D.selectionStartColumn===y.selectionStartColumn&&D.positionLineNumber===y.positionLineNumber&&D.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,y){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,y):new T(D,y,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,y){return this.getDirection()===0?new T(D,y,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,y)}static fromPositions(D,y=D){return new T(D.lineNumber,D.column,y.lineNumber,y.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,y){if(D&&!y||!D&&y)return!1;if(!D&&!y)return!0;if(D.length!==y.length)return!1;for(let C=0,i=D.length;C<i;C++)if(!this.selectionsEqual(D[C],y[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,y,C,i,I){return I===0?new T(D,y,C,i):new T(C,i,D,y)}}e.Selection=T}),define(be[85],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class y{constructor(r,o){this.range=r,this.matches=o}}e.FindMatch=y;var C;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class I{constructor(r,o,v,m,E,p){this.identifier=r,this.range=o,this.text=v,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=E,this._isTracked=p}}e.ValidAnnotatedEditOperation=I;class d{constructor(r,o,v){this.reverseEdits=r,this.changes=o,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=d}),define(be[115],we([0,1,8,113,38,32,85]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class y{constructor(p,u,b,t){this.searchString=p,this.isRegex=u,this.matchCase=b,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=C(this.searchString):p=this.searchString.indexOf(`
`)>=0;let u=null;try{u=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let b=!this.isRegex&&!p;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new i(u,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}e.SearchParams=y;function C(E){if(!E||E.length===0)return!1;for(let p=0,u=E.length;p<u;p++)if(E.charCodeAt(p)===92){if(p++,p>=u)break;const t=E.charCodeAt(p);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(p,u,b){this.regex=p,this.wordSeparators=u,this.simpleSearch=b}}e.SearchData=i;function I(E,p,u){if(!u)return new S.FindMatch(E,null);let b=[];for(let t=0,n=p.length;t<n;t++)b[t]=p[t];return new S.FindMatch(E,b)}e.createFindMatch=I;class d{constructor(p){let u=[],b=0;for(let t=0,n=p.length;t<n;t++)p.charCodeAt(t)===10&&(u[b++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(p){const u=this._lineFeedsOffsets;let b=0,t=u.length-1;if(t===-1||p<=u[0])return 0;for(;b<t;){const n=b+((t-b)/2>>0);u[n]>=p?t=n-1:u[n+1]>=p?(b=n,t=n):b=n+1}return b+1}}class f{static findMatches(p,u,b,t,n){const a=u.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(p,b,new m(a.wordSeparators,a.regex),t,n):this._doFindMatchesLineByLine(p,b,a,t,n):[]}static _getMultilineMatchRange(p,u,b,t,n,a){let s,c=0;t?(c=t.findLineFeedCountBeforeOffset(n),s=u+n+c):s=u+n;let l;if(t){let w=t.findLineFeedCountBeforeOffset(n+a.length)-c;l=s+a.length+w}else l=s+a.length;const h=p.getPositionAt(s),P=p.getPositionAt(l);return new T.Range(h.lineNumber,h.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(p,u,b,t,n){const a=p.getOffsetAt(u.getStartPosition()),s=p.getValueInRange(u,1),c=p.getEOL()===`\r
`?new d(s):null,l=[];let h=0,P;for(b.reset(0);P=b.next(s);)if(l[h++]=I(this._getMultilineMatchRange(p,a,s,c,P.index,P[0]),P,t),h>=n)return l;return l}static _doFindMatchesLineByLine(p,u,b,t,n){const a=[];let s=0;if(u.startLineNumber===u.endLineNumber){const l=p.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return s=this._findMatchesInLine(b,l,u.startLineNumber,u.startColumn-1,s,a,t,n),a}const c=p.getLineContent(u.startLineNumber).substring(u.startColumn-1);s=this._findMatchesInLine(b,c,u.startLineNumber,u.startColumn-1,s,a,t,n);for(let l=u.startLineNumber+1;l<u.endLineNumber&&s<n;l++)s=this._findMatchesInLine(b,p.getLineContent(l),l,0,s,a,t,n);if(s<n){const l=p.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);s=this._findMatchesInLine(b,l,u.endLineNumber,0,s,a,t,n)}return a}static _findMatchesInLine(p,u,b,t,n,a,s,c){const l=p.wordSeparators;if(!s&&p.simpleSearch){const g=p.simpleSearch,w=g.length,R=u.length;let L=-w;for(;(L=u.indexOf(g,L+w))!==-1;)if((!l||v(l,u,R,L,w))&&(a[n++]=new S.FindMatch(new T.Range(b,L+1+t,b,L+1+w+t),null),n>=c))return n;return n}const h=new m(p.wordSeparators,p.regex);let P;h.reset(0);do if(P=h.next(u),P&&(a[n++]=I(new T.Range(b,P.index+1+t,b,P.index+1+P[0].length+t),P,s),n>=c))return n;while(P);return n}static findNextMatch(p,u,b,t){const n=u.parseSearchRequest();if(!n)return null;const a=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(p,b,a,t):this._doFindNextMatchLineByLine(p,b,a,t)}static _doFindNextMatchMultiline(p,u,b,t){const n=new A.Position(u.lineNumber,1),a=p.getOffsetAt(n),s=p.getLineCount(),c=p.getValueInRange(new T.Range(n.lineNumber,n.column,s,p.getLineMaxColumn(s)),1),l=p.getEOL()===`\r
`?new d(c):null;b.reset(u.column-1);let h=b.next(c);return h?I(this._getMultilineMatchRange(p,a,c,l,h.index,h[0]),h,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(p,new A.Position(1,1),b,t):null}static _doFindNextMatchLineByLine(p,u,b,t){const n=p.getLineCount(),a=u.lineNumber,s=p.getLineContent(a),c=this._findFirstMatchInLine(b,s,a,u.column,t);if(c)return c;for(let l=1;l<=n;l++){const h=(a+l-1)%n,P=p.getLineContent(h+1),g=this._findFirstMatchInLine(b,P,h+1,1,t);if(g)return g}return null}static _findFirstMatchInLine(p,u,b,t,n){p.reset(t-1);const a=p.next(u);return a?I(new T.Range(b,a.index+1,b,a.index+1+a[0].length),a,n):null}static findPreviousMatch(p,u,b,t){const n=u.parseSearchRequest();if(!n)return null;const a=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(p,b,a,t):this._doFindPreviousMatchLineByLine(p,b,a,t)}static _doFindPreviousMatchMultiline(p,u,b,t){const n=this._doFindMatchesMultiline(p,new T.Range(1,1,u.lineNumber,u.column),b,t,10*D);if(n.length>0)return n[n.length-1];const a=p.getLineCount();return u.lineNumber!==a||u.column!==p.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(p,new A.Position(a,p.getLineMaxColumn(a)),b,t):null}static _doFindPreviousMatchLineByLine(p,u,b,t){const n=p.getLineCount(),a=u.lineNumber,s=p.getLineContent(a).substring(0,u.column-1),c=this._findLastMatchInLine(b,s,a,t);if(c)return c;for(let l=1;l<=n;l++){const h=(n+a-l-1)%n,P=p.getLineContent(h+1),g=this._findLastMatchInLine(b,P,h+1,t);if(g)return g}return null}static _findLastMatchInLine(p,u,b,t){let n=null,a;for(p.reset(0);a=p.next(u);)n=I(new T.Range(b,a.index+1,b,a.index+1+a[0].length),a,t);return n}}e.TextModelSearch=f;function r(E,p,u,b,t){if(b===0)return!0;const n=p.charCodeAt(b-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const a=p.charCodeAt(b);if(E.get(a)!==0)return!0}return!1}function o(E,p,u,b,t){if(b+t===u)return!0;const n=p.charCodeAt(b+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const a=p.charCodeAt(b+t-1);if(E.get(a)!==0)return!0}return!1}function v(E,p,u,b,t){return r(E,p,u,b,t)&&o(E,p,u,b,t)}e.isValidMatch=v;class m{constructor(p,u){this._wordSeparators=p,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const u=p.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(b=this._searchRegex.exec(p),!b))return null;const t=b.index,n=b[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(p,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||v(this._wordSeparators,p,u,t,n))return b}while(b);return null}}e.Searcher=m}),define(be[86],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(D=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(y+="\\"+C);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=_();function k(D){let y=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)y=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),y=new RegExp(D.source,C)}return y.lastIndex=0,y}e.ensureValidWordDefinition=k;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,y,C,i,I=A){if(C.length>I.maxLen){let v=D-I.maxLen/2;return v<0?v=0:i+=v,C=C.substring(v,D+I.maxLen/2),T(D,y,C,i,I)}const d=Date.now(),f=D-1-i;let r=-1,o=null;for(let v=1;!(Date.now()-d>=I.timeBudget);v++){const m=f-I.windowSize*v;y.lastIndex=Math.max(0,m);const E=S(y,C,f,r);if(!E&&o||(o=E,m<=0))break;r=m}if(o){let v={word:o[0],startColumn:i+1+o.index,endColumn:i+1+o.index+o[0].length};return y.lastIndex=0,v}return null}e.getWordAtText=T;function S(D,y,C,i){let I;for(;I=D.exec(y);){const d=I.index||0;if(d<=C&&D.lastIndex>=C)return I;if(i>0&&d>i)return null}return null}}),define(be[116],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class k{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let y=0,C=D.notIn.length;y<C;y++)switch(D.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=k;class A{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of D)T(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),T(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),T(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),T(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&T(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=A;function T(S,D,y){S.has(D)?S.get(D).push(y):S.set(D,[y])}}),define(be[60],we([0,1,28,13]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,S,D,y){if(Array.isArray(T)){let C=0;for(const i of T){const I=A(i,S,D,y);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof T=="string")return y?T==="*"?5:T===D?10:0:0;if(T){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:d}=T;if(!y&&!d)return 0;let f=0;if(I)if(I===S.scheme)f=10;else if(I==="*")f=5;else return 0;if(C)if(C===D)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,k.normalize)(i.base)}),r===S.fsPath||(0,_.match)(r,S.fsPath))f=10;else return 0}return f}else return 0}}e.score=A}),define(be[117],we([0,1,84]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class A{constructor(r,o,v){const m=new Uint8Array(r*o);for(let E=0,p=r*o;E<p;E++)m[E]=v;this._data=m,this.rows=r,this.cols=o}get(r,o){return this._data[r*this.cols+o]}set(r,o,v){this._data[r*this.cols+o]=v}}e.Uint8Matrix=A;class T{constructor(r){let o=0,v=0;for(let E=0,p=r.length;E<p;E++){let[u,b,t]=r[E];b>o&&(o=b),u>v&&(v=u),t>v&&(v=t)}o++,v++;let m=new A(v,o,0);for(let E=0,p=r.length;E<p;E++){let[u,b,t]=r[E];m.set(u,b,t)}this._states=m,this._maxCharCode=o}nextState(r,o){return o<0||o>=this._maxCharCode?0:this._states.get(r,o)}}e.StateMachine=T;let S=null;function D(){return S===null&&(S=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let C=null;function i(){if(C===null){C=new _.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<f.length;o++)C.set(f.charCodeAt(o),1);const r=".,;";for(let o=0;o<r.length;o++)C.set(r.charCodeAt(o),2)}return C}class I{static _createLink(r,o,v,m,E){let p=E-1;do{const u=o.charCodeAt(p);if(r.get(u)!==2)break;p--}while(p>m);if(m>0){const u=o.charCodeAt(m-1),b=o.charCodeAt(p);(u===40&&b===41||u===91&&b===93||u===123&&b===125)&&p--}return{range:{startLineNumber:v,startColumn:m+1,endLineNumber:v,endColumn:p+2},url:o.substring(m,p+1)}}static computeLinks(r,o=D()){const v=i();let m=[];for(let E=1,p=r.getLineCount();E<=p;E++){const u=r.getLineContent(E),b=u.length;let t=0,n=0,a=0,s=1,c=!1,l=!1,h=!1,P=!1;for(;t<b;){let g=!1;const w=u.charCodeAt(t);if(s===13){let R;switch(w){case 40:c=!0,R=0;break;case 41:R=c?0:1;break;case 91:h=!0,l=!0,R=0;break;case 93:h=!1,R=l?0:1;break;case 123:P=!0,R=0;break;case 125:R=P?0:1;break;case 39:R=a===34||a===96?0:1;break;case 34:R=a===39||a===96?0:1;break;case 96:R=a===39||a===34?0:1;break;case 42:R=a===42?1:0;break;case 124:R=a===124?1:0;break;case 32:R=h?0:1;break;default:R=v.get(w)}R===1&&(m.push(I._createLink(v,u,E,n,t)),g=!0)}else if(s===12){let R;w===91?(l=!0,R=0):R=v.get(w),R===1?g=!0:s=13}else s=o.nextState(s,w),s===0&&(g=!0);g&&(s=1,c=!1,l=!1,P=!1,n=t+1,a=w),t++}s===13&&m.push(I._createLink(v,u,E,n,b))}return m}}e.LinkComputer=I;function d(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:I.computeLinks(f)}e.computeLinks=d}),define(be[118],we([0,1,3,6]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,D){return this._map.set(S,D),this.fire([S]),(0,k.toDisposable)(()=>{this._map.get(S)===D&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,D){let y=null,C=!1;return this._promises.set(S,D.then(i=>{this._promises.delete(S),!(C||!i)&&(y=this.register(S,i))})),(0,k.toDisposable)(()=>{C=!0,y&&y.dispose()})}getPromise(S){const D=this.get(S);if(D)return Promise.resolve(D);const y=this._promises.get(S);return y?y.then(C=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(be[87],we([0,1,23,21]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(A||(A={}));function T(I){for(let d=0,f=I.length;d<f;d+=4){const r=I[d+0],o=I[d+1],v=I[d+2],m=I[d+3];I[d+0]=m,I[d+1]=v,I[d+2]=o,I[d+3]=r}}function S(I){const d=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return k.isLittleEndian()||T(d),_.VSBuffer.wrap(d)}function D(I){const d=I.buffer;if(k.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const f=new Uint8Array(d.byteLength);return f.set(d),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(I){const d=new Uint32Array(C(I));let f=0;if(d[f++]=I.id,I.type==="full")d[f++]=1,d[f++]=I.data.length,d.set(I.data,f),f+=I.data.length;else{d[f++]=2,d[f++]=I.deltas.length;for(const r of I.deltas)d[f++]=r.start,d[f++]=r.deleteCount,r.data?(d[f++]=r.data.length,d.set(r.data,f),f+=r.data.length):d[f++]=0}return S(d)}e.encodeSemanticTokensDto=y;function C(I){let d=0;if(d+=1+1,I.type==="full")d+=1+I.data.length;else{d+=1,d+=(1+1+1)*I.deltas.length;for(const f of I.deltas)f.data&&(d+=f.data.length)}return d}function i(I){const d=D(I);let f=0;const r=d[f++];if(d[f++]===1){const E=d[f++],p=d.subarray(f,f+E);return f+=E,{id:r,type:"full",data:p}}const v=d[f++];let m=[];for(let E=0;E<v;E++){const p=d[f++],u=d[f++],b=d[f++];let t;b>0&&(t=d.subarray(f,f+b),f+=b),m[E]={start:p,deleteCount:u,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(be[88],we([0,1,82]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(S,D){this.index=S,this.remainder=D}}e.PrefixSumIndexOfResult=k;class A{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,D){S=(0,_.toUint32)(S);const y=this.values,C=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(y.length+i),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+i),this.values.set(D,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,D){return S=(0,_.toUint32)(S),D=(0,_.toUint32)(D),this.values[S]===D?!1:(this.values[S]=D,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,D){S=(0,_.toUint32)(S),D=(0,_.toUint32)(D);const y=this.values,C=this.prefixSum;if(S>=y.length)return!1;let i=y.length-S;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(y.length-D),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+D),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,_.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),S>=this.values.length&&(S=this.values.length-1);for(let y=D;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let D=0,y=this.values.length-1,C=0,i=0,I=0;for(;D<=y;)if(C=D+(y-D)/2|0,i=this.prefixSum[C],I=i-this.values[C],S<I)y=C-1;else if(S>=i)D=C+1;else break;return new k(C,S-I)}}e.PrefixSumComputer=A}),define(be[119],we([0,1,8,38,88]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,y,C,i){this._uri=D,this._lines=y,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const y=D.changes;for(const C of y)this._acceptDeleteRange(C.range),this._acceptInsertText(new k.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,y=this._lines.length,C=new Uint32Array(y);for(let i=0;i<y;i++)C[i]=this._lines[i].length+D;this._lineStarts=new A.PrefixSumComputer(C)}}_setLineText(D,y){this._lines[D]=y,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,y){if(y.length!==0){let C=(0,_.splitLines)(y);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}}e.MirrorTextModel=T}),define(be[120],we([16,17]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(be[61],we([0,1,120,10,12]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(C,i){return i&&(C.stack||C.stacktrace)?_.localize(0,null,D(C),S(C.stack)||S(C.stacktrace)):D(C)}function S(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?_.localize(1,null,C.message):C.message||_.localize(2,null)}function y(C=null,i=!1){if(!C)return _.localize(3,null);if(Array.isArray(C)){const I=A.coalesce(C),d=y(I[0],i);return I.length>1?_.localize(4,null,d,I.length):d}if(k.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return T(I.error,i);if(I.exception)return T(I.exception,i)}return C.stack?T(C,i):C.message?C.message:_.localize(5,null)}e.toErrorMessage=y}),define(be[121],we([16,17]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(be[122],we([0,1,121,21,86]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=S;class D{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=D;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class C{constructor(te,ve,Ue,He){this.id=te,this.name=ve,this.defaultValue=Ue,this.schema=He}compute(te,ve,Ue){return Ue}}class i{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class I{constructor(te,ve,Ue,He){this.id=te,this.name=ve,this.defaultValue=Ue,this.schema=He}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Ue){return Ue}}function d(j,te){return typeof j=="undefined"?te:j==="false"?!1:Boolean(j)}e.boolean=d;class f extends I{constructor(te,ve,Ue,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Ue),super(te,ve,Ue,He)}validate(te){return d(te,this.defaultValue)}}class r extends I{constructor(te,ve,Ue,He,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ue,Ye.minimum=He,Ye.maximum=$e),super(te,ve,Ue,Ye),this.minimum=He,this.maximum=$e}static clampedInt(te,ve,Ue,He){if(typeof te=="undefined")return ve;let $e=parseInt(te,10);return isNaN($e)?ve:($e=Math.max(Ue,$e),$e=Math.min(He,$e),$e|0)}validate(te){return r.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class o extends I{constructor(te,ve,Ue,He,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ue),super(te,ve,Ue,$e),this.validationFn=He}static clamp(te,ve,Ue){return te<ve?ve:te>Ue?Ue:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Ue=parseFloat(te);return isNaN(Ue)?ve:Ue}validate(te){return this.validationFn(o.float(te,this.defaultValue))}}class v extends I{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Ue,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Ue),super(te,ve,Ue,He)}validate(te){return v.string(te,this.defaultValue)}}function m(j,te,ve){return typeof j!="string"||ve.indexOf(j)===-1?te:j}e.stringSet=m;class E extends I{constructor(te,ve,Ue,He,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=He,$e.default=Ue),super(te,ve,Ue,$e),this._allowedValues=He}validate(te){return m(te,this.defaultValue,this._allowedValues)}}class p extends C{constructor(te,ve,Ue,He,$e,Ye,H=void 0){typeof H!="undefined"&&(H.type="string",H.enum=$e,H.default=He),super(te,ve,Ue,H),this._allowedValues=$e,this._convert=Ye}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function u(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Ue){return Ue===0?te.accessibilitySupport:Ue}}class t extends C{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:_.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:d(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(j){switch(j){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function l(j){switch(j){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class h extends i{constructor(){super(123,[62,31])}compute(te,ve,Ue){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),te.extraEditorClassName&&He.push(te.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class P extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(te,ve,Ue){return Ue&&te.emptySelectionClipboard}}class g extends C{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:_.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:_.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:d(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":m(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ve.loop,this.defaultValue.loop)}}}class w extends C{constructor(){super(41,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?w.OFF:te==="true"?w.ON:te:Boolean(te)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(te,ve,Ue){return te.fontInfo}}class L extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(te){let ve=o.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ve,6,100)}compute(te,ve,Ue){return te.fontInfo.fontSize}}class V extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(r.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class he extends C{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]};super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,description:_.localize(35,null)}})}validate(te){var ve,Ue,He,$e,Ye;if(!te||typeof te!="object")return this.defaultValue;const H=te;return{multiple:m(H.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=H.multipleDefinitions)!==null&&ve!==void 0?ve:m(H.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ue=H.multipleTypeDefinitions)!==null&&Ue!==void 0?Ue:m(H.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=H.multipleDeclarations)!==null&&He!==void 0?He:m(H.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=H.multipleImplementations)!==null&&$e!==void 0?$e:m(H.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=H.multipleReferences)!==null&&Ye!==void 0?Ye:m(H.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(H.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(H.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(H.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(H.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(H.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends C{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:_.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:d(ve.sticky,this.defaultValue.sticky)}}}var W;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class J extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(te,ve,Ue){return J.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Ue=te.scrollBeyondLastLine?ve-1:0,He=(te.viewLineCount+Ue)/(te.pixelRatio*te.height),$e=Math.floor(te.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:$e}}static _computeMinimapLayout(te,ve){const Ue=te.outerWidth,He=te.outerHeight,$e=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ye=ve.stableMinimapLayoutInput,H=Ye&&te.outerHeight===Ye.outerHeight&&te.lineHeight===Ye.lineHeight&&te.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ye.pixelRatio&&te.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&te.minimap.enabled===Ye.minimap.enabled&&te.minimap.side===Ye.minimap.side&&te.minimap.size===Ye.minimap.size&&te.minimap.showSlider===Ye.minimap.showSlider&&te.minimap.renderCharacters===Ye.minimap.renderCharacters&&te.minimap.maxColumn===Ye.minimap.maxColumn&&te.minimap.scale===Ye.minimap.scale&&te.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&te.isViewportWrapping===Ye.isViewportWrapping,se=te.lineHeight,de=te.typicalHalfwidthCharacterWidth,K=te.scrollBeyondLastLine,ee=te.minimap.renderCharacters;let le=$e>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const fe=te.minimap.maxColumn,Ee=te.minimap.size,Ve=te.minimap.side,Fe=te.verticalScrollbarWidth,We=te.viewLineCount,Qe=te.remainingWidth,it=te.isViewportWrapping,at=ee?2:3;let Ze=Math.floor($e*He);const nt=Ze/$e;let dt=!1,wt=!1,ue=at*le,Se=le/$e,ae=1;if(Ee==="fill"||Ee==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:Ge,desiredRatio:ht,minimapLineCount:ot}=J.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:K,height:He,lineHeight:se,pixelRatio:$e});if(We/ot>1)dt=!0,wt=!0,le=1,ue=1,Se=le/$e;else{let pt=!1,_t=le+1;if(Ee==="fit"){const yt=Math.ceil((We+Ge)*ue);it&&H&&Qe<=ve.stableFitRemainingWidth?(pt=!0,_t=ve.stableFitMaxMinimapScale):(pt=yt>Ze,it&&pt?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Qe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(Ee==="fill"||pt){dt=!0;const yt=le;ue=Math.min(se*$e,Math.max(1,Math.floor(1/ht))),le=Math.min(_t,Math.max(1,Math.floor(ue/at))),le>yt&&(ae=Math.min(2,le/yt)),Se=le/$e/ae,Ze=Math.ceil(Math.max(rt,We+Ge)*ue),it&&pt&&(ve.stableFitMaxMinimapScale=le)}}}const q=Math.floor(fe*Se),Le=Math.min(q,Math.max(0,Math.floor((Qe-Fe-2)*Se/(de+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor($e*Le);const Xe=Ie/$e;Ie=Math.floor(Ie*ae);const et=ee?1:2,ct=Ve==="left"?0:Ue-Le-Fe;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Le,minimapHeightIsEditorHeight:dt,minimapIsSampling:wt,minimapScale:le,minimapLineHeight:ue,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:Xe,minimapCanvasOuterHeight:nt}}static computeLayout(te,ve){const Ue=ve.outerWidth|0,He=ve.outerHeight|0,$e=ve.lineHeight|0,Ye=ve.lineNumbersDigitCount|0,H=ve.typicalHalfwidthCharacterWidth,se=ve.maxDigitWidth,de=ve.pixelRatio,K=ve.viewLineCount,ee=te.get(118),le=ee==="inherit"?te.get(117):ee,fe=le==="inherit"?te.get(113):le,Ee=te.get(116),Ve=te.get(2),Fe=ve.isDominatedByLongLines,We=te.get(46),Qe=te.get(56).renderType!==0,it=te.get(57),at=te.get(91),Ze=te.get(61),nt=te.get(89),dt=nt.verticalScrollbarSize,wt=nt.verticalHasArrows,ue=nt.arrowSize,Se=nt.horizontalScrollbarSize,ae=te.get(54),q=te.get(35);let Le;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const Pt=parseFloat(ae.substr(0,ae.length-2));Le=r.clampedInt(Pt*H,0,0,1e3)}else Le=r.clampedInt(ae,0,0,1e3);q&&(Le+=16);let Ie=0;if(Qe){const Pt=Math.max(Ye,it);Ie=Math.round(Pt*se)}let Xe=0;We&&(Xe=$e);let et=0,ct=et+Xe,rt=ct+Ie,Ge=rt+Le;const ht=Ue-Xe-Ie-Le;let ot=!1,vt=!1,pt=-1;Ve!==2&&(le==="inherit"&&Fe?(ot=!0,vt=!0):fe==="on"||fe==="bounded"?vt=!0:fe==="wordWrapColumn"&&(pt=Ee));const _t=J._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:$e,typicalHalfwidthCharacterWidth:H,pixelRatio:de,scrollBeyondLastLine:at,minimap:Ze,verticalScrollbarWidth:dt,viewLineCount:K,remainingWidth:ht,isViewportWrapping:vt},ve.memory||new y);_t.renderMinimap!==0&&_t.minimapLeft===0&&(et+=_t.minimapWidth,ct+=_t.minimapWidth,rt+=_t.minimapWidth,Ge+=_t.minimapWidth);const yt=ht-_t.minimapWidth,It=Math.max(1,Math.floor((yt-dt-2)/H)),bt=wt?ue:0;return vt&&(pt=Math.max(1,It),fe==="bounded"&&(pt=Math.min(pt,Ee))),{width:Ue,height:He,glyphMarginLeft:et,glyphMarginWidth:Xe,lineNumbersLeft:ct,lineNumbersWidth:Ie,decorationsLeft:rt,decorationsWidth:Le,contentLeft:Ge,contentWidth:yt,minimap:_t,viewportColumn:It,isWordWrapMinified:ot,isViewportWrapping:vt,wrappingColumn:pt,verticalScrollbarWidth:dt,horizontalScrollbarHeight:Se,overviewRuler:{top:bt,width:dt,height:He-2*bt,right:0}}}}e.EditorLayoutInfoComputer=J;class O extends C{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:_.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:d(te.enabled,this.defaultValue.enabled)}}}class F extends C{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",te,{"editor.inlineHints.enabled":{type:"boolean",default:te.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:te.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:te.fontFamily,description:_.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class N extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(te,ve,Ue){return te.fontInfo.lineHeight}}class B extends C{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:te.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:_.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),size:m(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ve.side,this.defaultValue.side,["right","left"]),showSlider:m(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(j){return j==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends C{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class Z extends C{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:_.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),cycle:d(ve.cycle,this.defaultValue.cycle)}}}class ne extends i{constructor(){super(124)}compute(te,ve,Ue){return te.pixelRatio}}class pe extends C{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:_.localize(58,null)},comments:{type:"boolean",default:te.comments,description:_.localize(59,null)},other:{type:"boolean",default:te.other,description:_.localize(60,null)}}}],default:te,description:_.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Ue={other:d(ve.other,this.defaultValue.other),comments:d(ve.comments,this.defaultValue.comments),strings:d(ve.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Pe;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends C{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Ue=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ue}}}function Te(j){const te=j.get(84);return te==="editable"?j.get(77):te!=="on"}e.filterValidationDecorations=Te;class xe extends C{constructor(){const te=[],ve={type:"number",description:_.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:te,description:_.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Ue of te)if(typeof Ue=="number")ve.push({column:r.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;ve.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Ue,He)=>Ue.column-He.column),ve}return this.defaultValue}}function $(j,te){if(typeof j!="string")return te;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends C{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Ue=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(ve.vertical,this.defaultValue.vertical),horizontal:$(ve.horizontal,this.defaultValue.horizontal),useShadows:d(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:d(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ie extends C{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:te.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:m(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ve.showIcons,this.defaultValue.showIcons),showStatusBar:d(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ve.showMethods,this.defaultValue.showMethods),showFunctions:d(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ve.showConstructors,this.defaultValue.showConstructors),showFields:d(ve.showFields,this.defaultValue.showFields),showVariables:d(ve.showVariables,this.defaultValue.showVariables),showClasses:d(ve.showClasses,this.defaultValue.showClasses),showStructs:d(ve.showStructs,this.defaultValue.showStructs),showInterfaces:d(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ve.showModules,this.defaultValue.showModules),showProperties:d(ve.showProperties,this.defaultValue.showProperties),showEvents:d(ve.showEvents,this.defaultValue.showEvents),showOperators:d(ve.showOperators,this.defaultValue.showOperators),showUnits:d(ve.showUnits,this.defaultValue.showUnits),showValues:d(ve.showValues,this.defaultValue.showValues),showConstants:d(ve.showConstants,this.defaultValue.showConstants),showEnums:d(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ve.showKeywords,this.defaultValue.showKeywords),showWords:d(ve.showWords,this.defaultValue.showWords),showColors:d(ve.showColors,this.defaultValue.showColors),showFiles:d(ve.showFiles,this.defaultValue.showFiles),showReferences:d(ve.showReferences,this.defaultValue.showReferences),showFolders:d(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ve.showSnippets,this.defaultValue.showSnippets),showUsers:d(ve.showUsers,this.defaultValue.showUsers),showIssues:d(ve.showIssues,this.defaultValue.showIssues)}}}class oe extends C{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends i{constructor(){super(125,[77])}compute(te,ve,Ue){return ve.get(77)?!0:te.tabFocusMode}}var De;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Ne(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends i{constructor(){super(127,[126])}compute(te,ve,Ue){const He=ve.get(126);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Ae:k.isLinux?Be:Ce,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(j){return e.editorOptionsRegistry[j.id]=j,j}var qe;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.letterSpacing=52]="letterSpacing",j[j.lightbulb=53]="lightbulb",j[j.lineDecorationsWidth=54]="lineDecorationsWidth",j[j.lineHeight=55]="lineHeight",j[j.lineNumbers=56]="lineNumbers",j[j.lineNumbersMinChars=57]="lineNumbersMinChars",j[j.linkedEditing=58]="linkedEditing",j[j.links=59]="links",j[j.matchBrackets=60]="matchBrackets",j[j.minimap=61]="minimap",j[j.mouseStyle=62]="mouseStyle",j[j.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=64]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",j[j.multiCursorModifier=66]="multiCursorModifier",j[j.multiCursorPaste=67]="multiCursorPaste",j[j.occurrencesHighlight=68]="occurrencesHighlight",j[j.overviewRulerBorder=69]="overviewRulerBorder",j[j.overviewRulerLanes=70]="overviewRulerLanes",j[j.padding=71]="padding",j[j.parameterHints=72]="parameterHints",j[j.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",j[j.quickSuggestions=75]="quickSuggestions",j[j.quickSuggestionsDelay=76]="quickSuggestionsDelay",j[j.readOnly=77]="readOnly",j[j.renameOnType=78]="renameOnType",j[j.renderControlCharacters=79]="renderControlCharacters",j[j.renderIndentGuides=80]="renderIndentGuides",j[j.renderFinalNewline=81]="renderFinalNewline",j[j.renderLineHighlight=82]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=84]="renderValidationDecorations",j[j.renderWhitespace=85]="renderWhitespace",j[j.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",j[j.roundedSelection=87]="roundedSelection",j[j.rulers=88]="rulers",j[j.scrollbar=89]="scrollbar",j[j.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=91]="scrollBeyondLastLine",j[j.scrollPredominantAxis=92]="scrollPredominantAxis",j[j.selectionClipboard=93]="selectionClipboard",j[j.selectionHighlight=94]="selectionHighlight",j[j.selectOnLineNumbers=95]="selectOnLineNumbers",j[j.showFoldingControls=96]="showFoldingControls",j[j.showUnused=97]="showUnused",j[j.snippetSuggestions=98]="snippetSuggestions",j[j.smartSelect=99]="smartSelect",j[j.smoothScrolling=100]="smoothScrolling",j[j.stickyTabStops=101]="stickyTabStops",j[j.stopRenderingLineAfter=102]="stopRenderingLineAfter",j[j.suggest=103]="suggest",j[j.suggestFontSize=104]="suggestFontSize",j[j.suggestLineHeight=105]="suggestLineHeight",j[j.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",j[j.suggestSelection=107]="suggestSelection",j[j.tabCompletion=108]="tabCompletion",j[j.tabIndex=109]="tabIndex",j[j.unusualLineTerminators=110]="unusualLineTerminators",j[j.useTabStops=111]="useTabStops",j[j.wordSeparators=112]="wordSeparators",j[j.wordWrap=113]="wordWrap",j[j.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=116]="wordWrapColumn",j[j.wordWrapOverride1=117]="wordWrapOverride1",j[j.wordWrapOverride2=118]="wordWrapOverride2",j[j.wrappingIndent=119]="wrappingIndent",j[j.wrappingStrategy=120]="wrappingStrategy",j[j.showDeprecated=121]="showDeprecated",j[j.inlineHints=122]="inlineHints",j[j.editorClassName=123]="editorClassName",j[j.pixelRatio=124]="pixelRatio",j[j.tabFocusMode=125]="tabFocusMode",j[j.layoutInfo=126]="layoutInfo",j[j.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:_e(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:_e(new b),accessibilityPageSize:_e(new r(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:_e(new v(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:_e(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:_e(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:_e(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:_e(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:_e(new p(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:_e(new f(10,"automaticLayout",!1)),autoSurround:_e(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:_e(new f(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:_e(new f(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:_e(new v(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:_e(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:_e(new f(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:_e(new f(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:_e(new t),contextmenu:_e(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new f(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:_e(new p(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:_e(new f(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:_e(new p(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:_.localize(145,null)})),cursorSurroundingLines:_e(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:_e(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:_e(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:_e(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new f(28,"domReadOnly",!1)),dragAndDrop:_e(new f(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:_e(new P),extraEditorClassName:_e(new v(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new o(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:_.localize(152,null)})),find:_e(new g),fixedOverflowWidgets:_e(new f(34,"fixedOverflowWidgets",!1)),folding:_e(new f(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:_e(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:_e(new f(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:_e(new v(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:_e(new R),fontLigatures2:_e(new w),fontSize:_e(new L),fontWeight:_e(new V),formatOnPaste:_e(new f(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:_e(new f(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:_e(new f(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:_e(new he),hideCursorInOverviewRuler:_e(new f(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:_e(new f(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:_e(new z),inDiffEditor:_e(new f(51,"inDiffEditor",!1)),letterSpacing:_e(new o(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>o.clamp(j,-5,20),{description:_.localize(165,null)})),lightbulb:_e(new O),lineDecorationsWidth:_e(new I(54,"lineDecorationsWidth",10)),lineHeight:_e(new N),lineNumbers:_e(new Oe),lineNumbersMinChars:_e(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new f(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:_e(new f(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:_e(new E(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:_e(new B),mouseStyle:_e(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new o(63,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:_e(new f(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:_e(new f(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:_e(new p(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:_e(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:_e(new f(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:_e(new f(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:_e(new r(70,"overviewRulerLanes",3,0,3)),padding:_e(new Q),parameterHints:_e(new Z),peekWidgetDefaultFocus:_e(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:_e(new f(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:_e(new pe),quickSuggestionsDelay:_e(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:_e(new f(77,"readOnly",!1)),renameOnType:_e(new f(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:_e(new f(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:_e(new f(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:_e(new f(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:_e(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new f(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:_e(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:_e(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new f(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:_e(new xe),scrollbar:_e(new G),scrollBeyondLastColumn:_e(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:_e(new f(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:_e(new f(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:_e(new f(93,"selectionClipboard",!0,{description:_.localize(201,null),included:k.isLinux})),selectionHighlight:_e(new f(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:_e(new f(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:_e(new f(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:_e(new f(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:_e(new F),snippetSuggestions:_e(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:_e(new oe),smoothScrolling:_e(new f(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:_e(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ie),suggestFontSize:_e(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:_e(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:_e(new f(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:_e(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:_e(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:_e(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:_e(new f(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:_e(new v(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:_e(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new v(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new v(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:_e(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new p(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:_e(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:_e(new h),pixelRatio:_e(new ne),tabFocusMode:_e(new me),layoutInfo:_e(new J),wrappingInfo:_e(new ge)}}),define(be[123],we([16,17]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[124],we([16,17]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[125],we([16,17]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(be[126],we([16,17]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(be[127],we([16,17]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(be[128],we([16,17]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(be[129],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[130],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[131],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[132],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[133],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(be[134],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[135],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[136],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[137],we([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[138],we([16,17]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(be[139],we([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[140],we([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[141],we([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[142],we([16,17]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[143],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var k;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var A;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[144],we([0,1,124]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(I){return I=I.trim(),I==="*"||k.test(I)}e.isValidVersionStr=A;function T(I){if(!A(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=I.match(k);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function S(I){if(!I)return null;let d=I.majorBase,f=I.majorMustEqual,r=I.minorBase,o=I.minorMustEqual,v=I.patchBase,m=I.patchMustEqual;return I.hasCaret&&(d===0||(o=!1),m=!1),{majorBase:d,majorMustEqual:f,minorBase:r,minorMustEqual:o,patchBase:v,patchMustEqual:m,isMinimum:I.hasGreaterEquals}}e.normalizeVersion=S;function D(I,d){let f;typeof I=="string"?f=S(T(I)):f=I;let r;if(typeof d=="string"?r=S(T(d)):r=d,!f||!r)return!1;let o=f.majorBase,v=f.minorBase,m=f.patchBase,E=r.majorBase,p=r.minorBase,u=r.patchBase,b=r.majorMustEqual,t=r.minorMustEqual,n=r.patchMustEqual;return r.isMinimum?o>E?!0:o<E?!1:v>p?!0:v<p?!1:m>=u:(o===1&&E===0&&(!b||!t||!n)&&(E=1,p=0,u=0,b=!0,t=!1,n=!1),o<E?!1:o>E?!b:v<p?!1:v>p?!t:m<u?!1:m>u?!n:!0)}e.isValidVersion=D;function y(I,d,f){return d.isBuiltin||typeof d.main=="undefined"?!0:i(I,d.engines.vscode,f)}e.isValidExtensionVersion=y;function C(I,d){return I==="*"||i(d,I)}e.isEngineValid=C;function i(I,d,f=[]){let r=S(T(d));if(!r)return f.push(_.localize(0,null,d)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return f.push(_.localize(1,null,d)),!1}else if(!r.majorMustEqual)return f.push(_.localize(2,null,d)),!1;return D(I,r)?!0:(f.push(_.localize(3,null,I,d)),!1)}e.isVersionValid=i}),define(be[89],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(T,S=[],D=!1){this.ctor=T,this.staticArguments=S,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=_;const k=(A,...T)=>new _(A,T);e.createSyncDescriptor=k}),define(be[62],we([0,1,89]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(S,D,y){D instanceof _.SyncDescriptor||(D=new _.SyncDescriptor(D,[],y)),k.push([S,D])}e.registerSingleton=A;function T(){return k}e.getSingletonServiceDescriptors=T}),define(be[145],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=_;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let S of this._nodes.values())S.outgoing.size===0&&T.push(S);return T}insertEdge(T,S){const D=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(S);D.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(T),D)}removeNode(T){const S=this._hashFn(T);this._nodes.delete(S);for(let D of this._nodes.values())D.outgoing.delete(S),D.incoming.delete(S)}lookupOrInsertNode(T){const S=this._hashFn(T);let D=this._nodes.get(S);return D||(D=new _(T),this._nodes.set(S,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[S,D]of this._nodes)T.push(`${S}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,S]of this._nodes){const D=new Set([T]),y=this._findCycle(S,D);if(y)return y}}_findCycle(T,S){for(let[D,y]of T.outgoing){if(S.has(D))return[...S,D].join(" -> ");S.add(D);const C=this._findCycle(y,S);if(C)return C;S.delete(D)}}}e.Graph=k}),define(be[4],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(_=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(D,y,C,i){y[_.DI_TARGET]===y?y[_.DI_DEPENDENCIES].push({id:D,index:C,optional:i}):(y[_.DI_DEPENDENCIES]=[{id:D,index:C,optional:i}],y[_.DI_TARGET]=y)}function A(D){if(_.serviceIds.has(D))return _.serviceIds.get(D);const y=function(C,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(y,C,I,!1)};return y.toString=()=>D,_.serviceIds.set(D,y),y}e.createDecorator=A;function T(D){return D}e.refineServiceDecorator=T;function S(D){return function(y,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(D,y,i,!0)}}e.optional=S}),define(be[146],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function k(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(be[147],we([0,1,3,57,6,22,81,60,146]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(C):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(f,r){let o={selector:f,provider:r,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(o){let v=this._entries.indexOf(o);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),o=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const r=[];for(let o of this._entries)o._score>0&&r.push(o.provider);return r}ordered(f){const r=[];return this._orderedForEach(f,o=>r.push(o.provider)),r}orderedGroups(f){const r=[];let o,v;return this._orderedForEach(f,m=>{o&&v===m._score?o.push(m.provider):(v=m._score,o=[m.provider],r.push(o))}),r}_orderedForEach(f,r){if(!!f){this._updateScores(f);for(const o of this._entries)o._score>0&&r(o)}}_updateScores(f){let r={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let o of this._entries)if(o._score=(0,D.score)(o.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),C(o.selector)&&o._score>0){for(let v of this._entries)v._score=0;o._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(f,r){return f._score<r._score?1:f._score>r._score?-1:f._time<r._time?1:f._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(f,r,o=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=r,this.max=o,this._cache=new T.LRUCache(50,.7)}_key(f){return f.id+(0,k.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const r=this._key(f),o=this._cache.get(r);return this._clamp(o==null?void 0:o.value)}update(f,r){const o=this._key(f);let v=this._cache.get(o);return v||(v=new S.MovingAverage,this._cache.set(o,v)),v.update(r),this.get(f)}}e.LanguageFeatureRequestDelays=I}),define(be[63],we([0,1,2,32,147,118,36]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class y{constructor(w,R){this.language=w,this.id=R}}e.LanguageIdentifier=y;var C;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let R=this.getForeground(w),L="mtk"+R,V=this.getFontStyle(w);return V&1&&(L+=" mtki"),V&2&&(L+=" mtkb"),V&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(w,R){const L=this.getForeground(w),V=this.getFontStyle(w);let he=`color: ${R[L]};`;return V&1&&(he+="font-style: italic;"),V&2&&(he+="font-weight: bold;"),V&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=f;var r;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(w){const R=g[w];let L=R&&S.iconRegistry.get(R);return L||(console.info("No codicon found for CompletionItemKind "+w),L=S.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(w,R){let L=g[w];return typeof L=="undefined"&&!R&&(L=9),L}}();var o;(function(g){g[g.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(g){return g&&_.URI.isUri(g.uri)&&k.Range.isIRange(g.range)&&(k.Range.isIRange(g.originSelectionRange)||k.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=b;var t;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(g){g[g.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var a;(function(g){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function L(z){return w.get(z)}g.fromString=L;function V(z){return R.get(z)}g.toString=V;function he(z,W){const J=R.get(z);let O=J&&S.iconRegistry.get("symbol-"+J);return O||(console.info("No codicon found for SymbolKind "+z),O=S.Codicon.symbolProperty),`${W?"inline":"block"} ${O.classNames}`}g.toCssClassName=he})(a=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(w){this.value=w}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var c;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var h;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(h=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var P;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[148],we([0,1,6,10,4,3,45,43]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,C){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!C)throw new Error("invalid command");return this.registerCommand({id:y,handler:C})}if(y.description){const r=[];for(let v of y.description.args)r.push(v.constraint);const o=y.handler;y.handler=function(v,...m){return(0,k.validateConstraints)(m,r),o(v,...m)}}const{id:i}=y;let I=this._commands.get(i);I||(I=new S.LinkedList,this._commands.set(i,I));let d=I.unshift(y),f=(0,_.toDisposable)(()=>{d();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),f}registerCommandAlias(y,C){return e.CommandsRegistry.registerCommand(y,(i,...I)=>i.get(e.ICommandService).executeCommand(C,...I))}getCommand(y){const C=this._commands.get(y);if(!(!C||C.isEmpty()))return D.Iterable.first(C)}getCommands(){const y=new Map;for(const C of this._commands.keys()){const i=this.getCommand(C);i&&y.set(C,i)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[64],we([0,1,8,4,21]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",A.isMacintosh),S.set("isLinux",A.isLinux),S.set("isWindows",A.isWindows),S.set("isWeb",A.isWeb),S.set("isMacNative",A.isMacintosh&&!A.isWeb),S.set("isEdge",T.indexOf("Edg/")>=0),S.set("isFirefox",T.indexOf("Firefox")>=0),S.set("isChrome",T.indexOf("Chrome")>=0),S.set("isSafari",T.indexOf("Safari")>=0),S.set("isIPad",T.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var y;(function(g){g[g.False=0]="False",g[g.True=1]="True",g[g.Defined=2]="Defined",g[g.Not=3]="Not",g[g.Equals=4]="Equals",g[g.NotEquals=5]="NotEquals",g[g.And=6]="And",g[g.Regex=7]="Regex",g[g.NotRegex=8]="NotRegex",g[g.Or=9]="Or",g[g.In=10]="In",g[g.NotIn=11]="NotIn",g[g.Greater=12]="Greater",g[g.GreaterEquals=13]="GreaterEquals",g[g.Smaller=14]="Smaller",g[g.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return d.INSTANCE}static has(w){return f.create(w)}static equals(w,R){return r.create(w,R)}static notEquals(w,R){return m.create(w,R)}static regex(w,R){return n.create(w,R)}static in(w,R){return o.create(w,R)}static not(w){return E.create(w)}static and(...w){return s.create(w)}static or(...w){return c.create(w)}static greater(w,R){return p.create(w,R)}static less(w,R){return b.create(w,R)}static deserialize(w,R=!1){if(!!w)return this._deserializeOrExpression(w,R)}static _deserializeOrExpression(w,R){let L=w.split("||");return c.create(L.map(V=>this._deserializeAndExpression(V,R)))}static _deserializeAndExpression(w,R){let L=w.split("&&");return s.create(L.map(V=>this._deserializeOne(V,R)))}static _deserializeOne(w,R){if(w=w.trim(),w.indexOf("!=")>=0){let L=w.split("!=");return m.create(L[0].trim(),this._deserializeValue(L[1],R))}if(w.indexOf("==")>=0){let L=w.split("==");return r.create(L[0].trim(),this._deserializeValue(L[1],R))}if(w.indexOf("=~")>=0){let L=w.split("=~");return n.create(L[0].trim(),this._deserializeRegexValue(L[1],R))}if(w.indexOf(" in ")>=0){let L=w.split(" in ");return o.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const L=w.split(">=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const L=w.split(">");return p.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const L=w.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const L=w.split("<");return b.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(w)?E.create(w.substr(1).trim()):f.create(w)}static _deserializeValue(w,R){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let L=/^'([^']*)'$/.exec(w);return L?L[1].trim():w}static _deserializeRegexValue(w,R){if((0,_.isFalsyOrWhitespace)(w)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=w.indexOf("/"),V=w.lastIndexOf("/");if(L===V||L<0){if(R)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let he=w.slice(L+1,V),z=w[V+1]==="i"?"i":"";try{return new RegExp(he,z)}catch(W){if(R)throw new Error(`bad regexp-value '${w}', parse error: ${W}`);return console.warn(`bad regexp-value '${w}', parse error: ${W}`),null}}}e.ContextKeyExpr=C;function i(g,w){return g.cmp(w)}class I{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class d{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class f{constructor(w){this.key=w,this.type=2}static create(w){const R=S.get(w);return typeof R=="boolean"?R?d.INSTANCE:I.INSTANCE:new f(w)}cmp(w){return w.type!==this.type?this.type-w.type:h(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=f;class r{constructor(w,R){this.key=w,this.value=R,this.type=4}static create(w,R){if(typeof R=="boolean")return R?f.create(w):E.create(w);const L=S.get(w);return typeof L=="boolean"?R===(L?"true":"false")?d.INSTANCE:I.INSTANCE:new r(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class o{constructor(w,R){this.key=w,this.valueKey=R,this.type=10}static create(w,R){return new o(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const R=w.getValue(this.valueKey),L=w.getValue(this.key);return Array.isArray(R)?R.indexOf(L)>=0:typeof L=="string"&&typeof R=="object"&&R!==null?D.call(R,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return v.create(this)}}e.ContextKeyInExpr=o;class v{constructor(w){this._actual=w,this.type=11}static create(w){return new v(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new v(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class m{constructor(w,R){this.key=w,this.value=R,this.type=5}static create(w,R){if(typeof R=="boolean")return R?E.create(w):f.create(w);const L=S.get(w);return typeof L=="boolean"?R===(L?"true":"false")?I.INSTANCE:d.INSTANCE:new m(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class E{constructor(w){this.key=w,this.type=3}static create(w){const R=S.get(w);return typeof R=="boolean"?R?I.INSTANCE:d.INSTANCE:new E(w)}cmp(w){return w.type!==this.type?this.type-w.type:h(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=E;class p{constructor(w,R){this.key=w,this.value=R,this.type=12}static create(w,R){return new p(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class u{constructor(w,R){this.key=w,this.value=R,this.type=13}static create(w,R){return new u(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class b{constructor(w,R){this.key=w,this.value=R,this.type=14}static create(w,R){return new b(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=b;class t{constructor(w,R){this.key=w,this.value=R,this.type=15}static create(w,R){return new t(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:P(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(w,R){this.key=w,this.regexp=R,this.type=7}static create(w,R){return new n(w,R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const R=this.regexp?this.regexp.source:"",L=w.regexp?w.regexp.source:"";return R<L?-1:R>L?1:0}equals(w){if(w.type===this.type){const R=this.regexp?this.regexp.source:"",L=w.regexp?w.regexp.source:"";return this.key===w.key&&R===L}return!1}evaluate(w){let R=w.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=n;class a{constructor(w){this._actual=w,this.type=8}static create(w){return new a(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new a(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class s{constructor(w){this.expr=w,this.type=6}static create(w){return s._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const V=i(this.expr[R],w.expr[R]);if(V!==0)return V}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].evaluate(w))return!1;return!0}static _normalizeArr(w){const R=[];let L=!1;for(const V of w)if(!!V){if(V.type===1){L=!0;continue}if(V.type===0)return I.INSTANCE;if(V.type===6){R.push(...V.expr);continue}R.push(V)}if(R.length===0&&L)return d.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const V=R[R.length-1];if(V.type!==9)break;R.pop();const he=R.pop(),z=c.create(V.expr.map(W=>s.create([W,he])));z&&(R.push(z),R.sort(i))}return R.length===1?R[0]:new s(R)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new s(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let R of this.expr)w.push(R.negate());return c.create(w)}}e.ContextKeyAndExpr=s;class c{constructor(w){this.expr=w,this.type=9}static create(w){const R=c._normalizeArr(w);if(R.length!==0)return R.length===1?R[0]:new c(R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const V=i(this.expr[R],w.expr[R]);if(V!==0)return V}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,L=this.expr.length;R<L;R++)if(this.expr[R].evaluate(w))return!0;return!1}static _normalizeArr(w){let R=[],L=!1;if(w){for(let V=0,he=w.length;V<he;V++){const z=w[V];if(!!z){if(z.type===0){L=!0;continue}if(z.type===1)return[d.INSTANCE];if(z.type===9){R=R.concat(z.expr);continue}R.push(z)}}if(R.length===0&&L)return[I.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new c(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let L of this.expr)w.push(L.negate());const R=L=>L.type===9?L.expr:[L];for(;w.length>1;){const L=w.shift(),V=w.shift(),he=[];for(const z of R(L))for(const W of R(V))he.push(C.and(z,W));w.unshift(C.or(...he))}return w[0]}}e.ContextKeyOrExpr=c;class l extends f{constructor(w,R,L){super(w);this._defaultValue=R,typeof L=="object"?l._info.push(Object.assign(Object.assign({},L),{key:w})):L!==!0&&l._info.push({key:w,description:L,type:R!=null?typeof R:void 0})}static all(){return l._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(w){return C.equals(this.key,w)}notEqualsTo(w){return C.notEquals(this.key,w)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(g,w){return g<w?-1:g>w?1:0}function P(g,w,R,L){return g<R?-1:g>R?1:w<L?-1:w>L?1:0}}),define(be[149],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],we([0,1,8,4]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class S{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let d=typeof i=="string"?i:i.value,f=typeof I=="string"?I:I.value;return _.equalsIgnoreCase(d,f)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=S;function D(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function y(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[150],we([0,1,8,26]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(f,r){return f.uuid&&r.uuid?f.uuid===r.uuid:f.id===r.id?!0:(0,_.compareIgnoreCase)(f.id,r.id)===0}e.areSameExtensions=A;class T{constructor(r,o){this.version=o,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?A(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function S(f,r){return`${f}.${r}`}e.getExtensionId=S;function D(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function y(f,r){return D(S(f,r))}e.getGalleryExtensionId=y;function C(f,r){const o=[],v=m=>{for(const E of o)if(E.some(p=>A(r(p),r(m))))return E;return null};for(const m of f){const E=v(m);E?E.push(m):o.push([m])}return o}e.groupByExtension=C;function i(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function d(f){const r=new Set;for(const o of f)o.malicious&&r.add(o.id.id);return r}e.getMaliciousExtensionsSet=d}),define(be[65],we([0,1,125,13,2,4,8,10,22]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=d;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function r(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function o(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=o;var v;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(W,J){super(W);this.code=J}}e.FileSystemProviderError=m;function E(z,W){const J=new m(z.toString(),W);return u(J,W),J}e.createFileSystemProviderError=E;function p(z){return z||E((0,_.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=p;function u(z,W){return z.name=W?`${W} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=u;function b(z){if(!z)return v.Unknown;if(z instanceof m)return z.code;const W=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!W)return v.Unknown;switch(W[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=b;function t(z){if(z instanceof h)return z.fileOperationResult;switch(b(z)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class a{constructor(W,J,O){this.resource=W,this.operation=J,this.target=O}isOperation(W){return this.operation===W}}e.FileOperationEvent=a;var s;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(W,J){this.ignorePathCasing=J,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const O of W)switch(O.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(O.resource,O);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(O.resource,O);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(O.resource,O);break}}contains(W,...J){return this.doContains(W,{includeChildren:!1},...J)}affects(W,...J){return this.doContains(W,{includeChildren:!0},...J)}doContains(W,J,...O){var F,N,B,U,Q,Z;if(!W)return!1;const ne=O.length>0;return!!((!ne||O.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(W))||J.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr(W)))||(!ne||O.includes(0))&&(((B=this.updated)===null||B===void 0?void 0:B.get(W))||J.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(W)))||(!ne||O.includes(2))&&(((Q=this.deleted)===null||Q===void 0?void 0:Q.findSubstr(W))||J.includeChildren&&((Z=this.deleted)===null||Z===void 0?void 0:Z.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const J=[],O=W===1?this.added:W===0?this.updated:this.deleted;if(O)for(const[,F]of O)J.push(F);return J}filter(W){return new c(this.changes.filter(J=>W(J)),this.ignorePathCasing)}}e.FileChangesEvent=c;function l(z,W,J){return!z||!W||z===W||W.length>z.length?!1:(W.charAt(W.length-1)!==k.sep&&(W+=k.sep),J?(0,S.startsWithIgnoreCase)(z,W):z.indexOf(W)===0)}e.isParent=l;class h extends Error{constructor(W,J,O){super(W);this.fileOperationResult=J,this.options=O}static isFileOperationError(W){return W instanceof Error&&!(0,D.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=h;var P;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var g;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(g=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=w;async function R(z,W){if(!W.canHandleResource(A.URI.from({scheme:z.scheme})))return new Promise(J=>{const O=W.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===z.scheme&&F.added&&(O.dispose(),J())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(W){return(0,D.isNumber)(W)||(W=0),W<L.KB?(0,_.localize)(1,null,W.toFixed(0)):W<L.MB?(0,_.localize)(2,null,(W/L.KB).toFixed(2)):W<L.GB?(0,_.localize)(3,null,(W/L.MB).toFixed(2)):W<L.TB?(0,_.localize)(4,null,(W/L.GB).toFixed(2)):(0,_.localize)(5,null,(W/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function he(z){return{maxFileSize:z===0?300*L.MB:16*L.GB,maxHeapSize:z===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=he}),define(be[66],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...A){this._entries=new Map;for(let[T,S]of A)this.set(T,S)}set(A,T){const S=this._entries.get(A);return this._entries.set(A,T),S}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=_}),define(be[151],we([0,1,11,145,89,4,66,14]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class C extends Error{constructor(r){var o;super("cyclic dependency between services");this.message=(o=r.findCycleSlow())!==null&&o!==void 0?o:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new S.ServiceCollection,o=!1,v){this._activeInstantiations=new Set,this._services=r,this._strict=o,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...o){let v=d.traceInvocation(r),m=!1;try{return r({get:(p,u)=>{if(m)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const b=this._getOrCreateServiceInstance(p,v);if(!b&&u!==T.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return b}},...o)}finally{m=!0,v.stop()}}createInstance(r,...o){let v,m;return r instanceof A.SyncDescriptor?(v=d.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(o),v)):(v=d.traceCreation(r),m=this._createInstance(r,o,v)),v.stop(),m}_createInstance(r,o=[],v){let m=T._util.getServiceDependencies(r).sort((u,b)=>u.index-b.index),E=[];for(const u of m){let b=this._getOrCreateServiceInstance(u.id,v);if(!b&&this._strict&&!u.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${u.id}.`);E.push(b)}let p=m.length>0?m[0].index:o.length;if(o.length!==p){console.warn(`[createInstance] First service dependency of ${r.name} at position ${p+1} conflicts with ${o.length} static arguments`);let u=p-o.length;u>0?o=o.concat(new Array(u)):o=o.slice(0,p)}return new r(...[...o,...E])}_setServiceInstance(r,o){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,o);else if(this._parent)this._parent._setServiceInstance(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let o=this._services.get(r);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):o}_getOrCreateServiceInstance(r,o){let v=this._getServiceInstanceOrDescriptor(r);return v instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,v,o.branch(r,!0)):(o.branch(r,!1),v)}_safeCreateAndCacheServiceInstance(r,o,v){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,o,v)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,o,v){const m=new k.Graph(u=>u.id.toString());let E=0;const p=[{id:r,desc:o,_trace:v}];for(;p.length;){const u=p.pop();if(m.lookupOrInsertNode(u),E++>1e3)throw new C(m);for(let b of T._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(b.id);if(!t&&!b.optional&&console.warn(`[createInstance] ${r} depends on ${b.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:b.id,desc:t,_trace:u._trace.branch(b.id,!0)};m.insertEdge(u,n),p.push(n)}}}for(;;){const u=m.roots();if(u.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:b}of u){if(this._getServiceInstanceOrDescriptor(b.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,n)}m.removeNode(b)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,o,v=[],m,E){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(o,v,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,o,v,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(r,o=[],v,m){if(v){const E=new D.IdleValue(()=>this._createInstance(r,o,m));return new Proxy(Object.create(null),{get(p,u){if(u in p)return p[u];let b=E.value,t=b[u];return typeof t!="function"||(t=t.bind(b),p[u]=t),t},set(p,u,b){return E.value[u]=b,!0}})}else return this._createInstance(r,o,m)}}e.InstantiationService=i;var I;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(I||(I={}));class d{constructor(r,o){this.type=r,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return y?new d(0,r.name):d._None}branch(r,o){let v=new d(2,r.toString());return this._dep.push([r,o,v]),v}stop(){let r=Date.now()-this._start;d._totals+=r;let o=!1;function v(E,p){let u=[],b=new Array(E+1).join("	");for(const[t,n,a]of p._dep)if(n&&a){o=!0,u.push(`${b}CREATES -> ${t}`);let s=v(E+1,a);s&&u.push(s)}else u.push(`${b}uses -> ${t}`);return u.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||o)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(be[19],we([0,1,4,6,21,3,61]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function D(){return new Date().toISOString()}var y;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(y.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(y.Error,this.format(a))}else this.log(y.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let a=0;a<t.length;a++){let s=t[a];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}n+=(a>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class d extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class f extends C{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class r extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const a of this.logServices)a.trace(t,...n)}debug(t,...n){for(const a of this.logServices)a.debug(t,...n)}info(t,...n){for(const a of this.logServices)a.info(t,...n)}warn(t,...n){for(const a of this.logServices)a.warn(t,...n)}error(t,...n){for(const a of this.logServices)a.error(t,...n)}critical(t,...n){for(const a of this.logServices)a.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class o extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=o;class v extends k.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(a))}))}createLogger(t,n){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,(n==null?void 0:n.always)?y.Trace:this.logLevel,n),this.loggers.set(t.toString(),a),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function E(b){if(b.verbose)return y.Trace;if(typeof b.logLevel=="string"){const t=p(b.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function p(b){switch(b){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=p;function u(b){switch(b){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=u}),define(be[90],we([0,1,4,126,47]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function C(r,o){return o-r}y.compare=C;const i=Object.create(null);i[y.Error]=(0,k.localize)(0,null),i[y.Warning]=(0,k.localize)(1,null),i[y.Info]=(0,k.localize)(2,null);function I(r){return i[r]||""}y.toString=I;function d(r){switch(r){case A.default.Error:return y.Error;case A.default.Warning:return y.Warning;case A.default.Info:return y.Info;case A.default.Ignore:return y.Hint}}y.fromSeverity=d;function f(r){switch(r){case y.Error:return A.default.Error;case y.Warning:return A.default.Warning;case y.Info:return A.default.Info;case y.Hint:return A.default.Ignore}}y.toSeverity=f}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(y){const C="";function i(d){return I(d,!0)}y.makeKey=i;function I(d,f){let r=[C];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(C),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(C),d.severity!==void 0&&d.severity!==null?r.push(S.toString(d.severity)):r.push(C),d.message&&f?r.push(d.message.replace("\xA6","\\\xA6")):r.push(C),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(C),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(C),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(C),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(C),r.push(C),r.join("\xA6")}y.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(be[152],we([0,1,47,4,3]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,k.createDecorator)("notificationService");var T;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new y,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class y{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(Y,e,_,k){var A=arguments.length,T=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,_):k,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Y,e,_,k);else for(var D=Y.length-1;D>=0;D--)(S=Y[D])&&(T=(A<3?S(T):A>3?S(e,_,T):S(e,_))||T);return A>3&&T&&Object.defineProperty(e,_,T),T},Ke=this&&this.__param||function(Y,e){return function(_,k){e(_,k,Y)}};define(be[153],we([0,1,4,20,6,14]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var S;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let y=class extends A.Disposable{constructor(I,d){super();this.deferred=new T.DeferredPromise,d.withProgress(I,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class C extends A.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(I){this.stop();const d=++this.currentOperationId,f=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:f.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(be[30],we([0,1,10,42]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(S,D){k.ok(_.isString(S)),k.ok(_.isObject(D)),k.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,D)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new A}),define(be[91],we([0,1,30,3]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,C){this.schemasById[A(y)]=C,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new T;_.Registry.add(e.Extensions.JSONContribution,S)}),define(be[67],we([0,1,123,3,30,10,91]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=A.Registry.as(S.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,E=!0){this.registerConfigurations([m],E)}registerConfigurations(m,E=!0){const p=[];m.forEach(u=>{p.push(...this.validateAndRegisterProperties(u,E,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(m){const E=[],p=u=>{if(u.properties)for(const b in u.properties)E.push(b),delete this.configurationProperties[b],this.removeFromSchema(b,u.properties[b]);u.allOf&&u.allOf.forEach(b=>p(b))};for(const u of m){p(u);const b=this.configurationContributors.indexOf(u);b!==-1&&this.configurationContributors.splice(b,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(m){const E=[],p=[];for(const u of m)for(const b in u)if(E.push(b),e.OVERRIDE_PROPERTY_PATTERN.test(b)){this.defaultValues[b]=Object.assign(Object.assign({},this.defaultValues[b]||{}),u[b]);const t={type:"object",default:this.defaultValues[b],description:_.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId};p.push(I(b)),this.configurationProperties[b]=t,this.defaultLanguageConfigurationOverridesNode.properties[b]=t}else{this.defaultValues[b]=u[b];const t=this.configurationProperties[b];t&&(this.updatePropertyDefaultValue(b,t),this.updateSchema(b,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(m){const E=[];for(const p of m)for(const u in p)if(E.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const b=this.configurationProperties[u];b&&(this.updatePropertyDefaultValue(u,b),this.updateSchema(u,b))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const E of m)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,E=!0,p,u=3){var b;u=T.isUndefinedOrNull(m.scope)?u:m.scope;let t=[],n=m.properties;if(n)for(let s in n){if(E&&r(s)){delete n[s];continue}const c=n[s];if(this.updatePropertyDefaultValue(s,c),e.OVERRIDE_PROPERTY_PATTERN.test(s)?c.scope=void 0:(c.scope=T.isUndefinedOrNull(c.scope)?u:c.scope,c.requireTrust=T.isUndefinedOrNull(c.requireTrust)?!!((b=p==null?void 0:p.requireTrustForConfigurations)===null||b===void 0?void 0:b.includes(s)):c.requireTrust),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let a=m.allOf;if(a)for(let s of a)t.push(...this.validateAndRegisterProperties(s,E,p,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const E=p=>{let u=p.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let b=p.allOf;b&&b.forEach(E)};E(m)}updateSchema(m,E){switch(e.allSettings.properties[m]=E,E.scope){case 1:e.applicationSettings.properties[m]=E;break;case 2:e.machineSettings.properties[m]=E;break;case 6:e.machineOverridableSettings.properties[m]=E;break;case 3:e.windowSettings.properties[m]=E;break;case 4:e.resourceSettings.properties[m]=E;break;case 5:e.resourceSettings.properties[m]=E,this.resourceLanguageSettingsSchema.properties[m]=E;break}}removeFromSchema(m,E){switch(delete e.allSettings.properties[m],E.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const E=`[${m}]`,p={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,p),e.allSettings.properties[E]=p,e.applicationSettings.properties[E]=p,e.machineSettings.properties[E]=p,e.machineOverridableSettings.properties[E]=p,e.windowSettings.properties[E]=p,e.resourceSettings.properties[E]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,E){let p=this.defaultValues[m];T.isUndefined(p)&&(p=E.default),T.isUndefined(p)&&(p=d(E.type)),E.default=p}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=I;function d(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new C;A.Registry.add(e.Extensions.Configuration,f);function r(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?_.localize(5,null,v):f.getConfigurationProperties()[v]!==void 0?_.localize(6,null,v):null:_.localize(4,null)}e.validateProperty=r;function o(){const v=[],m=f.getConfigurationProperties();for(const E of Object.keys(m))v.push([E,m[E].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=o}),define(be[92],we([0,1,24,10,2,30,4,67]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=y;var C;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,a){const s=a?n?a.keys.filter(R=>n.keys.indexOf(R)===-1):[...a.keys]:[],c=n?a?n.keys.filter(R=>a.keys.indexOf(R)===-1):[...n.keys]:[],l=[];if(a&&n){for(const R of n.keys)if(a.keys.indexOf(R)!==-1){const L=m(n.contents,R),V=m(a.contents,R);_.equals(L,V)||l.push(R)}}const h=[],P=R=>{const L={};for(const V of R)for(const he of V.identifiers)L[b(he)]=V;return L},g=a?P(a.overrides):{},w=n?P(n.overrides):{};if(Object.keys(g).length)for(const R of s){const L=g[R];L&&h.push([(0,D.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(w).length)for(const R of c){const L=w[R];L&&h.push([(0,D.overrideIdentifierFromKey)(R),L.keys])}if(Object.keys(g).length&&Object.keys(w).length)for(const R of l){const L=w[R],V=g[R];if(L&&V){const he=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:V.contents,keys:V.keys,overrides:[]});h.push([(0,D.overrideIdentifierFromKey)(R),[...he.added,...he.removed,...he.updated]])}}return{added:s,removed:c,updated:l,overrides:h}}e.compare=I;function d(n,a){const s=[];for(const c of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const h in n[c])l[h]=n[c][h];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:f(l,a)})}return s}e.toOverrides=d;function f(n,a){const s=Object.create(null);for(let c in n)r(s,c,n[c],a);return s}e.toValuesTree=f;function r(n,a,s,c){const l=a.split("."),h=l.pop();let P=n;for(let g=0;g<l.length;g++){let w=l[g],R=P[w];switch(typeof R){case"undefined":R=P[w]=Object.create(null);break;case"object":break;default:c(`Ignoring ${a} as ${l.slice(0,g+1).join(".")} is ${JSON.stringify(R)}`);return}P=R}if(typeof P=="object"&&P!==null)try{P[h]=s}catch(g){c(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(P)}`)}else c(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=r;function o(n,a){const s=a.split(".");v(n,s)}e.removeFromValueTree=o;function v(n,a){const s=a.shift();if(a.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const c=n[s];typeof c=="object"&&!Array.isArray(c)&&(v(c,a),Object.keys(c).length===0&&delete n[s])}}function m(n,a,s){function c(P,g){let w=P;for(const R of g){if(typeof w!="object"||w===null)return;w=w[R]}return w}const l=a.split("."),h=c(n,l);return typeof h=="undefined"?s:h}e.getConfigurationValue=m;function E(n,a,s){Object.keys(a).forEach(c=>{c!=="__proto__"&&(c in n?k.isObject(n[c])&&k.isObject(a[c])?E(n[c],a[c],s):s&&(n[c]=a[c]):n[c]=a[c])})}e.merge=E;function p(){const n=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=p;function u(){const n=Object.create(null),a=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in a){let c=a[s].default;r(n,s,c,l=>console.error(`Conflict in default settings: ${l}`))}return n}e.getDefaultValues=u;function b(n){return`[${n}]`}e.keyFromOverrideIdentifier=b;function t(n,a,s){const c=n.inspect(a),l=n.inspect(s);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(be[154],we([0,1,44,22,12,10,24,2,67,92,30,6,3]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},n=[],a=[]){this._contents=t,this._keys=n,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const a=this.getContentsForOverrideIdentifer(n);return a?t?(0,C.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let a={};for(const s of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[s],l=n[s];l&&(typeof c=="object"&&typeof l=="object"?(c=S.deepClone(c),this.mergeContents(c,l)):c=l),a[s]=c}return new f(a,this.keys,this.overrides)}merge(...t){const n=S.deepClone(this.contents),a=S.deepClone(this.overrides),s=[...this.keys];for(const c of t){this.mergeContents(n,c.contents);for(const l of c.overrides){const[h]=a.filter(P=>A.equals(P.identifiers,l.identifiers));h?this.mergeContents(h.contents,l.contents):a.push(S.deepClone(l))}for(const l of c.keys)s.indexOf(l)===-1&&s.push(l)}return new f(n,s,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const a of Object.keys(n)){if(a in t&&T.isObject(t[a])&&T.isObject(n[a])){this.mergeContents(t[a],n[a]);continue}t[a]=S.deepClone(n[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,C.addToValueTree)(this.contents,t,n,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let a=0;a<n;a++)t.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class r extends f{constructor(){const t=(0,C.getDefaultValues)(),n=(0,C.getConfigurationKeys)(),a=[];for(const s of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(s)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,C.toValuesTree)(t[s],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,n,a)}}e.DefaultConfigurationModel=r;class o{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const a=this.doParseContent(t);this.parseRaw(a,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:a,keys:s,overrides:c,untrusted:l}=this.doParseRaw(t,n);this._configurationModel=new f(a,s,c),this._untrustedConfigurations=l||[]}doParseContent(t){let n={},a=null,s=[],c=[],l=[];function h(g){Array.isArray(s)?s.push(g):a&&(s[a]=g)}let P={onObjectBegin:()=>{let g={};h(g),c.push(s),s=g,a=null},onObjectProperty:g=>{a=g},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let g=[];h(g),c.push(s),s=g,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:h,onError:(g,w,R)=>{l.push({error:g,offset:w,length:R})}};if(t)try{_.visit(t,P),n=s[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return n}doParseRaw(t,n){const a=i.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,a,!0,n);t=s.raw;const c=(0,C.toValuesTree)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),l=Object.keys(t),h=(0,C.toOverrides)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:c,keys:l,overrides:h,untrusted:s.untrusted}}filter(t,n,a,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.isUntrusted))return{raw:t,untrusted:[]};const c={},l=[];for(let h in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(h)&&a){const P=this.filter(t[h],n,!1,s);c[h]=P.raw,l.push(...P.untrusted)}else{const P=n[h],g=P?typeof P.scope!="undefined"?P.scope:3:void 0;(g===void 0||s.scopes===void 0||s.scopes.includes(g))&&(s.isUntrusted&&(P==null?void 0:P.requireTrust)?l.push(h):c[h]=t[h])}return{raw:c,untrusted:l}}}e.ConfigurationModelParser=o;class v extends I.Disposable{constructor(t,n,a,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=v;class m{constructor(t,n,a=new f,s=new f,c=new k.ResourceMap,l=new f,h=new k.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=a,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,a){return this.getConsolidateConfigurationModel(n,a).getValue(t)}updateValue(t,n,a={}){let s;a.resource?(s=this._memoryConfigurationByResource.get(a.resource),s||(s=new f,this._memoryConfigurationByResource.set(a.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,a){const s=this.getConsolidateConfigurationModel(n,a),c=this.getFolderConfigurationModelForResource(n.resource,a),l=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,h=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),g=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=a?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,V=n.overrideIdentifier?l.override(n.overrideIdentifier).getValue(t):l.getValue(t),he=s.getValue(t),z=A.distinct(A.flatten(s.overrides.map(W=>W.identifiers))).filter(W=>s.getOverrideValue(t,W)!==void 0);return{defaultValue:h,userValue:P,userLocalValue:g,userRemoteValue:w,workspaceValue:R,workspaceFolderValue:L,memoryValue:V,value:he,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:g!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:n.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:V!==void 0?{value:l.getValue(t),override:n.overrideIdentifier?l.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const a=n.filter(s=>y.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const c=(0,y.overrideIdentifierFromKey)(s),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=t.getKeysForOverrideIdentifier(c),P=[...h.filter(g=>l.indexOf(g)===-1),...l.filter(g=>h.indexOf(g)===-1),...l.filter(g=>!S.equals(this._defaultConfiguration.override(c).getValue(g),t.override(c).getValue(g)))];return[c,P]});return this.updateDefaultConfiguration(t),{keys:n,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:a,removed:s,overrides:c}=(0,C.compare)(this.localUserConfiguration,t),l=[...n,...a,...s];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:a,removed:s,overrides:c}=(0,C.compare)(this.remoteUserConfiguration,t);let l=[...n,...a,...s];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:a,removed:s,overrides:c}=(0,C.compare)(this.workspaceConfiguration,t);let l=[...n,...a,...s];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,n){const a=this.folderConfigurations.get(t),{added:s,updated:c,removed:l,overrides:h}=(0,C.compare)(a,n);let P=[...s,...c,...l];return(P.length||!a)&&this.updateFolderConfiguration(t,n),{keys:P,overrides:h}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:s,removed:c,overrides:l}=(0,C.compare)(n,void 0);return{keys:[...a,...s,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let a=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},n){let a=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(a=this.getFolderConsolidatedConfiguration(s.uri)||a);const c=this._memoryConfigurationByResource.get(t);c&&(a=a.merge(c))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const a=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=a.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=a}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const a=n.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:a,overrides:s,keys:c}=this._folderConfigurations.get(n);return t.push([n,{contents:a,overrides:s,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,h)=>(l.set(D.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new k.ResourceMap);return new m(n,a,new f,s,c,new f,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function E(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,n=new Map;for(const s of b)s.keys.forEach(c=>t.add(c)),s.overrides.forEach(([c,l])=>{const h=(0,k.getOrSet)(n,c,new Set);l.forEach(P=>h.add(P))});const a=[];return n.forEach((s,c)=>a.push([c,[...s.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=E;class p{constructor(t,n,a,s){this.change=t,this.previous=n,this.currentConfiguraiton=a,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(h=>c.add(h)),t.overrides.forEach(([,h])=>h.forEach(P=>c.add(P))),this.affectedKeys=[...c.values()];const l=new f;this.affectedKeys.forEach(h=>l.setValue(h,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,c=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!S.equals(s,c)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let a=(0,C.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(t=t[s],!t)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=p;class u extends p{constructor(t,n,a,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=a,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=u}),define(be[68],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var k;(function(S){S[S.Unknown=0]="Unknown",S[S.DisableTrust=1]="DisableTrust",S[S.MachineTrusted=2]="MachineTrusted"})(k=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,y=A.Unknown,C){super(D);this._message=D,this._code=y,this._detail=C,this.isHandled=y===A.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===A.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===A.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(be[93],we([0,1,18]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function k(y){return y.scheme===_.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=k;function A(y){if(!!y){const C=y.indexOf("+");return C<0?y:y.substr(0,C)}}e.getRemoteName=A;function T(y){return y.scheme!==_.Schemas.file&&y.scheme!==_.Schemas.vscodeRemote}function S(y){if(y.folders.length)return y.folders.every(C=>T(C.uri))?y.folders[0].uri:void 0;if(y.configuration&&T(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function D(y){var C;return(C=S(y))===null||C===void 0?void 0:C.scheme}e.getVirtualWorkspaceScheme=D}),define(be[155],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,S=5){let D;return D=T(y=>{const C=typeof y=="string"?y:y.data;let i=this._terminalBufferMap.get(A);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(A),S);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(A),D.dispose()}},this._terminalBufferMap.set(A,i)}),D}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=_}),define(be[156],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(be[157],we([0,1,4,6,30,3,156,36]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var y;(function(v){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}v.isThemeColor=m})(y=e.ThemeColor||(e.ThemeColor={}));function C(v){return{id:v}}e.themeColorFromId=C;var i;(function(v){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}v.isThemeIcon=m;const E=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function p(t){const n=E.exec(t);if(!!n){let[,a]=n;return{id:a}}}v.fromString=p;function u(t,n){let a=t.id;const s=a.lastIndexOf("~");return s!==-1&&(a=a.substring(0,s)),n&&(a=`${a}~${n}`),{id:a}}v.modify=u;function b(t,n){var a,s;return t.id===n.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((s=n.color)===null||s===void 0?void 0:s.id)}v.isEqual=b,v.asClassNameArray=D.CSSIcon.asClassNameArray,v.asClassName=D.CSSIcon.asClassName,v.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(v){switch(v){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(m);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new d;A.Registry.add(e.Extensions.ThemingContribution,f);function r(v){return f.onColorThemeChange(v)}e.registerThemingParticipant=r;class o extends k.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,E){let p=this.theme.getColor(m);return p&&E&&(p=E(p,this.theme)),p?p.toString():null}}e.Themable=o}),define(be[158],we([0,1,30,157,3,127,91,14,36]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,E,p,u){const b=this.iconsById[m];if(b){if(p&&!b.description){b.description=p,this.iconSchema.properties[m].markdownDescription=`${p} $(${m})`;const a=this.iconReferenceSchema.enum.indexOf(m);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=p),this._onDidChange.fire()}return b}let t={id:m,description:p,defaults:E,deprecationMessage:u};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),p&&(n.markdownDescription=`${p}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(p||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const E=this.iconReferenceSchema.enum.indexOf(m);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,E){const p=this.iconFontsById[m];if(p)return p;let u={id:m,definition:E};return this.iconFontsById[m]=u,this._onDidChange.fire(),u}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(b,t)=>b.id.localeCompare(t.id),E=b=>{for(;k.ThemeIcon.isThemeIcon(b.defaults);)b=this.iconsById[b.defaults.id];return`codicon codicon-${b?b.id:""}`};let p=[];p.push("| preview     | identifier                        | default codicon ID                | description"),p.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(b=>this.iconsById[b]);for(const b of u.filter(t=>!!t.description).sort(m))p.push(`|<i class="${E(b)}"></i>|${b.id}|${k.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);p.push("| preview     | identifier                        "),p.push("| ----------- | --------------------------------- |");for(const b of u.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(m))p.push(`|<i class="${E(b)}"></i>|${b.id}|`);return p.join(`
`)}}const i=new C;_.Registry.add(e.Extensions.IconContribution,i);function I(v,m,E,p){return i.registerIcon(v,m,E,p)}e.registerIcon=I;function d(){return i}e.getIconRegistry=d;function f(){for(const v of y.iconRegistry.all)i.registerIcon(v.id,v.definition,v.description);y.iconRegistry.onDidRegister(v=>i.registerIcon(v.id,v.definition,v.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let r=_.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const o=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=I("widget-close",y.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",y.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",y.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=k.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[48],we([0,1,2,25,4,22]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var S;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function D(d){const f=d;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=D;function y(d){const f=d;return!!(f&&typeof f=="object"&&_.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class C{constructor(f,r,o,v){this._id=f,this._configuration=o,this._ignorePathCasing=v,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(f,r){this.raw=r,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,k.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(d){return new i({uri:d,index:0,name:(0,k.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=I}),define(be[159],we([0,1,4,128,48,2,21,13,25,106,44,18,59,37,93]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const o=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(J){return(typeof J=="string"?(0,D.extname)(J):(0,y.extname)(J))===o}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function m(J){return J.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function E(J){return J.hasOwnProperty("folderUri")}e.isRecentFolder=E;function p(J){return J.hasOwnProperty("fileUri")}e.isRecentFile=p;function u(J){const O=J;return typeof(O==null?void 0:O.id)=="string"&&T.URI.isUri(O.uri)}e.isSingleFolderWorkspaceIdentifier=u;function b(J){if(J.configuration)return{id:J.id,configPath:J.configuration};if(J.folders.length===1)return{id:J.id,uri:J.folders[0].uri}}e.toWorkspaceIdentifier=b;function t(J){const O=J;return typeof(O==null?void 0:O.id)=="string"&&T.URI.isUri(O.configPath)}e.isWorkspaceIdentifier=t;function n(J){const O=J;if(O==null?void 0:O.uri)return{id:O.id,uri:T.URI.revive(O.uri)};const F=J;if(F==null?void 0:F.configPath)return{id:F.id,configPath:T.URI.revive(F.configPath)};if(J==null?void 0:J.id)return{id:J.id}}e.reviveIdentifier=n;function a(J,O){return y.extUriBiasedIgnorePathCase.isEqualOrParent(J,O.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function s(J){return c(J)||l(J)}e.isStoredWorkspaceFolder=s;function c(J){const O=J;return typeof(O==null?void 0:O.path)=="string"&&(!O.name||typeof O.name=="string")}e.isRawFileWorkspaceFolder=c;function l(J){const O=J;return typeof(O==null?void 0:O.uri)=="string"&&(!O.name||typeof O.name=="string")}e.isRawUriWorkspaceFolder=l;function h(J,O,F,N,B=!S.isWindows,U){if(J.scheme!==N.scheme)return{name:F,uri:J.toString(!0)};let Q=O?void 0:U.relativePath(N,J);if(Q!==void 0)Q.length===0?Q=".":S.isWindows&&J.scheme===I.Schemas.file&&!B&&(Q=Q.replace(/\//g,"\\"));else if(J.scheme===I.Schemas.file)Q=J.fsPath,S.isWindows&&(Q=(0,d.normalizeDriveLetter)(Q),B&&(Q=(0,f.toSlashes)(Q)));else{if(!U.isEqualAuthority(J.authority,N.authority))return{name:F,uri:J.toString(!0)};Q=J.path}return{name:F,path:Q}}e.getStoredWorkspaceFolder=h;function P(J,O,F){let N=[],B=new Set;const U=F.dirname(O);for(let Q of J){let Z=null;if(c(Q))Q.path&&(Z=F.resolvePath(U,Q.path));else if(l(Q))try{Z=T.URI.parse(Q.uri),Z.path[0]!=="/"&&(Z=Z.with({path:"/"+Z.path}))}catch(ne){console.warn(ne)}if(Z){let ne=F.getComparisonKey(Z);if(!B.has(ne)){B.add(ne);const pe=Q.name||F.basenameOrAuthority(Z);N.push(new A.WorkspaceFolder({uri:Z,name:pe,index:N.length},Q))}}}return N}e.toWorkspaceFolders=P;function g(J,O,F,N,B){let U=w(O,J);const Q=B.dirname(O),Z=B.dirname(N),ne=[],pe=R(U.folders);for(const xe of U.folders){const $=c(xe)?B.resolvePath(Q,xe.path):T.URI.parse(xe.uri);let G;F?G=!1:G=!c(xe)||(0,D.isAbsolute)(xe.path),ne.push(h($,G,xe.name,Z,pe,B))}const Pe={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Oe=C.setProperty(J,["folders"],ne,Pe);let Te=C.applyEdits(J,Oe);return U.remoteAuthority===(0,r.getRemoteAuthority)(N)&&(Te=C.applyEdits(Te,C.removeProperty(Te,["remoteAuthority"],Pe))),Te}e.rewriteWorkspaceFileForNewLocation=g;function w(J,O){let F=i.parse(O);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(N=>s(N));else throw new Error(`${J} looks like an invalid workspace file.`);return F}function R(J){return S.isWindows?J.some(O=>c(O)&&O.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function L(J){return J.workspace&&typeof J.workspace=="object"&&typeof J.workspace.id=="string"&&typeof J.workspace.configPath=="string"}function V(J){return typeof J.folderUri=="string"}function he(J){return typeof J.fileUri=="string"}function z(J,O){const F={workspaces:[],files:[]};if(J){const N=function(U,Q){for(let Z=0;Z<U.length;Z++)try{Q(U[Z],Z)}catch(ne){O.warn(`Error restoring recent entry ${JSON.stringify(U[Z])}: ${ne.toString()}. Skip entry.`)}},B=J;if(Array.isArray(B.entries))N(B.entries,U=>{const Q=U.label,Z=U.remoteAuthority;L(U)?F.workspaces.push({label:Q,remoteAuthority:Z,workspace:{id:U.workspace.id,configPath:T.URI.parse(U.workspace.configPath)}}):V(U)?F.workspaces.push({label:Q,remoteAuthority:Z,folderUri:T.URI.parse(U.folderUri)}):he(U)&&F.files.push({label:Q,remoteAuthority:Z,fileUri:T.URI.parse(U.fileUri)})});else{const U=J;Array.isArray(U.workspaces3)&&N(U.workspaces3,(Q,Z)=>{const ne=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[Z]||void 0;typeof Q=="object"&&typeof Q.id=="string"&&typeof Q.configURIPath=="string"?F.workspaces.push({label:ne,workspace:{id:Q.id,configPath:T.URI.parse(Q.configURIPath)}}):typeof Q=="string"&&F.workspaces.push({label:ne,folderUri:T.URI.parse(Q)})}),Array.isArray(U.files2)&&N(U.files2,(Q,Z)=>{const ne=Array.isArray(U.fileLabels)&&U.fileLabels[Z]||void 0;typeof Q=="string"&&F.files.push({label:ne,fileUri:T.URI.parse(Q)})})}}return F}e.restoreRecentlyOpened=z;function W(J){const O={entries:[]};for(const F of J.workspaces)E(F)?O.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):O.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of J.files)O.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return O}e.toStoreData=W}),define(be[69],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(be[160],we([0,1,2,3]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(D=>({name:D.name,group:D.group,resource:_.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(be[49],we([0,1,18,4]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,D){D===null?this._providerInfo.delete(S):this._providerInfo.set(S,D)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(be[161],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class _{constructor(T,S,D){this._id=T,this._shared=S,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(T,S){let D=this._value[T];return typeof D=="undefined"&&(D=S),D}update(T,S){return this._value[T]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=_;class k extends _{constructor(T,S){super(T.identifier.value,!0,S);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(be[15],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=k});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[162],we([0,1,26,3]),function(Y,e,_,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,y){A.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(D.identifier),tt(this,A,y,"f"),Me(this,A,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Me(this,A,"f").get(this._id,D)}store(D,y){return Me(this,A,"f").store(this._id,D,y)}delete(D){return Me(this,A,"f").delete(this._id,D)}}e.ExtensionSecrets=T,A=new WeakMap}),define(be[94],we([0,1,4,3]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(be[70],we([0,1,3]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var k;(function(S){S[S.NewChild=0]="NewChild",S[S.Disposed=1]="Disposed",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp"})(k=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=S=>{let D=A.get(S);return D||(D={children:new Map,bus:new _.Emitter},A.set(S,D)),D};e.getPrivateApiFor=T}),define(be[71],we([0,1,4,3,15]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function y(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}D.fromApiTunnel=y;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}D.fromServiceTunnel=C})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,C){return{dispose:()=>{}}}async $providePortAttributes(y,C,i,I,d){return[]}async $forwardPort(y,C){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([Ke(0,A.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)},$t=this&&this.__rest||function(Y,e){var _={};for(var k in Y)Object.prototype.hasOwnProperty.call(Y,k)&&e.indexOf(k)<0&&(_[k]=Y[k]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(Y);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(Y,k[A])&&(_[k[A]]=Y[k[A]]);return _};define(be[7],we([0,1,12,11,83,22,10,2,29,65,68,70]),function(Y,e,_,k,A,T,S,D,y,C,i,I){"use strict";var d,f,r,o,v,m,E,p,u,b,t,n,a,s,c,l;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function h(x){function M(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(M,x),Object.setPrototypeOf(M.prototype,x.prototype),M}let P=r=class{constructor(M){d.set(this,void 0),tt(this,d,M,"f")}static from(...M){let re=M;return new r(function(){if(re){for(const ye of re)ye&&typeof ye.dispose=="function"&&ye.dispose();re=void 0}})}dispose(){typeof Me(this,d,"f")=="function"&&(Me(this,d,"f").call(this),tt(this,d,void 0,"f"))}};d=new WeakMap,P=r=je([h],P),e.Disposable=P;let g=o=class{constructor(M,re){if(M<0)throw(0,k.illegalArgument)("line must be non-negative");if(re<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=M,this._character=re}static Min(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let ye=1;ye<M.length;ye++){const ze=M[ye];ze.isBefore(re)&&(re=ze)}return re}static Max(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let ye=1;ye<M.length;ye++){const ze=M[ye];ze.isAfter(re)&&(re=ze)}return re}static isPosition(M){if(!M)return!1;if(M instanceof o)return!0;let{line:re,character:ye}=M;return typeof re=="number"&&typeof ye=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,re=0){if(M===null||re===null)throw(0,k.illegalArgument)();let ye;return typeof M=="undefined"?ye=0:typeof M=="number"?ye=M:(ye=typeof M.lineDelta=="number"?M.lineDelta:0,re=typeof M.characterDelta=="number"?M.characterDelta:0),ye===0&&re===0?this:new o(this.line+ye,this.character+re)}with(M,re=this.character){if(M===null||re===null)throw(0,k.illegalArgument)();let ye;return typeof M=="undefined"?ye=this.line:typeof M=="number"?ye=M:(ye=typeof M.line=="number"?M.line:this.line,re=typeof M.character=="number"?M.character:this.character),ye===this.line&&re===this.character?this:new o(ye,re)}toJSON(){return{line:this.line,character:this.character}}};g=o=je([h],g),e.Position=g;let w=v=class{constructor(M,re,ye,ze){let Je,ut;if(typeof M=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof ze=="number"?(Je=new g(M,re),ut=new g(ye,ze)):M instanceof g&&re instanceof g&&(Je=M,ut=re),!Je||!ut)throw new Error("Invalid arguments");Je.isBefore(ut)?(this._start=Je,this._end=ut):(this._start=ut,this._end=Je)}static isRange(M){return M instanceof v?!0:M?g.isPosition(M.start)&&g.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof v?this.contains(M._start)&&this.contains(M._end):M instanceof g?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const re=g.Max(M.start,this._start),ye=g.Min(M.end,this._end);if(!re.isAfter(ye))return new v(re,ye)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const re=g.Min(M.start,this._start),ye=g.Max(M.end,this.end);return new v(re,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,re=this.end){if(M===null||re===null)throw(0,k.illegalArgument)();let ye;return M?g.isPosition(M)?ye=M:(ye=M.start||this.start,re=M.end||this.end):ye=this.start,ye.isEqual(this._start)&&re.isEqual(this.end)?this:new v(ye,re)}toJSON(){return[this.start,this.end]}};w=v=je([h],w),e.Range=w;let R=m=class extends w{constructor(M,re,ye,ze){let Je,ut;if(typeof M=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof ze=="number"?(Je=new g(M,re),ut=new g(ye,ze)):M instanceof g&&re instanceof g&&(Je=M,ut=re),!Je||!ut)throw new Error("Invalid arguments");super(Je,ut);this._anchor=Je,this._active=ut}static isSelection(M){return M instanceof m?!0:M?w.isRange(M)&&g.isPosition(M.anchor)&&g.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=m=je([h],R),e.Selection=R;class L{constructor(M,re,ye){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,k.illegalArgument)("port");if(typeof ye!="undefined"&&(typeof ye!="string"||ye.length===0||!/^[0-9A-Za-z\-]+$/.test(ye)))throw(0,k.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(re),this.connectionToken=ye}}e.ResolvedAuthority=L;class V extends Error{constructor(M,re=i.RemoteAuthorityResolverErrorCode.Unknown,ye){super(M);this._message=M,this._code=re,this._detail=ye,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(M,re){return new V(M,i.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(M){return new V(M,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var he;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(he=e.EndOfLine||(e.EndOfLine={}));var z;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=E=class{constructor(M,re){this._range=M,this._newText=re}static isTextEdit(M){return M instanceof E?!0:M?w.isRange(M)&&typeof M.newText=="string":!1}static replace(M,re){return new E(M,re)}static insert(M,re){return E.replace(new w(M,M),re)}static delete(M){return E.replace(M,"")}static setEndOfLine(M){const re=new E(new w(new g(0,0),new g(0,0)),"");return re.newEol=M,re}get range(){return this._range}set range(M){if(M&&!w.isRange(M))throw(0,k.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,k.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,k.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=E=je([h],W),e.TextEdit=W;var J;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellOutput=4]="CellOutput",x[x.CellReplace=5]="CellReplace",x[x.CellOutputItem=6]="CellOutputItem"})(J=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,re,ye,ze){this._edits.push({_type:1,from:M,to:re,options:ye,metadata:ze})}createFile(M,re,ye){this._edits.push({_type:1,from:void 0,to:M,options:re,metadata:ye})}deleteFile(M,re,ye){this._edits.push({_type:1,from:M,to:void 0,options:re,metadata:ye})}replaceNotebookMetadata(M,re,ye){this._edits.push({_type:3,metadata:ye,uri:M,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(M,re,ye,ze,Je){(re!==ye||ze.length>0)&&this._edits.push({_type:5,uri:M,index:re,count:ye-re,cells:ze,metadata:Je})}replaceNotebookCellOutput(M,re,ye,ze){this._editNotebookCellOutput(M,re,!1,ye,ze)}appendNotebookCellOutput(M,re,ye,ze){this._editNotebookCellOutput(M,re,!0,ye,ze)}replaceNotebookCellOutputItems(M,re,ye,ze,Je){this._editNotebookCellOutputItems(M,re,ye,!1,ze,Je)}appendNotebookCellOutputItems(M,re,ye,ze,Je){this._editNotebookCellOutputItems(M,re,ye,!0,ze,Je)}_editNotebookCellOutputItems(M,re,ye,ze,Je,ut){this._edits.push({_type:6,metadata:ut,uri:M,index:re,outputId:ye,append:ze,newOutputItems:Je})}_editNotebookCellOutput(M,re,ye,ze,Je){this._edits.push({_type:4,metadata:Je,uri:M,index:re,append:ye,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(M,re,ye,ze){this._edits.push({_type:3,metadata:ze,uri:M,edit:{editType:11,index:re,metadata:ye}})}replace(M,re,ye,ze){this._edits.push({_type:2,uri:M,edit:new W(re,ye),metadata:ze})}insert(M,re,ye,ze){this.replace(M,new w(re,re),ye,ze)}delete(M,re,ye){this.replace(M,re,"",ye)}has(M){return this._edits.some(re=>re._type===2&&re.uri.toString()===M.toString())}set(M,re){if(re)for(const ye of re)ye&&this._edits.push({_type:2,uri:M,edit:ye});else{for(let ye=0;ye<this._edits.length;ye++){const ze=this._edits[ye];ze._type===2&&ze.uri.toString()===M.toString()&&(this._edits[ye]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(M){const re=[];for(let ye of this._edits)ye._type===2&&ye.uri.toString()===M.toString()&&re.push(ye.edit);return re}entries(){const M=new T.ResourceMap;for(let re of this._edits)if(re._type===2){let ye=M.get(re.uri);ye||(ye=[re.uri,[]],M.set(re.uri,ye)),ye[1].push(re.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=je([h],O),e.WorkspaceEdit=O;let F=p=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof p?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=p._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,re=this._tabstop++){if(typeof M=="function"){const ye=new p;ye._tabstop=this._tabstop,M(ye),this._tabstop=ye._tabstop,M=ye.value}else M=p._escape(M);return this.value+="${",this.value+=re,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,re=this._tabstop++){const ye=M.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(M,re){if(typeof re=="function"){const ye=new p;ye._tabstop=this._tabstop,re(ye),this._tabstop=ye._tabstop,re=ye.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,re&&(this.value+=":",this.value+=re),this.value+="}",this}};F=p=je([h],F),e.SnippetString=F;var N;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let U=u=class{constructor(M,re){if(this.uri=M,re)if(re instanceof w)this.range=re;else if(re instanceof g)this.range=new w(re,re);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof u?!0:M?w.isRange(M.range)&&D.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};U=u=je([h],U),e.Location=U;let Q=class{constructor(M,re){this.location=M,this.message=re}static is(M){return M?typeof M.message=="string"&&M.location&&w.isRange(M.location.range)&&D.URI.isUri(M.location.uri):!1}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.location.range.isEqual(re.location.range)&&M.location.uri.toString()===re.location.uri.toString()}};Q=je([h],Q),e.DiagnosticRelatedInformation=Q;let Z=class{constructor(M,re,ye=B.Error){if(!w.isRange(M))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=M,this.message=re,this.severity=ye}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.severity===re.severity&&M.code===re.code&&M.severity===re.severity&&M.source===re.source&&M.range.isEqual(re.range)&&(0,_.equals)(M.tags,re.tags)&&(0,_.equals)(M.relatedInformation,re.relatedInformation,Q.isEqual)}};Z=je([h],Z),e.Diagnostic=Z;let ne=class{constructor(M,re){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,A.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=re}};ne=je([h],ne),e.Hover=ne;var pe;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(pe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Pe=class{constructor(M,re=pe.Text){this.range=M,this.kind=re}toJSON(){return{range:this.range,kind:pe[this.kind]}}};Pe=je([h],Pe),e.DocumentHighlight=Pe;var Oe;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Oe=e.SymbolKind||(e.SymbolKind={}));var Te;(function(x){x[x.Deprecated=1]="Deprecated"})(Te=e.SymbolTag||(e.SymbolTag={}));let xe=b=class{constructor(M,re,ye,ze,Je){this.name=M,this.kind=re,this.containerName=Je,typeof ye=="string"&&(this.containerName=ye),ze instanceof U?this.location=ze:ye instanceof w&&(this.location=new U(ze,ye)),b.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};xe=b=je([h],xe),e.SymbolInformation=xe;let $=t=class{constructor(M,re,ye,ze,Je){this.name=M,this.detail=re,this.kind=ye,this.range=ze,this.selectionRange=Je,this.children=[],t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(t.validate)}};$=t=je([h],$),e.DocumentSymbol=$;var G;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(M,re){this.title=M,this.kind=re}};ie=je([h],ie),e.CodeAction=ie;let oe=n=class{constructor(M){this.value=M}append(M){return new n(this.value?this.value+n.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+n.sep)}};oe.sep=".",oe=n=je([h],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let me=class{constructor(M,re){if(this.range=M,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=je([h],me),e.SelectionRange=me;class De{constructor(M,re,ye,ze,Je,ut){this.kind=M,this.name=re,this.detail=ye,this.uri=ze,this.range=Je,this.selectionRange=ut}}e.CallHierarchyItem=De;class Ne{constructor(M,re){this.fromRanges=re,this.from=M}}e.CallHierarchyIncomingCall=Ne;class ge{constructor(M,re){this.fromRanges=re,this.to=M}}e.CallHierarchyOutgoingCall=ge;let Ce=class{constructor(M,re){this.range=M,this.command=re}get isResolved(){return!!this.command}};Ce=je([h],Ce),e.CodeLens=Ce;let Ae=a=class{constructor(M,re=!1){f.set(this,void 0),tt(this,f,new A.MarkdownString(M,{supportThemeIcons:re}),"f")}static isMarkdownString(M){return M instanceof a?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Me(this,f,"f").value}set value(M){Me(this,f,"f").value=M}get isTrusted(){return Me(this,f,"f").isTrusted}set isTrusted(M){Me(this,f,"f").isTrusted=M}get supportThemeIcons(){return Me(this,f,"f").supportThemeIcons}appendText(M){return Me(this,f,"f").appendText(M),this}appendMarkdown(M){return Me(this,f,"f").appendMarkdown(M),this}appendCodeblock(M,re){return Me(this,f,"f").appendCodeblock(re!=null?re:"",M),this}};f=new WeakMap,Ae=a=je([h],Ae),e.MarkdownString=Ae;let Be=class{constructor(M,re){this.label=M,this.documentation=re}};Be=je([h],Be),e.ParameterInformation=Be;let _e=class{constructor(M,re){this.label=M,this.documentation=re,this.parameters=[]}};_e=je([h],_e),e.SignatureInformation=_e;let qe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};qe=je([h],qe),e.SignatureHelp=qe;var j;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(j=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var te;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(te=e.InlineHintKind||(e.InlineHintKind={}));let ve=class{constructor(M,re,ye){this.text=M,this.range=re,this.kind=ye}};ve=je([h],ve),e.InlineHint=ve;var Ue;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var $e;(function(x){x[x.Deprecated=1]="Deprecated"})($e=e.CompletionItemTag||(e.CompletionItemTag={}));let Ye=class{constructor(M,re){this.label=M,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ye=je([h],Ye),e.CompletionItem=Ye;let H=class{constructor(M=[],re=!1){this.items=M,this.isIncomplete=re}};H=je([h],H),e.CompletionList=H;var se;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(se=e.ViewColumn||(e.ViewColumn={}));var de;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(de=e.StatusBarAlignment||(e.StatusBarAlignment={}));var K;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var le;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(le=e.TextEditorRevealType||(e.TextEditorRevealType={}));var fe;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(fe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ee;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function M(re){switch(re){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=M}(fe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ve=class{constructor(M,re){if(re&&!D.URI.isUri(re))throw(0,k.illegalArgument)("target");if(!w.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.target=re}};Ve=je([h],Ve),e.DocumentLink=Ve;let Fe=class{constructor(M,re,ye,ze){this.red=M,this.green=re,this.blue=ye,this.alpha=ze}};Fe=je([h],Fe),e.Color=Fe;let We=class{constructor(M,re){if(re&&!(re instanceof Fe))throw(0,k.illegalArgument)("color");if(!w.isRange(M)||M.isEmpty)throw(0,k.illegalArgument)("range");this.range=M,this.color=re}};We=je([h],We),e.ColorInformation=We;let Qe=class{constructor(M){if(!M||typeof M!="string")throw(0,k.illegalArgument)("label");this.label=M}};Qe=je([h],Qe),e.ColorPresentation=Qe;var it;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(it=e.ColorFormat||(e.ColorFormat={}));var at;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ze;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Ze=e.TaskRevealKind||(e.TaskRevealKind={}));var nt;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(nt=e.TaskPanelKind||(e.TaskPanelKind={}));let dt=s=class{constructor(M,re){if(typeof M!="string"||typeof re!="string")throw(0,k.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};dt.Clean=new s("clean","Clean"),dt.Build=new s("build","Build"),dt.Rebuild=new s("rebuild","Rebuild"),dt.Test=new s("test","Test"),dt=s=je([h],dt),e.TaskGroup=dt;function wt(x){let M="";for(let re=0;re<x.length;re++)M+=x[re].replace(/,/g,",,")+",";return M}let ue=class{constructor(M,re,ye){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=M,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ye):this._options=re)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,k.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let re of this._args)M.push(re);return wt(M)}};ue=je([h],ue),e.ProcessExecution=ue;let Se=class{constructor(M,re,ye){if(this._args=[],Array.isArray(re)){if(!M)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M,this._args=re,this._options=ye}else{if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M,this._options=re}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,k.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)M.push(typeof re=="string"?re:re.value);return wt(M)}};Se=je([h],Se),e.ShellExecution=Se;var ae;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ae=e.ShellQuoting||(e.ShellQuoting={}));var q;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(q=e.TaskScope||(e.TaskScope={}));class Le{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Le;let Ie=c=class{constructor(M,re,ye,ze,Je,ut){this.__deprecated=!1,this._definition=this.definition=M;let gt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ye,this.execution=ze,gt=Je,this.__deprecated=!0):re===q.Global||re===q.Workspace?(this.target=re,this._name=this.name=ye,this._source=this.source=ze,this.execution=Je,gt=ut):(this.target=re,this._name=this.name=ye,this._source=this.source=ze,this.execution=Je,gt=ut),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof Se?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const re=this._definition.type;(c.EmptyType===re||c.ProcessType===re||c.ShellType===re||c.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Ie.ExtensionCallbackType="customExecution",Ie.ProcessType="process",Ie.ShellType="shell",Ie.EmptyType="$empty",Ie=c=je([h],Ie),e.Task=Ie;var Xe;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Xe=e.ProgressLocation||(e.ProgressLocation={}));let et=class{constructor(M,re=ct.None){this.collapsibleState=re,D.URI.isUri(M)?this.resourceUri=M:this.label=M}};et=je([h],et),e.TreeItem=et;var ct;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let rt=class{constructor(M,re){this.id=M,this.color=re}};rt=je([h],rt),e.ThemeIcon=rt,rt.File=new rt("file"),rt.Folder=new rt("folder");let Ge=class{constructor(M){this.id=M}};Ge=je([h],Ge),e.ThemeColor=Ge;var ht;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ot=class{constructor(M,re){if(typeof M!="string"&&(!M||!D.URI.isUri(M)&&!D.URI.isUri(M.uri)))throw(0,k.illegalArgument)("base");if(typeof re!="string")throw(0,k.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=D.URI.file(M),this.base=M):D.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=re}};ot=je([h],ot),e.RelativePattern=ot;let vt=class{constructor(M,re,ye,ze){this.enabled=typeof M=="boolean"?M:!0,typeof re=="string"&&(this.condition=re),typeof ye=="string"&&(this.hitCondition=ye),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([h],vt),e.Breakpoint=vt;let pt=class extends vt{constructor(M,re,ye,ze,Je){super(re,ye,ze,Je);if(M===null)throw(0,k.illegalArgument)("location");this.location=M}};pt=je([h],pt),e.SourceBreakpoint=pt;let _t=class extends vt{constructor(M,re,ye,ze,Je){super(re,ye,ze,Je);this.functionName=M}};_t=je([h],_t),e.FunctionBreakpoint=_t;let yt=class extends vt{constructor(M,re,ye,ze,Je,ut,gt){super(ze,Je,ut,gt);if(!re)throw(0,k.illegalArgument)("dataId");this.label=M,this.dataId=re,this.canPersist=ye}};yt=je([h],yt),e.DataBreakpoint=yt;let It=class{constructor(M,re,ye){this.command=M,this.args=re||[],this.options=ye}};It=je([h],It),e.DebugAdapterExecutable=It;let bt=class{constructor(M,re){this.port=M,this.host=re}};bt=je([h],bt),e.DebugAdapterServer=bt;let Pt=class{constructor(M){this.path=M}};Pt=je([h],Pt),e.DebugAdapterNamedPipeServer=Pt;let qt=class{constructor(M){this.implementation=M}};qt=je([h],qt),e.DebugAdapterInlineImplementation=qt;let ft=class{constructor(M,re){this.range=M,this.expression=re}};ft=je([h],ft),e.EvaluatableExpression=ft;let Kt=class{constructor(M,re){this.range=M,this.text=re}};Kt=je([h],Kt),e.InlineValueText=Kt;let Et=class{constructor(M,re,ye=!0){this.range=M,this.variableName=re,this.caseSensitiveLookup=ye}};Et=je([h],Et),e.InlineValueVariableLookup=Et;let Bt=class{constructor(M,re){this.range=M,this.expression=re}};Bt=je([h],Bt),e.InlineValueEvaluatableExpression=Bt;let Gt=class{constructor(M,re){this.frameId=M,this.stoppedLocation=re}};Gt=je([h],Gt),e.InlineValueContext=Gt;var Wt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Wt=e.FileChangeType||(e.FileChangeType={}));let lt=l=class extends Error{constructor(M,re=C.FileSystemProviderErrorCode.Unknown,ye){var ze;super(D.URI.isUri(M)?M.toString(!0):M);this.code=(ze=ye==null?void 0:ye.name)!==null&&ze!==void 0?ze:"Unknown",(0,C.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,l.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}static FileExists(M){return new l(M,C.FileSystemProviderErrorCode.FileExists,l.FileExists)}static FileNotFound(M){return new l(M,C.FileSystemProviderErrorCode.FileNotFound,l.FileNotFound)}static FileNotADirectory(M){return new l(M,C.FileSystemProviderErrorCode.FileNotADirectory,l.FileNotADirectory)}static FileIsADirectory(M){return new l(M,C.FileSystemProviderErrorCode.FileIsADirectory,l.FileIsADirectory)}static NoPermissions(M){return new l(M,C.FileSystemProviderErrorCode.NoPermissions,l.NoPermissions)}static Unavailable(M){return new l(M,C.FileSystemProviderErrorCode.Unavailable,l.Unavailable)}};lt=l=je([h],lt),e.FileSystemError=lt;let Qt=class{constructor(M,re,ye){this.start=M,this.end=re,this.kind=ye}};Qt=je([h],Qt),e.FoldingRange=Qt;var At;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(At=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ot;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ot=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var un;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(un=e.CommentMode||(e.CommentMode={}));class pn{constructor(M,re=[]){this.tokenTypes=M,this.tokenModifiers=re}}e.SemanticTokensLegend=pn;function cn(x){return typeof x=="undefined"||(0,S.isStringArray)(x)}class Jt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let re=0,ye=M.tokenTypes.length;re<ye;re++)this._tokenTypeStrToInt.set(M.tokenTypes[re],re);for(let re=0,ye=M.tokenModifiers.length;re<ye;re++)this._tokenModifierStrToInt.set(M.tokenModifiers[re],re)}}push(M,re,ye,ze,Je){if(typeof M=="number"&&typeof re=="number"&&typeof ye=="number"&&typeof ze=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(M,re,ye,ze,Je);if(w.isRange(M)&&typeof re=="string"&&cn(ye))return this._push(M,re,ye);throw(0,k.illegalArgument)()}_push(M,re,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const ze=M.start.line,Je=M.start.character,ut=M.end.character-M.start.character,gt=this._tokenTypeStrToInt.get(re);let St=0;if(ye)for(const Dt of ye){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const Ct=this._tokenModifierStrToInt.get(Dt);St|=1<<Ct>>>0}this._pushEncoded(ze,Je,ut,gt,St)}_pushEncoded(M,re,ye,ze,Je){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Dt=0,Ct=0;for(let kt=0;kt<St;kt++){let Rt=this._data[5*kt],an=this._data[5*kt+1];Rt===0?(Rt=Dt,an+=Ct):Rt+=Dt,this._data[5*kt]=Rt,this._data[5*kt+1]=an,Dt=Rt,Ct=an}}let ut=M,gt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Je,this._prevLine=M,this._prevChar=re}static _sortAndDeltaEncode(M){let re=[];const ye=M.length/5|0;for(let gt=0;gt<ye;gt++)re[gt]=gt;re.sort((gt,St)=>{const Dt=M[5*gt],Ct=M[5*St];if(Dt===Ct){const kt=M[5*gt+1],Rt=M[5*St+1];return kt-Rt}return Dt-Ct});const ze=new Uint32Array(M.length);let Je=0,ut=0;for(let gt=0;gt<ye;gt++){const St=5*re[gt],Dt=M[St+0],Ct=M[St+1],kt=M[St+2],Rt=M[St+3],an=M[St+4],In=Dt-Je,Rn=In===0?Ct-ut:Ct,ln=5*gt;ze[ln+0]=In,ze[ln+1]=Rn,ze[ln+2]=kt,ze[ln+3]=Rt,ze[ln+4]=an,Je=Dt,ut=Ct}return ze}build(M){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),M):new Ht(Jt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Jt;class Ht{constructor(M,re){this.resultId=re,this.data=M}}e.SemanticTokens=Ht;class Lt{constructor(M,re,ye){this.start=M,this.deleteCount=re,this.data=ye}}e.SemanticTokensEdit=Lt;class vn{constructor(M,re){this.resultId=re,this.edits=M}}e.SemanticTokensEdits=vn;var Yt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Yt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Xt;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Xt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let zt=class{constructor(){}};zt.Back={iconPath:new rt("arrow-left")},zt=je([h],zt),e.QuickInputButtons=zt;var bn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(bn=e.ExtensionKind||(e.ExtensionKind={}));class Tt{constructor(M,re,ye){this.badge=M,this.tooltip=re,this.color=ye}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Tt;let Zt=class{constructor(M){this.kind=M}};Zt=je([h],Zt),e.ColorTheme=Zt;var wn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(wn=e.ColorThemeKind||(e.ColorThemeKind={}));class en{constructor(M,re){if(M<0)throw(0,k.illegalArgument)("start must be positive");if(re<0)throw(0,k.illegalArgument)("end must be positive");M<=re?(this._start=M,this._end=re):(this._start=re,this._end=M)}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let re=this._start,ye=this._end;return M.start!==void 0&&(re=M.start),M.end!==void 0&&(ye=M.end),re===this._start&&ye===this._end?this:new en(re,ye)}}e.NotebookRange=en;class tn{constructor(M,re){typeof M=="object"?Object.assign(this,M):(this.inputCollapsed=M,this.outputCollapsed=re)}with(M){let{inputCollapsed:re,outputCollapsed:ye,custom:ze}=M,Je=$t(M,["inputCollapsed","outputCollapsed","custom"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ye===void 0?ye=this.outputCollapsed:ye===null&&(ye=void 0),ze===void 0?ze=this.custom:ze===null&&(ze=void 0),re===this.inputCollapsed&&ye===this.outputCollapsed&&ze===this.custom&&Object.keys(Je).length===0?this:new tn(Object.assign({inputCollapsed:re,outputCollapsed:ye,custom:ze},Je))}}e.NotebookCellMetadata=tn;class Mt{constructor(M=!0,re={}){var ye,ze;typeof M=="object"?(Object.assign(this,M),this.trusted=(ye=M.trusted)!==null&&ye!==void 0?ye:!0,this.custom=(ze=M.custom)!==null&&ze!==void 0?ze:{}):(this.trusted=M,this.custom=re)}with(M){let{custom:re,trusted:ye}=M,ze=$t(M,["custom","trusted"]);return re===void 0?re=this.custom:re===null&&(re=void 0),ye===void 0?ye=this.trusted:ye===null&&(ye=void 0),re===this.custom&&ye===this.trusted&&Object.keys(ze).length===0?this:new Mt(Object.assign({trusted:ye,custom:re},ze))}}e.NotebookDocumentMetadata=Mt;class dn{constructor(M,re,ye,ze,Je,ut){this.kind=M,this.source=re,this.language=ye,this.outputs=ze!=null?ze:[],this.metadata=Je,this.latestExecutionSummary=ut}}e.NotebookCellData=dn;class hn{constructor(M,re){this.cells=M,this.metadata=re!=null?re:new Mt}}e.NotebookData=hn;class Nt{constructor(M,re,ye){this.mime=M,this.value=re,this.metadata=ye}static isNotebookCellOutputItem(M){return M instanceof Nt}}e.NotebookCellOutputItem=Nt;class Re{constructor(M,re,ye){this.outputs=M,typeof re=="string"?(this.id=re,this.metadata=ye):(this.id=(0,y.generateUuid)(),this.metadata=re!=null?re:ye)}}e.NotebookCellOutput=Re;var nn;(function(x){x[x.Markdown=1]="Markdown",x[x.Code=2]="Code"})(nn=e.NotebookCellKind||(e.NotebookCellKind={}));var rn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(rn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(mt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _n;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(_n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class En{constructor(M,re,ye,ze,Je,ut){this.text=M,this.alignment=re,this.command=ye,this.tooltip=ze,this.priority=Je,this.accessibilityInformation=ut}}e.NotebookCellStatusBarItem=En;let Vt=class{constructor(M,re){this.label=M,this.timestamp=re}};Vt=je([h],Vt),e.TimelineItem=Vt;var fn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(fn=e.ExtensionMode||(e.ExtensionMode={}));var yn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(yn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Sn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Sn=e.StandardTokenType||(e.StandardTokenType={}));class Dn{constructor(M,re){this.ranges=M,this.wordPattern=re}}e.LinkedEditingRanges=Dn;var Cn;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Cn=e.TestResultState||(e.TestResultState={}));var sn;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information",x[x.Hint=3]="Hint"})(sn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var mn;(function(x){x[x.Pending=0]="Pending",x[x.Resolved=1]="Resolved"})(mn=e.TestItemStatus||(e.TestItemStatus={}));const Ut=(x,M,re,ye)=>{let ze=re;return{enumerable:!0,configurable:!1,get(){return ze},set(Je){ye(ze,Je)||(ze=Je,x.bus.fire([3,M,Je]))}}},jt=(x,M)=>x===M,kn=(x,M)=>x===M?!0:!x||!M?!1:x.isEqual(M);class on{constructor(M,re,ye,ze){this.label=re,this.data=ze;const Je=(0,I.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},uri:{value:ye,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Je.parent},children:{value:new T.ReadonlyMapView(Je.children),enumerable:!0,writable:!1},range:Ut(Je,"range",void 0,kn),description:Ut(Je,"description",void 0,jt),runnable:Ut(Je,"runnable",!0,jt),debuggable:Ut(Je,"debuggable",!0,jt),status:Ut(Je,"status",mn.Resolved,jt)})}invalidate(){(0,I.getPrivateApiFor)(this).bus.fire([2])}dispose(){const M=(0,I.getPrivateApiFor)(this);M.parent&&(0,I.getPrivateApiFor)(M.parent).children.delete(this.id),M.bus.fire([1])}addChild(M){if(!(M instanceof on))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,I.getPrivateApiFor)(this);if(re.children.has(M.id))throw new Error(`Attempted to insert a duplicate test item ID ${M.id}`);re.children.set(M.id,M),re.bus.fire([0,M])}}e.TestItemImpl=on;class X{constructor(M){this.message=M,this.severity=sn.Error}static diff(M,re,ye){const ze=new X(M);return ze.expectedOutput=re,ze.actualOutput=ye,ze}}e.TestMessage=X;var ce;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(ce=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ke;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(ke=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var st;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore"})(st=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[95],we([0,1,42,18,8,119,86,7,12]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(r,o){o?C.set(r,o):C.delete(r)}e.setWordDefinitionFor=i;function I(r){return C.get(r)}e.getWordDefinitionFor=I;class d extends T.MirrorTextModel{constructor(o,v,m,E,p,u,b,t){super(v,m,E,p);this._proxy=o,this._languageId=u,this._isDirty=b,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,y.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===k.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(v){return v?o._getTextInRange(v):o.getText()},get eol(){return o._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(v){return o._lineAt(v)},offsetAt(v){return o._offsetAt(v)},positionAt(v){return o._positionAt(v)},validateRange(v){return o._validateRange(v)},validatePosition(v){return o._validatePosition(v)},getWordRangeAtPosition(v,m){return o._getWordRangeAtPosition(v,m)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,_.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,_.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const v=this._validateRange(o);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const m=this._eol,E=v.start.line,p=v.end.line,u=[];u.push(this._lines[E].substring(v.start.character));for(let b=E+1;b<p;b++)u.push(this._lines[b]);return u.push(this._lines[p].substring(0,v.end.character)),u.join(m)}_lineAt(o){let v;if(o instanceof D.Position?v=o.line:typeof o=="number"&&(v=o),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new f(v,this._lines[v],v===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(o),m=this._lines[v.index].length;return new D.Position(v.index,Math.min(v.remainder,m))}_validateRange(o){if(!(o instanceof D.Range))throw new Error("Invalid argument");const v=this._validatePosition(o.start),m=this._validatePosition(o.end);return v===o.start&&m===o.end?o:new D.Range(v.line,v.character,m.line,m.character)}_validatePosition(o){if(!(o instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:v,character:m}=o,E=!1;if(v<0)v=0,m=0,E=!0;else if(v>=this._lines.length)v=this._lines.length-1,m=this._lines[v].length,E=!0;else{const p=this._lines[v].length;m<0?(m=0,E=!0):m>p&&(m=p,E=!0)}return E?new D.Position(v,m):o}_getWordRangeAtPosition(o,v){const m=this._validatePosition(o);if(!v)v=I(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const E=(0,S.getWordAtText)(m.character+1,(0,S.ensureValidWordDefinition)(v),this._lines[m.line],0);if(E)return new D.Range(m.line,E.startColumn-1,m.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class f{constructor(o,v,m){this._line=o,this._text=v,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[163],we([0,1,7,3,88,6,60,22,2,29]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,f,r,o){this._notebook=r,this._selector=o,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(m=>{const E=this._cellUris.get(m.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(m=>v(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const d=[],f=[];for(const r of this._notebook.getCells())r.kind===_.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),f.push(r.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(d){var f,r;if(!d){let p="";for(const u of this._cells)p+=u.document.getText()+`
`;return p=p.slice(0,-1),p}if(d.isEmpty)return"";const o=this.locationAt(d.start),v=this.locationAt(d.end),m=this._cells[(f=this._cellUris.get(o.uri))!==null&&f!==void 0?f:-1],E=this._cells[(r=this._cellUris.get(v.uri))!==null&&r!==void 0?r:-1];if(!m||!E)return"";if(m===E)return m.document.getText(new _.Range(o.range.start,v.range.end));{const p=m.document.getText(new _.Range(o.range.start,new _.Position(m.document.lineCount,0))),u=E.document.getText(new _.Range(new _.Position(0,0),v.range.end));return p+`
`+u}}offsetAt(d){const f=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(f.index-1),o=this._cells[f.index].document.offsetAt(d.with(f.remainder));return r+o}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),o=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(o)}const f=this._cellUris.get(d.uri);if(f!==void 0){const r=this._cellLines.getAccumulatedValue(f-1);return new _.Position(r+d.range.start.line,d.range.start.character)}return new _.Position(0,0)}locationAt(d){_.Range.isRange(d)||(d=new _.Range(d,d));const f=this._cellLines.getIndexOf(d.start.line);let r=f;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const o=new _.Position(f.remainder,d.start.character),v=new _.Position(r.remainder,d.end.character),m=new _.Range(o,v),E=this._cells[f.index];return new _.Location(E.document.uri,E.document.validateRange(m))}contains(d){return this._cellUris.has(d)}validateRange(d){const f=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(f,r)}validatePosition(d){const f=this._cellLines.getIndexOf(d.line),r=new _.Position(f.remainder,d.character),o=this._cells[f.index].document.validatePosition(r),v=this._cellLines.getAccumulatedValue(f.index-1);return new _.Position(v+o.line,o.character)}}e.ExtHostNotebookConcatDocument=i}),define(be[164],we([0,1,7,15,3]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let y=D==="light"?_.ColorThemeKind.Light:D==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[72],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=k}),define(be[165],we([0,1,23]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(y){let C=this.buffers.indexOf(y);return C<0&&(C=this.buffers.length,this.buffers.push(y)),C}}function A(D,y){if(y){const C=new k,i=(f,r)=>{if(r instanceof ArrayBuffer){const o=C.add(r);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(r)){const o=T(r);if(o){const v=C.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},I=JSON.stringify(D,i),d=C.buffers.map(f=>{const r=new Uint8Array(f);return _.VSBuffer.wrap(r)});return{message:I,buffers:d}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=A;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(D,y){const C=y.map(d=>{const f=new ArrayBuffer(d.byteLength);return new Uint8Array(f).set(d.buffer),f}),i=y.length?(d,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const r=f,{index:o}=r,v=C[o];if(r.view)switch(r.view.type){case 1:return new Int8Array(v,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return f}:void 0;return{message:JSON.parse(D,i),arrayBuffers:C}}e.deserializeWebviewMessage=S}),define(be[50],we([0,1,2]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(T,S,D){const y=T.webviewResourceRoot.replace("{{resource}}",D.scheme+A(D)).replace("{{uuid}}",S);return _.URI.parse(y)}e.asWebviewUri=k;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(be[166],we([0,1,3,6,50,29]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,C,i){this._proxy=y,this._editors=C,this._initData=i,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const I=C.getVisibleTextEditors();for(const d of this._insets.values())I.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,C,i,I,d){let f;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===y){f=u;break}if(!f)throw new Error("not a visible editor");const r=this,o=this._handlePool++,v=new _.Emitter,m=new _.Emitter,E=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,A.asWebviewUri)(r._initData,this._uuid,u)}get cspSource(){return r._initData.webviewCspSource}set options(u){this._options=u,r._proxy.$setOptions(o,u)}get options(){return this._options}set html(u){this._html=u,r._proxy.$setHtml(o,u)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(u){return r._proxy.$postMessage(o,u)}},p=new class{constructor(){this.editor=y,this.line=C,this.height=i,this.webview=E,this.onDidDispose=m.event}dispose(){r._insets.has(o)&&(r._insets.delete(o),r._proxy.$disposeEditorInset(o),m.fire(),m.dispose(),v.dispose())}};return this._proxy.$createEditorInset(o,f.id,f.value.document.uri,C+1,i,I||{},d.identifier,d.extensionLocation),this._insets.set(o,{editor:y,inset:p,onDidReceiveMessage:v}),p}$onDidDispose(y){const C=this._insets.get(y);C&&C.inset.dispose()}$onDidReceiveMessage(y,C){const i=this._insets.get(y);i&&i.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=S}),define(be[167],we([0,1,3,64,138,4,6,22,30,12,52,24,36,158]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",d.Codicon.window,(0,A.localize)(0,null));var r;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var o;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(o=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function m(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=m;class E extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(l,h,P){var g;const w=this.get(l.id);if(w)return w;const R=l;return R.openCommandActionDescriptor=(P==null?void 0:P.donotRegisterOpenCommand)?void 0:(g=R.openCommandActionDescriptor)!==null&&g!==void 0?g:{id:R.id},(0,D.getOrSet)(this.viewContainers,h,[]).push(R),(P==null?void 0:P.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:h}),R}deregisterViewContainer(l){for(const h of this.viewContainers.keys()){const P=this.viewContainers.get(h),g=P==null?void 0:P.indexOf(l);if(g!==-1){P==null||P.splice(g,1),P.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:l,viewContainerLocation:h});return}}}get(l){return this.all.filter(h=>h.id===l)[0]}getViewContainers(l){return[...this.viewContainers.get(l)||[]]}getViewContainerLocation(l){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(P=>(P==null?void 0:P.id)===l.id).length>0)[0]}getDefaultViewContainer(l){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===l)}}y.Registry.add(r.ViewContainersRegistry,new E);var p;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(p=e.ViewContentGroups||(e.ViewContentGroups={}));function u(c,l){var h,P,g,w;const R=(h=c.group)!==null&&h!==void 0?h:p.More,L=(P=l.group)!==null&&P!==void 0?P:p.More;return R!==L?R.localeCompare(L):((g=c.order)!==null&&g!==void 0?g:5)-((w=l.order)!==null&&w!==void 0?w:5)}class b extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(l,h){this.registerViews2([{views:l,viewContainer:h}])}registerViews2(l){l.forEach(({views:h,viewContainer:P})=>this.addViews(h,P)),this._onViewsRegistered.fire(l)}deregisterViews(l,h){const P=this.removeViews(l,h);P.length&&this._onViewsDeregistered.fire({views:P,viewContainer:h})}moveViews(l,h){for(const P of this._views.keys())if(P!==h){const g=this.removeViews(l,P);g.length&&(this.addViews(g,h),this._onDidChangeContainer.fire({views:g,from:P,to:h}))}}getViews(l){return this._views.get(l)||[]}getView(l){for(const h of this._viewContainers){const P=(this._views.get(h)||[]).filter(g=>g.id===l)[0];if(P)return P}return null}getViewContainer(l){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(g=>g.id===l)[0])return h;return null}registerViewWelcomeContent(l,h){return this._viewWelcomeContents.add(l,h),this._onDidChangeViewWelcomeContent.fire(l),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(l,h),this._onDidChangeViewWelcomeContent.fire(l)})}registerViewWelcomeContent2(l,h){const P=new Map;for(const[g,w]of h)this._viewWelcomeContents.add(l,w),P.set(g,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(l,w),this._onDidChangeViewWelcomeContent.fire(l)}));return this._onDidChangeViewWelcomeContent.fire(l),P}getViewWelcomeContent(l){const h=[];return this._viewWelcomeContents.forEach(l,P=>h.push(P)),h.sort(u)}addViews(l,h){let P=this._views.get(h);P||(P=[],this._views.set(h,P),this._viewContainers.push(h));for(const g of l){if(this.getView(g.id)!==null)throw new Error((0,A.localize)(1,null,g.id));P.push(g)}}removeViews(l,h){const P=this._views.get(h);if(!P)return[];const g=[],w=[];for(const R of P)l.includes(R)?g.push(R):w.push(R);return g.length&&(w.length?this._views.set(h,w):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),g}}y.Registry.add(r.ViewsRegistry,new b),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(l,h){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,l),this._hasResolve=!!h,this.resolve=async P=>{var g,w;if(h&&!this.resolved){const R=await h(P);R&&(this.tooltip=(g=this.tooltip)!==null&&g!==void 0?g:R.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:R.command)}P.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(be[168],we([0,1,2,148,159,19,149,167]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(o){return(v,...m)=>o(v.get(k.ICommandService),...m)}class C{static execute(v,m){const E={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return v.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=C,C.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:C.ID,handler:y(C.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,v){return o.get(A.IWorkspacesService).removeRecentlyOpened([v])});class i{static execute(v,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?_.URI.parse(m):_.URI.file(m):m=_.URI.revive(m),v.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(i.ID,y(i.execute));class I{static execute(v,m){const E=typeof m=="string"?{extensionId:m}:m;return v.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,v){const m=o.get(A.IWorkspacesService);let E;const p=v.uri,u=v.label,b=v.remoteAuthority;return v.type==="workspace"?E={workspace:await m.getWorkspaceIdentifier(p),label:u,remoteAuthority:b}:v.type==="folder"?E={folderUri:p,label:u,remoteAuthority:b}:E={fileUri:p,label:u,remoteAuthority:b},m.addRecentlyOpened([E])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(A.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,v){const m=o.get(T.ILogService),E=o.get(S.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&m.setLevel(v)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(T.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,v){const m=o.get(D.IViewDescriptorService),E=m.getViewContainerById(v.destinationId);if(!!E){for(const p of v.viewIds){const u=m.getViewDescriptorById(p);(u==null?void 0:u.canMoveView)&&m.moveViewsToContainer([u],E,D.ViewVisibilityState.Default)}await o.get(D.IViewsService).openViewContainer(E.id,!0)}});class d{static execute(v,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):v.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:d.ID,handler:y(d.execute),description:{description:"Move Views",args:[]}});class f{static execute(v,m){return v.executeCommand("_workbench.open",m)}}f.ID="vscode.open",k.CommandsRegistry.registerCommand(f.ID,y(f.execute));class r{static execute(v,m,E,p,u){return v.executeCommand("_workbench.diff",[m,E,p])}}r.ID="vscode.diff",k.CommandsRegistry.registerCommand(r.ID,y(r.execute))}),define(be[169],we([0,1,3,14,139]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,y,C,i){const I={command:D};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.internalSend("request",I),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const f=this.pendingRequests.get(I.seq);if(f){this.pendingRequests.delete(I.seq);const r={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,A.localize)(0,null,i,D)};f(r)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,y){return D.type!=="event"||y.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,k.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const y=D,C=this.pendingRequests.get(y.request_seq);C&&(this.pendingRequests.delete(y.request_seq),C(y));break}}}internalSend(D,y){y.type=D,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((y,C)=>D.set(C,y)),await(0,k.timeout)(500),D.forEach((y,C)=>{y({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[170],we([0,1,8,2,13,24,18]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function y(n,a,s){return n.replace(D,function(c,l){return a&&l.length>0&&l[0]!=="_"?c:s&&s.hasOwnProperty(l)?s[l]:c})}e.formatPII=y;function C(n){const a={};for(const s of Object.keys(n))s.startsWith("!")||(a[s]=n[s]);return a}e.filterExceptionsFromTelemetry=C;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let a=n.configuration.type;if(!!a)return a==="vslsShare"&&(a=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(a,"extensionhost")||(0,_.equalsIgnoreCase)(a,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function f(n,a,s){let c,l=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=h.exec(n);){let g=P.index+1,w=g+P[0].length;if(g<=a&&w>=s){c=P[0],l=g;break}}if(c){let g=/\w+/g,w=null;for(;(w=g.exec(c))&&!(w.index+1+l+w[0].length>=s););w&&(c=c.substring(0,g.lastIndex))}return c?{start:l,end:l+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(n){return!!(n&&n.match(r))}e.isUri=o;function v(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(o(n.path))return k.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const a=k.URI.revive(n.path);if(a)return a.scheme===S.Schemas.file?a.fsPath:a.toString()}return n.path}function E(n,a){const s=a?v:m,c=(0,T.deepClone)(n);return u(c,(l,h)=>{l&&h&&(h.path=s(h))}),c}e.convertToDAPaths=E;function p(n,a){const s=a?v:m,c=(0,T.deepClone)(n);return u(c,(l,h)=>{!l&&h&&(h.path=s(h))}),c}e.convertToVSCPaths=p;function u(n,a){switch(n.type){case"event":const s=n;switch(s.event){case"output":a(!1,s.body.source);break;case"loadedSource":a(!1,s.body.source);break;case"breakpoint":a(!1,s.body.breakpoint.source);break;default:break}break;case"request":const c=n;switch(c.command){case"setBreakpoints":a(!0,c.arguments.source);break;case"breakpointLocations":a(!0,c.arguments.source);break;case"source":a(!0,c.arguments.source);break;case"gotoTargets":a(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(h=>a(!1,h));break;default:break}break;case"response":const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(h=>a(!1,h.source));break;case"loadedSources":l.body.sources.forEach(h=>a(!1,h));break;case"scopes":l.body.scopes.forEach(h=>a(!1,h.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(h=>a(!1,h.source));break;case"setBreakpoints":l.body.breakpoints.forEach(h=>a(!1,h.source));break;default:break}break}}function b(n){return n.filter(a=>{var s;return!((s=a.presentation)===null||s===void 0?void 0:s.hidden)}).sort((a,s)=>a.presentation?s.presentation?a.presentation.group?s.presentation.group?a.presentation.group!==s.presentation.group?a.presentation.group.localeCompare(s.presentation.group):t(a.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(a.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=b;function t(n,a){return typeof n!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:n-a}}),define(be[73],we([0,1,28,18,13,21,64]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(L){L[L.Markdown=1]="Markdown",L[L.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var C;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.CellClearOutput=3]="CellClearOutput",L[L.CellsClearOutput=4]="CellsClearOutput",L[L.ChangeLanguage=5]="ChangeLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.OutputsSplice=6]="OutputsSplice",L[L.Move=7]="Move",L[L.Unknown=8]="Unknown",L[L.CellContent=9]="CellContent",L[L.OutputItems=10]="OutputItems",L[L.PartialMetadata=11]="PartialMetadata"})(f=e.CellEditType||(e.CellEditType={}));function r(L){const V=o.parse(L);return V?V.notebook.toString():L.toString()}e.getCellUndoRedoComparisonKey=r;var o;(function(L){L.scheme=k.Schemas.vscodeNotebookCell;const V=/^ch(\d{7,})/;function he(O,F){return O.with({scheme:L.scheme,fragment:`ch${F.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}L.generate=he;function z(O){if(O.scheme===L.scheme){const F=V.exec(O.fragment);if(!!F)return{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}}}L.parse=z;function W(O,F){return O.with({scheme:k.Schemas.vscodeNotebookCellMetadata,fragment:`ch${F.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}L.generateCellMetadataUri=W;function J(O){if(O.scheme===k.Schemas.vscodeNotebookCellMetadata){const F=V.exec(O.fragment);if(!!F)return{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}}}L.parseCellMetadataUri=J})(o=e.CellUri||(e.CellUri={}));const v=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(L){var V,he;return(he=(V=v.get(L))===null||V===void 0?void 0:V.alwaysSecure)!==null&&he!==void 0?he:!1}e.mimeTypeIsAlwaysSecure=m;function E(L){var V,he;return(he=(V=v.get(L))===null||V===void 0?void 0:V.supportedByCore)!==null&&he!==void 0?he:!1}e.mimeTypeSupportedByCore=E;function p(L){var V,he;return(he=(V=v.get(L))===null||V===void 0?void 0:V.mergeable)!==null&&he!==void 0?he:!1}e.mimeTypeIsMergeable=p;function u(L,V){return T.isWindows&&(L=L.replace(/\//g,"\\"),V=V.replace(/\//g,"\\")),_.match(L,V)}function b(L,V,he){let z=0;for(let W=0;W<V.length;W++){if(u(V[W],L))return z;z++}for(let W=0;W<he.length;W++){if(u(he[W],L))return z;z++}return z}function t(L,V,he){return L.sort((z,W)=>b(z,V,he)-b(W,V,he))}e.sortMimeTypes=t;function n(L,V,he,z=(W,J)=>W===J){const W=[];function J(N,B,U){if(!(B===0&&U.length===0)){const Q=W[W.length-1];Q&&Q.start+Q.deleteCount===N?(Q.deleteCount+=B,Q.toInsert.push(...U)):W.push({start:N,deleteCount:B,toInsert:U})}}let O=0,F=0;for(;;){if(O===L.length){J(O,0,V.slice(F));break}if(F===V.length){J(O,L.length-O,[]);break}const N=L[O],B=V[F];if(z(N,B)){O+=1,F+=1;continue}he(B)?(J(O,1,[]),O+=1):(J(O,0,[B]),F+=1)}return W}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(L){L.default="default",L.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(L){const V=L;return!!((typeof V.include=="string"||_.isRelativePattern(V.include))&&(typeof V.exclude=="string"||_.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=s;function c(L,V,he){if(Array.isArray(L.viewType)&&L.viewType.indexOf(V)>=0||L.viewType===V)return!0;if(L.filenamePattern){let z=s(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,W=s(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(_.match(z,(0,A.basename)(he.fsPath).toLowerCase()))return!(W&&_.match(W,(0,A.basename)(he.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class l{constructor(V){this.textModel=V}getElements(){const V=new Int32Array(this.textModel.cells.length);for(let he=0;he<this.textModel.cells.length;he++)V[he]=this.textModel.cells[he].getHashValue();return V}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var h;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function P(L){L.sort((he,z)=>he-z);const V=L.shift();return V===void 0?[]:L.reduce(function(he,z){return z<=he[0][1]?he[0][1]=z+1:he.unshift([z,z+1]),he},[[V,V+1]]).reverse().map(he=>({start:he[0],end:he[1]}))}e.cellIndexesToRanges=P;function g(L){return L.reduce((he,z)=>{for(let W=z.start;W<z.end;W++)he.push(W);return he},[])}e.cellRangesToIndexes=g;function w(L){const V=L.sort((z,W)=>z.start-W.start),he=V[0];return he?V.reduce((z,W)=>{const J=z[z.length-1];return J.end>=W.start?J.end=Math.max(J.end,W.end):z.push(W),z},[he]):[]}e.reduceRanges=w;function R(L,V){return V.start>=L.start&&V.end<=L.end}e.cellRangeContains=R}),define(be[171],we([0,1,141,4,64]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[172],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=_;function k(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=k}),define(be[96],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(y,C)=>{C.expand!==void 0&&(y.expand=C.expand),C.item!==void 0&&Object.assign(y.item,C.item)};e.applyTestItemUpdate=k;var A;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(y,C)=>`${y}:${C.toString()}`;e.getTestSubscriptionKey=T;class S{add(C){}update(C){}remove(C,i){}complete(){}}e.IncrementalChangeCollector=S;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const i=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const d=I[1];if(d.parent){if(this.items.has(d.parent)){const f=this.items.get(d.parent);f.children.add(d.item.extId);const r=this.createItem(d,f);this.items.set(d.item.extId,r),i.add(r)}}else{this.roots.add(d.item.extId);const f=this.createItem(d);this.items.set(d.item.extId,f),i.add(f)}d.expand===2&&this.updateBusyControllers(1);break}case 1:{const d=I[1],f=this.items.get(d.extId);if(!f)break;(0,e.applyTestItemUpdate)(f,d),i.update(f),d.expand!==void 0&&f.expand===2&&d.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const d=this.items.get(I[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const f=[[I[1]]];for(;f.length;)for(const r of f.pop()){const o=this.items.get(r);o&&(f.push(o.children),this.items.delete(r),i.remove(o,o!==d),o.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(C){}updateBusyControllers(C){this.busyControllerCount+=C}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=D}),define(be[173],we([0,1,13,46,10,24,21,59,142]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,d,f,r){if(this._contributedVariables=new Map,this._context=I,this._labelService=d,f)if(S.isWindows){const o=Object.create(null);this._envVariables=o,Object.keys(f).forEach(v=>{o[v.toLowerCase()]=f[v]})}else this._envVariables=f}resolveWithEnvironment(I,d,f){return this.recursiveResolve(I,d?d.uri:void 0,f)}async resolveAsync(I,d){return this.recursiveResolve(this._envVariables,I?I.uri:void 0,d)}resolve(I,d){return this.recursiveResolve(this._envVariables,I?I.uri:void 0,d)}resolveAnyBase(I,d,f,r){const o=T.deepClone(d);return S.isWindows&&o.windows?Object.keys(o.windows).forEach(v=>o[v]=o.windows[v]):S.isMacintosh&&o.osx?Object.keys(o.osx).forEach(v=>o[v]=o.osx[v]):S.isLinux&&o.linux&&Object.keys(o.linux).forEach(v=>o[v]=o.linux[v]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(this._envVariables,I?I.uri:void 0,o,f,r)}resolveAny(I,d,f){return this.resolveAnyBase(I,d,f)}async resolveAnyAsync(I,d,f){return this.resolveAnyBase(I,d,f)}resolveAnyMap(I,d,f){const r=new Map;return{newConfig:this.resolveAnyBase(I,d,f,r),resolvedVariables:r}}resolveWithInteractionReplace(I,d,f,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,d,f,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,d){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,d)}recursiveResolve(I,d,f,r,o){if(A.isString(f))return this.resolveString(I,d,f,r,o);if(A.isArray(f))return f.map(v=>this.recursiveResolve(I,d,v,r,o));if(A.isObject(f)){let v=Object.create(null);return Object.keys(f).forEach(m=>{const E=this.resolveString(I,d,m,r,o);v[E]=this.recursiveResolve(I,d,f[m],r,o)}),v}return f}resolveString(I,d,f,r,o){return f.replace(C.VARIABLE_REGEXP,(m,E)=>{if(E.includes(C.VARIABLE_LHS))return m;let p=this.evaluateSingleVariable(I,m,E,d,r);return o&&o.set(E,p),p})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,d,f,r,o){let v;const m=f.split(":");m.length>1&&(f=m[0],v=m[1]);const E=()=>{const b=this._context.getFilePath();if(b)return b;throw new Error((0,y.localize)(0,null,d))},p=()=>{const b=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,y.localize)(1,null,d,_.basename(b)))},u=()=>{if(v){const b=this._context.getFolderUri(v);if(b)return b;throw new Error((0,y.localize)(2,null,d,v))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,d)):new Error((0,y.localize)(4,null,d))};switch(f){case"env":if(v){if(I){const b=I[S.isWindows?v.toLowerCase():v];if(A.isString(b))return b}return""}throw new Error((0,y.localize)(5,null,d));case"config":if(v){const b=this._context.getConfigurationValue(r,v);if(A.isUndefinedOrNull(b))throw new Error((0,y.localize)(6,null,d,v));if(A.isObject(b))throw new Error((0,y.localize)(7,null,d,v));return b}throw new Error((0,y.localize)(8,null,d));case"command":return this.resolveFromMap(d,v,o,"command");case"input":return this.resolveFromMap(d,v,o,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return r||v?(0,D.normalizeDriveLetter)(this.fsPath(u())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(u()));case"lineNumber":const b=this._context.getLineNumber();if(b)return b;throw new Error((0,y.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,y.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return p();case"relativeFile":return r||v?_.relative(this.fsPath(u()),E()):E();case"relativeFileDirname":const n=_.dirname(E());if(r||v){const l=_.relative(this.fsPath(u()),n);return l.length===0?".":l}return n;case"fileDirname":return _.dirname(E());case"fileExtname":return _.extname(E());case"fileBasename":return _.basename(E());case"fileBasenameNoExtension":const a=_.basename(E());return a.slice(0,a.length-_.extname(a).length);case"fileDirnameBasename":return _.basename(_.dirname(E()));case"execPath":const s=this._context.getExecPath();return s||d;case"execInstallFolder":const c=this._context.getAppRoot();return c||d;case"pathSeparator":return _.sep;default:try{const l=v?`${f}:${v}`:f;return this.resolveFromMap(d,l,o,void 0)}catch(l){return d}}}}resolveFromMap(I,d,f,r){if(d&&f){const o=r===void 0?f[d]:f[r+":"+d];if(typeof o=="string")return o;throw new Error((0,y.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[174],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var k;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var S;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(be[175],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,12,83,229,58,24,10,2,32,63,143,90,73,175,7]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var v;(function(ue){function Se(q){const{selectionStartLineNumber:Le,selectionStartColumn:Ie,positionLineNumber:Xe,positionColumn:et}=q,ct=new o.Position(Le-1,Ie-1),rt=new o.Position(Xe-1,et-1);return new o.Selection(ct,rt)}ue.to=Se;function ae(q){const{anchor:Le,active:Ie}=q;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}ue.from=ae})(v=e.Selection||(e.Selection={}));var m;(function(ue){function Se(q){if(!!q){const{start:Le,end:Ie}=q;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}ue.from=Se;function ae(q){if(!!q){const{startLineNumber:Le,startColumn:Ie,endLineNumber:Xe,endColumn:et}=q;return new o.Range(Le-1,Ie-1,Xe-1,et-1)}}ue.to=ae})(m=e.Range||(e.Range={}));var E;(function(ue){function Se(ae){switch(ae){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 4:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}ue.to=Se})(E=e.TokenType||(e.TokenType={}));var p;(function(ue){function Se(q){return new o.Position(q.lineNumber-1,q.column-1)}ue.to=Se;function ae(q){return{lineNumber:q.line+1,column:q.character+1}}ue.from=ae})(p=e.Position||(e.Position={}));var u;(function(ue){function Se(q){switch(q){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}ue.from=Se;function ae(q){switch(q){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}ue.to=ae})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var b;(function(ue){function Se(q){let Le;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Le=String(q.code):Le={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},m.from(q.range)),{message:q.message,source:q.source,code:Le,severity:n.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,_.coalesce)(q.tags.map(u.from)):void 0})}ue.from=Se;function ae(q){var Le;const Ie=new o.Diagnostic(m.to(q),q.message,n.to(q.severity));return Ie.source=q.source,Ie.code=(0,D.isString)(q.code)?q.code:(Le=q.code)===null||Le===void 0?void 0:Le.value,Ie.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Ie.tags=q.tags&&(0,_.coalesce)(q.tags.map(u.to)),Ie}ue.to=ae})(b=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function Se(q){return Object.assign(Object.assign({},m.from(q.location.range)),{message:q.message,resource:q.location.uri})}ue.from=Se;function ae(q){return new o.DiagnosticRelatedInformation(new o.Location(q.resource,m.to(q)),q.message)}ue.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ue){function Se(q){switch(q){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ue.from=Se;function ae(q){switch(q){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}ue.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(ue){function Se(q){return typeof q=="number"&&q>=o.ViewColumn.One?q-1:q===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ue.from=Se;function ae(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ae})(a=e.ViewColumn||(e.ViewColumn={}));function s(ue){return typeof ue.range!="undefined"}function c(ue){return ue.length===0?!0:!!s(ue[0])}e.isDecorationOptionsArr=c;var l;(function(ue){function Se(et){return et.map(ue.from)}ue.fromMany=Se;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function q(et){let ct;if(ae(et)){const{language:ot,value:vt}=et;ct={value:"```"+ot+`
`+vt+"\n```\n"}}else o.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const rt=Object.create(null);ct.uris=rt;const Ge=ot=>{try{let vt=y.URI.parse(ot,!0);vt=vt.with({query:Le(vt.query,rt)}),rt[ot]=vt}catch(vt){}return""},ht=new A.Renderer;return ht.link=Ge,ht.image=ot=>Ge(k.parseHrefAndDimensions(ot).href),A(ct.value,{renderer:ht}),ct}ue.from=q;function Le(et,ct){if(!et)return et;let rt;try{rt=(0,T.parse)(et)}catch(ht){}if(!rt)return et;let Ge=!1;return rt=(0,S.cloneAndChange)(rt,ht=>{if(y.URI.isUri(ht)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ot]=ht,Ge=!0,ot}else return}),Ge?JSON.stringify(rt):et}function Ie(et){const ct=new o.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}ue.to=Ie;function Xe(et){if(!!et)return typeof et=="string"?et:ue.from(et)}ue.fromStrict=Xe})(l=e.MarkdownString||(e.MarkdownString={}));function h(ue){return c(ue)?ue.map(Se=>({range:m.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?l.fromMany(Se.hoverMessage):Se.hoverMessage?l.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):ue.map(Se=>({range:m.from(Se)}))}e.fromRangeOrRangeWithMessage=h;function P(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?y.URI.file(ue):ue}e.pathOrURIToURI=P;var g;(function(ue){function Se(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?P(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ue.from=Se})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(ue){function Se(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?g.from(ae.before):void 0,after:ae.after?g.from(ae.after):void 0}}ue.from=Se})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ue){function Se(ae){if(typeof ae=="undefined")return ae;switch(ae){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=Se})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ue){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?w.from(ae.light):void 0,dark:ae.dark?w.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?g.from(ae.before):void 0,after:ae.after?g.from(ae.after):void 0}}ue.from=Se})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(ue){function Se(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:m.from(q.range)}}ue.from=Se;function ae(q){const Le=new o.TextEdit(m.to(q.range),q.text);return Le.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Le}ue.to=ae})(V=e.TextEdit||(e.TextEdit={}));var he;(function(ue){function Se(q,Le,Ie){var Xe,et,ct;const rt={edits:[]};if(q instanceof o.WorkspaceEdit)for(let Ge of q._allEntries())if(Ge._type===1)rt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const ht=Le==null?void 0:Le.getDocument(Ge.uri);rt.edits.push({_type:2,resource:Ge.uri,edit:V.from(Ge.edit),modelVersionId:ht==null?void 0:ht.version,metadata:Ge.metadata})}else Ge._type===3?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:(Xe=Ie==null?void 0:Ie.lookupNotebookDocument(Ge.uri))===null||Xe===void 0?void 0:Xe.notebookDocument.version}):Ge._type===4?(Ge.newOutputs&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:2,index:Ge.index,append:Ge.append,outputs:Ge.newOutputs.map(Ve.from)}}),Ge.newMetadata&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:11,index:Ge.index,metadata:Ge.newMetadata}})):Ge._type===5?rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:(et=Ie==null?void 0:Ie.lookupNotebookDocument(Ge.uri))===null||et===void 0?void 0:et.notebookDocument.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(fe.from)}}):Ge._type===6&&rt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:{editType:10,outputId:Ge.outputId,items:((ct=Ge.newOutputItems)===null||ct===void 0?void 0:ct.map(Ee.from))||[],append:Ge.append}});return rt}ue.from=Se;function ae(q){const Le=new o.WorkspaceEdit;for(const Ie of q.edits)Ie.edit?Le.replace(y.URI.revive(Ie.resource),m.to(Ie.edit.range),Ie.edit.text):Le.renameFile(y.URI.revive(Ie.oldUri),y.URI.revive(Ie.newUri),Ie.options);return Le}ue.to=ae})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ue){const Se=Object.create(null);Se[o.SymbolKind.File]=0,Se[o.SymbolKind.Module]=1,Se[o.SymbolKind.Namespace]=2,Se[o.SymbolKind.Package]=3,Se[o.SymbolKind.Class]=4,Se[o.SymbolKind.Method]=5,Se[o.SymbolKind.Property]=6,Se[o.SymbolKind.Field]=7,Se[o.SymbolKind.Constructor]=8,Se[o.SymbolKind.Enum]=9,Se[o.SymbolKind.Interface]=10,Se[o.SymbolKind.Function]=11,Se[o.SymbolKind.Variable]=12,Se[o.SymbolKind.Constant]=13,Se[o.SymbolKind.String]=14,Se[o.SymbolKind.Number]=15,Se[o.SymbolKind.Boolean]=16,Se[o.SymbolKind.Array]=17,Se[o.SymbolKind.Object]=18,Se[o.SymbolKind.Key]=19,Se[o.SymbolKind.Null]=20,Se[o.SymbolKind.EnumMember]=21,Se[o.SymbolKind.Struct]=22,Se[o.SymbolKind.Event]=23,Se[o.SymbolKind.Operator]=24,Se[o.SymbolKind.TypeParameter]=25;function ae(Le){return typeof Se[Le]=="number"?Se[Le]:6}ue.from=ae;function q(Le){for(const Ie in Se)if(Se[Ie]===Le)return Number(Ie);return o.SymbolKind.Property}ue.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var W;(function(ue){function Se(q){switch(q){case o.SymbolTag.Deprecated:return 1}}ue.from=Se;function ae(q){switch(q){case 1:return o.SymbolTag.Deprecated}}ue.to=ae})(W=e.SymbolTag||(e.SymbolTag={}));var J;(function(ue){function Se(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(W.from),containerName:q.containerName,location:U.from(q.location)}}ue.from=Se;function ae(q){const Le=new o.SymbolInformation(q.name,z.to(q.kind),q.containerName,U.to(q.location));return Le.tags=q.tags&&q.tags.map(W.to),Le}ue.to=ae})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ue){function Se(q){var Le,Ie;const Xe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:m.from(q.range),selectionRange:m.from(q.selectionRange),kind:z.from(q.kind),tags:(Ie=(Le=q.tags)===null||Le===void 0?void 0:Le.map(W.from))!==null&&Ie!==void 0?Ie:[]};return q.children&&(Xe.children=q.children.map(Se)),Xe}ue.from=Se;function ae(q){const Le=new o.DocumentSymbol(q.name,q.detail,z.to(q.kind),m.to(q.range),m.to(q.selectionRange));return(0,_.isNonEmptyArray)(q.tags)&&(Le.tags=q.tags.map(W.to)),q.children&&(Le.children=q.children.map(ae)),Le}ue.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(ue){function Se(ae){const q=new o.CallHierarchyItem(z.to(ae.kind),ae.name,ae.detail||"",y.URI.revive(ae.uri),m.to(ae.range),m.to(ae.selectionRange));return q._sessionId=ae._sessionId,q._itemId=ae._itemId,q}ue.to=Se})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(ue){function Se(ae){return new o.CallHierarchyIncomingCall(F.to(ae.from),ae.fromRanges.map(q=>m.to(q)))}ue.to=Se})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var B;(function(ue){function Se(ae){return new o.CallHierarchyOutgoingCall(F.to(ae.to),ae.fromRanges.map(q=>m.to(q)))}ue.to=Se})(B=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(ue){function Se(q){return{range:q.range&&m.from(q.range),uri:q.uri}}ue.from=Se;function ae(q){return new o.Location(y.URI.revive(q.uri),m.to(q.range))}ue.to=ae})(U=e.location||(e.location={}));var Q;(function(ue){function Se(q){const Le=q,Ie=q;return{originSelectionRange:Le.originSelectionRange?m.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ie.uri,range:m.from(Le.targetRange?Le.targetRange:Ie.range),targetSelectionRange:Le.targetSelectionRange?m.from(Le.targetSelectionRange):void 0}}ue.from=Se;function ae(q){return{targetUri:y.URI.revive(q.uri),targetRange:m.to(q.range),targetSelectionRange:q.targetSelectionRange?m.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?m.to(q.originSelectionRange):void 0}}ue.to=ae})(Q=e.DefinitionLink||(e.DefinitionLink={}));var Z;(function(ue){function Se(q){return{range:m.from(q.range),contents:l.fromMany(q.contents)}}ue.from=Se;function ae(q){return new o.Hover(q.contents.map(l.to),m.to(q.range))}ue.to=ae})(Z=e.Hover||(e.Hover={}));var ne;(function(ue){function Se(q){return{range:m.from(q.range),expression:q.expression}}ue.from=Se;function ae(q){return new o.EvaluatableExpression(m.to(q.range),q.expression)}ue.to=ae})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(ue){function Se(q){if(q instanceof o.InlineValueText)return{type:"text",range:m.from(q.range),text:q.text};if(q instanceof o.InlineValueVariableLookup)return{type:"variable",range:m.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=Se;function ae(q){switch(q.type){case"text":return{range:m.to(q.range),text:q.text};case"variable":return{range:m.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:m.to(q.range),expression:q.expression}}}ue.to=ae})(pe=e.InlineValue||(e.InlineValue={}));var Pe;(function(ue){function Se(q){return{frameId:q.frameId,stoppedLocation:m.from(q.stoppedLocation)}}ue.from=Se;function ae(q){return new o.InlineValueContext(q.frameId,m.to(q.stoppedLocation))}ue.to=ae})(Pe=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(ue){function Se(q){return{range:m.from(q.range),kind:q.kind}}ue.from=Se;function ae(q){return new o.DocumentHighlight(m.to(q.range),q.kind)}ue.to=ae})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(ue){function Se(ae){switch(ae){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}ue.to=Se})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(ue){function Se(ae){return{triggerKind:Te.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ue.to=Se})(xe=e.CompletionContext||(e.CompletionContext={}));var $;(function(ue){function Se(q){switch(q){case o.CompletionItemTag.Deprecated:return 1}}ue.from=Se;function ae(q){switch(q){case 1:return o.CompletionItemTag.Deprecated}}ue.to=ae})($=e.CompletionItemTag||(e.CompletionItemTag={}));var G;(function(ue){const Se=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ae(Ie){var Xe;return(Xe=Se.get(Ie))!==null&&Xe!==void 0?Xe:9}ue.from=ae;const q=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Le(Ie){var Xe;return(Xe=q.get(Ie))!==null&&Xe!==void 0?Xe:o.CompletionItemKind.Property}ue.to=Le})(G=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(ue){function Se(ae,q){var Le;const Ie=new o.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Ie.label2=ae.label),Ie.insertText=ae.insertText,Ie.kind=G.to(ae.kind),Ie.tags=(Le=ae.tags)===null||Le===void 0?void 0:Le.map($.to),Ie.detail=ae.detail,Ie.documentation=k.isMarkdownString(ae.documentation)?l.to(ae.documentation):ae.documentation,Ie.sortText=ae.sortText,Ie.filterText=ae.filterText,Ie.preselect=ae.preselect,Ie.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?Ie.range=m.to(ae.range):typeof ae.range=="object"&&(Ie.range={inserting:m.to(ae.range.insert),replacing:m.to(ae.range.replace)}),Ie.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ie.insertText=new o.SnippetString(ae.insertText):(Ie.insertText=ae.insertText,Ie.textEdit=Ie.range instanceof o.Range?new o.TextEdit(Ie.range,Ie.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ie.additionalTextEdits=ae.additionalTextEdits.map(Xe=>V.to(Xe))),Ie.command=q&&ae.command?q.fromInternal(ae.command):void 0,Ie}ue.to=Se})(ie=e.CompletionItem||(e.CompletionItem={}));var oe;(function(ue){function Se(q){return{label:q.label,documentation:q.documentation?l.fromStrict(q.documentation):void 0}}ue.from=Se;function ae(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?l.to(q.documentation):q.documentation}}ue.to=ae})(oe=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ue){function Se(q){return{label:q.label,documentation:q.documentation?l.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.from):[],activeParameter:q.activeParameter}}ue.from=Se;function ae(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?l.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.to):[],activeParameter:q.activeParameter}}ue.to=ae})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(ue){function Se(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(me.from):[]}}ue.from=Se;function ae(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(me.to):[]}}ue.to=ae})(De=e.SignatureHelp||(e.SignatureHelp={}));var Ne;(function(ue){function Se(q){var Le;return{text:q.text,range:m.from(q.range),kind:ge.from((Le=q.kind)!==null&&Le!==void 0?Le:o.InlineHintKind.Other),description:q.description&&l.fromStrict(q.description),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ue.from=Se;function ae(q){const Le=new o.InlineHint(q.text,m.to(q.range),ge.to(q.kind));return Le.whitespaceAfter=q.whitespaceAfter,Le.whitespaceBefore=q.whitespaceBefore,Le.description=k.isMarkdownString(q.description)?l.to(q.description):q.description,Le}ue.to=ae})(Ne=e.InlineHint||(e.InlineHint={}));var ge;(function(ue){function Se(q){return q}ue.from=Se;function ae(q){return q}ue.to=ae})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ue){function Se(q){return{range:m.from(q.range),url:q.target,tooltip:q.tooltip}}ue.from=Se;function ae(q){let Le;if(q.url)try{Le=typeof q.url=="string"?y.URI.parse(q.url,!0):y.URI.revive(q.url)}catch(Ie){}return new o.DocumentLink(m.to(q.range),Le)}ue.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(ue){function Se(q){const Le=new o.ColorPresentation(q.label);return q.textEdit&&(Le.textEdit=V.to(q.textEdit)),q.additionalTextEdits&&(Le.additionalTextEdits=q.additionalTextEdits.map(Ie=>V.to(Ie))),Le}ue.to=Se;function ae(q){return{label:q.label,textEdit:q.textEdit?V.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Le=>V.from(Le)):void 0}}ue.from=ae})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(ue){function Se(q){return new o.Color(q[0],q[1],q[2],q[3])}ue.to=Se;function ae(q){return[q.red,q.green,q.blue,q.alpha]}ue.from=ae})(Be=e.Color||(e.Color={}));var _e;(function(ue){function Se(q){return{range:m.from(q.range)}}ue.from=Se;function ae(q){return new o.SelectionRange(m.to(q.range))}ue.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ue){function Se(ae){switch(ae){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}ue.to=Se})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(ue){function Se(q){switch(q){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=Se;function ae(q){switch(q){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}ue.to=ae})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ue){function Se(q){if(q===o.EndOfLine.CRLF)return 1;if(q===o.EndOfLine.LF)return 0}ue.from=Se;function ae(q){if(q===1)return o.EndOfLine.CRLF;if(q===0)return o.EndOfLine.LF}ue.to=ae})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ue){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=Se})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(ue){function Se(ae){const q={start:ae.start+1,end:ae.end+1};return ae.kind&&(q.kind=He.from(ae.kind)),q}ue.from=Se})(Ue=e.FoldingRange||(e.FoldingRange={}));var He;(function(ue){function Se(ae){if(ae)switch(ae){case o.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ue.from=Se})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(ue){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?m.from(ae.selection):void 0,override:typeof ae.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ue.from=Se})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ue){function Se(q){return q instanceof o.RelativePattern||typeof q=="string"?q:ae(q)?new o.RelativePattern(q.base,q.pattern):q}ue.from=Se;function ae(q){const Le=q;return Le&&typeof Le.base=="string"&&typeof Le.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var H;(function(ue){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const q=ae;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ye.from(q.pattern),exclusive:q.exclusive}}}else return}ue.from=Se})(H=e.LanguageSelector||(e.LanguageSelector={}));var se;(function(ue){function Se(q){return{start:q.start,end:q.end}}ue.from=Se;function ae(q){return new o.NotebookRange(q.start,q.end)}ue.to=ae})(se=e.NotebookRange||(e.NotebookRange={}));var de;(function(ue){function Se(ae){return new o.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ue.to=Se})(de=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var K;(function(ue){function Se(q){return q}ue.from=Se;function ae(q){return new o.NotebookDocumentMetadata().with(q)}ue.to=ae})(K=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ee;(function(ue){function Se(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ue.to=Se;function ae(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}ue.from=ae})(ee=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var le;(function(ue){function Se(q){switch(q){case o.NotebookCellKind.Markdown:return f.CellKind.Markdown;case o.NotebookCellKind.Code:default:return f.CellKind.Code}}ue.from=Se;function ae(q){switch(q){case f.CellKind.Markdown:return o.NotebookCellKind.Markdown;case f.CellKind.Code:default:return o.NotebookCellKind.Code}}ue.to=ae})(le=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ue){function Se(q){var Le;return{cellKind:le.from(q.kind),language:q.language,source:q.source,metadata:Object.assign(Object.assign({},q.metadata),ee.from((Le=q.latestExecutionSummary)!==null&&Le!==void 0?Le:{})),outputs:q.outputs?q.outputs.map(Ve.from):[]}}ue.from=Se;function ae(q){return new o.NotebookCellData(le.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(Ve.to):void 0,q.metadata?de.to(q.metadata):void 0)}ue.to=ae})(fe=e.NotebookCellData||(e.NotebookCellData={}));var Ee;(function(ue){function Se(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}ue.from=Se;function ae(q){return new o.NotebookCellOutputItem(q.mime,q.value,q.metadata)}ue.to=ae})(Ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ve;(function(ue){function Se(q){return{outputId:q.id,outputs:q.outputs.map(Ee.from),metadata:q.metadata}}ue.from=Se;function ae(q){const Le=q.outputs.map(Ee.to);return new o.NotebookCellOutput(Le,q.outputId,q.metadata)}ue.to=ae})(Ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Fe;(function(ue){function Se(Ie){if(Ie!=null){if(Ie instanceof o.RelativePattern||typeof Ie=="string")return Ie;if(Le(Ie))return new o.RelativePattern(Ie.base,Ie.pattern);if(q(Ie))return{include:Ye.from(Ie.include)||void 0,exclude:Ye.from(Ie.exclude)||void 0}}}ue.from=Se;function ae(Ie){return typeof Ie=="string"?Ie:Le(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}ue.to=ae;function q(Ie){const Xe=Ie,et=Ye.from(Xe.include);if(!(et&&et instanceof o.RelativePattern||typeof et=="string"))return!1;const ct=Ye.from(Xe.exclude);return!!(ct&&ct instanceof o.RelativePattern||typeof ct=="string")}function Le(Ie){const Xe=Ie;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(Fe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(ue){function Se(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?g.from(ae.top):void 0}}ue.from=Se})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(ue){function Se(ae,q,Le){const Ie=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Ie,Le),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ue.from=Se})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(ue){function Se(ae){var q,Le,Ie;return{transientOutputs:(q=ae==null?void 0:ae.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:Object.assign(Object.assign({},(Le=ae==null?void 0:ae.transientCellMetadata)!==null&&Le!==void 0?Le:ae==null?void 0:ae.transientMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Ie=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Ie!==void 0?Ie:{}}}ue.from=Se})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var at;(function(ue){function Se(q){var Le;return{uri:q.uri,provides:typeof q.provides=="string"?[q.provides]:(Le=q.provides)!==null&&Le!==void 0?Le:[]}}ue.from=Se;function ae(q){return{uri:y.URI.revive(q.uri),provides:q.provides}}ue.to=ae})(at=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var Ze;(function(ue){function Se(q){return{message:l.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?U.from(q.location):void 0}}ue.from=Se;function ae(q){const Le=new o.TestMessage(typeof q.message=="string"?q.message:l.to(q.message));return Le.severity=q.severity,Le.actualOutput=q.actualOutput,Le.expectedOutput=q.expectedOutput,Le}ue.to=ae})(Ze=e.TestMessage||(e.TestMessage={}));var nt;(function(ue){function Se(Ie){var Xe,et;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range),debuggable:(Xe=Ie.debuggable)!==null&&Xe!==void 0?Xe:!1,description:Ie.description,runnable:(et=Ie.runnable)!==null&&et!==void 0?et:!0}}ue.from=Se;function ae(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range),debuggable:!1,description:Ie.description,runnable:!0}}ue.fromResultSnapshot=ae;function q(Ie){return{id:Ie.extId,label:Ie.label,uri:y.URI.revive(Ie.uri),range:m.to(Ie.range),addChild:()=>{},dispose:()=>{},status:o.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}ue.toPlain=q;function Le(Ie){const Xe=new o.TestItemImpl(Ie.extId,Ie.label,y.URI.revive(Ie.uri),void 0);return Xe.range=m.to(Ie.range),Xe.debuggable=Ie.debuggable,Xe.description=Ie.description,Xe.runnable=Ie.runnable,Xe}ue.to=Le})(nt=e.TestItem||(e.TestItem={}));var dt;(function(ue){const Se=(q,Le)=>Object.assign(Object.assign({},nt.toPlain(q.item)),{taskStates:q.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(Ze.to)})),children:q.children.map(Ie=>Le.get(Ie)).filter(D.isDefined).map(Ie=>Se(Ie,Le))});function ae(q){const Le=[],Ie=new Map;for(const Xe of q.items)Ie.set(Xe.item.extId,Xe),Xe.direct&&Le.push(Xe);return{completedAt:q.completedAt,results:Le.map(Xe=>Se(Xe,Ie))}}ue.to=ae})(dt=e.TestResults||(e.TestResults={}));var wt;(function(ue){function Se(ae){switch(ae){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}ue.to=Se})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[176],we([0,1,2,11,7,9,45]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,i,I,d={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=d,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,d)=>{const r={dispose:this._callbacks.push([i,I,C])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(C,i){const I=_.URI.revive(C);let d=!1;const f=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let o of[...this._callbacks]){if(d)break;const v=this._documents.getDocument(I),m=await this._deliverEventAsyncAndBlameBadListeners(o,{document:v,reason:T.TextDocumentSaveReason.to(i)});r.push(m)}}finally{clearTimeout(f)}return r}_deliverEventAsyncAndBlameBadListeners([C,i,I],d){const f=this._badListeners.get(C);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(C);this._badListeners.set(C,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,d){const f=[],r=Date.now(),{document:o,reason:v}=d,{version:m}=o,E=Object.freeze({document:o,reason:v,waitUntil(p){if(Object.isFrozen(f))throw(0,k.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(p))}});try{i.apply(I,[E])}catch(p){return Promise.reject(p)}return Object.freeze(f),new Promise((p,u)=>{const b=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(b),p(t)}).catch(t=>{clearTimeout(b),u(t)})}).then(p=>{const u={edits:[]};for(const b of p)if(Array.isArray(b)&&b.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:a}of b)u.edits.push({_type:2,resource:o.uri,edit:{range:a&&T.Range.from(a),text:t,eol:n&&T.EndOfLine.from(n)}});if(u.edits.length!==0)return m===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(be[177],we([0,1,3,14,28,2,9,7]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(I,d,f,r,o){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,f&&(this._config+=1),r&&(this._config+=2),o&&(this._config+=4);const v=(0,A.parse)(d),m=I(E=>{if(!f)for(let p of E.created){const u=T.URI.revive(p);v(u.fsPath)&&this._onDidCreate.fire(u)}if(!r)for(let p of E.changed){const u=T.URI.revive(p);v(u.fsPath)&&this._onDidChange.fire(u)}if(!o)for(let p of E.deleted){const u=T.URI.revive(p);v(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,d,f){this._logService=d,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,d,f,r){return new y(this._onFileSystemEvent.event,I,d,f,r)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,d){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(f=>({oldUri:T.URI.revive(f.source),newUri:T.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(f=>T.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(f=>T.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,d){return(f,r,o)=>{const v=function(E){f.call(r,E)};return v.extension=I,d.event(v,void 0,o)}}async $onWillRunFileOperation(I,d,f,r){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(o=>({oldUri:T.URI.revive(o.source),newUri:T.URI.revive(o.target)}))},f,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(o=>T.URI.revive(o.target))},f,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(o=>T.URI.revive(o.target))},f,r)}}async _fireWillEvent(I,d,f,r){const o=new Set,v=[];if(await I.fireAsync(d,r,async(E,p)=>{var u;const b=Date.now(),t=await Promise.resolve(E);t instanceof D.WorkspaceEdit&&(v.push(t),o.add((u=p.extension.displayName)!==null&&u!==void 0?u:p.extension.identifier.value)),Date.now()-b>f&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),!r.isCancellationRequested&&v.length!==0){const m={edits:[]};for(let E of v){let{edits:p}=S.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(p)}return{edit:m,extensionNames:Array.from(o)}}}}e.ExtHostFileSystemEventService=C}),define(be[178],we([0,1,18,24,2,9,7,73]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(d,f,r,o){this.start=d,this.deletedCount=f,this.deletedItems=r,this.items=o}static asApiEvents(d){return d.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(r=>r.cell)}))}}class C{constructor(d,f,r){var o;this._notebook=d,this._extHostDocument=f,this._cellData=r,this.handle=r.handle,this.uri=A.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(o=r.metadata)!==null&&o!==void 0?o:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const d=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.notebookDocument,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._cell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,f,r){const o=r.map(T.NotebookCellOutputItem.to),v=this._outputs.find(m=>m.id===d);v&&(f||(v.outputs.length=0),v.outputs.push(...o))}setMetadata(d){this._internalMetadata=d,this._metadata=T.NotebookCellMetadata.to(d),this._previousResult=T.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=C;class i{constructor(d,f,r,o,v,m,E){this._proxy=d,this._textDocumentsAndEditors=f,this._textDocuments=r,this._emitter=o,this._viewType=v,this._metadata=m,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get notebookDocument(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===_.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(f){return f=d._validateIndex(f),d._cells[f].cell},getCells(f){return(f?d._getCells(f):d._cells).map(o=>o.cell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,f){this._versionId=d.versionId,this._isDirty=f;for(const r of d.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){return d.start<0&&(d=d.with({start:0})),d.end>this._cells.length&&(d=d.with({end:this._cells.length})),d}_getCells(d){d=this._validateRange(d);const f=[];for(let r=d.start;r<d.end;r++)f.push(this._cells[r]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,f){if(!this._disposed){const r=[],o=[],v=[];d.reverse().forEach(m=>{const p=m[2].map(t=>{const n=new C(this,this._textDocumentsAndEditors,t);return f||o.push(C.asModelAddData(this.notebookDocument,t)),n}),u=new y(m[0],m[1],[],p),b=this._cells.splice(m[0],m[1],...p);for(let t of b)v.push(t.uri),u.deletedItems.push(t.cell);r.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:v}),f||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(r)}))}}_moveCell(d,f){const r=this._cells.splice(d,1);this._cells.splice(f,0,...r);const o=[new y(d,1,r.map(v=>v.cell),[]),new y(f,0,[],r)];this._emitter.emitModelChange((0,k.deepFreeze)({document:this.notebookDocument,changes:y.asApiEvents(o)}))}_setCellOutputs(d,f){const r=this._cells[d];r.setOutputs(f),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.notebookDocument,cells:[r.cell]}))}_setCellOutputItems(d,f,r,o){const v=this._cells[d];v.setOutputItems(f,r,o),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.notebookDocument,cells:[v.cell]}))}_changeCellLanguage(d,f){const r=this._cells[d];r.cell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(r.uri,f)}_changeCellMetadata(d,f){var r;const o=this._cells[d],v=o.internalMetadata,m=o.cell.metadata;o.setMetadata(f);const E=o.cell.metadata;if((0,k.equals)(m,E)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.notebookDocument,cell:o.cell})),v.runState!==f.runState){const p=(r=f.runState)!==null&&r!==void 0?r:S.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,k.deepFreeze)({document:this.notebookDocument,cell:o.cell,executionState:p}))}}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(f=>f.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(be[179],we([0,1,7,9]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:y})}replaceCellOutput(D,y){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:D,outputs:y.map(C=>k.NotebookCellOutput.from(C))})}replaceCells(D,y,C){this._throwIfFinalized(),!(D===y&&C.length===0)&&this._collectedEdits.push({editType:1,index:D,count:y-D,cells:C.map(k.NotebookCellData.from)})}}class T{constructor(D,y,C,i,I,d){this.id=D,this._proxy=y,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.notebookDocument},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(y,C){D._proxy.$tryRevealRange(D.id,k.NotebookRange.from(y),C!=null?C:_.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(y){const C=new A(this.document.version);return y(C),D._applyEdit(C.finalize())},get kernel(){return D._kernel},setDecorations(y,C){return D.setDecorations(y,C)}}}return this._editor}_acceptKernel(D){this._kernel=D}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const y=[];let C=-1;for(let i=0;i<D.cellEdits.length;i++){if(C<0){y.push(D.cellEdits[i]),C++;continue}const d=y[C],f=D.cellEdits[i];if(d.editType===1&&f.editType===1&&d.index===f.index){d.cells.push(...D.cellEdits[i].cells),d.count+=D.cellEdits[i].count;continue}y.push(D.cellEdits[i]),C++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,y)}setDecorations(D,y){if(!(y.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return y.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(y),D.key)}}e.ExtHostNotebookEditor=T}),define(be[180],we([0,1,9,153,133,20,53]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,d,f){const r=this._handles++,{title:o,location:v,cancellable:m}=d,E={label:(0,A.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(r,{location:_.ProgressLocation.from(v),title:o,source:E,cancellable:m},I),this._withProgress(r,f,!!m)}_withProgress(I,d,f){let r;f&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,r));const o=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let v;try{v=d(new C(this._proxy,I),f&&r?r.token:T.CancellationToken.None)}catch(m){throw o(I),m}return v.then(m=>o(I),m=>o(I)),v}$acceptProgressCanceled(I){const d=this._mapHandleToCancellationSource.get(I);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function y(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class C extends k.Progress{constructor(I,d){super(f=>this.throttledReport(f));this._proxy=I,this._handle=d}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}je([(0,S.throttle)(100,(i,I)=>y(i,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(be[97],we([0,1,42,11,55,9,7]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(d,f){const r=D._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new A.IdGenerator("TextEditorDecorationType");class y{constructor(d,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,f){this._throwIfFinalized();let r=null;if(d instanceof S.Position)r=new S.Range(d,d);else if(d instanceof S.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,f,!1)}insert(d,f){this._throwIfFinalized(),this._pushEdit(new S.Range(d,d),f,!0)}delete(d){this._throwIfFinalized();let f=null;if(d instanceof S.Range)f=d;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(d,f,r){const o=this._document.validateRange(d);this._collectedEdits.push({range:o,text:f,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==S.EndOfLine.LF&&d!==S.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=y;class C{constructor(d,f,r,o){this._proxy=d,this._id=f,this._accept(r),this._logService=o;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(m){v._setTabSize(m)},get insertSpaces(){return v._insertSpaces},set insertSpaces(m){v._setInsertSpaces(m)},get cursorStyle(){return v._cursorStyle},set cursorStyle(m){v._setCursorStyle(m)},get lineNumbers(){return v._lineNumbers},set lineNumbers(m){v._setLineNumbers(m)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const f=Math.floor(d);return f>0?f:null}if(typeof d=="string"){const f=parseInt(d,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(d){const f=this._validateTabSize(d);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const f=this._validateInsertSpaces(d);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const f={};let r=!1;if(typeof d.tabSize!="undefined"){const o=this._validateTabSize(d.tabSize);o==="auto"?(r=!0,f.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,r=!0,f.tabSize=o)}if(typeof d.insertSpaces!="undefined"){const o=this._validateInsertSpaces(d.insertSpaces);o==="auto"?(r=!0,f.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,r=!0,f.insertSpaces=o)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,f.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(d){d.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=C;class i{constructor(d,f,r,o,v,m,E,p){this.id=d,this._proxy=f,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new C(this._proxy,this.id,m,r),this._visibleRanges=E,this._viewColumn=p;const u=this;this.value=Object.freeze({get document(){return o.getValue()},set document(b){throw(0,k.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(b){if(!(b instanceof S.Selection))throw(0,k.illegalArgument)("selection");u._selections=[b],u._trySetSelection()},get selections(){return u._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof S.Selection)))throw(0,k.illegalArgument)("selections");u._selections=b,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(b){throw(0,k.readonly)("visibleRanges")},get options(){return u._options.value},set options(b){u._disposed||u._options.assign(b)},get viewColumn(){return u._viewColumn},set viewColumn(b){throw(0,k.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new y(o.getValue(),t);return b(n),u._applyEdit(n)},insertSnippet(b,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=u._selections.map(s=>T.Range.from(s));else if(t instanceof S.Position){const{lineNumber:s,column:c}=T.Position.from(t);a=[{startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c}]}else if(t instanceof S.Range)a=[T.Range.from(t)];else{a=[];for(const s of t)if(s instanceof S.Range)a.push(T.Range.from(s));else{const{lineNumber:c,column:l}=T.Position.from(s);a.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return f.$tryInsertSnippet(d,b.value,a,n)},setDecorations(b,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(b.key)||(n?u._hasDecorationsForKey.delete(b.key):u._hasDecorationsForKey.add(b.key),u._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return f.$trySetDecorations(d,b.key,T.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let s=0,c=t.length;s<c;s++){const l=t[s];a[4*s]=l.start.line+1,a[4*s+1]=l.start.character+1,a[4*s+2]=l.end.line+1,a[4*s+3]=l.end.character+1}return f.$trySetDecorationsFast(d,b.key,a)}}))},revealRange(b,t){u._runOnProxy(()=>f.$tryRevealRange(d,T.Range.from(b),t||S.TextEditorRevealType.Default))},show(b){f.$tryShowEditor(d,T.ViewColumn.from(b))},hide(){f.$tryHideEditor(d)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,_.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,_.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,_.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,_.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const f=d.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const r=f.edits.map(v=>v.range);r.sort((v,m)=>v.end.line===m.end.line?v.end.character===m.end.character?v.start.line===m.start.line?v.start.character-m.start.character:v.start.line-m.start.line:v.end.character-m.end.character:v.end.line-m.end.line);for(let v=0,m=r.length-1;v<m;v++){const E=r[v].end;if(r[v+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=f.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,o,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=i}),define(be[181],we([0,1,136,25,2,3,6,14,7,10,12,9,20]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(v,m){if((0,C.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let E;return Array.isArray(v.highlights)&&(E=v.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),E=E.length?E:void 0),{label:v.label,highlights:E}}}class r{constructor(m,E,p){this._proxy=m,this.commands=E,this.logService=p,this.treeViews=new Map;function u(b){return b&&b.$treeViewId&&b.$treeItemHandle}E.registerArgumentProcessor({processArgument:b=>u(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(t=>u(t)?this.convertArgument(t):t):b})}registerTreeDataProvider(m,E,p){const u=this.createTreeView(m,{treeDataProvider:E},p);return{dispose:()=>u.dispose()}}createTreeView(m,E,p){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany}),b=this.createExtHostTreeView(m,E,p);return{get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get message(){return b.message},set message(t){b.message=t},get title(){return b.title},set title(t){b.title=t},get description(){return b.description},set description(t){b.description=t},reveal:(t,n)=>b.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(m),b.dispose()}}}$getChildren(m,E){const p=this.treeViews.get(m);return p?p.getChildren(E):Promise.reject(new Error((0,_.localize)(0,null,m)))}async $hasResolve(m){const E=this.treeViews.get(m);if(!E)throw new Error((0,_.localize)(1,null,m));return E.hasResolve}$resolve(m,E,p){const u=this.treeViews.get(m);if(!u)throw new Error((0,_.localize)(2,null,m));return u.resolveTreeItem(E,p)}$setExpanded(m,E,p){const u=this.treeViews.get(m);if(!u)throw new Error((0,_.localize)(3,null,m));u.setExpanded(E,p)}$setSelection(m,E){const p=this.treeViews.get(m);if(!p)throw new Error((0,_.localize)(4,null,m));p.setSelection(E)}$setVisible(m,E){const p=this.treeViews.get(m);if(!p)throw new Error((0,_.localize)(5,null,m));p.setVisible(E)}createExtHostTreeView(m,E,p){const u=new o(m,E,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(m,u),u}convertArgument(m){const E=this.treeViews.get(m.$treeViewId);return E?E.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class o extends S.Disposable{constructor(m,E,p,u,b,t){super();if(this.viewId=m,this.proxy=p,this.commands=u,this.logService=b,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const c of t.contributes.views[s])c.id===m&&(this._title=c.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,a;this._register(T.Event.debounce(this._onDidChangeData.event,(s,c)=>(s||(s={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(l=>a=l),this.refreshPromise=this.refreshPromise.then(()=>n)),s.elements.push(c.element)),c.message&&(s.message=!0),s),200,!0)(({message:s,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const l=a;return n=null,this.refresh(c).then(()=>l())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,C.isUndefinedOrNull)(m))}getChildren(m){const E=m?this.getExtensionElement(m):void 0;if(m&&!E)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(m);return(p?Promise.resolve(p):this.fetchChildrenNodes(E)).then(u=>u.map(b=>b.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,E){E=E||{select:!0,focus:!1};const p=(0,C.isUndefinedOrNull)(E.select)?!0:E.select,u=(0,C.isUndefinedOrNull)(E.focus)?!1:E.focus,b=(0,C.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(a=>a.item)},{select:p,focus:u,expand:b})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:u,expand:b})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,E){const p=this.getExtensionElement(m);p&&(E?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,E){var p;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(m);if(u){const b=this.nodes.get(u);if(b){const t=(p=await this.dataProvider.resolveTreeItem(b.extensionItem,u,E))!==null&&p!==void 0?p:b.extensionItem;return b.item.tooltip=this.getTooltip(t.tooltip),b.item.command=this.getCommand(b.disposableStore,t.command),b.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(E=>E?this.resolveUnknownParentChain(E).then(p=>this.resolveTreeNode(E,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}resolveParent(m){const E=this.nodes.get(m);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,E){const p=this.nodes.get(m);return p?Promise.resolve(p):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(u=>this.createHandle(m,u,E,!0)).then(u=>this.getChildren(E?E.item.handle:void 0).then(()=>{const b=this.getExtensionElement(u);if(b){const t=this.nodes.get(b);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(m){if(m){let E;if(typeof m=="string"){const p=this.getExtensionElement(m);E=p?this.nodes.get(p):void 0}else E=m;return E&&E.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=m?this.nodes.get(m):void 0,u=await this.dataProvider.getChildren(m);if(E.token.isCancellationRequested)return[];const b=await Promise.all((0,i.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,p):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(b)}finally{E.dispose()}}refresh(m){if(m.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(m);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const E=new Set,p=m.map(b=>this.nodes.get(b));for(const b of p)if(b&&!E.has(b.item.handle)){let t=b;for(;t&&t.parent&&p.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(b.item.handle)}const u=[];return E.forEach(b=>{const t=this.elements.get(b);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&u.push(b)}}),u}refreshHandles(m){const E={};return Promise.all(m.map(p=>this.refreshNode(p).then(u=>{u&&(E[p]=u.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(m){const E=this.getExtensionElement(m);if(E){const p=this.nodes.get(E);if(p)return this.clearChildren(E),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(u=>{if(u){const b=this.createTreeNode(E,u,p.parent);return this.updateNodeCache(E,b,p,p.parent),p.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,E,p){const u=this.createTreeNode(m,E,p);if(E.id&&this.elements.has(u.item.handle))throw new Error((0,_.localize)(6,null,E.id));return this.addNodeToCache(m,u),this.addNodeToParentCache(u,p),u}getTooltip(m){return y.MarkdownString.isMarkdownString(m)?I.MarkdownString.from(m):m}getCommand(m,E){return E?this.commands.toInternal(E,m):void 0}createTreeNode(m,E,p){const u=new S.DisposableStore,b=this.createHandle(m,E,p),t=this.getLightIconPath(E);return{item:{handle:b,parentHandle:p?p.item.handle:void 0,label:f(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(u,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,C.isUndefinedOrNull)(E.collapsibleState)?y.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(m){return m.iconPath instanceof y.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:E,label:p,resourceUri:u},b,t){if(E)return`${o.ID_HANDLE_PREFIX}/${E}`;const n=f(p,this.extension),a=b?b.item.handle:o.LABEL_HANDLE_PREFIX;let s=n?n.label:u?(0,k.basename)(u):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const c=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,l=this.getChildrenNodes(b)||[];let h,P=0;do{if(h=`${a}/${P}:${s}`,t||!this.elements.has(h)||c===h)break;P++}while(P<=l.length);return h}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return A.URI.isUri(m)?m:A.URI.file(m)}addNodeToCache(m,E){this.elements.set(E.item.handle,m),this.nodes.set(m,E)}updateNodeCache(m,E,p,u){this.elements.delete(E.item.handle),this.nodes.delete(m),E.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(m,E);const b=this.getChildrenNodes(u)||[],t=b.filter(n=>n.item.handle===p.item.handle)[0];t&&b.splice(b.indexOf(t),1,E)}addNodeToParentCache(m,E){E?(E.children||(E.children=[]),E.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const E=this.nodes.get(m);if(E){if(E.children)for(const p of E.children){const u=this.elements.get(p.item.handle);u&&this.clear(u)}E.children=void 0}}else this.clearAll()}clear(m){const E=this.nodes.get(m);if(E){if(E.children)for(const p of E.children){const u=this.elements.get(p.item.handle);u&&this.clear(u)}this.nodes.delete(m),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(be[182],we([0,1,12,14,20,10,70,9,7,96]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(v,m){if(m!==void 0){const E=this.testIdsToInternal.get(m),p=E==null?void 0:E.get(v);if(p)return[E,p]}return(0,_.mapFind)(this.testIdsToInternal.values(),E=>{const p=E.get(v);return p&&[E,p]})}createForHierarchy(v=()=>{}){return new r(this.createIdMap(d++),v)}createIdMap(v){const m=new f(v);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var I;(function(o){o[o.Disconnected=0]="Disconnected",o[o.IsChild=1]="IsChild",o[o.IsParent=2]="IsParent",o[o.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let d=0;class f{constructor(v){this.id=v,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(v){if(this.map.has(v.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${v.item.extId}`);this.map.set(v.item.extId,v),v.parent||this._roots.add(v)}has(v){return this.map.has(v)}delete(v){const m=this.map.get(v);return m?(this.map.delete(v),this._roots.delete(m),!0):!1}get(v){return this.map.get(v)}comparePositions(v,m){const E=typeof v=="string"?this.map.get(v):v,p=typeof m=="string"?this.map.get(m):m;if(!E||!p)return 0;if(E===p)return 3;for(let u=this.map.get(p.parent);u;u=this.map.get(u.parent))if(u===E)return 1;for(let u=this.map.get(E.parent);u;u=this.map.get(u.parent))if(u===p)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=f;class r{constructor(v,m){this.testIdToInternal=v,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(v,m){this.addItem(v,m,null)}getTestByReference(v){return this.testItemToInternal.get(v)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const m=this.diff[this.diff.length-1];if(m&&v[0]===1){if(m[0]===1&&m[1].extId===v[1].extId){(0,C.applyTestItemUpdate)(m[1],v[1]);return}if(m[0]===0&&m[1].item.extId===v[1].extId){(0,C.applyTestItemUpdate)(m[1],v[1]);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,m){var E;const p=this.testIdToInternal.object.get(v);if(!!p){if((p.expandLevels===void 0||m>p.expandLevels)&&(p.expandLevels=m),p.expand===1){const u=this.refreshChildren(p);return u.isSettled?this.expandChildren(p,m-1):u.p.then(()=>this.expandChildren(p,m-1))}else if(p.expand===3)return((E=p.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?p.initialExpand.p.then(()=>this.expandChildren(p,m-1)):this.expandChildren(p,m-1)}}dispose(){var v;for(const m of this.testItemToInternal.values())(v=m.discoverCts)===null||v===void 0||v.dispose(!0),(0,S.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(v,m){const E=v==null?void 0:v.actual.id;switch(m[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(v);break;case 0:this.addItem(m[1],v.src.controller,v);break;case 3:const[p,u,b]=m;switch(u){case"status":this.updateExpandability(v);break;case"range":this.pushDiff([1,{extId:E,item:{range:D.Range.from(b)}}]);break;default:this.pushDiff([1,{extId:E,item:{[u]:b}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(v,m,E){if(!(v instanceof y.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${v.id} did not`);if(this.testItemToInternal.has(v))throw new Error(`Attempted to add a single TestItem ${v.id} multiple times to the tree`);if(this.testIdToInternal.object.has(v.id))throw new Error(`Attempted to insert a duplicate test item ID ${v.id}`);const p=E?E.item.extId:null,u=v.resolveHandler?1:0,b=E==null?void 0:E.expandLevels,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:v,parent:p,item:D.TestItem.from(v),expandLevels:b?b-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(v,n),this.pushDiff([0,{parent:p,src:t,expand:u,item:n.item}]);const a=(0,S.getPrivateApiFor)(v);a.parent=E==null?void 0:E.actual,a.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const s of a.children.values())this.testItemToInternal.has(s)||this.addItem(s,m,n)}updateExpandability(v){var m;let E;v.actual.resolveHandler?v.actual.status===y.TestItemStatus.Pending?E=v.discoverCts?2:1:((m=v.initialExpand)===null||m===void 0||m.complete(),E=3):E=0,E!==v.expand&&(v.expand=E,this.pushDiff([1,{extId:v.actual.id,expand:E}]),E===1&&v.expandLevels!==void 0&&this.refreshChildren(v))}expandChildren(v,m){if(!(m<0)){const E=[...v.actual.children.values()].map(p=>this.expand(p.id,m)).filter(k.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(v){if(v.discoverCts&&v.discoverCts.dispose(!0),!v.actual.resolveHandler){const m=new k.DeferredPromise;return m.complete(),m}return v.expand=2,v.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(v),v.initialExpand=new k.DeferredPromise,v.actual.resolveHandler(v.discoverCts.token),v.initialExpand}pushExpandStateUpdate(v){this.pushDiff([1,{extId:v.actual.id,expand:v.expand}])}removeItem(v){var m;this.pushDiff([2,v.actual.id]);const E=[v];for(;E.length;){const p=E.pop();if(!!p){(m=p.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(p.item.extId),this.testItemToInternal.delete(p.actual);for(const u of p.actual.children.values())E.push(this.testIdToInternal.object.get(u.id))}}}flushDiff(){const v=this.collectDiff();v.length&&this.publishDiff(v)}}e.SingleUseTestCollection=r}),define(be[183],we([0,1,26,3,13]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class S{constructor(i){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${_.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(d=>I.add(_.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>I.has(_.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=S._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(d.map(f=>f.identifier)),I.length>0){const f=new Set;I.forEach(r=>f.add(_.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!f.has(_.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,m){this.addNode(v),this.addNode(m),this._arcs.has(v)?this._arcs.get(v).push(m):this._arcs.set(v,[m])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,m){const E=I.getArcs(v);for(let p=0;p<E.length;p++)if(!m.has(E[p]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let v of i){const m=_.ExtensionIdentifier.toKey(v.identifier);if(d.set(m,v),v.extensionDependencies)for(let E of v.extensionDependencies){const p=_.ExtensionIdentifier.toKey(E);I.addArc(m,p)}}let f=new Set;I.getNodes().filter(v=>I.getArcs(v).length===0).forEach(v=>f.add(v));let r=I.getNodes().filter(v=>!f.has(v)),o;do{o=!1;for(let v=0;v<r.length;v++){const m=r[v];I.hasOnlyGoodArcs(m,f)&&(r.splice(v,1),v--,f.add(m),o=!0)}}while(o);return r.map(v=>d.get(v))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(_.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=S;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function y(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==d)return I-d;const f=A.posix.basename(C.extensionLocation.path),r=A.posix.basename(i.extensionLocation.path);return f<r?-1:f>r?1:0}}),define(be[184],we([0,1,23]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(D){const y=_.VSBuffer.alloc(1);switch(D){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=T;function S(D,y){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(be[33],we([0,1,3,2,4,26,150]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class D{constructor(E){this.dependency=E}}e.MissingDependencyError=D;var y;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,p,u,b){this.codeLoadingTime=E,this.activateCallTime=p,this.activateResolvedTime=u,this.activationReason=b}}e.ActivationTimes=C;class i{constructor(E,p){this.description=E,this.value=p}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function d(m){m.enableProposedApi||f(m)}e.checkProposedApiEnabled=d;function f(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=f;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function o(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=o;class v{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(E,p){}_activateById(E,p){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,p,u,b,t){}_onExtensionRuntimeError(E,p){}_onExtensionHostExit(E){}}e.NullExtensionService=v}),define(be[185],we([0,1,131,26,33,19]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class D{constructor(o,v,m,E){this.startup=o,this.codeLoadingTime=v,this.activateCallTime=m,this.activateResolvedTime=E}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class y{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,v){return o===-1||v===-1?-1:v-o}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class C{constructor(o,v,m,E,p,u){this.activationFailed=o,this.activationFailedError=v,this.activationTimes=m,this.module=E,this.exports=p,this.subscriptions=u}}e.ActivatedExtension=C;class i extends C{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=i;class I extends C{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class d extends C{constructor(o){super(!0,o,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=d;let f=class{constructor(o,v,m,E,p){this._logService=p,this._registry=o,this._resolvedExtensionsSet=new Set,v.forEach(u=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,m.forEach(u=>this._hostExtensionsMap.set(k.ExtensionIdentifier.toKey(u),u)),this._host=E,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const v=k.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(v)}getActivatedExtension(o){const v=k.ExtensionIdentifier.toKey(o),m=this._activatedExtensions.get(v);if(!m)throw new Error("Extension `"+o.value+"` is not known or not activated");return m}activateByEvent(o,v){if(this._alreadyActivatedEvents[o])return S;const m=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(m.map(E=>({id:E.identifier,reason:{startup:v,extensionId:E.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,v){const m=this._registry.getExtensionDescription(o);if(!m)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:m.identifier,reason:v}])}_handleActivateRequest(o,v,m){if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(o.id))){v[k.ExtensionIdentifier.toKey(o.id)]=o;return}const E=this._registry.getExtensionDescription(o.id);if(!E){this._host.onExtensionActivationError(o.id,new A.MissingDependencyError(o.id.value));const b=new Error(`Unknown dependency '${o.id.value}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(o.id),new d(b));return}const p=typeof E.extensionDependencies=="undefined"?[]:E.extensionDependencies;let u=!0;for(let b=0,t=p.length;b<t;b++){const n=p[b];if(!this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(n))){const a=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(n));if(!(a&&!a.activationFailed)){if(a&&a.activationFailed){this._host.onExtensionActivationError(E.identifier,_.localize(0,null,E.displayName||E.identifier.value,n));const l=new Error(`Dependency ${n} failed to activate`);l.detail=a.activationFailedError,this._activatedExtensions.set(k.ExtensionIdentifier.toKey(E.identifier),new d(l));return}if(this._hostExtensionsMap.has(k.ExtensionIdentifier.toKey(n))){u=!1,v[k.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(k.ExtensionIdentifier.toKey(n)),reason:o.reason};continue}const s=this._registry.getExtensionDescription(n);if(s){u=!1,v[k.ExtensionIdentifier.toKey(n)]={id:s.identifier,reason:o.reason};continue}this._host.onExtensionActivationError(E.identifier,new A.MissingDependencyError(n));const c=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(k.ExtensionIdentifier.toKey(E.identifier),new d(c));return}}}u?v[k.ExtensionIdentifier.toKey(E.identifier)]=o:m.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(p=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(p.id))),o.length===0))return Promise.resolve(void 0);const v=Object.create(null),m=[];for(let p=0,u=o.length;p<u;p++)this._handleActivateRequest(o[p],v,m);for(let p=0,u=m.length;p<u;p++){const b=k.ExtensionIdentifier.toKey(m[p].id);v[b]&&delete v[b]}const E=Object.keys(v).map(p=>v[p]);return m.length===0?Promise.all(E.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(E).then(p=>this._activateExtensions(m))}_activateExtension(o,v){const m=k.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const E=this._activatingExtensions.get(m);if(E)return E;const p=this._host.actualActivateExtension(o,v).then(void 0,u=>(this._host.onExtensionActivationError(o,_.localize(1,null,o.value,u.message)),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(u),new d(u))).then(u=>{this._activatedExtensions.set(m,u),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,p),p}};f=je([Ke(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(be[186],we([0,1,11]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,S)=>{this._actualOk=T,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,_.onUnexpectedError)(T))}then(T,S){return this._ensureActual().then(T,S)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=k}),define(be[98],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(y,C){this.isMain=y,this.sid=C,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const k=[];function A(D){const y=new _(!0,D);return k[y.nid]=y,y}e.createMainContextProxyIdentifier=A;function T(D){const y=new _(!1,D);return k[y.nid]=y,y}e.createExtHostContextProxyIdentifier=T;function S(D){return k[D].sid}e.getStringIdentifierForProxy=S}),define(be[5],we([0,1,2,98,58]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var S;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(C=e.CellKind||(e.CellKind={}));var i;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var d;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(d=e.CandidatePortSource||(e.CandidatePortSource={}));var f;(function(u){u.name="$ident";function b(n,a){return Object.defineProperty(n,u.name,{value:a,enumerable:!0}),n}u.mixin=b;function t(n){return n[u.name]}u.of=t})(f=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(b){return b._id=r._n++,b}}e.IdObject=r,r._n=0;var o;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(u){if(u&&u.edits)for(const b of u.edits)typeof b.resource=="object"?b.resource=_.URI.revive(b.resource):(b.newUri=_.URI.revive(b.newUri),b.oldUri=_.URI.revive(b.oldUri)),b.metadata&&b.metadata.iconPath&&(b.metadata=(0,A.revive)(b.metadata));return u}e.reviveWorkspaceEditDto=E;var p;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],we([0,1,5,3,4]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,y){return this._proxy.$getPassword(D,y)}store(D,y,C){return this._proxy.$setPassword(D,y,C)}delete(D,y){return this._proxy.$deletePassword(D,y)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(be[75],we([0,1,4,19,5,15]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(A.MainContext.MainThreadTelemetry)}report(y,C,i){const I=this.getUsageKey(y,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:y}))}getUsageKey(y,C){return`${y}-${C.identifier.value}`}};S=je([Ke(0,T.IExtHostRpcService),Ke(1,k.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(D,y,C){}})}),define(be[187],we([0,1,3,5,7,26]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,C,i,I={}){const d=T.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(d)||[],r=i.sort().join(" ");let o=f.find(v=>v.scopes===r);if(o)return o.result;{const v=this._getSession(y,d,C,i,I);o={scopes:r,result:v},f.push(o),this._inFlightRequests.set(d,f);try{await v}finally{const m=f.findIndex(E=>E.scopes===r);m>-1&&(f.splice(m),this._inFlightRequests.set(d,f))}return v}}async _getSession(y,C,i,I,d={}){await this._proxy.$ensureProvider(i);const f=y.displayName||y.name;return this._proxy.$getSession(i,I,C,f,d)}async removeSession(y,C){const i=this._authenticationProviders.get(y);return i?i.provider.removeSession(C):this._proxy.$removeSession(y,C)}registerAuthenticationProvider(y,C,i,I){var d;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:C,provider:i,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:C});const f=i.onDidChangeSessions(r=>{var o,v,m;this._proxy.$sendDidChangeSessions(y,{added:(o=r.added)!==null&&o!==void 0?o:[],changed:(v=r.changed)!==null&&v!==void 0?v:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(y,C,(d=I==null?void 0:I.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new A.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(o=>o.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,C){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,C){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,C){const i=this._authenticationProviders.get(y);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,C){return this._onDidChangeSessions.fire({provider:{id:y,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,C){return y.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),C.forEach(i=>{const I=this._providers.findIndex(d=>d.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(be[188],we([0,1,5,15,9]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,y){this._extHostDocumentsAndEditors=y,this._proxy=D.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const y=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[189],we([0,1,5]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(T){const S=T.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(D){return S.$writeText(D)}})}}e.ExtHostClipboard=k}),define(be[76],we([0,1,10,7,9,24,5,12,19,58,32,38,2,6,4,15]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,a=>{const s=this._apiCommands.get(a);return(s==null?void 0:s.result)===p.Void?s:void 0},n),this._argumentProcessors=[{processArgument(a){return(0,C.revive)(a)}},{processArgument(a){return(0,T.cloneAndChange)(a,function(s){if(i.Range.isIRange(s))return A.Range.to(s);if(I.Position.isIPosition(s))return A.Position.to(s);if(i.Range.isIRange(s.range)&&d.URI.isUri(s.uri))return A.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...a)=>{const s=t.args.map((l,h)=>{if(!l.validate(a[h]))throw new Error(`Invalid argument '${l.name}' when running '${t.id}', received: ${a[h]}`);return l.convert(a[h])}),c=await this.executeCommand(t.internalId,...s);return t.result.convert(c,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,a,s,c){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:a,thisArg:s,description:c}),t&&this._proxy.$registerCommand(n),new k.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,a){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=(0,T.cloneAndChange)(n,function(c){if(c instanceof k.Position)return A.Position.from(c);if(c instanceof k.Range)return A.Range.from(c);if(c instanceof k.Location)return A.location.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,s,a);return(0,C.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw c}}}async _executeContributedCommand(t,n){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:s,thisArg:c,description:l}=a;if(l)for(let h=0;h<l.args.length;h++)try{(0,_.validateConstraint)(n[h],l.args[h].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${l.args[h].name}' - ${l.args[h].description}`)}try{return await s.apply(c,n)}catch(h){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...n);P&&(t=P.command)}throw this._logService.error(h,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(a=>this._argumentProcessors.reduce((s,c)=>c.processArgument(s),a)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(a=>a[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,a]of this._commands){let{description:s}=a;s&&(t[n]=s)}return Promise.resolve(t)}};v=je([Ke(0,o.IExtHostRpcService),Ke(1,y.ILogService)],v),e.ExtHostCommands=v,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,n,a){this._commands=t,this._lookupApiCommand=n,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const s=this._lookupApiCommand(t.command);if(s)a.id=s.internalId,a.arguments=s.args.map((c,l)=>c.convert(t.arguments&&t.arguments[l]));else if((0,D.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),n.add((0,f.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),a.$ident=c,a.id=this.delegatingCommandId,a.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return a}}fromInternal(t){const n=S.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class E{constructor(t,n,a,s){this.name=t,this.description=n,this.validate=a,this.convert=s}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",b=>d.URI.isUri(b),b=>b),E.Position=new E("position","A position in a text document",b=>k.Position.isPosition(b),A.Position.from),E.Range=new E("range","A range in a text document",b=>k.Range.isRange(b),A.Range.from),E.Selection=new E("selection","A selection in a text document",b=>k.Selection.isSelection(b),A.Selection.from),E.Number=new E("number","",b=>typeof b=="number",b=>b),E.String=new E("string","",b=>typeof b=="string",b=>b),E.CallHierarchyItem=new E("item","A call hierarchy item",b=>b instanceof k.CallHierarchyItem,A.CallHierarchyItem.to);class p{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=p,p.Void=new p("no result",b=>b);class u{constructor(t,n,a,s,c){this.id=t,this.internalId=n,this.description=a,this.args=s,this.result=c}}e.ApiCommand=u}),define(be[190],we([0,1,6,9,7,63,76,168,12,87]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(k.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if(!(0,y.isFalsyOrEmpty)(r)){class v extends A.SymbolInformation{static to(E){const p=new v(E.name,k.SymbolKind.to(E.kind),E.containerName||"",new A.Location(o[0],k.Range.to(E.range)));return p.detail=E.detail,p.range=p.location.range,p.selectionRange=k.Range.to(E.selectionRange),p.children=E.children?E.children.map(v.to):[],p}}return r.map(v.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(k.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(k.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(k.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(k.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.Position.isPosition(o)),r=>r.map(k.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let v;for(const m of o.reverse())v=new A.SelectionRange(k.Range.to(m),v);return v}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const o=[];if(Array.isArray(r))for(let v of r)o.push(...v[1].map(k.WorkspaceSymbol.to));return o})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,C.decodeSemanticTokensDto)(r);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,C.decodeSemanticTokensDto)(r);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,v)=>{if(!r)return new A.CompletionList([]);const m=r.suggestions.map(E=>k.CompletionItem.to(E,v));return new A.CompletionList(m,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,v)=>d(m=>new A.CodeLens(k.Range.to(m.range),m.command&&v.fromInternal(m.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.Range.isRange(r),r=>A.Selection.isSelection(r)?k.Selection.from(r):k.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,v)=>d(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return v.fromInternal(m.command)}else{const E=new A.CodeAction(m.title,m.kind?new A.CodeActionKind(m.kind):void 0);return m.edit&&(E.edit=k.WorkspaceEdit.to(m.edit)),m.command&&(E.command=v.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof A.Color,k.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(k.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientCellMetadata,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class I{constructor(o){this._disposables=new _.DisposableStore,this._commands=o}static register(o){return i.forEach(o.registerApiCommand,o),new I(o).registerCommands()}registerCommands(){const o=v=>(...m)=>v(this._commands,...m);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,o(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:v=>typeof v=="string"}]}),this._register(D.OpenIssueReporter.ID,o(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:v=>typeof v=="string"||typeof v=="object"&&typeof v.extensionId=="string"}]})}_register(o,v,m){const E=this._commands.registerCommand(!1,o,v,this,m);this._disposables.add(E)}}e.ExtHostApiCommands=I;function d(r){return o=>{if(Array.isArray(o))return o.map(r)}}function f(r){if(!!Array.isArray(r)){const o=[];for(const v of r)T.isLocationLink(v)?o.push(k.DefinitionLink.to(v)):o.push(k.location.to(v));return o}}}),define(be[191],we([0,1,14,53,3,6,2,63,26,9,7,5]),function(Y,e,_,k,A,T,S,D,y,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(u,b,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadComments),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.commentThreadHandle);return s||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);return s?{thread:s,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let c=n.commentUniqueId,l=s.getCommentByUniqueId(c);return l||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let c=n.text,l=n.commentUniqueId,h=s.getCommentByUniqueId(l);return h?(h.body=c,h):n}return n}})}createCommentController(u,b,t){const n=d.handlePool++,a=new r(u,n,this._proxy,b,t);this._commentControllers.set(a.handle,a);const s=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return s.push(a),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(u.identifier),s),a}$createCommentThreadTemplate(u,b,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(b,t)}async $updateCommentThreadTemplate(u,b,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(b,t)}$deleteCommentThread(u,b){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(b)}$provideCommentingRanges(u,b,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const a=this._documents.getDocument(S.URI.revive(b));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(a,t)).then(s=>s?s.map(c=>C.Range.from(c)):void 0)}$toggleReaction(u,b,t,n,a){const s=this._commentControllers.get(u);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const c=s.getCommentThread(b);if(c){const l=c.getCommentByUniqueId(n.uniqueIdInThread);if(s!==void 0&&l&&s.reactionHandler)return s.reactionHandler(l,m(a))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class f{constructor(u,b,t,n,a,s,c){this._proxy=u,this._commentController=b,this._id=t,this._uri=n,this._range=a,this._comments=s,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${b.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),c),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),b={};u("range")&&(b.range=C.Range.from(this._range)),u("label")&&(b.label=this.label),u("contextValue")&&(b.contextValue=this.contextValue),u("comments")&&(b.comments=this._comments.map(t=>o(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(b.collapseState=E(this._collapseState)),u("canReply")&&(b.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,b)}}getCommentByUniqueId(u){for(let b of this._commentsMap){let t=b[0],n=b[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,k.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class r{constructor(u,b,t,n,a){this._extension=u,this._handle=b,this._proxy=t,this._id=n,this._label=a,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,a)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,b,t,n){if(typeof u=="string"){const a=new f(this._proxy,this,u,b,t,n,this._extension.identifier);return this._threads.set(a.handle,a),a}else{const a=new f(this._proxy,this,void 0,u,b,t,this._extension.identifier);return this._threads.set(a.handle,a),a}}$createCommentThreadTemplate(u,b){const t=new f(this._proxy,this,void 0,S.URI.revive(u),C.Range.to(b),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,b){let t=this._threads.get(u);t&&(t.range=C.Range.to(b))}$deleteCommentThread(u){let b=this._threads.get(u);b&&b.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function o(p,u,b,t){let n=t.get(b);n||(n=++p.commentHandle,t.set(b,n));const a=b.author&&b.author.iconPath?b.author.iconPath.toString():void 0;return{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:n,body:C.MarkdownString.from(b.body),userName:b.author.name,userIconPath:a,label:b.label,commentReactions:b.reactions?b.reactions.map(s=>v(s)):void 0}}function v(p){return{label:p.label,iconPath:p.iconPath?C.pathOrURIToURI(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function m(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?S.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function E(p){if(p!==void 0)switch(p){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(be[99],we([0,1,2,5,7,4,15,19,12,8,13]),function(Y,e,_,k,A,T,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class gn{constructor(f,r){this._logService=r,this._provider=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,r){const o=gn._handlePool++;this._provider.set(o,{provider:f,extensionId:r}),this._proxy.$registerDecorationProvider(o,r.value);const v=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(o,null);return}let E=(0,y.asArray)(m);if(E.length<=gn._maxEventSize){this._proxy.$onDidChange(o,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const p=E.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),u=(0,y.groupBy)(p,(t,n)=>t.rank-n.rank||(0,C.compare)(t.uri.path,n.uri.path));let b=[];e:for(let t of u){let n;for(let a of t){let s=(0,i.dirname)(a.uri.path);if(n!==s&&(n=s,b.push(a.uri)>=gn._maxEventSize))break e}}this._proxy.$onDidChange(o,b)});return new A.Disposable(()=>{v==null||v.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(f,r,o){if(!this._provider.has(f))return Object.create(null);const v=Object.create(null),{provider:m,extensionId:E}=this._provider.get(f);return await Promise.all(r.map(async p=>{try{const{uri:u,id:b}=p,t=await Promise.resolve(m.provideFileDecoration(_.URI.revive(u),o));if(!t)return;try{A.FileDecoration.validate(t),v[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(u){this._logService.error(u)}})),v}};I._handlePool=0,I._maxEventSize=250,I=je([Ke(0,S.IExtHostRpcService),Ke(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[192],we([0,1,130,90,2,5,7,9,3,19,22]),function(Y,e,_,k,A,T,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(r,o,v,m,E){this._name=r,this._owner=o,this._maxDiagnosticsPerFile=v,this._proxy=m,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,o){if(!r){this.clear();return}this._checkDisposed();let v=[];if(A.URI.isUri(r)){if(!o){this.delete(r);return}this._data.set(r,o.slice()),v=[r]}else if(Array.isArray(r)){v=[];let E;r=[...r].sort(I._compareIndexedTuplesByUri);for(const p of r){const[u,b]=p;if((!E||u.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=u,v.push(u),this._data.set(u,[])),b){const t=this._data.get(u);t&&t.push(...b)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(v),!!this._proxy){const m=[];for(let E of v){let p=[];const u=this._data.get(E);if(u)if(u.length>this._maxDiagnosticsPerFile){p=[];const b=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===b[t]&&p.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;p.push({severity:k.MarkerSeverity.Info,message:(0,_.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:p[p.length-1].startLineNumber,startColumn:p[p.length-1].startColumn,endLineNumber:p[p.length-1].endLineNumber,endColumn:p[p.length-1].endColumn})}else p=u.map(b=>D.Diagnostic.from(b));m.push([E,p])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,o){this._checkDisposed();for(let v of this._data.keys())r.apply(o,[v,this.get(v),this])}get(r){this._checkDisposed();const o=this._data.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=I;let d=class xt{constructor(r,o){this._logService=o,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,xt._debouncer,50),xt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,o){return r?r.concat(o):o}static _mapper(r){const o=[],v=new Set;for(const m of r)typeof m=="string"?v.has(m)||(v.add(m),o.push(A.URI.parse(m))):v.has(m.toString())||(v.add(m.toString()),o.push(m));return Object.freeze(o),{uris:o}}createDiagnosticCollection(r,o){const{_collections:v,_proxy:m,_onDidChangeDiagnostics:E,_logService:p}=this,u=new class{$changeMany(n,a){m.$changeMany(n,a),p.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,a.length===0?"CLEARING":a)}$clear(n){m.$clear(n),p.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){m.dispose()}};let b;if(!o)o="_generated_diagnostic_collection_name_#"+xt._idPool++,b=o;else if(!v.has(o))b=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do b=o+xt._idPool++;while(v.has(b))}return new class extends I{constructor(){super(o,b,xt._maxDiagnosticsPerFile,u,E);v.set(b,this)}dispose(){super.dispose(),v.delete(b)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const o=new Map,v=[];for(const m of this._collections.values())m.forEach((E,p)=>{let u=o.get(E.toString());typeof u=="undefined"&&(u=v.length,o.set(E.toString(),u),v.push([E,[]])),v[u][1]=v[u][1].concat(...p)});return v}}_getDiagnostics(r){let o=[];for(let v of this._collections.values())v.has(r)&&(o=o.concat(v.get(r)));return o}$acceptMarkersChange(r){if(!this._mirrorCollection){const o="_generated_mirror",v=new I(o,o,xt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(o,v),this._mirrorCollection=v}for(const[o,v]of r)this._mirrorCollection.set(A.URI.revive(o),v.map(D.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=je([Ke(1,C.ILogService)],d),e.ExtHostDiagnostics=d}),define(be[193],we([0,1,2,5]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(S){this._proxy=S.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(D=>D?D.map(y=>_.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(D=>D?_.URI.revive(D):void 0)}}e.ExtHostDialogs=A}),define(be[194],we([0,1,11,2,7,5,18,20,8]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,d,f){this._documentsAndEditors=d,this._logService=f,this._documentContentProviders=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,d){if(Object.keys(S.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const f=C._handlePool++;this._documentContentProviders.set(f,d),this._proxy.$registerTextContentProvider(f,I);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(o=>{if(o.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(f,o).then(v=>{if(!(!v&&typeof v!="string")){const m=this._documentsAndEditors.getDocument(o);if(!!m){const E=(0,y.splitLines)(v);if(!m.equalLines(E))return this._proxy.$onVirtualDocumentChange(o,v)}}},_.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(I,d){const f=this._documentContentProviders.get(I);return f?Promise.resolve(f.provideTextDocumentContent(k.URI.revive(d),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(be[195],we([0,1,3,6,2,5,95,9,10,24]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,f){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const f=this._documentsAndEditors.getDocument(d);if(f)return f}}getDocument(d){const f=this.getDocumentData(d);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return f.document}ensureDocumentData(d){const f=this._documentsAndEditors.getDocument(d);if(f)return Promise.resolve(f);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(o=>{this._documentLoader.delete(d.toString());const v=A.URI.revive(o);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(v))},o=>(this._documentLoader.delete(d.toString()),Promise.reject(o))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(f=>A.URI.revive(f))}$acceptModelModeChanged(d,f){const r=A.URI.revive(d),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(f),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(d){const f=A.URI.revive(d),r=this._documentsAndEditors.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,f){const r=A.URI.revive(d),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this._onDidChangeDocument.fire({document:o.document,contentChanges:[]})}$acceptModelChanged(d,f,r){const o=A.URI.revive(d),v=this._documentsAndEditors.getDocument(o);if(!v)throw new Error("unknown document");v._acceptIsDirty(r),v.onEvents(f),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:v.document,contentChanges:f.changes.map(m=>({range:D.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(d,f){(0,S.setWordDefinitionFor)(d,f)}}e.ExtHostDocuments=i}),define(be[39],we([0,1,42,3,6,2,4,5,95,15,97,9,19,22,18,43,107]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(u,b){this._extHostRpc=u,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const b=[],t=[],n=[];if(u.removedDocuments)for(const a of u.removedDocuments){const s=T.URI.revive(a),c=this._documents.get(s);(c==null?void 0:c.unref())&&(this._documents.delete(s),b.push(c.value))}if(u.addedDocuments)for(const a of u.addedDocuments){const s=T.URI.revive(a.uri);let c=this._documents.get(s);if(c&&s.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);c||(c=new m(new y.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(s,c),t.push(c.value)),c.ref()}if(u.removedEditors)for(const a of u.removedEditors){const s=this._editors.get(a);this._editors.delete(a),s&&n.push(s)}if(u.addedEditors)for(const a of u.addedEditors){const s=T.URI.revive(a.documentUri);_.ok(this._documents.has(s),`document '${s}' does not exist`),_.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const c=this._documents.get(s).value,l=new i.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>c.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(h=>I.Range.to(h)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,l)}u.newActiveEditor!==void 0&&(_.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,A.dispose)(b),(0,A.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(b),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var b;return(b=this._documents.get(u))===null||b===void 0?void 0:b.value}allDocuments(){return o.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const b=this._editors.get(this._activeEditorId);return u?b:b==null?void 0:b.value}}allEditors(){return[...this._editors.values()]}};E=je([Ke(0,C.IExtHostRpcService),Ke(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[196],we([0,1,2,5,6,7,9,117,8,23]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const r=this._schemes.indexOf(f);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),r=[];let o,v,m=14,E=14;for(const p of f){let u=o?(0,y.commonPrefixLength)(o,p):0;for(u===0?v=1:v=E;u<p.length;u++)u+1===p.length?(m=E,E=9):E+=1,r.push([v,p.toUpperCase().charCodeAt(u),E]),r.push([v,p.toLowerCase().charCodeAt(u),E]),v=E;o=p,E=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(f){this._initStateMachine();const r=[],o=D.LinkComputer.computeLinks({getLineContent(v){return f.lineAt(v-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const v of o){const m=S.DocumentLink.to(v);m.target&&r.push(m)}return r}}class I{constructor(f,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,r,o,v={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,o);let E=2;v.isCaseSensitive&&(E+=1024),v.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(m,r,E).catch(u=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${r}`),console.error(u)});const p=o.onDidChangeFile(u=>{const b=[];for(const t of u){let{uri:n,type:a}=t;if(n.scheme===r){let s;switch(a){case T.FileChangeType.Changed:s=0;break;case T.FileChangeType.Created:s=1;break;case T.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:n,type:s})}}this._proxy.$onFileSystemChange(m,b)});return(0,A.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(f){const{type:r,ctime:o,mtime:v,size:m}=f;return{type:r,ctime:o,mtime:v,size:m}}$stat(f,r){return Promise.resolve(this._getFsProvider(f).stat(_.URI.revive(r))).then(I._asIStat)}$readdir(f,r){return Promise.resolve(this._getFsProvider(f).readDirectory(_.URI.revive(r)))}$readFile(f,r){return Promise.resolve(this._getFsProvider(f).readFile(_.URI.revive(r))).then(o=>C.VSBuffer.wrap(o))}$writeFile(f,r,o,v){return Promise.resolve(this._getFsProvider(f).writeFile(_.URI.revive(r),o.buffer,v))}$delete(f,r,o){return Promise.resolve(this._getFsProvider(f).delete(_.URI.revive(r),o))}$rename(f,r,o,v){return Promise.resolve(this._getFsProvider(f).rename(_.URI.revive(r),_.URI.revive(o),v))}$copy(f,r,o,v){const m=this._getFsProvider(f);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(_.URI.revive(r),_.URI.revive(o),v))}$mkdir(f,r){return Promise.resolve(this._getFsProvider(f).createDirectory(_.URI.revive(r)))}$watch(f,r,o,v){const m=this._getFsProvider(f).watch(_.URI.revive(o),v);this._watches.set(r,m)}$unwatch(f,r){const o=this._watches.get(r);o&&(o.dispose(),this._watches.delete(r))}$open(f,r,o){const v=this._getFsProvider(f);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(_.URI.revive(r),o))}$close(f,r){const o=this._getFsProvider(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(f,r,o,v){const m=this._getFsProvider(f);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(v);return Promise.resolve(m.read(r,o,E.buffer,0,v)).then(p=>E.slice(0,p))}$write(f,r,o,v){const m=this._getFsProvider(f);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,o,v.buffer,0,v.byteLength))}_getFsProvider(f){const r=this._fsProvider.get(f);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.ExtHostFileSystem=I}),define(be[77],we([0,1,5,65,7,23,4,15,49]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ft{constructor(I,d){const f=I.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return f.$stat(r).catch(Ft._handleError)},readDirectory(r){return f.$readdir(r).catch(Ft._handleError)},createDirectory(r){return f.$mkdir(r).catch(Ft._handleError)},async readFile(r){return f.$readFile(r).then(o=>o.buffer).catch(Ft._handleError)},writeFile(r,o){return f.$writeFile(r,T.VSBuffer.wrap(o)).catch(Ft._handleError)},delete(r,o){return f.$delete(r,Object.assign({recursive:!1,useTrash:!1},o)).catch(Ft._handleError)},rename(r,o,v){return f.$rename(r,o,Object.assign({overwrite:!1},v)).catch(Ft._handleError)},copy(r,o,v){return f.$copy(r,o,Object.assign({overwrite:!1},v)).catch(Ft._handleError)},isWritableFileSystem(r){const o=d.getCapabilities(r);if(typeof o=="number")return!(o&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new A.FileSystemError(String(I));if(I.name==="ENOPRO")throw A.FileSystemError.Unavailable(I.message);switch(I.name){case k.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(I.message);case k.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(I.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(I.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(I.message);case k.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(I.message);case k.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(I.message);default:throw new A.FileSystemError(I.message,I.name)}}};C=je([Ke(0,D.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(be[197],we([0,1,6,5]),function(Y,e,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(S){this._handlePool=0,this._proxy=S.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,S),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=A}),define(be[198],we([0,1,2,24,9,7,14,5,8,32,12,10,114,6,87,55,69,56,11]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class p{constructor($,G){this._documents=$,this._provider=G}provideDocumentSymbols($,G){const ie=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(ie,G)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(A.DocumentSymbol.from):p._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree($){var G;$=$.slice(0).sort((me,De)=>{let Ne=me.location.range.start.compareTo(De.location.range.start);return Ne===0&&(Ne=De.location.range.end.compareTo(me.location.range.end)),Ne});const ie=[],oe=[];for(const me of $){const De={name:me.name||"!!MISSING: name!!",kind:A.SymbolKind.from(me.kind),tags:((G=me.tags)===null||G===void 0?void 0:G.map(A.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:A.Range.from(me.location.range),selectionRange:A.Range.from(me.location.range),children:[]};for(;;){if(oe.length===0){oe.push(De),ie.push(De);break}const Ne=oe[oe.length-1];if(C.Range.containsRange(Ne.range,De.range)&&!C.Range.equalsRange(Ne.range,De.range)){Ne.children&&Ne.children.push(De),oe.push(De);break}oe.pop()}}return ie}}class u{constructor($,G,ie){this._documents=$,this._commands=G,this._provider=ie,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const ie=this._documents.getDocument($),oe=await this._provider.provideCodeLenses(ie,G);if(!(!oe||G.isCancellationRequested)){const me=this._cache.add(oe),De=new f.DisposableStore;this._disposables.set(me,De);const Ne={cacheId:me,lenses:[]};for(let ge=0;ge<oe.length;ge++)Ne.lenses.push({cacheId:[me,ge],range:A.Range.from(oe[ge].range),command:this._commands.toInternal(oe[ge].command,De)});return Ne}}async resolveCodeLens($,G){var ie;const oe=$.cacheId&&this._cache.get(...$.cacheId);if(!!oe){let me;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?me=oe:me=await this._provider.resolveCodeLens(oe,G),me||(me=oe),!G.isCancellationRequested){const De=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!De)return $.command=this._commands.toInternal((ie=me.command)!==null&&ie!==void 0?ie:u._badCmd,De),$}}}releaseCodeLenses($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(xe){return Array.isArray(xe)?xe.map(A.DefinitionLink.from):xe?[A.DefinitionLink.from(xe)]:[]}class t{constructor($,G){this._documents=$,this._provider=G}provideDefinition($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDefinition(oe,me,ie)).then(b)}}class n{constructor($,G){this._documents=$,this._provider=G}provideDeclaration($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDeclaration(oe,me,ie)).then(b)}}class a{constructor($,G){this._documents=$,this._provider=G}provideImplementation($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideImplementation(oe,me,ie)).then(b)}}class s{constructor($,G){this._documents=$,this._provider=G}provideTypeDefinition($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(oe,me,ie)).then(b)}}class c{constructor($,G){this._documents=$,this._provider=G}provideHover($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideHover(oe,me,ie)).then(De=>{if(!(!De||(0,i.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=oe.getWordRangeAtPosition(me)),De.range||(De.range=new T.Range(me,me)),A.Hover.from(De)})}}class l{constructor($,G){this._documents=$,this._provider=G}provideEvaluatableExpression($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,me,ie)).then(De=>{if(De)return A.EvaluatableExpression.from(De)})}}class h{constructor($,G){this._documents=$,this._provider=G}provideInlineValues($,G,ie,oe){const me=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideInlineValues(me,A.Range.to(G),A.InlineValueContext.to(ie),oe)).then(De=>{if(Array.isArray(De))return De.map(Ne=>A.InlineValue.from(Ne))})}}class P{constructor($,G){this._documents=$,this._provider=G}provideDocumentHighlights($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(oe,me,ie)).then(De=>{if(Array.isArray(De))return De.map(A.DocumentHighlight.from)})}}class g{constructor($,G){this._documents=$,this._provider=G}provideLinkedEditingRanges($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,me,ie)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,i.coalesce)(De.ranges.map(A.Range.from)),wordPattern:De.wordPattern}})}}class w{constructor($,G){this._documents=$,this._provider=G}provideReferences($,G,ie,oe){const me=this._documents.getDocument($),De=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideReferences(me,De,ie,oe)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(A.location.from)})}}class R{constructor($,G,ie,oe,me,De,Ne){this._documents=$,this._commands=G,this._diagnostics=ie,this._provider=oe,this._logService=me,this._extension=De,this._apiDeprecation=Ne,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,G,ie,oe){const me=this._documents.getDocument($),De=d.Selection.isISelection(G)?A.Selection.to(G):A.Range.to(G),Ne=[];for(const Ce of this._diagnostics.getDiagnostics($))if(De.intersection(Ce.range)&&Ne.push(Ce)>R._maxCodeActionsPerFile)break;const ge={diagnostics:Ne,only:ie.only?new T.CodeActionKind(ie.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ie.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(me,De,ge,oe)).then(Ce=>{var Ae;if(!(!(0,i.isNonEmptyArray)(Ce)||oe.isCancellationRequested)){const Be=this._cache.add(Ce),_e=new f.DisposableStore;this._disposables.set(Be,_e);const qe=[];for(let j=0;j<Ce.length;j++){const te=Ce[j];!te||(R._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,_e)})):(ge.only&&(te.kind?ge.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,j],title:te.title,command:te.command&&this._commands.toInternal(te.command,_e),diagnostics:te.diagnostics&&te.diagnostics.map(A.Diagnostic.from),edit:te.edit&&A.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Ae=te.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction($,G){var ie;const[oe,me]=$,De=this._cache.get(oe,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Ne=(ie=await this._provider.resolveCodeAction(De,G))!==null&&ie!==void 0?ie:De;return(Ne==null?void 0:Ne.edit)?A.WorkspaceEdit.from(Ne.edit):void 0}}releaseCodeActions($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}R._maxCodeActionsPerFile=1e3;class L{constructor($,G){this._documents=$,this._provider=G}provideDocumentFormattingEdits($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,G,ie)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class V{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeFormattingEdits($,G,ie,oe){const me=this._documents.getDocument($),De=A.Range.to(G);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,ie,oe)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(A.TextEdit.from)})}}class he{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,G,ie,oe,me){const De=this._documents.getDocument($),Ne=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Ne,ie,oe,me)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class z{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,G){const ie=D.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols($,G)).then(oe=>{if((0,i.isNonEmptyArray)(oe)){for(const me of oe)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=D.IdObject.mixin(A.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),ie.symbols.push(De)}}}).then(()=>(ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie))}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ie=this._symbolCache.get($._id);if(ie){const oe=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ie,G));return oe&&(0,k.mixin)($,A.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[ie,oe]=G;ie<=oe;ie++)this._symbolCache.delete(ie);this._resultCache.delete($)}}}class W{constructor($,G,ie){this._documents=$,this._provider=G,this._logService=ie}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,G,ie,oe){const me=this._documents.getDocument($),De=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(me,De,ie,oe)).then(Ne=>{if(!!Ne)return A.WorkspaceEdit.from(Ne)},Ne=>{const ge=W._asMessage(Ne);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Ne)})}resolveRenameLocation($,G,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument($),me=A.Position.to(G);return(0,S.asPromise)(()=>this._provider.prepareRename(oe,me,ie)).then(De=>{let Ne,ge;if(T.Range.isRange(De)?(Ne=De,ge=oe.getText(De)):(0,I.isObject)(De)&&(Ne=De.range,ge=De.placeholder),!!Ne){if(Ne.start.line>me.line||Ne.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Ne),text:ge}}},De=>{const Ne=W._asMessage(De);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class J{constructor($,G){this.resultId=$,this.tokens=G}}class O{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,G,ie){const oe=this._documents.getDocument($),me=G!==0?this._previousResults.get(G):null;return(0,S.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,me.resultId,ie):this._provider.provideDocumentSemanticTokens(oe,ie)).then(De=>(me&&this._previousResults.delete(G),De?(De=O._fixProvidedSemanticTokens(De),this._send(O._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return O._isSemanticTokens($)?O._isCorrectSemanticTokens($)?$:new T.SemanticTokens(new Uint32Array($.data),$.resultId):O._isSemanticTokensEdits($)?O._isCorrectSemanticTokensEdits($)?$:new T.SemanticTokensEdits($.edits.map(G=>new T.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!O._isSemanticTokens(G)||!$||!$.tokens)return G;const ie=$.tokens,oe=ie.length,me=G.data,De=me.length;let Ne=0;const ge=Math.min(oe,De);for(;Ne<ge&&ie[Ne]===me[Ne];)Ne++;if(Ne===oe&&Ne===De)return new T.SemanticTokensEdits([],G.resultId);let Ce=0;const Ae=ge-Ne;for(;Ce<Ae&&ie[oe-Ce-1]===me[De-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Ne,deleteCount:oe-Ne-Ce,data:me.subarray(Ne,De-Ce)}],G.resultId)}_send($,G){if(O._isSemanticTokens($)){const ie=this._nextResultId++;return this._previousResults.set(ie,new J($.resultId,$.data)),(0,r.encodeSemanticTokensDto)({id:ie,type:"full",data:$.data})}if(O._isSemanticTokensEdits($)){const ie=this._nextResultId++;return O._isSemanticTokens(G)?this._previousResults.set(ie,new J(G.resultId,G.data)):this._previousResults.set(ie,new J($.resultId)),(0,r.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:($.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=O;class F{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeSemanticTokens($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,A.Range.to(G),ie)).then(me=>me?this._send(me):null)}_send($){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=F;class N{constructor($,G,ie,oe,me){this._documents=$,this._commands=G,this._provider=ie,this._apiDeprecation=oe,this._extension=me,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,ie,oe){const me=this._documents.getDocument($),De=A.Position.to(G),Ne=me.getWordRangeAtPosition(De)||new T.Range(De,De),ge=Ne.with({end:De}),Ce=new m.StopWatch(!0),Ae=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(me,De,oe,A.CompletionContext.to(ie)));if(!!Ae&&!oe.isCancellationRequested){const Be=Array.isArray(Ae)?new T.CompletionList(Ae):Ae,_e=N.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new f.DisposableStore;this._disposables.set(_e,qe);const j=[],te={x:_e,b:j,a:{replace:A.Range.from(Ne),insert:A.Range.from(ge)},c:Be.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<Be.items.length;ve++){const Ue=Be.items[ve],He=this._convertCompletionItem(Ue,[_e,ve],ge,Ne);j.push(He)}return te}}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem=="function"){const ie=this._cache.get(...$);if(!!ie){const oe=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(ie,G));if(!!oe)return this._convertCompletionItem(oe,$)}}}releaseCompletionItems($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,ie,oe){var me;const De=this._disposables.get(G[0]);if(!De)throw Error("DisposableStore is missing...");const Ne={x:G,a:(me=$.label)!==null&&me!==void 0?me:"",o:$.label2,b:$.kind!==void 0?A.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(A.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:A.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal($.command,De)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=$.textEdit.newText):typeof $.insertText=="string"?Ne.h=$.insertText:$.insertText instanceof T.SnippetString&&(Ne.h=$.insertText.value,Ne.i|=4);let ge;return $.textEdit?ge=$.textEdit.range:$.range&&(ge=$.range),T.Range.isRange(ge)?Ne.j=A.Range.from(ge):ge&&(!(ie==null?void 0:ie.isEqual(ge.inserting))||!(oe==null?void 0:oe.isEqual(ge.replacing)))&&(Ne.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Ne}}class B{constructor($,G){this._documents=$,this._provider=G,this._cache=new v.Cache("SignatureHelp")}provideSignatureHelp($,G,ie,oe){const me=this._documents.getDocument($),De=A.Position.to(G),Ne=this.reviveContext(ie);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(me,De,oe,Ne)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext($){let G;if($.activeSignatureHelp){const ie=A.SignatureHelp.to($.activeSignatureHelp),oe=this._cache.get($.activeSignatureHelp.id,0);oe?(G=oe,G.activeSignature=ie.activeSignature,G.activeParameter=ie.activeParameter):G=ie}return Object.assign(Object.assign({},$),{activeSignatureHelp:G})}releaseSignatureHelp($){this._cache.delete($)}}class U{constructor($,G){this._documents=$,this._provider=G}provideInlineHints($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideInlineHints(oe,A.Range.to(G),ie)).then(me=>me?{hints:me.map(A.InlineHint.from)}:void 0)}}class Q{constructor($,G){this._documents=$,this._provider=G,this._cache=new v.Cache("DocumentLink")}provideLinks($,G){const ie=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(ie,G)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(A.DocumentLink.from)};{const me=this._cache.add(oe),De={links:[],id:me};for(let Ne=0;Ne<oe.length;Ne++){const ge=A.DocumentLink.from(oe[Ne]);ge.cacheId=[me,Ne],De.links.push(ge)}return De}}})}resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ie=this._cache.get(...$);return ie?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(ie,G)).then(oe=>oe&&A.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks($){this._cache.delete($)}}class Z{constructor($,G){this._documents=$,this._provider=G}provideColors($,G){const ie=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(ie,G)).then(oe=>Array.isArray(oe)?oe.map(De=>({color:A.Color.from(De.color),range:A.Range.from(De.range)})):[])}provideColorPresentations($,G,ie){const oe=this._documents.getDocument($),me=A.Range.to(G.range),De=A.Color.to(G.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(De,{document:oe,range:me},ie)).then(Ne=>{if(!!Array.isArray(Ne))return Ne.map(A.ColorPresentation.from)})}}class ne{constructor($,G){this._documents=$,this._provider=G}provideFoldingRanges($,G,ie){const oe=this._documents.getDocument($);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(oe,G,ie)).then(me=>{if(!!Array.isArray(me))return me.map(A.FoldingRange.from)})}}class pe{constructor($,G,ie){this._documents=$,this._provider=G,this._logService=ie}provideSelectionRanges($,G,ie){const oe=this._documents.getDocument($),me=G.map(A.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(oe,me,ie)).then(De=>{if(!(0,i.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Ne.push(Ce);let Ae=me[ge],Be=De[ge];for(;;){if(!Be.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from(Be)),!Be.parent)break;Ae=Be.range,Be=Be.parent}}return Ne})}}class Pe{constructor($,G){this._documents=$,this._provider=G,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,G,ie){const oe=this._documents.getDocument($),me=A.Position.to(G),De=await this._provider.prepareCallHierarchy(oe,me,ie);if(!!De){const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(De)?De.map(ge=>this._cacheAndConvertItem(Ne,ge)):[this._cacheAndConvertItem(Ne,De)]}}async provideCallsTo($,G,ie){const oe=this._itemFromCache($,G);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(oe,ie);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem($,De.from),fromRanges:De.fromRanges.map(Ne=>A.Range.from(Ne))}))}async provideCallsFrom($,G,ie){const oe=this._itemFromCache($,G);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(oe,ie);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem($,De.to),fromRanges:De.fromRanges.map(Ne=>A.Range.from(Ne))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){var ie;const oe=this._cache.get($),me={_sessionId:$,_itemId:oe.size.toString(36),name:G.name,detail:G.detail,kind:A.SymbolKind.from(G.kind),uri:G.uri,range:A.Range.from(G.range),selectionRange:A.Range.from(G.selectionRange),tags:(ie=G.tags)===null||ie===void 0?void 0:ie.map(A.SymbolTag.from)};return oe.set(me._itemId,G),me}_itemFromCache($,G){const ie=this._cache.get($);return ie==null?void 0:ie.get(G)}}class Oe{constructor($,G){this.adapter=$,this.extension=G}}class Te{constructor($,G,ie,oe,me,De,Ne){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=oe,this._diagnostics=me,this._logService=De,this._apiDeprecation=Ne}_transformDocumentSelector($){return(0,i.coalesce)((0,i.asArray)($).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:A.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new T.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Te._handlePool++}_withAdapter($,G,ie,oe,me=!1){const De=this._adapter.get($);if(!De)return Promise.resolve(oe);if(De.adapter instanceof G){let Ne;De.extension&&(Ne=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${G.name}'`));const ge=ie(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Ne}ms`),Ae=>{me&&Ae instanceof E.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const ie=this._nextHandle();return this._adapter.set(ie,new Oe($,G)),ie}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,ie,oe){const me=this._addNewAdapter(new p(this._documents,ie),$),De=oe&&oe.label||Te._extLabel($);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(G),De),this._createDisposable(me)}$provideDocumentSymbols($,G,ie){return this._withAdapter($,p,oe=>oe.provideDocumentSymbols(_.URI.revive(G),ie),void 0)}registerCodeLensProvider($,G,ie){const oe=this._nextHandle(),me=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Oe(new u(this._documents,this._commands.converter,ie),$)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(G),me);let De=this._createDisposable(oe);if(me!==void 0){const Ne=ie.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));De=T.Disposable.from(De,Ne)}return De}$provideCodeLenses($,G,ie){return this._withAdapter($,u,oe=>oe.provideCodeLenses(_.URI.revive(G),ie),void 0)}$resolveCodeLens($,G,ie){return this._withAdapter($,u,oe=>oe.resolveCodeLens(G,ie),void 0)}$releaseCodeLenses($,G){this._withAdapter($,u,ie=>Promise.resolve(ie.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,ie){const oe=this._addNewAdapter(new t(this._documents,ie),$);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDefinition($,G,ie,oe){return this._withAdapter($,t,me=>me.provideDefinition(_.URI.revive(G),ie,oe),[])}registerDeclarationProvider($,G,ie){const oe=this._addNewAdapter(new n(this._documents,ie),$);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDeclaration($,G,ie,oe){return this._withAdapter($,n,me=>me.provideDeclaration(_.URI.revive(G),ie,oe),[])}registerImplementationProvider($,G,ie){const oe=this._addNewAdapter(new a(this._documents,ie),$);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideImplementation($,G,ie,oe){return this._withAdapter($,a,me=>me.provideImplementation(_.URI.revive(G),ie,oe),[])}registerTypeDefinitionProvider($,G,ie){const oe=this._addNewAdapter(new s(this._documents,ie),$);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideTypeDefinition($,G,ie,oe){return this._withAdapter($,s,me=>me.provideTypeDefinition(_.URI.revive(G),ie,oe),[])}registerHoverProvider($,G,ie,oe){const me=this._addNewAdapter(new c(this._documents,ie),$);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideHover($,G,ie,oe){return this._withAdapter($,c,me=>me.provideHover(_.URI.revive(G),ie,oe),void 0)}registerEvaluatableExpressionProvider($,G,ie,oe){const me=this._addNewAdapter(new l(this._documents,ie),$);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(G)),this._createDisposable(me)}$provideEvaluatableExpression($,G,ie,oe){return this._withAdapter($,l,me=>me.provideEvaluatableExpression(_.URI.revive(G),ie,oe),void 0)}registerInlineValuesProvider($,G,ie,oe){const me=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new h(this._documents,ie),$);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(G),me);let Ne=this._createDisposable(De);if(me!==void 0){const ge=ie.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Ne=T.Disposable.from(Ne,ge)}return Ne}$provideInlineValues($,G,ie,oe,me){return this._withAdapter($,h,De=>De.provideInlineValues(_.URI.revive(G),ie,oe,me),void 0)}registerDocumentHighlightProvider($,G,ie){const oe=this._addNewAdapter(new P(this._documents,ie),$);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentHighlights($,G,ie,oe){return this._withAdapter($,P,me=>me.provideDocumentHighlights(_.URI.revive(G),ie,oe),void 0)}registerLinkedEditingRangeProvider($,G,ie){const oe=this._addNewAdapter(new g(this._documents,ie),$);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideLinkedEditingRanges($,G,ie,oe){return this._withAdapter($,g,async me=>{const De=await me.provideLinkedEditingRanges(_.URI.revive(G),ie,oe);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Te._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,ie){const oe=this._addNewAdapter(new w(this._documents,ie),$);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideReferences($,G,ie,oe,me){return this._withAdapter($,w,De=>De.provideReferences(_.URI.revive(G),ie,oe,me),void 0)}registerCodeActionProvider($,G,ie,oe){var me,De;const Ne=new f.DisposableStore,ge=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(G),{providedKinds:(me=oe==null?void 0:oe.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(De=oe==null?void 0:oe.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Ne)}))},Te._extLabel($),Boolean(ie.resolveCodeAction)),Ne.add(this._createDisposable(ge)),Ne}$provideCodeActions($,G,ie,oe,me){return this._withAdapter($,R,De=>De.provideCodeActions(_.URI.revive(G),ie,oe,me),void 0)}$resolveCodeAction($,G,ie){return this._withAdapter($,R,oe=>oe.resolveCodeAction(G,ie),void 0)}$releaseCodeActions($,G){this._withAdapter($,R,ie=>Promise.resolve(ie.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,ie){const oe=this._addNewAdapter(new L(this._documents,ie),$);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(oe)}$provideDocumentFormattingEdits($,G,ie,oe){return this._withAdapter($,L,me=>me.provideDocumentFormattingEdits(_.URI.revive(G),ie,oe),void 0)}registerDocumentRangeFormattingEditProvider($,G,ie){const oe=this._addNewAdapter(new V(this._documents,ie),$);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits($,G,ie,oe,me){return this._withAdapter($,V,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(G),ie,oe,me),void 0)}registerOnTypeFormattingEditProvider($,G,ie,oe){const me=this._addNewAdapter(new he(this._documents,ie),$);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(G),oe,$.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits($,G,ie,oe,me,De){return this._withAdapter($,he,Ne=>Ne.provideOnTypeFormattingEdits(_.URI.revive(G),ie,oe,me,De),void 0)}registerWorkspaceSymbolProvider($,G){const ie=this._addNewAdapter(new z(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols($,G,ie){return this._withAdapter($,z,oe=>oe.provideWorkspaceSymbols(G,ie),{symbols:[]})}$resolveWorkspaceSymbol($,G,ie){return this._withAdapter($,z,oe=>oe.resolveWorkspaceSymbol(G,ie),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,z,ie=>ie.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,ie){const oe=this._addNewAdapter(new W(this._documents,ie,this._logService),$);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(G),W.supportsResolving(ie)),this._createDisposable(oe)}$provideRenameEdits($,G,ie,oe,me){return this._withAdapter($,W,De=>De.provideRenameEdits(_.URI.revive(G),ie,oe,me),void 0)}$resolveRenameLocation($,G,ie,oe){return this._withAdapter($,W,me=>me.resolveRenameLocation(_.URI.revive(G),ie,oe),void 0)}registerDocumentSemanticTokensProvider($,G,ie,oe){const me=this._nextHandle(),De=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Oe(new O(this._documents,ie),$)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(G),oe,De);let Ne=this._createDisposable(me);if(De){const ge=ie.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Ne=T.Disposable.from(Ne,ge)}return Ne}$provideDocumentSemanticTokens($,G,ie,oe){return this._withAdapter($,O,me=>me.provideDocumentSemanticTokens(_.URI.revive(G),ie,oe),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,O,ie=>ie.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,ie,oe){const me=this._addNewAdapter(new F(this._documents,ie),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(G),oe),this._createDisposable(me)}$provideDocumentRangeSemanticTokens($,G,ie,oe){return this._withAdapter($,F,me=>me.provideDocumentRangeSemanticTokens(_.URI.revive(G),ie,oe),null,!0)}registerCompletionItemProvider($,G,ie,oe){const me=this._addNewAdapter(new N(this._documents,this._commands.converter,ie,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(G),oe,N.supportsResolving(ie),`${$.identifier.value}(${oe.join("")})`),this._createDisposable(me)}$provideCompletionItems($,G,ie,oe,me){return this._withAdapter($,N,De=>De.provideCompletionItems(_.URI.revive(G),ie,oe,me),void 0)}$resolveCompletionItem($,G,ie){return this._withAdapter($,N,oe=>oe.resolveCompletionItem(G,ie),void 0)}$releaseCompletionItems($,G){this._withAdapter($,N,ie=>ie.releaseCompletionItems(G),void 0)}registerSignatureHelpProvider($,G,ie,oe){const me=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,De=this._addNewAdapter(new B(this._documents,ie),$);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(G),me),this._createDisposable(De)}$provideSignatureHelp($,G,ie,oe,me){return this._withAdapter($,B,De=>De.provideSignatureHelp(_.URI.revive(G),ie,oe,me),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,B,ie=>ie.releaseSignatureHelp(G),void 0)}registerInlineHintsProvider($,G,ie){const oe=typeof ie.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new U(this._documents,ie),$);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(G),oe);let De=this._createDisposable(me);if(oe!==void 0){const Ne=ie.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(oe));De=T.Disposable.from(De,Ne)}return De}$provideInlineHints($,G,ie,oe){return this._withAdapter($,U,me=>me.provideInlineHints(_.URI.revive(G),ie,oe),void 0)}registerDocumentLinkProvider($,G,ie){const oe=this._addNewAdapter(new Q(this._documents,ie),$);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(G),typeof ie.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks($,G,ie){return this._withAdapter($,Q,oe=>oe.provideLinks(_.URI.revive(G),ie),void 0)}$resolveDocumentLink($,G,ie){return this._withAdapter($,Q,oe=>oe.resolveLink(G,ie),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,Q,ie=>ie.releaseLinks(G),void 0)}registerColorProvider($,G,ie){const oe=this._addNewAdapter(new Z(this._documents,ie),$);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideDocumentColors($,G,ie){return this._withAdapter($,Z,oe=>oe.provideColors(_.URI.revive(G),ie),[])}$provideColorPresentations($,G,ie,oe){return this._withAdapter($,Z,me=>me.provideColorPresentations(_.URI.revive(G),ie,oe),void 0)}registerFoldingRangeProvider($,G,ie){const oe=this._nextHandle(),me=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Oe(new ne(this._documents,ie),$)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(G),me);let De=this._createDisposable(oe);if(me!==void 0){const Ne=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=T.Disposable.from(De,Ne)}return De}$provideFoldingRanges($,G,ie,oe){return this._withAdapter($,ne,me=>me.provideFoldingRanges(_.URI.revive(G),ie,oe),void 0)}registerSelectionRangeProvider($,G,ie){const oe=this._addNewAdapter(new pe(this._documents,ie,this._logService),$);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$provideSelectionRanges($,G,ie,oe){return this._withAdapter($,pe,me=>me.provideSelectionRanges(_.URI.revive(G),ie,oe),[])}registerCallHierarchyProvider($,G,ie){const oe=this._addNewAdapter(new Pe(this._documents,ie),$);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(G)),this._createDisposable(oe)}$prepareCallHierarchy($,G,ie,oe){return this._withAdapter($,Pe,me=>Promise.resolve(me.prepareSession(_.URI.revive(G),ie,oe)),void 0)}$provideCallHierarchyIncomingCalls($,G,ie,oe){return this._withAdapter($,Pe,me=>me.provideCallsTo(G,ie,oe),void 0)}$provideCallHierarchyOutgoingCalls($,G,ie,oe){return this._withAdapter($,Pe,me=>me.provideCallsFrom(G,ie,oe),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,Pe,ie=>Promise.resolve(ie.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,y.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Te._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Te._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Te._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Te._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Te._serializeRegExp($.beforeText),afterText:$.afterText?Te._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Te._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Te._serializeOnEnterRule)}setLanguageConfiguration($,G,ie){let{wordPattern:oe}=ie;if(oe&&(0,y.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(G,oe):this._documents.setWordDefinitionFor(G,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const me=this._nextHandle(),De={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Te._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Te._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Te._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,G,De),this._createDisposable(me)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Te,Te._handlePool=0}),define(be[199],we([0,1,5,9,7]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,y){this._proxy=D.getProxy(_.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,y){await this._proxy.$changeLanguage(D,y);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,y){var C;const i=D.version,I=k.Position.from(y),d=await this._proxy.$tokensAtPosition(D.uri,I),f={type:A.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(y))!==null&&C!==void 0?C:new A.Range(y.line,y.character,y.line,y.character)};if(!d)return f;const r={range:k.Range.to(d.range),type:k.TokenType.to(d.type)};return!r.range.contains(y)||i!==D.version?f:r}}e.ExtHostLanguages=T}),define(be[200],we([0,1,5,19,33]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let S=class{constructor(y,C){this._logService=C,this._proxy=y.getProxy(_.MainContext.MainThreadMessageService)}showMessage(y,C,i,I,d){const f={extension:y};let r;typeof I=="string"||T(I)?r=[I,...d]:(f.modal=I&&I.modal,f.useCustom=I&&I.useCustom,r=d),f.useCustom&&(0,A.checkProposedApiEnabled)(y);const o=[];for(let v=0;v<r.length;v++){const m=r[v];if(typeof m=="string")o.push({title:m,handle:v,isCloseAffordance:!1});else if(typeof m=="object"){let{title:E,isCloseAffordance:p}=m;o.push({title:E,isCloseAffordance:!!p,handle:v})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(C,i,f,o).then(v=>{if(typeof v=="number")return r[v]})}};S=je([Ke(1,k.ILogService)],S),e.ExtHostMessageService=S}),define(be[201],we([0,1,20,3,6,2,29,5,9,7,50,73,22,178,179,55,10,23,57,69]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class u extends A.Disposable{constructor(l,h,P,g,w){super();this._editorId=l,this.uri=h,this._proxy=P,this._webviewInitData=g,this.document=w,this._onDidReceiveDocumentMessage=new k.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:R=>this._proxy.$postMessage(this._editorId,void 0,R),asWebviewUri:R=>this._asWebviewUri(R)}}onDidReceiveMessage(l,h){var P;this._onDidReceiveDocumentMessage.fire(h),l!==void 0&&((P=this._rendererIdToEmitters.get(l))===null||P===void 0||P.fire(h))}getRendererComm(l){const h=new k.Emitter;return this._rendererIdToEmitters.set(l,h),{editorId:this._editorId,onDidReceiveMessage:h.event,postMessage:P=>this._proxy.$postMessage(this._editorId,l,P),asWebviewUri:P=>this._asWebviewUri(P)}}_asWebviewUri(l){return(0,i.asWebviewUri)(this._webviewInitData,this._editorId,l)}}class b extends A.Disposable{constructor(l,h,P,g){super();this._proxy=l,this._handle=h,this._extension=P,this._provider=g,this._kernelToFriendlyId=new d.ResourceMap,this._friendlyIdToKernel=new d.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(w=>{const R=w==null?void 0:w.uri;this._proxy.$onNotebookKernelChange(this._handle,R)}))}async provideKernels(l,h){const P=await this._provider.provideKernels(l.notebookDocument,h)||[],g=new Map;let w=0;const R=new Set,L=this._kernelToFriendlyId.get(l.uri),V=P.map(z=>{var W;let J=L==null?void 0:L.get(z);return J===void 0&&(z.id&&R.has(z.id)?J=`${this._extension.identifier.value}_${z.id}_${w++}`:J=`${this._extension.identifier.value}_${z.id||S.generateUuid()}`),g.set(z,J),{id:z.id,friendlyId:J,label:z.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:z.description,detail:z.detail,isPreferred:z.isPreferred,preloads:(W=z.preloads)===null||W===void 0?void 0:W.map(O=>(T.URI.isUri(O)&&(O={uri:O,provides:[]}),{uri:O.uri,provides:typeof O.provides=="string"?[O.provides]:O.provides===void 0?[]:O.provides})),supportedLanguages:z.supportedLanguages,implementsInterrupt:!!z.interrupt}});this._kernelToFriendlyId.set(l.uri,g);const he=new Map;return g.forEach((z,W)=>{he.set(z,W)}),this._friendlyIdToKernel.set(l.uri,he),V}getKernelByFriendlyId(l,h){var P;return(P=this._friendlyIdToKernel.get(l))===null||P===void 0?void 0:P.get(h)}async resolveNotebook(l,h,P,g){var w;const R=(w=this._friendlyIdToKernel.get(h.uri))===null||w===void 0?void 0:w.get(l);if(R&&this._provider.resolveKernel)return this._provider.resolveKernel(R,h.notebookDocument,P,g)}async executeNotebook(l,h,P){var g;const w=(g=this._friendlyIdToKernel.get(h.uri))===null||g===void 0?void 0:g.get(l);if(!!w){const R=P.map(L=>y.NotebookRange.to(L));return w.executeCellsRequest(h.notebookDocument,R)}}async interruptNotebookExecution(l,h){var P;const g=(P=this._friendlyIdToKernel.get(h.uri))===null||P===void 0?void 0:P.get(l);if(!(!g||!g.interrupt))return g.interrupt(h.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=b;class t{constructor(l,h){const P=t._Keys.nextId();l.$registerNotebookEditorDecorationType(P,y.NotebookDecorationRenderOptions.from(h)),this.value={key:P,dispose(){l.$removeNotebookEditorDecorationType(P)}}}}e.NotebookEditorDecorationType=t,t._Keys=new o.IdGenerator("NotebookEditorDecorationType");class n{constructor(l,h,P,g,w,R,L){this._textDocumentsAndEditors=P,this._textDocuments=g,this._webviewInitData=w,this.logService=R,this._extensionStoragePaths=L,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new d.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new k.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new d.ResourceMap,this._statusBarCache=new p.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:V=>{var he;if(V&&V.$mid===12){const z=(he=V.notebookEditor)===null||he===void 0?void 0:he.notebookUri,W=V.cell.handle,J=this._documents.get(z),O=J==null?void 0:J.getCell(W);if(O)return O.cell}return V}})}get activeNotebookEditor(){var l;return(l=this._activeNotebookEditor)===null||l===void 0?void 0:l.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){return this._editors.get(l)}getIdByEditor(l){for(const[h,P]of this._editors)if(P.apiEditor===l)return h}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(l){return this._documents.get(l)}_getNotebookDocument(l){const h=this._documents.get(l);if(!h)throw new Error(`NO notebook document for '${l}'`);return h}_getProviderData(l){const h=this._notebookContentProviders.get(l);if(!h)throw new Error(`NO provider for '${l}'`);return h}registerNotebookContentProvider(l,h,P,g){var w,R,L;if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:l,provider:P});let V;P.onDidChangeNotebookContentOptions&&(V=P.onDidChangeNotebookContentOptions(()=>{const W=y.NotebookDocumentContentOptions.from(P.options);this._notebookProxy.$updateNotebookProviderOptions(h,W)}));const he=(w=g==null?void 0:g.viewOptions)===null||w===void 0?void 0:w.filenamePattern.map(W=>y.NotebookExclusiveDocumentPattern.from(W)).filter(W=>W!==void 0);((R=g==null?void 0:g.viewOptions)===null||R===void 0?void 0:R.filenamePattern)&&!he&&console.warn(`Notebook content provider view options file name pattern is invalid ${(L=g==null?void 0:g.viewOptions)===null||L===void 0?void 0:L.filenamePattern}`);const z=y.NotebookDocumentContentOptions.from(g);return this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation,description:l.description},h,{transientOutputs:z.transientOutputs,transientCellMetadata:z.transientCellMetadata,transientDocumentMetadata:z.transientDocumentMetadata,viewOptions:(g==null?void 0:g.viewOptions)&&he?{displayName:g.viewOptions.displayName,filenamePattern:he,exclusive:g.viewOptions.exclusive||!1}:void 0}),new C.Disposable(()=>{V==null||V.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}registerNotebookKernelProvider(l,h,P){const g=n._notebookKernelProviderHandlePool++,w=new b(this._notebookProxy,g,l,P);return this._notebookKernelProviders.set(g,w),this._notebookProxy.$registerNotebookKernelProvider({id:l.identifier,location:l.extensionLocation,description:l.description},g,{viewType:h.viewType,filenamePattern:h.filenamePattern?y.NotebookExclusiveDocumentPattern.from(h.filenamePattern):void 0}),new C.Disposable(()=>{w.dispose(),this._notebookKernelProviders.delete(g),this._notebookProxy.$unregisterNotebookKernelProvider(g)})}registerNotebookCellStatusBarItemProvider(l,h,P){const g=n._notebookStatusBarItemProviderHandlePool++,w=typeof P.onDidChangeCellStatusBarItems=="function"?n._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,P),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,w,h);let R;return w!==void 0&&(R=P.onDidChangeCellStatusBarItems(L=>this._notebookProxy.$emitCellStatusBarEvent(w))),new C.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,w),R&&R.dispose()})}createNotebookEditorDecorationType(l){return new t(this._notebookEditorsProxy,l).value}async openNotebookDocument(l){const h=this._documents.get(l);if(h)return h.notebookDocument;const P=await this._notebookDocumentsProxy.$tryOpenDocument(l),g=this._documents.get(T.URI.revive(P));return(0,v.assertIsDefined)(g==null?void 0:g.notebookDocument)}_withAdapter(l,h,P){const g=this._documents.get(T.URI.revive(h));if(!g)return[];const w=this._notebookKernelProviders.get(l);return w?P(w,g):[]}async showNotebookDocument(l,h){var P;T.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let g;typeof h=="object"?g={position:y.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(y.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const w=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.viewType,g),R=w&&((P=this._editors.get(w))===null||P===void 0?void 0:P.apiEditor);if(R)return R;throw w?new Error(`Could NOT open editor for "${l.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.toString()}".`)}async $provideNotebookKernels(l,h,P){return this._withAdapter(l,h,(g,w)=>g.provideKernels(w,P))}async $resolveNotebookKernel(l,h,P,g,w){await this._withAdapter(l,P,async(R,L)=>{const V=this._webviewComm.get(h);V&&await R.resolveNotebook(g,L,V.contentProviderComm,w)})}async $provideNotebookCellStatusBarItems(l,h,P,g){var w;const R=this._notebookStatusBarItemProviders.get(l),L=T.URI.revive(h),V=this._documents.get(L);if(!(!V||!R)){const he=V.getCellFromIndex(P);if(!!he){const z=await R.provideCellStatusBarItems(he.cell,g);if(!!z){const W=new A.DisposableStore,J=this._statusBarCache.add([W]),O=(w=z&&z.map(F=>y.NotebookStatusBarItem.from(F,this._commandsConverter,W)))!==null&&w!==void 0?w:void 0;return{cacheId:J,items:O}}}}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}async $resolveNotebookEditor(l,h,P){const g=this._notebookContentProviders.get(l),w=T.URI.revive(h),R=this._documents.get(w);if(!(!R||!g)){let L=this._webviewComm.get(P);L||(L=new u(P,w,this._notebookProxy,this._webviewInitData,R),this._webviewComm.set(P,L))}}async $executeNotebookKernelFromProvider(l,h,P,g){await this._withAdapter(l,h,async(w,R)=>w.executeNotebook(P,R,g))}registerNotebookSerializer(l,h,P,g){const w=this._handlePool++;this._notebookSerializer.set(w,P);const R=y.NotebookDocumentContentOptions.from(g);return this._notebookProxy.$registerNotebookSerializer(w,{id:l.identifier,location:l.extensionLocation,description:l.description},h,R),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(w)})}async $dataToNotebook(l,h,P){const g=this._notebookSerializer.get(l);if(!g)throw new Error("NO serializer found");const w=await g.deserializeNotebook(h.buffer,P);return{metadata:y.NotebookDocumentMetadata.from(w.metadata),cells:w.cells.map(y.NotebookCellData.from)}}async $notebookToData(l,h,P){const g=this._notebookSerializer.get(l);if(!g)throw new Error("NO serializer found");const w=await g.serializeNotebook({metadata:y.NotebookDocumentMetadata.to(h.metadata),cells:h.cells.map(y.NotebookCellData.to)},P);return m.VSBuffer.wrap(w)}async $cancelNotebookCellExecution(l,h,P,g){await this._withAdapter(l,h,async(R,L)=>R.interruptNotebookExecution(P,L));const w=this._documents.get(T.URI.revive(h));if(!!w)for(let R of g)for(let L=R.start;L<R.end;L++){const V=w.getCellFromIndex(L);V&&this.cancelOneNotebookCellExecution(V)}}cancelOneNotebookCellExecution(l){const h=this._activeExecutions.get(l.uri);h==null||h.cancel()}async $openNotebook(l,h,P,g,w){const{provider:R}=this._getProviderData(l),L=await R.openNotebook(T.URI.revive(h),{backupId:P,untitledDocumentData:g==null?void 0:g.buffer},w);return{metadata:y.NotebookDocumentMetadata.from(L.metadata),cells:L.cells.map(y.NotebookCellData.from)}}async $saveNotebook(l,h,P){const g=this._getNotebookDocument(T.URI.revive(h)),{provider:w}=this._getProviderData(l);return await w.saveNotebook(g.notebookDocument,P),!0}async $saveNotebookAs(l,h,P,g){const w=this._getNotebookDocument(T.URI.revive(h)),{provider:R}=this._getProviderData(l);return await R.saveNotebookAs(T.URI.revive(P),w.notebookDocument,g),!0}async $backupNotebook(l,h,P){var g;const w=this._getNotebookDocument(T.URI.revive(h)),R=this._getProviderData(l),L=(g=this._extensionStoragePaths.workspaceValue(R.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(R.extension),V=String((0,E.hash)([w.uri.toString(),this._backupIdPool++])),he=T.URI.joinPath(L,V),z=await R.provider.backupNotebook(w.notebookDocument,{destination:he},P);return w.updateBackup(z),z.id}$acceptNotebookActiveKernelChange(l){l.providerHandle!==void 0&&this._withAdapter(l.providerHandle,l.uri,async(h,P)=>{const g=l.kernelFriendlyId?h.getKernelByFriendlyId(T.URI.revive(l.uri),l.kernelFriendlyId):void 0;this._editors.forEach(w=>{w.notebookData===P&&w._acceptKernel(g)}),this._onDidChangeActiveNotebookKernel.fire({document:P.notebookDocument,kernel:g})})}$onDidReceiveMessage(l,h,P){var g;(g=this._webviewComm.get(l))===null||g===void 0||g.onDidReceiveMessage(h,P)}$acceptModelChanged(l,h,P){this._getNotebookDocument(T.URI.revive(l)).acceptModelChanged(h,P)}$acceptDirtyStateChanged(l,h){const P=this._getNotebookDocument(T.URI.revive(l));P.acceptModelChanged({rawEvents:[],versionId:P.notebookDocument.version},h)}$acceptModelSaved(l){const h=this._getNotebookDocument(T.URI.revive(l));this._onDidSaveNotebookDocument.fire(h.notebookDocument)}$acceptEditorPropertiesChanged(l,h){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",l,h);const P=this._editors.get(l);if(!P)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);h.visibleRanges&&P._acceptVisibleRanges(h.visibleRanges.ranges.map(y.NotebookRange.to)),h.selections&&P._acceptSelections(h.selections.selections.map(y.NotebookRange.to)),h.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),h.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(l){for(const h in l){const P=this._editors.get(h);if(!P)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);P._acceptViewColumn(y.ViewColumn.to(l[h]))}}$acceptDocumentPropertiesChanged(l,h){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",l.path,h);const P=this._getNotebookDocument(T.URI.revive(l));P.acceptDocumentPropertiesChanged(h),h.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.notebookDocument})}_createExtHostEditor(l,h,P){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const g=l.uri;let w=this._webviewComm.get(h);w||(w=new u(h,g,this._notebookProxy,this._webviewInitData,l),this._webviewComm.set(h,w));const R=new r.ExtHostNotebookEditor(h,this._notebookEditorsProxy,l,P.visibleRanges.map(y.NotebookRange.to),P.selections.map(y.NotebookRange.to),typeof P.viewColumn=="number"?y.ViewColumn.to(P.viewColumn):void 0);this._editors.set(h,R)}$acceptDocumentAndEditorsDelta(l){var h,P,g;if(l.removedDocuments)for(const R of l.removedDocuments){const L=T.URI.revive(R),V=this._documents.get(L);V&&(V.dispose(),this._documents.delete(L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:V.notebookDocument.getCells().map(he=>he.document.uri)}),this._onDidCloseNotebookDocument.fire(V.notebookDocument));for(const he of this._editors.values())he.notebookData.uri.toString()===L.toString()&&this._editors.delete(he.id)}if(l.addedDocuments){const R=[];for(const L of l.addedDocuments){const V=T.URI.revive(L.uri),he=L.viewType;if(this._documents.has(V))throw new Error(`adding EXISTING notebook ${V} `);const z=this,W=new f.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(J){z._onDidChangeNotebookCells.fire(J)},emitCellOutputsChange(J){z._onDidChangeCellOutputs.fire(J)},emitCellMetadataChange(J){z._onDidChangeCellMetadata.fire(J)},emitCellExecutionStateChange(J){z._onDidChangeCellExecutionState.fire(J)}},he,L.metadata?y.NotebookDocumentMetadata.to(L.metadata):new C.NotebookDocumentMetadata,V);W.acceptModelChanged({versionId:L.versionId,rawEvents:[{kind:I.NotebookCellsChangeType.Initialize,changes:[[0,0,L.cells]]}]},!1),R.push(...L.cells.map(J=>f.ExtHostCell.asModelAddData(W.notebookDocument,J))),(h=this._documents.get(V))===null||h===void 0||h.dispose(),this._documents.set(V,W),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this._onDidOpenNotebookDocument.fire(W.notebookDocument)}}if(l.addedEditors)for(const R of l.addedEditors){if(this._editors.has(R.id))return;const L=T.URI.revive(R.documentUri),V=this._documents.get(L);V&&this._createExtHostEditor(V,R.id,R)}const w=[];if(l.removedEditors)for(const R of l.removedEditors){const L=this._editors.get(R);L&&(this._editors.delete(R),((P=this._activeNotebookEditor)===null||P===void 0?void 0:P.id)===L.id&&(this._activeNotebookEditor=void 0),w.push(L))}if(l.visibleEditors){this._visibleNotebookEditors=l.visibleEditors.map(L=>this._editors.get(L)).filter(L=>!!L);const R=new Set;this._visibleNotebookEditors.forEach(L=>R.add(L.id));for(const L of this._editors.values()){const V=R.has(L.id);L._acceptVisibility(V)}this._visibleNotebookEditors=[...this._editors.values()].map(L=>L).filter(L=>L.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.newActiveEditor===null?this._activeNotebookEditor=void 0:l.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.newActiveEditor)),l.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}createNotebookCellExecution(l,h,P){const g=this.lookupNotebookDocument(l);if(!g)throw new Error(`Invalid cell uri / index: ${l}, ${h} `);const w=g.getCellFromIndex(h);if(!w)throw new Error(`Invalid cell uri / index: ${l}, ${h} `);if(!this._activeExecutions.has(w.uri)){const R=new s(l,g,w,this._notebookDocumentsProxy);this._activeExecutions.set(w.uri,R);const L=R.onDidChangeState(()=>{R.state===a.Resolved&&(R.dispose(),L.dispose(),this._activeExecutions.delete(w.uri))});return R.asApiObject()}}}e.ExtHostNotebookController=n,n._notebookKernelProviderHandlePool=0,n._notebookStatusBarItemProviderHandlePool=0;var a;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(a||(a={}));class s extends A.Disposable{constructor(l,h,P,g){super();this._uri=l,this._document=h,this._cell=P,this._proxy=g,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._executionOrder=P.internalMetadata.executionOrder,this.mixinMetadata({runState:C.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(l){return this._proxy.$applyEdits(this._uri,l,!1)}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(l){const h=[{editType:11,handle:this._cell.handle,metadata:l}];this.applyEdits(h)}cellIndexToHandle(l){const h=typeof l=="number"?this._document.getCellFromIndex(l):this._cell;if(!!h)return h.handle}asApiObject(){const l=this;return Object.freeze({get document(){return l._document.notebookDocument},get cell(){return l._cell.cell},get executionOrder(){return l._executionOrder},set executionOrder(h){l._executionOrder=h,l.mixinMetadata({executionOrder:h})},start(h){if(l._state===a.Resolved||l._state===a.Started)throw new Error("Cannot call start again");l._state=a.Started,l._onDidChangeState.fire(),l.mixinMetadata({runState:C.NotebookCellExecutionState.Executing,runStartTime:h==null?void 0:h.startTime})},end(h){var P,g;if(l._state===a.Resolved)throw new Error("Cannot call resolve twice");l._state=a.Resolved,l._onDidChangeState.fire(),l.mixinMetadata({runState:C.NotebookCellExecutionState.Idle,lastRunSuccess:(P=h==null?void 0:h.success)!==null&&P!==void 0?P:null,runEndTime:(g=h==null?void 0:h.endTime)!==null&&g!==void 0?g:null})},clearOutput(h){return l.verifyStateForOutput(),this.replaceOutput([],h)},async appendOutput(h,P){l.verifyStateForOutput();const g=l.cellIndexToHandle(P);if(typeof g=="number")return h=Array.isArray(h)?h:[h],l.applyEdits([{editType:2,handle:g,append:!0,outputs:h.map(y.NotebookCellOutput.from)}])},async replaceOutput(h,P){l.verifyStateForOutput();const g=l.cellIndexToHandle(P);if(typeof g=="number")return h=Array.isArray(h)?h:[h],l.applyEdits([{editType:2,handle:g,outputs:h.map(y.NotebookCellOutput.from)}])},async appendOutputItems(h,P){return l.verifyStateForOutput(),h=Array.isArray(h)?h:[h],l.applyEdits([{editType:10,append:!0,items:h.map(y.NotebookCellOutputItem.from),outputId:P}])},async replaceOutputItems(h,P){return l.verifyStateForOutput(),h=Array.isArray(h)?h:[h],l.applyEdits([{editType:10,items:h.map(y.NotebookCellOutputItem.from),outputId:P}])},token:l._tokenSource.token})}}}),define(be[202],we([0,1,3,6,5,2,9,12,50]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class C{constructor(I,d,f){this._initData=d,this._extHostNotebook=f,this._kernelData=new Map,this._handlePool=0,this._proxy=I.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(I,d,f,r,o,v){for(let w of this._kernelData.values())if(w.controller.id===d)throw new Error(`notebook controller with id '${d}' ALREADY exist`);const m=this._handlePool++,E=this,p=["plaintext"],u=()=>console.warn(`NO execute handler from notebook controller '${s.id}' of extension: '${I.identifier}'`);let b=!1;const t=new k.DisposableStore,n=new _.Emitter,a=new _.Emitter,s={id:d,selector:f,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:r||I.identifier.value,supportedLanguages:p,preloads:v?v.map(S.NotebookKernelPreload.from):[]};let c=o!=null?o:u,l;this._proxy.$addKernel(m,s).catch(w=>{console.log(w),b=!0});let h=0;const P=()=>{if(!b){const w=++h;Promise.resolve().then(()=>{w===h&&this._proxy.$updateKernel(m,s)})}},g={get id(){return s.id},get selector(){return s.selector},onDidChangeNotebookAssociation:n.event,get label(){return s.label},set label(w){var R;s.label=(R=w!=null?w:I.displayName)!==null&&R!==void 0?R:I.name,P()},get detail(){var w;return(w=s.detail)!==null&&w!==void 0?w:""},set detail(w){s.detail=w,P()},get description(){var w;return(w=s.description)!==null&&w!==void 0?w:""},set description(w){s.description=w,P()},get isPreferred(){var w;return(w=s.isPreferred)!==null&&w!==void 0?w:!1},set isPreferred(w){s.isPreferred=w,P()},get supportedLanguages(){return s.supportedLanguages},set supportedLanguages(w){s.supportedLanguages=(0,D.isNonEmptyArray)(w)?w:p,P()},get hasExecutionOrder(){var w;return(w=s.hasExecutionOrder)!==null&&w!==void 0?w:!1},set hasExecutionOrder(w){s.hasExecutionOrder=w,P()},get preloads(){return s.preloads?s.preloads.map(S.NotebookKernelPreload.to):[]},get executeHandler(){return c},set executeHandler(w){c=w!=null?w:u},get interruptHandler(){return l},set interruptHandler(w){l=w,s.supportsInterrupt=Boolean(w),P()},createNotebookCellExecutionTask(w){if(b)throw new Error("notebook controller is DISPOSED");return E._extHostNotebook.createNotebookCellExecution(w.notebook.uri,w.index,s.id)},dispose:()=>{b||(b=!0,this._kernelData.delete(m),t.dispose(),n.dispose(),a.dispose(),this._proxy.$removeKernel(m))},onDidReceiveMessage:a.event,postMessage(w,R){return E._proxy.$postMessage(m,R&&E._extHostNotebook.getIdByEditor(R),w)},asWebviewUri(w){return(0,y.asWebviewUri)(E._initData.environment,s.id,w)}};return this._kernelData.set(m,{extensionId:I.identifier,controller:g,onDidChangeSelection:n,onDidReceiveMessage:a}),g}$acceptSelection(I,d,f){const r=this._kernelData.get(I);r&&r.onDidChangeSelection.fire({selected:f,notebook:this._extHostNotebook.lookupNotebookDocument(T.URI.revive(d)).notebookDocument})}async $executeCells(I,d,f){const r=this._kernelData.get(I);if(!!r){const o=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(d));if(!o)throw new Error("MISSING notebook");const v=[];for(let m of f)v.push(...o.notebookDocument.getCells(S.NotebookRange.to(m)));try{r.controller.executeHandler.call(r.controller,v,r.controller)}catch(m){console.error(m)}}}async $cancelCells(I,d,f){const r=this._kernelData.get(I);if(!!r){const o=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(d));if(!o)throw new Error("MISSING notebook");r.controller.interruptHandler&&r.controller.interruptHandler.call(r.controller);for(const v of f)for(let m=v.start;m<v.end;m++){const E=o.getCellFromIndex(m);E&&this._extHostNotebook.cancelOneNotebookCellExecution(E)}}}$acceptRendererMessage(I,d,f){const r=this._kernelData.get(I);if(!!r){const o=this._extHostNotebook.getEditorById(d);if(!o)throw new Error(`send message for UNKNOWN editor: ${d}`);r.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:f}))}}}e.ExtHostNotebookKernels=C}),define(be[100],we([0,1,5,3,6,23,4,15]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends A.Disposable{constructor(r,o,v,m){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,o,v),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(o=>this._proxy.$clear(o,r))}show(r,o){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof r=="boolean"?r:o)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class C extends y{constructor(r,o){super(r,!1,void 0,o)}append(r){super.append(r),this._id.then(o=>this._proxy.$append(o,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends y{constructor(r,o,v){super(r,!0,o,v)}append(r){throw new Error("Not supported")}}class I{constructor(r,o){this.name=r,this._channel=o}append(r){this._channel.then(o=>o.append(r))}appendLine(r){this._channel.then(o=>o.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,o){this._channel.then(v=>v.show(r,o))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=I;let d=class{constructor(r){this._proxy=r.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new C(r,this._proxy)}createOutputChannelFromLogFile(r,o){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!o)throw new Error("illegal argument `file`. must not be falsy");return new i(r,o,this._proxy)}};d=je([Ke(0,D.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(be[203],we([0,1,14,20,3,6,5,2,7,11,12,47]),function(Y,e,_,k,A,T,S,D,y,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(f,r,o){const v=f.getProxy(S.MainContext.MainThreadQuickOpen);class m{constructor(s,c){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=c}showQuickPick(s,c,l,h=k.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(s),g=++this._instances,w=v.$show(g,{title:l==null?void 0:l.title,placeHolder:l==null?void 0:l.placeHolder,matchOnDescription:l==null?void 0:l.matchOnDescription,matchOnDetail:l==null?void 0:l.matchOnDetail,ignoreFocusLost:l==null?void 0:l.ignoreFocusOut,canPickMany:l==null?void 0:l.canPickMany},h),R={},L=w.then(()=>R);return Promise.race([L,P]).then(V=>{if(V!==R)return P.then(he=>{const z=[];for(let W=0;W<he.length;W++){const J=he[W];let O,F,N,B,U;typeof J=="string"?O=J:(O=J.label,F=J.description,N=J.detail,B=J.picked,U=J.alwaysShow),z.push({label:O,description:F,handle:W,detail:N,picked:B,alwaysShow:U})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{l.onDidSelectItem(he[W])}),v.$setItems(g,z),w.then(W=>{if(typeof W=="number")return he[W];if(Array.isArray(W))return W.map(J=>he[J])})})}).then(void 0,V=>{if(!(0,C.isPromiseCanceledError)(V))return v.$setError(g,V),Promise.reject(V)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,c=k.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,v.$input(s,typeof this._validateInput=="function",c).then(void 0,l=>{if(!(0,C.isPromiseCanceledError)(l))return Promise.reject(l)})}$validateInput(s){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,c=k.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!l){const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(P=>P.uri.toString()===l.uri.toString())}}createQuickPick(s,c){const l=new t(s,c,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(s){const c=new n(s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(s,c){const l=this._sessions.get(s);l&&l._fireDidChangeValue(c)}$onDidAccept(s){const c=this._sessions.get(s);c&&c._fireDidAccept()}$onDidChangeActive(s,c){const l=this._sessions.get(s);l instanceof t&&l._fireDidChangeActive(c)}$onDidChangeSelection(s,c){const l=this._sessions.get(s);l instanceof t&&l._fireDidChangeSelection(c)}$onDidTriggerButton(s,c){const l=this._sessions.get(s);l&&l._fireDidTriggerButton(c)}$onDidHide(s){const c=this._sessions.get(s);c&&c._fireDidHide()}}class E{constructor(s,c){this._extensionId=s,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((c,l)=>{const h=c===y.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(h,c)}),this.update({buttons:s.map((c,l)=>({iconPath:p(c.iconPath),tooltip:c.tooltip,handle:c===y.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const c=this._handlesToButtons.get(s);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(s){if(!this._disposed){for(const c of Object.keys(s)){const l=s[c];this._pendingUpdate[c]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function p(a){if(a instanceof y.ThemeIcon)return{id:a.id};const s=b(a),c=u(a);return{dark:typeof s=="string"?D.URI.file(s):s,light:typeof c=="string"?D.URI.file(c):c}}function u(a){return typeof a=="object"&&"light"in a?a.light:a}function b(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends E{constructor(s,c,l){super(s,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((c,l)=>{this._handlesToItems.set(l,c),this._itemsToHandles.set(c,l)}),this.update({items:s.map((c,l)=>({label:c.label,description:c.description,handle:l,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(s){const c=(0,i.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(s){const c=(0,i.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class n extends E{constructor(s,c){super(s,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?I.default.Error:I.default.Ignore})}}return new m(r,o)}e.createExtHostQuickOpen=d}),define(be[204],we([0,1,2,3,53,6,14,5,12,111,19,26,33]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(s){if(s)return typeof s.iconPath=="string"?_.URI.file(s.iconPath):s.iconPath}function r(s,c){if(!s.iconPath&&!c.iconPath)return 0;if(s.iconPath){if(!c.iconPath)return 1}else return-1;const l=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,h=typeof c.iconPath=="string"?c.iconPath:c.iconPath.fsPath;return(0,C.comparePaths)(l,h)}function o(s,c){let l=0;if(s.strikeThrough!==c.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==c.faded)return s.faded?1:-1;if(s.tooltip!==c.tooltip)return(s.tooltip||"").localeCompare(c.tooltip||"");if(l=r(s,c),l!==0)return l;if(s.light&&c.light)l=r(s.light,c.light);else{if(s.light)return 1;if(c.light)return-1}if(l!==0)return l;if(s.dark&&c.dark)l=r(s.dark,c.dark);else{if(s.dark)return 1;if(c.dark)return-1}return l}function v(s,c){if(s.command!==c.command)return s.command<c.command?-1:1;if(s.title!==c.title)return s.title<c.title?-1:1;if(s.tooltip!==c.tooltip){if(s.tooltip!==void 0&&c.tooltip!==void 0)return s.tooltip<c.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(s.arguments===c.arguments)return 0;if(s.arguments)if(c.arguments){if(s.arguments.length!==c.arguments.length)return s.arguments.length-c.arguments.length}else return 1;else return-1;for(let l=0;l<s.arguments.length;l++){const h=s.arguments[l],P=c.arguments[l];if(h!==P)return h<P?-1:1}return 0}function m(s,c){let l=(0,C.comparePaths)(s.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(l!==0)return l;if(s.command&&c.command)l=v(s.command,c.command);else{if(s.command)return 1;if(c.command)return-1}if(l!==0)return l;if(s.decorations&&c.decorations)l=o(s.decorations,c.decorations);else{if(s.decorations)return 1;if(c.decorations)return-1}return l}function E(s,c){for(let l=0;l<s.length;l++)if(s[l]!==c[l])return!1;return!0}function p(s,c){return s.command===c.command&&s.title===c.title&&s.tooltip===c.tooltip&&(s.arguments&&c.arguments?E(s.arguments,c.arguments):s.arguments===c.arguments)}function u(s,c){return(0,y.equals)(s,c,p)}class b{constructor(c,l,h){this._extension=c,this._proxy=l,this._sourceControlHandle=h,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,d.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,l){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,l)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=b;class t{constructor(c,l,h,P,g){this._proxy=c,this._commands=l,this._sourceControlHandle=h,this._id=P,this._label=g,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,l){const h=this._resourceStatesCommandsMap.get(c);return h?(0,S.asPromise)(()=>this._commands.executeCommand(h.command,...h.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var c;const l=[...this._resourceStates].sort(m),P=(0,y.sortedDiff)(this._resourceSnapshot,l,m).map(R=>{const L=R.toInsert.map(V=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,V);const z=V.resourceUri,W=f(V.decorations),J=V.decorations&&f(V.decorations.light)||W,O=V.decorations&&f(V.decorations.dark)||W,F=[];let N;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const pe=new T.DisposableStore;N=this._commands.converter.toInternal(V.command,pe),this._resourceStatesDisposablesMap.set(he,pe)}else this._resourceStatesCommandsMap.set(he,V.command);J&&F.push(J),O&&O.toString()!==(J==null?void 0:J.toString())&&F.push(O);const B=V.decorations&&V.decorations.tooltip||"",U=V.decorations&&!!V.decorations.strikeThrough,Q=V.decorations&&!!V.decorations.faded,Z=V.contextValue||"";return{rawResource:[he,z,F,B,U,Q,Z,N],handle:he}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),g=P.map(({start:R,deleteCount:L,toInsert:V})=>[R,L,V.map(he=>he.rawResource)]),w=P.reverse();for(const{start:R,deleteCount:L,toInsert:V}of w){const he=V.map(W=>W.handle),z=this._handlesSnapshot.splice(R,L,...he);for(const W of z)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(c=this._resourceStatesDisposablesMap.get(W))===null||c===void 0||c.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=l,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(c,l,h,P,g,w){this._proxy=l,this._commands=h,this._id=P,this._label=g,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,g,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=c;const l=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:l})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(!(this._statusBarCommands&&c&&u(this._statusBarCommands,c))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=c;const l=(c||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:l})}}get selected(){return this._selected}createResourceGroup(c,l){const h=new t(this._proxy,this._commands,this.handle,c,l),P=k.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,P),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const c=[],l=[];for(const[h,P]of this.createdResourceGroups){P.dispose();const g=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});k.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),g.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),c.push([h.handle,h.id,h.label,h.features]);const w=h._takeResourceStateSnapshot();w.length>0&&l.push([h.handle,w]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,c,l),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(l=>{const h=l._takeResourceStateSnapshot();h.length!==0&&c.push([l.handle,h])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class Pn{constructor(c,l,h){this._commands=l,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=c.getProxy(D.MainContext.MainThreadSCM),this._telemetry=c.getProxy(D.MainContext.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const g=this._sourceControls.get(P.sourceControlHandle);if(!g)return P;const w=g.getResourceGroup(P.groupHandle);return w?w.getResourceState(P.handle):P}else if(P&&P.$mid===4){const g=this._sourceControls.get(P.sourceControlHandle);return g?g.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const g=this._sourceControls.get(P.handle);return g||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,l,h,P){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,l,h,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const g=Pn._handlePool++,w=new n(c,this._proxy,this._commands,l,h,P);this._sourceControls.set(g,w);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier))||[];return R.push(w),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(c.identifier),R),w}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const l=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier)),h=l&&l[l.length-1];return h&&h.inputBox}$provideOriginalResource(c,l,h){const P=_.URI.revive(l);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,P.toString());const g=this._sourceControls.get(c);return!g||!g.quickDiffProvider||!g.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>g.quickDiffProvider.provideOriginalResource(P,h)).then(w=>w||null)}$onInputBoxValueChange(c,l){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const h=this._sourceControls.get(c);return h&&h.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(c,l,h,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,l,h);const g=this._sourceControls.get(c);if(!g)return Promise.resolve(void 0);const w=g.getResourceGroup(l);return w?w.$executeResourceCommand(h,P):Promise.resolve(void 0)}$validateInput(c,l,h){this.logService.trace("ExtHostSCM#$validateInput",c);const P=this._sourceControls.get(c);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>P.inputBox.validateInput(l,h)).then(g=>g?Promise.resolve([g.message,g.type]):Promise.resolve(void 0))}$setSelectedSourceControl(c){var l,h;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&((l=this._sourceControls.get(c))===null||l===void 0||l.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((h=this._sourceControls.get(this._selectedSourceControlHandle))===null||h===void 0||h.setSelectionState(!1)),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};a._handlePool=0,a=je([Ke(2,i.ILogService)],a),e.ExtHostSCM=a});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[205],we([0,1,7,5,134,6]),function(Y,e,_,k,A,T){"use strict";var S,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(d,f,r,o,v=_.StatusBarAlignment.Left,m,E){S.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,S,d,"f"),tt(this,D,f,"f"),this._id=y.ID_GEN++,this._statusId=r,this._statusName=o,this._alignment=v,this._priority=m,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!y.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Me(this,D,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Me(this,D,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,f,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,D=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const f={message:d};return this._messages.unshift(f),this._update(),new _.Disposable(()=>{const r=this._messages.indexOf(f);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,f){this._proxy=d.getProxy(k.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new C(this)}createStatusBarEntry(d,f,r,o,v){return new y(this._proxy,this._commands,d,f,r,o,v)}setStatusBarMessage(d,f){const r=this._statusMessage.setMessage(d);let o;return typeof f=="number"?o=setTimeout(()=>r.dispose(),f):typeof f!="undefined"&&f.then(()=>r.dispose(),()=>r.dispose()),new _.Disposable(()=>{r.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=i}),define(be[78],we([0,1,5,3,4]),function(Y,e,_,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,y){this._proxy.$registerExtensionStorageKeysToSync(D,y)}getValue(D,y,C){return this._proxy.$getValue(D,y).then(i=>i||C)}setValue(D,y,C){return this._proxy.$setValue(D,y,C)}$acceptValue(D,y,C){this._onDidChangeStorage.fire({shared:D,key:y,value:C})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(be[79],we([0,1,4,27,19,77,2]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let D=class{constructor(C,i,I){var d;this._logService=i,this._extHostFileSystem=I,this._workspace=(d=C.workspace)!==null&&d!==void 0?d:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=S.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=S.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(C){if(this._value)return S.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return S.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=je([Ke(0,k.IExtHostInitDataService),Ke(1,A.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(be[40],we([0,1,3,5,4,2,15,6,7,135,11,172,20,29,155]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class o{constructor(t,n,a,s){this._proxy=t,this._id=n,this._creationOptions=a,this._name=s,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(l=>this._pidPromiseComplete=l);const c=this;this.value={get name(){return c._name||""},get processId(){return c._pidPromise},get creationOptions(){return c._creationOptions},get exitStatus(){return c._exitStatus},sendText(l,h=!0){c._checkDisposed(),c._proxy.$sendText(c._id,l,h)},show(l){c._checkDisposed(),c._proxy.$show(c._id,l)},hide(){c._checkDisposed(),c._proxy.$hide(c._id)},dispose(){c._disposed||(c._disposed=!0,c._proxy.$dispose(c._id))},get dimensions(){if(!(c._cols===void 0||c._rows===void 0))return{columns:c._cols,rows:c._rows}}}}async create(t,n,a,s,c,l,h,P,g,w,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:a,env:s,icon:c,initialText:l,waitOnExit:h,strictEnv:P,hideFromUser:g,isFeatureTerminal:w,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=o;class v{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let m=1,E=class extends D.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[a,s]of this._terminalProcesses)s.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new o(this._proxy,(0,f.generateUuid)(),t,t.name),a=new v(t.pty);return n.createExtensionTerminal().then(s=>{const c=this._setupExtHostProcessListeners(s,a);this._terminalProcessDisposables[s]=c}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const s=new v(n),c=this._setupExtHostProcessListeners(t,s);this._terminalProcessDisposables[t]=c}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(t);a&&(this._activeTerminal=a,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const a=this._getTerminalById(t);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:n})}async $acceptTerminalDimensions(t,n,a){const s=this._getTerminalById(t);s&&s.setDimensions(n,a)&&this._onDidChangeTerminalDimensions.fire({terminal:s.value,dimensions:s.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,a){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,a)}async $acceptTerminalTitleChange(t,n){const a=this._getTerminalById(t);a&&(a.name=n)}async $acceptTerminalClosed(t,n){const a=this._getTerminalObjectIndexById(this._terminals,t);if(a!==null){const s=this._terminals.splice(a,1)[0];s.setExitCode(n),this._onDidCloseTerminal.fire(s.value)}}$acceptTerminalOpened(t,n,a,s){if(n){const h=this._getTerminalObjectIndexById(this._terminals,n);if(h!==null){this._terminals[h]._id=t,this._onDidOpenTerminal.fire(this.terminals[h]),this._terminals[h].isOpen=!0;return}}const c={name:s.name,shellPath:s.executable,shellArgs:s.args,cwd:typeof s.cwd=="string"?s.cwd:T.URI.revive(s.cwd),env:s.env,hideFromUser:s.hideFromUser},l=new o(this._proxy,t,c,a);this._terminals.push(l),this._onDidOpenTerminal.fire(l.value),l.isOpen=!0}async $acceptTerminalProcessId(t,n){const a=this._getTerminalById(t);a&&a._setProcessId(n)}async $startExtensionTerminal(t,n){const a=this._getTerminalById(t);if(!a)return{message:(0,C.localize)(0,null,t)};a.isOpen||await new Promise(c=>{const l=this.onDidOpenTerminal(async h=>{h===a.value&&(l.dispose(),c())})});const s=this._terminalProcesses.get(t);s?s.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const a=new D.DisposableStore;a.add(n.onProcessReady(c=>this._proxy.$sendProcessReady(t,c.pid,c.cwd))),a.add(n.onProcessTitleChanged(c=>this._proxy.$sendProcessTitle(t,c))),this._bufferer.startBuffering(t,n.onProcessData),a.add(n.onProcessExit(c=>this._onProcessExit(t,c))),n.onProcessOverrideDimensions&&a.add(n.onProcessOverrideDimensions(c=>this._proxy.$sendOverrideDimensions(t,c))),this._terminalProcesses.set(t,n);const s=this._extensionTerminalAwaitingStart[t];return s&&n instanceof v&&(n.startSendingEvents(s.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),a}$acceptProcessAckDataEvent(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.input(n)}$acceptProcessResize(t,n,a){var s;try{(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,a)}catch(c){if(c.code!=="EPIPE"&&c.code!=="ERR_IPC_CHANNEL_CLOSED")throw c}}$acceptProcessShutdown(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(t,a))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(a=>this._proxy.$sendProcessCwd(t,a))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const a=this._getTerminalById(t);if(!a)return[];this._terminalLinkCache.delete(t);const s=this._terminalLinkCancellationSource.get(t);s&&s.dispose(!0);const c=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,c);const l=[],h={terminal:a.value,line:n},P=[];for(const R of this._linkProviders)P.push(new Promise(async L=>{c.token.onCancellationRequested(()=>L({provider:R,links:[]}));const V=await R.provideTerminalLinks(h,c.token)||[];c.token.isCancellationRequested||L({provider:R,links:V})}));const g=await Promise.all(P);if(c.token.isCancellationRequested)return[];const w=new Map;for(const R of g)R&&R.links.length>0&&l.push(...R.links.map(L=>{const V={id:m++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return w.set(V.id,{provider:R.provider,link:L}),V}));return this._terminalLinkCache.set(t,w),l}$activateLink(t,n){var a;const s=(a=this._terminalLinkCache.get(t))===null||a===void 0?void 0:a.get(n);!s||s.provider.handleTerminalLink(s.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const a=this._terminalProcessDisposables[t];a&&(a.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const a=this._getTerminalObjectIndexById(t,n);return a!==null?t[a]:null}_getTerminalObjectIndexById(t,n){let a=null;return t.some((s,c)=>s._id===n?(a=c,!0):!1),a}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new p,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const a=(0,I.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const a=n[0],s=new p(n[1]);this._setEnvironmentVariableCollection(a,s)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=je([Ke(1,S.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class p{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const a=this.map.get(t);(!a||a.value!==n.value||a.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((a,s)=>t.call(n,s,a,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let u=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,a){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}async $getDefaultShellAndArgs(t){throw new i.NotSupportedError}};u=je([Ke(0,S.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(be[206],we([0,1,3,12,5,97,9,7]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(d=>d.value)}async showTextDocument(i,I,d){let f;typeof I=="number"?f={position:S.ViewColumn.from(I),preserveFocus:d}:typeof I=="object"?f={position:S.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?S.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:f={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,f),o=r&&this._extHostDocumentsAndEditors.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,I){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(I.options&&d._acceptOptions(I.options),I.selections){const f=I.selections.selections.map(S.Selection.to);d._acceptSelections(f)}if(I.visibleRanges){const f=k.coalesce(I.visibleRanges.map(S.Range.to));d._acceptVisibleRanges(f)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const f=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),r=I.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:f})}if(I.visibleRanges){const f=k.coalesce(I.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:f})}}$acceptEditorPositionData(i){for(const I in i){const d=this._extHostDocumentsAndEditors.getEditor(I);if(!d)throw new Error("Unknown text editor");const f=S.ViewColumn.to(i[I]);d.value.viewColumn!==f&&(d._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:f}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=y});var $t=this&&this.__rest||function(Y,e){var _={};for(var k in Y)Object.prototype.hasOwnProperty.call(Y,k)&&e.indexOf(k)<0&&(_[k]=Y[k]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(Y);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(Y,k[A])&&(_[k[A]]=Y[k[A]]);return _};define(be[207],we([0,1,2,4,5,6,7]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class D{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:d=>{var f,r;if(d&&d.$mid===11){const o=d.uri===void 0?void 0:_.URI.revive(d.uri);return(r=(f=this._itemsBySourceAndUriMap.get(d.source))===null||f===void 0?void 0:f.get(y(o)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(i,I,d,f,r){const o=this._providers.get(i);return o==null?void 0:o.provideTimeline(_.URI.revive(I),d,f,r)}registerTimelineProvider(i,I,d,f){const r=new T.DisposableStore,o=this.convertTimelineItem(I.id,f,r).bind(this);let v;I.onDidChange&&(v=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(E,p,u,b){var t;(b==null?void 0:b.resetCache)&&(r.clear(),(t=m.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(E,p,u);if(n!=null){const a=o(E,b);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(a)})}},dispose(){var E;for(const p of m.values())(E=p.get(I.id))===null||E===void 0||E.clear();v==null||v.dispose(),r.dispose()}}))}convertTimelineItem(i,I,d){return(f,r)=>{let o;if(r==null?void 0:r.cacheResults){let v=this._itemsBySourceAndUriMap.get(i);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(i,v));const m=y(f);o=v.get(m),o===void 0&&(o=new Map,v.set(m,o))}return v=>{var m,E;const{iconPath:p}=v,u=$t(v,["iconPath"]),b=`${i}|${(m=v.id)!==null&&m!==void 0?m:v.timestamp}`;o==null||o.set(b,v);let t,n,a;return v.iconPath&&(p instanceof S.ThemeIcon?a={id:p.id}:_.URI.isUri(p)?(t=p,n=p):{light:t,dark:n}=p),Object.assign(Object.assign({},u),{id:(E=u.id)!==null&&E!==void 0?E:void 0,handle:b,source:i,command:v.command?I.toInternal(v.command,d):void 0,icon:t,iconDark:n,themeIcon:a,accessibilityInformation:v.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const f of this._itemsBySourceAndUriMap.values())(d=f.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function y(C){return C==null?void 0:C.toString()}}),define(be[208],we([0,1,6,18,2,5]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const d=I.schemes.find(f=>!S.supportedSchemes.has(f));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,y,I.label),(0,_.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(y,C,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const d=A.URI.revive(C);return I.canOpenExternalUri(d,i)}async $openUri(y,C,i){const I=this._openers.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(A.URI.revive(C.resolvedUri),{sourceUri:A.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(be[209],we([0,1,5,2,6,11,26]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(S.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),(0,A.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(k.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(C){return k.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[51],we([0,1,23,3,2,144,165,50,5]),function(Y,e,_,k,A,T,S,D,y){"use strict";var C,i,I,d,f,r,o,v,m,E,p,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class b{constructor(g,w,R,L,V,he,z){C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,""),v.set(this,void 0),m.set(this,!1),E.set(this,!1),p.set(this,!1),this._onMessageEmitter=new k.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new k.Emitter),this._onDidDispose=Me(this,u,"f").event,tt(this,C,g,"f"),tt(this,i,w,"f"),tt(this,v,R,"f"),tt(this,d,L,"f"),tt(this,f,V,"f"),tt(this,r,he,"f"),tt(this,p,t(he),"f"),tt(this,I,z,"f")}dispose(){tt(this,m,!0,"f"),Me(this,u,"f").fire(),Me(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return tt(this,E,!0,"f"),(0,D.asWebviewUri)(Me(this,d,"f"),Me(this,C,"f"),g)}get cspSource(){return Me(this,d,"f").webviewCspSource.replace("{{uuid}}",Me(this,C,"f"))}get html(){return this.assertNotDisposed(),Me(this,o,"f")}set html(g){this.assertNotDisposed(),Me(this,o,"f")!==g&&(tt(this,o,g,"f"),!Me(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(tt(this,E,!0,"f"),Me(this,I,"f").report("Webview vscode-resource: uris",Me(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,i,"f").$setHtml(Me(this,C,"f"),g))}get options(){return this.assertNotDisposed(),Me(this,v,"f")}set options(g){this.assertNotDisposed(),Me(this,i,"f").$setOptions(Me(this,C,"f"),c(Me(this,r,"f"),Me(this,f,"f"),g)),tt(this,v,g,"f")}async postMessage(g){if(Me(this,m,"f"))return!1;const w=n(g,{serializeBuffersForPostMessage:Me(this,p,"f")});return Me(this,i,"f").$postMessage(Me(this,C,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Me(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=b,C=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,v=new WeakMap,m=new WeakMap,E=new WeakMap,p=new WeakMap,u=new WeakMap;function t(P){if(!P.enableProposedApi)return!1;try{const g=(0,T.normalizeVersion)((0,T.parseVersion)(P.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=56}catch(g){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(P,g){if(g.serializeBuffersForPostMessage){const w=[],R=(V,he)=>{if(he&&he instanceof ArrayBuffer){let z=w.findIndex(W=>W.original===he);if(z===-1){const W=new Uint8Array(he),J=_.VSBuffer.wrap(W);z=w.length,w.push({original:he,vsBuffer:J})}return{$$vscode_array_buffer_reference$$:!0,index:z}}return he};return{message:JSON.stringify(P,R),buffers:w.map(V=>V.vsBuffer)}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeMessage=n;class a{constructor(g,w,R,L,V){this.initData=w,this.workspace=R,this._logService=L,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=g.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(g,w,...R){const L=this.getWebview(g);if(L){const{message:V}=(0,S.deserializeWebviewMessage)(w,R);L._onMessageEmitter.fire(V)}}$onMissingCsp(g,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,w,R){const L=new b(g,this._webviewProxy,l(w),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(g,L),L._onDidDispose(()=>{this._webviews.delete(g)}),L}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=a;function s(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=s;function c(P,g,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||h(P,g)}}e.serializeWebviewOptions=c;function l(P){var g;return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:(g=P.localResourceRoots)===null||g===void 0?void 0:g.map(w=>A.URI.from(w))}}e.reviveOptions=l;function h(P,g){return[...((g==null?void 0:g.getWorkspaceFolders())||[]).map(w=>w.uri),P.extensionLocation]}}),define(be[210],we([0,1,20,57,6,18,25,2,9,51,69,5,7]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,a){const s=this.key(t,n.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const c=new f(n,a);return this._documents.set(s,c),c}delete(t,n){const a=this.key(t,n.uri);this._documents.delete(a)}key(t,n){return`${t}@@@${n}`}}var o;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(o||(o={}));class v{constructor(){this._providers=new Map}addTextProvider(t,n,a){return this.add(0,t,n,a)}addCustomProvider(t,n,a){return this.add(1,t,n,a)}get(t){return this._providers.get(t)}add(t,n,a,s){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:a,provider:s}),new d.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,a,s,c){this._extHostDocuments=n,this._extensionStoragePaths=a,this._extHostWebview=s,this._extHostWebviewPanels=c,this._editorProviders=new v,this._documents=new r,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,a,s){const c=new A.DisposableStore;return E(a)?(c.add(this._editorProviders.addTextProvider(n,t,a)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),n,s.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(n,t,a)),this.supportEditing(a)&&c.add(a.onDidChangeCustomDocument(l=>{const h=this.getCustomDocumentEntry(n,l.document.uri);if(p(l)){const P=h.addEdit(l);this._proxy.$onDidEdit(l.document.uri,n,P,l.label)}else this._proxy.$onContentChange(l.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),n,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(c,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,a,s,c){var l;const h=this._editorProviders.get(n);if(!h)throw new Error(`No provider found for '${n}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=D.URI.revive(t),g=await h.provider.openCustomDocument(P,{backupId:a,untitledDocumentData:s==null?void 0:s.buffer},c);let w;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(w=(l=this._extensionStoragePaths.workspaceValue(h.extension))!==null&&l!==void 0?l:this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(n,g,w),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,n){const a=this._editorProviders.get(n);if(!a)throw new Error(`No provider found for '${n}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${n}'`);const s=D.URI.revive(t),{document:c}=this.getCustomDocumentEntry(n,s);this._documents.delete(n,c),c.dispose()}async $resolveWebviewEditor(t,n,a,s,c,l){const h=this._editorProviders.get(a);if(!h)throw new Error(`No provider found for '${a}'`);const P=y.ViewColumn.to(c),g=this._extHostWebview.createNewWebview(n,s.webviewOptions,h.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(n,a,s.title,P,s.panelOptions,g),R=D.URI.revive(t);switch(h.type){case 1:{const{document:L}=this.getCustomDocumentEntry(a,R);return h.provider.resolveCustomEditor(L,w,l)}case 0:{const L=this._extHostDocuments.getDocument(R);return h.provider.resolveCustomTextEditor(L,w,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,a){this.getCustomDocumentEntry(n,t).disposeEdits(a)}async $onMoveCustomEditor(t,n,a){const s=this._editorProviders.get(a);if(!s)throw new Error(`No provider found for '${a}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const l=D.URI.revive(n),h=this._extHostDocuments.getDocument(l);await s.provider.moveCustomTextEditor(h,c,_.CancellationToken.None)}async $undo(t,n,a,s){return this.getCustomDocumentEntry(n,t).undo(a,s)}async $redo(t,n,a,s){return this.getCustomDocumentEntry(n,t).redo(a,s)}async $revert(t,n,a){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(s.document,a),s.disposeBackup()}async $onSave(t,n,a){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(s.document,a),s.disposeBackup()}async $onSaveAs(t,n,a,s){const c=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(c.document,D.URI.revive(a),s)}async $backup(t,n,a){const s=this.getCustomDocumentEntry(n,t),l=await this.getCustomEditorProvider(n).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},a);return s.updateBackup(l),l.id}getCustomDocumentEntry(t,n){const a=this._documents.get(t,D.URI.revive(n));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const n=this._editorProviders.get(t),a=n==null?void 0:n.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function E(b){return typeof b.resolveCustomTextEditor=="function"}function p(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function u(b){const t=b.scheme===T.Schemas.file||b.scheme===T.Schemas.untitled?b.fsPath:b.toString();return(0,k.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[211],we([0,1,3,6,2,29,9,51,5,7]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";var i,I,d,f,r,o,v,m,E,p,u,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends k.Disposable{constructor(l,h,P,g,w,R,L){super();i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,void 0),v.set(this,void 0),m.set(this,void 0),E.set(this,!0),p.set(this,!0),u.set(this,!1),b.set(this,this._register(new _.Emitter)),this.onDidDispose=Me(this,b,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,i,l,"f"),tt(this,I,h,"f"),tt(this,d,P,"f"),tt(this,r,R,"f"),tt(this,m,w,"f"),tt(this,o,g,"f"),tt(this,f,L,"f")}dispose(){Me(this,u,"f")||(tt(this,u,!0,"f"),Me(this,b,"f").fire(),Me(this,I,"f").$disposeWebview(Me(this,i,"f")),Me(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,f,"f")}get viewType(){return this.assertNotDisposed(),Me(this,d,"f")}get title(){return this.assertNotDisposed(),Me(this,o,"f")}set title(l){this.assertNotDisposed(),Me(this,o,"f")!==l&&(tt(this,o,l,"f"),Me(this,I,"f").$setTitle(Me(this,i,"f"),l))}get iconPath(){return this.assertNotDisposed(),Me(this,v,"f")}set iconPath(l){this.assertNotDisposed(),Me(this,v,"f")!==l&&(tt(this,v,l,"f"),Me(this,I,"f").$setIconPath(Me(this,i,"f"),A.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Me(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,m,"f")=="number"&&Me(this,m,"f")<0))return Me(this,m,"f")}get active(){return this.assertNotDisposed(),Me(this,p,"f")}get visible(){return this.assertNotDisposed(),Me(this,E,"f")}_updateViewState(l){Me(this,u,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(tt(this,p,l.active,"f"),tt(this,E,l.visible,"f"),tt(this,m,l.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(l,h){this.assertNotDisposed(),Me(this,I,"f").$reveal(Me(this,i,"f"),{viewColumn:l?S.ViewColumn.from(l):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Me(this,u,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,d=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,v=new WeakMap,m=new WeakMap,E=new WeakMap,p=new WeakMap,u=new WeakMap,b=new WeakMap,t=new WeakMap;class a{constructor(l,h,P){this.webviews=h,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=l.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(l,h,P,g,w={}){const R=typeof g=="object"?g.viewColumn:g,L={viewColumn:S.ViewColumn.from(R),preserveFocus:typeof g=="object"&&!!g.preserveFocus},V=(0,D.shouldSerializeBuffersForPostMessage)(l),he=a.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(l),he,h,{title:P,panelOptions:s(w),webviewOptions:(0,D.serializeWebviewOptions)(l,this.workspace,w),serializeBuffersForPostMessage:V},L);const z=this.webviews.createNewWebview(he,w,l);return this.createNewWebviewPanel(he,h,P,R,w,z)}$onDidChangeWebviewPanelViewStates(l){const h=Object.keys(l);h.sort((P,g)=>{const w=l[P],R=l[g];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const P of h){const g=this.getWebviewPanel(P);if(!!g){const w=l[P];g._updateViewState({active:w.active,visible:w.visible,viewColumn:S.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(l){const h=this.getWebviewPanel(l);h==null||h.dispose(),this._webviewPanels.delete(l),this.webviews.deleteWebview(l)}registerWebviewPanelSerializer(l,h,P){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:P,extension:l}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(l)}),new C.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(l,h,P,g){const w=this._serializers.get(h);if(!w)throw new Error(`No serializer found for '${h}'`);const{serializer:R,extension:L}=w,V=this.webviews.createNewWebview(l,P.webviewOptions,L),he=this.createNewWebviewPanel(l,h,P.title,g,P.panelOptions,V);await R.deserializeWebviewPanel(he,P.state)}createNewWebviewPanel(l,h,P,g,w,R){const L=new n(l,this._proxy,h,P,g,w,R);return this._webviewPanels.set(l,L),L}getWebviewPanel(l){return this._webviewPanels.get(l)}}e.ExtHostWebviewPanels=a;function s(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[212],we([0,1,3,6,51,5,7]),function(Y,e,_,k,A,T,S){"use strict";var D,y,C,i,I,d,f,r,o,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends k.Disposable{constructor(u,b,t,n,a,s){super();D.set(this,void 0),y.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),d.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Me(this,o,"f").event,v.set(this,this._register(new _.Emitter)),this.onDidDispose=Me(this,v,"f").event,tt(this,C,t,"f"),tt(this,f,n,"f"),tt(this,D,u,"f"),tt(this,y,b,"f"),tt(this,i,a,"f"),tt(this,d,s,"f")}dispose(){Me(this,I,"f")||(tt(this,I,!0,"f"),Me(this,v,"f").fire(),Me(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,f,"f")}set title(u){this.assertNotDisposed(),Me(this,f,"f")!==u&&(tt(this,f,u,"f"),Me(this,y,"f").$setWebviewViewTitle(Me(this,D,"f"),u))}get description(){return this.assertNotDisposed(),Me(this,r,"f")}set description(u){this.assertNotDisposed(),Me(this,r,"f")!==u&&(tt(this,r,u,"f"),Me(this,y,"f").$setWebviewViewDescription(Me(this,D,"f"),u))}get visible(){return Me(this,d,"f")}get webview(){return Me(this,i,"f")}get viewType(){return Me(this,C,"f")}_setVisible(u){u===Me(this,d,"f")||Me(this,I,"f")||(tt(this,d,u,"f"),Me(this,o,"f").fire())}show(u){this.assertNotDisposed(),Me(this,y,"f").$show(Me(this,D,"f"),!!u)}assertNotDisposed(){if(Me(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,y=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,v=new WeakMap;class E{constructor(u,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,b,t,n){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(u),b,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(u,b,t,n,a){const s=this._viewProviders.get(b);if(!s)throw new Error(`No view provider found for '${b}'`);const{provider:c,extension:l}=s,h=this._extHostWebview.createNewWebview(u,{},l),P=new m(u,this._proxy,b,t,h,!0);this._webviewViews.set(u,P),await c.resolveWebviewView(P,{state:n},a)}async $onDidChangeWebviewViewVisibility(u,b){this.getWebviewView(u)._setVisible(b)}async $disposeWebviewView(u){const b=this.getWebviewView(u);this._webviewViews.delete(u),b.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const b=this._webviewViews.get(u);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=E}),define(be[101],we([0,1,3,5,2,18,8,4,15]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class An{constructor(I){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=An.InitialState,this._proxy=I.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,d){let f;if(typeof I=="string"){f=I;try{I=A.URI.parse(I)}catch(r){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,S.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,f,d)}async asExternalUri(I,d){if((0,S.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const f=await this._proxy.$asExternalUri(I,d);return A.URI.from(f)}};C.InitialState={focused:!0},C=je([Ke(0,y.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(be[213],we([0,1,19,5,27,15]),function(Y,e,_,k,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends _.AbstractLogger{constructor(y,C){super();this._proxy=y.getProxy(k.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...C){this.getLevel()<=_.LogLevel.Trace&&this._proxy.$log(this._logFile,_.LogLevel.Trace,Array.from(arguments))}debug(y,...C){this.getLevel()<=_.LogLevel.Debug&&this._proxy.$log(this._logFile,_.LogLevel.Debug,Array.from(arguments))}info(y,...C){this.getLevel()<=_.LogLevel.Info&&this._proxy.$log(this._logFile,_.LogLevel.Info,Array.from(arguments))}warn(y,...C){this.getLevel()<=_.LogLevel.Warning&&this._proxy.$log(this._logFile,_.LogLevel.Warning,Array.from(arguments))}error(y,...C){this.getLevel()<=_.LogLevel.Error&&this._proxy.$log(this._logFile,_.LogLevel.Error,Array.from(arguments))}critical(y,...C){this.getLevel()<=_.LogLevel.Critical&&this._proxy.$log(this._logFile,_.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([Ke(0,T.IExtHostRpcService),Ke(1,A.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(be[214],we([0,1,14,20,11,3,6,112,186,98,23]),function(Y,e,_,k,A,T,S,D,y,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(s,c){try{return JSON.stringify(s,c)}catch(l){return"null"}}function f(s,c){return JSON.stringify(s,c)}function r(s){return s?(c,l)=>l&&l.$mid===1?s.transformOutgoing(l):l:null}var o;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},E=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class u extends S.Disposable{constructor(c,l=null,h=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=l,this._uriTransformer=h,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,g=C.ProxyIdentifier.count;P<g;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,D.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:l,sid:h}=c;return this._proxies[l]||(this._proxies[l]=this._createProxy(l,h)),this._proxies[l]}_createProxy(c,l){let h={get:(P,g)=>(typeof g=="string"&&!P[g]&&g.charCodeAt(0)===36&&(P[g]=(...w)=>this._remoteCall(c,g,w)),g===p?l:P[g])};return new Proxy(Object.create(null),h)}set(c,l){return this._locals[c.nid]=l,l}assertRegistered(c){for(let l=0,h=c.length;l<h;l++){const P=c[l];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(c){if(!this._isDisposed){const l=c.byteLength,h=b.read(c,0),P=h.readUInt8(),g=h.readUInt32();switch(P){case 1:case 2:{let{rpcId:w,method:R,args:L}=t.deserializeRequestJSONArgs(h);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(l,g,w,R,L,P===2);break}case 3:case 4:{let{rpcId:w,method:R,args:L}=t.deserializeRequestMixedArgs(h);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(l,g,w,R,L,P===4);break}case 5:{this._logger&&this._logger.logIncoming(l,g,0,"ack"),this._onDidReceiveAcknowledge(g);break}case 6:{this._receiveCancel(l,g);break}case 7:{this._receiveReply(l,g,void 0);break}case 9:{let w=t.deserializeReplyOKJSON(h);this._uriTransformer&&(w=(0,D.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(l,g,w);break}case 8:{let w=t.deserializeReplyOKVSBuffer(h);this._receiveReply(l,g,w);break}case 10:{let w=t.deserializeReplyErrError(h);this._uriTransformer&&(w=(0,D.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(l,g,w);break}case 11:{this._receiveReplyErr(l,g,void 0);break}default:console.error("received unexpected message"),console.error(c)}}}_receiveRequest(c,l,h,P,g,w){this._logger&&this._logger.logIncoming(c,l,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(h)}.${P}(`,g);const R=String(l);let L,V;if(w){const z=new k.CancellationTokenSource;g.push(z.token),L=this._invokeHandler(h,P,g),V=()=>z.cancel()}else L=this._invokeHandler(h,P,g),V=m;this._cancelInvokedHandlers[R]=V;const he=t.serializeAcknowledged(l);this._logger&&this._logger.logOutgoing(he.byteLength,l,1,"ack"),this._protocol.send(he),L.then(z=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyOK(l,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,l,1,"reply:",z),this._protocol.send(W)},z=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyErr(l,z);this._logger&&this._logger.logOutgoing(W.byteLength,l,1,"replyErr:",z),this._protocol.send(W)})}_receiveCancel(c,l){this._logger&&this._logger.logIncoming(c,l,1,"receiveCancel");const h=String(l);this._cancelInvokedHandlers[h]&&this._cancelInvokedHandlers[h]()}_receiveReply(c,l,h){this._logger&&this._logger.logIncoming(c,l,0,"receiveReply:",h);const P=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(P)){const g=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],g.resolveOk(h)}}_receiveReplyErr(c,l,h){this._logger&&this._logger.logIncoming(c,l,0,"receiveReplyErr:",h);const P=String(l);if(!!this._pendingRPCReplies.hasOwnProperty(P)){const g=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let w;h&&(h.$isError?(w=new Error,w.name=h.name,w.message=h.message,w.stack=h.stack):w=h),g.resolveErr(w)}}_invokeHandler(c,l,h){try{return Promise.resolve(this._doInvokeHandler(c,l,h))}catch(P){return Promise.reject(P)}}_doInvokeHandler(c,l,h){const P=this._locals[c];if(!P)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(c));let g=P[l];if(typeof g!="function")throw new Error("Unknown method "+l+" on actor "+(0,C.getStringIdentifierForProxy)(c));return g.apply(P,h)}_remoteCall(c,l,h){if(this._isDisposed)return Promise.reject(A.canceled());let P=null;if(h.length>0&&k.CancellationToken.isCancellationToken(h[h.length-1])&&(P=h.pop()),P&&P.isCancellationRequested)return Promise.reject(A.canceled());const g=t.serializeRequestArguments(h,this._uriReplacer),w=++this._lastMessageId,R=String(w),L=new y.LazyPromise;P&&P.onCancellationRequested(()=>{const he=t.serializeCancel(w);this._logger&&this._logger.logOutgoing(he.byteLength,w,0,"cancel"),this._protocol.send(t.serializeCancel(w))}),this._pendingRPCReplies[R]=L,this._onWillSendRequest(w);const V=t.serializeRequest(w,c,l,g,!!P);return this._logger&&this._logger.logOutgoing(V.byteLength,w,0,`request: ${(0,C.getStringIdentifierForProxy)(c)}.${l}(`,h),this._protocol.send(V),L}}e.RPCProtocol=u,I=E,u.UNRESPONSIVE_TIME=3*1e3;class b{constructor(c,l){this._buff=c,this._offset=l}static alloc(c,l,h){let P=new b(i.VSBuffer.alloc(h+1+4),0);return P.writeUInt8(c),P.writeUInt32(l),P}static read(c,l){return new b(c,l)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const h=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,h}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,h}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const l=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,l}static sizeMixedArray(c,l){let h=0;h+=1;for(let P=0,g=c.length;P<g;P++){const w=c[P],R=l[P];switch(h+=1,R){case 1:h+=this.sizeLongString(w);break;case 2:h+=this.sizeVSBuffer(w);break;case 3:break}}return h}writeMixedArray(c,l){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let h=0,P=c.length;h<P;h++){const g=c[h];switch(l[h]){case 1:this.writeUInt8(1),this.writeLongString(g);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let l=new Array(c);for(let h=0;h<c;h++)switch(this.readUInt8()){case 1:l[h]=this.readLongString();break;case 2:l[h]=this.readVSBuffer();break;case 3:l[h]=void 0;break}return l}}class t{static _arrayContainsBufferOrUndefined(c){for(let l=0,h=c.length;l<h;l++)if(c[l]instanceof i.VSBuffer||typeof c[l]=="undefined")return!0;return!1}static serializeRequestArguments(c,l){if(this._arrayContainsBufferOrUndefined(c)){let h=[],P=[];for(let g=0,w=c.length;g<w;g++){const R=c[g];R instanceof i.VSBuffer?(h[g]=R,P[g]=2):typeof R=="undefined"?(h[g]=i.VSBuffer.alloc(0),P[g]=3):(h[g]=i.VSBuffer.fromString(f(R,l)),P[g]=1)}return{type:"mixed",args:h,argsType:P}}return{type:"simple",args:f(c,l)}}static serializeRequest(c,l,h,P,g){return P.type==="mixed"?this._requestMixedArgs(c,l,h,P.args,P.argsType,g):this._requestJSONArgs(c,l,h,P.args,g)}static _requestJSONArgs(c,l,h,P,g){const w=i.VSBuffer.fromString(h),R=i.VSBuffer.fromString(P);let L=0;L+=b.sizeUInt8(),L+=b.sizeShortString(w),L+=b.sizeLongString(R);let V=b.alloc(g?2:1,c,L);return V.writeUInt8(l),V.writeShortString(w),V.writeLongString(R),V.buffer}static deserializeRequestJSONArgs(c){const l=c.readUInt8(),h=c.readShortString(),P=c.readLongString();return{rpcId:l,method:h,args:JSON.parse(P)}}static _requestMixedArgs(c,l,h,P,g,w){const R=i.VSBuffer.fromString(h);let L=0;L+=b.sizeUInt8(),L+=b.sizeShortString(R),L+=b.sizeMixedArray(P,g);let V=b.alloc(w?4:3,c,L);return V.writeUInt8(l),V.writeShortString(R),V.writeMixedArray(P,g),V.buffer}static deserializeRequestMixedArgs(c){const l=c.readUInt8(),h=c.readShortString(),P=c.readMixedArray(),g=new Array(P.length);for(let w=0,R=P.length;w<R;w++){const L=P[w];typeof L=="string"?g[w]=JSON.parse(L):g[w]=L}return{rpcId:l,method:h,args:g}}static serializeAcknowledged(c){return b.alloc(5,c,0).buffer}static serializeCancel(c){return b.alloc(6,c,0).buffer}static serializeReplyOK(c,l,h){return typeof l=="undefined"?this._serializeReplyOKEmpty(c):l instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(c,l):this._serializeReplyOKJSON(c,d(l,h))}static _serializeReplyOKEmpty(c){return b.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,l){let h=0;h+=b.sizeVSBuffer(l);let P=b.alloc(8,c,h);return P.writeVSBuffer(l),P.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,l){const h=i.VSBuffer.fromString(l);let P=0;P+=b.sizeLongString(h);let g=b.alloc(9,c,P);return g.writeLongString(h),g.buffer}static deserializeReplyOKJSON(c){const l=c.readLongString();return JSON.parse(l)}static serializeReplyErr(c,l){return l?this._serializeReplyErrEror(c,l):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,l){const h=i.VSBuffer.fromString(d(A.transformErrorForSerialization(l),null));let P=0;P+=b.sizeLongString(h);let g=b.alloc(10,c,P);return g.writeLongString(h),g.buffer}static deserializeReplyErrError(c){const l=c.readLongString();return JSON.parse(l)}static _serializeReplyErrEmpty(c){return b.alloc(11,c,0).buffer}}var n;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var a;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(a||(a={}))}),define(be[215],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const _=function(T){const S=D=>{self.removeEventListener("message",S);const y=D.data;Object.defineProperties(self,{postMessage:{value(C,i){y.postMessage(C,i)}},onmessage:{get(){return y.onmessage},set(C){y.onmessage=C}}}),y.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",S)}.toString();class k extends EventTarget{constructor(T,S,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${_})('${S}'))`,C=new Blob([y],{type:"application/javascript"}),i=URL.createObjectURL(C),I=new MessageChannel,d=i,f={type:"_newWorker",id:d,port:I.port2,url:i,options:D};T(f,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};I.port1.postMessage(r),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(r){I.port1.onmessage=r}},onmessageerror:{get(){return I.port1.onmessageerror},set(r){I.port1.onmessageerror=r}}}),I.port1.addEventListener("messageerror",r=>{const o=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(o)}),I.port1.addEventListener("message",r=>{const o=new MessageEvent("message",{data:r.data});this.dispatchEvent(o)}),I.port1.start()}}e.NestedWorker=k}),define(be[216],we([0,1,4]),function(Y,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(be[217],we([0,1,18,13,21,2,4,216]),function(Y,e,_,k,A,T,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||A.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?k.win32:k.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const f=i.indexOf("/",2);f===-1?(I=i.substring(2),i="/"):(I=i.substring(2,f),i=i.substring(f)||"/")}return T.URI.from({scheme:_.Schemas.file,authority:I,path:i,query:"",fragment:""})}};y=je([Ke(1,D.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[41],we([0,1,12,28,24,37,8,4,13,11]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",I=" characters skipped \u27EB",d=(i.length+I.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var f;(function(O){O[O.file=0]="file",O[O.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(O){O[O.File=1]="File",O[O.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function o(O){return!!O.preview}e.resultIsMatch=o;function v(O){return!!O.resource}e.isFileMatch=v;function m(O){return!!O.message}e.isProgressMessage=m;var E;(function(O){O[O.Normal=0]="Normal",O[O.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(F){this.resource=F,this.results=[]}}e.FileMatch=p;class u{constructor(F,N,B){this.ranges=N;const U=Array.isArray(N)?N:[N];if(B&&B.matchLines===1&&b(U)){F=(0,S.getNLines)(F,B.matchLines);let Q="",Z=0,ne=0;const pe=Math.floor(B.charsPerLine/5),Pe=[];for(const Oe of U){const Te=Math.max(Oe.startColumn-pe,0),xe=Oe.startColumn+B.charsPerLine;if(Te>ne+pe+d){const $=i+(Te-ne)+I;Q+=$+F.slice(Te,xe),Z+=Te-(ne+$.length)}else Q+=F.slice(ne,xe);Pe.push(new n(0,Oe.startColumn-Z,Oe.endColumn-Z)),ne=xe}this.preview={text:Q,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const Q=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:F,matches:(0,_.mapArrayOrNot)(N,Z=>new t(Z.startLineNumber-Q,Z.startColumn,Z.endLineNumber-Q,Z.endColumn))}}}}e.TextSearchMatch=u;function b(O){const F=O[0].startLineNumber;for(const N of O)if(N.startLineNumber!==F||N.endLineNumber!==F)return!1;return!0}class t{constructor(F,N,B,U){this.startLineNumber=F,this.startColumn=N,this.endLineNumber=B,this.endColumn=U}}e.SearchRange=t;class n extends t{constructor(F,N,B){super(F,N,F,B)}}e.OneLineRange=n;var a;(function(O){O.Default="default",O.FileNames="fileNames",O.Type="type",O.Modified="modified",O.CountDescending="countDescending",O.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function s(O,F=!0){const N=O&&O.files&&O.files.exclude,B=F&&O&&O.search&&O.search.exclude;if(!(!N&&!B)){if(!N||!B)return N||B;let U=Object.create(null);return U=A.mixin(U,A.deepClone(N)),U=A.mixin(U,A.deepClone(B),!0),U}}e.getExcludes=s;function c(O,F){return O.excludePattern&&k.match(O.excludePattern,F)?!1:O.includePattern||O.usingSearchPaths?O.includePattern&&k.match(O.includePattern,F)?!0:O.usingSearchPaths?!!O.folderQueries&&O.folderQueries.some(N=>{const B=N.folder.fsPath;if(T.isEqualOrParent(F,B)){const U=y.relative(B,F);return!N.includePattern||!!k.match(N.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var l;(function(O){O[O.unknownEncoding=1]="unknownEncoding",O[O.regexParseError=2]="regexParseError",O[O.globParseError=3]="globParseError",O[O.invalidLiteral=4]="invalidLiteral",O[O.rgProcessError=5]="rgProcessError",O[O.other=6]="other",O[O.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(F,N){super(F);this.code=N}}e.SearchError=h;function P(O){const F=O.message;if((0,C.isPromiseCanceledError)(O))return new h(F,l.canceled);try{const N=JSON.parse(F);return new h(N.message,N.code)}catch(N){return new h(F,l.other)}}e.deserializeSearchError=P;function g(O){const F={message:O.message,code:O.code};return new Error(JSON.stringify(F))}e.serializeSearchError=g;function w(O){return O.type==="error"?!0:O.type==="success"}e.isSerializedSearchComplete=w;function R(O){return O.type==="success"}e.isSerializedSearchSuccess=R;function L(O){return!!O.path}e.isSerializedFileMatch=L;function V(O,F){const N=O.searchPath?O.searchPath:O.relativePath;return(0,S.fuzzyContains)(N,F)}e.isFilePatternMatch=V;class he{constructor(F){this.path=F,this.results=[]}addMatch(F){this.results.push(F)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function z(O,F){const N=Object.assign(Object.assign({},O||{}),F||{});return Object.keys(N).filter(B=>{const U=N[B];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=z;class W{constructor(F,N){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},F.excludePattern||{}),N.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let B=F.includePattern;N.includePattern&&(B?B=Object.assign(Object.assign({},B),N.includePattern):B=N.includePattern),B&&(this._parsedIncludeExpression=k.parse(B))}includedInQuerySync(F,N,B){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(F,N,B)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(F,N,B))}includedInQuery(F,N,B){return Promise.resolve(this._parsedExcludeExpression(F,N,B)).then(Q=>!!Q).then(Q=>Q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(F,N,B)).then(Z=>!!Z):Promise.resolve(!0)).then(Q=>Q)}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=W;function J(O){for(const F in O)if(typeof O[F]!="boolean")return!0;return!1}}),define(be[31],we([0,1,12,14,20,3,22,18,81,25,8,10,2,137,4,19,152,48,49,27,15,7,41,5]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p,u,b,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(R,L,V){return new C.ExtUri(he=>h(he,V)).isEqual(R,L)}function s(R,L,V){return a(R.uri,L.uri,V)?0:(0,i.compare)(R.uri.toString(),L.uri.toString())}function c(R,L,V){return R.index!==L.index?R.index<L.index?-1:1:a(R.uri,L.uri,V)?(0,i.compare)(R.name,L.name):(0,i.compare)(R.uri.toString(),L.uri.toString())}function l(R,L,V,he){const z=R.slice(0).sort((J,O)=>V(J,O,he)),W=L.slice(0).sort((J,O)=>V(J,O,he));return(0,_.delta)(z,W,(J,O)=>V(J,O,he))}function h(R,L){const V=L.getCapabilities(R.scheme);return!(V&&V&1024)}class P extends m.Workspace{constructor(L,V,he,z,W,J){super(L,he.map(O=>new m.WorkspaceFolder(O)),z,J);this._name=V,this._isUntitled=W,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(J),he.forEach(O=>{this._workspaceFolders.push(O),this._structure.set(O.uri,O)})}static toExtHostWorkspace(L,V,he,z){if(!L)return{workspace:null,added:[],removed:[]};const{id:W,name:J,folders:O,configuration:F,isUntitled:N}=L,B=[],U=V;V?O.forEach((pe,Pe)=>{const Oe=d.URI.revive(pe.uri),Te=P._findFolder(he||V,Oe,z);Te?(Te.name=pe.name,Te.index=pe.index,B.push(Te)):B.push({uri:Oe,name:pe.name,index:Pe})}):B.push(...O.map(({uri:pe,name:Pe,index:Oe})=>({uri:d.URI.revive(pe),name:Pe,index:Oe}))),B.sort((pe,Pe)=>pe.index<Pe.index?-1:1);const Q=new P(W,J,B,F?d.URI.revive(F):null,!!N,pe=>h(pe,z)),{added:Z,removed:ne}=l(U?U.workspaceFolders:[],Q.workspaceFolders,s,z);return{workspace:Q,added:Z,removed:ne}}static _findFolder(L,V,he){for(let z=0;z<L.folders.length;z++){const W=L.workspaceFolders[z];if(a(W.uri,V,he))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,V){return V&&this._structure.get(L)&&(L=(0,C.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let g=class{constructor(L,V,he,z){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidReceieveWorkspaceTrust=new T.Emitter,this.onDidReceiveWorkspaceTrust=this._onDidReceieveWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=he,this._requestIdProvider=new y.Counter,this._barrier=new k.Barrier,this._proxy=L.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(n.MainContext.MainThreadMessageService);const W=V.workspace;this._confirmedWorkspace=W?new P(W.id,W.name,[],W.configuration?d.URI.revive(W.configuration):null,!!W.isUntitled,J=>h(J,he)):void 0}$initializeWorkspace(L,V){this._trusted=V,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:D.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,V,he,...z){const W=[];if(Array.isArray(z)&&z.forEach(B=>{d.URI.isUri(B.uri)&&!W.some(U=>a(U.uri,B.uri,this._extHostFileSystemInfo))&&W.push({uri:B.uri,name:B.name||(0,C.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[V,he].some(B=>typeof B!="number"||B<0)||he===0&&W.length===0)return!1;const J=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(V+he>J.length)return!1;const O=J.slice(0);O.splice(V,he,...W.map(B=>({uri:B.uri,name:B.name||(0,C.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<O.length;B++){const U=O[B];if(O.some((Q,Z)=>Z!==B&&a(U.uri,Q.uri,this._extHostFileSystemInfo)))return!1}O.forEach((B,U)=>B.index=U);const{added:F,removed:N}=l(J,O,c,this._extHostFileSystemInfo);if(F.length===0&&N.length===0)return!1;if(this._proxy){const B=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(B,V,he,W).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,f.localize)(0,null,B,U.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(O),!0}getWorkspaceFolder(L,V){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,V)}async getWorkspaceFolder2(L,V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,V)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!!this._actualWorkspace){const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}}getRelativePath(L,V){let he,z="";if(typeof L=="string"?(he=d.URI.file(L),z=L):typeof L!="undefined"&&(he=L,z=L.fsPath),!he)return z;const W=this.getWorkspaceFolder(he,!0);if(!W)return z;typeof V=="undefined"&&this._actualWorkspace&&(V=this._actualWorkspace.folders.length>1);let J=(0,C.relativePath)(W.uri,he);return V&&W.name&&(J=`${W.name}/${J}`),J}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:V,added:he,removed:z}=P.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=V||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:z}))}findFiles(L,V,he,z,W=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let J;if(V===null?J=!1:V&&(typeof V=="string"?J=V:J=V.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:O,folder:F}=w(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(O),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(J),(0,I.withUndefinedAsNull)(he),W).then(N=>Array.isArray(N)?N.map(B=>d.URI.revive(B)):[])}async findTextInFiles(L,V,he,z,W=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const J=this._requestIdProvider.getNext(),O=typeof V.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:F,folder:N}=w(V.include),B=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,U={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:O,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:F,excludePattern:B},Q=!1;if(this._activeSearchCallbacks[J]=Z=>{if(!Q){const ne=d.URI.revive(Z.resource);Z.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?he({uri:ne,preview:{text:pe.preview.text,matches:(0,_.mapArrayOrNot)(pe.preview.matches,Pe=>new b.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,_.mapArrayOrNot)(pe.ranges,Pe=>new b.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):he({uri:ne,text:pe.text,lineNumber:pe.lineNumber})})}},W.isCancellationRequested)return{};try{const Z=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(N),U,J,W);return delete this._activeSearchCallbacks[J],Z||{}}catch(Z){throw delete this._activeSearchCallbacks[J],Z}}$handleTextSearchResult(L,V){this._activeSearchCallbacks[V]&&this._activeSearchCallbacks[V](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){const V=this._proxy.$requestWorkspaceTrust(L);return(L==null?void 0:L.modal)?V:Promise.resolve(this._trusted)}$onDidReceiveWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidReceieveWorkspaceTrust.fire())}};g=je([Ke(0,u.IExtHostRpcService),Ke(1,p.IExtHostInitDataService),Ke(2,E.IExtHostFileSystemInfo),Ke(3,o.ILogService)],g),e.ExtHostWorkspace=g,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function w(R){let L,V;return R&&(typeof R=="string"?L=R:(L=R.pattern,V=R.baseFolder||d.URI.file(R.base))),{includePattern:L,folder:V}}}),define(be[34],we([0,1,24,3,31,5,7,154,67,10,14,4,15,19,2]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(n,a){if(a){const s=a.split(".");let c=n;for(let l=0;c&&l<s.length;l++)c=c[s[l]];return c}}function v(n){return n instanceof r.URI}function m(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function p(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(v(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(p(n))return{resource:n.uri};if(n===null)return{resource:null}}let b=class{constructor(a,s,c){this._proxy=a.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=c,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,s){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,s))}};b=je([Ke(0,d.IExtHostRpcService),Ke(1,A.IExtHostWorkspace),Ke(2,f.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(a,s,c,l){this._onDidChangeConfiguration=new k.Emitter,this._proxy=a,this._logService=l,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,s){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,c))}getConfiguration(a,s,c){const l=u(s)||{},h=this._toReadonlyValue(a?o(this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,l,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,l,c==null?void 0:c.identifier);function P(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(w){return typeof o(h,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(a?`${a}.${w}`:w,l,c==null?void 0:c.identifier);let L=o(h,w);if(typeof L=="undefined")L=R;else{let V;const he=(z,W)=>{let J;const O=()=>{V=V||(0,_.deepClone)(h),J=J||o(V,W)};return(0,C.isObject)(z)?new Proxy(z,{get:(F,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return O(),()=>J;if(V)return J=J||o(V,W),J[N];const B=F[N];return typeof N=="string"?he(B,`${W}.${N}`):B},set:(F,N,B)=>(O(),J&&(J[N]=B),!0),deleteProperty:(F,N)=>(O(),J&&delete J[N],!0),defineProperty:(F,N,B)=>(O(),J&&Object.defineProperty(J,N,B),!0)}):z};L=he(L,w)}return L},update:(w,R,L,V)=>{w=a?`${a}.${w}`:w;const he=P(L);return R!==void 0?this._proxy.$updateConfigurationOption(he,w,R,l,V):this._proxy.$removeConfigurationOption(he,w,l,V)},inspect:w=>{var R,L,V,he,z,W,J,O;w=a?`${a}.${w}`:w;const F=(0,_.deepClone)(this._configuration.inspect(w,l,this._extHostWorkspace.workspace));if(F)return{key:w,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(L=F.user)===null||L===void 0?void 0:L.value,workspaceValue:(V=F.workspace)===null||V===void 0?void 0:V.value,workspaceFolderValue:(he=F.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(z=F.default)===null||z===void 0?void 0:z.override,globalLanguageValue:(W=F.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:(J=F.workspace)===null||J===void 0?void 0:J.override,workspaceFolderLanguageValue:(O=F.workspaceFolder)===null||O===void 0?void 0:O.override,languageIds:F.overrideIdentifiers}}};return typeof h=="object"&&(0,_.mixin)(g,h,!1),Object.freeze(g)}_toReadonlyValue(a){const s=c=>(0,C.isObject)(c)?new Proxy(c,{get:(l,h)=>s(l[h]),set:(l,h,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(l,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(l,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return s(a)}_validateConfigurationAccess(a,s,c){const l=y.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),h=c?`[${c.value}] `:"";if(l===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){(s==null?void 0:s.resource)&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,s){const c=new D.ConfigurationChangeEvent(a,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(l,h)=>c.affectsConfiguration(l,u(h))})}_toMap(a){return a.reduce((s,c)=>(s.set(c[0],c[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[102],we([0,1,2,14,3,5,7,31,39,34,20,40,15,27,4,18,21,19,75,171,11]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(z){function W(F){if(F){const N=F;return N&&!!N.process}else return!1}z.is=W;function J(F){if(F!=null){const N={process:F.process,args:F.args};return F.options&&(N.options=a.from(F.options)),N}}z.from=J;function O(F){if(F!=null)return new S.ProcessExecution(F.process,F.args,F.options)}z.to=O})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(z){function W(O){if(O!=null)return O}z.from=W;function J(O){if(O!=null)return O}z.to=J})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var l;(function(z){function W(F){if(F){const N=F;return N&&(!!N.commandLine||!!N.command)}else return!1}z.is=W;function J(F){if(F!=null){const N={};return F.commandLine!==void 0?N.commandLine=F.commandLine:(N.command=F.command,N.args=F.args),F.options&&(N.options=c.from(F.options)),N}}z.from=J;function O(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new S.ShellExecution(F.commandLine,F.options):new S.ShellExecution(F.command,F.args?F.args:[],F.options)}z.to=O})(l=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(z){function W(F){if(F){let N=F;return N&&N.customExecution==="customExecution"}else return!1}z.is=W;function J(F){return{customExecution:"customExecution"}}z.from=J;function O(F,N){return N.get(F)}z.to=O})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(z){function W(J,O){let F;return J.scope!==void 0&&typeof J.scope!="number"?F=J.scope.uri:J.scope!==void 0&&typeof J.scope=="number"&&(J.scope===S.TaskScope.Workspace&&O&&O.workspaceFile?F=O.workspaceFile:F=p.USER_TASKS_GROUP_KEY),{id:J._id,workspaceFolder:F}}z.from=W})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(z){function W(F,N){if(F==null)return[];const B=[];for(let U of F){const Q=J(U,N);Q&&B.push(Q)}return B}z.fromMany=W;function J(F,N){if(F!=null){let B;F.execution instanceof S.ProcessExecution?B=s.from(F.execution):F.execution instanceof S.ShellExecution?B=l.from(F.execution):F.execution&&F.execution instanceof S.CustomExecution&&(B=h.from(F.execution));const U=t.from(F.definition);let Q;if(F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=S.TaskScope.Workspace,!(!U||!Q)){const Z=F.group?F.group.id:void 0;return{_id:F._id,definition:U,name:F.name,source:{extensionId:N.identifier.value,label:F.source,scope:Q},execution:B,isBackground:F.isBackground,group:Z,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}z.from=J;async function O(F,N,B){if(F!=null){let U;s.is(F.execution)?U=s.to(F.execution):l.is(F.execution)?U=l.to(F.execution):h.is(F.execution)&&(U=h.to(F._id,B));const Q=t.to(F.definition);let Z;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Z=F.source.scope:Z=await N.resolveWorkspaceFolder(_.URI.revive(F.source.scope)):Z=S.TaskScope.Workspace),!(!Q||!Z)){const ne=new S.Task(Q,Z,F.name,F.source.label,U,F.problemMatchers);return F.isBackground!==void 0&&(ne.isBackground=F.isBackground),F.group!==void 0&&(ne.group=S.TaskGroup.from(F.group)),F.presentationOptions&&(ne.presentationOptions=n.to(F.presentationOptions)),F._id&&(ne._id=F._id),F.detail&&(ne.detail=F.detail),ne}}}z.to=O})(g=e.TaskDTO||(e.TaskDTO={}));var w;(function(z){function W(O){return O}z.from=W;function J(O){if(!!O)return Object.assign(Object.create(null),O)}z.to=J})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,J,O){this._id=J,this._task=O,b.set(this,void 0),tt(this,b,W,"f")}get task(){return this._task}terminate(){Me(this,b,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}b=new WeakMap;var L;(function(z){function W(J){return{id:J._id,task:void 0}}z.from=W})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let V=class{constructor(W,J,O,F,N,B,U,Q){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=W.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=O,this._editorService=F,this._configurationService=N,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=Q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,J,O){if(!O)return new S.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:J,provider:O,extension:W}),this._proxy.$registerTaskProvider(F,J),new S.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(W,J){this._proxy.$registerTaskSystem(W,J)}fetchTasks(W){return this._proxy.$fetchTasks(w.from(W)).then(async J=>{const O=[];for(let F of J){const N=await g.to(F,this._workspaceProvider,this._providedCustomExecutions2);N&&O.push(N)}return O})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(J=>W.push(J)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,J,O){const F=this._providedCustomExecutions2.get(W.id);if(F){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,F),this._terminalService.attachPtyToTerminal(J,await F.callback(O))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const J=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:J})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const J=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:J,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const J=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:J,exitCode:W.exitCode})}$provideTasks(W,J){const O=this._handlers.get(W);if(!O)return Promise.reject(new Error("no handler found"));const F=[],N=(0,k.asPromise)(()=>O.provider.provideTasks(i.CancellationToken.None)).then(B=>this.provideTasksInternal(J,F,O,B));return new Promise(B=>{N.then(U=>{Promise.all(F).then(()=>{B(U)})})})}async $resolveTask(W,J){const O=this._handlers.get(W);if(!O)return Promise.reject(new Error("no handler found"));if(J.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${J.definition.type}] cannot be resolved by provider of type [${O.type}].`);const F=await g.to(J,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const N=await O.provider.resolveTask(F,i.CancellationToken.None);if(!!N){this.checkDeprecation(N,O);const B=g.from(N,O.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(B.execution)&&await this.addCustomExecution(B,N,!0),await this.resolveTaskInternal(B)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,J,O){const F=await this._proxy.$createTaskId(W);!O&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,J.execution)}async getTaskExecution(W,J){if(typeof W=="string"){const N=this._taskExecutionPromises.get(W);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let O=this._taskExecutionPromises.get(W.id);if(O)return O;const F=new Promise(async(N,B)=>{const U=J||await g.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);U?N(new R(this,W.id,U)):B("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,F),F.then(N=>(this._taskExecutions.set(W.id,N),N),N=>Promise.reject(N))}checkDeprecation(W,J){W._deprecated&&this._deprecationService.report("Task.constructor",J.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let O=this._notProvidedCustomExecutions.values(),F=O.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=O.next()}};V=je([Ke(0,d.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,m.ILogService),Ke(7,E.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let he=class extends V{constructor(W,J,O,F,N,B,U,Q){super(W,J,O,F,N,B,U,Q);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(W,J){if(!J.execution)throw new Error("Tasks to execute must include an execution");const O=g.from(J,W);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.addCustomExecution(O,J,!1);else throw new u.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(O),J);return this._proxy.$executeTask(O).catch(N=>{throw new Error(N)}),F}provideTasksInternal(W,J,O,F){const N=[];if(F)for(let B of F){this.checkDeprecation(B,O),(!B.definition||!W[B.definition.type])&&this._logService.warn(`The task [${B.source}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`);const U=g.from(B,O.extension);U&&h.is(U.execution)?(N.push(U),J.push(this.addCustomExecution(U,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:O.extension}}async resolveTaskInternal(W){if(h.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,J){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,J,O){}};he=je([Ke(0,d.IExtHostRpcService),Ke(1,f.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,m.ILogService),Ke(7,E.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)},$t=this&&this.__rest||function(Y,e){var _={};for(var k in Y)Object.prototype.hasOwnProperty.call(Y,k)&&e.indexOf(k)<0&&(_[k]=Y[k]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,k=Object.getOwnPropertySymbols(Y);A<k.length;A++)e.indexOf(k[A])<0&&Object.prototype.propertyIsEnumerable.call(Y,k[A])&&(_[k[A]]=Y[k[A]]);return _};define(be[218],we([0,1,12,14,23,20,3,54,43,6,24,10,2,29,5,39,15,70,9,7,31,182,96]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p,u,b,t){"use strict";var n,a,s,c;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const l=(O,F)=>`${O}:${F.toString()}`;let h=class{constructor(F,N,B){this.documents=N,this.workspace=B,this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.ownedTests=new b.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new P(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new J(this.proxy,N)}registerTestController(F,N){const B=(0,f.generateUuid)();this.controllers.set(B,{instance:N,extensionId:F}),this.proxy.$registerTestController(B);const U=[...this.testControllers.keys()];return setTimeout(()=>{var Q;for(const Z of U)(Q=this.testControllers.get(Z))===null||Q===void 0||Q.subscribeFn(B,N)},0),new p.Disposable(()=>{this.controllers.delete(B),this.proxy.$unregisterTestController(B)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,N=T.CancellationToken.None){const B=U=>U.map(this.getInternalTestForReference,this).filter(I.isDefined).map(Q=>({src:Q.src,testId:Q.item.extId}));await this.proxy.$runTests({exclude:F.exclude?B(F.exclude).map(U=>U.testId):void 0,tests:B(F.tests),debug:F.debug},N)}createTestRunTask(F,N,B,U=!0){return this.runQueue.createTestRunTask(F,N,B,U)}$publishTestResults(F){this.results=Object.freeze(F.map(N=>(0,i.deepFreeze)(E.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,N){const B=d.URI.revive(N),U=l(F,B);if(!this.testControllers.has(U)){const Q=new T.CancellationTokenSource;let Z;if(F===1){let Oe=this.documents.getDocument(B);if(!Oe){const Te=new C.DisposableStore;Oe=await new Promise(xe=>{Te.add((0,k.disposableTimeout)(()=>xe(void 0),5e3)),Te.add(this.documents.onDidAddDocuments($=>{const G=$.find(ie=>ie.document.uri.toString()===B.toString());G&&xe(G)}))}).finally(()=>Te.dispose())}if(Oe){const Te=await this.workspace.getWorkspaceFolder2(B,!1);Z=xe=>xe.createDocumentTestRoot?xe.createDocumentTestRoot(Oe.document,Q.token):(0,e.createDefaultDocumentTestRoot)(xe,Oe.document,Te,Q.token)}}else{const Oe=await this.workspace.getWorkspaceFolder2(B,!1);Oe&&(Z=Te=>Te.createWorkspaceTestRoot(Oe,Q.token))}if(!!Z){const ne=async(Oe,Te)=>{try{const xe=await Z(Te);xe&&Pe.addRoot(xe,Oe)}catch(xe){console.error(xe)}},pe=new C.DisposableStore,Pe=pe.add(this.ownedTests.createForHierarchy(Oe=>this.proxy.$publishDiff(F,N,Oe)));pe.add((0,C.toDisposable)(()=>Q.dispose(!0)));for(const[Oe,Te]of this.controllers)ne(Oe,Te.instance);Pe.pushDiff([3,-1]),this.testControllers.set(U,{store:pe,collection:Pe,subscribeFn:ne})}}}async $expandTest(F,N){const B=(0,_.mapFind)(this.testControllers.values(),U=>U.collection.treeId===F.src.tree?U:void 0);await(B==null?void 0:B.collection.expand(F.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,N){var B;const U=d.URI.revive(N),Q=l(F,U);(B=this.testControllers.get(Q))===null||B===void 0||B.store.dispose(),this.testControllers.delete(Q)}$acceptDiff(F,N,B){F===1?this.textDocumentObservers.acceptDiff(d.URI.revive(N),B):this.workspaceObservers.acceptDiff(d.URI.revive(N),B)}async $runTestsForProvider(F,N){const B=this.controllers.get(F.tests[0].src.controller);if(!!B){const U=F.tests.map(({testId:ne,src:pe})=>this.ownedTests.getTestById(ne,pe==null?void 0:pe.tree)).filter(I.isDefined).map(([ne,pe])=>pe),Q=F.excludeExtIds.map(ne=>this.ownedTests.getTestById(ne)).filter(I.isDefined).filter(([ne,pe])=>U.some(Pe=>ne.comparePositions(Pe,pe)===1));if(!!U.length){const Z={tests:U.map(ne=>L.unwrap(ne.actual)),exclude:Q.map(([,ne])=>L.unwrap(ne.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:g.fromInternal(F),token:N,extensionId:B.extensionId,req:Z,doRun:()=>B.instance.runTests(Z,N)})}}}$lookupTest(F){const N=this.ownedTests.getTestById(F.testId);if(!N)return Promise.resolve(void 0);const B=N[1],{actual:U,discoverCts:Q,expandLevels:Z}=B,ne=$t(B,["actual","discoverCts","expandLevels"]);return Promise.resolve(ne)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var N,B;return(B=(N=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&N!==void 0?N:(0,_.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(F)))!==null&&B!==void 0?B:this.textDocumentObservers.getMirroredTestDataByReference(F)}};h=je([Ke(0,v.IExtHostRpcService),Ke(1,o.IExtHostDocumentsAndEditors),Ke(2,u.IExtHostWorkspace)],h),e.ExtHostTesting=h;class P{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let N=this.state.get(F.extensionId);N||(N={queue:[],current:void 0},this.state.set(F.extensionId,N));const B=new k.DeferredPromise,U=()=>{const Q=[],Z=new Set;N.current={publicReq:F.req,factory:ne=>{const pe=new w(ne,F.dto,Z,this.proxy);return Q.push(pe),F.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,Q).finally(()=>B.complete())};return N.queue.push(U),N.queue.length===1&&U(),B.p}createTestRunTask(F,N,B,U){var Q,Z;const ne=this.state.get(F);if((ne==null?void 0:ne.current.publicReq)===N)return ne.current.factory(B);const pe=g.fromPublic(N),Pe=new w(B,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(Z=(Q=N.exclude)===null||Q===void 0?void 0:Q.map(Oe=>Oe.id))!==null&&Z!==void 0?Z:[],id:pe.id,tests:N.tests.map(Oe=>Oe.id),persist:U}),Pe.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Pe}invokeRunner(F,N,B,U){try{const Q=B();return(0,k.isThenable)(Q)?Q.then(()=>this.handleInvokeResult(F,N,U,void 0)).catch(Z=>this.handleInvokeResult(F,N,U,Z)):this.handleInvokeResult(F,N,U,void 0)}catch(Q){return this.handleInvokeResult(F,N,U,Q)}}async handleInvokeResult(F,N,B,U){const Q=this.state.get(F);!Q||(Q.queue.shift(),Q.queue.length>0?Q.queue[0]():this.state.delete(F),await Promise.all(B.map(Z=>Z.onEnd.wait())))}}class g{constructor(F,N,B){this.id=F,this.include=N,this.exclude=B}static fromPublic(F){var N,B;return new g((0,f.generateUuid)(),new Set(F.tests.map(U=>U.id)),new Set((B=(N=F.exclude)===null||N===void 0?void 0:N.map(U=>U.id))!==null&&B!==void 0?B:y.Iterable.empty()))}static fromInternal(F){return new g(F.runId,new Set(F.tests.map(N=>N.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let N=F;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class w{constructor(F,N,B,U){this.name=F,n.set(this,void 0),a.set(this,void 0),s.set(this,(0,f.generateUuid)()),c.set(this,void 0),this.onEnd=new k.Barrier,tt(this,n,U,"f"),tt(this,a,N,"f"),tt(this,c,B,"f"),U.$startedTestRunTask(N.id,{id:Me(this,s,"f"),name:F,running:!0})}setState(F,N,B){Me(this,a,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Me(this,n,"f").$updateTestStateInRun(Me(this,a,"f").id,Me(this,s,"f"),F.id,N,B))}appendMessage(F,N){Me(this,a,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Me(this,n,"f").$appendTestMessageInRun(Me(this,a,"f").id,Me(this,s,"f"),F.id,E.TestMessage.from(N)))}appendOutput(F){Me(this,n,"f").$appendOutputToRun(Me(this,a,"f").id,Me(this,s,"f"),A.VSBuffer.fromString(F))}end(){Me(this,n,"f").$finishedTestRunTask(Me(this,a,"f").id,Me(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(F){const N=Me(this,c,"f");if(!N.has(F.id)){const B=[];for(;B.unshift(E.TestItem.from(F)),!(N.has(F.id)||(N.add(F.id),!F.parent));)F=F.parent;Me(this,n,"f").$addTestsToRun(Me(this,a,"f").id,B)}}}n=new WeakMap,a=new WeakMap,s=new WeakMap,c=new WeakMap;const R=async(O,F,N,B)=>{if(!!N){const U=await O.createWorkspaceTestRoot(N,B);if(!!U)return B.onCancellationRequested(()=>{L.removeFilter(F)}),L.getWrapperForTestItem(U,F)}};e.createDefaultDocumentTestRoot=R;class L extends p.TestItemImpl{constructor(F,N,B){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=N,this.actualParent=B,!(F instanceof p.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status;const U=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(F).bus.event(Z=>{switch(Z[0]){case 3:this[Z[1]]=Z[2];break;case 0:const ne=L.getWrapperForTestItem(Z[1],this.filterDocument,this);(0,m.getPrivateApiFor)(ne).parent=F,ne.refreshMatch();break;default:U.bus.fire(Z)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,N,B){let U=this.wrapperMap.get(N);if(U==null?void 0:U.has(F))return U.get(F);U||(U=new WeakMap,this.wrapperMap.set(N,U));const Q=new L(F,N,B);return U.set(F,Q),Q}static unwrap(F){return F instanceof L?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F;const N=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const Q=L.getWrapperForTestItem(U,this.filterDocument,this);Q.hasNodeMatchingFilter?this.addChild(Q):Q.dispose()}const B=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=B,B!==N&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=L,L.wrapperMap=new WeakMap;class V extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,E.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:N,removed:B}=this;return{get added(){return[...F].map(U=>U.revived)},get updated(){return[...N].map(U=>U.revived)},get removed(){return[...B].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let N=[];for(const B of F){const U=this.items.get(B);U&&N.push(U.revived)}return N}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,N){return Object.assign(Object.assign({},F),{revived:E.TestItem.toPlain(F.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new V(this.changeEmitter)}}e.MirroredTestCollection=he;class z{constructor(){this.resources=new Map}checkout(F){var N,B;const U=F.toString(),Q=(N=this.resources.get(U))!==null&&N!==void 0?N:this.createObserverData(F);return(B=Q.pendingDeletion)===null||B===void 0||B.dispose(),Q.observers++,{onDidChangeTest:Q.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return Q.tests.rootTestItems},dispose:(0,D.once)(()=>{--Q.observers||(Q.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:N}of this.resources.values()){const B=N.getMirroredTestDataByReference(F);if(B)return B}}eventuallyDispose(F){return(0,k.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const N=new he,B=this.listen(F,Q=>N.apply(Q)),U={observers:0,tests:N,listener:B};return this.resources.set(F.toString(),U),U}unlisten(F){var N;const B=F.toString(),U=this.resources.get(B);U&&(U.observers=-1,(N=U.pendingDeletion)===null||N===void 0||N.dispose(),U.listener.dispose(),this.resources.delete(B))}}class W extends z{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,N){var B;(B=this.diffListeners.get(F.toString()))===null||B===void 0||B(N)}listen(F,N){this.proxy.$subscribeToDiffs(0,F);const B=F.toString();return this.diffListeners.set(B,N),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(B)})}}class J extends z{constructor(F,N){super();this.proxy=F,this.documents=N,this.diffListeners=new Map}acceptDiff(F,N){var B;(B=this.diffListeners.get(F.toString()))===null||B===void 0||B(N)}listen(F,N){if(!this.documents.getDocument(F))return new p.Disposable(()=>{});const U=F.toString();return this.diffListeners.set(U,N),this.proxy.$subscribeToDiffs(1,F),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(U)})}}}),define(be[219],we([0,1,12,52,28,59,22,18,13,25,8,10,2,115,140,92,48,174,217,41]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(P,g,w,R){this.configurationService=P,this.workspaceContextService=g,this.editorGroupsService=w,this.pathService=R}text(P,g,w={}){P=this.getContentPattern(P,w);const R=this.configurationService.getValue(),L=g&&g.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),V=this.commonQuery(g==null?void 0:g.map(v.toWorkspaceFolder),w);return Object.assign(Object.assign({},V),{type:2,contentPattern:P,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:R.search.usePCRE2||L||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(P,g){const w=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},P),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(P,g)&&(R.isCaseSensitive=!0),this.isMultiline(P)&&(R.isMultiline=!0),R}file(P,g={}){const w=this.commonQuery(P,g);return Object.assign(Object.assign({},w),{type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey})}handleIncludeExclude(P,g){return P?(P=Array.isArray(P)?P.map(s):s(P),g?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],g={}){const w=this.handleIncludeExclude(g.includePattern,g.expandPatterns),R=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),L=P.length>1,V=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,g,R)):P.map(W=>this.getFolderQueryForRoot(W,g,R,L))).filter(W=>!!W),he={_reason:g._reason,folderQueries:V,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:R.pattern,includePattern:w.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const J=_.coalesce(_.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(N=>N.resource)))).filter(F=>(0,p.pathIncludedInQuery)(he,F.fsPath)),O=this.commonQueryFromFileList(J);return Object.assign(Object.assign({},he),O)}const z=g.extraFileResources&&g.extraFileResources.filter(W=>(0,p.pathIncludedInQuery)(he,W.fsPath));return he.extraFileResources=z&&z.length?z:void 0,he}commonQueryFromFileList(P){const g=[],w=new S.ResourceMap,R={};let L=!1;return P.forEach(V=>{var he,z;if(V.scheme!==D.Schemas.walkThrough)if((0,C.isAbsolutePath)(V)){const J=(z=(he=this.workspaceContextService.getWorkspaceFolder(V))===null||he===void 0?void 0:he.uri)!==null&&z!==void 0?z:V.with({path:y.dirname(V.fsPath)});let O=w.get(J);O||(L=!0,O={folder:J,includePattern:{}},g.push(O),w.set(J,O));const F=y.relative(J.fsPath,V.fsPath);(0,I.assertIsDefined)(O.includePattern)[F.replace(/\\/g,"/")]=!0}else V.fsPath&&(L=!0,R[V.fsPath]=!0)}),{folderQueries:g,includePattern:R,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(P,g){if(g.isSmartCase){if(P.isRegExp){if(i.containsUppercaseCharacter(P.pattern,!0))return!0}else if(i.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&(0,f.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const g=O=>y.isAbsolute(O)||/^\.\.?([\/\\]|$)/.test(O),R=(Array.isArray(P)?P:n(P)).map(O=>{const F=this.pathService.resolvedUserHome;return F?(0,T.untildify)(O,F.scheme===D.Schemas.file?F.fsPath:F.path):O}),L=k.groupBy(R,O=>g(O)?"searchPaths":"exprSegments"),V=(L.exprSegments||[]).map(O=>i.rtrim(O,"/")).map(O=>i.rtrim(O,"\\")).map(O=>(O[0]==="."&&(O="*"+O),a(O))),he={},z=this.expandSearchPathPatterns(L.searchPaths||[]);z&&z.length&&(he.searchPaths=z);const W=_.flatten(V),J=t(...W);return J&&(he.pattern=J),he}getExcludesForFolder(P,g){return g.disregardExcludeSettings?void 0:(0,p.getExcludes)(P,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const g=_.flatten(P.map(R=>{let{pathPortion:L,globPortion:V}=b(R);V&&(V=c(V));const he=this.expandOneSearchPath(L);return _.flatten(he.map(z=>this.resolveOneSearchPathPattern(z,V)))})),w=new Map;return g.forEach(R=>{const L=R.searchPath.toString(),V=w.get(L);V?R.pattern&&(V.pattern=V.pattern||{},V.pattern[R.pattern]=!0):w.set(L,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(P){if(y.isAbsolute(P)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==D.Schemas.file?[{searchPath:g[0].uri.with({path:P})}]:[{searchPath:d.URI.file(y.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=s(P),P.startsWith("../")||P===".."){const R=y.posix.resolve(g.path,P);return[{searchPath:g.with({path:R})}]}const w=c(P);return[{searchPath:g,pattern:w}]}else{if(P==="./"||P===".\\")return[];{const g=P.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(g){const w=g[1],R=this.workspaceContextService.getWorkspace().folders.filter(L=>L.name===w);if(R.length)return R.map(L=>{const V=g[2];return{searchPath:L.uri,pattern:V&&c(V)}});{const L=r.localize(0,null,w);throw new Error(L)}}}}return[]}resolveOneSearchPathPattern(P,g){const w=P.pattern&&g?`${P.pattern}/${g}`:P.pattern||g,R=[{searchPath:P.searchPath,pattern:w}];return w&&!w.endsWith("**")&&R.push({searchPath:P.searchPath,pattern:w+"/**"}),R}getFolderQueryForSearchPath(P,g,w){const R=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(P.searchPath),g,w,!1);return R?Object.assign(Object.assign({},R),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,g,w,R){let L;const V=d.URI.isUri(P)?P:P.uri;if(w.searchPaths){const O=w.searchPaths.filter(F=>(0,C.isEqual)(F.searchPath,V))[0];if(O&&!O.pattern)return null;O&&(L=O.pattern)}const he=this.configurationService.getValue({resource:V}),z=this.getExcludesForFolder(he,g),W=Object.assign(Object.assign({},z||{}),L||{}),J=d.URI.isUri(P)?(0,C.basename)(P):P.name;return{folder:V,folderName:R?J:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!he.search.followSymlinks}}};u=je([Ke(0,o.IConfigurationService),Ke(1,v.IWorkspaceContextService),Ke(2,m.IEditorGroupsService),Ke(3,E.IPathService)],u),e.QueryBuilder=u;function b(h){const P=h.match(/[\*\{\}\(\)\[\]\?]/);if(P){const g=P.index,w=h.substr(0,g).match(/[/|\\][^/\\]*$/);if(w){let R=h.substr(0,w.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:h.substr((w.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((P,g)=>(P[g]=!0,P),Object.create(null)):void 0}function n(h){return A.splitGlobAware(h,",").map(P=>P.trim()).filter(P=>!!P.length)}function a(h){return[`**/${h}/**`,`**/${h}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function s(h){return h.replace(/\\/g,"/")}function c(h){return s(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(h,P){h=_.distinct(h,R=>R.toString());const g=[],w=P.getWorkspace();return h&&h.forEach(R=>{let L;if(P.getWorkbenchState()===2)L=(0,C.relativePath)(w.folders[0].uri,R),L&&L!=="."&&(L="./"+L);else{const V=P.getWorkspaceFolder(R);if(V){const he=V.name;if(w.folders.filter(W=>W.name===he).length===1){const W=(0,C.relativePath)(V.uri,R);W===""?L=`./${V.name}`:L=`./${V.name}/${W}`}else L=R.fsPath}}L&&g.push(L)}),g}e.resolveResourcesForSearchIncludes=l}),define(be[220],we([0,1,25,2,20,11,4,219,41,48]),function(Y,e,_,k,A,T,S,D,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(o,v){const m=v.activationEvents;if(!m)return Promise.resolve(void 0);const E=[],p=[];for(const s of m)if(/^workspaceContains:/.test(s)){const c=s.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||o.forceUsingSearch?p.push(c):E.push(c)}if(E.length===0&&p.length===0)return Promise.resolve(void 0);let u;const b=new Promise((s,c)=>{u=s}),t=s=>u({activationEvent:s}),n=Promise.all(E.map(s=>d(o,s,t))).then(()=>{}),a=f(o,v.identifier,p,t);return Promise.all([n,a]).then(()=>{u(void 0)}),b}e.checkActivateWorkspaceContainsExtension=I;async function d(o,v,m){for(const E of o.folders)if(await o.exists(_.joinPath(k.URI.revive(E),v))){m(`workspaceContains:${v}`);return}}async function f(o,v,m,E){if(m.length===0)return Promise.resolve(void 0);const p=new A.CancellationTokenSource,u=o.checkExists(o.folders,m,p.token),b=setTimeout(async()=>{p.cancel(),E(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await u}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}p.dispose(),clearTimeout(b),t&&E(`workspaceContains:${m.join(",")}`)}function r(o,v,m,E){const p=o.get(S.IInstantiationService),u=o.get(y.ISearchService),t=p.createInstance(D.QueryBuilder).file(v.map(n=>(0,C.toWorkspaceFolder)(k.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return u.fileSearch(t,E).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(Y,e,_,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(Y,_):A?A.value=_:e.set(Y,_),_},Me=this&&this.__classPrivateFieldGet||function(Y,e,_,k){if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!k:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?k:_==="a"?k.call(Y):k?k.value:e.get(Y)};define(be[35],we([0,1,132,13,80,25,14,6,22,2,19,5,34,185,78,31,33,183,11,26,18,23,161,7,68,4,27,79,15,66,71,40,3,220,74,162]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p,u,b,t,n,a,s,c,l,h,P,g,w,R,L,V,he){"use strict";var z,W,J;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let O=class Tn extends D.Disposable{constructor(U,Q,Z,ne,pe,Pe,Oe,Te,xe,$){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=Z,this._initData=Oe,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=Pe,this._extHostTunnelService=xe,this._extHostTerminalService=$,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=U.createChild(new P.ServiceCollection([r.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));const G=new Set;this._initData.hostExtensions.forEach(ie=>G.add(p.ExtensionIdentifier.toKey(ie))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ie,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ie,oe)},actualActivateExtension:async(ie,oe)=>{if(G.has(p.ExtensionIdentifier.toKey(ie)))return await this._mainThreadExtensionsProxy.$activateExtension(ie,oe),new f.HostExtension;const me=this._registry.getExtensionDescription(ie);return this._activateExtension(me,oe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){E.onUnexpectedError(U)}}async deactivateAll(){let U=[];try{U=this._registry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch(Q){}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,Q){return this._activator.activateByEvent(U,Q)}_activateById(U,Q){return this._activator.activateById(U,Q)}activateByIdWithErrors(U,Q){return this._activateById(U,Q).then(()=>{const Z=this._activator.getActivatedExtension(U);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const U=y.TernarySearchTree.forPaths(),Q=this._registry.getAllExtensionDescriptions().map(Z=>{if(!!this._getEntryPoint(Z))return this._hostUtils.realpath(Z.extensionLocation.fsPath).then(ne=>U.set(C.URI.file(ne).fsPath,Z))});this._extensionPathIndex=Promise.all(Q).then(()=>U)}return this._extensionPathIndex}_deactivate(U){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return Q;const Z=this._activator.getActivatedExtension(U);if(!Z)return Q;try{typeof Z.module.deactivate=="function"&&(Q=Promise.resolve(Z.module.deactivate()).then(void 0,ne=>Promise.resolve(void 0)))}catch(ne){}try{(0,D.dispose)(Z.subscriptions)}catch(ne){}return Q}async _activateExtension(U,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,Q).then(Z=>{const ne=Z.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,Q),this._logExtensionActivationTimes(U,Q,"success",ne),Z},Z=>{throw this._logExtensionActivationTimes(U,Q,"failure"),Z})}_logExtensionActivationTimes(U,Q,Z,ne){const pe=F(U,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},pe),ne||{}),{outcome:Z}))}_doActivateExtension(U,Q){const Z=F(U,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Z);const ne=this._getEntryPoint(U);if(!ne)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value} ${JSON.stringify(Q)}`),this._logService.flush();const pe=new f.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,T.joinPath)(U.extensionLocation,ne),pe),this._loadExtensionContext(U)]).then(Pe=>(A.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),Tn._callActivate(this._logService,U.identifier,Pe[0],Pe[1],pe))).then(Pe=>(A.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),Pe))}_loadExtensionContext(U){const Q=new t.ExtensionGlobalMemento(U,this._storage),Z=new t.ExtensionMemento(U.identifier.value,!1,this._storage),ne=new he.ExtensionSecrets(U,this._secretState),pe=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Pe=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([Q.whenReady,Z.whenReady,this._storagePath.whenReady]).then(()=>{const Oe=this;let Te;return Object.freeze({globalState:Q,workspaceState:Z,secrets:ne,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(xe){return k.join(U.extensionLocation.fsPath,xe)},get storagePath(){var xe;return(xe=Oe._storagePath.workspaceValue(U))===null||xe===void 0?void 0:xe.fsPath},get globalStoragePath(){return Oe._storagePath.globalValue(U).fsPath},get logPath(){return k.join(Oe._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return C.URI.joinPath(Oe._initData.logsLocation,U.identifier.value)},get storageUri(){return Oe._storagePath.workspaceValue(U)},get globalStorageUri(){return Oe._storagePath.globalValue(U)},get extensionMode(){return pe},get extension(){return Te===void 0&&(Te=new N(Oe,U.identifier,U,Pe)),Te},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(U),Oe.extensionRuntime},get environmentVariableCollection(){return Oe._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,Q,Z,ne,pe){return Z=Z||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,Q,Z,ne,pe).then(Pe=>new f.ActivatedExtension(!1,null,pe.build(),Z,Pe,ne.subscriptions))}static _callActivateOptional(U,Q,Z,ne,pe){if(typeof Z.activate=="function")try{pe.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Pe=typeof global=="object"?global:self,Oe=Z.activate.apply(Pe,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Oe).then(Te=>(pe.activateResolveStop(),Te))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(Z)}_activateOneStartupFinished(U,Q){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:Q}).then(void 0,Z=>{this._logService.error(Z)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const Q of U.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(U,Q)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Z=this._handleWorkspaceContainsEagerExtensions(Q),ne=Promise.all([U,Z]).then(()=>{});return Promise.race([ne,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(U,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,Q){if(!this.isActivated(Q.identifier)){const Z=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={folders:U.map(Pe=>Pe.uri),forceUsingSearch:Z,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Oe,Te)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Oe,Te)},pe=await(0,L.checkActivateWorkspaceContainsExtension)(ne,Q);if(!!pe)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:pe.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:Q}=this._initData.environment;if(!U||!Q||Q.scheme!==u.Schemas.file)throw new Error(_.localize(0,null));const Z=(0,T.originalFSPath)(Q),ne=await this._loadCommonJSModule(null,Q,new f.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(_.localize(1,null,Z));return new Promise((pe,Pe)=>{const Oe=(xe,$)=>{xe?Pe(xe):pe(typeof $=="number"&&$>0?1:0)},Te=ne.run(Z,Oe);Te&&Te.then&&Te.then(()=>{pe(0)}).catch(xe=>{Pe(xe.toString())})})}async $extensionTestsExit(U){this._logService.info(`extension host terminating: test runner requested exit with code ${U}`),this._logService.info(`exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(U,Q){return this._resolvers[U]=Q,(0,D.toDisposable)(()=>{delete this._resolvers[U]})}async $resolveAuthority(U,Q){const Z=U.indexOf("+");if(Z===-1)throw new Error("Not an authority that can be resolved!");const ne=U.substr(0,Z);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1);const pe=this._resolvers[ne];if(!pe)return{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${ne}`);const Pe=await pe.resolve(U,{resolveAttempt:Q});A.mark(`code/extHost/didResolveAuthorityOK/${ne}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(pe));const Oe={authority:U,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},Te={extensionHostEnv:Pe.extensionHostEnv,trust:Pe.trust};return{type:"ok",value:{authority:Oe,options:Te,tunnelInformation:{environmentTunnels:Pe.environmentTunnels}}}}catch(Pe){if(A.mark(`code/extHost/didResolveAuthorityError/${ne}`),Pe instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,Q){return Q===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(Z=>this._activateByEvent(U,!1))}async $activate(U,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,Q),!0):!1}async $deltaExtensions(U,Q){U.forEach(ne=>ne.extensionLocation=C.URI.revive(ne.extensionLocation));const Z=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ne=>{const pe=this._registry.getExtensionDescription(ne);if(!!pe){const Pe=await this._hostUtils.realpath(pe.extensionLocation.fsPath);Z.delete(C.URI.file(Pe).fsPath)}})),await Promise.all(U.map(async ne=>{const pe=await this._hostUtils.realpath(ne.extensionLocation.fsPath);Z.set(C.URI.file(pe).fsPath,ne)})),this._registry.deltaExtensions(U,Q),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let Q=b.VSBuffer.alloc(U),Z=Math.random()%256;for(let ne=0;ne<U;ne++)Q.writeUInt8(Z,ne);return Q}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};O=je([Ke(0,s.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,h.IExtHostRpcService),Ke(3,o.IExtHostWorkspace),Ke(4,d.IExtHostConfiguration),Ke(5,i.ILogService),Ke(6,c.IExtHostInitDataService),Ke(7,l.IExtensionStoragePaths),Ke(8,g.IExtHostTunnelService),Ke(9,w.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function F(B,U){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class N{constructor(U,Q,Z,ne){z.set(this,void 0),W.set(this,void 0),J.set(this,void 0),tt(this,z,U,"f"),tt(this,W,Q,"f"),tt(this,J,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=k.normalize((0,T.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ne}get isActive(){return Me(this,z,"f").isActivated(Me(this,J,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,z,"f").getExtensionExports(Me(this,J,"f"))}activate(){return Me(this,z,"f").activateByIdWithErrors(Me(this,J,"f"),{startup:!1,extensionId:Me(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,z=new WeakMap,W=new WeakMap,J=new WeakMap}),define(be[103],we([0,1,13,2,3,14,5,7,169,31,35,39,173,34,170,15,4,10,46]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let p=class{constructor(l,h,P,g,w){this._workspaceService=h,this._extensionService=P,this._editorsService=g,this._configurationService=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=l.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(L=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,h){const P=l;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let g=`debug:${encodeURIComponent(P.path||"")}`,w="?";return h&&(g+=`${w}session=${encodeURIComponent(h.id)}`,w="&"),g+=`${w}ref=${P.sourceReference}`,k.URI.parse(g)}else{if(P.path)return k.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const h=[];for(const P of l.getAllExtensionDescriptions())if(P.contributes){const g=P.contributes.debuggers;if(g&&g.length>0)for(const w of g)(0,r.isDebuggerMainContribution)(w)&&h.push(w.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(h=>l.push(h)),l}addBreakpoints(l){this.startBreakpoints();const h=l.filter(w=>{const R=w.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,w),!0)});this.fireBreakpointChanges(h,[],[]);const P=[],g=new Map;for(const w of h)if(w instanceof D.SourceBreakpoint){let R=g.get(w.location.uri.toString());R||(R={type:"sourceMulti",uri:w.location.uri,lines:[]},g.set(w.location.uri.toString(),R),P.push(R)),R.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof D.FunctionBreakpoint&&P.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(l){this.startBreakpoints();const h=l.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],h,[]);const P=h.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),g=h.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),w=h.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(P,g,w)}startDebugging(l,h,P){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,h,{parentSessionID:P.parentSession?P.parentSession.id:void 0,repl:P.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,h,P){if(!h)return new D.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:g,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,P,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,g),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(l,h,P){if(!P)return new D.Disposable(()=>{});if(!this.definesDebugType(l,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:g,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,g),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(l,h){if(!h)return new D.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:P,factory:h}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==h)})}async $runInTerminal(l,h){return Promise.resolve(void 0)}async $substituteVariables(l,h){if(!this._variableResolver){const[w,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,R)}let P;const g=await this.getFolder(l);return g&&(P={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,h)}createDebugAdapter(l,h){if(l.type==="implementation")return new a(l.implementation)}createSignService(){}async $startDASession(l,h){const P=this,g=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const R=this.convertToDto(w),L=this.createDebugAdapter(R,g);if(!L)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const V=L;return this._debugAdapters.set(l,V),this.getDebugAdapterTrackers(g).then(he=>(he&&this._debugAdaptersTrackers.set(l,he),V.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const W=z,J={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const O=await this._signService.sign(W.arguments.value);J.body={signature:O},V.sendResponse(J)}else throw new Error("no signer")}catch(O){J.success=!1,J.message=O.message,V.sendResponse(J)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(z),z=(0,r.convertToVSCPaths)(z,!0),P._debugServiceProxy.$acceptDAMessage(l,z)}),V.onError(z=>{he&&he.onError&&he.onError(z),this._debugServiceProxy.$acceptDAError(l,z.name,z.message,z.stack)}),V.onExit(z=>{he&&he.onExit&&he.onExit((0,m.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,m.withNullAsUndefined)(z),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),V.startSession()))})}$sendDAMessage(l,h){h=(0,r.convertToDAPaths)(h,!1);const P=this._debugAdaptersTrackers.get(l);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(h);const g=this._debugAdapters.get(l);g&&g.sendMessage(h)}$stopDASession(l){const h=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),h&&h.onWillStopSession&&h.onWillStopSession();const P=this._debugAdapters.get(l);return this._debugAdapters.delete(l),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const h=[],P=[],g=[];if(l.added)for(const w of l.added){const R=w.id;if(R&&!this._breakpoints.has(R)){let L;if(w.type==="function")L=new D.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")L=new D.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const V=k.URI.revive(w.uri);L=new D.SourceBreakpoint(new D.Location(V,new D.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}L._id=R,this._breakpoints.set(R,L),h.push(L)}}if(l.removed)for(const w of l.removed){const R=this._breakpoints.get(w);R&&(this._breakpoints.delete(w),P.push(R))}if(l.changed){for(const w of l.changed)if(w.id){const R=this._breakpoints.get(w.id);if(R){if(R instanceof D.FunctionBreakpoint&&w.type==="function"){const L=R;L.enabled=w.enabled,L.condition=w.condition,L.hitCondition=w.hitCondition,L.logMessage=w.logMessage,L.functionName=w.functionName}else if(R instanceof D.SourceBreakpoint&&w.type==="source"){const L=R;L.enabled=w.enabled,L.condition=w.condition,L.hitCondition=w.hitCondition,L.logMessage=w.logMessage,L.location=new D.Location(k.URI.revive(w.uri),new D.Position(w.line,w.character))}g.push(R)}}}this.fireBreakpointChanges(h,P,g)}$provideDebugConfigurations(l,h,P){return(0,T.asPromise)(async()=>{const g=this.getConfigProviderByHandle(l);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(h);return g.provideDebugConfigurations(w,P)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(l,h,P,g){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(l);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(h);return w.resolveDebugConfiguration(R,P,g)})}$resolveDebugConfigurationWithSubstitutedVariables(l,h,P,g){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(l);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(h);return w.resolveDebugConfigurationWithSubstitutedVariables(R,P,g)})}async $provideDebugAdapter(l,h){const P=this.getAdapterDescriptorFactoryByHandle(l);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(h);return this.getAdapterDescriptor(P,g).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(l){const h=await this.getSession(l);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(l){const h=await this.getSession(l);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,h){const P=await this.getSession(l);P&&P._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(l,h){const g={session:await this.getSession(l),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(l){if(l instanceof D.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof D.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const h=this._adapterFactories.filter(P=>P.type===l);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(l){const h=this._adapterFactories.filter(P=>P.handle===l);if(h.length>0)return h[0].factory}getConfigProviderByHandle(l){const h=this._configProviders.filter(P=>P.handle===l);if(h.length>0)return h[0].provider}definesDebugType(l,h){if(l.contributes){const P=l.contributes.debuggers;if(P&&P.length>0){for(const g of P)if(g.label&&g.type&&g.type===h)return!0}}return!1}getDebugAdapterTrackers(l){const P=l.configuration.type,g=this._trackerFactories.filter(w=>w.type===P||w.type==="*").map(w=>(0,T.asPromise)(()=>w.factory.createDebugAdapterTracker(l)).then(R=>R,R=>null));return Promise.race([Promise.all(g).then(w=>{const R=w.filter(L=>!!L);if(R.length>0)return new n(R)}),new Promise((w,R)=>{const L=setTimeout(()=>{clearTimeout(L),R(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(l,h){const P=h.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new D.DebugAdapterServer(P));if(l){const w=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>l.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,w))).then(R=>{if(R)return R})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,g))}daExecutableFromPackage(l,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,h,P){(l.length>0||h.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:h,changed:P}))}async getSession(l){if(l)if(typeof l=="string"){const h=this._debugSessions.get(l);if(h)return h}else{let h=this._debugSessions.get(l.id);if(!h){const P=await this.getFolder(l.folderUri);h=new u(this._debugServiceProxy,l.id,l.type,l.name,P,l.configuration),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(l){if(l){const h=k.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};p=je([Ke(0,o.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],p),e.ExtHostDebugServiceBase=p;class u{constructor(l,h,P,g,w,R){this._debugServiceProxy=l,this._id=h,this._type=P,this._name=g,this._workspaceFolder=w,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,h)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=u;class b{constructor(l){this.value=Object.freeze({append(h){l.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=b;class t extends d.AbstractVariableResolverService{constructor(l,h,P,g){super({getFolderUri:w=>{const R=l.filter(L=>L.name===w);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(w,R)=>P.getConfiguration(void 0,w).get(R),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(h){const w=h.activeEditor();if(w)return _.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(h&&g){const w=h.activeEditor();if(w){const R=g.getWorkspaceFolder(w.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(h){const w=h.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(h){const w=h.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,E.env)}}e.ExtHostVariableResolverService=t;class n{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(h=>h.onError?h.onError(l):void 0)}onExit(l,h){this.trackers.forEach(P=>P.onExit?P.onExit(l,h):void 0)}}class a extends y.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends p{constructor(l,h,P,g,w){super(l,h,P,g,w)}createVariableResolver(l,h,P){return new t(l,h,P)}};s=je([Ke(0,o.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,f.IExtHostConfiguration)],s),e.WorkerExtHostDebugService=s}),define(be[221],we([0,1,80,2,5,34,33,26,15,27,4,35,46,19]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(p,u,b,t,n,a,s){this._apiFactory=p,this._extensionRegistry=u,this._instaService=b,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=a,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const p=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,u,this._extensionRegistry,p,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,u,this._initData.environment.appUriScheme))}register(p){if(Array.isArray(p.nodeModuleName))for(let u of p.nodeModuleName)this._factories.set(u,p);else this._factories.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this._alternatives.push(u=>p.alternativeModuleName(u))}};r=je([Ke(2,i.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,I.IExtHostExtensionService),Ke(5,C.IExtHostInitDataService),Ke(6,f.ILogService)],r),e.RequireInterceptor=r;class o{constructor(p,u,b,t,n){this._apiFactory=p,this._extensionPaths=u,this._extensionRegistry=b,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(p,u){const b=this._extensionPaths.findSubstr(u.fsPath);if(b){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(b.identifier));return t||(t=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(b.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,a)=>t+=`	${a} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(p,u){this.nodeModuleName="keytar";const{environment:b}=u,t=p.getProxy(A.MainContext.MainThreadKeytar);if(b.appRoot){let n=b.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,a)=>t.$getPassword(n,a),setPassword:(n,a,s)=>t.$setPassword(n,a,s),deletePassword:(n,a)=>t.$deletePassword(n,a),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(p,u){return this._impl}alternativeModuleName(p){const u=p.length;if(!(u<=7||!this.alternativeNames)){const b=u-7;if((p.charAt(b)==="/"||p.charAt(b)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.alternativeNames.has(p)))return"keytar"}}};v=je([Ke(0,y.IExtHostRpcService),Ke(1,C.IExtHostInitDataService)],v);let m=class{constructor(p,u,b){this._extensionPaths=p,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(A.MainContext.MainThreadTelemetry);const t=b.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,a)=>{const s=k.URI.parse(n);return a?this.callOriginal(n,a):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,n,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,n,{}):this.callOriginal(n,a)}}load(p,u,b){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=b(p),this._impl}callOriginal(p,u){return this.sendNoForwardTelemetry(),this._original(p,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([Ke(2,y.IExtHostRpcService)],m)}),define(be[222],we([0,1,14,11,80,6,2,5,214,19,62,66,27,151,15,72,35,40]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(u,b,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const a=new y.RPCProtocol(u,null,n);b=E._transform(b,a);const s=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},b)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(a)),s.set(o.IURITransformerService,new o.URITransformerService(n)),s.set(v.IHostUtils,t);const c=new f.InstantiationService(s,!0),l=c.invokeFunction(w=>w.get(m.IExtHostTerminalService));this._disposables.add(l),this._logService=c.invokeFunction(w=>w.get(C.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",b),this._extensionService=c.invokeFunction(w=>w.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(R,L)=>{let V="",he,z;for(const W of L)V+=`
	at ${W.toString()}`,z=W.getFileName(),!he&&z&&(he=w.findSubstr(z));return h.set(R,he),`${R.name||"Error"}: ${R.message||""}${V}`}});const P=a.getProxy(D.MainContext.MainThreadExtensionService),g=a.getProxy(D.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(w=>{const R=k.transformErrorForSerialization(w),L=h.get(w);L?P.$onExtensionRuntimeError(L.identifier,R):g.$onUnexpectedError(R)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const b=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),b]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,b){u.extensions.forEach(n=>n.extensionLocation=S.URI.revive(b.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=S.URI.revive(b.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>S.URI.revive(b.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=S.URI.revive(b.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=S.URI.revive(b.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=S.URI.revive(b.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=S.URI.revive(b.transformIncomingURIs(u.logsLocation)),u.logFile=S.URI.revive(b.transformIncomingURIs(u.logFile)),u.workspace=b.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=E}),define(be[223],we([0,1,13,20,61,28,25,56,41]),function(Y,e,_,k,A,T,S,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(d,f,r){this.config=d,this.provider=f,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const f=this.config.folderQueries||[];return new Promise((r,o)=>{const v=m=>{this.resultCount++,d(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const E=m.toString(),p=_.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,p)||this.matchFile(v,{base:m,basename:p})}),Promise.all(f.map(m=>this.searchInFolder(m,v))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{o(new Error((0,A.toErrorMessage)(m)))})})}async searchInFolder(d,f){const r=new k.CancellationTokenSource,o=this.getSearchOptionsForFolder(d),v=this.initDirectoryTree(),m=new y.QueryGlobTester(this.config,d),E=!m.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(r),p=D.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,r.token),b=p.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const a=_.posix.relative(d.folder.path,n.path);if(E){const s=_.basename(n.path);this.matchFile(f,{base:d.folder,relativePath:a,basename:s});return}this.addDirectoryEntries(v,d.folder,a,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,m,f),{providerTime:b,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,y.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:f,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},f,r,o){if(r===this.filePattern){const m=_.basename(this.filePattern);this.matchFile(o,{base:f,relativePath:this.filePattern,basename:m})}function v(m){const E=_.basename(m),p=_.dirname(m);let u=d[p];u||(u=d[p]=[],v(p)),u.push({base:f,relativePath:m,basename:E})}v(r)}matchDirectoryTree({rootEntries:d,pathToEntries:f},r,o){const v=this,m=this.filePattern;function E(p){const u=T.hasSiblingFn(()=>p.map(b=>b.basename));for(let b=0,t=p.length;b<t;b++){const n=p[b],{relativePath:a,basename:s}=n;if(!!r.includedInQuerySync(a,s,m!==s?u:void 0)){const c=f[a];if(c)E(c);else{if(a===m)continue;v.matchFile(o,n)}if(v.isLimitHit)break}}}E(d)}matchFile(d,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(f))}}class i{constructor(){this.sessions=new Map}fileSearch(d,f,r,o){const v=this.getSessionTokenSource(d.cacheKey),m=new C(d,f,v&&v.token);let E=0;const p=u=>{E+=u.length,r(u.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(m,i.BATCH_SIZE,p,o).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:u.stats}}))}clearCache(d){const f=this.getSessionTokenSource(d);f&&f.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new k.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:S.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,f,r,o){o.onCancellationRequested(()=>{d.cancel()});const v=E=>{E&&(m.push(E),f>0&&m.length>=f&&(r(m),m=[]))};let m=[];return d.search(v).then(E=>(m.length&&r(m),E),E=>(m.length&&r(m),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(be[224],we([0,1,13,12,20,61,25,28,2,41,18]),function(Y,e,_,k,A,T,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class I{constructor(E,p,u){this.query=E,this.provider=p,this.fileUtils=u,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(E,p){const u=this.query.folderQueries||[],b=new A.CancellationTokenSource;return p.onCancellationRequested(()=>b.cancel()),new Promise((t,n)=>{this.collector=new f(E);let a=!1;const s=(c,l)=>{if(!a&&!this.isLimitHit){const h=this.resultSize(c);o(c)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,a=!0,b.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const P=this.resultSize(c);this.resultCount+=P,(P>0||!o(c))&&this.collector.add(c,l)}};Promise.all(u.map((c,l)=>this.searchInFolder(c,h=>s(h,l),b.token))).then(c=>{b.dispose(),this.collector.flush();const l=c.some(h=>!!h&&!!h.limitHit);t({limitHit:this.isLimitHit||l,stats:{type:"textSearchProvider"}})},c=>{b.dispose();const l=(0,T.toErrorMessage)(c);n(new Error(l))})})}resultSize(E){return o(E)?Array.isArray(E.ranges)?E.ranges.length:1:0}trimResultToSize(E,p){const u=Array.isArray(E.ranges)?E.ranges:[E.ranges],b=Array.isArray(E.preview.matches)?E.preview.matches:[E.preview.matches];return{ranges:u.slice(0,p),preview:{matches:b.slice(0,p),text:E.preview.text},uri:E.uri}}async searchInFolder(E,p,u){const b=new C.QueryGlobTester(this.query,E),t=[],n={report:c=>{if(!!this.validateProviderResult(c)){const l=E.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(c.uri))):void 0,h=S.relativePath(E.folder,c.uri);h&&t.push(b.includedInQuery(h,_.basename(h),l).then(P=>{P&&p(c)}))}}},a=this.getSearchOptionsForFolder(E),s=await this.provider.provideTextSearchResults(d(this.query.contentPattern),a,n,u);return await Promise.all(t),s}validateProviderResult(E){if(o(E)){if(Array.isArray(E.ranges)){if(!Array.isArray(E.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(E.preview.matches.length!==E.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(E.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(E){const p=(0,C.resolvePatternsForProvider)(this.query.includePattern,E.includePattern),u=(0,C.resolvePatternsForProvider)(this.query.excludePattern,E.excludePattern),b={folder:y.URI.from(E.folder),excludes:u,includes:p,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,followSymlinks:!E.ignoreSymlinks,encoding:E.fileEncoding&&this.fileUtils.toCanonicalName(E.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=I;function d(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class f{constructor(E){this._onResult=E,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,p=>this.sendItems(p))}add(E,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!S.isEqual(this._currentUri,E.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:E.uri,results:[]}),this._currentFileMatch.results.push(r(E))}pushToCollector(){const E=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,E)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(E){this._onResult(E)}}e.TextSearchResultsCollector=f;function r(m){return o(m)?{preview:{matches:(0,k.mapArrayOrNot)(m.preview.matches,E=>({startLineNumber:E.start.line,startColumn:E.start.character,endLineNumber:E.end.line,endColumn:E.end.character})),text:m.preview.text},ranges:(0,k.mapArrayOrNot)(m.ranges,E=>({startLineNumber:E.start.line,startColumn:E.start.character,endLineNumber:E.end.line,endColumn:E.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function o(m){return!!m.preview}e.extensionResultIsMatch=o;class v{constructor(E,p){this.maxBatchSize=E,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(E,p){!E||this.addItemToBatch(E,p)}addItems(E,p){!E||this.addItemsToBatch(E,p)}addItemToBatch(E,p){this.batch.push(E),this.batchSize+=p,this.onUpdate()}addItemsToBatch(E,p){this.batch=this.batch.concat(E),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(be[104],we([0,1,6,5,4,223,15,72,19,2,224]),function(Y,e,_,k,A,T,S,D,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let I=class{constructor(o,v,m){this.extHostRpc=o,this._uriTransformer=v,this._logService=m,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,v){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const m=this._handlePool++;return this._textSearchProvider.set(m,v),this._proxy.$registerTextSearchProvider(m,this._transformScheme(o)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(o,v){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const m=this._handlePool++;return this._fileSearchProvider.set(m,v),this._proxy.$registerFileSearchProvider(m,this._transformScheme(o)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(o,v,m,E){const p=d(m),u=this._fileSearchProvider.get(o);if(u)return this._fileSearchManager.fileSearch(p,u,b=>{this._proxy.$handleFileMatch(o,v,b.map(t=>t.resource))},E);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,v,m,E){const p=this._textSearchProvider.get(o);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const u=d(m);return this.createTextSearchManager(u,p).search(t=>this._proxy.$handleTextMatch(o,v,t),E)}createTextSearchManager(o,v){return new i.TextSearchManager(o,v,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};I=je([Ke(0,S.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,y.ILogService)],I),e.ExtHostSearch=I;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(f),extraFileResources:r.extraFileResources&&r.extraFileResources.map(o=>C.URI.revive(o))})}e.reviveQuery=d;function f(r){return Object.assign(Object.assign({},r),{folder:C.URI.revive(r.folder)})}}),define(be[225],we([0,1,129,20,11,3,47,2,122,85,116,60,65,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,51,101,31,33,52,166,197,93,99,102,103,104,19,72,15,27,201,164,71,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,68]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p,u,b,t,n,a,s,c,l,h,P,g,w,R,L,V,he,z,W,J,O,F,N,B,U,Q,Z,ne,pe,Pe,Oe,Te,xe,$,G,ie,oe,me,De,Ne,ge,Ce,Ae,Be,_e,qe,j,te,ve,Ue,He,$e,Ye,H,se,de,K,ee,le,fe,Ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ve(Fe){const We=Fe.get(Ne.IExtHostInitDataService),Qe=Fe.get(H.IExtHostFileSystemInfo),it=Fe.get(ve.IExtHostConsumerFileSystem),at=Fe.get(s.IExtHostExtensionService),Ze=Fe.get(Z.IExtHostWorkspace),nt=Fe.get(le.IExtHostTelemetry),dt=Fe.get(E.IExtHostConfiguration),wt=Fe.get(me.IURITransformerService),ue=Fe.get(De.IExtHostRpcService),Se=Fe.get(z.IExtHostStorage),ae=Fe.get(te.IExtensionStoragePaths),q=Fe.get(oe.ILogService),Le=Fe.get(Ae.IExtHostTunnelService),Ie=Fe.get(Be.IExtHostApiDeprecationService),Xe=Fe.get(Q.IExtHostWindow),et=Fe.get(K.IExtHostSecretState);ue.set(f.ExtHostContext.ExtHostFileSystemInfo,Qe),ue.set(f.ExtHostContext.ExtHostLogService,q),ue.set(f.ExtHostContext.ExtHostWorkspace,Ze),ue.set(f.ExtHostContext.ExtHostConfiguration,dt),ue.set(f.ExtHostContext.ExtHostExtensionService,at),ue.set(f.ExtHostContext.ExtHostStorage,Se),ue.set(f.ExtHostContext.ExtHostTunnelService,Le),ue.set(f.ExtHostContext.ExtHostWindow,Xe),ue.set(f.ExtHostContext.ExtHostSecretState,et),ue.set(f.ExtHostContext.ExtHostTelemetry,nt);const ct=ue.set(f.ExtHostContext.ExtHostDecorations,Fe.get(xe.IExtHostDecorations)),rt=ue.set(f.ExtHostContext.ExtHostDocumentsAndEditors,Fe.get(a.IExtHostDocumentsAndEditors)),Ge=ue.set(f.ExtHostContext.ExtHostCommands,Fe.get(v.IExtHostCommands)),ht=ue.set(f.ExtHostContext.ExtHostTerminalService,Fe.get(W.IExtHostTerminalService)),ot=ue.set(f.ExtHostContext.ExtHostDebugService,Fe.get(G.IExtHostDebugService)),vt=ue.set(f.ExtHostContext.ExtHostSearch,Fe.get(ie.IExtHostSearch)),pt=ue.set(f.ExtHostContext.ExtHostTask,Fe.get($.IExtHostTask)),_t=ue.set(f.ExtHostContext.ExtHostOutputService,Fe.get(w.IExtHostOutputService)),yt=ue.set(f.ExtHostContext.ExtHostEditorTabs,new ee.ExtHostEditorTabs),It=ue.set(f.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(ue)),bt=ue.set(f.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,rt)),Pt=ue.set(f.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(ue,rt,q)),qt=ue.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(q,bt,ue.getProxy(f.MainContext.MainThreadBulkEdits))),ft=ue.set(f.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ue,Ge,rt,bt,We.environment,q,ae)),Kt=ue.set(f.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(ue,We,ft)),Et=ue.set(f.ExtHostContext.ExtHostEditors,new J.ExtHostEditors(ue,rt)),Bt=ue.set(f.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(ue.getProxy(f.MainContext.MainThreadTreeViews),Ge,q)),Gt=ue.set(f.ExtHostContext.ExtHostEditorInsets,new Pe.ExtHostEditorInsets(ue.getProxy(f.MainContext.MainThreadEditorInsets),Et,We.environment)),Wt=ue.set(f.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(ue,q)),lt=ue.set(f.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(ue,wt,bt,Ge,Wt,q,Ie)),Qt=ue.set(f.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(ue,lt)),At=ue.set(f.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(ue,q,rt)),Ot=ue.set(f.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(ue,Ze,Ge)),un=ue.set(f.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(ue,Ge,q)),pn=ue.set(f.ExtHostContext.ExtHostComments,new m.ExtHostComments(ue,Ge,bt)),cn=ue.set(f.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ue.getProxy(f.MainContext.MainThreadProgress))),Jt=ue.set(f.ExtHostContext.ExtHosLabelService,new Oe.ExtHostLabelService(ue)),Ht=ue.set(f.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ue)),Lt=ue.set(f.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(ue)),vn=ue.set(f.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ue,Ge)),Yt=ue.set(f.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(ue,We.environment,Ze,q,Ie)),Xt=ue.set(f.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ue,Yt,Ze)),zt=ue.set(f.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(ue,bt,ae,Yt,Xt)),bn=ue.set(f.ExtHostContext.ExtHostWebviewViews,new Ue.ExtHostWebviewViews(ue,Yt)),Tt=ue.set(f.ExtHostContext.ExtHostTesting,new se.ExtHostTesting(ue,rt,Ze)),Zt=ue.set(f.ExtHostContext.ExtHostUriOpeners,new de.ExtHostUriOpeners(ue)),wn=(0,pe.values)(f.ExtHostContext);ue.assertRegistered(wn);const en=new Ye.ExtHostBulkEdits(ue,rt),tn=new o.ExtHostClipboard(ue),Mt=new g.ExtHostMessageService(ue,q),dn=new u.ExtHostDialogs(ue),hn=new he.ExtHostStatusBar(ue,Ge.converter),Nt=new P.ExtHostLanguages(ue,bt);return r.ExtHostApiCommands.register(Ge),function(Re,nn,rn){const mt=function(){let X=!Re.isUnderDevelopment;function ce(ke){X||(q.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(st){if(Array.isArray(st))st.forEach(ke);else if(typeof st=="string")ce(st);else{const x=st;typeof x.scheme=="undefined"&&ce(st),!Re.enableProposedApi&&typeof x.exclusive=="boolean"&&(0,ne.throwProposedApiError)(Re)}return st}}(),_n={getSession(X,ce,ke){return Lt.getSession(Re,X,ce,ke)},get onDidChangeSessions(){return Lt.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,st){return Lt.registerAuthenticationProvider(X,ce,ke,st)},get onDidChangeAuthenticationProviders(){return(0,ne.checkProposedApiEnabled)(Re),Lt.onDidChangeAuthenticationProviders},get providers(){return(0,ne.checkProposedApiEnabled)(Re),Lt.providers},logout(X,ce){return(0,ne.checkProposedApiEnabled)(Re),Lt.removeSession(X,ce)}},En={registerCommand(X,ce,ke){return Ge.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return Ge.registerCommand(!0,X,(...st)=>{const x=Et.getActiveTextEditor();if(!x){q.warn("Cannot execute "+X+" because there is no active text editor.");return}return x.edit(M=>{ce.apply(ke,[x,M,...st])}).then(M=>{M||q.warn("Edits from command "+X+" were not applied.")},M=>{q.warn("An error occurred while running command "+X,M)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,ne.checkProposedApiEnabled)(Re),Ge.registerCommand(!0,X,async(...st)=>{const x=rt.activeEditor(!0);if(!x){q.warn("Cannot execute "+X+" because there is no active text editor.");return}const M=await Et.getDiffInformation(x.id);ce.apply(ke,[M,...st])})),executeCommand(X,...ce){return Ge.executeCommand(X,...ce)},getCommands(X=!1){return Ge.getCommands(X)}},Vt={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var X,ce;return(ce=(X=We.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return tn.value},get shell(){return ht.getDefaultShell(!1,rn)},get isTelemetryEnabled(){return nt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return nt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Xe.openUri(X,{allowTunneling:!!We.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},asExternalUri(X){return X.scheme===We.environment.appUriScheme?It.createAppUri(X):Xe.asExternalUri(X,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Te.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(Vt);const fn=We.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,yn={registerTestController(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.registerTestController(Re.identifier.value,X)},createDocumentTestObserver(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.createWorkspaceTestObserver(X)},runTests(X){return(0,ne.checkProposedApiEnabled)(Re),Tt.runTests(X)},createTestItem(X,ce){return new N.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRunTask(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),Tt.createTestRunTask(Re.identifier.value,X,ce,ke)},get onDidChangeTestResults(){return(0,ne.checkProposedApiEnabled)(Re),Tt.onResultsChanged},get testResults(){return(0,ne.checkProposedApiEnabled)(Re),Tt.results}},Sn={getExtension(X){const ce=nn.getExtensionDescription(X);if(ce)return new s.Extension(at,Re.identifier,ce,fn)},get all(){return nn.getAllExtensionDescriptions().map(X=>new s.Extension(at,Re.identifier,X,fn))},get onDidChange(){return nn.onDidChange}},Dn={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Nt.getLanguages()},setTextDocumentLanguage(X,ce){return Nt.changeLanguage(X.uri,ce)},match(X,ce){return(0,I.score)(F.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return lt.registerCodeActionProvider(Re,mt(X),ce,ke)},registerCodeLensProvider(X,ce){return lt.registerCodeLensProvider(Re,mt(X),ce)},registerDefinitionProvider(X,ce){return lt.registerDefinitionProvider(Re,mt(X),ce)},registerDeclarationProvider(X,ce){return lt.registerDeclarationProvider(Re,mt(X),ce)},registerImplementationProvider(X,ce){return lt.registerImplementationProvider(Re,mt(X),ce)},registerTypeDefinitionProvider(X,ce){return lt.registerTypeDefinitionProvider(Re,mt(X),ce)},registerHoverProvider(X,ce){return lt.registerHoverProvider(Re,mt(X),ce,Re.identifier)},registerEvaluatableExpressionProvider(X,ce){return lt.registerEvaluatableExpressionProvider(Re,mt(X),ce,Re.identifier)},registerInlineValuesProvider(X,ce){return lt.registerInlineValuesProvider(Re,mt(X),ce,Re.identifier)},registerDocumentHighlightProvider(X,ce){return lt.registerDocumentHighlightProvider(Re,mt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return lt.registerLinkedEditingRangeProvider(Re,mt(X),ce)},registerReferenceProvider(X,ce){return lt.registerReferenceProvider(Re,mt(X),ce)},registerRenameProvider(X,ce){return lt.registerRenameProvider(Re,mt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return lt.registerDocumentSymbolProvider(Re,mt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return lt.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,ce){return lt.registerDocumentFormattingEditProvider(Re,mt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return lt.registerDocumentRangeFormattingEditProvider(Re,mt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...st){return lt.registerOnTypeFormattingEditProvider(Re,mt(X),ce,[ke].concat(st))},registerDocumentSemanticTokensProvider(X,ce,ke){return lt.registerDocumentSemanticTokensProvider(Re,mt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return lt.registerDocumentRangeSemanticTokensProvider(Re,mt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...st){return typeof ke=="object"?lt.registerSignatureHelpProvider(Re,mt(X),ce,ke):lt.registerSignatureHelpProvider(Re,mt(X),ce,typeof ke=="undefined"?[]:[ke,...st])},registerCompletionItemProvider(X,ce,...ke){return lt.registerCompletionItemProvider(Re,mt(X),ce,ke)},registerDocumentLinkProvider(X,ce){return lt.registerDocumentLinkProvider(Re,mt(X),ce)},registerColorProvider(X,ce){return lt.registerColorProvider(Re,mt(X),ce)},registerFoldingRangeProvider(X,ce){return lt.registerFoldingRangeProvider(Re,mt(X),ce)},registerSelectionRangeProvider(X,ce){return lt.registerSelectionRangeProvider(Re,X,ce)},registerCallHierarchyProvider(X,ce){return lt.registerCallHierarchyProvider(Re,X,ce)},setLanguageConfiguration:(X,ce)=>lt.setLanguageConfiguration(Re,X,ce),getTokenInformationAtPosition(X,ce){return(0,ne.checkProposedApiEnabled)(Re),Nt.tokenAtPosition(X,ce)},registerInlineHintsProvider(X,ce){return(0,ne.checkProposedApiEnabled)(Re),lt.registerInlineHintsProvider(Re,X,ce)}},Cn={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(X,ce,ke){const st=await(D.URI.isUri(X)?Promise.resolve(sn.openTextDocument(X)):Promise.resolve(X));return Et.showTextDocument(st,ce,ke)},createTextEditorDecorationType(X){return Et.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ce,ke){return Et.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return Et.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return Et.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return Et.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return Et.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return Et.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return ht.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return ht.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return ht.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ht.onDidChangeTerminalDimensions(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ht.onDidWriteTerminalData(X,ce,ke)},get state(){return Xe.state},onDidChangeWindowState(X,ce,ke){return Xe.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return Mt.showMessage(Re,S.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return Mt.showMessage(Re,S.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return Mt.showMessage(Re,S.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Ot.showQuickPick(X,!!Re.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Ot.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Ot.showInput(X,ce)},showOpenDialog(X){return dn.showOpenDialog(X)},showSaveDialog(X){return dn.showSaveDialog(X)},createStatusBarItem(X,ce){let ke,st,x,M;return X&&typeof X!="number"?(ke=X.id,st=X.name,x=X.alignment,ce=X.priority,M=X.accessibilityInformation):(ke=Re.identifier.value,st=_.localize(0,null,Re.displayName||Re.name),x=X),hn.createStatusBarEntry(ke,st,x,ce,M)},setStatusBarMessage(X,ce){return hn.setStatusBarMessage(X,ce)},withScmProgress(X){return Ie.report("window.withScmProgress",Re,"Use 'withProgress' instead."),cn.withProgress(Re,{location:N.ProgressLocation.SourceControl},(ce,ke)=>X({report(st){}}))},withProgress(X,ce){return cn.withProgress(Re,X,ce)},createOutputChannel(X){return _t.createOutputChannel(X)},createWebviewPanel(X,ce,ke,st){return Xt.createWebviewPanel(Re,X,ce,ke,st)},createWebviewTextEditorInset(X,ce,ke,st){return(0,ne.checkProposedApiEnabled)(Re),Gt.createWebviewEditorInset(X,ce,ke,st,Re)},createTerminal(X,ce,ke){return typeof X=="object"?"pty"in X?ht.createExtensionTerminal(X):(X.message&&(0,ne.checkProposedApiEnabled)(Re),X.icon&&(0,ne.checkProposedApiEnabled)(Re),ht.createTerminalFromOptions(X)):ht.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return ht.registerLinkProvider(X)},registerTreeDataProvider(X,ce){return Bt.registerTreeDataProvider(X,ce,Re)},createTreeView(X,ce){return Bt.createTreeView(X,ce,Re)},registerWebviewPanelSerializer:(X,ce)=>Xt.registerWebviewPanelSerializer(Re,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>zt.registerCustomEditorProvider(Re,X,ce,ke),registerFileDecorationProvider(X){return ct.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return It.registerUriHandler(Re.identifier,X)},createQuickPick(){return Ot.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Ot.createInputBox(Re.identifier)},get activeColorTheme(){return Ht.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return Ht.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return bn.registerWebviewViewProvider(Re,X,ce,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,ne.checkProposedApiEnabled)(Re),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Re),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,ne.checkProposedApiEnabled)(Re),ft.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),Zt.registerExternalUriOpener(Re.identifier,X,ce,ke)},get openEditors(){return(0,ne.checkProposedApiEnabled)(Re),yt.tabs},get onDidChangeOpenEditors(){return(0,ne.checkProposedApiEnabled)(Re),yt.onDidChangeTabs}},sn={get rootPath(){return Ie.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(X){throw A.readonly()},getWorkspaceFolder(X){return Ze.getWorkspaceFolder(X)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(X){throw A.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(X){throw A.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>Ze.updateWorkspaceFolders(Re,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return Ze.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>Ze.getRelativePath(X,ce),findFiles:(X,ce,ke,st)=>Ze.findFiles(F.GlobPattern.from(X),F.GlobPattern.from(ce),ke,Re.identifier,st),findTextInFiles:(X,ce,ke,st)=>{let x,M;return typeof ce=="object"?(x=ce,M=ke):(x={},M=ce,st=ke),Ze.findTextInFiles(X,x||{},M,Re.identifier,st)},saveAll:X=>Ze.saveAll(X),applyEdit(X){return en.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,st)=>At.createFileSystemWatcher(F.GlobPattern.from(X),ce,ke,st),get textDocuments(){return bt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw A.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(D.URI.file(X));else if(D.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=bt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>bt.ensureDocumentData(st).then(x=>x.document))},onDidOpenTextDocument:(X,ce,ke)=>bt.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>bt.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>bt.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>bt.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>qt.getOnWillSaveTextDocumentEvent(Re)(X,ce,ke),onDidChangeConfiguration:(X,ce,ke)=>rn.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,rn.getConfiguration(X,ce,Re)},registerTextDocumentContentProvider(X,ce){return Pt.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Ie.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Re,X,ce)),registerFileSystemProvider(X,ce,ke){return Qt.registerFileSystemProvider(Re.identifier,X,ce,ke)},get fs(){return it.value},registerFileSearchProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),vt.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),vt.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),at.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,ne.checkProposedApiEnabled)(Re),Jt.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>At.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>At.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>At.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>At.getOnWillCreateFileEvent(Re)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>At.getOnWillDeleteFileEvent(Re)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>At.getOnWillRenameFileEvent(Re)(X,ce,ke),openTunnel:X=>((0,ne.checkProposedApiEnabled)(Re),Le.openTunnel(Re,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,ne.checkProposedApiEnabled)(Re),Le.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,ne.checkProposedApiEnabled)(Re),Le.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),Le.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),vn.registerTimelineProvider(X,ce,Re.identifier,Ge.converter)),get isTrusted(){return(0,ne.checkProposedApiEnabled)(Re),Ze.trusted},requestWorkspaceTrust:X=>((0,ne.checkProposedApiEnabled)(Re),Ze.requestWorkspaceTrust(X)),onDidReceiveWorkspaceTrust:(X,ce,ke)=>Ze.onDidReceiveWorkspaceTrust(X,ce,ke)},mn={get inputBox(){return Ie.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(Re)},createSourceControl(X,ce,ke){return un.createSourceControl(Re,X,ce,ke)}},Ut={createCommentController(X,ce){return pn.createCommentController(Re,X,ce)}},jt={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(X,ce,ke){return ot.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return ot.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return ot.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return ot.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return ot.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return ot.registerDebugConfigurationProvider(X,ce,ke||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return ot.registerDebugAdapterDescriptorFactory(Re,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return ot.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ot.startDebugging(X,ce,{parentSession:ke}):ot.startDebugging(X,ce,ke||{})},stopDebugging(X){return ot.stopDebugging(X)},addBreakpoints(X){return ot.addBreakpoints(X)},removeBreakpoints(X){return ot.removeBreakpoints(X)},asDebugSourceUri(X,ce){return ot.asDebugSourceUri(X,ce)}},kn={registerTaskProvider:(X,ce)=>pt.registerTaskProvider(Re,X,ce),fetchTasks:X=>pt.fetchTasks(X),executeTask:X=>pt.executeTask(Re,X),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(X,ce,ke)=>pt.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>pt.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>pt.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>pt.onDidEndTaskProcess(X,ce,ke)},on={openNotebookDocument:X=>((0,ne.checkProposedApiEnabled)(Re),ft.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ne.checkProposedApiEnabled)(Re),ft.notebookDocuments.map(X=>X.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookSerializer(Re,X,ce,ke)},registerNotebookContentProvider:(X,ce,ke)=>((0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookContentProvider(Re,X,ce,ke)),registerNotebookKernelProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookKernelProvider(Re,X,ce)),registerNotebookCellStatusBarItemProvider:(X,ce)=>((0,ne.checkProposedApiEnabled)(Re),ft.registerNotebookCellStatusBarItemProvider(Re,X,ce)),createNotebookEditorDecorationType(X){return(0,ne.checkProposedApiEnabled)(Re),ft.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCells(X,ce,ke)},onDidChangeCellExecutionState(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,ne.checkProposedApiEnabled)(Re),new j.ExtHostNotebookConcatDocument(ft,bt,X,ce)},createNotebookCellExecutionTask(X,ce,ke){return(0,ne.checkProposedApiEnabled)(Re),ft.createNotebookCellExecution(X,ce,ke)},createNotebookController(X,ce,ke,st,x){return(0,ne.checkProposedApiEnabled)(Re),Kt.createNotebookController(Re,X,ce,ke,st,x)}};return{version:We.version,authentication:_n,commands:En,comments:Ut,debug:jt,env:Vt,extensions:Sn,languages:Dn,notebook:on,scm:mn,tasks:kn,test:yn,window:Cn,workspace:sn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:d.FileType,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,Hover:N.Hover,IndentAction:i.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:D.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlineHint:N.InlineHint,InlineHintKind:N.InlineHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,RemoteTrustOption:Ee.RemoteTrustOption,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookDocumentMetadata:N.NotebookDocumentMetadata,NotebookCellMetadata:N.NotebookCellMetadata,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,LinkedEditingRanges:N.LinkedEditingRanges,TestItemStatus:N.TestItemStatus,TestResultState:N.TestResultState,TestMessage:N.TestMessage,TestMessageSeverity:N.TestMessageSeverity,WorkspaceTrustState:N.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ve}),define(be[226],we([0,1,62,100,31,99,34,76,39,40,102,103,104,79,78,71,75,101,77,49,74,94]),function(Y,e,_,k,A,T,S,D,y,C,i,I,d,f,r,o,v,m,E,p,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,_.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,_.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,_.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,_.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,_.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,_.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,_.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,_.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,_.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,_.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,_.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,_.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,_.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,_.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,_.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,_.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,_.registerSingleton)(b.IExtHostTelemetry,b.ExtHostTelemetry)}),define(be[227],we([0,1,225,35,221,7,14,5]),function(Y,e,_,k,A,T,S,D){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(r){var o;const v=(o=self.trustedTypes)===null||o===void 0?void 0:o.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...p)=>{p.forEach(n=>{var a;if(!((a=self.trustedTypes)===null||a===void 0?void 0:a.isScript(n)))throw new Error("TrustedScripts only, please")});const u=p.slice(0,-1).join(","),b=p.pop().toString();return`(function anonymous(${u}) {
${b}
})`}});function m(...E){return v?self.eval(v.createScript("",...E)):new Function(...E)}r.create=m})(C||(C={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(o,v){for(let m of this._alternatives){let E=m(o);if(E){o=E;break}}if(this._factories.has(o))return this._factories.get(o).load(o,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);f(o,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(_.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,v,m){var E,p,u,b,t,n,a,s;v=v.with({path:d(v.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const c=await fetch(v.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),c.status!==200)throw new Error(c.statusText);const l=await c.text(),h=`${v.toString(!0)}#vscode-extension`,P=`${l}
//# sourceURL=${h}`;let g;try{g=C.create((p=(E=I._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&p!==void 0?p:"module",(b=(u=I._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("exports"))!==null&&b!==void 0?b:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(s=(a=I._ttpExtensionScripts)===null||a===void 0?void 0:a.createScript(P))!==null&&s!==void 0?s:P)}catch(V){throw o?console.error(`Loading code for extension ${o.value} failed: ${V.message}`):console.error(`Loading code failed: ${V.message}`),console.error(`${v.toString(!0)}${typeof V.line=="number"?` line ${V.line}`:""}${typeof V.column=="number"?` column ${V.column}`:""}`),console.error(V),V}const w={},R={exports:w},L=V=>{const he=this._fakeModules.getModule(V,v);if(he===void 0)throw new Error(`Cannot load module '${V}'`);return he};try{return m.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),g(R,w,L),R.exports!==w?R.exports:w}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(o){throw new Error("Not supported")}async _waitForDebuggerAttachment(o=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const v=Date.now()+o;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,o){return r.endsWith(o)?r:r+o}function f(r,o){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(p,u){const b=console[p];console[p]=function(){r.$logExtensionHostMessage({type:"__$console",severity:u,arguments:E(arguments)}),o&&b.apply(console,arguments)}}const m=1e5;function E(p){const u=[],b=[];if(p.length)for(let t=0;t<p.length;t++){if(typeof p[t]=="undefined")p[t]="undefined";else if(p[t]instanceof Error){const n=p[t];n.stack?p[t]=n.stack:p[t]=n.toString()}b.push(p[t])}try{const t=JSON.stringify(b,function(n,a){if(a&&typeof a=="object"){if(u.indexOf(a)!==-1)return"[Circular]";u.push(a)}return a});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[228],we([0,1,62,19,35,227,213]),function(Y,e,_,k,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,_.registerSingleton)(k.ILogService,S.ExtHostLogService)}),define(be[230],we([0,1,23,3,184,222,215,13,80,226,228]),function(Y,e,_,k,A,T,S,D,y){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const v=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),m=self.Worker;Worker=function(E,p){const u=`importScripts('${E}');`;p=p||{},p.name=p.name||D.basename(E.toString());const b=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(b);return new m(v?v.createScriptURL(t):t,p)}}else self.Worker=class extends S.NestedWorker{constructor(v,m){super(I,v,Object.assign({name:D.basename(v.toString())},m))}};const d=new class{exit(v){i()}async exists(v){return!0}async realpath(v){return v}};class f{constructor(){const m=new MessageChannel,E=new k.Emitter;let p=!1;I(m.port2,[m.port2]),m.port1.onmessage=u=>{const{data:b}=u;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const t=_.VSBuffer.wrap(new Uint8Array(b,0,b.byteLength));if((0,A.isMessageOfType)(t,2)){p=!0,o("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:u=>{if(!p){const b=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);m.port1.postMessage(b,[b])}}}}}function r(v){return new Promise(m=>{const E=v.onMessage(p=>{E.dispose();const u=JSON.parse(p.toString());v.send((0,A.createMessageOfType)(0)),m({protocol:v,initData:u})});v.send((0,A.createMessageOfType)(1))})}let o=v=>i();(function(){const m=new f;y.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(E=>{y.mark("code/extHost/didWaitForInitData");const p=new T.ExtensionHostMain(E.protocol,E.initData,d,null);o=u=>p.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b4816cfd1f4161a3bb272354d181a9947760ee26/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
